﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Adams.Admin.Business.Sitemap
{
    public static class Web
    {
        public static Adams.Admin.DataTransfer.Sitemap.Web.PageLoad PageLoad()
        {
            return DataAccess.Sitemap.Web.PageLoad();
        }

        public static void UpdateTop(Adams.Admin.DataTransfer.Sitemap.Web.UpdateTopInput input)
        {
            DataAccess.Sitemap.Web.UpdateTop(input);
        }

        public static DataTransfer.FormOutput SaveTopNode(DataTransfer.Sitemap.Web.NodeTopFormInput input)
        {
            var output = Validation.PerformBasicValidation(input);

            if (output.IsValid)
            {
                var nodeinfo = DataAccess.Sitemap.Web.GetTopNodeInfo(input.Url, input.ID.ToInt());

                if (input.ID.ToInt() > 0)
                {
                    if (!Shared.Str.IsEqual(input.Url, nodeinfo.Url))
                    {
                        if (nodeinfo.Exists)
                        {
                            output.InvalidFields.Add(new DataTransfer.InvalidField()
                            {
                                Name = "Url",
                                Code = 4
                            });
                        }
                    }
                }
                else
                {
                    if (nodeinfo.Exists)
                    {
                        output.InvalidFields.Add(new DataTransfer.InvalidField()
                        {
                            Name = "Url",
                            Code = 4
                        });
                    }
                }

                if (output.IsValid)
                {
                    output.ID = DataAccess.Sitemap.Web.SaveTopNode(input);
                    output.IsSaved = true;
                }
            }

            return output;
        }

        public static Adams.Admin.DataTransfer.Sitemap.Web.GetTopNode GetTopNode(Adams.Admin.DataTransfer.Sitemap.Web.GetTopNodeInput input)
        {
            return DataAccess.Sitemap.Web.GetTopNode(input);
        }

        public static void DeleteTopNode(int nodeId)
        {
            DataAccess.Sitemap.Web.DeleteTopNode(nodeId);
        }

        public static void UpdateLeft(Adams.Admin.DataTransfer.Sitemap.Web.UpdateLeftInput input)
        {
            DataAccess.Sitemap.Web.UpdateLeft(input);
        }

        public static DataTransfer.FormOutput SaveLeftNode(DataTransfer.Sitemap.Web.NodeLeftFormInput input)
        {
            var output = Validation.PerformBasicValidation(input);

            if (output.IsValid)
            {
                var nodeinfo = DataAccess.Sitemap.Web.GetLeftNodeInfo(input.Url, input.ID.ToInt());

                if (input.ID.ToInt() > 0)
                {
                    if (!Shared.Str.IsEqual(input.Url, nodeinfo.Url))
                    {
                        if (nodeinfo.Exists)
                        {
                            output.InvalidFields.Add(new DataTransfer.InvalidField()
                            {
                                Name = "Url",
                                Code = 4
                            });
                        }
                    }
                }
                else
                {
                    if (nodeinfo.Exists)
                    {
                        output.InvalidFields.Add(new DataTransfer.InvalidField()
                        {
                            Name = "Url",
                            Code = 4
                        });
                    }
                }

                if (output.IsValid)
                {
                    output.ID = DataAccess.Sitemap.Web.SaveLeftNode(input);
                    output.IsSaved = true;
                }
            }

            return output;
        }

        public static Adams.Admin.DataTransfer.Sitemap.Web.GetLeftNode GetLeftNode(Adams.Admin.DataTransfer.Sitemap.Web.GetLeftNodeInput input)
        {
            return DataAccess.Sitemap.Web.GetLeftNode(input);
        }

        public static void DeleteLeftNode(int nodeId)
        {
            DataAccess.Sitemap.Web.DeleteLeftNode(nodeId);
        }

        public static void UpdateBottom(Adams.Admin.DataTransfer.Sitemap.Web.UpdateBottomInput input)
        {
            DataAccess.Sitemap.Web.UpdateBottom(input);
        }

        public static DataTransfer.FormOutput SaveBottomNode(DataTransfer.Sitemap.Web.NodeBottomFormInput input)
        {
            var output = Validation.PerformBasicValidation(input);

            if (output.IsValid)
            {
                var nodeinfo = DataAccess.Sitemap.Web.GetBottomNodeInfo(input.Url, input.ID.ToInt());

                if (input.ID.ToInt() > 0)
                {
                    if (!Shared.Str.IsEqual(input.Url, nodeinfo.Url))
                    {
                        if (nodeinfo.Exists)
                        {
                            output.InvalidFields.Add(new DataTransfer.InvalidField()
                            {
                                Name = "Url",
                                Code = 4
                            });
                        }
                    }
                }
                else
                {
                    if (nodeinfo.Exists)
                    {
                        output.InvalidFields.Add(new DataTransfer.InvalidField()
                        {
                            Name = "Url",
                            Code = 4
                        });
                    }
                }

                if (output.IsValid)
                {
                    output.ID = DataAccess.Sitemap.Web.SaveBottomNode(input);
                    output.IsSaved = true;
                }
            }

            return output;
        }

        public static Adams.Admin.DataTransfer.Sitemap.Web.GetBottomNode GetBottomNode(Adams.Admin.DataTransfer.Sitemap.Web.GetBottomNodeInput input)
        {
            return DataAccess.Sitemap.Web.GetBottomNode(input);
        }

        public static void DeleteBottomNode(int nodeId)
        {
            DataAccess.Sitemap.Web.DeleteBottomNode(nodeId);
        }
    }
}
