﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Data.SqlClient;
using System.Data;
namespace Adams.Admin.DataAccess.Classifieds
{
    public static class Categories
    {
        public static Adams.Admin.DataTransfer.Classifieds.Categories.PageLoad PageLoad()
        {
            var data = new Adams.Admin.DataTransfer.Classifieds.Categories.PageLoad();
            data.Types = new Shared.Entities.Classifieds.TypeCollection();

            using (SqlDataReader dr = DB.RunDataReader(@"
SELECT * FROM Classifieds.Types ORDER BY Name
SELECT * FROM Classifieds.Categories ORDER BY Name
", CommandType.Text))
            {
                while (dr.Read())
                {
                    var type = new Shared.Entities.Classifieds.Type();
                    type.Categories = new Shared.Entities.Classifieds.CategoryCollection();
                    type.ID = dr["TypeID"].DbInt();
                    type.Name = dr["Name"].DbString();
                    data.Types.Add(type);
                }
                dr.NextResult();
                while (dr.Read())
                {
                    var cat = new Shared.Entities.Classifieds.Category();
                    cat.ID = dr["CategoryID"].DbInt();
                    cat.Name = dr["Name"].DbString();
                    data.Types.Where(t => t.ID == dr["TypeID"].DbInt()).FirstOrDefault().Categories.Add(cat);
                }
            }

            return data;
        }

        public static Adams.Admin.DataTransfer.Classifieds.Categories.GetType GetType(Adams.Admin.DataTransfer.Classifieds.Categories.GetTypeInput input)
        {
            var data = new Adams.Admin.DataTransfer.Classifieds.Categories.GetType();
            data.Type = new Shared.Entities.Classifieds.Type();

            using (SqlDataReader dr = DB.RunDataReader(@"
SELECT * FROM Classifieds.Types WHERE TypeID = @TypeID
", CommandType.Text,
    DB.CreateParameter("@TypeID", input.TypeID)))
            {
                dr.Read();
                data.Type.ID = dr["TypeID"].DbInt();
                data.Type.Name = dr["Name"].DbString();
            }

            return data;
        }

        public static Adams.Admin.DataTransfer.Classifieds.Categories.GetCategory GetCategory(Adams.Admin.DataTransfer.Classifieds.Categories.GetCategoryInput input)
        {
            var data = new Adams.Admin.DataTransfer.Classifieds.Categories.GetCategory();
            data.Category = new Shared.Entities.Classifieds.Category();

            using (SqlDataReader dr = DB.RunDataReader(@"
SELECT * FROM Classifieds.Categories WHERE CategoryID = @CategoryID
", CommandType.Text,
    DB.CreateParameter("@CategoryID", input.CategoryID)))
            {
                dr.Read();
                data.Category.ID = dr["CategoryID"].DbInt();
                data.Category.Name = dr["Name"].DbString();
                data.Category.Type = new Shared.Entities.Classifieds.Type() {
                    ID = dr["TypeID"].DbInt()
                };
            }

            return data;
        }

        public static int SaveType(DataTransfer.Classifieds.Categories.TypeFormInput input)
        {
            return DB.RunScalar(@"
IF(@TypeID = 0)
BEGIN
    INSERT Classifieds.Types (Name)
    VALUES (@Name)
    SELECT SCOPE_IDENTITY() AS TypeID
END
ELSE
BEGIN
    UPDATE Classifieds.Types
    SET Name = @Name
    WHERE TypeID = @TypeID
    SELECT @TypeID AS TypeID
END
", CommandType.Text,
                DB.CreateParameter("@TypeID", input.ID),
                DB.CreateParameter("@Name", input.Name)).DbInt();
        }

        public static int SaveCategory(DataTransfer.Classifieds.Categories.CategoryFormInput input)
        {
            return DB.RunScalar(@"
IF(@CategoryID = 0)
BEGIN
    INSERT Classifieds.Categories (TypeID, Name)
    VALUES (@TypeID, @Name)
    SELECT SCOPE_IDENTITY() AS CategoryID
END
ELSE
BEGIN
    UPDATE Classifieds.Categories
    SET TypeID = @TypeID, Name = @Name
    WHERE CategoryID = @CategoryID
    SELECT @CategoryID AS CategoryID
END
", CommandType.Text,
                DB.CreateParameter("@CategoryID", input.ID),
                DB.CreateParameter("@TypeID", input.TypeID),
                DB.CreateParameter("@Name", input.Name)).DbInt();
        }

        public static void DeleteType(int typeId)
        {
            DB.Run(@"
DELETE Classifieds.Types WHERE TypeID = @TypeID
", CommandType.Text,
    DB.CreateParameter("@TypeID", typeId));
        }

        public static void DeleteCategory(int categoryId)
        {
            DB.Run(@"
DELETE Classifieds.Categories WHERE CategoryID = @CategoryID
", CommandType.Text,
    DB.CreateParameter("@CategoryID", categoryId));
        }
    }
}
