﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Data.SqlClient;
using System.Data;
namespace Adams.Admin.DataAccess.Classifieds
{
    public static class Pending
    {
        public static Adams.Admin.DataTransfer.Classifieds.Pending.PageLoad PageLoad()
        {
            var data = new Adams.Admin.DataTransfer.Classifieds.Pending.PageLoad();
            data.Postings = new Shared.Entities.Classifieds.PostingCollection();

            using (SqlDataReader dr = DB.RunDataReader(@"
SELECT P.PostingID,P.CategoryID,P.MemberID,P.StatusID,P.Title,P.Price,P.Location,P.ReplyTo,P.Description,P.CreatedOn,P.ExpiresOn,M.FirstName,M.LastName,M.Email,C.Name As Category,T.TypeID AS TypeID, T.Name AS Type
FROM Classifieds.Postings P 
INNER JOIN Classifieds.Categories C ON P.CategoryID = C.CategoryID 
INNER JOIN Classifieds.Types T ON C.TypeID = T.TypeID 
INNER JOIN Membership.Members M ON P.MemberID = M.MemberID
WHERE P.StatusID = 1
ORDER BY CreatedOn ASC
", CommandType.Text))
            {
                while (dr.Read())
                {
                    var posting = new Shared.Entities.Classifieds.Posting();
                    posting.ID = dr["PostingID"].DbInt();
                    posting.Status = (Shared.Entities.Classifieds.Status)dr["StatusID"].DbInt();
                    posting.Title = dr["Title"].DbString();
                    posting.Price = dr["Price"].DbString();
                    posting.Location = dr["Location"].DbString();
                    posting.ReplyTo = dr["Location"].DbString();
                    posting.Description = dr["Description"].DbString();
                    posting.CreatedOn = dr["CreatedOn"].DbDate();
                    posting.ExpiresOn = dr["ExpiresOn"].DbDate();

                    posting.Category = new Shared.Entities.Classifieds.Category()
                    {
                        ID = dr["CategoryID"].DbInt(),
                        Name = dr["Type"].DbString(),
                        Type = new Shared.Entities.Classifieds.Type()
                        {
                            ID = dr["TypeID"].DbInt(),
                            Name = dr["Type"].DbString()
                        }
                    };

                    posting.Member = new Shared.Entities.Membership.Member()
                    {
                        ID = dr["MemberID"].DbInt(),
                        Email = dr["Email"].DbString(),
                        FirstName = dr["FirstName"].DbString(),
                        LastName = dr["LastName"].DbString(),
                    };

                    data.Postings.Add(posting);
                }
            }

            return data;
        }

        public static void UpdateStatus(Adams.Admin.DataTransfer.Classifieds.Pending.UpdateStatusSave input)
        {
            DB.Run(@"
UPDATE Classifieds.Postings
SET StatusID = @StatusID, ExpiresOn = @ExpiresOn
WHERE PostingID = @PostingID
", CommandType.Text,
                    DB.CreateParameter("@PostingID", input.PostingID, SqlDbType.Int),
                    DB.CreateParameter("@StatusID", input.StatusID, SqlDbType.Int),
                    DB.CreateParameter("@ExpiresOn", input.ExpiresOn));
        }
    }
}
