﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Data.SqlClient;
using System.Data;
namespace Adams.Admin.DataAccess.Pages
{
    public static class Index
    {
        public static Adams.Admin.DataTransfer.Pages.Index.PageLoad PageLoad()
        {
            var data = new Adams.Admin.DataTransfer.Pages.Index.PageLoad();

            return data;
        }

        public static Adams.Admin.DataTransfer.Pages.Index.GridLoad GridLoad(DataTransfer.GridLoadInput gridinput)
        {
            var data = new Adams.Admin.DataTransfer.Pages.Index.GridLoad();
            data.Records = new Shared.Entities.Pages.PageCollection();

            string filter = string.IsNullOrWhiteSpace(gridinput.Search) ? string.Empty : "FREETEXT ((Title,Url), '" + gridinput.Search.Replace("'", "''") + "' )";

            string dbq = DB.BuildPagingQuery(gridinput.StartRow, gridinput.PageSize,
                "PageID,Title,Url",
                "Pages.Pages",
                filter, string.Empty, gridinput.Sort + " " + gridinput.SortDirection, "PageID");

            using (SqlDataReader dr = DB.RunDataReader(dbq, CommandType.Text))
            {
                dr.Read();
                data.TotalRecords = dr[0].DbInt();

                dr.NextResult();
                while (dr.Read())
                {
                    var page = new Shared.Entities.Pages.Page();
                    page.ID = dr["PageID"].DbInt();
                    page.Title = dr["Title"].DbString();
                    page.Url = dr["Url"].DbString();
                    data.Records.Add(page);
                }
            }

            return data;
        }

        public static void Delete(int id)
        {
            DB.Run(@"
DELETE Pages.Pages
WHERE PageID = @PageID
", CommandType.Text,
                DB.CreateParameter("@PageID", id, SqlDbType.Int));
        }
    }
}
