﻿using System;
using System.ComponentModel.DataAnnotations;

namespace Adams.Admin.DataTransfer.Businesses.Create
{
    public class PageLoad
    {
        public Adams.Shared.Entities.Businesses.Business Business { get; set; }
        public Adams.Shared.Entities.Businesses.TypeCollection Types { get; set; }
        public Adams.Shared.Entities.Businesses.CategoryCollection Categories { get; set; }
    }

    public class FormInput
    {
        public string ID { get; set; }

        [Required]
        [Integer]
        public string CategoryID { get; set; }

        [Required]
        [Integer]
        public string StatusID { get; set; }

        [Required]
        [Integer]
        public string MemberID { get; set; }

        [Required]
        [StringLength(70)]
        public string Name { get; set; }

        [Required]
        [StringLength(100)]
        public string Street { get; set; }

        [Required]
        [StringLength(100)]
        public string Street2 { get; set; }

        [Required]
        [StringLength(50)]
        public string City { get; set; }

        [Required]
        [StringLength(40)]
        public string State { get; set; }

        [Required]
        [StringLength(10)]
        public string Zip { get; set; }

        [Required]
        [StringLength(15)]
        public string Phone { get; set; }
        
        [Required]
        public string Description { get; set; }
        
        [Required]
        [Date]
        public string ExpiresOn { get; set; }
    }
}
