﻿using System.ComponentModel.DataAnnotations;

namespace Adams.Admin.DataTransfer.DailyPrayers.CreateLocation
{
    public class PageLoad
    {
        public bool IsMasterAssigned { get; set; }
        public Adams.Shared.Entities.DailyPrayers.Location Location { get; set; }
    }

    public class FormInput
    {
        public string ID { get; set; }
        public bool IsMaster { get; set; }
        public bool InheritMaster { get; set; }

        [Required]
        [StringLength(50)]
        public string Name { get; set; }

        [Required]
        [StringLength(100)]
        public string Street { get; set; }

        [Required]
        [StringLength(100)]
        public string Street2 { get; set; }

        [Required]
        [StringLength(50)]
        public string City { get; set; }

        [Required]
        [StringLength(2)]
        public string State { get; set; }

        [Required]
        [StringLength(10)]
        public string ZipCode { get; set; }

        [Required]
        [StringLength(50)]
        [Decimal]
        public string Latitude { get; set; }

        [Required]
        [StringLength(50)]
        [Decimal]
        public string Longitude { get; set; }

        [Required]
        [Integer]
        public string TimeZone { get; set; }

        public string LongNote { get; set; }

        [Required]
        [Integer]
        public string DisplayOrder { get; set; }
    }
}
