﻿using System.ComponentModel.DataAnnotations;

namespace Adams.Admin.DataTransfer.Membership.CreateMember
{
    public class PageLoad
    {
        public Adams.Shared.Entities.Membership.Member Member { get; set; }
    }

    public class FormInput
    {
        public string ID { get; set; }
        
        [Required]
        [StringLength(50)]
        public string FirstName { get; set; }

        [Required]
        [StringLength(50)]
        public string LastName { get; set; }

        [Required]
        [StringLength(255)]
        [Email]
        public string Email { get; set; }

        [Required]
        [StringLength(100)]
        public string Street { get; set; }

        [Required]
        [StringLength(100)]
        public string Street2 { get; set; }

        [Required]
        [StringLength(50)]
        public string City { get; set; }

        [Required]
        [StringLength(2)]
        public string State { get; set; }

        [Required]
        [StringLength(10)]
        public string ZipCode { get; set; }

        [Required]
        [StringLength(15)]
        public string Phone { get; set; }

        [StringLength(50, MinimumLength=0)]
        public string Password { get; set; }

        public bool IsActive { get; set; }

        public bool IsLocked { get; set; }
    }
}
