﻿using System.Web.Mvc;
using System.Collections.Generic;
using System.Linq;

namespace Adams.Admin.Presentation.Controllers
{
    [Authorize]
    [EnsureSsl]
    public class AnnouncementsController : Controller
    {
        [AppendLayoutViewModel]
        public ActionResult Index()
        {
            var model = Business.Announcements.Index.PageLoad();
            ViewBag.Message = Request["msg"];
            return View(model);
        }

        public JsonResult GridLoad(DataTransfer.GridLoadInput gridinput)
        {
            var model = Business.Announcements.Index.GridLoad(gridinput);
            return Json(model);
        }

        [AppendLayoutViewModel]
        public ActionResult Create(int id)
        {
            var model = Business.Announcements.Create.PageLoad(id);
            return View(model);
        }

        public JsonResult Save(Adams.Admin.DataTransfer.Announcements.Create.FormInput input)
        {
            var model = Business.Announcements.Create.Save(input);
            return Json(model);
        }

        public RedirectResult Delete(int id)
        {
            Business.Announcements.Index.Delete(id);
            var model = new { Deleted = true };
            return Redirect("/Announcements?msg=2");
        }
    }
}
