﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;

namespace Adams.Admin.Presentation.Controllers
{
    [Authorize]
    [EnsureSsl]
    public class EidPrayersController : Controller
    {
        [AppendLayoutViewModel]
        public ActionResult Index()
        {
            
            var model = Business.EidPrayers.Index.PageLoad();
            ViewBag.Message = Request["msg"];
            return View(model);
        }

        [AppendLayoutViewModel]
        public ActionResult CreateLocation(int id)
        {
            
            var model = Business.EidPrayers.CreateLocation.PageLoad(id);
            return View(model);
        }

        public JsonResult SaveLocation(Adams.Admin.DataTransfer.EidPrayers.CreateLocation.FormInput input)
        {
            var model = Business.EidPrayers.CreateLocation.SaveLocation(input);
            return Json(model);
        }

        public RedirectResult DeleteLocation(int id)
        {
            Business.EidPrayers.Index.DeleteLocation(id);
            var model = new { Deleted = true };
            return Redirect("/EidPrayers?msg=2");
        }

        [AppendLayoutViewModel]
        public ActionResult CreatePrayer(int id)
        {
            
            var model = Business.EidPrayers.CreatePrayer.PageLoad(id);
            ViewBag.LocationID = Request["LocationID"].ToInt();
            return View(model);
        }

        public JsonResult SavePrayer(Adams.Admin.DataTransfer.EidPrayers.CreatePrayer.FormInput input)
        {
            var model = Business.EidPrayers.CreatePrayer.SavePrayer(input);
            return Json(model);
        }

        public RedirectResult DeletePrayer(int id)
        {
            Business.EidPrayers.Index.DeletePrayer(id);
            var model = new { Deleted = true };
            return Redirect("/EidPrayers?msg=4");
        }
    }
}
