﻿using System.Web.Mvc;
using System.Collections.Generic;
using System.Linq;

namespace Adams.Admin.Presentation.Controllers
{
    [Authorize]
    [EnsureSsl]
    public class HomeController : Controller
    {
        [AppendLayoutViewModel]
        public ActionResult Index()
        {
            var model = Business.Home.Index.PageLoad();
            ViewBag.Message = Request["msg"];
            return View(model);
        }

        
        [AppendLayoutViewModel]
        public ActionResult Create(int id)
        {
            var model = Business.Home.Create.PageLoad(id);
            return View(model);
        }

        public JsonResult Save(Adams.Admin.DataTransfer.Announcements.Create.FormInput input)
        {
            var model = Business.Home.Create.Save(input);
            return Json(model);
        }

        
    }
}
