﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;

namespace Adams.Admin.Presentation.Controllers
{
    [Authorize]
    [EnsureSsl]
    public class PressReleasesController : Controller
    {
        [AppendLayoutViewModel]
        public ActionResult Index()
        {
            
            var model = Business.PressReleases.Index.PageLoad();
            ViewBag.Message = Request["msg"];
            return View(model);
        }

        public JsonResult GridLoad(DataTransfer.GridLoadInput gridinput)
        {
            var model = Business.PressReleases.Index.GridLoad(gridinput);
            return Json(model);
        }

        [AppendLayoutViewModel]
        public ActionResult Create(int id)
        {
            
            var model = Business.PressReleases.Create.PageLoad(id);
            return View(model);
        }

        public JsonResult Save(Adams.Admin.DataTransfer.PressReleases.Create.FormInput input)
        {
            var model = Business.PressReleases.Create.Save(input);
            return Json(model);
        }

        public RedirectResult Delete(int id)
        {
            Business.PressReleases.Index.Delete(id);
            var model = new { Deleted = true };
            return Redirect("/PressReleases?msg=2");
        }
    }
}
