﻿$(function () {
    var date = new Date();
    var d = date.getDate();
    var m = date.getMonth();
    var y = date.getFullYear();

    var calendar = $('#calendar').fullCalendar({
        header: {
            left: 'prev,next today',
            center: 'title',
            right: 'month,agendaWeek,agendaDay'
        },
        selectable: true,
        selectHelper: true,
        select: function (start, end, allDay, jsEvent, view) {
            var title = prompt('Enter New Event Title:');
            if (title) {
                location.href = "/Events/CreateEvent?start=" + $.fullCalendar.formatDate(start, "MM/dd/yyyy HH:mm") + "&end=" + $.fullCalendar.formatDate(end, "MM/dd/yyyy HH:mm") + "&allday=" + allDay + "&title=" + title;
            }
            calendar.fullCalendar('unselect');
        },
        editable: true,

        eventDrop: function (event, dayDelta, minuteDelta, allDay, revertFunc) {

            var input = {
                occuranceid: event.id,
                dayDelta: dayDelta,
                minuteDelta: minuteDelta,
                allDay: allDay
            };

            Ajax({
                url: "/Events/MoveEvent",
                data: JSON.stringify(input),
                success: function (data) {
               
                }
            });
        },

        eventResize: function (event, dayDelta, minuteDelta, revertFunc) {

            var input = {
                occuranceid: event.id,
                dayDelta: dayDelta,
                minuteDelta: minuteDelta
            };

            Ajax({
                url: "/Events/ResizeEvent",
                data: JSON.stringify(input),
                success: function (data) {
                 
                }
            });

        },

        eventClick: function (calEvent, jsEvent, view) {
            location.href = "/Events/CreateEvent/" + calEvent.id;
        },

        loading: function (bool) {
            if (bool) $('#loading').show();
            else $('#loading').hide();
        },

        events: function (start, end, callback) {

            var input = {
                start: $.fullCalendar.formatDate(start, "MM/dd/yyyy"),
                end: $.fullCalendar.formatDate(end, "MM/dd/yyyy")
            };

            Ajax({
                url: "/Events/GetEvents",
                data: JSON.stringify(input),
                success: function (data) {
                    callback(data);
                },
                complete: function () {

                }
            });
        } //,
        //        events: [
        //				{
        //				    title: 'All Day Event',
        //				    start: new Date(y, m, 1),
        //				    color: "red"
        //				},
        //				{
        //				    title: 'Long Event',
        //				    start: new Date(y, m, d - 5),
        //				    end: new Date(y, m, d - 2)
        //				},
        //				{
        //				    id: 999,
        //				    title: 'Repeating Event',
        //				    start: new Date(y, m, d - 3, 16, 0),
        //				    allDay: false
        //				},
        //				{
        //				    id: 999,
        //				    title: 'Repeating Event',
        //				    start: new Date(y, m, d + 4, 16, 0),
        //				    allDay: false
        //				},
        //				{
        //				    title: 'Meeting',
        //				    start: new Date(y, m, d, 10, 30),
        //				    allDay: false
        //				},
        //				{
        //				    title: 'Lunch',
        //				    start: new Date(y, m, d, 12, 0),
        //				    end: new Date(y, m, d, 14, 0),
        //				    allDay: false
        //				},
        //				{
        //				    title: 'Birthday Party',
        //				    start: new Date(y, m, d + 1, 19, 0),
        //				    end: new Date(y, m, d + 1, 22, 30),
        //				    allDay: false
        //				},
        //				{
        //				    title: 'Click for Google',
        //				    start: new Date(y, m, 28),
        //				    end: new Date(y, m, 29),
        //				    url: 'http://google.com/'
        //				}
        //			]
    });
});
