﻿$(function () {
    $(".nodes").sortable({
        connectWith: ".nodes",
        placeholder: "ph ui-state-highlight",
        update: fUpdate
    }).disableSelection();

    $(".nodes .add").click(fAdd);

    $(".nodes .edit").click(fEdit);

    $(".nodes .delete").click(fDelete);

    $(".nodes .showhide").click(fShowHide);

    $("#cancel").click(function () {
        hideModal($("#editbox"));
    });

    $("#submit").click(function () {
        Submit();
    });

    $("#editbox").keypress(function (event) {
        if (event.which == '13') {
            Submit();
        }
    });

    $("#create").click(function () {

        var parentnodeid = "1";
        var displayorder = $("#p_1").children().length + 1;

        addNode(parentnodeid, displayorder);
    });

    $("#Title").autocomplete({
        source: "/Pages/GetPagesBySearch",
        minLength: 0,
        focus: function (event, ui) {
            $("#Title").val(ui.item.Title);
            $("#Url").val(ui.item.Url);
            return false;
        },
        select: function (event, ui) {
            $("#Title").val(ui.item.Title);
            $("#Url").val(ui.item.Url);
            return false;
        }
    }).data("autocomplete")._renderItem = function (ul, item) {
        return $("<li></li>")
				.data("item.autocomplete", item)
				.append("<a>" + item.Title + " (" + item.Url + ")</a>")
				.appendTo(ul);
    };

    $("#lTitle").autocomplete({
        source: "/Pages/GetPagesBySearch",
        minLength: 0,
        focus: function (event, ui) {
            $("#lTitle").val(ui.item.Title);
            $("#lUrl").val(ui.item.Url);
            return false;
        },
        select: function (event, ui) {
            $("#lTitle").val(ui.item.Title);
            $("#lUrl").val(ui.item.Url);
            return false;
        }
    }).data("autocomplete")._renderItem = function (ul, item) {
        return $("<li></li>")
				.data("item.autocomplete", item)
				.append("<a>" + item.Title + " (" + item.Url + ")</a>")
				.appendTo(ul);
    };

    $("#bTitle").autocomplete({
        source: "/Pages/GetPagesBySearch",
        minLength: 0,
        focus: function (event, ui) {
            $("#bTitle").val(ui.item.Title);
            $("#bUrl").val(ui.item.Url);
            return false;
        },
        select: function (event, ui) {
            $("#bTitle").val(ui.item.Title);
            $("#bUrl").val(ui.item.Url);
            return false;
        }
    }).data("autocomplete")._renderItem = function (ul, item) {
        return $("<li></li>")
				.data("item.autocomplete", item)
				.append("<a>" + item.Title + " (" + item.Url + ")</a>")
				.appendTo(ul);
    };

});

function fUpdate (event, ui) {

    if (ui.sender == null) {

        var parentnodeid = ui.item.parent().attr("id").split("_")[1];

        var nodes = [];
        ui.item.parent().children('li').each(function (idx, elm) {
            nodes.push({
                ID: elm.id.split('_')[1],
                DisplayOrder: idx + 1
            });
        });

        var input = {
            ParentNodeID: parentnodeid,
            Nodes: nodes
        };

        Ajax({
            url: "/SiteMap/WebTopUpdate",
            data: JSON.stringify(input),
            success: function (data) {
                if (data.success) {
                    ShowMessage("saved");
                }
            }
        });

        //db("update " + ui.item.parent().attr("id"));
    }
}

function fShowHide() {

    var nodeid = $(this).parent().attr("id").split("_")[1];
    $("#p_" + nodeid).toggle();
    var src = $("#p_" + nodeid).is(":visible") ? "/Content/images/tree_minus.png" : "/Content/images/tree_plus.png";
    $("img", $(this)).attr("src", src);
}

function fAdd () {

    var parentnodeid = $(this).parent().attr("id").split("_")[1];
    var displayorder = $(this).parent().parent().children().length + 1;

    addNode(parentnodeid, displayorder);
}

function fEdit () {
    var nodeid = $(this).parent().attr("id").split("_")[1];

    var input = {
        NodeID: nodeid
    };

    Ajax({
        url: "/SiteMap/WebTopGetNode",
        data: JSON.stringify(input),
        success: function (data) {
            $("#NodeID").val(data.Node.ID);
            $("#ParentNodeID").val("");
            $("#DisplayOrder").val(""),
                $("#Title").val(data.Node.Title);
            $("#Url").val(data.Node.Url);
            showModal($("#editbox"));
        }
    });
}

function fDelete () {

    if (!confirm("are you sure?")) {
        return;
    }

    var nodeid = $(this).parent().attr("id").split("_")[1];

    var input = {
        NodeID: nodeid
    };

    Ajax({
        url: "/SiteMap/WebDeleteTopNode",
        data: JSON.stringify(input),
        success: function (data) {
            $("#n_" + input.NodeID).fadeOut(1000, function () {
                $(this).remove();
                if ($("#n_" + input.NodeID).parent().children().length == 0) {
                    $("#n_" + input.NodeID).parent().hide();
                }
            });

            ShowMessage("deleted");
        }
    });
}

function addNode(parentnodeid, displayorder) {
    $("#NodeID").val("0");
    $("#ParentNodeID").val(parentnodeid);
    $("#DisplayOrder").val(displayorder),
        $("#Title").val("");
    $("#Url").val("");
    showModal($("#editbox"));
}

function db(message) {
    $("#msg").html($("#msg").html() + "<br/>" + message);
}

function Submit() {

    $("#submit").hide();

    var input = {
        ID: $("#NodeID").val(),
        ParentNodeID: $("#ParentNodeID").val(),
        DisplayOrder: $("#DisplayOrder").val(),
        Title: $("#Title").val(),
        Url: $("#Url").val()
    };

    Ajax({
        url: "/Sitemap/WebSaveTopNode",
        data: JSON.stringify(input),
        success: function (data) {
            ShowValidationErrors(data);
            if (data.IsSaved == true) {
                hideModal($("#editbox"));
                ShowMessage("saved");

                if (input.ParentNodeID.length > 0) {
                    var liclass;
                    if (input.ParentNodeID == "1") {
                        liclass = "level1";
                    } else {
                        liclass = "level2";
                    }

                    var html = "<li id=\"n_" + data.ID + "\" class=\"" + liclass + "\"><span>" + input.Title + "</span>";
                    html += "<a href=\"#\"class=\"delete\"><img src=\"/Content/images/cross.png\" alt=\"delete\" /></a>";
                    html += "<a href=\"#\" class=\"edit\"><img src=\"/Content/images/pencil.png\" alt=\"Edit\" /></a>";
                    html += "<a href=\"#\" class=\"add\"><img src=\"/Content/images/add.png\" alt=\"Add\" /></a>";
                    html += "<ul id=\"p_" + data.ID + "\" class=\"nodes\"></ul></li>";

                    $("#p_" + input.ParentNodeID).show().append(html);

                    $("#p_" + data.ID).sortable({
                        connectWith: ".nodes",
                        placeholder: "ph ui-state-highlight",
                        update: fUpdate
                    }).disableSelection();

                    $("#n_" + data.ID + " .add").click(fAdd);
                    $("#n_" + data.ID + " .edit").click(fEdit);
                    $("#n_" + data.ID + " .delete").click(fDelete);
                    $("#n_" + data.ID + " .showhide").click(fShowHide);
                }

                $("#n_" + input.ID + " span:first").text(input.Title);
                $("#n_" + input.ID + " span:first").fadeOut(1000, function () {
                    $(this).fadeIn(2000)
                });
            }
        },
        complete: function () {
            $("#submit").show();
        }
    });
}












$(function () {
    $(".lnodes").sortable({
        connectWith: ".lnodes",
        placeholder: "ph ui-state-highlight",
        update: lfUpdate
    }).disableSelection();

    $(".lnodes .ladd").click(lfAdd);

    $(".lnodes .ledit").click(lfEdit);

    $(".lnodes .ldelete").click(lfDelete);

    $(".lnodes .lshowhide").click(lfShowHide);

    $("#lcancel").click(function () {
        hideModal($("#leditbox"));
    });

    $("#lsubmit").click(function () {
        lSubmit();
    });

    $("#leditbox").keypress(function (event) {
        if (event.which == '13') {
            lSubmit();
        }
    });

    $("#lcreate").click(function () {

        var parentnodeid = "1";
        var displayorder = $("#lp_1").children().length + 1;

        laddNode(parentnodeid, displayorder);
    });

});

function lfShowHide() {

    var nodeid = $(this).parent().attr("id").split("_")[1];
    $("#lp_" + nodeid).toggle();
    var src = $("#lp_" + nodeid).is(":visible") ? "/Content/images/tree_minus.png" : "/Content/images/tree_plus.png";
    $("img", $(this)).attr("src", src);
}

function lfUpdate(event, ui) {

    if (ui.sender == null) {

        var parentnodeid = ui.item.parent().attr("id").split("_")[1];

        var nodes = [];
        ui.item.parent().children('li').each(function (idx, elm) {
            nodes.push({
                ID: elm.id.split('_')[1],
                DisplayOrder: idx + 1
            });
        });

        var input = {
            ParentNodeID: parentnodeid,
            Nodes: nodes
        };

        Ajax({
            url: "/SiteMap/WebLeftUpdate",
            data: JSON.stringify(input),
            success: function (data) {
                if (data.success) {
                    ShowMessage("saved");
                }
            }
        });
    }
}

function lfAdd() {

    var parentnodeid = $(this).parent().attr("id").split("_")[1];
    var displayorder = $(this).parent().parent().children().length + 1;

    laddNode(parentnodeid, displayorder);
}

function lfEdit() {
    var nodeid = $(this).parent().attr("id").split("_")[1];

    var input = {
        NodeID: nodeid
    };

    Ajax({
        url: "/SiteMap/WebLeftGetNode",
        data: JSON.stringify(input),
        success: function (data) {
            $("#lNodeID").val(data.Node.ID);
            $("#lParentNodeID").val("");
            $("#lDisplayOrder").val(""),
            $("#lTitle").val(data.Node.Title);
            $("#lUrl").val(data.Node.Url);
            showModal($("#leditbox"));
        }
    });
}

function lfDelete() {

    if (!confirm("are you sure?")) {
        return;
    }

    var nodeid = $(this).parent().attr("id").split("_")[1];

    var input = {
        NodeID: nodeid
    };

    Ajax({
        url: "/SiteMap/WebDeleteLeftNode",
        data: JSON.stringify(input),
        success: function (data) {
            $("#ln_" + input.NodeID).fadeOut(1000, function () {
                $(this).remove();
                if ($("#ln_" + input.NodeID).parent().children().length == 0) {
                    $("#ln_" + input.NodeID).parent().hide();
                }
            });

            ShowMessage("deleted");
        }
    });
}

function laddNode(parentnodeid, displayorder) {
    $("#lNodeID").val("0");
    $("#lParentNodeID").val(parentnodeid);
    $("#lDisplayOrder").val(displayorder),
    $("#lTitle").val("");
    $("#lUrl").val("");
    showModal($("#leditbox"));
}

function lSubmit() {

    $("#lsubmit").hide();

    var input = {
        ID: $("#lNodeID").val(),
        ParentNodeID: $("#lParentNodeID").val(),
        DisplayOrder: $("#lDisplayOrder").val(),
        Title: $("#lTitle").val(),
        Url: $("#lUrl").val()
    };

    Ajax({
        url: "/Sitemap/WebSaveLeftNode",
        data: JSON.stringify(input),
        success: function (data) {
            ShowValidationErrors(data, { Title: "lTitle", Url: "lUrl" });
            if (data.IsSaved == true) {
                hideModal($("#leditbox"));
                ShowMessage("saved");

                if (input.ParentNodeID.length > 0) {
                    var liclass;
                    if (input.ParentNodeID == "1") {
                        liclass = "llevel1";
                    } else {
                        liclass = "llevel2";
                    }

                    var html = "<li id=\"ln_" + data.ID + "\" class=\"" + liclass + "\"><span>" + input.Title + "</span>";
                    html += "<a href=\"#\"class=\"ldelete\"><img src=\"/Content/images/cross.png\" alt=\"delete\" /></a>";
                    html += "<a href=\"#\" class=\"ledit\"><img src=\"/Content/images/pencil.png\" alt=\"Edit\" /></a>";
                    html += "<a href=\"#\" class=\"ladd\"><img src=\"/Content/images/add.png\" alt=\"Add\" /></a>";
                    html += "<ul id=\"lp_" + data.ID + "\" class=\"lnodes\"></ul></li>";

                    $("#lp_" + input.ParentNodeID).show().append(html);

                    $("#lp_" + data.ID).sortable({
                        connectWith: ".lnodes",
                        placeholder: "ph ui-state-highlight",
                        update: fUpdate
                    }).disableSelection();

                    $("#ln_" + data.ID + " .ladd").click(fAdd);
                    $("#ln_" + data.ID + " .ledit").click(fEdit);
                    $("#ln_" + data.ID + " .ldelete").click(fDelete);
                    $("#ln_" + data.ID + " .lshowhide").click(lfShowHide);
                }

                $("#ln_" + input.ID + " span:first").text(input.Title);
                $("#ln_" + input.ID + " span:first").fadeOut(1000, function () {
                    $(this).fadeIn(2000)
                });
            }
        },
        complete: function () {
            $("#lsubmit").show();
        }
    });
}
















$(function () {
    $(".bnodes").sortable({
        connectWith: ".bnodes",
        placeholder: "ph ui-state-highlight",
        update: bfUpdate
    }).disableSelection();

    $(".bnodes .badd").click(bfAdd);

    $(".bnodes .bedit").click(bfEdit);

    $(".bnodes .bdelete").click(bfDelete);

    $(".bnodes .bshowhide").click(bfShowHide);

    $("#bcancel").click(function () {
        hideModal($("#beditbox"));
    });

    $("#bsubmit").click(function () {
        bSubmit();
    });

    $("#beditbox").keypress(function (event) {
        if (event.which == '13') {
            bSubmit();
        }
    });

    $("#bcreate").click(function () {

        var parentnodeid = "1";
        var displayorder = $("#bp_1").children().length + 1;

        baddNode(parentnodeid, displayorder);
    });

});

function bfShowHide() {

    var nodeid = $(this).parent().attr("id").split("_")[1];
    $("#bp_" + nodeid).toggle();
    var src = $("#bp_" + nodeid).is(":visible") ? "/Content/images/tree_minus.png" : "/Content/images/tree_plus.png";
    $("img", $(this)).attr("src", src);
}

function bfUpdate(event, ui) {

    if (ui.sender == null) {

        var parentnodeid = ui.item.parent().attr("id").split("_")[1];

        var nodes = [];
        ui.item.parent().children('li').each(function (idx, elm) {
            nodes.push({
                ID: elm.id.split('_')[1],
                DisplayOrder: idx + 1
            });
        });

        var input = {
            ParentNodeID: parentnodeid,
            Nodes: nodes
        };

        Ajax({
            url: "/SiteMap/WebBottomUpdate",
            data: JSON.stringify(input),
            success: function (data) {
                if (data.success) {
                    ShowMessage("saved");
                }
            }
        });
    }
}

function bfAdd() {

    var parentnodeid = $(this).parent().attr("id").split("_")[1];
    var displayorder = $(this).parent().parent().children().length + 1;

    baddNode(parentnodeid, displayorder);
}

function bfEdit() {
    var nodeid = $(this).parent().attr("id").split("_")[1];

    var input = {
        NodeID: nodeid
    };

    Ajax({
        url: "/SiteMap/WebBottomGetNode",
        data: JSON.stringify(input),
        success: function (data) {
            $("#bNodeID").val(data.Node.ID);
            $("#bParentNodeID").val("");
            $("#bDisplayOrder").val(""),
            $("#bTitle").val(data.Node.Title);
            $("#bUrl").val(data.Node.Url);
            showModal($("#beditbox"));
        }
    });
}

function bfDelete() {

    if (!confirm("are you sure?")) {
        return;
    }

    var nodeid = $(this).parent().attr("id").split("_")[1];

    var input = {
        NodeID: nodeid
    };

    Ajax({
        url: "/SiteMap/WebDeleteBottomNode",
        data: JSON.stringify(input),
        success: function (data) {
            $("#bn_" + input.NodeID).fadeOut(1000, function () {
                $(this).remove();
                if ($("#bn_" + input.NodeID).parent().children().length == 0) {
                    $("#bn_" + input.NodeID).parent().hide();
                }
            });

            ShowMessage("deleted");
        }
    });
}

function baddNode(parentnodeid, displayorder) {
    $("#bNodeID").val("0");
    $("#bParentNodeID").val(parentnodeid);
    $("#bDisplayOrder").val(displayorder),
    $("#bTitle").val("");
    $("#bUrl").val("");
    showModal($("#beditbox"));
}

function bSubmit() {

    $("#bsubmit").hide();

    var input = {
        ID: $("#bNodeID").val(),
        ParentNodeID: $("#bParentNodeID").val(),
        DisplayOrder: $("#bDisplayOrder").val(),
        Title: $("#bTitle").val(),
        Url: $("#bUrl").val()
    };

    Ajax({
        url: "/Sitemap/WebSaveBottomNode",
        data: JSON.stringify(input),
        success: function (data) {
            ShowValidationErrors(data, { Title: "bTitle", Url: "bUrl" });
            if (data.IsSaved == true) {
                hideModal($("#beditbox"));
                ShowMessage("saved");

                if (input.ParentNodeID.length > 0) {
                    var liclass;
                    if (input.ParentNodeID == "1") {
                        liclass = "blevel1";
                    } else {
                        liclass = "blevel2";
                    }

                    var html = "<li id=\"bn_" + data.ID + "\" class=\"" + liclass + "\"><span>" + input.Title + "</span>";
                    html += "<a href=\"#\"class=\"bdelete\"><img src=\"/Content/images/cross.png\" alt=\"delete\" /></a>";
                    html += "<a href=\"#\" class=\"bedit\"><img src=\"/Content/images/pencil.png\" alt=\"Edit\" /></a>";
                    html += "<a href=\"#\" class=\"badd\"><img src=\"/Content/images/add.png\" alt=\"Add\" /></a>";
                    html += "<ul id=\"bp_" + data.ID + "\" class=\"bnodes\"></ul></li>";

                    $("#bp_" + input.ParentNodeID).show().append(html);

                    $("#bp_" + data.ID).sortable({
                        connectWith: ".bnodes",
                        placeholder: "ph ui-state-highlight",
                        update: fUpdate
                    }).disableSelection();

                    $("#bn_" + data.ID + " .badd").click(fAdd);
                    $("#bn_" + data.ID + " .bedit").click(fEdit);
                    $("#bn_" + data.ID + " .bdelete").click(fDelete);
                    $("#bn_" + data.ID + " .bshowhide").click(lfShowHide);
                }

                $("#bn_" + input.ID + " span:first").text(input.Title);
                $("#bn_" + input.ID + " span:first").fadeOut(1000, function () {
                    $(this).fadeIn(2000)
                });
            }
        },
        complete: function () {
            $("#bsubmit").show();
        }
    });
}

