﻿$.ajaxSetup({
    error: function (request, status, error) {
        showErrorAlert(request.responseText);
    }
});

// Ajax Call
function Ajax(obj) {
    obj.type = "POST";
    obj.dataType = "json";
    obj.contentType = "application/json; charset=utf-8";
    obj.cache = false;
    obj.timeout = 60000;
    $.ajax(obj);
}

// Show Message
function ShowMessage(msg){
    var html = '<div class="notification success png_bg"><div><b>' + msg + '</b></div></div>';
    $('<div class="message"></div>').prependTo("#main-content").html(html).fadeIn("slow", HideMessage);
}
function HideMessage(msg) {
    setTimeout(function () { $(".message").fadeOut("slow") }, 5000);
}

// Error Alert
var isErrorLoaded = false;
function showErrorAlert(msg) {
    if (!isErrorLoaded) {
        $('<div id="erroralert"></div>').html(msg).appendTo("body").dblclick(function () {
            hideModal($("#erroralert"));
        });
    }
    isErrorLoaded = true;
    showModal($("#erroralert"));
    return false;
}

// Modal Overlay
function showModal(jqObj) {
    $("<div id='modalbg' class='modalbg'></div>").appendTo("body").css("z-index", "100");
    jqObj.css({ "position": "absolute", "z-index": "101" }).fadeIn(300);
    changeModal(jqObj);
    $(window).resize(function () {
        changeModal(jqObj);
    });
    $(window).scroll(function () {
        changeModal(jqObj);
    });
}
function hideModal(jqObj) {
    jqObj.fadeOut(300); ;
    $("#modalbg").remove();
}
function changeModal(jqObj) {
    resizeModalBg();
    resizeModal(jqObj);
}
function resizeModalBg() {
    var bg = $("#modalbg");
    var documentwidth = $(document).width();
    var documentheight = $(document).height();
    bg.width(documentwidth);
    bg.height(documentheight);
}
function resizeModal(jqObj) {
    var screenwidth = $(window).width();
    var screenheight = $(window).height();
    var scrolltop = $(window).scrollTop();
    var jqObjwidth = $(jqObj).width();
    var jqObjheight = $(jqObj).height();
    var lefter = ((screenwidth - jqObjwidth) / 2);
    var upper = ((screenheight - jqObjheight) / 2) + scrolltop;
    jqObj.css({ "top": upper + "px", "left": lefter + "px" });
}

// Show Validation Errors
function ShowValidationErrors(formOutput, ids) {

    $("span.error").remove();
    $(".errorinput").removeClass("errorinput");

    for (var i in formOutput.InvalidFields) {
        var invalidfield = formOutput.InvalidFields[i];
        DisplayValidationError(formOutput, invalidfield.Name, invalidfield.Code, ids);
    }
}

function DisplayValidationError(formOutput, name, code, ids) {

    var msg = "";
    if (code == 1) {
        msg = "invalid input";
    } else if (code == 4) {
        msg = "already taken";
    } else if (code == 5) {
        msg = "invalid password";
    } else if (code == 6) {
        msg = "does not match";
    } else if (code == 7) {
        msg = "master already chosen";
    } else if (code == 7) {
        msg = "master cannot inherit";
    } else if (code == 20) {
        msg = "email not registered";
    } else if (code == 21) {
        msg = "email already registered";
    } else if (code == 22) {
        msg = "locked out for " + formOutput.LockWaitMinutes + " minutes";
    } else if (code == 23) {
        msg = "invalid password. " + formOutput.AttemptsLeft + " attempts left.";
    } else if (code == 24) {
        msg = "email not active";
    } else {
        alert("error code " + code);
    }

    if (ids) {
        if (ids[name]) {
            name = ids[name];
        }
    }

    var espan = $('<span class="error">' + msg + '</span>');

    $("#" + name).focus();
    $("#" + name).after(espan);

    espan.show().css({
        opacity: 0,
        "margin-left": 50 + 'px'
    }).animate({
        "margin-left": 0 + 'px',
        opacity: 1
    }, 'slow');
}

function formatDate(d) {
    var date = eval(d.replace(/\/Date\((\d+)\)\//gi, "new Date($1)"));
    var day = date.getDate();
    var month = date.getMonth();
    var year = date.getFullYear();
    return month + "/" + day + "/" + year;
}