﻿using System.Data;
using System.Data.SqlClient;

namespace Adams.Public.DataAccess
{
    public static class Pages
    {
        public static Adams.Shared.Entities.Pages.Page GetPage(Adams.Public.DataTransfer.Pages.GetPageInput input)
        {
            var data = new Adams.Shared.Entities.Pages.Page();

            using (SqlDataReader dr = DB.RunDataReader(@"
SELECT P.*
FROM Pages.Pages P
WHERE P.Url = @Url
", CommandType.Text,
    DB.CreateParameter("@Url", input.Url)))
            {

                if (dr.HasRows)
                {
                    dr.Read();
                    data.ID = dr["PageID"].DbInt();
                    data.Title = dr["Title"].DbString();
                    data.Url = dr["Url"].DbString();
                    data.Content = dr["Content"].DbString();
                }

                return data;
            }
        }
    }
}
