﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using System.Web.Routing;

namespace Adams.Public.Mobile
{
    // Note: For instructions on enabling IIS6 or IIS7 classic mode, 
    // visit http://go.microsoft.com/?LinkId=9394801

    public class MvcApplication : System.Web.HttpApplication
    {
        public static void RegisterGlobalFilters(GlobalFilterCollection filters)
        {
            filters.Add(new HandleErrorAttribute());
        }

        public static void RegisterRoutes(RouteCollection routes)
        {
            routes.IgnoreRoute("{resource}.axd/{*pathInfo}");

            routes.MapRoute("Home", "", new { controller = "Home", action = "Index" });

            routes.MapRoute("Event", "Events/{id}", new { controller = "Events", action = "Event", id = "" }, new { id = @"\d+" });
            routes.MapRoute("Events", "Events/{action}", new { controller = "Events", action = "Index" });

            routes.MapRoute("Announcement", "Announcements/{id}", new { controller = "Announcements", action = "Announcement", id = "" }, new { id = @"\d+" });
            routes.MapRoute("Announcements", "Announcements/{action}", new { controller = "Announcements", action = "Index" });

            routes.MapRoute("Pages", "{*url}", new { controller = "Pages", action = "Index" });
        }

        protected void Application_Start()
        {
            AreaRegistration.RegisterAllAreas();

            RegisterGlobalFilters(GlobalFilters.Filters);
            RegisterRoutes(RouteTable.Routes);
        }
    }
}