﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;

namespace Adams.Public.Web.Areas.Membership.Controllers
{
    [Authorize]
    [EnsureSsl]
    public class BusinessesController : Controller
    {
        [AppendLayoutViewModel]
        public ActionResult Index()
        {
            var token = User.Identity.Name;
            var model = Adams.Public.Web.Business.Web.Areas.Membership.Businesses.Index.PageLoad(token);
            return View(model);
        }

        [AppendLayoutViewModel]
        public ActionResult Create(int id)
        {
            var token = User.Identity.Name;
            var model = Adams.Public.Web.Business.Web.Areas.Membership.Businesses.Create.PageLoad(token, id);
            return View(model);
        }

        public JsonResult GetCategoriesByType(string typeId)
        {
            var model = Adams.Public.Web.Business.Web.Areas.Membership.Businesses.Create.GetCategoriesByType(typeId.ToInt());
            return Json(model);
        }

        public JsonResult Save(Adams.Public.DataTransfer.Web.Areas.Membership.Businesses.Create.FormInput input)
        {
            input.Token = User.Identity.Name;
            var model = Adams.Public.Web.Business.Web.Areas.Membership.Businesses.Create.Save(input);
            return Json(model);
        }

        public JsonResult Renew(Adams.Public.DataTransfer.Businesses.RenewInput input)
        {
            input.Token = User.Identity.Name;
            var model = Business.Web.Areas.Membership.Businesses.Index.Renew(input);
            return Json(model);
        }

        public JsonResult Remove(Adams.Public.DataTransfer.Businesses.RemoveInput input)
        {
            input.Token = User.Identity.Name;
            var model = Business.Web.Areas.Membership.Businesses.Index.Remove(input);
            return Json(model);
        }
    }
}