﻿using Adams.Admin.Business.Security;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using System;

namespace Adams.Tests.Admin.Business.Console
{
    
    
    /// <summary>
    ///This is a test class for LoginUnitTest and is intended
    ///to contain all LoginUnitTest Unit Tests
    ///</summary>
    [TestClass()]
    public class LoginUnitTest
    {


        private TestContext testContextInstance;

        /// <summary>
        ///Gets or sets the test context which provides
        ///information about and functionality for the current test run.
        ///</summary>
        public TestContext TestContext
        {
            get
            {
                return testContextInstance;
            }
            set
            {
                testContextInstance = value;
            }
        }

        #region Additional test attributes
        // 
        //You can use the following additional attributes as you write your tests:
        //
        //Use ClassInitialize to run code before running the first test in the class
        //[ClassInitialize()]
        //public static void MyClassInitialize(TestContext testContext)
        //{
        //}
        //
        //Use ClassCleanup to run code after all tests in a class have run
        //[ClassCleanup()]
        //public static void MyClassCleanup()
        //{
        //}
        //
        //Use TestInitialize to run code before running each test
        //[TestInitialize()]
        //public void MyTestInitialize()
        //{
        //}
        //
        //Use TestCleanup to run code after each test has run
        //[TestCleanup()]
        //public void MyTestCleanup()
        //{
        //}
        //
        #endregion


        /// <summary>
        ///A test for IsLocked
        ///</summary>
        [TestMethod()]
        public void IsLockedUnitTest()
        {
            int failedLoginAttempts = 0;
            DateTime lastLoginAttempt = new DateTime(); 
            bool expected = false;
            bool actual;
            actual = Adams.Shared.SecurityHelper.IsLocked(failedLoginAttempts, lastLoginAttempt, 5, 5);
            Assert.AreEqual(expected, actual);

            failedLoginAttempts = 5;
            lastLoginAttempt = DateTime.UtcNow.AddMinutes(-1); 
            expected = true;
            actual = Adams.Shared.SecurityHelper.IsLocked(failedLoginAttempts, lastLoginAttempt, 5, 5);
            Assert.AreEqual(expected, actual);

            failedLoginAttempts = 5;
            lastLoginAttempt = DateTime.UtcNow.AddMinutes(-20);
            expected = false;
            actual = Adams.Shared.SecurityHelper.IsLocked(failedLoginAttempts, lastLoginAttempt, 5, 5);
            Assert.AreEqual(expected, actual);

            failedLoginAttempts = 10;
            lastLoginAttempt = DateTime.UtcNow.AddMinutes(-20);
            expected = true;
            actual = Adams.Shared.SecurityHelper.IsLocked(failedLoginAttempts, lastLoginAttempt, 5, 5);
            Assert.AreEqual(expected, actual);
        }

        /// <summary>
        ///A test for GetLockWaitMinutes
        ///</summary>
        [TestMethod()]
        public void GetLockWaitMinutesUnitTest()
        {
            int failedLoginAttempts = 0;
            DateTime lastLoginAttempt = new DateTime();
            double expected = 0;
            double actual;
            actual = Adams.Shared.SecurityHelper.GetLockWaitMinutes(failedLoginAttempts, lastLoginAttempt, 5, 5);
            Assert.AreEqual(expected, actual);

            failedLoginAttempts = 5;
            lastLoginAttempt = DateTime.UtcNow.AddMinutes(-1);
            expected = 4;
            actual = Adams.Shared.SecurityHelper.GetLockWaitMinutes(failedLoginAttempts, lastLoginAttempt, 5, 5);
            Assert.AreEqual(expected, actual);

            failedLoginAttempts = 5;
            lastLoginAttempt = DateTime.UtcNow.AddMinutes(-20);
            expected = 0;
            actual = Adams.Shared.SecurityHelper.GetLockWaitMinutes(failedLoginAttempts, lastLoginAttempt, 5, 5);
            Assert.AreEqual(expected, actual);

            failedLoginAttempts = 10;
            lastLoginAttempt = DateTime.UtcNow.AddMinutes(-20);
            expected = 10;
            actual = Adams.Shared.SecurityHelper.GetLockWaitMinutes(failedLoginAttempts, lastLoginAttempt, 5, 5);
            Assert.AreEqual(expected, actual);
        }
    }
}
