﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;

namespace Adams.Web.Areas.MyAdams.Controllers
{
    [Authorize]
    [EnsureSsl]
    public class BusinessesController : Controller
    {
        [AppendLayoutModel]
        public ActionResult Index()
        {
            var memberid = User.Identity.Name.ToInt();
            var model = MyAdams.Logic.Businesses.Index.PageLoad(memberid);
            return View(Adams.Web.Controllers.MobileCheck.IsMobile() ? "Index.Mobile" : "Index", model);
        }

        public JsonResult Renew(int businessId)
        {
            var memberid = User.Identity.Name.ToInt();
            var model = MyAdams.Logic.Businesses.Index.Renew(memberid, businessId);
            return Json(model);
        }

        public JsonResult Remove(int businessId)
        {
            var memberid = User.Identity.Name.ToInt();
            var model = MyAdams.Logic.Businesses.Index.Remove(memberid, businessId);
            return Json(model);
        }

        [AppendLayoutModel]
        public ActionResult Create(int id)
        {
            var memberid = User.Identity.Name.ToInt();
            var model = MyAdams.Logic.Businesses.Create.PageLoad(memberid, id);
            return View(Adams.Web.Controllers.MobileCheck.IsMobile() ? "Create.Mobile" : "Create", model);
        }

        public JsonResult GetCategoriesByType(int typeId)
        {
            var model = MyAdams.Logic.Businesses.Create.GetCategoriesByType(typeId);
            return Json(model);
        }

        public JsonResult Save(MyAdams.Models.Businesses.Create.FormInput input)
        {
            input.MemberID = User.Identity.Name.ToInt();
            var model = MyAdams.Logic.Businesses.Create.Save(input);
            return Json(model);
        }
    }
}