﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;

namespace Adams.Web.Controllers
{
    public class BusinessesController : Controller
    {
        [AppendLayoutModel]
        public ActionResult Index()
        {
            var model = Logic.Businesses.Index.PageLoad();
            return View(MobileCheck.IsMobile() ? "Index.Mobile" : "Index", model);
        }

        [AppendLayoutModel]
        public ActionResult List(string type, string category)
        {
            type = Shared.UrlHelper.Dec(type);
            category = Shared.UrlHelper.Dec(category);
            var model = Logic.Businesses.List.PageLoad(type, category);
            return View(MobileCheck.IsMobile() ? "List.Mobile" : "List", model);
        }

        [AppendLayoutModel]
        public ActionResult Search(string criteria)
        {
            var model = Logic.Businesses.Search.PageLoad(criteria);
            return View(MobileCheck.IsMobile() ? "Search.Mobile" : "Search", model);
        }

        [AppendLayoutModel]
        public ActionResult Business(string id)
        {
            var model = Logic.Businesses.Business.PageLoad(id.ToInt());
            if (model.Business == null)
            {
                return HttpNotFound();
            }
            else
            {
                return View(MobileCheck.IsMobile() ? "Business.Mobile" : "Business", model);
            }
        }
    }
}
