﻿using System;
using System.Data;
using System.Data.SqlClient;
using System.Linq;

namespace Adams.Web.Data.Businesses
{
    public static class Search
    {
        public static Adams.Web.Models.Businesses.Search.PageLoad PageLoad(string criteria)
        {
            var data = new Adams.Web.Models.Businesses.Search.PageLoad() { 
                Businesses = new Shared.Entities.Businesses.BusinessCollection()
            };

            using (SqlDataReader dr = DB.RunDataReader(@"
SELECT P.BusinessID,P.CategoryID,P.StatusID,P.Name,P.Street,P.Street2,P.City,P.State,P.Zip,P.Phone,P.Description,P.CreatedOn,P.ExpiresOn,C.Name As CategoryName,T.TypeID AS TypeID, T.Name AS TypeName
FROM Businesses.Businesses P 
INNER JOIN Businesses.Categories C ON P.CategoryID = C.CategoryID 
INNER JOIN Businesses.Types T ON C.TypeID = T.TypeID 
WHERE FREETEXT ((P.Name,P.Street,P.Street2,P.City,P.State,P.Zip,P.Phone,P.Description), '" + criteria.Replace("'", "''") + @"' )
AND P.StatusID = 2  AND DATEDIFF(d, GETDATE(), P.ExpiresOn) >= 0
ORDER BY ExpiresOn DESC
", CommandType.Text,
    DB.CreateParameter("@Search", criteria)))
            {
                while (dr.Read())
                {
                    var Business = DB.InitFromReader<Shared.Entities.Businesses.Business>(dr, new ColMap { NameInDb = "BusinessID", NameInObject = "ID" });
                    Business.Status = (Shared.Entities.Businesses.Status)dr["StatusID"].DbInt();
                    Business.Category = new Shared.Entities.Businesses.Category()
                    {
                        ID = dr["CategoryID"].DbInt(),
                        Name = dr["CategoryName"].DbString(),
                        Type = new Shared.Entities.Businesses.Type()
                        {
                            ID = dr["TypeID"].DbInt(),
                            Name = dr["TypeName"].DbString()
                        }
                    };

                    data.Businesses.Add(Business);
                }
            }

            return data;
        }
    }
}