﻿using System;
using System.Data;
using System.Data.SqlClient;
using System.Linq;

namespace Adams.Web.Data.Classifieds
{
    public static class List
    {
        public static Adams.Web.Models.Classifieds.List.PageLoad PageLoad(string type, string category)
        {
            var data = new Adams.Web.Models.Classifieds.List.PageLoad() { 
                Postings = new Shared.Entities.Classifieds.PostingCollection()
            };

            using (SqlDataReader dr = DB.RunDataReader(@"
SELECT P.PostingID,P.CategoryID,P.StatusID,P.Title,P.Price,P.Location,P.ReplyTo,P.Description,P.CreatedOn,P.ExpiresOn,C.Name As CategoryName,T.TypeID AS TypeID, T.Name AS TypeName
FROM Classifieds.Postings P 
INNER JOIN Classifieds.Categories C ON P.CategoryID = C.CategoryID 
INNER JOIN Classifieds.Types T ON C.TypeID = T.TypeID 
WHERE T.Name = @Type" + (string.IsNullOrEmpty(category) ? "" : @" AND C.Name = @Category") + @"
AND P.StatusID = 2 AND DATEDIFF(d, GETDATE(), P.ExpiresOn) >= 0
ORDER BY ExpiresOn DESC
", CommandType.Text,
    DB.CreateParameter("@Type", type),
    DB.CreateParameter("@Category", category)))
            {
                while (dr.Read())
                {
                    var Posting = DB.InitFromReader<Shared.Entities.Classifieds.Posting>(dr, new ColMap { NameInDb = "PostingID", NameInObject = "ID" });
                    Posting.Status = (Shared.Entities.Classifieds.Status)dr["StatusID"].DbInt();
                    data.Postings.Add(Posting);
                }
            }

            return data;
        }
    }
}