﻿using System.Data;
using System.Data.SqlClient;

namespace Adams.Web.Data
{
    public static class Files
    {
        public static Models.Files.Index.PageLoad PageLoad(string url)
        {
            var data = new Models.Files.Index.PageLoad();
            data.File = new Shared.Entities.Files.File();

            using (SqlDataReader dr = DB.RunDataReader(@"
SELECT F.*
FROM Files.Files F
WHERE Url = @Url
", CommandType.Text,
    DB.CreateParameter("@Url", url)))
            {
                dr.Read();
                data.File.ID = dr["FileID"].DbInt();
                data.File.Url = dr["Url"].DbString();
                data.File.ContentType = dr["ContentType"].DbString();
                data.File.Size = dr["Size"].DbLong();
                data.File.LastModified = dr["LastModified"].DbDate();
                data.File.Content = (byte[])dr["Content"];
            }

            return data;
        }
    }
}
