﻿using System.Data;
using System.Data.SqlClient;
using System.Linq;

namespace Adams.Web.Data.JummahPrayers
{
    public static class Index
    {
        public static Adams.Web.Models.JummahPrayers.Index.PageLoad PageLoad()
        {
            var data = new Adams.Web.Models.JummahPrayers.Index.PageLoad() { 
                Locations = new Shared.Entities.JummahPrayers.LocationCollection()
            };

            using (SqlDataReader dr = DB.RunDataReader(@"
SELECT LocationID, Name, Street, Street2, City, State, ZipCode, Latitude, Longitude, DisplayOrder
FROM JummahPrayers.Locations
ORDER BY DisplayOrder

SELECT *
FROM JummahPrayers.Prayers
ORDER BY DisplayOrder
", CommandType.Text))
            {

                while (dr.Read())
                {
                    var location = DB.InitFromReader<Shared.Entities.JummahPrayers.Location>(dr, new ColMap{ NameInDb="LocationID", NameInObject="ID" });
                    location.Prayers = new Shared.Entities.JummahPrayers.PrayerCollection();
                    data.Locations.Add(location);
                }

                dr.NextResult();

                while (dr.Read())
                {
                    var prayer = DB.InitFromReader<Shared.Entities.JummahPrayers.Prayer>(dr, new ColMap{ NameInDb="PrayerID", NameInObject="ID" });
                    data.Locations.Where(l => l.ID == dr["LocationID"].DbInt()).FirstOrDefault().Prayers.Add(prayer);
                }

                return data;
            }
        }
    }
}
