﻿using System.Data;
using System.Data.SqlClient;

namespace Adams.Web.Data.PressReleases
{
    public static class PressRelease
    {
        public static Models.PressReleases.PressRelease.PageLoad PageLoad(int id)
        {
            var data = new Models.PressReleases.PressRelease.PageLoad();

            using (SqlDataReader dr = DB.RunDataReader(@"
SELECT P.* 
FROM PressReleases.PressReleases P
WHERE P.PressReleaseID = @PressReleaseID
                ", 
                CommandType.Text,
                DB.CreateParameter("@PressReleaseID", id)))
            {
                if (dr.HasRows)
                {
                    dr.Read();
                    data.PressRelease = DB.InitFromReader<Shared.Entities.PressReleases.PressRelease>(dr, new ColMap { NameInDb = "PressReleaseID", NameInObject = "ID" });
                }

                return data;
            }
        }

        public static Models.PressReleases.PressRelease.PageLoad PageLoad(string title)
        {
            var data = new Models.PressReleases.PressRelease.PageLoad();

            using (SqlDataReader dr = DB.RunDataReader(@"
SELECT TOP 1 P.* 
FROM PressReleases.PressReleases P
WHERE P.Title = @Title
ORDER BY P.ReleaseDate DESC
                ",
                CommandType.Text,
                DB.CreateParameter("@Title", title)))
            {
                if (dr.HasRows)
                {
                    dr.Read();
                    data.PressRelease = DB.InitFromReader<Shared.Entities.PressReleases.PressRelease>(dr, new ColMap { NameInDb = "PressReleaseID", NameInObject = "ID" });
                }

                return data;
            }
        }
    }
}
