﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Data.SqlClient;
using System.Data;

namespace Adams.Web.Data.Security
{
    public static class Common
    {
        public static Models.Security.MemberInfo GetMemberInfo(string email)
        {
            var data = new Models.Security.MemberInfo();

            using (SqlDataReader dr = DB.RunDataReader(@"
SELECT *
FROM Membership.Members
WHERE Email = @Email
", CommandType.Text,
                DB.CreateParameter("@Email", email, SqlDbType.VarChar, 50)))
            {
                if (dr.HasRows)
                {
                    dr.Read();
                    data.MemberID = dr["MemberID"].DbInt();
                    data.PasswordHash = dr["PasswordHash"].DbString();
                    data.PasswordSalt = dr["PasswordSalt"].DbString();
                    data.IsActive = dr["IsActive"].DbBool();
                    data.IsEmailConfirmed = dr["IsEmailConfirmed"].DbBool();
                    data.LastLoginAttempt = dr["LastLoginAttempt"].DbDate();
                    data.FailedLoginAttempts = dr["FailedLoginAttempts"].DbInt();
                    data.Exists = true;
                }
                else
                {
                    data.Exists = false;
                }
            }

            return data;
        }
    }
}
