﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Adams.Web.Logic.Security
{
    public class Forgot
    {
        public static Adams.Web.Models.Security.Forgot.PageLoad PageLoad(string email)
        {
            var model = new Adams.Web.Models.Security.Forgot.PageLoad();
            model.Email = email;
            return model;
        }

        public static Models.FormOutput TryForgot(Models.Security.Forgot.FormInput input)
        {
            var output = Validation.PerformBasicValidation(input);

            if (output.IsValid)
            {
                var data = Data.Security.Common.GetMemberInfo(input.Email);

                if (data.Exists)
                {
                    // User does exist
                    if (data.IsActive)
                    {
                        string subject = "Reset your ADAMS password";
                        string from = Shared.Config.GetAppSetting("SecurityFromEmail");
                        string body = Logic.Email.GenerateForgotEmail(input.Email);
                        Email.QueueEmail(subject, from, input.Email, body, 1);
                    }
                    else
                    {
                        output.InvalidFields.Add(new Models.InvalidField() { Name = "Email", Code = 24 });
                    }
                }
                else
                {
                    output.InvalidFields.Add(new Models.InvalidField() { Name = "Email", Code = 20 });
                }
            }

            return output;
        }
    }
}
