﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ComponentModel.DataAnnotations;
using System.Reflection;

namespace Adams.Web.Logic
{
    public static class Validation
    {
        public static Models.FormOutput PerformBasicValidation(object input)
        {
            var ret = new Models.FormOutput();

            foreach (PropertyInfo propInfo in input.GetType().GetProperties())
            {
                foreach (ValidationAttribute attr in propInfo.GetCustomAttributes(typeof(ValidationAttribute), true))
                {
                    if (!attr.IsValid(propInfo.GetValue(input, null)))
                    {
                        ret.InvalidFields.Add(new Models.InvalidField() {
                            Name = propInfo.Name,
                            Code = string.IsNullOrEmpty(attr.ErrorMessage) ? 1 : attr.ErrorMessage.ToInt()
                        });
                    }
                }
            }

            return ret;
        }

        public static void PerformBasicValidation(object input, Models.FormOutput output)
        {
            foreach (PropertyInfo propInfo in input.GetType().GetProperties())
            {
                foreach (ValidationAttribute attr in propInfo.GetCustomAttributes(typeof(ValidationAttribute), true))
                {
                    if (!attr.IsValid(propInfo.GetValue(input, null)))
                    {
                        output.InvalidFields.Add(new Models.InvalidField()
                        {
                            Name = propInfo.Name,
                            Code = string.IsNullOrEmpty(attr.ErrorMessage) ? 1 : attr.ErrorMessage.ToInt()
                        });
                    }
                }
            }
        }
    }
}
