﻿/*
This script was created by Visual Studio on 8/8/2011 at 2:57 PM.
Run this script on [HDC00041006\SQL2008.Adams.Database] to make it the same as [HDC00041006\SQL2008.v3].
This script performs its actions in the following order:
1. Disable foreign-key constraints.
2. Perform DELETE commands. 
3. Perform UPDATE commands.
4. Perform INSERT commands.
5. Re-enable foreign-key constraints.
Please back up your target database before running this script.
*/
SET NUMERIC_ROUNDABORT OFF
GO
SET XACT_ABORT, ANSI_PADDING, ANSI_WARNINGS, CONCAT_NULL_YIELDS_NULL, ARITHABORT, QUOTED_IDENTIFIER, ANSI_NULLS ON
GO
/*Pointer used for text / image updates. This might not be needed, but is declared here just in case*/
DECLARE @pv binary(16)
BEGIN TRANSACTION
ALTER TABLE [Sitemap].[WebBottomNodes] DROP CONSTRAINT [Fk_WebBottomNodes_WebBottomNodes]
ALTER TABLE [Sitemap].[WebLeftNodes] DROP CONSTRAINT [Fk_WebLeftNodes_WebLeftNodes]
ALTER TABLE [Sitemap].[WebTopNodes] DROP CONSTRAINT [Fk_WebTopNodes_WebTopNodes]
ALTER TABLE [Sitemap].[Nodes] DROP CONSTRAINT [Fk_Nodes_Nodes]
ALTER TABLE [Sitemap].[MobileNodes] DROP CONSTRAINT [Fk_MobileNodes_MobileNodes]
ALTER TABLE [JummahPrayers].[Prayers] DROP CONSTRAINT [Fk_Prayers_Locations]
ALTER TABLE [Events].[Occurances] DROP CONSTRAINT [Fk_Occurances_Events]
ALTER TABLE [Donations].[Quick] DROP CONSTRAINT [Fk_Quick_Buckets]
ALTER TABLE [Donations].[OneTime] DROP CONSTRAINT [Fk_OneTime_Buckets]
ALTER TABLE [Donations].[OneTime] DROP CONSTRAINT [Fk_OneTime_Members]
ALTER TABLE [DailyPrayers].[PrayerTimes] DROP CONSTRAINT [Fk_PrayerTimes_Locations]
ALTER TABLE [TarawehPrayers].[Prayers] DROP CONSTRAINT [Fk_Prayers_Locations]
ALTER TABLE [Events].[WidgetEvents] DROP CONSTRAINT [Fk_WidgetEvents_Events]
ALTER TABLE [Events].[WidgetEvents] DROP CONSTRAINT [Fk_WidgetEvents_Widgets]
ALTER TABLE [Events].[Events] DROP CONSTRAINT [Fk_Events_Calendars]
ALTER TABLE [Classifieds].[Categories] DROP CONSTRAINT [Fk_Categories_Types]
ALTER TABLE [Businesses].[Businesses] DROP CONSTRAINT [Fk_Businesses_Categories]
ALTER TABLE [Businesses].[Businesses] DROP CONSTRAINT [Fk_Businesses_Members]
ALTER TABLE [Businesses].[Categories] DROP CONSTRAINT [Fk_Categories_Types]
ALTER TABLE [Console].[UsersApplications] DROP CONSTRAINT [Fk_UsersApplications_ApplicationID]
ALTER TABLE [Console].[UsersApplications] DROP CONSTRAINT [Fk_UsersApplications_UserID]
ALTER TABLE [Donations].[Recurring] DROP CONSTRAINT [Fk_Recurring_Buckets]
ALTER TABLE [Donations].[Recurring] DROP CONSTRAINT [Fk_Recurring_Members]
ALTER TABLE [EidPrayers].[Prayers] DROP CONSTRAINT [Fk_Prayers_Location]
ALTER TABLE [Finance].[CreditCards] DROP CONSTRAINT [Fk_CreditCards_Members]
ALTER TABLE [Classifieds].[Postings] DROP CONSTRAINT [Fk_Postings_Categories]
ALTER TABLE [Classifieds].[Postings] DROP CONSTRAINT [Fk_Postings_Members]
SET IDENTITY_INSERT [Membership].[Members] ON
INSERT INTO [Membership].[Members] ([MemberID], [FirstName], [LastName], [Email], [Street], [Street2], [City], [State], [ZipCode], [Phone], [PasswordHash], [PasswordSalt], [IsActive], [IsLocked], [IsEmailConfirmed], [LastLoginAttempt], [FailedLoginAttempts]) VALUES (1, N'admin', N'admin', N'admin@admin.com', N'123 Main street', N'suite 1', N'Sterling', N'VA', N'20164', N'7035555555', N'CCE6FD560F5C910BFA37DDA5DBB181B5CF59BBC0', N'TtRvV0VnhY+QP2AacpfdEQ==', 1, 0, 1, NULL, NULL)
INSERT INTO [Membership].[Members] ([MemberID], [FirstName], [LastName], [Email], [Street], [Street2], [City], [State], [ZipCode], [Phone], [PasswordHash], [PasswordSalt], [IsActive], [IsLocked], [IsEmailConfirmed], [LastLoginAttempt], [FailedLoginAttempts]) VALUES (5, N'Ghafran', N'Abbas', N'ghafranabbas@gmail.com', N'2559 Peter Jefferson Ln', N'', N'Herndon', N'VA', N'20171', N'7036221154', N'F5EF281D0589661E1A115AB42F7CD5E0F1B652DE', N'z+B+K0e8RfUhzHvybdGmLA==', 1, 0, 1, '20110808 18:46:00.000', 0)
INSERT INTO [Membership].[Members] ([MemberID], [FirstName], [LastName], [Email], [Street], [Street2], [City], [State], [ZipCode], [Phone], [PasswordHash], [PasswordSalt], [IsActive], [IsLocked], [IsEmailConfirmed], [LastLoginAttempt], [FailedLoginAttempts]) VALUES (6, N'amin ', N'khaliqi', N'akhaliqi@hotmail.com', N'', N'', N'', N'', N'', N'', N'E1320C82583336C4092DA9BF387D40FCDF6B5669', N'T0do5PpaLhsfUdhar1ZZuw==', 1, 0, 0, NULL, NULL)
INSERT INTO [Membership].[Members] ([MemberID], [FirstName], [LastName], [Email], [Street], [Street2], [City], [State], [ZipCode], [Phone], [PasswordHash], [PasswordSalt], [IsActive], [IsLocked], [IsEmailConfirmed], [LastLoginAttempt], [FailedLoginAttempts]) VALUES (7, N'Ann', N'Khilji', N'khilji_ann@yahoo.com', N'1921 ', N'', N'McLean', N'VA', N'22102', N'5555555555', N'23FE8C4641334BF3982331CF38D069714538E7DE', N'leNfQ/+geyf6hIb69E1ykw==', 1, 0, 1, '20110726 16:20:00.000', 0)
INSERT INTO [Membership].[Members] ([MemberID], [FirstName], [LastName], [Email], [Street], [Street2], [City], [State], [ZipCode], [Phone], [PasswordHash], [PasswordSalt], [IsActive], [IsLocked], [IsEmailConfirmed], [LastLoginAttempt], [FailedLoginAttempts]) VALUES (8, N'Shuaib', N'Malik', N'shuaib.malik@tenpearls.com', N'13800 Coppermine Road', N'', N'Herndon', N'VA', N'20170', N'703-234-5334', N'DF171C75B17F2C316064214332DCE16F0BFC93AF', N'W2H2CDgtJXza9fw2HK31ig==', 1, 0, 1, '20110726 17:52:00.000', 0)
INSERT INTO [Membership].[Members] ([MemberID], [FirstName], [LastName], [Email], [Street], [Street2], [City], [State], [ZipCode], [Phone], [PasswordHash], [PasswordSalt], [IsActive], [IsLocked], [IsEmailConfirmed], [LastLoginAttempt], [FailedLoginAttempts]) VALUES (9, N'Kash', N'TEst', N'kashifghori@gmail.com', N'123 Elm St', N'', N'Ashburn', N'VA', N'20148', N'301-332-7020', N'8C1D93A454E76B61C25BED8C645AC8502DBCC2D5', N'bkd4OJFWH+PsrISD/bvKpQ==', 1, 0, 1, '20110802 22:56:00.000', 0)
INSERT INTO [Membership].[Members] ([MemberID], [FirstName], [LastName], [Email], [Street], [Street2], [City], [State], [ZipCode], [Phone], [PasswordHash], [PasswordSalt], [IsActive], [IsLocked], [IsEmailConfirmed], [LastLoginAttempt], [FailedLoginAttempts]) VALUES (10, N'Test', N'User', N'testid@gmail.com', N'Adams St', N'', N'Reston', N'VA', N'20000', N'(703) 123 1234', N'FC4503CA6B78757ADA232D81DDCD97F07A198D98', N'BSe75Wvpd7Hxpd7k+rUEfA==', 0, 0, 0, NULL, NULL)
INSERT INTO [Membership].[Members] ([MemberID], [FirstName], [LastName], [Email], [Street], [Street2], [City], [State], [ZipCode], [Phone], [PasswordHash], [PasswordSalt], [IsActive], [IsLocked], [IsEmailConfirmed], [LastLoginAttempt], [FailedLoginAttempts]) VALUES (11, N'Sharjil', N'Hasan', N'sharjil.hasan@gmail.com', N'25325 Fairbanks Pl', N'', N'South Riding', N'VA', N'20152', N'2022135813', N'8558EFB3A67237C1CD7B1B5ABA36A77C612811B5', N'YobtfLE7c8yq7mE9GuXJZg==', 1, 0, 1, NULL, NULL)
INSERT INTO [Membership].[Members] ([MemberID], [FirstName], [LastName], [Email], [Street], [Street2], [City], [State], [ZipCode], [Phone], [PasswordHash], [PasswordSalt], [IsActive], [IsLocked], [IsEmailConfirmed], [LastLoginAttempt], [FailedLoginAttempts]) VALUES (12, N'Khalid', N'Iqbal', N'Khalid_Iqbal1@hotmail.com', N'144 Edinburgh Sq', N'', N'Sterling', N'VA', N'20164', N'202 439 5432', N'1274C6A55B5E15E0639C216E4869951A50BE94C9', N'vxRLEECT2kNGXcUpBNbO5A==', 1, 0, 1, '20110731 22:09:00.000', 0)
INSERT INTO [Membership].[Members] ([MemberID], [FirstName], [LastName], [Email], [Street], [Street2], [City], [State], [ZipCode], [Phone], [PasswordHash], [PasswordSalt], [IsActive], [IsLocked], [IsEmailConfirmed], [LastLoginAttempt], [FailedLoginAttempts]) VALUES (13, N'murtaza', N'mostamandi', N'mbautosale@verizon.net', N'21170 millwood sq', N'', N'sterling', N'VA', N'20165', N'703-929-9483', N'3A2283C4DD382D2545A38A0D1FFE442820A9D2C8', N'E3XVBxkl/BSZdhPzuTZrJg==', 1, 0, 1, '20110731 23:20:00.000', 0)
INSERT INTO [Membership].[Members] ([MemberID], [FirstName], [LastName], [Email], [Street], [Street2], [City], [State], [ZipCode], [Phone], [PasswordHash], [PasswordSalt], [IsActive], [IsLocked], [IsEmailConfirmed], [LastLoginAttempt], [FailedLoginAttempts]) VALUES (14, N'Kamran', N'Abbas', N'kamran@brambleton.net', N'42510 Regal Wood Drive', N'', N'Brambleton', N'VA', N'20148', N'918 352 6726', N'C280F1CA662DC193CACB3D57C1A699F7B0F43EF6', N'8EQjV3SDQ+ZvdnPFTsHSIw==', 1, 0, 1, '20110806 08:56:00.000', 0)
INSERT INTO [Membership].[Members] ([MemberID], [FirstName], [LastName], [Email], [Street], [Street2], [City], [State], [ZipCode], [Phone], [PasswordHash], [PasswordSalt], [IsActive], [IsLocked], [IsEmailConfirmed], [LastLoginAttempt], [FailedLoginAttempts]) VALUES (15, N'Asad', N'Saqib', N'asadsaqib@gmail.com', N'13011 Farthingale Dr', N'', N'Oak Hill', N'VA', N'20171', N'7036091452', N'60C1062B1AF61CECAD4525799B2D466BAB7A126A', N'2JvmSULh7lvZ+ruYr/5dwA==', 1, 0, 1, '20110802 13:24:00.000', 0)
INSERT INTO [Membership].[Members] ([MemberID], [FirstName], [LastName], [Email], [Street], [Street2], [City], [State], [ZipCode], [Phone], [PasswordHash], [PasswordSalt], [IsActive], [IsLocked], [IsEmailConfirmed], [LastLoginAttempt], [FailedLoginAttempts]) VALUES (16, N'Saleem', N'Arif', N'saleem_arif@yahoo.com', N'46678 Cavendish Sq', N'', N'Sterling', N'VA', N'20165', N'703-439-9600', N'635DB738E38A45251FC8A449B0A4273482DC55FE', N'01OAu5ietWIYJ8vci6m2Mw==', 1, 0, 1, '20110807 05:22:00.000', 0)
INSERT INTO [Membership].[Members] ([MemberID], [FirstName], [LastName], [Email], [Street], [Street2], [City], [State], [ZipCode], [Phone], [PasswordHash], [PasswordSalt], [IsActive], [IsLocked], [IsEmailConfirmed], [LastLoginAttempt], [FailedLoginAttempts]) VALUES (17, N'Awais', N'Sheikh', N'asheikh@vt.edu', N'47601 Woodboro Terrace', N'', N'Sterling', N'VA', N'20165', N'703-430-4183', N'E78F37ED504E57A40470E5B6197A27B1CC673730', N'MrbgQ4XnCPiIPVeFqBNnRg==', 1, 0, 1, NULL, NULL)
INSERT INTO [Membership].[Members] ([MemberID], [FirstName], [LastName], [Email], [Street], [Street2], [City], [State], [ZipCode], [Phone], [PasswordHash], [PasswordSalt], [IsActive], [IsLocked], [IsEmailConfirmed], [LastLoginAttempt], [FailedLoginAttempts]) VALUES (18, N'Syed', N'Moktadir', N'smoktadir@aol.com', N'21973 Amin Ct', N'', N'Sterling', N'VA', N'20164', N'7037281800', N'FA09922C5CCDBF8954B0B60CD7403DDB70B75907', N'NIwAzPTLpJdQTQ9puo83PA==', 1, 0, 1, '20110804 02:36:00.000', 0)
INSERT INTO [Membership].[Members] ([MemberID], [FirstName], [LastName], [Email], [Street], [Street2], [City], [State], [ZipCode], [Phone], [PasswordHash], [PasswordSalt], [IsActive], [IsLocked], [IsEmailConfirmed], [LastLoginAttempt], [FailedLoginAttempts]) VALUES (19, N'Tania', N'Mysorewala', N'taniamysore@gmail.com', N'12440B Liberty Bridge RD', N'', N'Fairfax', N'VA', N'22033', N'703-222-5184', N'5EE4246F7D2F1C86A29436BDBF2D0C4CF1994260', N'9lY5UsIsDdMjG/PDLqRp0g==', 1, 0, 1, NULL, NULL)
INSERT INTO [Membership].[Members] ([MemberID], [FirstName], [LastName], [Email], [Street], [Street2], [City], [State], [ZipCode], [Phone], [PasswordHash], [PasswordSalt], [IsActive], [IsLocked], [IsEmailConfirmed], [LastLoginAttempt], [FailedLoginAttempts]) VALUES (20, N'Sajjad', N'Ahmad', N'ksahmad@gmail.com', N'22309 Lost Branch Circle', N'', N'Ashburn', N'VA', N'20148', N'7036753428', N'993599A5A21F5D2D65C3A662D06323D3A2F637C4', N'YcBLw7rydE1TR/l6iXQS7g==', 1, 0, 1, '20110805 08:51:00.000', 0)
INSERT INTO [Membership].[Members] ([MemberID], [FirstName], [LastName], [Email], [Street], [Street2], [City], [State], [ZipCode], [Phone], [PasswordHash], [PasswordSalt], [IsActive], [IsLocked], [IsEmailConfirmed], [LastLoginAttempt], [FailedLoginAttempts]) VALUES (21, N'Omair', N'Chaudhry', N'omair.chaudhry@gmail.com', N'2206 Lofty Heights Place', N'', N'Reston', N'VA', N'20191', N'7033044319', N'512910D8DB97078037C3F86CD3F8207767537164', N'asEeACw6tKjnPKBC7TUtgQ==', 1, 0, 1, NULL, NULL)
INSERT INTO [Membership].[Members] ([MemberID], [FirstName], [LastName], [Email], [Street], [Street2], [City], [State], [ZipCode], [Phone], [PasswordHash], [PasswordSalt], [IsActive], [IsLocked], [IsEmailConfirmed], [LastLoginAttempt], [FailedLoginAttempts]) VALUES (22, N'Shehzad', N'Hussain', N'shehzadhussain@yahoo.com', N'21297 Mirror Ridge pl', N'', N'Sterling', N'VA', N'20164', N'7034073155', N'F9F715746CDFE782C361670D2CB7018DCB1EE733', N'ORdCx02ArelAo1deO+fcgw==', 1, 0, 1, '20110807 16:49:00.000', 0)
INSERT INTO [Membership].[Members] ([MemberID], [FirstName], [LastName], [Email], [Street], [Street2], [City], [State], [ZipCode], [Phone], [PasswordHash], [PasswordSalt], [IsActive], [IsLocked], [IsEmailConfirmed], [LastLoginAttempt], [FailedLoginAttempts]) VALUES (23, N'Farhan', N'Khan', N'khanzf@gmail.com', N'3101 Nestlewood Drive', N'', N'Herndon', N'VA', N'20171', N'703-508-0786', N'C9AD774596D20B2A471F19067DE1ACA6D35593E0', N'uZoG1fvVxRVLdkM10SODsA==', 1, 0, 1, '20110806 08:24:00.000', 0)
INSERT INTO [Membership].[Members] ([MemberID], [FirstName], [LastName], [Email], [Street], [Street2], [City], [State], [ZipCode], [Phone], [PasswordHash], [PasswordSalt], [IsActive], [IsLocked], [IsEmailConfirmed], [LastLoginAttempt], [FailedLoginAttempts]) VALUES (24, N'mary', N'abbott', N'maabbott@gmail.com', N'1933 Kennedy Drive', N'Apartment 201', N'McLean', N'VA', N'22102', N'5742862976', N'569605A10B2D49C1E2D266D4B3A1996C7C6DE80B', N'1JaKCbOPlzUXIfepNuUXhw==', 1, 0, 1, '20110805 17:41:00.000', 0)
INSERT INTO [Membership].[Members] ([MemberID], [FirstName], [LastName], [Email], [Street], [Street2], [City], [State], [ZipCode], [Phone], [PasswordHash], [PasswordSalt], [IsActive], [IsLocked], [IsEmailConfirmed], [LastLoginAttempt], [FailedLoginAttempts]) VALUES (25, N'Tariq', N'Aziz', N'taaziz@hotmail.com', N'43183 Rosehaven Pl', N'', N'Leesburg', N'VA', N'20176', N'7036525588', N'D9681C267F1832774F5F620D3F3D8A9652DFDEA5', N'MEA+vBf+EGmN+QcCM8p3tQ==', 1, 0, 1, NULL, NULL)
INSERT INTO [Membership].[Members] ([MemberID], [FirstName], [LastName], [Email], [Street], [Street2], [City], [State], [ZipCode], [Phone], [PasswordHash], [PasswordSalt], [IsActive], [IsLocked], [IsEmailConfirmed], [LastLoginAttempt], [FailedLoginAttempts]) VALUES (26, N'Rejaul', N'Lasker', N'rhlasker@gmail.com', N'6119 George Baylor Dr', N'', N'Centreville', N'VA', N'20121', N'404-6264337', N'165451B91FD2D3A7A503F58C8B8480C09081F80E', N'3IeTodUvxlosEqIxN0ilOA==', 1, 0, 1, '20110805 17:16:00.000', 0)
INSERT INTO [Membership].[Members] ([MemberID], [FirstName], [LastName], [Email], [Street], [Street2], [City], [State], [ZipCode], [Phone], [PasswordHash], [PasswordSalt], [IsActive], [IsLocked], [IsEmailConfirmed], [LastLoginAttempt], [FailedLoginAttempts]) VALUES (27, N'abdul', N'khan', N'wing86man@yahoo.com', N'VA', N'', N'bristow', N'VA', N'20136', N'571-247-5960', N'3D9D064D8A618A645C6A3C1603ABEE05C4227FBB', N'QRfzKoDUHBIefhAhzQdFkQ==', 1, 0, 1, NULL, NULL)
INSERT INTO [Membership].[Members] ([MemberID], [FirstName], [LastName], [Email], [Street], [Street2], [City], [State], [ZipCode], [Phone], [PasswordHash], [PasswordSalt], [IsActive], [IsLocked], [IsEmailConfirmed], [LastLoginAttempt], [FailedLoginAttempts]) VALUES (28, N'Mohammed', N'Mohibullah', N'mohibullah@adamscenter.us', N'45610 Iron horse ter', N'', N'Sterling', N'VA', N'20166', N'7033461589', N'7C19BE9A825912B0F1DA6562732EBF0F81369D2B', N'kCGk/MAdzgimi64LbLp2qw==', 1, 0, 1, '20110805 17:36:00.000', 0)
INSERT INTO [Membership].[Members] ([MemberID], [FirstName], [LastName], [Email], [Street], [Street2], [City], [State], [ZipCode], [Phone], [PasswordHash], [PasswordSalt], [IsActive], [IsLocked], [IsEmailConfirmed], [LastLoginAttempt], [FailedLoginAttempts]) VALUES (29, N'Arif', N'Maqbool', N'arifmaqbool@gmail.com', N'121 Herndon Mill Cir', N'', N'Herndon', N'VA', N'20170', N'972-800-1830', N'D2D0AEE4B68EF5C507420DB9F96FAB2D90F719FE', N'hZaQ3Eu1d3/FnnGUJVA0yw==', 1, 0, 1, '20110805 19:31:00.000', 0)
INSERT INTO [Membership].[Members] ([MemberID], [FirstName], [LastName], [Email], [Street], [Street2], [City], [State], [ZipCode], [Phone], [PasswordHash], [PasswordSalt], [IsActive], [IsLocked], [IsEmailConfirmed], [LastLoginAttempt], [FailedLoginAttempts]) VALUES (30, N'Tabish', N'Masood', N'tabish427@gmail.com', N'150 Applegate Dr', N'', N'Sterling', N'VA', N'20164', N'5719694062', N'AEA1E90F2EE02E78D4359EE93472362464A0B1FF', N'aObOWFPI/GUZbA3zIhHMyg==', 0, 0, 0, NULL, NULL)
INSERT INTO [Membership].[Members] ([MemberID], [FirstName], [LastName], [Email], [Street], [Street2], [City], [State], [ZipCode], [Phone], [PasswordHash], [PasswordSalt], [IsActive], [IsLocked], [IsEmailConfirmed], [LastLoginAttempt], [FailedLoginAttempts]) VALUES (31, N'Shakira', N'Ali', N'shakira_ali@yahoo.com', N'22086 Manning SQ', N'', N'Sterling', N'VA', N'20166', N'703-371-6981', N'692EDEEBCE21216DA75B1933C24FB3704369DFB1', N'XLwjyx8ONgRDOSuLuREotg==', 1, 0, 1, '20110806 04:01:00.000', 0)
INSERT INTO [Membership].[Members] ([MemberID], [FirstName], [LastName], [Email], [Street], [Street2], [City], [State], [ZipCode], [Phone], [PasswordHash], [PasswordSalt], [IsActive], [IsLocked], [IsEmailConfirmed], [LastLoginAttempt], [FailedLoginAttempts]) VALUES (32, N'Faizah', N'Hoque', N'faizah95@gmail.com', N'303 reneau way', N'', N'herndon', N'VA', N'20170', N'703 563 9030', N'1140D5BC94BD6E7413DE605BE3E3B7AC818F96B8', N'8rblh/lcakFmLiuxZ1yepw==', 1, 0, 1, '20110806 17:10:00.000', 0)
INSERT INTO [Membership].[Members] ([MemberID], [FirstName], [LastName], [Email], [Street], [Street2], [City], [State], [ZipCode], [Phone], [PasswordHash], [PasswordSalt], [IsActive], [IsLocked], [IsEmailConfirmed], [LastLoginAttempt], [FailedLoginAttempts]) VALUES (33, N'Nissar', N'Kamal', N'nissarkamal@yahoo.com', N'213 Cardinal Glen Circle', N'', N'Sterling', N'VA', N'20164', N'7034218991', N'B64E38715F2EA78A10308428AA615CA458F48408', N'jkT957jVcVH7PPQw224cVg==', 1, 0, 1, '20110805 22:52:00.000', 0)
INSERT INTO [Membership].[Members] ([MemberID], [FirstName], [LastName], [Email], [Street], [Street2], [City], [State], [ZipCode], [Phone], [PasswordHash], [PasswordSalt], [IsActive], [IsLocked], [IsEmailConfirmed], [LastLoginAttempt], [FailedLoginAttempts]) VALUES (34, N'Sajeel', N'ahmed', N'sajeel1965@yahoo.com', N'400 S.Oak street', N'', N'Falls church', N'VA', N'22046', N'571-243-6090', N'8B86A24F2239793DBC8515C1439E0B33AA6BC428', N'huwC2Q6uoWlStAMhHtmFeA==', 0, 0, 0, NULL, NULL)
INSERT INTO [Membership].[Members] ([MemberID], [FirstName], [LastName], [Email], [Street], [Street2], [City], [State], [ZipCode], [Phone], [PasswordHash], [PasswordSalt], [IsActive], [IsLocked], [IsEmailConfirmed], [LastLoginAttempt], [FailedLoginAttempts]) VALUES (35, N'saberah', N'ismael', N'isaberah@hotmail.com', N'44197 litchfield ter', N'', N'ashburn', N'VA', N'20147', N'5712358949', N'90DA3A8967B1586CBC845DFAFE470F28546602FE', N'JevgnkPj26bDREKWlUrr7Q==', 0, 0, 0, NULL, NULL)
INSERT INTO [Membership].[Members] ([MemberID], [FirstName], [LastName], [Email], [Street], [Street2], [City], [State], [ZipCode], [Phone], [PasswordHash], [PasswordSalt], [IsActive], [IsLocked], [IsEmailConfirmed], [LastLoginAttempt], [FailedLoginAttempts]) VALUES (36, N'Kashif', N'Aziz', N'Aziz_kashif@hotmail.com', N'42701 Ridgeway Dr. ', N'', N'Ashburn', N'VA', N'20148', N'571-228-6204', N'3798474E08B3913FFC39B3B358BB1711F643DB81', N'sJIbb33+Y1nOJtxctWYdFQ==', 0, 0, 0, NULL, NULL)
INSERT INTO [Membership].[Members] ([MemberID], [FirstName], [LastName], [Email], [Street], [Street2], [City], [State], [ZipCode], [Phone], [PasswordHash], [PasswordSalt], [IsActive], [IsLocked], [IsEmailConfirmed], [LastLoginAttempt], [FailedLoginAttempts]) VALUES (37, N'mohammed', N'khan', N'zhss4@aol.com', N'707 north sterling blvd', N'', N'sterling', N'VA', N'20164', N'7035019711', N'DFB6E5386E5BB63D11C55559404E8DEA0BF5D80F', N'gIe+g84saSBIJqPIABfktg==', 1, 0, 1, '20110806 02:14:00.000', 0)
INSERT INTO [Membership].[Members] ([MemberID], [FirstName], [LastName], [Email], [Street], [Street2], [City], [State], [ZipCode], [Phone], [PasswordHash], [PasswordSalt], [IsActive], [IsLocked], [IsEmailConfirmed], [LastLoginAttempt], [FailedLoginAttempts]) VALUES (38, N'palwasha', N'nasser', N'palwashanasser@aol.com', N'6018 amherst ave', N'', N'springfield', N'VA', N'22150', N'7036355158', N'DFBB5FBFD691623284EF5B732790340A00D3717C', N'vgYuw1kLQwpcQ26yo2o9wg==', 1, 0, 1, '20110806 02:13:00.000', 0)
INSERT INTO [Membership].[Members] ([MemberID], [FirstName], [LastName], [Email], [Street], [Street2], [City], [State], [ZipCode], [Phone], [PasswordHash], [PasswordSalt], [IsActive], [IsLocked], [IsEmailConfirmed], [LastLoginAttempt], [FailedLoginAttempts]) VALUES (39, N'Shakila', N'Khan', N'khan_shakila@yahoo.com', N'21948 Panmure Court', N'', N'Ashburn', N'VA', N'20148', N'7038582997', N'81C03D49F2817512B5B85F839AE65B2D45B038FC', N'jDxodyLIMyan3GLyMcgdXQ==', 1, 0, 1, '20110806 02:11:00.000', 0)
INSERT INTO [Membership].[Members] ([MemberID], [FirstName], [LastName], [Email], [Street], [Street2], [City], [State], [ZipCode], [Phone], [PasswordHash], [PasswordSalt], [IsActive], [IsLocked], [IsEmailConfirmed], [LastLoginAttempt], [FailedLoginAttempts]) VALUES (40, N'Mohammed Reza', N'Sacks', N'pants4ants@gmail.com', N'8340 Greensboro Dr', N'#319', N'McLean', N'VA', N'22102', N'7033464062', N'7AC14387D386B9EA56F364C2AC5621CF96A17E6E', N'2f3XM6zzhIGaXQetz/FhTA==', 1, 0, 1, '20110806 12:45:00.000', 0)
INSERT INTO [Membership].[Members] ([MemberID], [FirstName], [LastName], [Email], [Street], [Street2], [City], [State], [ZipCode], [Phone], [PasswordHash], [PasswordSalt], [IsActive], [IsLocked], [IsEmailConfirmed], [LastLoginAttempt], [FailedLoginAttempts]) VALUES (41, N'Faiza', N'Khan', N'faizapkhan@yahoo.com', N'12304 Darton Woods Loop', N'', N'Bristow', N'VA', N'20136', N'7033931460', N'402B7D2C3188A2E122FEC9FD4DBA2223905F7018', N'YpxQFe2Lp6FRd/zu91+Ljw==', 1, 0, 1, '20110806 02:31:00.000', 0)
INSERT INTO [Membership].[Members] ([MemberID], [FirstName], [LastName], [Email], [Street], [Street2], [City], [State], [ZipCode], [Phone], [PasswordHash], [PasswordSalt], [IsActive], [IsLocked], [IsEmailConfirmed], [LastLoginAttempt], [FailedLoginAttempts]) VALUES (42, N'Tim', N'Guenedy', N'timgue@gmail.com', N'PO Box 8787', N'', N'Reston', N'VA', N'20195', N'703-218-2869', N'A899E50F800DB4FE8AA215694F0CA14EC96D58E8', N'yuu5x/1TTUyiDJ0qXCHiLA==', 1, 0, 1, '20110806 02:41:00.000', 0)
INSERT INTO [Membership].[Members] ([MemberID], [FirstName], [LastName], [Email], [Street], [Street2], [City], [State], [ZipCode], [Phone], [PasswordHash], [PasswordSalt], [IsActive], [IsLocked], [IsEmailConfirmed], [LastLoginAttempt], [FailedLoginAttempts]) VALUES (43, N'IFFAT', N'ZIA', N'iffat16@hotmail.com', N'46947 Mossgrove Court', N'', N'Sterling', N'VA', N'20164', N'703-421-4653', N'BD4DDDD8D98A66B49CBF8EC41B6115F1B8239988', N'BmnJqzlIdDUZqt/WmoMihg==', 1, 0, 1, '20110806 02:53:00.000', 0)
INSERT INTO [Membership].[Members] ([MemberID], [FirstName], [LastName], [Email], [Street], [Street2], [City], [State], [ZipCode], [Phone], [PasswordHash], [PasswordSalt], [IsActive], [IsLocked], [IsEmailConfirmed], [LastLoginAttempt], [FailedLoginAttempts]) VALUES (44, N'sara ', N'zaman', N'sarazmn@hotmail.com', N'22543 welborne manor sq', N'', N'ashburn', N'VA', N'20148', N'703 348 0833', N'65C03168F8E44463AECE0F814959E342043EA749', N'9U5XOeFTNtt4d+/hWhD2fg==', 1, 0, 1, '20110806 03:14:00.000', 0)
INSERT INTO [Membership].[Members] ([MemberID], [FirstName], [LastName], [Email], [Street], [Street2], [City], [State], [ZipCode], [Phone], [PasswordHash], [PasswordSalt], [IsActive], [IsLocked], [IsEmailConfirmed], [LastLoginAttempt], [FailedLoginAttempts]) VALUES (45, N'Sabri', N'Math', N'smath03@gmail.com', N'1233 Summerfielld drive', N'', N'herndon', N'VA', N'20170', N'7038671495', N'E2CC63F2D23D61FF63EC1FB51117F7F5F03F8D9B', N'YhcXucTE/04RoQG3ahbeKQ==', 1, 0, 1, '20110806 03:16:00.000', 0)
INSERT INTO [Membership].[Members] ([MemberID], [FirstName], [LastName], [Email], [Street], [Street2], [City], [State], [ZipCode], [Phone], [PasswordHash], [PasswordSalt], [IsActive], [IsLocked], [IsEmailConfirmed], [LastLoginAttempt], [FailedLoginAttempts]) VALUES (46, N'mossadeq', N'zia', N'mzia@yahoo.com', N'46947 mossgrove ct', N'', N'Sterling', N'VA', N'20164', N'7037250214', N'10A6622BF380E00E1A8076CE6176E34FAFE4859E', N'rnYiSrTFfItCCVEKK3ErnA==', 1, 0, 1, '20110806 03:36:00.000', 0)
INSERT INTO [Membership].[Members] ([MemberID], [FirstName], [LastName], [Email], [Street], [Street2], [City], [State], [ZipCode], [Phone], [PasswordHash], [PasswordSalt], [IsActive], [IsLocked], [IsEmailConfirmed], [LastLoginAttempt], [FailedLoginAttempts]) VALUES (47, N'Mehrunnisa', N'abbasi', N'mehriabz@hotmail.com', N'22543 welborne manor sq', N'22543 welborne manor sq', N'ashburn', N'VA', N'20148', N'703-348-0833', N'7CBB9FDE0D896CC7AE4DBFD5F79B38CABE9F58F6', N'IO4ofWHN7mRItaoaODxF3A==', 0, 0, 0, NULL, NULL)
INSERT INTO [Membership].[Members] ([MemberID], [FirstName], [LastName], [Email], [Street], [Street2], [City], [State], [ZipCode], [Phone], [PasswordHash], [PasswordSalt], [IsActive], [IsLocked], [IsEmailConfirmed], [LastLoginAttempt], [FailedLoginAttempts]) VALUES (48, N'muhammad', N'ghaffar', N'ghaffar2311@hotmail.com', N'1', N'2', N'kjaffd', N'IL', N'234567', N'56768676869', N'F1B4B4DF12A1D0D89F715DE40FA4FA5220D42623', N'2lK3gMF3PEWWPN2wi0R2qQ==', 1, 0, 1, '20110806 03:36:00.000', 0)
INSERT INTO [Membership].[Members] ([MemberID], [FirstName], [LastName], [Email], [Street], [Street2], [City], [State], [ZipCode], [Phone], [PasswordHash], [PasswordSalt], [IsActive], [IsLocked], [IsEmailConfirmed], [LastLoginAttempt], [FailedLoginAttempts]) VALUES (49, N'sadulla', N'mohammed', N'sadulla@gmail.com', N'21915 muirfield cr', N'', N'sterling', N'VA', N'20164', N'7035855881', N'DE34D35646E65E914EF36AEA3DBB90947C17B938', N'dhosMNJz8a+E8U3ptxpt/A==', 1, 0, 1, '20110806 03:46:00.000', 0)
INSERT INTO [Membership].[Members] ([MemberID], [FirstName], [LastName], [Email], [Street], [Street2], [City], [State], [ZipCode], [Phone], [PasswordHash], [PasswordSalt], [IsActive], [IsLocked], [IsEmailConfirmed], [LastLoginAttempt], [FailedLoginAttempts]) VALUES (50, N'Anika', N'Arshad', N'aaa340@nyu.edu', N'1645 Oak Spring Way', N'', N'Reston', N'VA', N'20190', N'2404816630', N'11F16C8A61B508F6C58AE78F54B3E150FE173A8B', N'oQn/f7bH+DjhvKSCRVvZEw==', 1, 0, 1, NULL, NULL)
INSERT INTO [Membership].[Members] ([MemberID], [FirstName], [LastName], [Email], [Street], [Street2], [City], [State], [ZipCode], [Phone], [PasswordHash], [PasswordSalt], [IsActive], [IsLocked], [IsEmailConfirmed], [LastLoginAttempt], [FailedLoginAttempts]) VALUES (51, N'Ashraf ', N'Alim', N'aalim98@gmail.com', N'104 Panmure Lane', N'', N'Stephens City', N'VA', N'22655', N'5406645910', N'A11CF7919C87AAE602F537EAC53D972DF63AE630', N'abmt6kopPjCCPO7qdC7TiQ==', 1, 0, 1, '20110806 22:18:00.000', 0)
INSERT INTO [Membership].[Members] ([MemberID], [FirstName], [LastName], [Email], [Street], [Street2], [City], [State], [ZipCode], [Phone], [PasswordHash], [PasswordSalt], [IsActive], [IsLocked], [IsEmailConfirmed], [LastLoginAttempt], [FailedLoginAttempts]) VALUES (52, N'sadia', N'zubairi', N'sadiabz@yahoo.com', N'1255 kenmore drive', N'', N'great falls', N'VA', N'22066', N'703-759-7869', N'683C027AD39991099F29D6978FA8C687EC390395', N'RsiPPHhzSLlWe9gyF5Sujg==', 0, 0, 0, NULL, NULL)
INSERT INTO [Membership].[Members] ([MemberID], [FirstName], [LastName], [Email], [Street], [Street2], [City], [State], [ZipCode], [Phone], [PasswordHash], [PasswordSalt], [IsActive], [IsLocked], [IsEmailConfirmed], [LastLoginAttempt], [FailedLoginAttempts]) VALUES (53, N'Saadia', N'Abbasi', N'saadiaabbasi@hotmail.com', N'2482 Angeline Dr. ', N'Unit# 301', N'Herndon', N'VA', N'20171', N'7039439811', N'08316176E9440D587B5D463DE4D40B1EC0188454', N'hmTYNqXOaMm4sX8DVVROpg==', 1, 0, 1, '20110806 15:28:00.000', 0)
INSERT INTO [Membership].[Members] ([MemberID], [FirstName], [LastName], [Email], [Street], [Street2], [City], [State], [ZipCode], [Phone], [PasswordHash], [PasswordSalt], [IsActive], [IsLocked], [IsEmailConfirmed], [LastLoginAttempt], [FailedLoginAttempts]) VALUES (54, N'Endon', N'Tahir', N'Tahirem@yahoo.com', N'427 Madison Forest Dr.', N'', N'Herndon', N'VA', N'20170', N'703 965 4259', N'82BDDACF9265F1D1798E2B5A08039F1D40626139', N'6XTbQi7j7dI3lVQMq/OYRA==', 1, 0, 1, NULL, NULL)
INSERT INTO [Membership].[Members] ([MemberID], [FirstName], [LastName], [Email], [Street], [Street2], [City], [State], [ZipCode], [Phone], [PasswordHash], [PasswordSalt], [IsActive], [IsLocked], [IsEmailConfirmed], [LastLoginAttempt], [FailedLoginAttempts]) VALUES (55, N'Imran', N'Khan', N'khan_imran_m@msn.com', N'20922 Cheyenne TER', N'', N'Sterling', N'VA', N'20165', N'703-421-4972', N'DFACF642DEE75DC8B8B87030302CC824DA72181D', N'HmDqJl+9eIHsrKUbx5hFlg==', 1, 0, 1, '20110806 16:59:00.000', 0)
INSERT INTO [Membership].[Members] ([MemberID], [FirstName], [LastName], [Email], [Street], [Street2], [City], [State], [ZipCode], [Phone], [PasswordHash], [PasswordSalt], [IsActive], [IsLocked], [IsEmailConfirmed], [LastLoginAttempt], [FailedLoginAttempts]) VALUES (56, N'ismat', N'ahmed', N'ismat_ahmed@yahoo.com', N'21383 marble chip ct.', N'', N'ashburn', N'VA', N'20147', N'7036751739', N'74F22E2DEC46EF9A0D54BF6DE8109E752A8AC34F', N'24N9OV9ij4CbjNS6bSZX3g==', 1, 0, 1, '20110806 16:52:00.000', 0)
INSERT INTO [Membership].[Members] ([MemberID], [FirstName], [LastName], [Email], [Street], [Street2], [City], [State], [ZipCode], [Phone], [PasswordHash], [PasswordSalt], [IsActive], [IsLocked], [IsEmailConfirmed], [LastLoginAttempt], [FailedLoginAttempts]) VALUES (57, N'Usman', N'Khan', N'khanausman@gmail.com', N'12256 Scarlet Maple Drive', N'', N'Gainesville', N'VA', N'20155', N'7033475249', N'C7F75519AAF0181B9A5937351102B72B05A5CFD2', N'9Ggf1xHbBHi0wbEihzwHdA==', 1, 0, 1, '20110806 17:56:00.000', 0)
INSERT INTO [Membership].[Members] ([MemberID], [FirstName], [LastName], [Email], [Street], [Street2], [City], [State], [ZipCode], [Phone], [PasswordHash], [PasswordSalt], [IsActive], [IsLocked], [IsEmailConfirmed], [LastLoginAttempt], [FailedLoginAttempts]) VALUES (58, N'Farooq', N'Syed', N'farooq_syed@yahoo.com', N'1112 Landerset Drive', N'', N'Herndon', N'VA', N'20170', N'703-408-4921', N'54E779762D474C8B2A8F6D27030D4FE155743FCC', N'wjjUtQRnkU3lqTRsB/WpmA==', 1, 0, 1, '20110806 18:38:00.000', 0)
INSERT INTO [Membership].[Members] ([MemberID], [FirstName], [LastName], [Email], [Street], [Street2], [City], [State], [ZipCode], [Phone], [PasswordHash], [PasswordSalt], [IsActive], [IsLocked], [IsEmailConfirmed], [LastLoginAttempt], [FailedLoginAttempts]) VALUES (59, N'Asif', N'Ali', N'asefali@gmail.com', N'21881 maywood terrace', N'', N'sterling', N'VA', N'20164', N'6466437987', N'844C8B137D8D090EFA0C0D47F11861219B4CCC71', N'nq4kSdv0ItG4RvotDym3Zw==', 1, 0, 1, '20110806 21:58:00.000', 0)
INSERT INTO [Membership].[Members] ([MemberID], [FirstName], [LastName], [Email], [Street], [Street2], [City], [State], [ZipCode], [Phone], [PasswordHash], [PasswordSalt], [IsActive], [IsLocked], [IsEmailConfirmed], [LastLoginAttempt], [FailedLoginAttempts]) VALUES (60, N'Ali', N'Shaikh', N'ticali@gmail.com', N'21851 Locomotive Ter', N'301', N'Sterling', N'VA', N'20166', N'7033029981', N'F11D0BAC303DA818685D4908D582C0F4734E371B', N'PrbAcZDhE4iYTcb2K5EhEw==', 1, 0, 1, '20110806 22:15:00.000', 0)
INSERT INTO [Membership].[Members] ([MemberID], [FirstName], [LastName], [Email], [Street], [Street2], [City], [State], [ZipCode], [Phone], [PasswordHash], [PasswordSalt], [IsActive], [IsLocked], [IsEmailConfirmed], [LastLoginAttempt], [FailedLoginAttempts]) VALUES (61, N'Shariq', N'Qureshi', N'shariqqureshi@hotmail.com', N'4702 brentwall ct', N'', N'CHANTILLY', N'VA', N'20151', N'703-817-1655', N'60DB235D31933FBB954379B838850893B6DD4AC3', N'BHcAr7S3aCIwGwyrvzTcXQ==', 0, 0, 0, NULL, NULL)
INSERT INTO [Membership].[Members] ([MemberID], [FirstName], [LastName], [Email], [Street], [Street2], [City], [State], [ZipCode], [Phone], [PasswordHash], [PasswordSalt], [IsActive], [IsLocked], [IsEmailConfirmed], [LastLoginAttempt], [FailedLoginAttempts]) VALUES (62, N'eihab', N'elwasila', N'eihab.elwasila@gmail.com', N'13300 Jefferson Commons ct apt 103', N'', N'Herndon', N'VA', N'20171', N'7037930056', N'1F845FBB80D52C358257E66C4B4A5E2C4349173D', N'2SpGKMYumy5sxIraNWQw3w==', 1, 0, 1, '20110807 15:06:00.000', 0)
INSERT INTO [Membership].[Members] ([MemberID], [FirstName], [LastName], [Email], [Street], [Street2], [City], [State], [ZipCode], [Phone], [PasswordHash], [PasswordSalt], [IsActive], [IsLocked], [IsEmailConfirmed], [LastLoginAttempt], [FailedLoginAttempts]) VALUES (63, N'Liban', N'Gurhan', N'lgurhan@gmail.com', N'21953 Manning SQ', N'', N'Sterling', N'VA', N'20166', N'703-593-9361', N'F894342D1CDD8A98A7DA41D6AD031F9497DE9321', N'a0RevGiljNDdRC8/I6AiJQ==', 1, 0, 1, '20110807 02:47:00.000', 0)
INSERT INTO [Membership].[Members] ([MemberID], [FirstName], [LastName], [Email], [Street], [Street2], [City], [State], [ZipCode], [Phone], [PasswordHash], [PasswordSalt], [IsActive], [IsLocked], [IsEmailConfirmed], [LastLoginAttempt], [FailedLoginAttempts]) VALUES (64, N'Mariam', N'Malik', N'mariam.s.malik@gmail.com', N'1301 Alps Drive', N'', N'McLean', N'VA', N'22102', N'571-643-6364', N'CEEC27A90DEB26982D4B916F433F38CB3A41B386', N'wucFu6ND9ED+EJZyIZ2BWQ==', 1, 0, 1, '20110807 03:21:00.000', 0)
INSERT INTO [Membership].[Members] ([MemberID], [FirstName], [LastName], [Email], [Street], [Street2], [City], [State], [ZipCode], [Phone], [PasswordHash], [PasswordSalt], [IsActive], [IsLocked], [IsEmailConfirmed], [LastLoginAttempt], [FailedLoginAttempts]) VALUES (65, N'Wafaa', N'Sabir', N'wafaasabir@gmail.com', N'12261 Pender Creek Circle', N'# L', N'Fairfax', N'VA', N'22033', N'8319174294', N'94ED9B8F7C62FF43A2A7EFB37B21E65AEB066AA4', N'0PC5ofurqkIytRjcNDjoEg==', 1, 0, 1, '20110807 03:57:00.000', 0)
INSERT INTO [Membership].[Members] ([MemberID], [FirstName], [LastName], [Email], [Street], [Street2], [City], [State], [ZipCode], [Phone], [PasswordHash], [PasswordSalt], [IsActive], [IsLocked], [IsEmailConfirmed], [LastLoginAttempt], [FailedLoginAttempts]) VALUES (66, N'Hibah', N'Khan', N'frost.city@gmail.com', N'43298 Lecroy Circle', N'', N'Leesburg', N'VA', N'20176', N'5713331272', N'03786C44EF24696BFD4687D2DEB1E53858828A14', N'eDWNPEJDSVOor8POh3QkKA==', 1, 0, 1, NULL, NULL)
INSERT INTO [Membership].[Members] ([MemberID], [FirstName], [LastName], [Email], [Street], [Street2], [City], [State], [ZipCode], [Phone], [PasswordHash], [PasswordSalt], [IsActive], [IsLocked], [IsEmailConfirmed], [LastLoginAttempt], [FailedLoginAttempts]) VALUES (67, N'Deborah', N'Nader', N'deborahnader00@gmail.com', N'43727 Lees Mill Square', N'', N'Leesburg', N'VA', N'20176', N'571-333-1153', N'CDC37B8D27DA7348EF2E4AD8A96E1201F9E7948D', N'9PsRLpDRKetAOzUqfZaT7w==', 1, 0, 1, '20110808 14:17:00.000', 0)
INSERT INTO [Membership].[Members] ([MemberID], [FirstName], [LastName], [Email], [Street], [Street2], [City], [State], [ZipCode], [Phone], [PasswordHash], [PasswordSalt], [IsActive], [IsLocked], [IsEmailConfirmed], [LastLoginAttempt], [FailedLoginAttempts]) VALUES (68, N'Faisal', N'Khan', N'fhk.PfS@gmail.com', N'20556 wake terrace ', N'', N'Sterling', N'VA', N'20165', N'571-243-8404', N'765678CB5A3AB396D4E735CEBB055D110E3851FA', N'MOM8Us9ac4dWjGWRJSR6Pw==', 1, 0, 1, '20110807 13:41:00.000', 0)
INSERT INTO [Membership].[Members] ([MemberID], [FirstName], [LastName], [Email], [Street], [Street2], [City], [State], [ZipCode], [Phone], [PasswordHash], [PasswordSalt], [IsActive], [IsLocked], [IsEmailConfirmed], [LastLoginAttempt], [FailedLoginAttempts]) VALUES (69, N'alketa', N'osmani', N'alketa.osmani@yahoo.com', N'7443 little river turnpike', N'unit # 201', N'annandale', N'VA', N'22003', N'703 855 5416', N'8B225B2EA100B38AFCD743D3C1E170BB7304FDF5', N'k1MijsswpMOkTyEeDBh+fg==', 0, 0, 0, NULL, NULL)
INSERT INTO [Membership].[Members] ([MemberID], [FirstName], [LastName], [Email], [Street], [Street2], [City], [State], [ZipCode], [Phone], [PasswordHash], [PasswordSalt], [IsActive], [IsLocked], [IsEmailConfirmed], [LastLoginAttempt], [FailedLoginAttempts]) VALUES (70, N'Haroon', N'Shah', N'Haroon_Shah@yahoo.com', N'2398 C Birch Run Cir', N'', N'Herndon', N'VA', N'20171', N'503-330-3287', N'A190DA65AF0C08D3E83684EE166CFEDF98645688', N'EMl2UYTNEjttaXpQuYjEKQ==', 1, 0, 1, '20110807 18:47:00.000', 0)
INSERT INTO [Membership].[Members] ([MemberID], [FirstName], [LastName], [Email], [Street], [Street2], [City], [State], [ZipCode], [Phone], [PasswordHash], [PasswordSalt], [IsActive], [IsLocked], [IsEmailConfirmed], [LastLoginAttempt], [FailedLoginAttempts]) VALUES (71, N'Mohammad', N'Azam', N'mfazam1@hotmail.com', N'19224 Kepharts Mill Terr', N'', N'Leesburg', N'VA', N'20176', N'703-659-1598', N'C3105D75CB7488A17E7D047217750225B2BA2EDC', N'6YB7/plcbnm5vJx1lyzMCA==', 1, 0, 1, '20110807 19:21:00.000', 0)
INSERT INTO [Membership].[Members] ([MemberID], [FirstName], [LastName], [Email], [Street], [Street2], [City], [State], [ZipCode], [Phone], [PasswordHash], [PasswordSalt], [IsActive], [IsLocked], [IsEmailConfirmed], [LastLoginAttempt], [FailedLoginAttempts]) VALUES (72, N'Yousra', N'Yasin', N'yousra786@yahoo.com', N'711 Alabama Drive', N'', N'Herndon', N'VA', N'20170', N'5712303671', N'FB5E5B58E94409A11AC4CB725EABEF0A5373336C', N'J38gy2hCgGEhIlF6Y8c/+Q==', 1, 0, 1, '20110807 19:38:00.000', 0)
INSERT INTO [Membership].[Members] ([MemberID], [FirstName], [LastName], [Email], [Street], [Street2], [City], [State], [ZipCode], [Phone], [PasswordHash], [PasswordSalt], [IsActive], [IsLocked], [IsEmailConfirmed], [LastLoginAttempt], [FailedLoginAttempts]) VALUES (73, N'Hamza', N'Ahmed', N'hamza_a83@yahoo.com', N'46845 Muirfield ct Apt 304', N'', N'Sterling', N'VA', N'20164', N'7032258636', N'A2C354EB55986EFC162F6F294A3E56274CF88FF7', N'wsG6yAo44IMj6p9x3OVegQ==', 1, 0, 1, '20110807 21:11:00.000', 0)
INSERT INTO [Membership].[Members] ([MemberID], [FirstName], [LastName], [Email], [Street], [Street2], [City], [State], [ZipCode], [Phone], [PasswordHash], [PasswordSalt], [IsActive], [IsLocked], [IsEmailConfirmed], [LastLoginAttempt], [FailedLoginAttempts]) VALUES (74, N'Naiema', N'Riaz', N'naiemariaz@gmail.com', N'18473 Sweetberry Court', N'', N'Leesburg', N'VA', N'20176', N'703-777-7429', N'6A879F094F4A20B0A071607F9E86225226DC0768', N'coBkwdsiOXxvf1peJptbag==', 1, 0, 1, '20110807 21:11:00.000', 0)
INSERT INTO [Membership].[Members] ([MemberID], [FirstName], [LastName], [Email], [Street], [Street2], [City], [State], [ZipCode], [Phone], [PasswordHash], [PasswordSalt], [IsActive], [IsLocked], [IsEmailConfirmed], [LastLoginAttempt], [FailedLoginAttempts]) VALUES (75, N'Nureddin', N'Aman', N'goal.goal@yahoo.com', N'1478 Kingstream Dr.', N'', N'Herndon', N'VA', N'20170', N'7035829155', N'26252457C0AFD47721A7448CBAAB8CA000DB7952', N'9Ms5wbKaVqV8kvfQT/lgCg==', 1, 0, 1, '20110808 00:49:00.000', 0)
INSERT INTO [Membership].[Members] ([MemberID], [FirstName], [LastName], [Email], [Street], [Street2], [City], [State], [ZipCode], [Phone], [PasswordHash], [PasswordSalt], [IsActive], [IsLocked], [IsEmailConfirmed], [LastLoginAttempt], [FailedLoginAttempts]) VALUES (76, N'Tarek', N'Al-Jallad', N'tarjall@yahoo.com', N'2253 Astoria Cir', N'Apt 201', N'Herndon', N'VA', N'20170', N'703-496-3719', N'53AC4791616C70F2DDC30EA5A366CF4AB6050B29', N'sKEEnRyQIBTtJMEzikpzkg==', 1, 0, 1, '20110808 03:41:00.000', 0)
INSERT INTO [Membership].[Members] ([MemberID], [FirstName], [LastName], [Email], [Street], [Street2], [City], [State], [ZipCode], [Phone], [PasswordHash], [PasswordSalt], [IsActive], [IsLocked], [IsEmailConfirmed], [LastLoginAttempt], [FailedLoginAttempts]) VALUES (77, N'wali', N'peart', N'waliworld08@gmail.com', N'13175 fox hunt ln', N'', N'herndon', N'VA', N'20171', N'5185275687', N'58CC645A25E0079511A2E96D30144B0CBCB731CA', N'rq3mN6T2w1PXF9qaPHguIw==', 1, 0, 1, '20110808 05:52:00.000', 0)
INSERT INTO [Membership].[Members] ([MemberID], [FirstName], [LastName], [Email], [Street], [Street2], [City], [State], [ZipCode], [Phone], [PasswordHash], [PasswordSalt], [IsActive], [IsLocked], [IsEmailConfirmed], [LastLoginAttempt], [FailedLoginAttempts]) VALUES (78, N'Shafayat', N'Alam', N'shafayat.alam@bucknell.edu', N'11649 Charter Oak Ct. ', N'Apt # 002', N'Reston', N'VA', N'20190', N'5704956206', N'F0AABA85CD79360430020E3756310D4FDD603D25', N'gnlZgcF4gOzOjZLonz+gvw==', 1, 0, 1, '20110808 06:37:00.000', 0)
INSERT INTO [Membership].[Members] ([MemberID], [FirstName], [LastName], [Email], [Street], [Street2], [City], [State], [ZipCode], [Phone], [PasswordHash], [PasswordSalt], [IsActive], [IsLocked], [IsEmailConfirmed], [LastLoginAttempt], [FailedLoginAttempts]) VALUES (79, N'Zohaib', N'Mohammad', N'moh.zohaib@gmail.com', N'12000 Greywing Square', N'B2', N'Reston', N'VA', N'20191', N'7329665139', N'F534D31358DED1E5E066A925EA28ABBE52726736', N'T5Ec9lVu707RA9xbqv3IQg==', 1, 0, 1, '20110808 09:01:00.000', 0)
INSERT INTO [Membership].[Members] ([MemberID], [FirstName], [LastName], [Email], [Street], [Street2], [City], [State], [ZipCode], [Phone], [PasswordHash], [PasswordSalt], [IsActive], [IsLocked], [IsEmailConfirmed], [LastLoginAttempt], [FailedLoginAttempts]) VALUES (80, N'Angela ', N'Williams', N'kd2hassan@yahoo.com', N'6011 Damascus Place', N'', N'Dulles', N'VA', N'20189-6110', N'323 963 8440', N'79451611E245BCB85EA632C49B3B517E0FC1A894', N'eb6TSSxvRYlT1YbT/oo3Vw==', 1, 0, 1, NULL, NULL)
INSERT INTO [Membership].[Members] ([MemberID], [FirstName], [LastName], [Email], [Street], [Street2], [City], [State], [ZipCode], [Phone], [PasswordHash], [PasswordSalt], [IsActive], [IsLocked], [IsEmailConfirmed], [LastLoginAttempt], [FailedLoginAttempts]) VALUES (81, N'RAMIN', N'MOHAMMAD', N'ramin.mohammad84@gmail.com', N'16760 sweeney lane', N'', N'woodbridge', N'VA', N'22191', N'7038555401', N'418A99F13EEC32EBD2948360BDC432B160E9B25E', N'BFBfiS5KhF197kg9+Gk5ug==', 1, 0, 1, '20110808 15:25:00.000', 0)
INSERT INTO [Membership].[Members] ([MemberID], [FirstName], [LastName], [Email], [Street], [Street2], [City], [State], [ZipCode], [Phone], [PasswordHash], [PasswordSalt], [IsActive], [IsLocked], [IsEmailConfirmed], [LastLoginAttempt], [FailedLoginAttempts]) VALUES (82, N'Sajid', N'Kapadia', N'sajid_kapadia@hotmail.com', N'2605 Meadow Hall Drive', N'', N'Herndon', N'VA', N'20171', N'7037876831', N'176395617B119F8086801002877F5DB16781DB1F', N'qaQMn/GRPmxqOfPaBJ8wSw==', 0, 0, 0, NULL, NULL)
INSERT INTO [Membership].[Members] ([MemberID], [FirstName], [LastName], [Email], [Street], [Street2], [City], [State], [ZipCode], [Phone], [PasswordHash], [PasswordSalt], [IsActive], [IsLocked], [IsEmailConfirmed], [LastLoginAttempt], [FailedLoginAttempts]) VALUES (83, N'Ibtihal', N'noureldin', N'ibtihalnoureldin@yahoo.com', N'21065 Calhoun Corners Terrace #303', N'', N'Ashburn', N'VA', N'20147', N'2676709116', N'E52CC1B7A5392CFC98D5AB689EC91F2BE2177F99', N'xynrkpM/95iTGCLfFSsfhw==', 1, 0, 1, '20110808 18:33:00.000', 0)
SET IDENTITY_INSERT [Membership].[Members] OFF
SET IDENTITY_INSERT [Classifieds].[Postings] ON
INSERT INTO [Classifieds].[Postings] ([PostingID], [CategoryID], [MemberID], [StatusID], [Title], [Price], [Location], [ReplyTo], [Description], [CreatedOn], [ExpiresOn]) VALUES (78600007, 13, 83, 1, N'Furniture for sale', N'300', N'Ashburn, VA20147', N'ibtihalnoureldin@yahoo.com', N'The sofa is three cushioned + Loveseat, good condition, no tears, is plaid and looks like it is new. It is available when you want to purchase it in Ashburn, Virginia. We can not deliver it and we live in 3rd flour APT. This sofa is a real find for the buyer. We can negotiate the price if you are interested. 267/670/9116 please leave a message if we are not home. ', '20110808 18:45:00.000', '20110822 14:45:00.000')
SET IDENTITY_INSERT [Classifieds].[Postings] OFF
SET IDENTITY_INSERT [EidPrayers].[Locations] ON
INSERT INTO [EidPrayers].[Locations] ([LocationID], [Name], [Street], [Street2], [City], [State], [ZipCode], [LongNote], [Latitude], [Longitude], [DisplayOrder]) VALUES (1, N'Main Center', N'46903 Sugarland Road', N'', N'Sterling', N'VA', N'20164', N'Longnote', 39.006436, -77.379334, 1)
INSERT INTO [EidPrayers].[Locations] ([LocationID], [Name], [Street], [Street2], [City], [State], [ZipCode], [LongNote], [Latitude], [Longitude], [DisplayOrder]) VALUES (2, N'Ashburn', N'21740 Beaumeade Circle', N'Unit 100', N'Ashburn', N'VA', N'20147', N'Longnote', 39.018245, -77.456244, 1)
INSERT INTO [EidPrayers].[Locations] ([LocationID], [Name], [Street], [Street2], [City], [State], [ZipCode], [LongNote], [Latitude], [Longitude], [DisplayOrder]) VALUES (3, N'North Reston', N'1441 Wiehle Avenue', N'', N'Reston', N'VA', N'20190', N'Longnote', 38.971250, -77.332228, 1)
SET IDENTITY_INSERT [EidPrayers].[Locations] OFF
SET IDENTITY_INSERT [EidPrayers].[Prayers] ON
INSERT INTO [EidPrayers].[Prayers] ([PrayerID], [LocationID], [Name], [Time], [DisplayOrder]) VALUES (1, 1, N'1st Eid', N'11:45 AM', 1)
INSERT INTO [EidPrayers].[Prayers] ([PrayerID], [LocationID], [Name], [Time], [DisplayOrder]) VALUES (2, 1, N'2nd Eid', N'1:45 PM', 2)
INSERT INTO [EidPrayers].[Prayers] ([PrayerID], [LocationID], [Name], [Time], [DisplayOrder]) VALUES (3, 2, N'1st Eid', N'11:45 AM', 1)
INSERT INTO [EidPrayers].[Prayers] ([PrayerID], [LocationID], [Name], [Time], [DisplayOrder]) VALUES (4, 2, N'2nd Eid', N'1:45 PM', 2)
INSERT INTO [EidPrayers].[Prayers] ([PrayerID], [LocationID], [Name], [Time], [DisplayOrder]) VALUES (5, 3, N'1st Eid', N'11:45 AM', 1)
INSERT INTO [EidPrayers].[Prayers] ([PrayerID], [LocationID], [Name], [Time], [DisplayOrder]) VALUES (6, 3, N'2nd Eid', N'1:45 PM', 2)
SET IDENTITY_INSERT [EidPrayers].[Prayers] OFF
SET IDENTITY_INSERT [Console].[Users] ON
INSERT INTO [Console].[Users] ([UserID], [FirstName], [LastName], [Email], [PasswordHash], [PasswordSalt], [IsActive], [IsLocked], [LastLoginAttempt], [FailedLoginAttempts]) VALUES (1, N'admin', N'admin', N'admin@admin.com', N'CCE6FD560F5C910BFA37DDA5DBB181B5CF59BBC0', N'TtRvV0VnhY+QP2AacpfdEQ==', 1, 0, '20110808 16:33:00.000', 0)
INSERT INTO [Console].[Users] ([UserID], [FirstName], [LastName], [Email], [PasswordHash], [PasswordSalt], [IsActive], [IsLocked], [LastLoginAttempt], [FailedLoginAttempts]) VALUES (2, N'Khalid', N'Iqbal', N'deputydirector@adamscenter.org', N'F7CFA419DF4E54FA7954120FEC02E3755C061F9C', N'yUnreU22ZFc+DIEO9dUiqQ==', 1, 0, '20110804 22:14:00.000', 0)
SET IDENTITY_INSERT [Console].[Users] OFF
INSERT INTO [Console].[UsersApplications] ([UserID], [ApplicationID]) VALUES (1, 18)
INSERT INTO [Console].[UsersApplications] ([UserID], [ApplicationID]) VALUES (1, 19)
INSERT INTO [Console].[UsersApplications] ([UserID], [ApplicationID]) VALUES (1, 20)
INSERT INTO [Console].[UsersApplications] ([UserID], [ApplicationID]) VALUES (1, 21)
INSERT INTO [Console].[UsersApplications] ([UserID], [ApplicationID]) VALUES (1, 22)
INSERT INTO [Console].[UsersApplications] ([UserID], [ApplicationID]) VALUES (1, 23)
INSERT INTO [Console].[UsersApplications] ([UserID], [ApplicationID]) VALUES (1, 24)
INSERT INTO [Console].[UsersApplications] ([UserID], [ApplicationID]) VALUES (1, 25)
INSERT INTO [Console].[UsersApplications] ([UserID], [ApplicationID]) VALUES (1, 26)
INSERT INTO [Console].[UsersApplications] ([UserID], [ApplicationID]) VALUES (1, 27)
INSERT INTO [Console].[UsersApplications] ([UserID], [ApplicationID]) VALUES (1, 28)
INSERT INTO [Console].[UsersApplications] ([UserID], [ApplicationID]) VALUES (1, 29)
INSERT INTO [Console].[UsersApplications] ([UserID], [ApplicationID]) VALUES (1, 30)
INSERT INTO [Console].[UsersApplications] ([UserID], [ApplicationID]) VALUES (1, 31)
INSERT INTO [Console].[UsersApplications] ([UserID], [ApplicationID]) VALUES (1, 32)
INSERT INTO [Console].[UsersApplications] ([UserID], [ApplicationID]) VALUES (1, 33)
INSERT INTO [Console].[UsersApplications] ([UserID], [ApplicationID]) VALUES (2, 18)
INSERT INTO [Console].[UsersApplications] ([UserID], [ApplicationID]) VALUES (2, 19)
INSERT INTO [Console].[UsersApplications] ([UserID], [ApplicationID]) VALUES (2, 20)
INSERT INTO [Console].[UsersApplications] ([UserID], [ApplicationID]) VALUES (2, 21)
INSERT INTO [Console].[UsersApplications] ([UserID], [ApplicationID]) VALUES (2, 22)
INSERT INTO [Console].[UsersApplications] ([UserID], [ApplicationID]) VALUES (2, 23)
INSERT INTO [Console].[UsersApplications] ([UserID], [ApplicationID]) VALUES (2, 24)
INSERT INTO [Console].[UsersApplications] ([UserID], [ApplicationID]) VALUES (2, 25)
INSERT INTO [Console].[UsersApplications] ([UserID], [ApplicationID]) VALUES (2, 26)
INSERT INTO [Console].[UsersApplications] ([UserID], [ApplicationID]) VALUES (2, 27)
INSERT INTO [Console].[UsersApplications] ([UserID], [ApplicationID]) VALUES (2, 28)
INSERT INTO [Console].[UsersApplications] ([UserID], [ApplicationID]) VALUES (2, 29)
INSERT INTO [Console].[UsersApplications] ([UserID], [ApplicationID]) VALUES (2, 30)
INSERT INTO [Console].[UsersApplications] ([UserID], [ApplicationID]) VALUES (2, 31)
INSERT INTO [Console].[UsersApplications] ([UserID], [ApplicationID]) VALUES (2, 32)
INSERT INTO [Console].[UsersApplications] ([UserID], [ApplicationID]) VALUES (2, 33)
SET IDENTITY_INSERT [Businesses].[Categories] ON
INSERT INTO [Businesses].[Categories] ([CategoryID], [TypeID], [Name]) VALUES (1, 1, N'baby sitting')
INSERT INTO [Businesses].[Categories] ([CategoryID], [TypeID], [Name]) VALUES (2, 1, N'nanny')
INSERT INTO [Businesses].[Categories] ([CategoryID], [TypeID], [Name]) VALUES (3, 1, N'tutoring')
INSERT INTO [Businesses].[Categories] ([CategoryID], [TypeID], [Name]) VALUES (4, 2, N'restaurants')
INSERT INTO [Businesses].[Categories] ([CategoryID], [TypeID], [Name]) VALUES (5, 2, N'clothing')
INSERT INTO [Businesses].[Categories] ([CategoryID], [TypeID], [Name]) VALUES (6, 3, N'Realtor Agent')
INSERT INTO [Businesses].[Categories] ([CategoryID], [TypeID], [Name]) VALUES (7, 4, N'Flooring')
INSERT INTO [Businesses].[Categories] ([CategoryID], [TypeID], [Name]) VALUES (8, 4, N'Painting')
INSERT INTO [Businesses].[Categories] ([CategoryID], [TypeID], [Name]) VALUES (9, 4, N'Repair')
SET IDENTITY_INSERT [Businesses].[Categories] OFF
SET IDENTITY_INSERT [Classifieds].[Types] ON
INSERT INTO [Classifieds].[Types] ([TypeID], [Name]) VALUES (1, N'Community')
INSERT INTO [Classifieds].[Types] ([TypeID], [Name]) VALUES (2, N'For Sale')
INSERT INTO [Classifieds].[Types] ([TypeID], [Name]) VALUES (3, N'Housing')
INSERT INTO [Classifieds].[Types] ([TypeID], [Name]) VALUES (4, N'Jobs')
INSERT INTO [Classifieds].[Types] ([TypeID], [Name]) VALUES (5, N'Services')
SET IDENTITY_INSERT [Classifieds].[Types] OFF
SET IDENTITY_INSERT [Classifieds].[Categories] ON
INSERT INTO [Classifieds].[Categories] ([CategoryID], [TypeID], [Name]) VALUES (1, 1, N'adult-care needed')
INSERT INTO [Classifieds].[Categories] ([CategoryID], [TypeID], [Name]) VALUES (2, 1, N'adult-care provided')
INSERT INTO [Classifieds].[Categories] ([CategoryID], [TypeID], [Name]) VALUES (4, 1, N'childcare needed')
INSERT INTO [Classifieds].[Categories] ([CategoryID], [TypeID], [Name]) VALUES (5, 1, N'childcare provided')
INSERT INTO [Classifieds].[Categories] ([CategoryID], [TypeID], [Name]) VALUES (7, 1, N'matrimony')
INSERT INTO [Classifieds].[Categories] ([CategoryID], [TypeID], [Name]) VALUES (8, 1, N'quran tutoring')
INSERT INTO [Classifieds].[Categories] ([CategoryID], [TypeID], [Name]) VALUES (9, 2, N'auto')
INSERT INTO [Classifieds].[Categories] ([CategoryID], [TypeID], [Name]) VALUES (10, 2, N'clothing')
INSERT INTO [Classifieds].[Categories] ([CategoryID], [TypeID], [Name]) VALUES (11, 2, N'books')
INSERT INTO [Classifieds].[Categories] ([CategoryID], [TypeID], [Name]) VALUES (12, 2, N'free stuff')
INSERT INTO [Classifieds].[Categories] ([CategoryID], [TypeID], [Name]) VALUES (13, 2, N'furniture')
INSERT INTO [Classifieds].[Categories] ([CategoryID], [TypeID], [Name]) VALUES (14, 2, N'other')
INSERT INTO [Classifieds].[Categories] ([CategoryID], [TypeID], [Name]) VALUES (15, 3, N'apts housing')
INSERT INTO [Classifieds].[Categories] ([CategoryID], [TypeID], [Name]) VALUES (16, 3, N'housing wanted')
INSERT INTO [Classifieds].[Categories] ([CategoryID], [TypeID], [Name]) VALUES (17, 3, N'rooms shared')
INSERT INTO [Classifieds].[Categories] ([CategoryID], [TypeID], [Name]) VALUES (18, 4, N'childcare')
INSERT INTO [Classifieds].[Categories] ([CategoryID], [TypeID], [Name]) VALUES (19, 4, N'education')
INSERT INTO [Classifieds].[Categories] ([CategoryID], [TypeID], [Name]) VALUES (20, 4, N'other')
INSERT INTO [Classifieds].[Categories] ([CategoryID], [TypeID], [Name]) VALUES (21, 4, N'seeking')
INSERT INTO [Classifieds].[Categories] ([CategoryID], [TypeID], [Name]) VALUES (22, 5, N'beauty')
INSERT INTO [Classifieds].[Categories] ([CategoryID], [TypeID], [Name]) VALUES (23, 5, N'carpentry')
INSERT INTO [Classifieds].[Categories] ([CategoryID], [TypeID], [Name]) VALUES (24, 5, N'computers')
INSERT INTO [Classifieds].[Categories] ([CategoryID], [TypeID], [Name]) VALUES (25, 5, N'catering')
INSERT INTO [Classifieds].[Categories] ([CategoryID], [TypeID], [Name]) VALUES (26, 5, N'legal')
INSERT INTO [Classifieds].[Categories] ([CategoryID], [TypeID], [Name]) VALUES (28, 5, N'other')
SET IDENTITY_INSERT [Classifieds].[Categories] OFF
SET IDENTITY_INSERT [Events].[Calendars] ON
INSERT INTO [Events].[Calendars] ([CalendarID], [Name], [Description], [Color]) VALUES (1, N'Main', N'Main Calendar', N'#7ab7f5')
INSERT INTO [Events].[Calendars] ([CalendarID], [Name], [Description], [Color]) VALUES (2, N'Qurtuba', NULL, N'#FF0000')
SET IDENTITY_INSERT [Events].[Calendars] OFF
SET IDENTITY_INSERT [Events].[Events] ON
INSERT INTO [Events].[Events] ([EventID], [CalendarID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay], [IsRepeat], [RepeatType], [RepeatEndType], [RepeatEndOccurences], [RepeatEndDate], [RepeatEvery], [RepeatStartsOn], [RepeatWeeklySun], [RepeatWeeklyMon], [RepeatWeeklyTeu], [RepeatWeeklyWed], [RepeatWeeklyThu], [RepeatWeeklyFri], [RepeatWeeklySat], [RepeatMonthlyBy]) VALUES (3, 1, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20110802 06:30:00.000', '20110802 07:00:00.000', -5, 0, 1, 2, 1, 5, '20160702 00:00:00.000', 1, '20110802 00:00:00.000', 0, 0, 1, 0, 0, 0, 0, 1)
INSERT INTO [Events].[Events] ([EventID], [CalendarID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay], [IsRepeat], [RepeatType], [RepeatEndType], [RepeatEndOccurences], [RepeatEndDate], [RepeatEvery], [RepeatStartsOn], [RepeatWeeklySun], [RepeatWeeklyMon], [RepeatWeeklyTeu], [RepeatWeeklyWed], [RepeatWeeklyThu], [RepeatWeeklyFri], [RepeatWeeklySat], [RepeatMonthlyBy]) VALUES (4, 1, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20110802 19:00:00.000', '20110802 20:00:00.000', -5, 0, 1, 2, 1, 5, '20160702 00:00:00.000', 1, '20110802 00:00:00.000', 0, 0, 1, 0, 0, 0, 0, 1)
INSERT INTO [Events].[Events] ([EventID], [CalendarID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay], [IsRepeat], [RepeatType], [RepeatEndType], [RepeatEndOccurences], [RepeatEndDate], [RepeatEvery], [RepeatStartsOn], [RepeatWeeklySun], [RepeatWeeklyMon], [RepeatWeeklyTeu], [RepeatWeeklyWed], [RepeatWeeklyThu], [RepeatWeeklyFri], [RepeatWeeklySat], [RepeatMonthlyBy]) VALUES (5, 1, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20110803 21:00:00.000', '20110803 22:00:00.000', -5, 0, 1, 2, 1, 5, '20160702 00:00:00.000', 1, '20110802 00:00:00.000', 0, 0, 1, 1, 0, 0, 0, 1)
INSERT INTO [Events].[Events] ([EventID], [CalendarID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay], [IsRepeat], [RepeatType], [RepeatEndType], [RepeatEndOccurences], [RepeatEndDate], [RepeatEvery], [RepeatStartsOn], [RepeatWeeklySun], [RepeatWeeklyMon], [RepeatWeeklyTeu], [RepeatWeeklyWed], [RepeatWeeklyThu], [RepeatWeeklyFri], [RepeatWeeklySat], [RepeatMonthlyBy]) VALUES (6, 1, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20110803 06:30:00.000', '20110803 07:00:00.000', -5, 0, 1, 2, 1, 5, '20160703 00:00:00.000', 1, '20110803 00:00:00.000', 0, 0, 0, 1, 0, 0, 1, 1)
INSERT INTO [Events].[Events] ([EventID], [CalendarID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay], [IsRepeat], [RepeatType], [RepeatEndType], [RepeatEndOccurences], [RepeatEndDate], [RepeatEvery], [RepeatStartsOn], [RepeatWeeklySun], [RepeatWeeklyMon], [RepeatWeeklyTeu], [RepeatWeeklyWed], [RepeatWeeklyThu], [RepeatWeeklyFri], [RepeatWeeklySat], [RepeatMonthlyBy]) VALUES (8, 1, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20110803 19:00:00.000', '20110803 20:00:00.000', -5, 0, 1, 2, 1, 5, '20160703 00:00:00.000', 1, '20110803 00:00:00.000', 0, 0, 0, 1, 0, 0, 0, 1)
INSERT INTO [Events].[Events] ([EventID], [CalendarID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay], [IsRepeat], [RepeatType], [RepeatEndType], [RepeatEndOccurences], [RepeatEndDate], [RepeatEvery], [RepeatStartsOn], [RepeatWeeklySun], [RepeatWeeklyMon], [RepeatWeeklyTeu], [RepeatWeeklyWed], [RepeatWeeklyThu], [RepeatWeeklyFri], [RepeatWeeklySat], [RepeatMonthlyBy]) VALUES (9, 1, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20110804 06:30:00.000', '20110804 07:00:00.000', -5, 0, 1, 2, 1, 5, '20160704 00:00:00.000', 1, '20110804 00:00:00.000', 0, 0, 0, 0, 1, 0, 0, 1)
INSERT INTO [Events].[Events] ([EventID], [CalendarID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay], [IsRepeat], [RepeatType], [RepeatEndType], [RepeatEndOccurences], [RepeatEndDate], [RepeatEvery], [RepeatStartsOn], [RepeatWeeklySun], [RepeatWeeklyMon], [RepeatWeeklyTeu], [RepeatWeeklyWed], [RepeatWeeklyThu], [RepeatWeeklyFri], [RepeatWeeklySat], [RepeatMonthlyBy]) VALUES (10, 1, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20110804 19:00:00.000', '20110804 20:00:00.000', -5, 0, 1, 2, 1, 5, '20160704 00:00:00.000', 1, '20110804 00:00:00.000', 0, 0, 0, 0, 1, 0, 0, 1)
INSERT INTO [Events].[Events] ([EventID], [CalendarID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay], [IsRepeat], [RepeatType], [RepeatEndType], [RepeatEndOccurences], [RepeatEndDate], [RepeatEvery], [RepeatStartsOn], [RepeatWeeklySun], [RepeatWeeklyMon], [RepeatWeeklyTeu], [RepeatWeeklyWed], [RepeatWeeklyThu], [RepeatWeeklyFri], [RepeatWeeklySat], [RepeatMonthlyBy]) VALUES (11, 1, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20110805 06:30:00.000', '20110805 07:00:00.000', -5, 0, 1, 2, 1, 5, '20160705 00:00:00.000', 1, '20110805 00:00:00.000', 0, 0, 0, 0, 0, 1, 0, 1)
INSERT INTO [Events].[Events] ([EventID], [CalendarID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay], [IsRepeat], [RepeatType], [RepeatEndType], [RepeatEndOccurences], [RepeatEndDate], [RepeatEvery], [RepeatStartsOn], [RepeatWeeklySun], [RepeatWeeklyMon], [RepeatWeeklyTeu], [RepeatWeeklyWed], [RepeatWeeklyThu], [RepeatWeeklyFri], [RepeatWeeklySat], [RepeatMonthlyBy]) VALUES (12, 1, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20110805 19:00:00.000', '20110805 20:00:00.000', -5, 0, 1, 2, 1, 5, '20160705 00:00:00.000', 1, '20110805 00:00:00.000', 0, 0, 0, 0, 0, 1, 0, 1)
INSERT INTO [Events].[Events] ([EventID], [CalendarID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay], [IsRepeat], [RepeatType], [RepeatEndType], [RepeatEndOccurences], [RepeatEndDate], [RepeatEvery], [RepeatStartsOn], [RepeatWeeklySun], [RepeatWeeklyMon], [RepeatWeeklyTeu], [RepeatWeeklyWed], [RepeatWeeklyThu], [RepeatWeeklyFri], [RepeatWeeklySat], [RepeatMonthlyBy]) VALUES (13, 1, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20110807 06:30:00.000', '20110807 19:00:00.000', -5, 0, 1, 2, 1, 5, '20160707 00:00:00.000', 1, '20110807 00:00:00.000', 1, 0, 0, 0, 0, 0, 0, 1)
INSERT INTO [Events].[Events] ([EventID], [CalendarID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay], [IsRepeat], [RepeatType], [RepeatEndType], [RepeatEndOccurences], [RepeatEndDate], [RepeatEvery], [RepeatStartsOn], [RepeatWeeklySun], [RepeatWeeklyMon], [RepeatWeeklyTeu], [RepeatWeeklyWed], [RepeatWeeklyThu], [RepeatWeeklyFri], [RepeatWeeklySat], [RepeatMonthlyBy]) VALUES (14, 1, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20110807 07:00:00.000', '20110807 08:00:00.000', -5, 0, 1, 2, 1, 5, '20160707 00:00:00.000', 1, '20110807 00:00:00.000', 1, 0, 0, 0, 0, 0, 0, 1)
INSERT INTO [Events].[Events] ([EventID], [CalendarID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay], [IsRepeat], [RepeatType], [RepeatEndType], [RepeatEndOccurences], [RepeatEndDate], [RepeatEvery], [RepeatStartsOn], [RepeatWeeklySun], [RepeatWeeklyMon], [RepeatWeeklyTeu], [RepeatWeeklyWed], [RepeatWeeklyThu], [RepeatWeeklyFri], [RepeatWeeklySat], [RepeatMonthlyBy]) VALUES (15, 1, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20110807 19:00:00.000', '20110807 20:00:00.000', -5, 0, 1, 2, 1, 5, '20160707 00:00:00.000', 1, '20110807 00:00:00.000', 1, 0, 0, 0, 0, 0, 0, 1)
INSERT INTO [Events].[Events] ([EventID], [CalendarID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay], [IsRepeat], [RepeatType], [RepeatEndType], [RepeatEndOccurences], [RepeatEndDate], [RepeatEvery], [RepeatStartsOn], [RepeatWeeklySun], [RepeatWeeklyMon], [RepeatWeeklyTeu], [RepeatWeeklyWed], [RepeatWeeklyThu], [RepeatWeeklyFri], [RepeatWeeklySat], [RepeatMonthlyBy]) VALUES (16, 1, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20110808 06:30:00.000', '20110808 07:00:00.000', -5, 0, 1, 2, 1, 5, '20160708 00:00:00.000', 1, '20110808 00:00:00.000', 0, 1, 0, 0, 0, 0, 0, 1)
INSERT INTO [Events].[Events] ([EventID], [CalendarID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay], [IsRepeat], [RepeatType], [RepeatEndType], [RepeatEndOccurences], [RepeatEndDate], [RepeatEvery], [RepeatStartsOn], [RepeatWeeklySun], [RepeatWeeklyMon], [RepeatWeeklyTeu], [RepeatWeeklyWed], [RepeatWeeklyThu], [RepeatWeeklyFri], [RepeatWeeklySat], [RepeatMonthlyBy]) VALUES (17, 1, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20110808 19:00:00.000', '20110808 20:00:00.000', -5, 0, 1, 2, 1, 5, '20160708 00:00:00.000', 1, '20110808 00:00:00.000', 0, 1, 0, 0, 0, 0, 0, 1)
INSERT INTO [Events].[Events] ([EventID], [CalendarID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay], [IsRepeat], [RepeatType], [RepeatEndType], [RepeatEndOccurences], [RepeatEndDate], [RepeatEvery], [RepeatStartsOn], [RepeatWeeklySun], [RepeatWeeklyMon], [RepeatWeeklyTeu], [RepeatWeeklyWed], [RepeatWeeklyThu], [RepeatWeeklyFri], [RepeatWeeklySat], [RepeatMonthlyBy]) VALUES (18, 1, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20110804 19:00:00.000', '20110804 20:30:00.000', -5, 0, 1, 2, 1, 5, '20160704 00:00:00.000', 1, '20110804 00:00:00.000', 0, 0, 0, 0, 1, 0, 0, 1)
SET IDENTITY_INSERT [Events].[Events] OFF
SET IDENTITY_INSERT [Businesses].[Types] ON
INSERT INTO [Businesses].[Types] ([TypeID], [Name]) VALUES (1, N'Child Care')
INSERT INTO [Businesses].[Types] ([TypeID], [Name]) VALUES (2, N'Retail')
INSERT INTO [Businesses].[Types] ([TypeID], [Name]) VALUES (3, N'Real Estate')
INSERT INTO [Businesses].[Types] ([TypeID], [Name]) VALUES (4, N'Carpentry')
SET IDENTITY_INSERT [Businesses].[Types] OFF
SET IDENTITY_INSERT [TarawehPrayers].[Locations] ON
INSERT INTO [TarawehPrayers].[Locations] ([LocationID], [Name], [Street], [Street2], [City], [State], [ZipCode], [LongNote], [Latitude], [Longitude], [DisplayOrder]) VALUES (1, N'Main Center', N'46903 Sugarland Road', N'', N'Sterling', N'VA', N'20164', N'<p><span class="Apple-style-span" style="font-family: verdana, helvetica, sans-serif; font-size: 13px; background-color: rgb(255, 255, 255); ">Prayer leaders: Rotation - Hafiz Abdul Basith, Hafiz Hatem Yousuf and Hafiz Samilullah.&nbsp;<br>Co-leader - Hafiz Ibrahim Moiz</span><br></p>', 39.006436, -77.379334, 1)
INSERT INTO [TarawehPrayers].[Locations] ([LocationID], [Name], [Street], [Street2], [City], [State], [ZipCode], [LongNote], [Latitude], [Longitude], [DisplayOrder]) VALUES (2, N'Ashburn', N'21740 Beaumeade Circle', N'Unit 100', N'Ashburn', N'VA', N'20147', N'<p><span class="Apple-style-span" style="font-family: verdana, helvetica, sans-serif; font-size: 13px; background-color: rgb(255, 255, 255); "><div>Prayer leaders: Rotation - Hafiz Hatem Yousuf, Hafiz Samilullah and Hafiz Abdul Basith.</div><div>Co-leader - Hafiz Tarek Zadage</div></span></p>', 39.018245, -77.456244, 2)
INSERT INTO [TarawehPrayers].[Locations] ([LocationID], [Name], [Street], [Street2], [City], [State], [ZipCode], [LongNote], [Latitude], [Longitude], [DisplayOrder]) VALUES (4, N'ADAMS Fairfax', N'12025 Lee Jackson Memorial Highway', N'', N'Fairfax', N'VA', N'Fairfax', N'<span class="Apple-style-span" style="font-family: verdana, helvetica, sans-serif; font-size: 13px; background-color: rgb(255, 255, 255); "><div><font color="#000000" face="verdana, helvetica, sans-serif">20 Rakahs</font></div><div><font color="#000000" face="verdana, helvetica, sans-serif">Taraweeh will be held in</font></div><div><font color="#000000" face="verdana, helvetica, sans-serif">Franklin Middle School on Aug 6,<var></var>&nbsp;13 and 20</font></div><div><font face="verdana, helvetica, sans-serif"><font color="#000000">and in Penderbrook Community Center on&nbsp;</font><font color="#000000">Aug 27</font></font></div><div><font face="verdana, helvetica, sans-serif"><font color="#000000">&nbsp;</font></font></div><div><span style="border-bottom-color: rgb(0, 102, 204); border-bottom-width: 1px; border-bottom-style: dashed; "><span style="border-bottom-color: rgb(0, 102, 204); border-bottom-width: 1px; border-bottom-style: dashed; "><span style="border-bottom-color: rgb(0, 102, 204); border-bottom-width: 1px; border-bottom-style: dashed; "></span></span></span><span style="border-bottom-color: rgb(0, 102, 204); border-bottom-width: 1px; border-bottom-style: dashed; "><span style="border-bottom-color: rgb(0, 102, 204); border-bottom-width: 1px; border-bottom-style: dashed; "><span style="border-bottom-color: rgb(0, 102, 204); border-bottom-width: 1px; border-bottom-style: dashed; "></span></span></span></div><div>Prayer leaders: Rotation Hafiz Samilullah, Hafiz Abdul Basith and Hafiz Hatem Yousuf&nbsp;<br>Co-leader - Hafiz Saad Yacoob</div></span>', 38.866298, -77.362209, 3)
INSERT INTO [TarawehPrayers].[Locations] ([LocationID], [Name], [Street], [Street2], [City], [State], [ZipCode], [LongNote], [Latitude], [Longitude], [DisplayOrder]) VALUES (5, N'ADAMS South Riding', N'4050 Westfax Drive', N'', N'Chantilly', N'VA', N'Chantilly', N'<span class="Apple-style-span" style="font-family: verdana, helvetica, sans-serif; font-size: 13px; background-color: rgb(255, 255, 255); "><div><span class="Apple-style-span" style="font-family: verdana, helvetica, sans-serif; font-size: 13px; background-color: rgb(255, 255, 255); ">20 Rakahs</span></div></span><span class="Apple-style-span" style="font-family: verdana, helvetica, sans-serif; background-color: rgb(255, 255, 255); font-size: small; ">Hampton Inn in Chantilly</span><span class="Apple-style-span" style="font-family: verdana, helvetica, sans-serif; font-size: 13px; background-color: rgb(255, 255, 255); ">Prayer leaders: Hafiz Yasir Zia and Mufti Amir Toft</span>', 38.894279, -77.431099, 4)
INSERT INTO [TarawehPrayers].[Locations] ([LocationID], [Name], [Street], [Street2], [City], [State], [ZipCode], [LongNote], [Latitude], [Longitude], [DisplayOrder]) VALUES (6, N'ADAMS North Reston', N'1441 Wiehle Avenue', N'', N'Reston', N'VA', N'20190', N'<p><span class="Apple-style-span" style="font-family: verdana, helvetica, sans-serif; font-size: 13px; background-color: rgb(255, 255, 255); "></span></p><div>8 Rakahs</div><span class="Apple-style-span" style="font-family: verdana, helvetica, sans-serif; font-size: 13px; background-color: rgb(255, 255, 255); ">NVHC</span><span class="Apple-style-span" style="font-family: verdana, helvetica, sans-serif; font-size: 13px; background-color: rgb(255, 255, 255); "><div><font color="#000000" face="verdana, helvetica, sans-serif">No Taraweeh on Aug 5, Aug 12 and Aug 19</font></div><div><font color="#000000" face="verdana, helvetica, sans-serif">Last day of Tarweeh Aug 25.</font></div></span><p></p>', 38.971227, -77.332301, 5)
INSERT INTO [TarawehPrayers].[Locations] ([LocationID], [Name], [Street], [Street2], [City], [State], [ZipCode], [LongNote], [Latitude], [Longitude], [DisplayOrder]) VALUES (7, N'ADAMS South Reston', N'12343 Sunrise Valley Dr ', N'Suite B', N'Reston', N'VA', N'20191', N'<font class="Apple-style-span" face="verdana, helvetica, sans-serif" size="2"><div>8 Rakahs</div><div>Taraweeh finish time: 11:15 pm</div><div>Prayer leaders: Hafiz Osamah Saleh and Hafiz Hassan Ahmad</div></font>', 38.950190, -77.370516, 6)
INSERT INTO [TarawehPrayers].[Locations] ([LocationID], [Name], [Street], [Street2], [City], [State], [ZipCode], [LongNote], [Latitude], [Longitude], [DisplayOrder]) VALUES (8, N'ADAMS Greater Gainesville', N'9050 Devlin Road', N'', N'Bristow', N'VA', N'20136', N'<div>Bristow Montessori school</div><div>Bristow Commons</div><div>Prayer leaders: Hafiz Zubair Alam and Br. Zia<br></div>', 38.762208, -77.573980, 7)
SET IDENTITY_INSERT [TarawehPrayers].[Locations] OFF
SET IDENTITY_INSERT [TarawehPrayers].[Prayers] ON
INSERT INTO [TarawehPrayers].[Prayers] ([PrayerID], [LocationID], [Name], [Time], [DisplayOrder]) VALUES (1, 1, N'1st Taraweh', N'10:15 PM', 1)
INSERT INTO [TarawehPrayers].[Prayers] ([PrayerID], [LocationID], [Name], [Time], [DisplayOrder]) VALUES (3, 2, N'1st Taraweh', N'10:15 PM', 1)
INSERT INTO [TarawehPrayers].[Prayers] ([PrayerID], [LocationID], [Name], [Time], [DisplayOrder]) VALUES (7, 4, N'1st Taraweh', N'10:15 PM', 0)
INSERT INTO [TarawehPrayers].[Prayers] ([PrayerID], [LocationID], [Name], [Time], [DisplayOrder]) VALUES (8, 5, N'1st Taraweh', N'10:00 PM', 0)
INSERT INTO [TarawehPrayers].[Prayers] ([PrayerID], [LocationID], [Name], [Time], [DisplayOrder]) VALUES (9, 6, N'1st Taraweh', N'10:15 PM', 0)
INSERT INTO [TarawehPrayers].[Prayers] ([PrayerID], [LocationID], [Name], [Time], [DisplayOrder]) VALUES (10, 7, N'1st Taraweh', N'10:15 PM', 0)
INSERT INTO [TarawehPrayers].[Prayers] ([PrayerID], [LocationID], [Name], [Time], [DisplayOrder]) VALUES (11, 8, N'1st Taraweh', N'10:15 PM', 0)
SET IDENTITY_INSERT [TarawehPrayers].[Prayers] OFF
SET IDENTITY_INSERT [DailyPrayers].[Locations] ON
INSERT INTO [DailyPrayers].[Locations] ([LocationID], [IsMaster], [InheritMaster], [Name], [Street], [Street2], [City], [State], [ZipCode], [LongNote], [Latitude], [Longitude], [TimeZone], [DisplayOrder]) VALUES (1, 1, 0, N'Main Center', N'46903 Sugarland Road', N'', N'Sterling', N'VA', N'20164', N'Longnote', 39.006436, -77.379334, -5, 1)
INSERT INTO [DailyPrayers].[Locations] ([LocationID], [IsMaster], [InheritMaster], [Name], [Street], [Street2], [City], [State], [ZipCode], [LongNote], [Latitude], [Longitude], [TimeZone], [DisplayOrder]) VALUES (2, 0, 1, N'Ashburn', N'21740 Beaumeade Circle', N'Unit 100', N'Ashburn', N'VA', N'20147', N'Longnote', 39.018245, -77.456244, -5, 1)
INSERT INTO [DailyPrayers].[Locations] ([LocationID], [IsMaster], [InheritMaster], [Name], [Street], [Street2], [City], [State], [ZipCode], [LongNote], [Latitude], [Longitude], [TimeZone], [DisplayOrder]) VALUES (3, 0, 1, N'North Reston', N'1441 Wiehle Avenue', N'', N'Reston', N'VA', N'20190', N'Longnote', 38.971250, -77.332228, -5, 1)
SET IDENTITY_INSERT [DailyPrayers].[Locations] OFF
SET IDENTITY_INSERT [DailyPrayers].[PrayerTimes] ON
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (1, 1, 7, 1, 7, 29, N'4:14', N'5:00', N'5:46', N'1:14', N'1:30', N'5:10', N'5:30', N'8:43', N'8:50', N'10:14', N'10:30')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (2, 1, 7, 2, 7, 30, N'4:15', N'5:00', N'5:46', N'1:14', N'1:30', N'5:11', N'5:30', N'8:43', N'8:50', N'10:14', N'10:30')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (3, 1, 7, 3, 8, 1, N'4:16', N'5:00', N'5:47', N'1:15', N'1:30', N'5:11', N'5:30', N'8:43', N'8:50', N'10:13', N'10:30')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (4, 1, 7, 4, 8, 2, N'4:16', N'5:00', N'5:47', N'1:15', N'1:30', N'5:11', N'5:30', N'8:43', N'8:50', N'10:13', N'10:30')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (5, 1, 7, 5, 8, 3, N'4:17', N'5:00', N'5:48', N'1:15', N'1:30', N'5:11', N'5:30', N'8:43', N'8:50', N'10:12', N'10:30')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (6, 1, 7, 6, 8, 4, N'4:18', N'5:00', N'5:48', N'1:15', N'1:30', N'5:11', N'5:30', N'8:42', N'8:49', N'10:12', N'10:30')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (7, 1, 7, 7, 8, 5, N'4:19', N'5:00', N'5:59', N'1:15', N'1:30', N'5:11', N'5:30', N'8:42', N'8:49', N'10:11', N'10:30')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (8, 1, 7, 8, 8, 6, N'4:19', N'5:00', N'5:50', N'1:15', N'1:30', N'5:11', N'5:30', N'8:42', N'8:49', N'10:11', N'10:30')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (9, 1, 7, 9, 8, 7, N'4:20', N'5:00', N'5:50', N'1:16', N'1:30', N'5:11', N'5:30', N'8:41', N'8:48', N'10:10', N'10:30')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (10, 1, 7, 10, 8, 8, N'4:21', N'5:00', N'5:51', N'1:16', N'1:30', N'5:11', N'5:30', N'8:41', N'8:48', N'10:10', N'10:15')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (11, 1, 7, 11, 8, 9, N'4:22', N'5:00', N'5:51', N'1:16', N'1:30', N'5:11', N'5:30', N'8:41', N'8:48', N'10:09', N'10:15')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (12, 1, 7, 12, 8, 10, N'4:23', N'5:00', N'5:52', N'1:16', N'1:30', N'5:11', N'5:30', N'8:40', N'8:47', N'10:08', N'10:15')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (13, 1, 7, 13, 8, 11, N'4:24', N'5:00', N'5:53', N'1:16', N'1:30', N'5:11', N'5:30', N'8:40', N'8:47', N'10:07', N'10:15')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (14, 1, 7, 14, 8, 12, N'4:25', N'5:00', N'5:54', N'1:16', N'1:30', N'5:11', N'5:30', N'8:39', N'8:46', N'10:07', N'10:15')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (15, 1, 7, 15, 8, 13, N'4:26', N'5:00', N'5:54', N'1:16', N'1:30', N'5:11', N'5:30', N'8:39', N'8:46', N'10:06', N'10:15')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (16, 1, 7, 16, 8, 14, N'4:27', N'5:00', N'5:55', N'1:16', N'1:30', N'5:11', N'5:30', N'8:38', N'8:45', N'10:05', N'10:15')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (17, 1, 7, 17, 8, 15, N'4:28', N'5:15', N'5:56', N'1:16', N'1:30', N'5:11', N'5:30', N'8:38', N'8:45', N'10:04', N'10:15')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (18, 1, 7, 18, 8, 16, N'4:29', N'5:15', N'5:57', N'1:16', N'1:30', N'5:11', N'5:30', N'8:37', N'8:44', N'10:03', N'10:15')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (19, 1, 7, 19, 8, 17, N'4:31', N'5:15', N'5:57', N'1:17', N'1:30', N'5:11', N'5:30', N'8:36', N'8:43', N'10:02', N'10:15')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (20, 1, 7, 20, 8, 18, N'4:32', N'5:15', N'5:58', N'1:17', N'1:30', N'5:11', N'5:30', N'8:36', N'8:43', N'10:01', N'10:15')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (21, 1, 7, 21, 8, 19, N'4:33', N'5:15', N'5:59', N'1:17', N'1:30', N'5:11', N'5:30', N'8:35', N'8:42', N'10:00', N'10:15')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (22, 1, 7, 22, 8, 20, N'4:34', N'5:15', N'6:00', N'1:17', N'1:30', N'5:11', N'5:30', N'8:34', N'8:41', N'9:59', N'10:15')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (23, 1, 7, 23, 8, 21, N'4:35', N'5:15', N'6:00', N'1:17', N'1:30', N'5:11', N'5:30', N'8:33', N'8:40', N'9:58', N'10:15')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (24, 1, 7, 24, 8, 22, N'4:36', N'5:15', N'6:01', N'1:17', N'1:30', N'5:10', N'5:30', N'8:33', N'8:40', N'9:57', N'10:15')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (25, 1, 7, 25, 8, 23, N'4:37', N'5:15', N'6:02', N'1:17', N'1:30', N'5:10', N'5:30', N'8:32', N'8:39', N'9:56', N'10:15')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (26, 1, 7, 26, 8, 24, N'4:39', N'5:15', N'6:03', N'1:17', N'1:30', N'5:10', N'5:30', N'8:31', N'8:38', N'9:54', N'10:15')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (27, 1, 7, 27, 8, 25, N'4:40', N'5:15', N'6:04', N'1:17', N'1:30', N'5:10', N'5:30', N'8:30', N'8:37', N'9:53', N'10:15')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (28, 1, 7, 28, 8, 26, N'4:41', N'5:15', N'6:05', N'1:17', N'1:30', N'5:10', N'5:30', N'8:29', N'8:36', N'9:52', N'10:15')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (29, 1, 7, 29, 8, 27, N'4:42', N'5:15', N'6:06', N'1:17', N'1:30', N'5:09', N'5:30', N'8:28', N'8:35', N'9:51', N'10:15')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (30, 1, 7, 30, 8, 28, N'4:43', N'5:15', N'6:06', N'1:17', N'1:30', N'5:09', N'5:30', N'8:27', N'8:34', N'9:49', N'10:15')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (31, 1, 7, 31, 8, 29, N'4:45', N'5:30', N'6:07', N'1:17', N'1:30', N'5:09', N'5:30', N'8:26', N'8:33', N'9:48', N'10:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (32, 1, 8, 1, 9, 1, N'4:46', N'5:30', N'6:08', N'1:17', N'1:30', N'5:08', N'5:30', N'8:25', N'8:35', N'9:47', N'10:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (33, 1, 8, 2, 9, 2, N'4:47', N'5:30', N'6:09', N'1:16', N'1:30', N'5:08', N'5:30', N'8:24', N'8:34', N'9:45', N'10:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (34, 1, 8, 3, 9, 3, N'4:48', N'5:30', N'6:10', N'1:16', N'1:30', N'5:08', N'5:30', N'8:23', N'8:33', N'9:44', N'10:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (35, 1, 8, 4, 9, 4, N'4:50', N'5:30', N'6:11', N'1:16', N'1:30', N'5:07', N'5:30', N'8:22', N'8:32', N'9:42', N'10:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (36, 1, 8, 5, 9, 5, N'4:51', N'5:30', N'6:12', N'1:16', N'1:30', N'5:07', N'5:30', N'8:21', N'8:31', N'9:41', N'10:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (37, 1, 8, 6, 9, 6, N'4:52', N'5:30', N'6:13', N'1:16', N'1:30', N'5:07', N'5:30', N'8:20', N'8:30', N'9:39', N'10:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (38, 1, 8, 7, 9, 7, N'4:53', N'5:30', N'6:14', N'1:16', N'1:30', N'5:06', N'5:30', N'8:19', N'8:29', N'9:38', N'9:45')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (39, 1, 8, 8, 9, 8, N'4:55', N'5:30', N'6:15', N'1:16', N'1:30', N'5:06', N'5:30', N'8:18', N'8:28', N'9:36', N'9:45')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (40, 1, 8, 9, 9, 9, N'4:56', N'5:30', N'6:15', N'1:16', N'1:30', N'5:05', N'5:30', N'8:16', N'8:26', N'9:35', N'9:45')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (41, 1, 8, 10, 9, 10, N'4:57', N'5:30', N'6:16', N'1:16', N'1:30', N'5:05', N'5:30', N'8:15', N'8:25', N'9:33', N'9:45')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (42, 1, 8, 11, 9, 11, N'4:58', N'5:30', N'6:17', N'1:15', N'1:30', N'5:04', N'5:30', N'8:14', N'8:24', N'9:32', N'9:45')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (43, 1, 8, 12, 9, 12, N'5:00', N'5:30', N'6:18', N'1:15', N'1:30', N'5:04', N'5:30', N'8:13', N'8:23', N'9:30', N'9:45')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (44, 1, 8, 13, 9, 13, N'5:01', N'5:30', N'6:19', N'1:15', N'1:30', N'5:03', N'5:30', N'8:12', N'8:22', N'9:29', N'9:45')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (45, 1, 8, 14, 9, 14, N'5:02', N'5:30', N'6:20', N'1:15', N'1:30', N'5:03', N'5:15', N'8:10', N'8:20', N'9:27', N'9:45')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (46, 1, 8, 15, 9, 15, N'5:03', N'5:30', N'6:21', N'1:15', N'1:30', N'5:02', N'5:15', N'8:09', N'8:19', N'9:25', N'9:45')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (47, 1, 8, 16, 9, 16, N'5:04', N'5:30', N'6:22', N'1:14', N'1:30', N'5:02', N'5:15', N'8:08', N'8:18', N'9:24', N'9:45')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (48, 1, 8, 17, 9, 17, N'5:06', N'5:30', N'6:23', N'1:14', N'1:30', N'5:01', N'5:15', N'8:06', N'8:16', N'9:22', N'9:45')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (49, 1, 8, 18, 9, 18, N'5:07', N'5:30', N'6:24', N'1:14', N'1:30', N'5:00', N'5:15', N'8:05', N'8:15', N'9:21', N'9:45')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (50, 1, 8, 19, 9, 19, N'5:08', N'5:30', N'6:25', N'1:14', N'1:30', N'5:00', N'5:15', N'8:04', N'8:14', N'9:19', N'9:45')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (51, 1, 8, 20, 9, 20, N'5:09', N'5:30', N'6:25', N'1:14', N'1:30', N'4:59', N'5:15', N'8:02', N'8:12', N'9:17', N'9:45')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (52, 1, 8, 21, 9, 21, N'5:10', N'5:30', N'6:26', N'1:13', N'1:30', N'4:58', N'5:15', N'8:01', N'8:11', N'9:16', N'9:30')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (53, 1, 8, 22, 9, 22, N'5:12', N'5:30', N'6:27', N'1:13', N'1:30', N'4:58', N'5:15', N'7:59', N'8:09', N'9:14', N'9:30')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (54, 1, 8, 23, 9, 23, N'5:13', N'5:30', N'6:28', N'1:13', N'1:30', N'4:57', N'5:15', N'7:58', N'8:08', N'9:12', N'9:30')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (55, 1, 8, 24, 9, 24, N'5:14', N'5:30', N'6:29', N'1:12', N'1:30', N'4:56', N'5:15', N'7:57', N'8:07', N'9:10', N'9:30')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (56, 1, 8, 25, 9, 25, N'5:15', N'5:30', N'6:30', N'1:12', N'1:30', N'4:55', N'5:15', N'7:55', N'8:05', N'9:09', N'9:30')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (57, 1, 8, 26, 9, 26, N'5:16', N'5:30', N'6:31', N'1:12', N'1:30', N'4:55', N'5:15', N'7:54', N'8:04', N'9:07', N'9:30')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (58, 1, 8, 27, 9, 27, N'5:17', N'5:30', N'6:32', N'1:12', N'1:30', N'4:54', N'5:15', N'7:53', N'8:03', N'9:05', N'9:30')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (59, 1, 8, 28, 9, 28, N'5:19', N'5:45', N'6:33', N'1:11', N'1:30', N'4:53', N'5:15', N'7:51', N'8:01', N'9:04', N'9:30')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (60, 1, 8, 29, 9, 29, N'5:20', N'5:45', N'6:34', N'1:11', N'1:30', N'4:52', N'5:15', N'7:49', N'7:59', N'9:02', N'9:30')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (61, 1, 8, 30, 9, 30, N'5:21', N'5:45', N'6:35', N'1:11', N'1:30', N'4:51', N'5:15', N'7:48', N'7:55', N'9:00', N'9:30')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (62, 1, 8, 31, 10, 1, N'5:22', N'5:45', N'6:35', N'1:10', N'1:30', N'4:51', N'5:15', N'7:46', N'7:53', N'8:58', N'9:30')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (63, 1, 6, 1, 6, 28, N'4:14', N'5:00', N'5:44', N'1:08', N'1:30', N'5:04', N'5:15', N'8:33', N'8:40', N'10:03', N'10:15')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (64, 1, 6, 2, 6, 29, N'4:13', N'5:00', N'5:44', N'1:08', N'1:30', N'5:04', N'5:15', N'8:34', N'8:41', N'10:04', N'10:15')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (65, 1, 6, 3, 7, 1, N'4:13', N'5:00', N'5:43', N'1:08', N'1:30', N'5:04', N'5:15', N'8:35', N'8:42', N'10:05', N'10:15')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (66, 1, 6, 4, 7, 2, N'4:12', N'5:00', N'5:43', N'1:09', N'1:30', N'5:05', N'5:15', N'8:35', N'8:42', N'10:05', N'10:15')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (67, 1, 6, 5, 7, 3, N'4:12', N'5:00', N'5:43', N'1:09', N'1:30', N'5:05', N'5:15', N'8:36', N'8:43', N'10:06', N'10:30')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (68, 1, 6, 6, 7, 4, N'4:11', N'5:00', N'5:43', N'1:09', N'1:30', N'5:05', N'5:15', N'8:37', N'8:44', N'10:07', N'10:30')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (69, 1, 6, 7, 7, 5, N'4:11', N'5:00', N'5:42', N'1:09', N'1:30', N'5:05', N'5:15', N'8:37', N'8:44', N'10:08', N'10:30')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (70, 1, 6, 8, 7, 6, N'4:10', N'5:00', N'5:42', N'1:09', N'1:30', N'5:06', N'5:15', N'8:38', N'8:45', N'10:08', N'10:30')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (71, 1, 6, 9, 7, 7, N'4:10', N'5:00', N'5:42', N'1:10', N'1:30', N'5:06', N'5:15', N'8:38', N'8:45', N'10:09', N'10:30')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (72, 1, 6, 10, 7, 8, N'4:10', N'5:00', N'5:42', N'1:10', N'1:30', N'5:06', N'5:15', N'8:39', N'8:46', N'10:10', N'10:30')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (73, 1, 6, 11, 7, 9, N'4:10', N'5:00', N'5:42', N'1:10', N'1:30', N'5:06', N'5:15', N'8:39', N'8:46', N'10:10', N'10:30')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (74, 1, 6, 12, 7, 10, N'4:09', N'5:00', N'5:42', N'1:10', N'1:30', N'5:07', N'5:15', N'8:40', N'8:47', N'10:11', N'10:30')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (75, 1, 6, 13, 7, 11, N'4:09', N'5:00', N'5:42', N'1:10', N'1:30', N'5:07', N'5:15', N'8:40', N'8:47', N'10:12', N'10:30')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (76, 1, 6, 14, 7, 12, N'4:09', N'5:00', N'5:42', N'1:11', N'1:30', N'5:07', N'5:15', N'8:41', N'8:48', N'10:12', N'10:30')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (77, 1, 6, 15, 7, 13, N'4:09', N'5:00', N'5:42', N'1:11', N'1:30', N'5:07', N'5:15', N'8:41', N'8:48', N'10:13', N'10:30')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (78, 1, 6, 16, 7, 14, N'4:09', N'5:00', N'5:42', N'1:11', N'1:30', N'5:08', N'5:15', N'8:41', N'8:48', N'10:13', N'10:30')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (79, 1, 6, 17, 7, 15, N'4:09', N'5:00', N'5:42', N'1:11', N'1:30', N'5:08', N'5:15', N'8:42', N'8:49', N'10:13', N'10:30')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (80, 1, 6, 18, 7, 16, N'4:09', N'5:00', N'5:42', N'1:11', N'1:30', N'5:08', N'5:15', N'8:42', N'8:49', N'10:14', N'10:30')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (81, 1, 6, 19, 7, 17, N'4:09', N'5:00', N'5:42', N'1:12', N'1:30', N'5:08', N'5:15', N'8:42', N'8:49', N'10:14', N'10:30')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (82, 1, 6, 20, 7, 18, N'4:09', N'5:00', N'5:42', N'1:12', N'1:30', N'5:08', N'5:15', N'8:43', N'8:50', N'10:14', N'10:30')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (83, 1, 6, 21, 7, 19, N'4:10', N'5:00', N'5:42', N'1:12', N'1:30', N'5:09', N'5:30', N'8:43', N'8:50', N'10:14', N'10:30')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (84, 1, 6, 22, 7, 20, N'4:10', N'5:00', N'5:42', N'1:12', N'1:30', N'5:09', N'5:30', N'8:43', N'8:50', N'10:15', N'10:30')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (85, 1, 6, 23, 7, 21, N'4:10', N'5:00', N'5:43', N'1:13', N'1:30', N'5:09', N'5:30', N'8:43', N'8:50', N'10:15', N'10:30')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (86, 1, 6, 24, 7, 22, N'4:11', N'5:00', N'5:43', N'1:13', N'1:30', N'5:09', N'5:30', N'8:43', N'8:50', N'10:15', N'10:30')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (87, 1, 6, 25, 7, 23, N'4:11', N'5:00', N'5:43', N'1:13', N'1:30', N'5:09', N'5:30', N'8:43', N'8:50', N'10:15', N'10:30')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (88, 1, 6, 26, 7, 24, N'4:11', N'5:00', N'5:44', N'1:13', N'1:30', N'5:10', N'5:30', N'8:43', N'8:50', N'10:15', N'10:30')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (89, 1, 6, 27, 7, 25, N'4:12', N'5:00', N'5:44', N'1:13', N'1:30', N'5:10', N'5:30', N'8:43', N'8:50', N'10:15', N'10:30')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (90, 1, 6, 28, 7, 26, N'4:12', N'5:00', N'5:44', N'1:14', N'1:30', N'5:10', N'5:30', N'8:43', N'8:50', N'10:14', N'10:30')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (91, 1, 6, 29, 7, 27, N'4:13', N'5:00', N'5:45', N'1:14', N'1:30', N'5:10', N'5:30', N'8:43', N'8:50', N'10:14', N'10:30')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (92, 1, 6, 30, 7, 28, N'4:14', N'5:00', N'5:45', N'1:14', N'1:30', N'5:10', N'5:30', N'8:43', N'8:50', N'10:14', N'10:30')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (93, 1, 9, 1, 10, 2, N'5:23', N'5:45', N'6:36', N'1:10', N'1:30', N'4:50', N'5:30', N'7:45', N'7:52', N'8:57', N'9:45')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (94, 1, 9, 2, 10, 3, N'5:24', N'5:45', N'6:37', N'1:10', N'1:30', N'4:49', N'5:30', N'7:43', N'7:50', N'8:55', N'9:45')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (95, 1, 9, 3, 10, 4, N'5:25', N'5:45', N'6:38', N'1:09', N'1:30', N'4:48', N'5:30', N'7:41', N'7:48', N'8:53', N'9:45')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (96, 1, 9, 4, 10, 5, N'5:26', N'6:00', N'6:39', N'1:09', N'1:30', N'4:47', N'5:15', N'7:40', N'7:47', N'8:51', N'9:15')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (97, 1, 9, 5, 10, 6, N'5:27', N'6:00', N'6:40', N'1:09', N'1:30', N'4:46', N'5:15', N'7:38', N'7:45', N'8:50', N'9:15')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (98, 1, 9, 6, 10, 7, N'5:28', N'6:00', N'6:41', N'1:08', N'1:30', N'4:45', N'5:15', N'7:37', N'7:44', N'8:48', N'9:15')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (99, 1, 9, 7, 10, 8, N'5:30', N'6:00', N'6:42', N'1:08', N'1:30', N'4:44', N'5:15', N'7:35', N'7:42', N'8:46', N'9:15')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (100, 1, 9, 8, 10, 9, N'5:31', N'6:00', N'6:43', N'1:08', N'1:30', N'4:43', N'5:15', N'7:34', N'7:41', N'8:44', N'9:15')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (101, 1, 9, 9, 10, 10, N'5:32', N'6:00', N'6:43', N'1:07', N'1:30', N'4:42', N'5:15', N'7:32', N'7:39', N'8:43', N'9:15')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (102, 1, 9, 10, 10, 11, N'5:33', N'6:00', N'6:44', N'1:07', N'1:30', N'4:41', N'5:15', N'7:30', N'7:37', N'8:41', N'9:15')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (103, 1, 9, 11, 10, 12, N'5:34', N'6:00', N'6:45', N'1:07', N'1:30', N'4:40', N'5:15', N'7:29', N'7:36', N'8:39', N'9:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (104, 1, 9, 12, 10, 13, N'5:35', N'6:00', N'6:46', N'1:06', N'1:30', N'4:39', N'5:15', N'7:27', N'7:34', N'8:37', N'9:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (105, 1, 9, 13, 10, 14, N'5:36', N'6:00', N'6:47', N'1:06', N'1:30', N'4:38', N'5:15', N'7:26', N'7:33', N'8:36', N'9:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (106, 1, 9, 14, 10, 15, N'5:37', N'6:00', N'6:48', N'1:06', N'1:30', N'4:37', N'5:15', N'7:24', N'7:31', N'8:34', N'9:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (107, 1, 9, 15, 10, 16, N'5:38', N'6:00', N'6:49', N'1:05', N'1:30', N'4:36', N'5:15', N'7:22', N'7:29', N'8:32', N'9:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (108, 1, 9, 16, 10, 17, N'5:39', N'6:00', N'6:50', N'1:05', N'1:30', N'4:35', N'5:15', N'7:21', N'7:28', N'8:31', N'9:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (109, 1, 9, 17, 10, 18, N'5:40', N'6:00', N'6:51', N'1:05', N'1:30', N'4:34', N'5:15', N'7:19', N'7:26', N'8:29', N'9:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (110, 1, 9, 18, 10, 19, N'5:41', N'6:15', N'6:52', N'1:04', N'1:30', N'4:33', N'5:00', N'7:18', N'7:25', N'8:27', N'9:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (111, 1, 9, 19, 10, 20, N'5:42', N'6:15', N'6:52', N'1:04', N'1:30', N'4:32', N'5:00', N'7:16', N'7:23', N'8:25', N'9:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (112, 1, 9, 20, 10, 21, N'5:43', N'6:15', N'6:53', N'1:04', N'1:30', N'4:31', N'5:00', N'7:14', N'7:21', N'8:24', N'9:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (113, 1, 9, 21, 10, 22, N'5:44', N'6:15', N'6:54', N'1:03', N'1:30', N'4:30', N'5:00', N'7:13', N'7:20', N'8:22', N'9:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (114, 1, 9, 22, 10, 23, N'5:45', N'6:15', N'6:55', N'1:03', N'1:30', N'4:29', N'5:00', N'7:11', N'7:18', N'8:20', N'9:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (115, 1, 9, 23, 10, 24, N'5:46', N'6:15', N'6:56', N'1:02', N'1:30', N'4:28', N'5:00', N'7:10', N'7:17', N'8:19', N'9:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (116, 1, 9, 24, 10, 25, N'5:47', N'6:15', N'6:59', N'1:02', N'1:30', N'4:26', N'5:00', N'7:08', N'7:15', N'8:17', N'9:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (117, 1, 9, 25, 10, 26, N'5:48', N'6:15', N'6:58', N'1:02', N'1:30', N'4:25', N'5:00', N'7:06', N'7:13', N'8:15', N'8:30')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (118, 1, 9, 26, 10, 27, N'5:49', N'6:15', N'6:59', N'1:01', N'1:30', N'4:24', N'5:00', N'7:05', N'7:12', N'8:14', N'8:30')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (119, 1, 9, 27, 10, 28, N'5:50', N'6:15', N'7:00', N'1:01', N'1:30', N'4:23', N'5:00', N'7:03', N'7:10', N'8:12', N'8:30')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (120, 1, 9, 28, 10, 29, N'5:51', N'6:15', N'7:01', N'1:01', N'1:30', N'4:22', N'5:00', N'7:02', N'7:09', N'8:10', N'8:30')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (121, 1, 9, 29, 11, 1, N'5:52', N'6:15', N'7:02', N'1:00', N'1:30', N'4:21', N'5:00', N'7:00', N'7:07', N'8:09', N'8:30')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (122, 1, 9, 30, 11, 2, N'5:53', N'6:15', N'7:02', N'1:00', N'1:30', N'4:20', N'5:00', N'6:58', N'7:05', N'8:07', N'8:30')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (123, 1, 1, 1, 1, 25, N'6:09', N'6:30', N'7:27', N'12:14', N'1:00', N'2:41', N'3:30', N'5:02', N'5:09', N'6:18', N'8:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (124, 1, 1, 2, 1, 26, N'6:10', N'6:30', N'7:27', N'12:14', N'12:45', N'2:41', N'3:30', N'5:03', N'5:10', N'6:18', N'8:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (125, 1, 1, 3, 1, 27, N'6:10', N'6:30', N'7:27', N'12:15', N'1:00', N'2:43', N'3:30', N'5:04', N'5:11', N'6:20', N'8:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (126, 1, 1, 4, 1, 28, N'6:10', N'6:30', N'7:27', N'12:15', N'1:00', N'2:43', N'3:30', N'5:05', N'5:12', N'6:21', N'8:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (127, 1, 1, 5, 1, 29, N'6:10', N'6:30', N'7:27', N'12:16', N'1:00', N'2:44', N'3:30', N'5:05', N'5:12', N'6:22', N'8:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (128, 1, 1, 6, 1, 30, N'6:10', N'6:30', N'7:27', N'12:16', N'1:00', N'2:45', N'3:30', N'5:06', N'5:13', N'6:22', N'8:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (129, 1, 1, 7, 2, 1, N'6:10', N'6:30', N'7:27', N'12:17', N'1:00', N'2:46', N'3:30', N'5:07', N'5:14', N'6:23', N'8:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (130, 1, 1, 8, 2, 2, N'6:10', N'6:30', N'7:27', N'12:17', N'1:00', N'2:47', N'3:30', N'5:07', N'5:14', N'6:24', N'8:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (131, 1, 1, 9, 2, 3, N'6:10', N'6:30', N'7:27', N'12:17', N'12:45', N'2:47', N'3:30', N'5:09', N'5:16', N'6:24', N'8:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (132, 1, 1, 10, 2, 4, N'6:10', N'6:30', N'7:26', N'12:18', N'1:00', N'2:48', N'3:30', N'5:10', N'5:17', N'6:25', N'8:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (133, 1, 1, 11, 2, 5, N'6:10', N'6:30', N'7:26', N'12:18', N'1:00', N'2:50', N'3:30', N'5:11', N'5:18', N'6:27', N'8:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (134, 1, 1, 12, 2, 6, N'6:10', N'6:30', N'7:26', N'12:19', N'1:00', N'2:50', N'3:30', N'5:12', N'5:19', N'6:28', N'8:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (135, 1, 1, 13, 2, 7, N'6:10', N'6:30', N'7:26', N'12:19', N'1:00', N'2:51', N'3:30', N'5:13', N'5:20', N'6:29', N'8:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (136, 1, 1, 14, 2, 8, N'6:09', N'6:30', N'7:25', N'12:19', N'1:00', N'2:52', N'3:30', N'5:14', N'5:21', N'6:30', N'8:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (137, 1, 1, 15, 2, 9, N'6:09', N'6:30', N'7:25', N'12:20', N'1:00', N'2:53', N'3:30', N'5:15', N'5:22', N'6:31', N'8:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (138, 1, 1, 16, 2, 10, N'6:09', N'6:30', N'7:25', N'12:20', N'12:45', N'2:53', N'3:30', N'5:16', N'5:23', N'6:31', N'8:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (139, 1, 1, 17, 2, 11, N'6:09', N'6:30', N'7:24', N'12:20', N'1:00', N'2:54', N'3:30', N'5:18', N'5:25', N'6:32', N'8:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (140, 1, 1, 18, 2, 12, N'6:08', N'6:30', N'7:24', N'12:21', N'1:00', N'2:56', N'3:30', N'5:19', N'5:26', N'6:33', N'8:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (141, 1, 1, 19, 2, 13, N'6:08', N'6:30', N'7:23', N'12:21', N'1:00', N'2:57', N'3:30', N'5:20', N'5:27', N'6:34', N'8:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (142, 1, 1, 20, 2, 14, N'6:07', N'6:30', N'7:23', N'12:21', N'1:00', N'2:58', N'3:30', N'5:21', N'5:28', N'6:35', N'8:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (143, 1, 1, 21, 2, 15, N'6:07', N'6:30', N'7:22', N'12:22', N'1:00', N'2:59', N'3:30', N'5:22', N'5:29', N'6:36', N'8:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (144, 1, 1, 22, 2, 16, N'6:07', N'6:30', N'7:22', N'12:22', N'1:00', N'3:00', N'3:30', N'5:23', N'5:30', N'6:37', N'8:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (145, 1, 1, 23, 2, 17, N'6:07', N'6:30', N'7:21', N'12:22', N'12:45', N'3:01', N'3:30', N'5:24', N'5:31', N'6:38', N'8:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (146, 1, 1, 24, 2, 18, N'6:06', N'6:30', N'7:21', N'12:22', N'1:00', N'3:01', N'3:30', N'5:25', N'5:32', N'6:38', N'8:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (147, 1, 1, 25, 2, 19, N'6:05', N'6:30', N'7:20', N'12:23', N'1:00', N'3:03', N'3:30', N'5:25', N'5:32', N'6:40', N'8:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (148, 1, 1, 26, 2, 20, N'6:04', N'6:30', N'7:19', N'12:23', N'1:00', N'3:04', N'3:30', N'5:28', N'5:35', N'6:42', N'8:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (149, 1, 1, 27, 2, 21, N'6:04', N'6:30', N'7:18', N'12:23', N'1:00', N'3:05', N'3:30', N'5:29', N'5:36', N'6:43', N'8:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (150, 1, 1, 28, 2, 22, N'6:03', N'6:30', N'7:17', N'12:23', N'1:00', N'3:06', N'3:30', N'5:30', N'5:37', N'6:44', N'8:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (151, 1, 1, 29, 2, 23, N'6:03', N'6:30', N'7:17', N'12:23', N'1:00', N'3:07', N'3:30', N'5:31', N'5:38', N'6:45', N'8:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (152, 1, 1, 30, 2, 24, N'6:03', N'6:15', N'7:16', N'12:24', N'12:45', N'3:08', N'3:30', N'5:32', N'5:39', N'6:46', N'8:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (153, 1, 1, 31, 2, 25, N'6:01', N'6:15', N'7:15', N'12:24', N'1:00', N'3:08', N'3:30', N'5:33', N'5:40', N'6:46', N'8:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (154, 1, 2, 1, 2, 26, N'6:00', N'6:15', N'7:14', N'12:24', N'1:00', N'3:09', N'3:30', N'5:35', N'5:42', N'6:47', N'8:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (155, 1, 2, 2, 2, 27, N'6:00', N'6:15', N'7:13', N'12:24', N'1:00', N'3:11', N'3:30', N'5:36', N'5:43', N'6:49', N'8:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (156, 1, 2, 3, 2, 28, N'5:59', N'6:15', N'7:13', N'12:24', N'1:00', N'3:12', N'3:30', N'5:37', N'5:44', N'6:50', N'8:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (157, 1, 2, 4, 2, 29, N'5:58', N'6:15', N'7:12', N'12:24', N'1:00', N'3:13', N'3:30', N'5:38', N'5:45', N'6:51', N'8:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (158, 1, 2, 5, 3, 1, N'5:57', N'6:15', N'7:11', N'12:24', N'1:00', N'3:14', N'3:30', N'5:39', N'5:46', N'6:52', N'8:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (159, 1, 2, 6, 3, 2, N'5:57', N'6:15', N'7:10', N'12:24', N'12:45', N'3:15', N'3:45', N'5:40', N'5:47', N'6:53', N'8:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (160, 1, 2, 7, 3, 3, N'5:55', N'6:15', N'7:09', N'12:24', N'1:00', N'3:15', N'3:45', N'5:42', N'5:49', N'6:53', N'8:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (161, 1, 2, 8, 3, 4, N'5:54', N'6:15', N'7:07', N'12:24', N'1:00', N'3:16', N'3:45', N'5:43', N'5:50', N'6:54', N'8:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (162, 1, 2, 9, 3, 5, N'5:53', N'6:15', N'7:06', N'12:24', N'1:00', N'3:18', N'3:45', N'5:44', N'5:51', N'6:56', N'8:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (163, 1, 2, 10, 3, 6, N'5:52', N'6:15', N'7:05', N'12:24', N'1:00', N'3:18', N'3:45', N'5:45', N'5:52', N'6:57', N'8:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (164, 1, 2, 11, 3, 7, N'5:51', N'6:15', N'7:04', N'12:24', N'1:00', N'3:19', N'3:45', N'5:46', N'5:53', N'6:58', N'8:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (165, 1, 2, 12, 3, 8, N'5:50', N'6:15', N'7:03', N'12:24', N'1:00', N'3:20', N'3:45', N'5:47', N'5:54', N'6:59', N'8:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (166, 1, 2, 13, 3, 9, N'5:50', N'6:15', N'7:02', N'12:24', N'12:45', N'3:21', N'3:45', N'5:49', N'5:56', N'7:00', N'8:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (167, 1, 2, 14, 3, 10, N'5:49', N'6:15', N'7:01', N'12:24', N'1:00', N'3:22', N'3:45', N'5:50', N'5:57', N'7:01', N'8:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (168, 1, 2, 15, 3, 11, N'5:47', N'6:15', N'6:59', N'12:24', N'1:00', N'3:22', N'3:45', N'5:51', N'5:58', N'7:01', N'8:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (169, 1, 2, 16, 3, 12, N'5:46', N'6:15', N'6:58', N'12:24', N'1:00', N'3:24', N'3:45', N'5:52', N'5:59', N'7:03', N'8:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (170, 1, 2, 17, 3, 13, N'5:45', N'6:15', N'6:57', N'12:24', N'1:00', N'3:24', N'3:45', N'5:53', N'6:00', N'7:04', N'8:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (171, 1, 2, 18, 3, 14, N'5:43', N'6:15', N'6:56', N'12:24', N'1:00', N'3:25', N'3:45', N'5:54', N'6:01', N'7:05', N'8:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (172, 1, 2, 19, 3, 15, N'5:42', N'6:15', N'6:54', N'12:24', N'1:00', N'3:26', N'3:45', N'5:55', N'6:02', N'7:06', N'8:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (173, 1, 2, 20, 3, 16, N'5:41', N'6:00', N'6:53', N'12:24', N'12:45', N'3:27', N'3:45', N'5:56', N'6:03', N'7:07', N'8:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (174, 1, 2, 21, 3, 17, N'5:41', N'6:00', N'6:52', N'12:24', N'1:00', N'3:28', N'3:45', N'5:57', N'6:04', N'7:08', N'8:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (175, 1, 2, 22, 3, 18, N'5:39', N'6:00', N'6:53', N'12:24', N'1:00', N'3:28', N'3:45', N'5:59', N'6:06', N'7:08', N'8:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (176, 1, 2, 23, 3, 19, N'5:37', N'6:00', N'6:49', N'12:24', N'1:00', N'3:28', N'3:45', N'6:00', N'6:07', N'7:09', N'8:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (177, 1, 2, 24, 3, 20, N'5:36', N'6:00', N'6:48', N'12:23', N'1:00', N'3:30', N'3:45', N'6:01', N'6:08', N'7:11', N'8:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (178, 1, 2, 25, 3, 21, N'5:35', N'6:00', N'6:47', N'12:23', N'1:00', N'3:31', N'3:45', N'6:02', N'6:09', N'7:13', N'8:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (179, 1, 2, 26, 3, 22, N'5:33', N'6:00', N'6:45', N'12:23', N'1:00', N'3:31', N'3:45', N'6:03', N'6:10', N'7:14', N'8:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (180, 1, 2, 27, 3, 23, N'5:32', N'5:45', N'6:44', N'12:23', N'12:45', N'3:32', N'4:00', N'6:04', N'6:11', N'7:15', N'8:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (181, 1, 2, 28, 3, 24, N'5:32', N'5:45', N'6:42', N'12:23', N'1:00', N'3:33', N'4:00', N'6:05', N'6:12', N'7:16', N'8:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (182, 1, 3, 1, 3, 25, N'5:29', N'5:45', N'6:41', N'12:22', N'1:00', N'3:34', N'4:00', N'6:06', N'6:13', N'7:17', N'8:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (183, 1, 3, 2, 3, 26, N'5:28', N'5:45', N'6:39', N'12:22', N'1:00', N'3:34', N'4:00', N'6:07', N'6:14', N'7:17', N'8:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (184, 1, 3, 3, 3, 27, N'5:26', N'5:45', N'6:38', N'12:22', N'1:00', N'3:35', N'4:00', N'6:08', N'6:15', N'7:19', N'8:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (185, 1, 3, 4, 3, 28, N'5:25', N'5:45', N'6:36', N'12:22', N'1:00', N'3:36', N'4:00', N'6:09', N'6:16', N'7:20', N'8:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (186, 1, 3, 5, 3, 29, N'5:23', N'5:45', N'6:35', N'12:22', N'1:00', N'3:36', N'4:00', N'6:10', N'6:17', N'7:21', N'8:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (187, 1, 3, 6, 3, 30, N'5:22', N'5:45', N'6:33', N'12:21', N'12:45', N'3:37', N'4:00', N'6:11', N'6:18', N'7:22', N'8:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (188, 1, 3, 7, 4, 1, N'5:22', N'5:45', N'6:32', N'12:21', N'1:00', N'3:37', N'4:00', N'6:12', N'6:19', N'7:23', N'8:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (189, 1, 3, 8, 4, 2, N'5:20', N'5:45', N'6:30', N'12:21', N'1:00', N'3:38', N'4:00', N'6:13', N'6:20', N'7:24', N'8:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (190, 1, 3, 9, 4, 3, N'5:17', N'5:45', N'6:29', N'12:21', N'1:00', N'3:39', N'4:00', N'6:14', N'6:21', N'7:25', N'8:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (191, 1, 3, 10, 4, 4, N'5:16', N'5:45', N'6:27', N'12:20', N'1:00', N'3:39', N'4:00', N'6:15', N'6:22', N'7:26', N'8:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (192, 1, 3, 11, 4, 5, N'5:14', N'5:45', N'6:26', N'12:20', N'1:00', N'3:40', N'4:00', N'6:16', N'6:23', N'7:27', N'8:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (193, 1, 3, 12, 4, 6, N'5:13', N'5:45', N'6:24', N'12:20', N'1:00', N'3:40', N'4:00', N'6:17', N'6:24', N'7:28', N'8:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (194, 1, 3, 13, 4, 7, N'6:11', N'6:30', N'7:23', N'1:20', N'1:30', N'4:41', N'5:15', N'7:18', N'7:25', N'8:29', N'9:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (195, 1, 3, 14, 4, 8, N'6:09', N'6:30', N'7:21', N'1:19', N'1:30', N'4:41', N'5:15', N'7:19', N'7:26', N'8:30', N'9:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (196, 1, 3, 15, 4, 9, N'6:08', N'6:30', N'7:20', N'1:19', N'1:30', N'4:42', N'5:15', N'7:20', N'7:27', N'8:31', N'9:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (197, 1, 3, 16, 4, 10, N'6:06', N'6:30', N'7:18', N'1:19', N'1:30', N'4:42', N'5:15', N'7:21', N'7:28', N'8:32', N'9:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (198, 1, 3, 17, 4, 11, N'6:05', N'6:30', N'7:16', N'1:18', N'1:30', N'4:43', N'5:15', N'7:22', N'7:29', N'8:33', N'9:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (199, 1, 3, 18, 4, 12, N'6:03', N'6:30', N'7:15', N'1:18', N'1:30', N'4:43', N'5:15', N'7:23', N'7:30', N'8:34', N'9:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (200, 1, 3, 19, 4, 13, N'6:01', N'6:30', N'7:13', N'1:18', N'1:30', N'4:44', N'5:15', N'7:24', N'7:31', N'8:35', N'9:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (201, 1, 3, 20, 4, 14, N'6:00', N'6:15', N'7:12', N'1:18', N'1:30', N'4:44', N'5:15', N'7:25', N'7:32', N'8:36', N'9:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (202, 1, 3, 21, 4, 15, N'5:58', N'6:15', N'7:10', N'1:17', N'1:30', N'4:45', N'5:15', N'7:26', N'7:33', N'8:37', N'9:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (203, 1, 3, 22, 4, 16, N'5:56', N'6:15', N'7:09', N'1:17', N'1:30', N'4:45', N'5:15', N'7:27', N'7:34', N'8:38', N'9:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (204, 1, 3, 23, 4, 17, N'5:55', N'6:15', N'7:07', N'1:17', N'1:30', N'4:45', N'5:15', N'7:28', N'7:35', N'8:40', N'9:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (205, 1, 3, 24, 4, 18, N'5:53', N'6:15', N'7:05', N'1:16', N'1:30', N'4:46', N'5:15', N'7:29', N'7:36', N'8:41', N'9:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (206, 1, 3, 25, 4, 19, N'5:51', N'6:15', N'7:04', N'1:16', N'1:30', N'4:46', N'5:15', N'7:30', N'7:37', N'8:42', N'9:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (207, 1, 3, 26, 4, 20, N'5:50', N'6:15', N'7:02', N'1:16', N'1:30', N'4:47', N'5:15', N'7:31', N'7:38', N'8:43', N'9:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (208, 1, 3, 27, 4, 21, N'5:48', N'6:00', N'7:01', N'1:15', N'1:30', N'4:47', N'5:15', N'7:32', N'7:39', N'8:44', N'9:15')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (209, 1, 3, 28, 4, 22, N'5:46', N'6:00', N'6:59', N'1:15', N'1:30', N'4:47', N'5:15', N'7:33', N'7:40', N'8:45', N'9:15')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (210, 1, 3, 29, 4, 23, N'5:44', N'6:00', N'6:57', N'1:15', N'1:30', N'4:48', N'5:15', N'7:34', N'7:41', N'8:46', N'9:15')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (211, 1, 3, 30, 4, 24, N'5:43', N'6:00', N'6:56', N'1:15', N'1:30', N'4:48', N'5:15', N'7:35', N'7:42', N'8:47', N'9:15')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (212, 1, 3, 31, 4, 25, N'5:41', N'6:00', N'6:54', N'1:14', N'1:30', N'4:49', N'5:15', N'7:36', N'7:43', N'8:48', N'9:15')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (213, 1, 4, 1, 4, 26, N'5:39', N'6:00', N'6:53', N'1:14', N'1:30', N'4:49', N'5:15', N'7:37', N'7:44', N'8:49', N'9:15')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (214, 1, 4, 2, 4, 27, N'5:38', N'6:00', N'6:51', N'1:14', N'1:30', N'4:49', N'5:15', N'7:38', N'7:45', N'8:51', N'9:15')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (215, 1, 4, 3, 4, 28, N'5:36', N'5:45', N'6:50', N'1:13', N'1:30', N'4:50', N'5:15', N'7:39', N'7:46', N'8:52', N'9:15')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (216, 1, 4, 4, 4, 29, N'5:34', N'5:45', N'6:48', N'1:13', N'1:30', N'4:50', N'5:15', N'7:40', N'7:47', N'8:53', N'9:15')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (217, 1, 4, 5, 5, 1, N'5:32', N'5:45', N'6:47', N'1:13', N'1:30', N'4:50', N'5:15', N'7:41', N'7:48', N'8:54', N'9:15')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (218, 1, 4, 6, 5, 2, N'5:31', N'5:45', N'6:45', N'1:13', N'1:30', N'4:51', N'5:15', N'7:42', N'7:49', N'8:55', N'9:15')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (219, 1, 4, 7, 5, 3, N'5:29', N'5:45', N'6:44', N'1:12', N'1:30', N'4:51', N'5:15', N'7:43', N'7:50', N'8:56', N'9:15')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (220, 1, 4, 8, 5, 4, N'5:27', N'5:45', N'6:42', N'1:12', N'1:30', N'4:51', N'5:15', N'7:44', N'7:51', N'8:57', N'9:15')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (221, 1, 4, 9, 5, 5, N'5:26', N'5:45', N'6:41', N'1:12', N'1:30', N'4:51', N'5:15', N'7:45', N'7:52', N'8:59', N'9:15')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (222, 1, 4, 10, 5, 6, N'5:24', N'5:45', N'6:39', N'1:11', N'1:30', N'4:52', N'5:15', N'7:46', N'7:53', N'9:00', N'9:30')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (223, 1, 4, 11, 5, 7, N'5:22', N'5:45', N'6:37', N'1:11', N'1:30', N'4:52', N'5:15', N'7:47', N'7:54', N'9:01', N'9:30')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (224, 1, 4, 12, 5, 8, N'5:20', N'5:45', N'6:36', N'1:11', N'1:30', N'4:52', N'5:15', N'7:48', N'7:55', N'9:02', N'9:30')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (225, 1, 4, 13, 5, 9, N'5:19', N'5:45', N'6:35', N'1:11', N'1:30', N'4:52', N'5:15', N'7:49', N'7:56', N'9:03', N'9:30')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (226, 1, 4, 14, 5, 10, N'5:17', N'5:45', N'6:33', N'1:10', N'1:30', N'4:53', N'5:15', N'7:50', N'7:57', N'9:05', N'9:30')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (227, 1, 4, 15, 5, 11, N'5:15', N'5:45', N'6:32', N'1:10', N'1:30', N'4:53', N'5:15', N'7:51', N'7:58', N'9:06', N'9:30')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (228, 1, 4, 16, 5, 12, N'5:14', N'5:45', N'6:30', N'1:10', N'1:30', N'4:53', N'5:15', N'7:52', N'7:59', N'9:07', N'9:30')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (229, 1, 4, 17, 5, 13, N'5:12', N'5:30', N'6:29', N'1:10', N'1:30', N'4:54', N'5:15', N'7:53', N'8:00', N'9:08', N'9:30')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (230, 1, 4, 18, 5, 14, N'5:10', N'5:30', N'6:27', N'1:09', N'1:30', N'4:54', N'5:15', N'7:54', N'8:01', N'9:09', N'9:30')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (231, 1, 4, 19, 5, 15, N'5:09', N'5:30', N'6:26', N'1:09', N'1:30', N'4:54', N'5:15', N'7:55', N'8:02', N'9:11', N'9:30')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (232, 1, 4, 20, 5, 16, N'5:07', N'5:30', N'6:24', N'1:09', N'1:30', N'4:54', N'5:15', N'7:56', N'8:03', N'9:12', N'9:30')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (233, 1, 4, 21, 5, 17, N'5:05', N'5:30', N'6:23', N'1:09', N'1:30', N'4:54', N'5:15', N'7:57', N'8:04', N'9:13', N'9:30')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (234, 1, 4, 22, 5, 18, N'5:04', N'5:30', N'6:22', N'1:09', N'1:30', N'4:55', N'5:15', N'7:57', N'8:04', N'9:14', N'9:30')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (235, 1, 4, 23, 5, 19, N'5:02', N'5:30', N'6:20', N'1:08', N'1:30', N'4:55', N'5:15', N'7:58', N'8:05', N'9:16', N'9:30')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (236, 1, 4, 24, 5, 20, N'5:00', N'5:30', N'6:19', N'1:08', N'1:30', N'4:55', N'5:15', N'7:58', N'8:05', N'9:17', N'9:45')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (237, 1, 4, 25, 5, 21, N'4:59', N'5:30', N'6:18', N'1:08', N'1:30', N'4:55', N'5:15', N'8:00', N'8:07', N'9:18', N'9:45')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (238, 1, 4, 26, 5, 22, N'4:57', N'5:30', N'6:16', N'1:08', N'1:30', N'4:56', N'5:15', N'8:01', N'8:08', N'9:20', N'9:45')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (239, 1, 4, 27, 5, 23, N'4:56', N'5:30', N'6:15', N'1:08', N'1:30', N'4:56', N'5:15', N'8:02', N'8:09', N'9:21', N'9:45')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (240, 1, 4, 28, 5, 24, N'4:54', N'5:30', N'6:14', N'1:08', N'1:30', N'4:56', N'5:15', N'8:03', N'8:10', N'9:22', N'9:45')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (241, 1, 4, 29, 5, 25, N'4:52', N'5:30', N'6:13', N'1:08', N'1:30', N'4:56', N'5:15', N'8:04', N'8:11', N'9:23', N'9:45')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (242, 1, 4, 30, 5, 26, N'4:51', N'5:30', N'6:11', N'1:07', N'1:30', N'4:57', N'5:15', N'8:05', N'8:12', N'9:25', N'9:45')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (243, 1, 5, 1, 5, 27, N'4:49', N'5:15', N'6:10', N'1:07', N'1:30', N'4:57', N'5:15', N'8:06', N'8:13', N'9:26', N'9:45')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (244, 1, 5, 2, 5, 28, N'4:48', N'5:15', N'6:09', N'1:07', N'1:30', N'4:57', N'5:15', N'8:07', N'8:14', N'9:27', N'9:45')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (245, 1, 5, 3, 5, 29, N'4:46', N'5:15', N'6:08', N'1:07', N'1:30', N'4:57', N'5:15', N'8:08', N'8:15', N'9:28', N'9:45')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (246, 1, 5, 4, 5, 30, N'4:45', N'5:15', N'6:07', N'1:07', N'1:30', N'4:57', N'5:15', N'8:09', N'8:16', N'9:30', N'9:45')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (247, 1, 5, 5, 6, 1, N'4:43', N'5:15', N'6:05', N'1:07', N'1:30', N'4:58', N'5:15', N'8:10', N'8:17', N'9:31', N'9:45')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (248, 1, 5, 6, 6, 2, N'4:42', N'5:15', N'6:04', N'1:07', N'1:30', N'4:58', N'5:15', N'8:11', N'8:18', N'9:32', N'9:45')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (249, 1, 5, 7, 6, 3, N'4:41', N'5:15', N'6:03', N'1:07', N'1:30', N'4:58', N'5:15', N'8:12', N'8:19', N'9:34', N'9:45')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (250, 1, 5, 8, 6, 4, N'4:39', N'5:15', N'6:02', N'1:07', N'1:30', N'4:58', N'5:15', N'8:13', N'8:20', N'9:35', N'10:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (251, 1, 5, 9, 6, 5, N'4:38', N'5:15', N'6:01', N'1:07', N'1:30', N'4:58', N'5:15', N'8:14', N'8:21', N'9:36', N'10:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (252, 1, 5, 10, 6, 6, N'4:36', N'5:15', N'5:59', N'1:07', N'1:30', N'4:59', N'5:15', N'8:15', N'8:22', N'9:37', N'10:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (253, 1, 5, 11, 6, 7, N'4:35', N'5:15', N'5:59', N'1:07', N'1:30', N'4:59', N'5:15', N'8:16', N'8:23', N'9:39', N'10:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (254, 1, 5, 12, 6, 8, N'4:34', N'5:15', N'5:58', N'1:07', N'1:30', N'4:59', N'5:15', N'8:17', N'8:24', N'9:40', N'10:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (255, 1, 5, 13, 6, 9, N'4:32', N'5:15', N'5:57', N'1:07', N'1:30', N'4:59', N'5:15', N'8:18', N'8:25', N'9:41', N'10:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (256, 1, 5, 14, 6, 10, N'4:31', N'5:15', N'5:56', N'1:07', N'1:30', N'5:00', N'5:15', N'8:19', N'8:26', N'9:42', N'10:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (257, 1, 5, 15, 6, 11, N'4:30', N'5:15', N'5:55', N'1:07', N'1:30', N'5:00', N'5:15', N'8:19', N'8:26', N'9:44', N'10:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (258, 1, 5, 16, 6, 12, N'4:29', N'5:15', N'5:54', N'1:07', N'1:30', N'5:00', N'5:15', N'8:20', N'8:27', N'9:45', N'10:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (259, 1, 5, 17, 6, 13, N'4:28', N'5:15', N'5:54', N'1:07', N'1:30', N'5:00', N'5:15', N'8:21', N'8:28', N'9:46', N'10:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (260, 1, 5, 18, 6, 14, N'4:26', N'5:15', N'5:53', N'1:07', N'1:30', N'5:00', N'5:15', N'8:21', N'8:28', N'9:47', N'10:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (261, 1, 5, 19, 6, 15, N'4:25', N'5:15', N'5:52', N'1:07', N'1:30', N'5:01', N'5:15', N'8:23', N'8:30', N'9:49', N'10:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (262, 1, 5, 20, 6, 16, N'4:24', N'5:15', N'5:51', N'1:07', N'1:30', N'5:01', N'5:15', N'8:24', N'8:31', N'9:50', N'10:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (263, 1, 5, 21, 6, 17, N'4:23', N'5:15', N'5:50', N'1:07', N'1:30', N'5:01', N'5:15', N'8:25', N'8:32', N'9:51', N'10:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (264, 1, 5, 22, 6, 18, N'4:22', N'5:00', N'5:50', N'1:07', N'1:30', N'5:01', N'5:15', N'8:26', N'8:33', N'9:52', N'10:15')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (265, 1, 5, 23, 6, 19, N'4:21', N'5:00', N'5:49', N'1:07', N'1:30', N'5:02', N'5:15', N'8:26', N'8:33', N'9:53', N'10:15')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (266, 1, 5, 24, 6, 20, N'4:20', N'5:00', N'5:48', N'1:07', N'1:30', N'5:02', N'5:15', N'8:27', N'8:34', N'9:54', N'10:15')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (267, 1, 5, 25, 6, 21, N'4:19', N'5:00', N'5:48', N'1:07', N'1:30', N'5:02', N'5:15', N'8:28', N'8:35', N'9:56', N'10:15')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (268, 1, 5, 26, 6, 22, N'4:18', N'5:00', N'5:47', N'1:07', N'1:30', N'5:02', N'5:15', N'8:29', N'8:36', N'9:57', N'10:15')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (269, 1, 5, 27, 6, 23, N'4:18', N'5:00', N'5:47', N'1:07', N'1:30', N'5:03', N'5:15', N'8:30', N'8:37', N'9:58', N'10:15')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (270, 1, 5, 28, 6, 24, N'4:17', N'5:00', N'5:46', N'1:08', N'1:30', N'5:03', N'5:15', N'8:30', N'8:37', N'9:59', N'10:15')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (271, 1, 5, 29, 6, 25, N'4:16', N'5:00', N'5:45', N'1:08', N'1:30', N'5:03', N'5:15', N'8:31', N'8:38', N'10:00', N'10:15')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (272, 1, 5, 30, 6, 26, N'4:15', N'5:00', N'5:45', N'1:08', N'1:30', N'5:03', N'5:15', N'8:32', N'8:39', N'10:01', N'10:15')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (273, 1, 5, 31, 6, 27, N'4:15', N'5:00', N'5:45', N'1:08', N'1:30', N'5:04', N'5:15', N'8:33', N'8:40', N'10:02', N'10:15')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (274, 1, 10, 1, 11, 3, N'5:54', N'6:15', N'7:03', N'1:00', N'1:30', N'4:19', N'5:00', N'6:57', N'7:04', N'8:05', N'8:30')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (275, 1, 10, 2, 11, 4, N'5:55', N'6:15', N'7:04', N'12:59', N'1:30', N'4:17', N'4:30', N'6:55', N'7:02', N'8:04', N'8:30')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (276, 1, 10, 3, 11, 5, N'5:56', N'6:15', N'7:05', N'12:59', N'1:30', N'4:16', N'4:30', N'6:54', N'7:01', N'8:02', N'8:30')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (277, 1, 10, 4, 11, 6, N'5:56', N'6:15', N'7:06', N'12:59', N'1:30', N'4:15', N'4:30', N'6:52', N'6:59', N'8:01', N'8:30')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (278, 1, 10, 5, 11, 7, N'5:57', N'6:15', N'7:07', N'12:59', N'1:30', N'4:14', N'4:30', N'6:51', N'6:58', N'7:59', N'8:30')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (279, 1, 10, 6, 11, 8, N'5:58', N'6:15', N'7:08', N'12:58', N'1:30', N'4:13', N'4:30', N'6:49', N'6:56', N'7:58', N'8:30')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (280, 1, 10, 7, 11, 9, N'5:59', N'6:15', N'7:09', N'12:58', N'1:30', N'4:12', N'4:30', N'6:47', N'6:54', N'7:56', N'8:30')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (281, 1, 10, 8, 11, 10, N'6:00', N'6:15', N'7:10', N'12:58', N'1:30', N'4:11', N'4:30', N'6:46', N'6:53', N'7:55', N'8:30')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (282, 1, 10, 9, 11, 11, N'6:01', N'6:30', N'7:11', N'12:57', N'1:30', N'4:10', N'4:30', N'6:44', N'6:51', N'7:53', N'8:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (283, 1, 10, 10, 11, 12, N'6:02', N'6:30', N'7:12', N'12:57', N'1:30', N'4:08', N'4:30', N'6:43', N'6:50', N'7:52', N'8:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (284, 1, 10, 11, 11, 13, N'6:03', N'6:30', N'7:13', N'12:57', N'1:30', N'4:07', N'4:30', N'6:41', N'6:48', N'7:50', N'8:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (285, 1, 10, 12, 11, 14, N'6:04', N'6:30', N'7:14', N'12:57', N'1:30', N'4:06', N'4:30', N'6:40', N'6:47', N'7:49', N'8:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (286, 1, 10, 13, 11, 15, N'6:05', N'6:30', N'7:15', N'12:56', N'1:30', N'4:05', N'4:30', N'6:38', N'6:45', N'7:47', N'8:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (287, 1, 10, 14, 11, 16, N'6:06', N'6:30', N'7:16', N'12:56', N'1:30', N'4:04', N'4:30', N'6:37', N'6:44', N'7:46', N'8:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (288, 1, 10, 15, 11, 17, N'6:07', N'6:30', N'7:17', N'12:56', N'1:30', N'4:03', N'4:30', N'6:36', N'6:43', N'7:44', N'8:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (289, 1, 10, 16, 11, 18, N'6:08', N'6:30', N'7:18', N'12:56', N'1:30', N'4:02', N'4:30', N'6:34', N'6:41', N'7:43', N'8:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (290, 1, 10, 17, 11, 19, N'6:09', N'6:30', N'7:19', N'12:56', N'1:30', N'4:01', N'4:30', N'6:33', N'6:40', N'7:42', N'8:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (291, 1, 10, 18, 11, 20, N'6:10', N'6:30', N'7:20', N'12:55', N'1:30', N'4:00', N'4:30', N'6:31', N'6:38', N'7:40', N'8:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (292, 1, 10, 19, 11, 21, N'6:11', N'6:30', N'7:21', N'12:55', N'1:30', N'3:59', N'4:30', N'6:30', N'6:37', N'7:39', N'8:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (293, 1, 10, 20, 11, 22, N'6:12', N'6:30', N'7:22', N'12:55', N'1:30', N'3:57', N'4:30', N'6:28', N'6:35', N'7:38', N'8:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (294, 1, 10, 21, 11, 23, N'6:13', N'6:30', N'7:23', N'12:55', N'1:30', N'3:56', N'4:30', N'6:27', N'6:34', N'7:36', N'8:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (295, 1, 10, 22, 11, 24, N'6:14', N'6:30', N'7:24', N'12:55', N'1:30', N'3:55', N'4:30', N'6:26', N'6:33', N'7:35', N'8:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (296, 1, 10, 23, 11, 25, N'6:15', N'6:30', N'7:25', N'12:55', N'1:30', N'3:54', N'4:15', N'6:24', N'6:31', N'7:34', N'8:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (297, 1, 10, 24, 11, 26, N'6:16', N'6:30', N'7:26', N'12:54', N'1:30', N'3:53', N'4:15', N'6:23', N'6:30', N'7:33', N'8:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (298, 1, 10, 25, 11, 27, N'6:16', N'6:30', N'7:27', N'12:54', N'1:30', N'3:52', N'4:15', N'6:22', N'6:29', N'7:32', N'8:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (299, 1, 10, 26, 11, 28, N'6:17', N'6:30', N'7:28', N'12:54', N'1:30', N'3:51', N'4:15', N'6:21', N'6:28', N'7:30', N'8:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (300, 1, 10, 27, 11, 29, N'6:18', N'6:30', N'7:29', N'12:54', N'1:30', N'3:50', N'4:15', N'6:19', N'6:26', N'7:29', N'8:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (301, 1, 10, 28, 11, 30, N'6:19', N'6:30', N'7:30', N'12:54', N'1:30', N'3:49', N'4:15', N'6:18', N'6:25', N'7:28', N'8:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (302, 1, 10, 29, 12, 1, N'6:20', N'6:30', N'7:32', N'12:54', N'1:30', N'3:48', N'4:15', N'6:17', N'6:24', N'7:27', N'8:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (303, 1, 10, 30, 12, 2, N'6:21', N'6:45', N'7:33', N'12:54', N'1:30', N'3:47', N'4:15', N'6:16', N'6:23', N'7:26', N'8:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (304, 1, 10, 31, 12, 3, N'6:22', N'6:45', N'7:34', N'12:54', N'1:30', N'3:47', N'4:15', N'6:14', N'6:21', N'7:25', N'8:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (305, 1, 11, 1, 12, 4, N'6:23', N'6:45', N'7:35', N'12:54', N'1:30', N'3:46', N'4:15', N'6:13', N'6:20', N'7:24', N'8:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (306, 1, 11, 2, 12, 5, N'6:24', N'6:45', N'7:36', N'12:54', N'1:30', N'3:45', N'4:15', N'6:12', N'6:19', N'7:23', N'8:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (307, 1, 11, 3, 12, 6, N'6:25', N'6:45', N'7:37', N'12:54', N'1:30', N'3:44', N'4:15', N'6:11', N'6:18', N'7:22', N'8:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (308, 1, 11, 4, 12, 7, N'6:26', N'6:45', N'7:38', N'12:54', N'1:30', N'3:43', N'4:15', N'6:10', N'6:17', N'7:21', N'8:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (309, 1, 11, 5, 12, 8, N'6:27', N'6:45', N'7:39', N'12:54', N'1:30', N'3:42', N'4:15', N'6:09', N'6:16', N'7:20', N'8:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (310, 1, 11, 6, 12, 9, N'5:28', N'6:00', N'7:40', N'11:54', N'12:45', N'2:41', N'3:30', N'5:07', N'5:14', N'6:19', N'8:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (311, 1, 11, 7, 12, 10, N'5:29', N'6:00', N'6:41', N'11:54', N'1:00', N'2:41', N'3:30', N'5:07', N'5:14', N'6:19', N'8:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (312, 1, 11, 8, 12, 11, N'5:30', N'6:00', N'6:43', N'11:54', N'1:00', N'2:40', N'3:30', N'5:06', N'5:13', N'6:17', N'8:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (313, 1, 11, 9, 12, 12, N'5:31', N'6:00', N'6:44', N'11:54', N'1:00', N'2:39', N'3:30', N'5:05', N'5:12', N'6:17', N'8:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (314, 1, 11, 10, 12, 13, N'5:32', N'6:00', N'6:45', N'11:54', N'1:00', N'2:38', N'3:30', N'5:04', N'5:11', N'6:16', N'8:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (315, 1, 11, 11, 12, 14, N'5:33', N'6:00', N'6:46', N'11:54', N'1:00', N'2:38', N'3:30', N'5:03', N'5:10', N'6:15', N'8:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (316, 1, 11, 12, 12, 15, N'5:34', N'6:00', N'6:47', N'11:54', N'1:00', N'2:37', N'3:30', N'5:02', N'5:09', N'6:14', N'8:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (317, 1, 11, 13, 12, 16, N'5:35', N'6:00', N'6:48', N'11:55', N'12:45', N'2:36', N'3:30', N'5:01', N'5:08', N'6:14', N'8:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (318, 1, 11, 14, 12, 17, N'5:36', N'6:00', N'6:49', N'11:55', N'1:00', N'2:36', N'3:30', N'5:01', N'5:08', N'6:14', N'8:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (319, 1, 11, 15, 12, 18, N'5:37', N'6:00', N'6:50', N'11:55', N'1:00', N'2:36', N'3:30', N'5:00', N'5:07', N'6:13', N'8:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (320, 1, 11, 16, 12, 19, N'5:38', N'6:00', N'6:51', N'11:55', N'1:00', N'2:35', N'3:30', N'4:59', N'5:06', N'6:12', N'8:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (321, 1, 11, 17, 12, 20, N'5:39', N'6:00', N'6:53', N'11:55', N'1:00', N'2:34', N'3:30', N'4:58', N'5:05', N'6:11', N'8:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (322, 1, 11, 18, 12, 21, N'5:40', N'6:00', N'6:54', N'11:55', N'1:00', N'2:34', N'3:30', N'4:58', N'5:05', N'6:11', N'8:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (323, 1, 11, 19, 12, 22, N'5:41', N'6:00', N'6:55', N'11:56', N'1:00', N'2:33', N'3:30', N'4:57', N'5:04', N'6:10', N'8:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (324, 1, 11, 20, 12, 23, N'5:42', N'6:15', N'6:56', N'11:56', N'12:45', N'2:33', N'3:30', N'4:56', N'5:03', N'6:10', N'8:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (325, 1, 11, 21, 12, 24, N'5:43', N'6:15', N'6:57', N'11:56', N'1:00', N'2:33', N'3:30', N'4:56', N'5:03', N'6:10', N'8:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (326, 1, 11, 22, 12, 25, N'5:43', N'6:15', N'6:59', N'11:56', N'1:00', N'2:32', N'3:30', N'4:55', N'5:02', N'6:09', N'8:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (327, 1, 11, 23, 12, 26, N'5:44', N'6:15', N'6:59', N'11:57', N'1:00', N'2:31', N'3:30', N'4:55', N'5:02', N'6:09', N'8:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (328, 1, 11, 24, 12, 27, N'5:45', N'6:15', N'7:00', N'11:57', N'1:00', N'2:31', N'3:30', N'4:54', N'5:01', N'6:08', N'8:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (329, 1, 11, 25, 12, 28, N'5:46', N'6:15', N'7:01', N'11:57', N'1:00', N'2:31', N'3:30', N'4:54', N'5:01', N'6:08', N'8:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (330, 1, 11, 26, 12, 29, N'5:47', N'6:15', N'7:02', N'11:58', N'1:00', N'2:30', N'3:30', N'4:53', N'5:00', N'6:08', N'8:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (331, 1, 11, 27, 1, 1, N'5:48', N'6:15', N'7:03', N'11:58', N'12:45', N'2:30', N'3:30', N'4:53', N'5:00', N'6:07', N'8:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (332, 1, 11, 28, 1, 2, N'5:49', N'6:15', N'7:04', N'11:58', N'1:00', N'2:30', N'3:30', N'4:53', N'5:00', N'6:07', N'8:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (333, 1, 11, 29, 1, 3, N'5:50', N'6:15', N'7:05', N'11:58', N'1:00', N'2:30', N'3:30', N'4:52', N'4:59', N'6:07', N'8:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (334, 1, 11, 30, 1, 4, N'5:51', N'6:15', N'7:06', N'11:59', N'1:00', N'2:30', N'3:30', N'4:52', N'4:59', N'6:07', N'8:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (335, 1, 12, 1, 1, 5, N'5:52', N'6:15', N'7:07', N'11:59', N'1:00', N'2:29', N'3:30', N'4:52', N'4:59', N'6:07', N'8:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (336, 1, 12, 2, 1, 6, N'5:52', N'6:15', N'7:08', N'12:00', N'1:00', N'2:29', N'3:30', N'4:52', N'4:59', N'6:07', N'8:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (337, 1, 12, 3, 1, 7, N'5:53', N'6:15', N'7:09', N'12:00', N'1:00', N'2:29', N'3:30', N'4:51', N'4:58', N'6:07', N'8:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (338, 1, 12, 4, 1, 8, N'5:54', N'6:15', N'7:10', N'12:01', N'12:45', N'2:29', N'3:30', N'4:51', N'4:58', N'6:07', N'8:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (339, 1, 12, 5, 1, 9, N'5:55', N'6:15', N'7:11', N'12:01', N'1:00', N'2:29', N'3:30', N'4:51', N'4:58', N'6:07', N'8:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (340, 1, 12, 6, 1, 10, N'5:56', N'6:15', N'7:12', N'12:01', N'1:00', N'2:29', N'3:30', N'4:51', N'4:58', N'6:07', N'8:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (341, 1, 12, 7, 1, 11, N'5:56', N'6:15', N'7:13', N'12:01', N'1:00', N'2:29', N'3:30', N'4:51', N'4:58', N'6:07', N'8:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (342, 1, 12, 8, 1, 12, N'5:57', N'6:15', N'7:14', N'12:02', N'1:00', N'2:29', N'3:30', N'4:51', N'4:58', N'6:07', N'8:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (343, 1, 12, 9, 1, 13, N'5:58', N'6:15', N'7:15', N'12:03', N'1:00', N'2:30', N'3:30', N'4:51', N'4:58', N'6:07', N'8:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (344, 1, 12, 10, 1, 14, N'5:59', N'6:15', N'7:15', N'12:03', N'1:00', N'2:30', N'3:30', N'4:51', N'4:58', N'6:07', N'8:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (345, 1, 12, 11, 1, 15, N'5:59', N'6:30', N'7:16', N'12:04', N'12:45', N'2:30', N'3:30', N'4:51', N'4:58', N'6:07', N'8:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (346, 1, 12, 12, 1, 16, N'6:00', N'6:30', N'7:17', N'12:04', N'1:00', N'2:30', N'3:30', N'4:52', N'4:59', N'6:08', N'8:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (347, 1, 12, 13, 1, 17, N'6:01', N'6:30', N'7:18', N'12:05', N'1:00', N'2:30', N'3:30', N'4:52', N'4:59', N'6:08', N'8:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (348, 1, 12, 14, 1, 18, N'6:01', N'6:30', N'7:18', N'12:05', N'1:00', N'2:30', N'3:30', N'4:52', N'4:59', N'6:08', N'8:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (349, 1, 12, 15, 1, 19, N'6:02', N'6:30', N'7:19', N'12:06', N'1:00', N'2:31', N'3:30', N'4:52', N'4:59', N'6:09', N'8:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (350, 1, 12, 16, 1, 20, N'6:03', N'6:30', N'7:20', N'12:06', N'1:00', N'2:31', N'3:30', N'4:53', N'5:00', N'6:09', N'8:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (351, 1, 12, 17, 1, 21, N'6:03', N'6:30', N'7:21', N'12:07', N'1:00', N'2:32', N'3:30', N'4:53', N'5:00', N'6:09', N'8:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (352, 1, 12, 18, 1, 22, N'6:04', N'6:30', N'7:21', N'12:07', N'12:45', N'2:31', N'3:30', N'4:53', N'5:00', N'6:09', N'8:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (353, 1, 12, 19, 1, 23, N'6:04', N'6:30', N'7:22', N'12:08', N'1:00', N'2:32', N'3:30', N'4:54', N'5:01', N'6:10', N'8:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (354, 1, 12, 20, 1, 24, N'6:05', N'6:30', N'7:22', N'12:08', N'1:00', N'2:32', N'3:30', N'4:54', N'5:01', N'6:11', N'8:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (355, 1, 12, 21, 1, 25, N'6:06', N'6:30', N'7:23', N'12:09', N'1:00', N'2:33', N'3:30', N'4:55', N'5:02', N'6:11', N'8:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (356, 1, 12, 22, 1, 26, N'6:06', N'6:30', N'7:23', N'12:09', N'1:00', N'2:33', N'3:30', N'4:55', N'5:02', N'6:12', N'8:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (357, 1, 12, 23, 1, 27, N'6:06', N'6:30', N'7:24', N'12:10', N'1:00', N'2:34', N'3:30', N'4:56', N'5:03', N'6:12', N'8:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (358, 1, 12, 24, 1, 28, N'6:07', N'6:30', N'7:24', N'12:10', N'1:00', N'2:34', N'3:30', N'4:57', N'5:04', N'6:13', N'8:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (359, 1, 12, 25, 1, 29, N'6:07', N'6:30', N'7:25', N'12:11', N'12:45', N'2:35', N'3:30', N'4:57', N'5:04', N'6:13', N'8:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (360, 1, 12, 26, 1, 30, N'6:08', N'6:30', N'7:25', N'12:11', N'1:00', N'2:35', N'3:30', N'4:57', N'5:04', N'6:13', N'8:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (361, 1, 12, 27, 2, 1, N'6:08', N'6:30', N'7:25', N'12:12', N'1:00', N'2:36', N'3:30', N'4:58', N'5:05', N'6:15', N'8:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (362, 1, 12, 28, 2, 2, N'6:08', N'6:30', N'7:26', N'12:12', N'1:00', N'2:37', N'3:30', N'4:59', N'5:06', N'6:15', N'8:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (363, 1, 12, 29, 2, 3, N'6:09', N'6:30', N'7:26', N'12:13', N'1:00', N'2:37', N'3:30', N'5:00', N'5:07', N'6:16', N'8:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (364, 1, 12, 30, 2, 4, N'6:09', N'6:30', N'7:26', N'12:13', N'1:00', N'2:38', N'3:30', N'5:00', N'5:07', N'6:17', N'8:00')
INSERT INTO [DailyPrayers].[PrayerTimes] ([PrayerID], [LocationID], [Month], [Day], [IMonth], [IDay], [Fajr], [FajrIqama], [Sunrise], [Duhr], [DuhrIqama], [Asr], [AsrIqama], [Maghrib], [MaghribIqama], [Isha], [IshaIqama]) VALUES (365, 1, 12, 31, 2, 5, N'6:09', N'6:30', N'7:26', N'12:14', N'1:00', N'2:39', N'3:30', N'5:01', N'5:08', N'6:18', N'8:00')
SET IDENTITY_INSERT [DailyPrayers].[PrayerTimes] OFF
SET IDENTITY_INSERT [Donations].[Buckets] ON
INSERT INTO [Donations].[Buckets] ([BucketID], [Name], [IsDefault], [AllowRecurring]) VALUES (1, N'ADAMS', 1, 1)
INSERT INTO [Donations].[Buckets] ([BucketID], [Name], [IsDefault], [AllowRecurring]) VALUES (2, N'New Masjid Construction', 0, 1)
INSERT INTO [Donations].[Buckets] ([BucketID], [Name], [IsDefault], [AllowRecurring]) VALUES (3, N'Zakat', 0, 1)
INSERT INTO [Donations].[Buckets] ([BucketID], [Name], [IsDefault], [AllowRecurring]) VALUES (4, N'Sadaqa', 0, 1)
INSERT INTO [Donations].[Buckets] ([BucketID], [Name], [IsDefault], [AllowRecurring]) VALUES (5, N'Hifz Program', 0, 1)
INSERT INTO [Donations].[Buckets] ([BucketID], [Name], [IsDefault], [AllowRecurring]) VALUES (6, N'Taleem Ul Quran', 0, 1)
INSERT INTO [Donations].[Buckets] ([BucketID], [Name], [IsDefault], [AllowRecurring]) VALUES (7, N'Zakat ul Fitr', 0, 0)
SET IDENTITY_INSERT [Donations].[Buckets] OFF
SET IDENTITY_INSERT [Events].[Occurances] ON
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (525, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20110802 19:00:00.000', '20110802 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (526, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20110809 19:00:00.000', '20110809 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (527, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20110816 19:00:00.000', '20110816 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (528, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20110823 19:00:00.000', '20110823 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (529, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20110830 19:00:00.000', '20110830 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (530, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20110906 19:00:00.000', '20110906 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (531, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20110913 19:00:00.000', '20110913 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (532, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20110920 19:00:00.000', '20110920 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (533, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20110927 19:00:00.000', '20110927 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (534, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20111004 19:00:00.000', '20111004 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (535, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20111011 19:00:00.000', '20111011 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (536, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20111018 19:00:00.000', '20111018 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (537, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20111025 19:00:00.000', '20111025 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (538, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20111101 19:00:00.000', '20111101 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (539, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20111108 19:00:00.000', '20111108 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (540, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20111115 19:00:00.000', '20111115 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (541, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20111122 19:00:00.000', '20111122 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (542, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20111129 19:00:00.000', '20111129 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (543, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20111206 19:00:00.000', '20111206 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (544, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20111213 19:00:00.000', '20111213 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (545, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20111220 19:00:00.000', '20111220 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (546, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20111227 19:00:00.000', '20111227 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (547, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20120103 19:00:00.000', '20120103 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (548, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20120110 19:00:00.000', '20120110 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (549, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20120117 19:00:00.000', '20120117 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (550, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20120124 19:00:00.000', '20120124 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (551, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20120131 19:00:00.000', '20120131 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (552, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20120207 19:00:00.000', '20120207 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (553, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20120214 19:00:00.000', '20120214 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (554, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20120221 19:00:00.000', '20120221 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (555, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20120228 19:00:00.000', '20120228 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (556, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20120306 19:00:00.000', '20120306 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (557, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20120313 19:00:00.000', '20120313 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (558, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20120320 19:00:00.000', '20120320 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (559, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20120327 19:00:00.000', '20120327 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (560, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20120403 19:00:00.000', '20120403 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (561, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20120410 19:00:00.000', '20120410 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (562, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20120417 19:00:00.000', '20120417 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (563, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20120424 19:00:00.000', '20120424 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (564, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20120501 19:00:00.000', '20120501 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (565, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20120508 19:00:00.000', '20120508 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (566, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20120515 19:00:00.000', '20120515 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (567, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20120522 19:00:00.000', '20120522 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (568, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20120529 19:00:00.000', '20120529 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (569, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20120605 19:00:00.000', '20120605 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (570, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20120612 19:00:00.000', '20120612 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (571, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20120619 19:00:00.000', '20120619 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (572, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20120626 19:00:00.000', '20120626 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (573, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20120703 19:00:00.000', '20120703 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (574, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20120710 19:00:00.000', '20120710 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (575, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20120717 19:00:00.000', '20120717 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (576, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20120724 19:00:00.000', '20120724 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (577, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20120731 19:00:00.000', '20120731 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (578, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20120807 19:00:00.000', '20120807 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (579, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20120814 19:00:00.000', '20120814 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (580, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20120821 19:00:00.000', '20120821 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (581, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20120828 19:00:00.000', '20120828 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (582, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20120904 19:00:00.000', '20120904 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (583, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20120911 19:00:00.000', '20120911 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (584, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20120918 19:00:00.000', '20120918 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (585, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20120925 19:00:00.000', '20120925 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (586, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20121002 19:00:00.000', '20121002 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (587, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20121009 19:00:00.000', '20121009 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (588, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20121016 19:00:00.000', '20121016 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (589, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20121023 19:00:00.000', '20121023 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (590, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20121030 19:00:00.000', '20121030 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (591, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20121106 19:00:00.000', '20121106 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (592, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20121113 19:00:00.000', '20121113 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (593, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20121120 19:00:00.000', '20121120 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (594, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20121127 19:00:00.000', '20121127 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (595, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20121204 19:00:00.000', '20121204 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (596, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20121211 19:00:00.000', '20121211 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (597, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20121218 19:00:00.000', '20121218 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (598, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20121225 19:00:00.000', '20121225 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (599, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20130101 19:00:00.000', '20130101 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (600, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20130108 19:00:00.000', '20130108 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (601, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20130115 19:00:00.000', '20130115 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (602, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20130122 19:00:00.000', '20130122 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (603, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20130129 19:00:00.000', '20130129 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (604, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20130205 19:00:00.000', '20130205 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (605, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20130212 19:00:00.000', '20130212 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (606, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20130219 19:00:00.000', '20130219 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (607, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20130226 19:00:00.000', '20130226 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (608, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20130305 19:00:00.000', '20130305 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (609, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20130312 19:00:00.000', '20130312 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (610, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20130319 19:00:00.000', '20130319 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (611, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20130326 19:00:00.000', '20130326 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (612, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20130402 19:00:00.000', '20130402 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (613, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20130409 19:00:00.000', '20130409 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (614, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20130416 19:00:00.000', '20130416 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (615, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20130423 19:00:00.000', '20130423 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (616, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20130430 19:00:00.000', '20130430 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (617, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20130507 19:00:00.000', '20130507 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (618, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20130514 19:00:00.000', '20130514 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (619, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20130521 19:00:00.000', '20130521 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (620, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20130528 19:00:00.000', '20130528 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (621, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20130604 19:00:00.000', '20130604 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (622, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20130611 19:00:00.000', '20130611 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (623, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20130618 19:00:00.000', '20130618 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (624, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20130625 19:00:00.000', '20130625 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (625, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20130702 19:00:00.000', '20130702 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (626, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20130709 19:00:00.000', '20130709 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (627, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20130716 19:00:00.000', '20130716 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (628, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20130723 19:00:00.000', '20130723 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (629, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20130730 19:00:00.000', '20130730 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (630, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20130806 19:00:00.000', '20130806 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (631, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20130813 19:00:00.000', '20130813 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (632, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20130820 19:00:00.000', '20130820 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (633, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20130827 19:00:00.000', '20130827 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (634, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20130903 19:00:00.000', '20130903 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (635, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20130910 19:00:00.000', '20130910 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (636, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20130917 19:00:00.000', '20130917 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (637, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20130924 19:00:00.000', '20130924 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (638, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20131001 19:00:00.000', '20131001 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (639, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20131008 19:00:00.000', '20131008 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (640, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20131015 19:00:00.000', '20131015 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (641, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20131022 19:00:00.000', '20131022 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (642, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20131029 19:00:00.000', '20131029 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (643, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20131105 19:00:00.000', '20131105 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (644, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20131112 19:00:00.000', '20131112 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (645, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20131119 19:00:00.000', '20131119 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (646, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20131126 19:00:00.000', '20131126 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (647, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20131203 19:00:00.000', '20131203 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (648, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20131210 19:00:00.000', '20131210 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (649, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20131217 19:00:00.000', '20131217 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (650, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20131224 19:00:00.000', '20131224 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (651, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20131231 19:00:00.000', '20131231 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (652, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20140107 19:00:00.000', '20140107 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (653, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20140114 19:00:00.000', '20140114 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (654, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20140121 19:00:00.000', '20140121 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (655, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20140128 19:00:00.000', '20140128 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (656, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20140204 19:00:00.000', '20140204 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (657, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20140211 19:00:00.000', '20140211 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (658, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20140218 19:00:00.000', '20140218 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (659, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20140225 19:00:00.000', '20140225 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (660, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20140304 19:00:00.000', '20140304 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (661, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20140311 19:00:00.000', '20140311 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (662, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20140318 19:00:00.000', '20140318 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (663, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20140325 19:00:00.000', '20140325 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (664, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20140401 19:00:00.000', '20140401 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (665, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20140408 19:00:00.000', '20140408 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (666, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20140415 19:00:00.000', '20140415 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (667, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20140422 19:00:00.000', '20140422 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (668, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20140429 19:00:00.000', '20140429 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (669, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20140506 19:00:00.000', '20140506 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (670, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20140513 19:00:00.000', '20140513 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (671, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20140520 19:00:00.000', '20140520 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (672, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20140527 19:00:00.000', '20140527 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (673, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20140603 19:00:00.000', '20140603 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (674, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20140610 19:00:00.000', '20140610 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (675, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20140617 19:00:00.000', '20140617 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (676, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20140624 19:00:00.000', '20140624 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (677, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20140701 19:00:00.000', '20140701 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (678, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20140708 19:00:00.000', '20140708 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (679, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20140715 19:00:00.000', '20140715 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (680, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20140722 19:00:00.000', '20140722 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (681, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20140729 19:00:00.000', '20140729 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (682, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20140805 19:00:00.000', '20140805 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (683, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20140812 19:00:00.000', '20140812 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (684, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20140819 19:00:00.000', '20140819 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (685, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20140826 19:00:00.000', '20140826 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (686, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20140902 19:00:00.000', '20140902 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (687, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20140909 19:00:00.000', '20140909 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (688, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20140916 19:00:00.000', '20140916 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (689, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20140923 19:00:00.000', '20140923 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (690, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20140930 19:00:00.000', '20140930 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (691, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20141007 19:00:00.000', '20141007 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (692, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20141014 19:00:00.000', '20141014 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (693, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20141021 19:00:00.000', '20141021 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (694, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20141028 19:00:00.000', '20141028 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (695, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20141104 19:00:00.000', '20141104 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (696, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20141111 19:00:00.000', '20141111 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (697, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20141118 19:00:00.000', '20141118 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (698, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20141125 19:00:00.000', '20141125 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (699, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20141202 19:00:00.000', '20141202 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (700, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20141209 19:00:00.000', '20141209 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (701, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20141216 19:00:00.000', '20141216 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (702, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20141223 19:00:00.000', '20141223 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (703, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20141230 19:00:00.000', '20141230 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (704, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20150106 19:00:00.000', '20150106 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (705, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20150113 19:00:00.000', '20150113 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (706, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20150120 19:00:00.000', '20150120 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (707, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20150127 19:00:00.000', '20150127 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (708, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20150203 19:00:00.000', '20150203 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (709, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20150210 19:00:00.000', '20150210 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (710, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20150217 19:00:00.000', '20150217 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (711, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20150224 19:00:00.000', '20150224 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (712, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20150303 19:00:00.000', '20150303 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (713, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20150310 19:00:00.000', '20150310 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (714, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20150317 19:00:00.000', '20150317 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (715, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20150324 19:00:00.000', '20150324 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (716, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20150331 19:00:00.000', '20150331 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (717, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20150407 19:00:00.000', '20150407 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (718, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20150414 19:00:00.000', '20150414 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (719, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20150421 19:00:00.000', '20150421 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (720, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20150428 19:00:00.000', '20150428 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (721, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20150505 19:00:00.000', '20150505 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (722, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20150512 19:00:00.000', '20150512 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (723, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20150519 19:00:00.000', '20150519 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (724, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20150526 19:00:00.000', '20150526 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (725, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20150602 19:00:00.000', '20150602 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (726, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20150609 19:00:00.000', '20150609 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (727, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20150616 19:00:00.000', '20150616 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (728, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20150623 19:00:00.000', '20150623 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (729, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20150630 19:00:00.000', '20150630 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (730, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20150707 19:00:00.000', '20150707 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (731, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20150714 19:00:00.000', '20150714 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (732, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20150721 19:00:00.000', '20150721 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (733, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20150728 19:00:00.000', '20150728 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (734, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20150804 19:00:00.000', '20150804 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (735, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20150811 19:00:00.000', '20150811 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (736, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20150818 19:00:00.000', '20150818 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (737, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20150825 19:00:00.000', '20150825 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (738, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20150901 19:00:00.000', '20150901 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (739, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20150908 19:00:00.000', '20150908 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (740, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20150915 19:00:00.000', '20150915 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (741, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20150922 19:00:00.000', '20150922 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (742, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20150929 19:00:00.000', '20150929 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (743, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20151006 19:00:00.000', '20151006 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (744, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20151013 19:00:00.000', '20151013 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (745, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20151020 19:00:00.000', '20151020 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (746, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20151027 19:00:00.000', '20151027 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (747, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20151103 19:00:00.000', '20151103 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (748, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20151110 19:00:00.000', '20151110 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (749, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20151117 19:00:00.000', '20151117 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (750, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20151124 19:00:00.000', '20151124 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (751, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20151201 19:00:00.000', '20151201 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (752, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20151208 19:00:00.000', '20151208 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (753, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20151215 19:00:00.000', '20151215 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (754, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20151222 19:00:00.000', '20151222 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (755, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20151229 19:00:00.000', '20151229 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (756, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20160105 19:00:00.000', '20160105 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (757, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20160112 19:00:00.000', '20160112 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (758, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20160119 19:00:00.000', '20160119 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (759, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20160126 19:00:00.000', '20160126 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (760, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20160202 19:00:00.000', '20160202 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (761, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20160209 19:00:00.000', '20160209 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (762, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20160216 19:00:00.000', '20160216 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (763, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20160223 19:00:00.000', '20160223 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (764, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20160301 19:00:00.000', '20160301 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (765, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20160308 19:00:00.000', '20160308 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (766, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20160315 19:00:00.000', '20160315 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (767, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20160322 19:00:00.000', '20160322 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (768, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20160329 19:00:00.000', '20160329 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (769, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20160405 19:00:00.000', '20160405 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (770, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20160412 19:00:00.000', '20160412 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (771, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20160419 19:00:00.000', '20160419 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (772, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20160426 19:00:00.000', '20160426 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (773, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20160503 19:00:00.000', '20160503 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (774, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20160510 19:00:00.000', '20160510 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (775, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20160517 19:00:00.000', '20160517 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (776, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20160524 19:00:00.000', '20160524 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (777, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20160531 19:00:00.000', '20160531 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (778, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20160607 19:00:00.000', '20160607 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (779, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20160614 19:00:00.000', '20160614 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (780, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20160621 19:00:00.000', '20160621 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (781, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20160628 19:00:00.000', '20160628 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (782, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20160705 19:00:00.000', '20160705 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (783, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20160712 19:00:00.000', '20160712 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (784, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20160719 19:00:00.000', '20160719 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (785, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20160726 19:00:00.000', '20160726 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (786, 4, N'Everyday Living - The Basics of Fiqh', N'Everyday Living - The Basics of Fiqh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Everyday Living - The Basics of Fiqh</h3>', N'Main Center', '20160802 19:00:00.000', '20160802 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4441, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20110807 19:00:00.000', '20110807 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4442, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20110814 19:00:00.000', '20110814 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4443, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20110821 19:00:00.000', '20110821 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4444, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20110828 19:00:00.000', '20110828 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4445, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20110904 19:00:00.000', '20110904 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4446, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20110911 19:00:00.000', '20110911 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4447, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20110918 19:00:00.000', '20110918 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4448, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20110925 19:00:00.000', '20110925 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4449, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20111002 19:00:00.000', '20111002 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4450, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20111009 19:00:00.000', '20111009 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4451, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20111016 19:00:00.000', '20111016 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4452, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20111023 19:00:00.000', '20111023 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4453, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20111030 19:00:00.000', '20111030 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4454, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20111106 19:00:00.000', '20111106 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4455, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20111113 19:00:00.000', '20111113 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4456, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20111120 19:00:00.000', '20111120 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4457, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20111127 19:00:00.000', '20111127 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4458, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20111204 19:00:00.000', '20111204 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4459, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20111211 19:00:00.000', '20111211 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4460, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20111218 19:00:00.000', '20111218 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4461, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20111225 19:00:00.000', '20111225 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4462, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20120101 19:00:00.000', '20120101 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4463, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20120108 19:00:00.000', '20120108 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4464, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20120115 19:00:00.000', '20120115 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4465, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20120122 19:00:00.000', '20120122 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4466, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20120129 19:00:00.000', '20120129 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4467, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20120205 19:00:00.000', '20120205 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4468, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20120212 19:00:00.000', '20120212 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4469, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20120219 19:00:00.000', '20120219 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4470, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20120226 19:00:00.000', '20120226 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4471, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20120304 19:00:00.000', '20120304 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4472, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20120311 19:00:00.000', '20120311 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4473, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20120318 19:00:00.000', '20120318 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4474, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20120325 19:00:00.000', '20120325 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4475, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20120401 19:00:00.000', '20120401 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4476, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20120408 19:00:00.000', '20120408 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4477, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20120415 19:00:00.000', '20120415 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4478, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20120422 19:00:00.000', '20120422 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4479, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20120429 19:00:00.000', '20120429 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4480, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20120506 19:00:00.000', '20120506 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4481, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20120513 19:00:00.000', '20120513 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4482, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20120520 19:00:00.000', '20120520 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4483, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20120527 19:00:00.000', '20120527 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4484, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20120603 19:00:00.000', '20120603 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4485, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20120610 19:00:00.000', '20120610 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4486, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20120617 19:00:00.000', '20120617 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4487, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20120624 19:00:00.000', '20120624 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4488, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20120701 19:00:00.000', '20120701 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4489, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20120708 19:00:00.000', '20120708 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4490, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20120715 19:00:00.000', '20120715 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4491, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20120722 19:00:00.000', '20120722 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4492, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20120729 19:00:00.000', '20120729 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4493, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20120805 19:00:00.000', '20120805 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4494, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20120812 19:00:00.000', '20120812 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4495, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20120819 19:00:00.000', '20120819 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4496, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20120826 19:00:00.000', '20120826 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4497, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20120902 19:00:00.000', '20120902 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4498, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20120909 19:00:00.000', '20120909 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4499, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20120916 19:00:00.000', '20120916 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4500, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20120923 19:00:00.000', '20120923 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4501, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20120930 19:00:00.000', '20120930 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4502, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20121007 19:00:00.000', '20121007 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4503, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20121014 19:00:00.000', '20121014 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4504, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20121021 19:00:00.000', '20121021 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4505, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20121028 19:00:00.000', '20121028 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4506, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20121104 19:00:00.000', '20121104 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4507, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20121111 19:00:00.000', '20121111 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4508, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20121118 19:00:00.000', '20121118 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4509, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20121125 19:00:00.000', '20121125 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4510, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20121202 19:00:00.000', '20121202 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4511, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20121209 19:00:00.000', '20121209 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4512, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20121216 19:00:00.000', '20121216 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4513, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20121223 19:00:00.000', '20121223 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4514, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20121230 19:00:00.000', '20121230 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4515, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20130106 19:00:00.000', '20130106 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4516, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20130113 19:00:00.000', '20130113 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4517, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20130120 19:00:00.000', '20130120 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4518, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20130127 19:00:00.000', '20130127 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4519, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20130203 19:00:00.000', '20130203 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4520, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20130210 19:00:00.000', '20130210 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4521, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20130217 19:00:00.000', '20130217 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4522, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20130224 19:00:00.000', '20130224 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4523, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20130303 19:00:00.000', '20130303 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4524, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20130310 19:00:00.000', '20130310 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4525, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20130317 19:00:00.000', '20130317 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4526, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20130324 19:00:00.000', '20130324 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4527, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20130331 19:00:00.000', '20130331 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4528, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20130407 19:00:00.000', '20130407 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4529, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20130414 19:00:00.000', '20130414 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4530, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20130421 19:00:00.000', '20130421 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4531, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20130428 19:00:00.000', '20130428 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4532, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20130505 19:00:00.000', '20130505 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4533, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20130512 19:00:00.000', '20130512 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4534, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20130519 19:00:00.000', '20130519 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4535, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20130526 19:00:00.000', '20130526 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4536, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20130602 19:00:00.000', '20130602 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4537, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20130609 19:00:00.000', '20130609 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4538, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20130616 19:00:00.000', '20130616 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4539, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20130623 19:00:00.000', '20130623 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4540, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20130630 19:00:00.000', '20130630 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4541, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20130707 19:00:00.000', '20130707 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4542, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20130714 19:00:00.000', '20130714 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4543, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20130721 19:00:00.000', '20130721 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4544, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20130728 19:00:00.000', '20130728 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4545, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20130804 19:00:00.000', '20130804 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4546, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20130811 19:00:00.000', '20130811 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4547, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20130818 19:00:00.000', '20130818 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4548, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20130825 19:00:00.000', '20130825 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4549, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20130901 19:00:00.000', '20130901 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4550, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20130908 19:00:00.000', '20130908 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4551, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20130915 19:00:00.000', '20130915 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4552, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20130922 19:00:00.000', '20130922 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4553, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20130929 19:00:00.000', '20130929 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4554, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20131006 19:00:00.000', '20131006 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4555, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20131013 19:00:00.000', '20131013 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4556, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20131020 19:00:00.000', '20131020 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4557, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20131027 19:00:00.000', '20131027 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4558, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20131103 19:00:00.000', '20131103 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4559, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20131110 19:00:00.000', '20131110 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4560, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20131117 19:00:00.000', '20131117 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4561, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20131124 19:00:00.000', '20131124 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4562, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20131201 19:00:00.000', '20131201 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4563, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20131208 19:00:00.000', '20131208 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4564, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20131215 19:00:00.000', '20131215 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4565, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20131222 19:00:00.000', '20131222 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4566, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20131229 19:00:00.000', '20131229 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4567, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20140105 19:00:00.000', '20140105 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4568, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20140112 19:00:00.000', '20140112 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4569, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20140119 19:00:00.000', '20140119 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4570, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20140126 19:00:00.000', '20140126 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4571, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20140202 19:00:00.000', '20140202 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4572, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20140209 19:00:00.000', '20140209 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4573, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20140216 19:00:00.000', '20140216 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4574, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20140223 19:00:00.000', '20140223 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4575, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20140302 19:00:00.000', '20140302 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4576, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20140309 19:00:00.000', '20140309 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4577, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20140316 19:00:00.000', '20140316 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4578, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20140323 19:00:00.000', '20140323 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4579, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20140330 19:00:00.000', '20140330 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4580, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20140406 19:00:00.000', '20140406 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4581, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20140413 19:00:00.000', '20140413 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4582, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20140420 19:00:00.000', '20140420 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4583, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20140427 19:00:00.000', '20140427 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4584, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20140504 19:00:00.000', '20140504 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4585, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20140511 19:00:00.000', '20140511 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4586, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20140518 19:00:00.000', '20140518 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4587, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20140525 19:00:00.000', '20140525 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4588, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20140601 19:00:00.000', '20140601 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4589, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20140608 19:00:00.000', '20140608 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4590, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20140615 19:00:00.000', '20140615 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4591, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20140622 19:00:00.000', '20140622 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4592, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20140629 19:00:00.000', '20140629 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4593, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20140706 19:00:00.000', '20140706 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4594, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20140713 19:00:00.000', '20140713 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4595, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20140720 19:00:00.000', '20140720 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4596, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20140727 19:00:00.000', '20140727 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4597, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20140803 19:00:00.000', '20140803 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4598, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20140810 19:00:00.000', '20140810 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4599, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20140817 19:00:00.000', '20140817 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4600, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20140824 19:00:00.000', '20140824 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4601, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20140831 19:00:00.000', '20140831 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4602, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20140907 19:00:00.000', '20140907 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4603, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20140914 19:00:00.000', '20140914 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4604, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20140921 19:00:00.000', '20140921 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4605, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20140928 19:00:00.000', '20140928 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4606, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20141005 19:00:00.000', '20141005 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4607, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20141012 19:00:00.000', '20141012 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4608, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20141019 19:00:00.000', '20141019 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4609, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20141026 19:00:00.000', '20141026 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4610, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20141102 19:00:00.000', '20141102 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4611, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20141109 19:00:00.000', '20141109 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4612, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20141116 19:00:00.000', '20141116 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4613, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20141123 19:00:00.000', '20141123 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4614, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20141130 19:00:00.000', '20141130 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4615, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20141207 19:00:00.000', '20141207 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4616, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20141214 19:00:00.000', '20141214 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4617, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20141221 19:00:00.000', '20141221 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4618, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20141228 19:00:00.000', '20141228 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4619, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20150104 19:00:00.000', '20150104 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4620, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20150111 19:00:00.000', '20150111 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4621, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20150118 19:00:00.000', '20150118 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4622, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20150125 19:00:00.000', '20150125 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4623, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20150201 19:00:00.000', '20150201 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4624, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20150208 19:00:00.000', '20150208 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4625, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20150215 19:00:00.000', '20150215 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4626, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20150222 19:00:00.000', '20150222 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4627, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20150301 19:00:00.000', '20150301 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4628, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20150308 19:00:00.000', '20150308 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4629, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20150315 19:00:00.000', '20150315 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4630, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20150322 19:00:00.000', '20150322 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4631, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20150329 19:00:00.000', '20150329 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4632, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20150405 19:00:00.000', '20150405 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4633, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20150412 19:00:00.000', '20150412 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4634, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20150419 19:00:00.000', '20150419 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4635, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20150426 19:00:00.000', '20150426 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4636, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20150503 19:00:00.000', '20150503 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4637, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20150510 19:00:00.000', '20150510 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4638, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20150517 19:00:00.000', '20150517 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4639, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20150524 19:00:00.000', '20150524 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4640, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20150531 19:00:00.000', '20150531 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4641, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20150607 19:00:00.000', '20150607 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4642, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20150614 19:00:00.000', '20150614 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4643, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20150621 19:00:00.000', '20150621 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4644, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20150628 19:00:00.000', '20150628 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4645, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20150705 19:00:00.000', '20150705 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4646, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20150712 19:00:00.000', '20150712 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4647, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20150719 19:00:00.000', '20150719 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4648, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20150726 19:00:00.000', '20150726 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4649, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20150802 19:00:00.000', '20150802 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4650, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20150809 19:00:00.000', '20150809 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4651, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20150816 19:00:00.000', '20150816 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4652, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20150823 19:00:00.000', '20150823 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4653, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20150830 19:00:00.000', '20150830 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4654, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20150906 19:00:00.000', '20150906 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4655, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20150913 19:00:00.000', '20150913 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4656, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20150920 19:00:00.000', '20150920 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4657, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20150927 19:00:00.000', '20150927 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4658, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20151004 19:00:00.000', '20151004 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4659, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20151011 19:00:00.000', '20151011 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4660, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20151018 19:00:00.000', '20151018 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4661, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20151025 19:00:00.000', '20151025 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4662, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20151101 19:00:00.000', '20151101 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4663, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20151108 19:00:00.000', '20151108 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4664, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20151115 19:00:00.000', '20151115 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4665, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20151122 19:00:00.000', '20151122 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4666, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20151129 19:00:00.000', '20151129 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4667, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20151206 19:00:00.000', '20151206 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4668, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20151213 19:00:00.000', '20151213 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4669, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20151220 19:00:00.000', '20151220 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4670, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20151227 19:00:00.000', '20151227 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4671, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20160103 19:00:00.000', '20160103 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4672, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20160110 19:00:00.000', '20160110 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4673, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20160117 19:00:00.000', '20160117 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4674, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20160124 19:00:00.000', '20160124 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4675, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20160131 19:00:00.000', '20160131 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4676, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20160207 19:00:00.000', '20160207 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4677, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20160214 19:00:00.000', '20160214 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4678, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20160221 19:00:00.000', '20160221 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4679, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20160228 19:00:00.000', '20160228 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4680, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20160306 19:00:00.000', '20160306 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4681, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20160313 19:00:00.000', '20160313 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4682, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20160320 19:00:00.000', '20160320 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4683, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20160327 19:00:00.000', '20160327 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4684, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20160403 19:00:00.000', '20160403 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4685, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20160410 19:00:00.000', '20160410 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4686, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20160417 19:00:00.000', '20160417 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4687, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20160424 19:00:00.000', '20160424 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4688, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20160501 19:00:00.000', '20160501 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4689, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20160508 19:00:00.000', '20160508 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4690, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20160515 19:00:00.000', '20160515 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4691, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20160522 19:00:00.000', '20160522 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4692, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20160529 19:00:00.000', '20160529 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4693, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20160605 19:00:00.000', '20160605 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4694, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20160612 19:00:00.000', '20160612 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4695, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20160619 19:00:00.000', '20160619 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4696, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20160626 19:00:00.000', '20160626 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4697, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20160703 19:00:00.000', '20160703 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4698, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20160710 19:00:00.000', '20160710 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4699, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20160717 19:00:00.000', '20160717 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4700, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20160724 19:00:00.000', '20160724 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4701, 15, N'Words of Wisdom - Hadith Studies', N'Words of Wisdom - Hadith Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Words of Wisdom - Hadith Studies</h3>', N'Main Center', '20160731 19:00:00.000', '20160731 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4963, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20110808 19:00:00.000', '20110808 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4964, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20110815 19:00:00.000', '20110815 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4965, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20110822 19:00:00.000', '20110822 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4966, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20110829 19:00:00.000', '20110829 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4967, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20110905 19:00:00.000', '20110905 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4968, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20110912 19:00:00.000', '20110912 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4969, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20110919 19:00:00.000', '20110919 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4970, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20110926 19:00:00.000', '20110926 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4971, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20111003 19:00:00.000', '20111003 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4972, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20111010 19:00:00.000', '20111010 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4973, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20111017 19:00:00.000', '20111017 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4974, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20111024 19:00:00.000', '20111024 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4975, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20111031 19:00:00.000', '20111031 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4976, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20111107 19:00:00.000', '20111107 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4977, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20111114 19:00:00.000', '20111114 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4978, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20111121 19:00:00.000', '20111121 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4979, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20111128 19:00:00.000', '20111128 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4980, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20111205 19:00:00.000', '20111205 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4981, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20111212 19:00:00.000', '20111212 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4982, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20111219 19:00:00.000', '20111219 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4983, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20111226 19:00:00.000', '20111226 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4984, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20120102 19:00:00.000', '20120102 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4985, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20120109 19:00:00.000', '20120109 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4986, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20120116 19:00:00.000', '20120116 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4987, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20120123 19:00:00.000', '20120123 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4988, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20120130 19:00:00.000', '20120130 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4989, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20120206 19:00:00.000', '20120206 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4990, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20120213 19:00:00.000', '20120213 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4991, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20120220 19:00:00.000', '20120220 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4992, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20120227 19:00:00.000', '20120227 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4993, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20120305 19:00:00.000', '20120305 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4994, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20120312 19:00:00.000', '20120312 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4995, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20120319 19:00:00.000', '20120319 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4996, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20120326 19:00:00.000', '20120326 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4997, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20120402 19:00:00.000', '20120402 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4998, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20120409 19:00:00.000', '20120409 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (4999, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20120416 19:00:00.000', '20120416 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5000, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20120423 19:00:00.000', '20120423 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5001, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20120430 19:00:00.000', '20120430 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5002, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20120507 19:00:00.000', '20120507 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5003, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20120514 19:00:00.000', '20120514 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5004, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20120521 19:00:00.000', '20120521 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5005, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20120528 19:00:00.000', '20120528 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5006, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20120604 19:00:00.000', '20120604 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5007, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20120611 19:00:00.000', '20120611 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5008, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20120618 19:00:00.000', '20120618 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5009, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20120625 19:00:00.000', '20120625 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5010, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20120702 19:00:00.000', '20120702 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5011, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20120709 19:00:00.000', '20120709 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5012, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20120716 19:00:00.000', '20120716 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5013, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20120723 19:00:00.000', '20120723 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5014, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20120730 19:00:00.000', '20120730 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5015, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20120806 19:00:00.000', '20120806 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5016, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20120813 19:00:00.000', '20120813 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5017, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20120820 19:00:00.000', '20120820 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5018, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20120827 19:00:00.000', '20120827 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5019, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20120903 19:00:00.000', '20120903 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5020, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20120910 19:00:00.000', '20120910 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5021, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20120917 19:00:00.000', '20120917 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5022, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20120924 19:00:00.000', '20120924 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5023, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20121001 19:00:00.000', '20121001 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5024, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20121008 19:00:00.000', '20121008 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5025, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20121015 19:00:00.000', '20121015 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5026, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20121022 19:00:00.000', '20121022 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5027, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20121029 19:00:00.000', '20121029 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5028, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20121105 19:00:00.000', '20121105 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5029, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20121112 19:00:00.000', '20121112 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5030, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20121119 19:00:00.000', '20121119 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5031, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20121126 19:00:00.000', '20121126 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5032, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20121203 19:00:00.000', '20121203 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5033, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20121210 19:00:00.000', '20121210 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5034, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20121217 19:00:00.000', '20121217 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5035, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20121224 19:00:00.000', '20121224 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5036, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20121231 19:00:00.000', '20121231 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5037, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20130107 19:00:00.000', '20130107 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5038, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20130114 19:00:00.000', '20130114 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5039, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20130121 19:00:00.000', '20130121 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5040, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20130128 19:00:00.000', '20130128 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5041, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20130204 19:00:00.000', '20130204 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5042, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20130211 19:00:00.000', '20130211 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5043, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20130218 19:00:00.000', '20130218 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5044, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20130225 19:00:00.000', '20130225 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5045, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20130304 19:00:00.000', '20130304 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5046, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20130311 19:00:00.000', '20130311 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5047, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20130318 19:00:00.000', '20130318 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5048, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20130325 19:00:00.000', '20130325 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5049, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20130401 19:00:00.000', '20130401 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5050, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20130408 19:00:00.000', '20130408 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5051, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20130415 19:00:00.000', '20130415 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5052, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20130422 19:00:00.000', '20130422 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5053, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20130429 19:00:00.000', '20130429 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5054, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20130506 19:00:00.000', '20130506 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5055, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20130513 19:00:00.000', '20130513 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5056, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20130520 19:00:00.000', '20130520 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5057, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20130527 19:00:00.000', '20130527 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5058, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20130603 19:00:00.000', '20130603 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5059, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20130610 19:00:00.000', '20130610 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5060, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20130617 19:00:00.000', '20130617 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5061, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20130624 19:00:00.000', '20130624 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5062, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20130701 19:00:00.000', '20130701 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5063, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20130708 19:00:00.000', '20130708 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5064, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20130715 19:00:00.000', '20130715 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5065, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20130722 19:00:00.000', '20130722 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5066, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20130729 19:00:00.000', '20130729 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5067, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20130805 19:00:00.000', '20130805 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5068, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20130812 19:00:00.000', '20130812 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5069, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20130819 19:00:00.000', '20130819 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5070, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20130826 19:00:00.000', '20130826 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5071, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20130902 19:00:00.000', '20130902 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5072, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20130909 19:00:00.000', '20130909 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5073, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20130916 19:00:00.000', '20130916 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5074, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20130923 19:00:00.000', '20130923 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5075, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20130930 19:00:00.000', '20130930 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5076, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20131007 19:00:00.000', '20131007 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5077, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20131014 19:00:00.000', '20131014 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5078, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20131021 19:00:00.000', '20131021 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5079, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20131028 19:00:00.000', '20131028 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5080, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20131104 19:00:00.000', '20131104 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5081, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20131111 19:00:00.000', '20131111 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5082, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20131118 19:00:00.000', '20131118 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5083, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20131125 19:00:00.000', '20131125 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5084, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20131202 19:00:00.000', '20131202 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5085, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20131209 19:00:00.000', '20131209 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5086, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20131216 19:00:00.000', '20131216 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5087, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20131223 19:00:00.000', '20131223 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5088, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20131230 19:00:00.000', '20131230 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5089, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20140106 19:00:00.000', '20140106 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5090, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20140113 19:00:00.000', '20140113 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5091, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20140120 19:00:00.000', '20140120 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5092, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20140127 19:00:00.000', '20140127 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5093, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20140203 19:00:00.000', '20140203 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5094, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20140210 19:00:00.000', '20140210 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5095, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20140217 19:00:00.000', '20140217 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5096, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20140224 19:00:00.000', '20140224 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5097, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20140303 19:00:00.000', '20140303 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5098, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20140310 19:00:00.000', '20140310 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5099, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20140317 19:00:00.000', '20140317 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5100, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20140324 19:00:00.000', '20140324 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5101, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20140331 19:00:00.000', '20140331 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5102, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20140407 19:00:00.000', '20140407 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5103, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20140414 19:00:00.000', '20140414 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5104, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20140421 19:00:00.000', '20140421 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5105, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20140428 19:00:00.000', '20140428 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5106, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20140505 19:00:00.000', '20140505 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5107, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20140512 19:00:00.000', '20140512 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5108, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20140519 19:00:00.000', '20140519 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5109, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20140526 19:00:00.000', '20140526 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5110, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20140602 19:00:00.000', '20140602 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5111, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20140609 19:00:00.000', '20140609 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5112, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20140616 19:00:00.000', '20140616 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5113, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20140623 19:00:00.000', '20140623 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5114, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20140630 19:00:00.000', '20140630 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5115, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20140707 19:00:00.000', '20140707 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5116, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20140714 19:00:00.000', '20140714 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5117, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20140721 19:00:00.000', '20140721 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5118, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20140728 19:00:00.000', '20140728 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5119, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20140804 19:00:00.000', '20140804 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5120, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20140811 19:00:00.000', '20140811 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5121, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20140818 19:00:00.000', '20140818 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5122, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20140825 19:00:00.000', '20140825 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5123, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20140901 19:00:00.000', '20140901 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5124, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20140908 19:00:00.000', '20140908 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5125, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20140915 19:00:00.000', '20140915 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5126, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20140922 19:00:00.000', '20140922 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5127, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20140929 19:00:00.000', '20140929 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5128, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20141006 19:00:00.000', '20141006 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5129, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20141013 19:00:00.000', '20141013 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5130, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20141020 19:00:00.000', '20141020 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5131, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20141027 19:00:00.000', '20141027 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5132, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20141103 19:00:00.000', '20141103 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5133, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20141110 19:00:00.000', '20141110 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5134, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20141117 19:00:00.000', '20141117 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5135, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20141124 19:00:00.000', '20141124 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5136, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20141201 19:00:00.000', '20141201 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5137, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20141208 19:00:00.000', '20141208 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5138, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20141215 19:00:00.000', '20141215 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5139, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20141222 19:00:00.000', '20141222 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5140, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20141229 19:00:00.000', '20141229 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5141, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20150105 19:00:00.000', '20150105 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5142, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20150112 19:00:00.000', '20150112 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5143, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20150119 19:00:00.000', '20150119 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5144, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20150126 19:00:00.000', '20150126 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5145, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20150202 19:00:00.000', '20150202 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5146, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20150209 19:00:00.000', '20150209 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5147, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20150216 19:00:00.000', '20150216 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5148, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20150223 19:00:00.000', '20150223 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5149, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20150302 19:00:00.000', '20150302 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5150, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20150309 19:00:00.000', '20150309 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5151, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20150316 19:00:00.000', '20150316 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5152, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20150323 19:00:00.000', '20150323 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5153, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20150330 19:00:00.000', '20150330 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5154, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20150406 19:00:00.000', '20150406 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5155, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20150413 19:00:00.000', '20150413 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5156, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20150420 19:00:00.000', '20150420 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5157, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20150427 19:00:00.000', '20150427 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5158, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20150504 19:00:00.000', '20150504 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5159, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20150511 19:00:00.000', '20150511 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5160, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20150518 19:00:00.000', '20150518 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5161, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20150525 19:00:00.000', '20150525 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5162, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20150601 19:00:00.000', '20150601 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5163, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20150608 19:00:00.000', '20150608 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5164, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20150615 19:00:00.000', '20150615 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5165, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20150622 19:00:00.000', '20150622 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5166, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20150629 19:00:00.000', '20150629 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5167, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20150706 19:00:00.000', '20150706 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5168, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20150713 19:00:00.000', '20150713 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5169, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20150720 19:00:00.000', '20150720 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5170, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20150727 19:00:00.000', '20150727 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5171, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20150803 19:00:00.000', '20150803 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5172, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20150810 19:00:00.000', '20150810 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5173, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20150817 19:00:00.000', '20150817 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5174, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20150824 19:00:00.000', '20150824 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5175, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20150831 19:00:00.000', '20150831 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5176, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20150907 19:00:00.000', '20150907 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5177, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20150914 19:00:00.000', '20150914 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5178, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20150921 19:00:00.000', '20150921 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5179, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20150928 19:00:00.000', '20150928 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5180, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20151005 19:00:00.000', '20151005 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5181, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20151012 19:00:00.000', '20151012 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5182, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20151019 19:00:00.000', '20151019 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5183, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20151026 19:00:00.000', '20151026 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5184, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20151102 19:00:00.000', '20151102 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5185, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20151109 19:00:00.000', '20151109 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5186, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20151116 19:00:00.000', '20151116 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5187, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20151123 19:00:00.000', '20151123 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5188, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20151130 19:00:00.000', '20151130 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5189, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20151207 19:00:00.000', '20151207 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5190, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20151214 19:00:00.000', '20151214 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5191, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20151221 19:00:00.000', '20151221 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5192, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20151228 19:00:00.000', '20151228 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5193, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20160104 19:00:00.000', '20160104 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5194, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20160111 19:00:00.000', '20160111 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5195, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20160118 19:00:00.000', '20160118 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5196, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20160125 19:00:00.000', '20160125 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5197, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20160201 19:00:00.000', '20160201 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5198, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20160208 19:00:00.000', '20160208 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5199, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20160215 19:00:00.000', '20160215 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5200, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20160222 19:00:00.000', '20160222 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5201, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20160229 19:00:00.000', '20160229 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5202, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20160307 19:00:00.000', '20160307 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5203, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20160314 19:00:00.000', '20160314 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5204, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20160321 19:00:00.000', '20160321 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5205, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20160328 19:00:00.000', '20160328 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5206, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20160404 19:00:00.000', '20160404 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5207, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20160411 19:00:00.000', '20160411 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5208, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20160418 19:00:00.000', '20160418 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5209, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20160425 19:00:00.000', '20160425 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5210, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20160502 19:00:00.000', '20160502 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5211, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20160509 19:00:00.000', '20160509 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5212, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20160516 19:00:00.000', '20160516 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5213, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20160523 19:00:00.000', '20160523 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5214, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20160530 19:00:00.000', '20160530 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5215, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20160606 19:00:00.000', '20160606 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5216, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20160613 19:00:00.000', '20160613 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5217, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20160620 19:00:00.000', '20160620 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5218, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20160627 19:00:00.000', '20160627 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5219, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20160704 19:00:00.000', '20160704 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5220, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20160711 19:00:00.000', '20160711 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5221, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20160718 19:00:00.000', '20160718 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5222, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20160725 19:00:00.000', '20160725 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5223, 17, N'Revival of the Heart - Spirituality', N'Revival of the Heart - Spirituality', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Revival of the Heart - Spirituality</h3>', N'Main Center', '20160801 19:00:00.000', '20160801 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5224, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20110802 06:30:00.000', '20110802 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5225, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20110809 06:30:00.000', '20110809 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5226, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20110816 06:30:00.000', '20110816 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5227, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20110823 06:30:00.000', '20110823 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5228, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20110830 06:30:00.000', '20110830 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5229, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20110906 06:30:00.000', '20110906 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5230, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20110913 06:30:00.000', '20110913 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5231, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20110920 06:30:00.000', '20110920 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5232, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20110927 06:30:00.000', '20110927 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5233, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20111004 06:30:00.000', '20111004 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5234, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20111011 06:30:00.000', '20111011 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5235, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20111018 06:30:00.000', '20111018 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5236, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20111025 06:30:00.000', '20111025 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5237, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20111101 06:30:00.000', '20111101 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5238, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20111108 06:30:00.000', '20111108 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5239, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20111115 06:30:00.000', '20111115 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5240, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20111122 06:30:00.000', '20111122 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5241, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20111129 06:30:00.000', '20111129 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5242, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20111206 06:30:00.000', '20111206 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5243, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20111213 06:30:00.000', '20111213 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5244, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20111220 06:30:00.000', '20111220 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5245, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20111227 06:30:00.000', '20111227 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5246, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20120103 06:30:00.000', '20120103 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5247, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20120110 06:30:00.000', '20120110 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5248, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20120117 06:30:00.000', '20120117 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5249, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20120124 06:30:00.000', '20120124 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5250, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20120131 06:30:00.000', '20120131 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5251, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20120207 06:30:00.000', '20120207 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5252, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20120214 06:30:00.000', '20120214 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5253, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20120221 06:30:00.000', '20120221 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5254, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20120228 06:30:00.000', '20120228 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5255, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20120306 06:30:00.000', '20120306 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5256, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20120313 06:30:00.000', '20120313 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5257, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20120320 06:30:00.000', '20120320 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5258, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20120327 06:30:00.000', '20120327 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5259, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20120403 06:30:00.000', '20120403 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5260, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20120410 06:30:00.000', '20120410 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5261, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20120417 06:30:00.000', '20120417 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5262, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20120424 06:30:00.000', '20120424 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5263, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20120501 06:30:00.000', '20120501 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5264, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20120508 06:30:00.000', '20120508 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5265, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20120515 06:30:00.000', '20120515 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5266, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20120522 06:30:00.000', '20120522 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5267, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20120529 06:30:00.000', '20120529 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5268, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20120605 06:30:00.000', '20120605 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5269, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20120612 06:30:00.000', '20120612 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5270, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20120619 06:30:00.000', '20120619 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5271, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20120626 06:30:00.000', '20120626 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5272, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20120703 06:30:00.000', '20120703 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5273, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20120710 06:30:00.000', '20120710 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5274, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20120717 06:30:00.000', '20120717 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5275, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20120724 06:30:00.000', '20120724 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5276, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20120731 06:30:00.000', '20120731 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5277, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20120807 06:30:00.000', '20120807 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5278, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20120814 06:30:00.000', '20120814 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5279, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20120821 06:30:00.000', '20120821 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5280, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20120828 06:30:00.000', '20120828 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5281, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20120904 06:30:00.000', '20120904 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5282, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20120911 06:30:00.000', '20120911 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5283, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20120918 06:30:00.000', '20120918 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5284, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20120925 06:30:00.000', '20120925 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5285, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20121002 06:30:00.000', '20121002 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5286, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20121009 06:30:00.000', '20121009 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5287, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20121016 06:30:00.000', '20121016 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5288, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20121023 06:30:00.000', '20121023 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5289, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20121030 06:30:00.000', '20121030 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5290, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20121106 06:30:00.000', '20121106 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5291, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20121113 06:30:00.000', '20121113 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5292, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20121120 06:30:00.000', '20121120 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5293, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20121127 06:30:00.000', '20121127 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5294, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20121204 06:30:00.000', '20121204 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5295, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20121211 06:30:00.000', '20121211 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5296, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20121218 06:30:00.000', '20121218 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5297, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20121225 06:30:00.000', '20121225 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5298, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20130101 06:30:00.000', '20130101 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5299, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20130108 06:30:00.000', '20130108 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5300, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20130115 06:30:00.000', '20130115 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5301, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20130122 06:30:00.000', '20130122 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5302, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20130129 06:30:00.000', '20130129 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5303, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20130205 06:30:00.000', '20130205 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5304, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20130212 06:30:00.000', '20130212 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5305, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20130219 06:30:00.000', '20130219 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5306, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20130226 06:30:00.000', '20130226 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5307, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20130305 06:30:00.000', '20130305 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5308, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20130312 06:30:00.000', '20130312 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5309, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20130319 06:30:00.000', '20130319 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5310, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20130326 06:30:00.000', '20130326 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5311, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20130402 06:30:00.000', '20130402 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5312, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20130409 06:30:00.000', '20130409 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5313, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20130416 06:30:00.000', '20130416 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5314, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20130423 06:30:00.000', '20130423 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5315, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20130430 06:30:00.000', '20130430 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5316, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20130507 06:30:00.000', '20130507 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5317, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20130514 06:30:00.000', '20130514 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5318, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20130521 06:30:00.000', '20130521 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5319, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20130528 06:30:00.000', '20130528 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5320, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20130604 06:30:00.000', '20130604 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5321, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20130611 06:30:00.000', '20130611 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5322, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20130618 06:30:00.000', '20130618 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5323, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20130625 06:30:00.000', '20130625 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5324, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20130702 06:30:00.000', '20130702 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5325, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20130709 06:30:00.000', '20130709 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5326, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20130716 06:30:00.000', '20130716 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5327, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20130723 06:30:00.000', '20130723 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5328, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20130730 06:30:00.000', '20130730 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5329, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20130806 06:30:00.000', '20130806 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5330, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20130813 06:30:00.000', '20130813 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5331, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20130820 06:30:00.000', '20130820 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5332, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20130827 06:30:00.000', '20130827 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5333, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20130903 06:30:00.000', '20130903 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5334, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20130910 06:30:00.000', '20130910 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5335, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20130917 06:30:00.000', '20130917 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5336, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20130924 06:30:00.000', '20130924 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5337, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20131001 06:30:00.000', '20131001 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5338, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20131008 06:30:00.000', '20131008 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5339, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20131015 06:30:00.000', '20131015 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5340, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20131022 06:30:00.000', '20131022 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5341, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20131029 06:30:00.000', '20131029 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5342, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20131105 06:30:00.000', '20131105 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5343, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20131112 06:30:00.000', '20131112 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5344, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20131119 06:30:00.000', '20131119 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5345, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20131126 06:30:00.000', '20131126 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5346, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20131203 06:30:00.000', '20131203 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5347, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20131210 06:30:00.000', '20131210 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5348, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20131217 06:30:00.000', '20131217 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5349, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20131224 06:30:00.000', '20131224 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5350, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20131231 06:30:00.000', '20131231 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5351, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20140107 06:30:00.000', '20140107 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5352, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20140114 06:30:00.000', '20140114 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5353, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20140121 06:30:00.000', '20140121 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5354, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20140128 06:30:00.000', '20140128 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5355, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20140204 06:30:00.000', '20140204 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5356, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20140211 06:30:00.000', '20140211 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5357, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20140218 06:30:00.000', '20140218 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5358, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20140225 06:30:00.000', '20140225 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5359, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20140304 06:30:00.000', '20140304 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5360, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20140311 06:30:00.000', '20140311 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5361, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20140318 06:30:00.000', '20140318 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5362, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20140325 06:30:00.000', '20140325 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5363, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20140401 06:30:00.000', '20140401 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5364, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20140408 06:30:00.000', '20140408 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5365, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20140415 06:30:00.000', '20140415 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5366, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20140422 06:30:00.000', '20140422 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5367, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20140429 06:30:00.000', '20140429 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5368, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20140506 06:30:00.000', '20140506 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5369, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20140513 06:30:00.000', '20140513 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5370, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20140520 06:30:00.000', '20140520 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5371, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20140527 06:30:00.000', '20140527 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5372, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20140603 06:30:00.000', '20140603 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5373, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20140610 06:30:00.000', '20140610 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5374, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20140617 06:30:00.000', '20140617 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5375, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20140624 06:30:00.000', '20140624 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5376, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20140701 06:30:00.000', '20140701 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5377, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20140708 06:30:00.000', '20140708 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5378, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20140715 06:30:00.000', '20140715 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5379, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20140722 06:30:00.000', '20140722 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5380, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20140729 06:30:00.000', '20140729 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5381, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20140805 06:30:00.000', '20140805 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5382, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20140812 06:30:00.000', '20140812 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5383, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20140819 06:30:00.000', '20140819 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5384, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20140826 06:30:00.000', '20140826 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5385, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20140902 06:30:00.000', '20140902 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5386, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20140909 06:30:00.000', '20140909 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5387, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20140916 06:30:00.000', '20140916 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5388, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20140923 06:30:00.000', '20140923 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5389, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20140930 06:30:00.000', '20140930 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5390, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20141007 06:30:00.000', '20141007 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5391, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20141014 06:30:00.000', '20141014 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5392, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20141021 06:30:00.000', '20141021 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5393, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20141028 06:30:00.000', '20141028 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5394, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20141104 06:30:00.000', '20141104 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5395, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20141111 06:30:00.000', '20141111 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5396, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20141118 06:30:00.000', '20141118 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5397, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20141125 06:30:00.000', '20141125 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5398, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20141202 06:30:00.000', '20141202 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5399, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20141209 06:30:00.000', '20141209 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5400, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20141216 06:30:00.000', '20141216 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5401, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20141223 06:30:00.000', '20141223 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5402, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20141230 06:30:00.000', '20141230 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5403, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20150106 06:30:00.000', '20150106 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5404, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20150113 06:30:00.000', '20150113 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5405, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20150120 06:30:00.000', '20150120 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5406, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20150127 06:30:00.000', '20150127 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5407, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20150203 06:30:00.000', '20150203 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5408, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20150210 06:30:00.000', '20150210 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5409, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20150217 06:30:00.000', '20150217 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5410, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20150224 06:30:00.000', '20150224 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5411, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20150303 06:30:00.000', '20150303 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5412, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20150310 06:30:00.000', '20150310 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5413, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20150317 06:30:00.000', '20150317 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5414, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20150324 06:30:00.000', '20150324 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5415, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20150331 06:30:00.000', '20150331 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5416, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20150407 06:30:00.000', '20150407 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5417, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20150414 06:30:00.000', '20150414 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5418, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20150421 06:30:00.000', '20150421 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5419, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20150428 06:30:00.000', '20150428 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5420, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20150505 06:30:00.000', '20150505 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5421, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20150512 06:30:00.000', '20150512 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5422, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20150519 06:30:00.000', '20150519 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5423, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20150526 06:30:00.000', '20150526 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5424, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20150602 06:30:00.000', '20150602 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5425, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20150609 06:30:00.000', '20150609 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5426, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20150616 06:30:00.000', '20150616 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5427, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20150623 06:30:00.000', '20150623 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5428, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20150630 06:30:00.000', '20150630 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5429, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20150707 06:30:00.000', '20150707 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5430, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20150714 06:30:00.000', '20150714 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5431, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20150721 06:30:00.000', '20150721 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5432, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20150728 06:30:00.000', '20150728 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5433, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20150804 06:30:00.000', '20150804 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5434, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20150811 06:30:00.000', '20150811 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5435, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20150818 06:30:00.000', '20150818 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5436, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20150825 06:30:00.000', '20150825 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5437, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20150901 06:30:00.000', '20150901 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5438, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20150908 06:30:00.000', '20150908 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5439, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20150915 06:30:00.000', '20150915 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5440, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20150922 06:30:00.000', '20150922 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5441, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20150929 06:30:00.000', '20150929 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5442, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20151006 06:30:00.000', '20151006 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5443, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20151013 06:30:00.000', '20151013 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5444, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20151020 06:30:00.000', '20151020 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5445, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20151027 06:30:00.000', '20151027 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5446, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20151103 06:30:00.000', '20151103 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5447, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20151110 06:30:00.000', '20151110 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5448, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20151117 06:30:00.000', '20151117 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5449, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20151124 06:30:00.000', '20151124 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5450, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20151201 06:30:00.000', '20151201 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5451, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20151208 06:30:00.000', '20151208 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5452, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20151215 06:30:00.000', '20151215 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5453, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20151222 06:30:00.000', '20151222 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5454, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20151229 06:30:00.000', '20151229 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5455, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20160105 06:30:00.000', '20160105 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5456, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20160112 06:30:00.000', '20160112 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5457, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20160119 06:30:00.000', '20160119 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5458, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20160126 06:30:00.000', '20160126 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5459, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20160202 06:30:00.000', '20160202 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5460, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20160209 06:30:00.000', '20160209 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5461, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20160216 06:30:00.000', '20160216 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5462, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20160223 06:30:00.000', '20160223 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5463, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20160301 06:30:00.000', '20160301 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5464, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20160308 06:30:00.000', '20160308 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5465, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20160315 06:30:00.000', '20160315 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5466, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20160322 06:30:00.000', '20160322 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5467, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20160329 06:30:00.000', '20160329 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5468, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20160405 06:30:00.000', '20160405 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5469, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20160412 06:30:00.000', '20160412 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5470, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20160419 06:30:00.000', '20160419 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5471, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20160426 06:30:00.000', '20160426 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5472, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20160503 06:30:00.000', '20160503 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5473, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20160510 06:30:00.000', '20160510 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5474, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20160517 06:30:00.000', '20160517 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5475, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20160524 06:30:00.000', '20160524 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5476, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20160531 06:30:00.000', '20160531 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5477, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20160607 06:30:00.000', '20160607 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5478, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20160614 06:30:00.000', '20160614 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5479, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20160621 06:30:00.000', '20160621 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5480, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20160628 06:30:00.000', '20160628 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5481, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20160705 06:30:00.000', '20160705 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5482, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20160712 06:30:00.000', '20160712 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5483, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20160719 06:30:00.000', '20160719 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5484, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20160726 06:30:00.000', '20160726 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5485, 3, N'Tafseer', N'Tafseer: Br. Shad Imam', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Shad Imam</h3>', N'Main Center', '20160802 06:30:00.000', '20160802 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5486, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20110803 06:30:00.000', '20110803 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5487, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20110806 06:30:00.000', '20110806 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5488, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20110810 06:30:00.000', '20110810 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5489, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20110813 06:30:00.000', '20110813 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5490, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20110817 06:30:00.000', '20110817 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5491, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20110820 06:30:00.000', '20110820 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5492, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20110824 06:30:00.000', '20110824 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5493, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20110827 06:30:00.000', '20110827 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5494, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20110831 06:30:00.000', '20110831 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5495, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20110903 06:30:00.000', '20110903 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5496, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20110907 06:30:00.000', '20110907 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5497, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20110910 06:30:00.000', '20110910 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5498, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20110914 06:30:00.000', '20110914 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5499, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20110917 06:30:00.000', '20110917 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5500, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20110921 06:30:00.000', '20110921 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5501, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20110924 06:30:00.000', '20110924 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5502, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20110928 06:30:00.000', '20110928 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5503, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20111001 06:30:00.000', '20111001 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5504, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20111005 06:30:00.000', '20111005 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5505, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20111008 06:30:00.000', '20111008 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5506, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20111012 06:30:00.000', '20111012 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5507, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20111015 06:30:00.000', '20111015 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5508, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20111019 06:30:00.000', '20111019 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5509, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20111022 06:30:00.000', '20111022 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5510, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20111026 06:30:00.000', '20111026 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5511, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20111029 06:30:00.000', '20111029 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5512, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20111102 06:30:00.000', '20111102 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5513, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20111105 06:30:00.000', '20111105 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5514, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20111109 06:30:00.000', '20111109 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5515, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20111112 06:30:00.000', '20111112 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5516, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20111116 06:30:00.000', '20111116 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5517, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20111119 06:30:00.000', '20111119 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5518, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20111123 06:30:00.000', '20111123 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5519, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20111126 06:30:00.000', '20111126 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5520, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20111130 06:30:00.000', '20111130 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5521, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20111203 06:30:00.000', '20111203 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5522, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20111207 06:30:00.000', '20111207 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5523, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20111210 06:30:00.000', '20111210 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5524, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20111214 06:30:00.000', '20111214 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5525, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20111217 06:30:00.000', '20111217 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5526, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20111221 06:30:00.000', '20111221 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5527, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20111224 06:30:00.000', '20111224 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5528, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20111228 06:30:00.000', '20111228 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5529, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20111231 06:30:00.000', '20111231 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5530, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20120104 06:30:00.000', '20120104 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5531, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20120107 06:30:00.000', '20120107 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5532, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20120111 06:30:00.000', '20120111 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5533, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20120114 06:30:00.000', '20120114 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5534, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20120118 06:30:00.000', '20120118 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5535, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20120121 06:30:00.000', '20120121 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5536, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20120125 06:30:00.000', '20120125 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5537, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20120128 06:30:00.000', '20120128 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5538, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20120201 06:30:00.000', '20120201 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5539, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20120204 06:30:00.000', '20120204 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5540, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20120208 06:30:00.000', '20120208 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5541, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20120211 06:30:00.000', '20120211 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5542, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20120215 06:30:00.000', '20120215 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5543, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20120218 06:30:00.000', '20120218 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5544, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20120222 06:30:00.000', '20120222 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5545, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20120225 06:30:00.000', '20120225 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5546, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20120229 06:30:00.000', '20120229 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5547, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20120303 06:30:00.000', '20120303 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5548, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20120307 06:30:00.000', '20120307 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5549, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20120310 06:30:00.000', '20120310 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5550, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20120314 06:30:00.000', '20120314 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5551, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20120317 06:30:00.000', '20120317 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5552, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20120321 06:30:00.000', '20120321 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5553, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20120324 06:30:00.000', '20120324 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5554, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20120328 06:30:00.000', '20120328 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5555, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20120331 06:30:00.000', '20120331 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5556, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20120404 06:30:00.000', '20120404 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5557, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20120407 06:30:00.000', '20120407 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5558, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20120411 06:30:00.000', '20120411 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5559, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20120414 06:30:00.000', '20120414 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5560, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20120418 06:30:00.000', '20120418 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5561, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20120421 06:30:00.000', '20120421 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5562, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20120425 06:30:00.000', '20120425 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5563, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20120428 06:30:00.000', '20120428 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5564, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20120502 06:30:00.000', '20120502 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5565, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20120505 06:30:00.000', '20120505 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5566, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20120509 06:30:00.000', '20120509 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5567, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20120512 06:30:00.000', '20120512 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5568, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20120516 06:30:00.000', '20120516 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5569, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20120519 06:30:00.000', '20120519 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5570, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20120523 06:30:00.000', '20120523 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5571, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20120526 06:30:00.000', '20120526 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5572, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20120530 06:30:00.000', '20120530 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5573, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20120602 06:30:00.000', '20120602 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5574, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20120606 06:30:00.000', '20120606 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5575, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20120609 06:30:00.000', '20120609 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5576, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20120613 06:30:00.000', '20120613 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5577, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20120616 06:30:00.000', '20120616 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5578, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20120620 06:30:00.000', '20120620 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5579, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20120623 06:30:00.000', '20120623 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5580, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20120627 06:30:00.000', '20120627 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5581, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20120630 06:30:00.000', '20120630 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5582, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20120704 06:30:00.000', '20120704 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5583, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20120707 06:30:00.000', '20120707 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5584, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20120711 06:30:00.000', '20120711 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5585, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20120714 06:30:00.000', '20120714 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5586, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20120718 06:30:00.000', '20120718 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5587, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20120721 06:30:00.000', '20120721 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5588, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20120725 06:30:00.000', '20120725 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5589, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20120728 06:30:00.000', '20120728 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5590, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20120801 06:30:00.000', '20120801 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5591, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20120804 06:30:00.000', '20120804 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5592, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20120808 06:30:00.000', '20120808 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5593, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20120811 06:30:00.000', '20120811 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5594, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20120815 06:30:00.000', '20120815 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5595, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20120818 06:30:00.000', '20120818 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5596, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20120822 06:30:00.000', '20120822 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5597, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20120825 06:30:00.000', '20120825 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5598, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20120829 06:30:00.000', '20120829 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5599, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20120901 06:30:00.000', '20120901 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5600, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20120905 06:30:00.000', '20120905 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5601, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20120908 06:30:00.000', '20120908 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5602, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20120912 06:30:00.000', '20120912 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5603, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20120915 06:30:00.000', '20120915 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5604, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20120919 06:30:00.000', '20120919 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5605, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20120922 06:30:00.000', '20120922 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5606, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20120926 06:30:00.000', '20120926 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5607, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20120929 06:30:00.000', '20120929 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5608, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20121003 06:30:00.000', '20121003 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5609, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20121006 06:30:00.000', '20121006 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5610, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20121010 06:30:00.000', '20121010 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5611, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20121013 06:30:00.000', '20121013 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5612, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20121017 06:30:00.000', '20121017 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5613, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20121020 06:30:00.000', '20121020 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5614, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20121024 06:30:00.000', '20121024 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5615, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20121027 06:30:00.000', '20121027 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5616, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20121031 06:30:00.000', '20121031 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5617, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20121103 06:30:00.000', '20121103 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5618, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20121107 06:30:00.000', '20121107 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5619, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20121110 06:30:00.000', '20121110 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5620, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20121114 06:30:00.000', '20121114 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5621, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20121117 06:30:00.000', '20121117 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5622, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20121121 06:30:00.000', '20121121 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5623, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20121124 06:30:00.000', '20121124 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5624, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20121128 06:30:00.000', '20121128 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5625, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20121201 06:30:00.000', '20121201 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5626, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20121205 06:30:00.000', '20121205 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5627, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20121208 06:30:00.000', '20121208 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5628, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20121212 06:30:00.000', '20121212 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5629, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20121215 06:30:00.000', '20121215 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5630, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20121219 06:30:00.000', '20121219 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5631, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20121222 06:30:00.000', '20121222 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5632, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20121226 06:30:00.000', '20121226 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5633, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20121229 06:30:00.000', '20121229 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5634, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20130102 06:30:00.000', '20130102 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5635, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20130105 06:30:00.000', '20130105 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5636, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20130109 06:30:00.000', '20130109 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5637, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20130112 06:30:00.000', '20130112 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5638, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20130116 06:30:00.000', '20130116 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5639, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20130119 06:30:00.000', '20130119 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5640, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20130123 06:30:00.000', '20130123 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5641, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20130126 06:30:00.000', '20130126 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5642, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20130130 06:30:00.000', '20130130 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5643, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20130202 06:30:00.000', '20130202 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5644, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20130206 06:30:00.000', '20130206 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5645, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20130209 06:30:00.000', '20130209 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5646, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20130213 06:30:00.000', '20130213 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5647, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20130216 06:30:00.000', '20130216 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5648, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20130220 06:30:00.000', '20130220 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5649, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20130223 06:30:00.000', '20130223 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5650, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20130227 06:30:00.000', '20130227 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5651, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20130302 06:30:00.000', '20130302 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5652, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20130306 06:30:00.000', '20130306 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5653, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20130309 06:30:00.000', '20130309 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5654, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20130313 06:30:00.000', '20130313 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5655, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20130316 06:30:00.000', '20130316 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5656, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20130320 06:30:00.000', '20130320 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5657, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20130323 06:30:00.000', '20130323 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5658, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20130327 06:30:00.000', '20130327 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5659, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20130330 06:30:00.000', '20130330 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5660, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20130403 06:30:00.000', '20130403 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5661, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20130406 06:30:00.000', '20130406 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5662, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20130410 06:30:00.000', '20130410 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5663, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20130413 06:30:00.000', '20130413 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5664, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20130417 06:30:00.000', '20130417 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5665, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20130420 06:30:00.000', '20130420 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5666, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20130424 06:30:00.000', '20130424 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5667, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20130427 06:30:00.000', '20130427 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5668, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20130501 06:30:00.000', '20130501 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5669, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20130504 06:30:00.000', '20130504 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5670, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20130508 06:30:00.000', '20130508 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5671, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20130511 06:30:00.000', '20130511 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5672, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20130515 06:30:00.000', '20130515 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5673, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20130518 06:30:00.000', '20130518 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5674, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20130522 06:30:00.000', '20130522 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5675, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20130525 06:30:00.000', '20130525 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5676, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20130529 06:30:00.000', '20130529 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5677, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20130601 06:30:00.000', '20130601 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5678, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20130605 06:30:00.000', '20130605 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5679, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20130608 06:30:00.000', '20130608 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5680, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20130612 06:30:00.000', '20130612 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5681, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20130615 06:30:00.000', '20130615 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5682, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20130619 06:30:00.000', '20130619 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5683, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20130622 06:30:00.000', '20130622 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5684, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20130626 06:30:00.000', '20130626 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5685, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20130629 06:30:00.000', '20130629 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5686, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20130703 06:30:00.000', '20130703 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5687, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20130706 06:30:00.000', '20130706 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5688, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20130710 06:30:00.000', '20130710 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5689, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20130713 06:30:00.000', '20130713 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5690, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20130717 06:30:00.000', '20130717 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5691, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20130720 06:30:00.000', '20130720 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5692, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20130724 06:30:00.000', '20130724 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5693, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20130727 06:30:00.000', '20130727 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5694, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20130731 06:30:00.000', '20130731 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5695, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20130803 06:30:00.000', '20130803 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5696, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20130807 06:30:00.000', '20130807 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5697, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20130810 06:30:00.000', '20130810 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5698, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20130814 06:30:00.000', '20130814 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5699, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20130817 06:30:00.000', '20130817 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5700, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20130821 06:30:00.000', '20130821 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5701, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20130824 06:30:00.000', '20130824 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5702, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20130828 06:30:00.000', '20130828 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5703, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20130831 06:30:00.000', '20130831 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5704, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20130904 06:30:00.000', '20130904 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5705, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20130907 06:30:00.000', '20130907 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5706, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20130911 06:30:00.000', '20130911 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5707, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20130914 06:30:00.000', '20130914 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5708, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20130918 06:30:00.000', '20130918 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5709, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20130921 06:30:00.000', '20130921 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5710, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20130925 06:30:00.000', '20130925 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5711, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20130928 06:30:00.000', '20130928 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5712, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20131002 06:30:00.000', '20131002 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5713, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20131005 06:30:00.000', '20131005 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5714, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20131009 06:30:00.000', '20131009 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5715, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20131012 06:30:00.000', '20131012 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5716, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20131016 06:30:00.000', '20131016 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5717, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20131019 06:30:00.000', '20131019 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5718, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20131023 06:30:00.000', '20131023 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5719, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20131026 06:30:00.000', '20131026 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5720, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20131030 06:30:00.000', '20131030 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5721, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20131102 06:30:00.000', '20131102 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5722, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20131106 06:30:00.000', '20131106 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5723, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20131109 06:30:00.000', '20131109 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5724, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20131113 06:30:00.000', '20131113 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5725, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20131116 06:30:00.000', '20131116 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5726, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20131120 06:30:00.000', '20131120 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5727, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20131123 06:30:00.000', '20131123 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5728, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20131127 06:30:00.000', '20131127 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5729, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20131130 06:30:00.000', '20131130 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5730, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20131204 06:30:00.000', '20131204 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5731, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20131207 06:30:00.000', '20131207 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5732, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20131211 06:30:00.000', '20131211 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5733, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20131214 06:30:00.000', '20131214 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5734, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20131218 06:30:00.000', '20131218 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5735, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20131221 06:30:00.000', '20131221 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5736, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20131225 06:30:00.000', '20131225 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5737, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20131228 06:30:00.000', '20131228 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5738, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20140101 06:30:00.000', '20140101 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5739, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20140104 06:30:00.000', '20140104 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5740, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20140108 06:30:00.000', '20140108 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5741, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20140111 06:30:00.000', '20140111 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5742, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20140115 06:30:00.000', '20140115 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5743, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20140118 06:30:00.000', '20140118 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5744, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20140122 06:30:00.000', '20140122 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5745, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20140125 06:30:00.000', '20140125 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5746, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20140129 06:30:00.000', '20140129 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5747, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20140201 06:30:00.000', '20140201 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5748, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20140205 06:30:00.000', '20140205 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5749, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20140208 06:30:00.000', '20140208 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5750, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20140212 06:30:00.000', '20140212 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5751, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20140215 06:30:00.000', '20140215 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5752, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20140219 06:30:00.000', '20140219 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5753, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20140222 06:30:00.000', '20140222 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5754, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20140226 06:30:00.000', '20140226 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5755, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20140301 06:30:00.000', '20140301 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5756, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20140305 06:30:00.000', '20140305 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5757, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20140308 06:30:00.000', '20140308 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5758, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20140312 06:30:00.000', '20140312 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5759, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20140315 06:30:00.000', '20140315 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5760, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20140319 06:30:00.000', '20140319 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5761, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20140322 06:30:00.000', '20140322 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5762, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20140326 06:30:00.000', '20140326 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5763, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20140329 06:30:00.000', '20140329 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5764, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20140402 06:30:00.000', '20140402 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5765, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20140405 06:30:00.000', '20140405 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5766, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20140409 06:30:00.000', '20140409 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5767, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20140412 06:30:00.000', '20140412 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5768, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20140416 06:30:00.000', '20140416 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5769, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20140419 06:30:00.000', '20140419 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5770, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20140423 06:30:00.000', '20140423 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5771, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20140426 06:30:00.000', '20140426 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5772, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20140430 06:30:00.000', '20140430 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5773, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20140503 06:30:00.000', '20140503 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5774, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20140507 06:30:00.000', '20140507 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5775, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20140510 06:30:00.000', '20140510 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5776, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20140514 06:30:00.000', '20140514 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5777, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20140517 06:30:00.000', '20140517 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5778, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20140521 06:30:00.000', '20140521 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5779, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20140524 06:30:00.000', '20140524 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5780, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20140528 06:30:00.000', '20140528 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5781, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20140531 06:30:00.000', '20140531 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5782, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20140604 06:30:00.000', '20140604 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5783, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20140607 06:30:00.000', '20140607 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5784, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20140611 06:30:00.000', '20140611 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5785, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20140614 06:30:00.000', '20140614 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5786, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20140618 06:30:00.000', '20140618 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5787, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20140621 06:30:00.000', '20140621 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5788, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20140625 06:30:00.000', '20140625 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5789, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20140628 06:30:00.000', '20140628 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5790, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20140702 06:30:00.000', '20140702 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5791, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20140705 06:30:00.000', '20140705 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5792, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20140709 06:30:00.000', '20140709 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5793, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20140712 06:30:00.000', '20140712 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5794, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20140716 06:30:00.000', '20140716 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5795, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20140719 06:30:00.000', '20140719 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5796, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20140723 06:30:00.000', '20140723 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5797, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20140726 06:30:00.000', '20140726 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5798, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20140730 06:30:00.000', '20140730 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5799, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20140802 06:30:00.000', '20140802 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5800, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20140806 06:30:00.000', '20140806 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5801, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20140809 06:30:00.000', '20140809 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5802, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20140813 06:30:00.000', '20140813 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5803, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20140816 06:30:00.000', '20140816 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5804, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20140820 06:30:00.000', '20140820 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5805, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20140823 06:30:00.000', '20140823 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5806, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20140827 06:30:00.000', '20140827 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5807, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20140830 06:30:00.000', '20140830 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5808, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20140903 06:30:00.000', '20140903 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5809, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20140906 06:30:00.000', '20140906 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5810, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20140910 06:30:00.000', '20140910 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5811, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20140913 06:30:00.000', '20140913 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5812, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20140917 06:30:00.000', '20140917 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5813, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20140920 06:30:00.000', '20140920 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5814, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20140924 06:30:00.000', '20140924 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5815, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20140927 06:30:00.000', '20140927 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5816, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20141001 06:30:00.000', '20141001 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5817, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20141004 06:30:00.000', '20141004 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5818, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20141008 06:30:00.000', '20141008 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5819, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20141011 06:30:00.000', '20141011 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5820, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20141015 06:30:00.000', '20141015 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5821, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20141018 06:30:00.000', '20141018 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5822, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20141022 06:30:00.000', '20141022 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5823, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20141025 06:30:00.000', '20141025 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5824, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20141029 06:30:00.000', '20141029 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5825, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20141101 06:30:00.000', '20141101 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5826, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20141105 06:30:00.000', '20141105 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5827, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20141108 06:30:00.000', '20141108 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5828, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20141112 06:30:00.000', '20141112 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5829, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20141115 06:30:00.000', '20141115 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5830, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20141119 06:30:00.000', '20141119 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5831, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20141122 06:30:00.000', '20141122 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5832, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20141126 06:30:00.000', '20141126 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5833, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20141129 06:30:00.000', '20141129 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5834, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20141203 06:30:00.000', '20141203 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5835, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20141206 06:30:00.000', '20141206 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5836, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20141210 06:30:00.000', '20141210 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5837, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20141213 06:30:00.000', '20141213 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5838, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20141217 06:30:00.000', '20141217 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5839, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20141220 06:30:00.000', '20141220 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5840, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20141224 06:30:00.000', '20141224 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5841, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20141227 06:30:00.000', '20141227 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5842, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20141231 06:30:00.000', '20141231 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5843, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20150103 06:30:00.000', '20150103 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5844, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20150107 06:30:00.000', '20150107 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5845, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20150110 06:30:00.000', '20150110 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5846, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20150114 06:30:00.000', '20150114 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5847, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20150117 06:30:00.000', '20150117 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5848, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20150121 06:30:00.000', '20150121 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5849, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20150124 06:30:00.000', '20150124 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5850, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20150128 06:30:00.000', '20150128 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5851, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20150131 06:30:00.000', '20150131 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5852, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20150204 06:30:00.000', '20150204 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5853, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20150207 06:30:00.000', '20150207 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5854, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20150211 06:30:00.000', '20150211 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5855, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20150214 06:30:00.000', '20150214 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5856, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20150218 06:30:00.000', '20150218 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5857, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20150221 06:30:00.000', '20150221 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5858, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20150225 06:30:00.000', '20150225 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5859, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20150228 06:30:00.000', '20150228 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5860, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20150304 06:30:00.000', '20150304 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5861, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20150307 06:30:00.000', '20150307 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5862, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20150311 06:30:00.000', '20150311 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5863, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20150314 06:30:00.000', '20150314 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5864, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20150318 06:30:00.000', '20150318 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5865, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20150321 06:30:00.000', '20150321 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5866, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20150325 06:30:00.000', '20150325 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5867, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20150328 06:30:00.000', '20150328 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5868, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20150401 06:30:00.000', '20150401 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5869, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20150404 06:30:00.000', '20150404 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5870, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20150408 06:30:00.000', '20150408 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5871, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20150411 06:30:00.000', '20150411 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5872, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20150415 06:30:00.000', '20150415 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5873, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20150418 06:30:00.000', '20150418 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5874, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20150422 06:30:00.000', '20150422 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5875, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20150425 06:30:00.000', '20150425 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5876, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20150429 06:30:00.000', '20150429 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5877, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20150502 06:30:00.000', '20150502 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5878, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20150506 06:30:00.000', '20150506 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5879, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20150509 06:30:00.000', '20150509 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5880, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20150513 06:30:00.000', '20150513 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5881, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20150516 06:30:00.000', '20150516 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5882, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20150520 06:30:00.000', '20150520 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5883, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20150523 06:30:00.000', '20150523 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5884, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20150527 06:30:00.000', '20150527 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5885, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20150530 06:30:00.000', '20150530 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5886, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20150603 06:30:00.000', '20150603 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5887, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20150606 06:30:00.000', '20150606 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5888, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20150610 06:30:00.000', '20150610 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5889, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20150613 06:30:00.000', '20150613 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5890, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20150617 06:30:00.000', '20150617 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5891, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20150620 06:30:00.000', '20150620 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5892, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20150624 06:30:00.000', '20150624 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5893, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20150627 06:30:00.000', '20150627 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5894, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20150701 06:30:00.000', '20150701 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5895, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20150704 06:30:00.000', '20150704 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5896, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20150708 06:30:00.000', '20150708 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5897, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20150711 06:30:00.000', '20150711 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5898, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20150715 06:30:00.000', '20150715 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5899, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20150718 06:30:00.000', '20150718 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5900, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20150722 06:30:00.000', '20150722 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5901, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20150725 06:30:00.000', '20150725 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5902, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20150729 06:30:00.000', '20150729 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5903, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20150801 06:30:00.000', '20150801 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5904, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20150805 06:30:00.000', '20150805 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5905, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20150808 06:30:00.000', '20150808 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5906, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20150812 06:30:00.000', '20150812 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5907, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20150815 06:30:00.000', '20150815 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5908, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20150819 06:30:00.000', '20150819 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5909, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20150822 06:30:00.000', '20150822 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5910, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20150826 06:30:00.000', '20150826 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5911, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20150829 06:30:00.000', '20150829 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5912, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20150902 06:30:00.000', '20150902 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5913, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20150905 06:30:00.000', '20150905 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5914, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20150909 06:30:00.000', '20150909 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5915, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20150912 06:30:00.000', '20150912 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5916, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20150916 06:30:00.000', '20150916 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5917, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20150919 06:30:00.000', '20150919 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5918, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20150923 06:30:00.000', '20150923 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5919, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20150926 06:30:00.000', '20150926 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5920, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20150930 06:30:00.000', '20150930 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5921, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20151003 06:30:00.000', '20151003 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5922, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20151007 06:30:00.000', '20151007 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5923, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20151010 06:30:00.000', '20151010 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5924, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20151014 06:30:00.000', '20151014 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5925, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20151017 06:30:00.000', '20151017 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5926, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20151021 06:30:00.000', '20151021 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5927, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20151024 06:30:00.000', '20151024 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5928, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20151028 06:30:00.000', '20151028 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5929, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20151031 06:30:00.000', '20151031 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5930, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20151104 06:30:00.000', '20151104 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5931, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20151107 06:30:00.000', '20151107 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5932, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20151111 06:30:00.000', '20151111 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5933, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20151114 06:30:00.000', '20151114 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5934, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20151118 06:30:00.000', '20151118 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5935, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20151121 06:30:00.000', '20151121 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5936, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20151125 06:30:00.000', '20151125 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5937, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20151128 06:30:00.000', '20151128 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5938, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20151202 06:30:00.000', '20151202 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5939, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20151205 06:30:00.000', '20151205 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5940, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20151209 06:30:00.000', '20151209 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5941, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20151212 06:30:00.000', '20151212 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5942, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20151216 06:30:00.000', '20151216 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5943, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20151219 06:30:00.000', '20151219 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5944, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20151223 06:30:00.000', '20151223 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5945, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20151226 06:30:00.000', '20151226 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5946, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20151230 06:30:00.000', '20151230 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5947, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20160102 06:30:00.000', '20160102 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5948, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20160106 06:30:00.000', '20160106 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5949, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20160109 06:30:00.000', '20160109 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5950, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20160113 06:30:00.000', '20160113 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5951, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20160116 06:30:00.000', '20160116 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5952, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20160120 06:30:00.000', '20160120 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5953, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20160123 06:30:00.000', '20160123 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5954, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20160127 06:30:00.000', '20160127 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5955, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20160130 06:30:00.000', '20160130 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5956, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20160203 06:30:00.000', '20160203 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5957, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20160206 06:30:00.000', '20160206 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5958, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20160210 06:30:00.000', '20160210 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5959, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20160213 06:30:00.000', '20160213 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5960, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20160217 06:30:00.000', '20160217 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5961, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20160220 06:30:00.000', '20160220 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5962, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20160224 06:30:00.000', '20160224 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5963, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20160227 06:30:00.000', '20160227 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5964, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20160302 06:30:00.000', '20160302 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5965, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20160305 06:30:00.000', '20160305 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5966, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20160309 06:30:00.000', '20160309 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5967, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20160312 06:30:00.000', '20160312 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5968, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20160316 06:30:00.000', '20160316 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5969, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20160319 06:30:00.000', '20160319 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5970, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20160323 06:30:00.000', '20160323 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5971, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20160326 06:30:00.000', '20160326 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5972, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20160330 06:30:00.000', '20160330 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5973, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20160402 06:30:00.000', '20160402 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5974, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20160406 06:30:00.000', '20160406 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5975, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20160409 06:30:00.000', '20160409 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5976, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20160413 06:30:00.000', '20160413 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5977, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20160416 06:30:00.000', '20160416 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5978, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20160420 06:30:00.000', '20160420 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5979, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20160423 06:30:00.000', '20160423 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5980, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20160427 06:30:00.000', '20160427 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5981, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20160430 06:30:00.000', '20160430 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5982, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20160504 06:30:00.000', '20160504 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5983, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20160507 06:30:00.000', '20160507 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5984, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20160511 06:30:00.000', '20160511 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5985, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20160514 06:30:00.000', '20160514 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5986, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20160518 06:30:00.000', '20160518 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5987, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20160521 06:30:00.000', '20160521 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5988, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20160525 06:30:00.000', '20160525 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5989, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20160528 06:30:00.000', '20160528 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5990, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20160601 06:30:00.000', '20160601 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5991, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20160604 06:30:00.000', '20160604 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5992, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20160608 06:30:00.000', '20160608 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5993, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20160611 06:30:00.000', '20160611 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5994, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20160615 06:30:00.000', '20160615 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5995, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20160618 06:30:00.000', '20160618 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5996, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20160622 06:30:00.000', '20160622 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5997, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20160625 06:30:00.000', '20160625 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5998, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20160629 06:30:00.000', '20160629 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (5999, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20160702 06:30:00.000', '20160702 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6000, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20160706 06:30:00.000', '20160706 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6001, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20160709 06:30:00.000', '20160709 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6002, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20160713 06:30:00.000', '20160713 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6003, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20160716 06:30:00.000', '20160716 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6004, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20160720 06:30:00.000', '20160720 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6005, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20160723 06:30:00.000', '20160723 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6006, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20160727 06:30:00.000', '20160727 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6007, 6, N'Tafseer', N'Tafseer: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Imam Magid</h3>', N'Main Center', '20160730 06:30:00.000', '20160730 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6008, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20110804 06:30:00.000', '20110804 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6009, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20110811 06:30:00.000', '20110811 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6010, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20110818 06:30:00.000', '20110818 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6011, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20110825 06:30:00.000', '20110825 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6012, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20110901 06:30:00.000', '20110901 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6013, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20110908 06:30:00.000', '20110908 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6014, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20110915 06:30:00.000', '20110915 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6015, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20110922 06:30:00.000', '20110922 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6016, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20110929 06:30:00.000', '20110929 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6017, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20111006 06:30:00.000', '20111006 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6018, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20111013 06:30:00.000', '20111013 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6019, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20111020 06:30:00.000', '20111020 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6020, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20111027 06:30:00.000', '20111027 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6021, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20111103 06:30:00.000', '20111103 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6022, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20111110 06:30:00.000', '20111110 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6023, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20111117 06:30:00.000', '20111117 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6024, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20111124 06:30:00.000', '20111124 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6025, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20111201 06:30:00.000', '20111201 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6026, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20111208 06:30:00.000', '20111208 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6027, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20111215 06:30:00.000', '20111215 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6028, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20111222 06:30:00.000', '20111222 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6029, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20111229 06:30:00.000', '20111229 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6030, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20120105 06:30:00.000', '20120105 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6031, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20120112 06:30:00.000', '20120112 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6032, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20120119 06:30:00.000', '20120119 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6033, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20120126 06:30:00.000', '20120126 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6034, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20120202 06:30:00.000', '20120202 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6035, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20120209 06:30:00.000', '20120209 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6036, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20120216 06:30:00.000', '20120216 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6037, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20120223 06:30:00.000', '20120223 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6038, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20120301 06:30:00.000', '20120301 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6039, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20120308 06:30:00.000', '20120308 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6040, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20120315 06:30:00.000', '20120315 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6041, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20120322 06:30:00.000', '20120322 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6042, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20120329 06:30:00.000', '20120329 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6043, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20120405 06:30:00.000', '20120405 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6044, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20120412 06:30:00.000', '20120412 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6045, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20120419 06:30:00.000', '20120419 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6046, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20120426 06:30:00.000', '20120426 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6047, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20120503 06:30:00.000', '20120503 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6048, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20120510 06:30:00.000', '20120510 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6049, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20120517 06:30:00.000', '20120517 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6050, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20120524 06:30:00.000', '20120524 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6051, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20120531 06:30:00.000', '20120531 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6052, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20120607 06:30:00.000', '20120607 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6053, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20120614 06:30:00.000', '20120614 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6054, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20120621 06:30:00.000', '20120621 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6055, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20120628 06:30:00.000', '20120628 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6056, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20120705 06:30:00.000', '20120705 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6057, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20120712 06:30:00.000', '20120712 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6058, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20120719 06:30:00.000', '20120719 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6059, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20120726 06:30:00.000', '20120726 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6060, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20120802 06:30:00.000', '20120802 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6061, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20120809 06:30:00.000', '20120809 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6062, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20120816 06:30:00.000', '20120816 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6063, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20120823 06:30:00.000', '20120823 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6064, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20120830 06:30:00.000', '20120830 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6065, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20120906 06:30:00.000', '20120906 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6066, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20120913 06:30:00.000', '20120913 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6067, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20120920 06:30:00.000', '20120920 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6068, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20120927 06:30:00.000', '20120927 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6069, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20121004 06:30:00.000', '20121004 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6070, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20121011 06:30:00.000', '20121011 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6071, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20121018 06:30:00.000', '20121018 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6072, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20121025 06:30:00.000', '20121025 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6073, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20121101 06:30:00.000', '20121101 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6074, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20121108 06:30:00.000', '20121108 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6075, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20121115 06:30:00.000', '20121115 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6076, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20121122 06:30:00.000', '20121122 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6077, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20121129 06:30:00.000', '20121129 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6078, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20121206 06:30:00.000', '20121206 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6079, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20121213 06:30:00.000', '20121213 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6080, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20121220 06:30:00.000', '20121220 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6081, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20121227 06:30:00.000', '20121227 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6082, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20130103 06:30:00.000', '20130103 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6083, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20130110 06:30:00.000', '20130110 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6084, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20130117 06:30:00.000', '20130117 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6085, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20130124 06:30:00.000', '20130124 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6086, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20130131 06:30:00.000', '20130131 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6087, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20130207 06:30:00.000', '20130207 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6088, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20130214 06:30:00.000', '20130214 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6089, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20130221 06:30:00.000', '20130221 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6090, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20130228 06:30:00.000', '20130228 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6091, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20130307 06:30:00.000', '20130307 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6092, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20130314 06:30:00.000', '20130314 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6093, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20130321 06:30:00.000', '20130321 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6094, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20130328 06:30:00.000', '20130328 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6095, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20130404 06:30:00.000', '20130404 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6096, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20130411 06:30:00.000', '20130411 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6097, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20130418 06:30:00.000', '20130418 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6098, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20130425 06:30:00.000', '20130425 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6099, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20130502 06:30:00.000', '20130502 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6100, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20130509 06:30:00.000', '20130509 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6101, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20130516 06:30:00.000', '20130516 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6102, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20130523 06:30:00.000', '20130523 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6103, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20130530 06:30:00.000', '20130530 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6104, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20130606 06:30:00.000', '20130606 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6105, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20130613 06:30:00.000', '20130613 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6106, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20130620 06:30:00.000', '20130620 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6107, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20130627 06:30:00.000', '20130627 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6108, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20130704 06:30:00.000', '20130704 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6109, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20130711 06:30:00.000', '20130711 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6110, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20130718 06:30:00.000', '20130718 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6111, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20130725 06:30:00.000', '20130725 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6112, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20130801 06:30:00.000', '20130801 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6113, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20130808 06:30:00.000', '20130808 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6114, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20130815 06:30:00.000', '20130815 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6115, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20130822 06:30:00.000', '20130822 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6116, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20130829 06:30:00.000', '20130829 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6117, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20130905 06:30:00.000', '20130905 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6118, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20130912 06:30:00.000', '20130912 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6119, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20130919 06:30:00.000', '20130919 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6120, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20130926 06:30:00.000', '20130926 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6121, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20131003 06:30:00.000', '20131003 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6122, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20131010 06:30:00.000', '20131010 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6123, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20131017 06:30:00.000', '20131017 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6124, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20131024 06:30:00.000', '20131024 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6125, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20131031 06:30:00.000', '20131031 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6126, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20131107 06:30:00.000', '20131107 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6127, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20131114 06:30:00.000', '20131114 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6128, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20131121 06:30:00.000', '20131121 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6129, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20131128 06:30:00.000', '20131128 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6130, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20131205 06:30:00.000', '20131205 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6131, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20131212 06:30:00.000', '20131212 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6132, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20131219 06:30:00.000', '20131219 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6133, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20131226 06:30:00.000', '20131226 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6134, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20140102 06:30:00.000', '20140102 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6135, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20140109 06:30:00.000', '20140109 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6136, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20140116 06:30:00.000', '20140116 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6137, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20140123 06:30:00.000', '20140123 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6138, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20140130 06:30:00.000', '20140130 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6139, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20140206 06:30:00.000', '20140206 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6140, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20140213 06:30:00.000', '20140213 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6141, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20140220 06:30:00.000', '20140220 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6142, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20140227 06:30:00.000', '20140227 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6143, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20140306 06:30:00.000', '20140306 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6144, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20140313 06:30:00.000', '20140313 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6145, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20140320 06:30:00.000', '20140320 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6146, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20140327 06:30:00.000', '20140327 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6147, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20140403 06:30:00.000', '20140403 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6148, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20140410 06:30:00.000', '20140410 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6149, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20140417 06:30:00.000', '20140417 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6150, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20140424 06:30:00.000', '20140424 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6151, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20140501 06:30:00.000', '20140501 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6152, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20140508 06:30:00.000', '20140508 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6153, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20140515 06:30:00.000', '20140515 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6154, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20140522 06:30:00.000', '20140522 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6155, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20140529 06:30:00.000', '20140529 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6156, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20140605 06:30:00.000', '20140605 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6157, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20140612 06:30:00.000', '20140612 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6158, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20140619 06:30:00.000', '20140619 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6159, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20140626 06:30:00.000', '20140626 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6160, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20140703 06:30:00.000', '20140703 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6161, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20140710 06:30:00.000', '20140710 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6162, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20140717 06:30:00.000', '20140717 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6163, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20140724 06:30:00.000', '20140724 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6164, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20140731 06:30:00.000', '20140731 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6165, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20140807 06:30:00.000', '20140807 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6166, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20140814 06:30:00.000', '20140814 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6167, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20140821 06:30:00.000', '20140821 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6168, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20140828 06:30:00.000', '20140828 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6169, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20140904 06:30:00.000', '20140904 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6170, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20140911 06:30:00.000', '20140911 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6171, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20140918 06:30:00.000', '20140918 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6172, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20140925 06:30:00.000', '20140925 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6173, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20141002 06:30:00.000', '20141002 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6174, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20141009 06:30:00.000', '20141009 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6175, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20141016 06:30:00.000', '20141016 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6176, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20141023 06:30:00.000', '20141023 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6177, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20141030 06:30:00.000', '20141030 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6178, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20141106 06:30:00.000', '20141106 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6179, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20141113 06:30:00.000', '20141113 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6180, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20141120 06:30:00.000', '20141120 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6181, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20141127 06:30:00.000', '20141127 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6182, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20141204 06:30:00.000', '20141204 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6183, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20141211 06:30:00.000', '20141211 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6184, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20141218 06:30:00.000', '20141218 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6185, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20141225 06:30:00.000', '20141225 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6186, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20150101 06:30:00.000', '20150101 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6187, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20150108 06:30:00.000', '20150108 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6188, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20150115 06:30:00.000', '20150115 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6189, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20150122 06:30:00.000', '20150122 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6190, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20150129 06:30:00.000', '20150129 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6191, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20150205 06:30:00.000', '20150205 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6192, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20150212 06:30:00.000', '20150212 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6193, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20150219 06:30:00.000', '20150219 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6194, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20150226 06:30:00.000', '20150226 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6195, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20150305 06:30:00.000', '20150305 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6196, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20150312 06:30:00.000', '20150312 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6197, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20150319 06:30:00.000', '20150319 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6198, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20150326 06:30:00.000', '20150326 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6199, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20150402 06:30:00.000', '20150402 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6200, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20150409 06:30:00.000', '20150409 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6201, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20150416 06:30:00.000', '20150416 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6202, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20150423 06:30:00.000', '20150423 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6203, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20150430 06:30:00.000', '20150430 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6204, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20150507 06:30:00.000', '20150507 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6205, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20150514 06:30:00.000', '20150514 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6206, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20150521 06:30:00.000', '20150521 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6207, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20150528 06:30:00.000', '20150528 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6208, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20150604 06:30:00.000', '20150604 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6209, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20150611 06:30:00.000', '20150611 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6210, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20150618 06:30:00.000', '20150618 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6211, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20150625 06:30:00.000', '20150625 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6212, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20150702 06:30:00.000', '20150702 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6213, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20150709 06:30:00.000', '20150709 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6214, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20150716 06:30:00.000', '20150716 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6215, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20150723 06:30:00.000', '20150723 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6216, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20150730 06:30:00.000', '20150730 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6217, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20150806 06:30:00.000', '20150806 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6218, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20150813 06:30:00.000', '20150813 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6219, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20150820 06:30:00.000', '20150820 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6220, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20150827 06:30:00.000', '20150827 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6221, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20150903 06:30:00.000', '20150903 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6222, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20150910 06:30:00.000', '20150910 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6223, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20150917 06:30:00.000', '20150917 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6224, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20150924 06:30:00.000', '20150924 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6225, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20151001 06:30:00.000', '20151001 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6226, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20151008 06:30:00.000', '20151008 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6227, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20151015 06:30:00.000', '20151015 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6228, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20151022 06:30:00.000', '20151022 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6229, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20151029 06:30:00.000', '20151029 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6230, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20151105 06:30:00.000', '20151105 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6231, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20151112 06:30:00.000', '20151112 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6232, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20151119 06:30:00.000', '20151119 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6233, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20151126 06:30:00.000', '20151126 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6234, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20151203 06:30:00.000', '20151203 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6235, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20151210 06:30:00.000', '20151210 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6236, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20151217 06:30:00.000', '20151217 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6237, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20151224 06:30:00.000', '20151224 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6238, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20151231 06:30:00.000', '20151231 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6239, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20160107 06:30:00.000', '20160107 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6240, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20160114 06:30:00.000', '20160114 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6241, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20160121 06:30:00.000', '20160121 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6242, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20160128 06:30:00.000', '20160128 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6243, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20160204 06:30:00.000', '20160204 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6244, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20160211 06:30:00.000', '20160211 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6245, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20160218 06:30:00.000', '20160218 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6246, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20160225 06:30:00.000', '20160225 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6247, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20160303 06:30:00.000', '20160303 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6248, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20160310 06:30:00.000', '20160310 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6249, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20160317 06:30:00.000', '20160317 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6250, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20160324 06:30:00.000', '20160324 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6251, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20160331 06:30:00.000', '20160331 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6252, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20160407 06:30:00.000', '20160407 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6253, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20160414 06:30:00.000', '20160414 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6254, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20160421 06:30:00.000', '20160421 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6255, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20160428 06:30:00.000', '20160428 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6256, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20160505 06:30:00.000', '20160505 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6257, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20160512 06:30:00.000', '20160512 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6258, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20160519 06:30:00.000', '20160519 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6259, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20160526 06:30:00.000', '20160526 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6260, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20160602 06:30:00.000', '20160602 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6261, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20160609 06:30:00.000', '20160609 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6262, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20160616 06:30:00.000', '20160616 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6263, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20160623 06:30:00.000', '20160623 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6264, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20160630 06:30:00.000', '20160630 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6265, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20160707 06:30:00.000', '20160707 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6266, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20160714 06:30:00.000', '20160714 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6267, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20160721 06:30:00.000', '20160721 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6268, 9, N'Tafseer', N'Tafseer: Daoud Nassimi', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Daoud Nassimi</h3>', N'Main Center', '20160728 06:30:00.000', '20160728 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6269, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20110807 06:30:00.000', '20110807 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6270, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20110814 06:30:00.000', '20110814 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6271, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20110821 06:30:00.000', '20110821 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6272, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20110828 06:30:00.000', '20110828 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6273, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20110904 06:30:00.000', '20110904 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6274, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20110911 06:30:00.000', '20110911 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6275, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20110918 06:30:00.000', '20110918 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6276, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20110925 06:30:00.000', '20110925 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6277, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20111002 06:30:00.000', '20111002 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6278, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20111009 06:30:00.000', '20111009 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6279, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20111016 06:30:00.000', '20111016 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6280, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20111023 06:30:00.000', '20111023 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6281, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20111030 06:30:00.000', '20111030 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6282, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20111106 06:30:00.000', '20111106 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6283, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20111113 06:30:00.000', '20111113 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6284, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20111120 06:30:00.000', '20111120 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6285, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20111127 06:30:00.000', '20111127 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6286, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20111204 06:30:00.000', '20111204 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6287, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20111211 06:30:00.000', '20111211 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6288, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20111218 06:30:00.000', '20111218 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6289, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20111225 06:30:00.000', '20111225 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6290, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20120101 06:30:00.000', '20120101 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6291, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20120108 06:30:00.000', '20120108 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6292, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20120115 06:30:00.000', '20120115 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6293, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20120122 06:30:00.000', '20120122 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6294, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20120129 06:30:00.000', '20120129 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6295, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20120205 06:30:00.000', '20120205 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6296, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20120212 06:30:00.000', '20120212 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6297, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20120219 06:30:00.000', '20120219 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6298, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20120226 06:30:00.000', '20120226 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6299, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20120304 06:30:00.000', '20120304 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6300, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20120311 06:30:00.000', '20120311 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6301, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20120318 06:30:00.000', '20120318 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6302, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20120325 06:30:00.000', '20120325 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6303, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20120401 06:30:00.000', '20120401 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6304, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20120408 06:30:00.000', '20120408 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6305, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20120415 06:30:00.000', '20120415 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6306, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20120422 06:30:00.000', '20120422 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6307, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20120429 06:30:00.000', '20120429 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6308, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20120506 06:30:00.000', '20120506 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6309, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20120513 06:30:00.000', '20120513 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6310, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20120520 06:30:00.000', '20120520 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6311, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20120527 06:30:00.000', '20120527 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6312, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20120603 06:30:00.000', '20120603 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6313, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20120610 06:30:00.000', '20120610 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6314, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20120617 06:30:00.000', '20120617 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6315, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20120624 06:30:00.000', '20120624 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6316, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20120701 06:30:00.000', '20120701 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6317, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20120708 06:30:00.000', '20120708 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6318, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20120715 06:30:00.000', '20120715 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6319, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20120722 06:30:00.000', '20120722 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6320, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20120729 06:30:00.000', '20120729 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6321, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20120805 06:30:00.000', '20120805 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6322, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20120812 06:30:00.000', '20120812 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6323, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20120819 06:30:00.000', '20120819 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6324, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20120826 06:30:00.000', '20120826 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6325, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20120902 06:30:00.000', '20120902 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6326, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20120909 06:30:00.000', '20120909 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6327, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20120916 06:30:00.000', '20120916 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6328, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20120923 06:30:00.000', '20120923 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6329, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20120930 06:30:00.000', '20120930 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6330, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20121007 06:30:00.000', '20121007 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6331, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20121014 06:30:00.000', '20121014 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6332, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20121021 06:30:00.000', '20121021 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6333, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20121028 06:30:00.000', '20121028 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6334, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20121104 06:30:00.000', '20121104 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6335, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20121111 06:30:00.000', '20121111 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6336, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20121118 06:30:00.000', '20121118 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6337, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20121125 06:30:00.000', '20121125 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6338, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20121202 06:30:00.000', '20121202 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6339, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20121209 06:30:00.000', '20121209 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6340, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20121216 06:30:00.000', '20121216 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6341, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20121223 06:30:00.000', '20121223 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6342, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20121230 06:30:00.000', '20121230 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6343, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20130106 06:30:00.000', '20130106 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6344, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20130113 06:30:00.000', '20130113 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6345, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20130120 06:30:00.000', '20130120 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6346, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20130127 06:30:00.000', '20130127 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6347, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20130203 06:30:00.000', '20130203 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6348, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20130210 06:30:00.000', '20130210 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6349, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20130217 06:30:00.000', '20130217 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6350, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20130224 06:30:00.000', '20130224 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6351, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20130303 06:30:00.000', '20130303 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6352, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20130310 06:30:00.000', '20130310 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6353, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20130317 06:30:00.000', '20130317 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6354, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20130324 06:30:00.000', '20130324 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6355, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20130331 06:30:00.000', '20130331 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6356, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20130407 06:30:00.000', '20130407 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6357, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20130414 06:30:00.000', '20130414 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6358, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20130421 06:30:00.000', '20130421 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6359, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20130428 06:30:00.000', '20130428 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6360, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20130505 06:30:00.000', '20130505 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6361, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20130512 06:30:00.000', '20130512 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6362, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20130519 06:30:00.000', '20130519 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6363, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20130526 06:30:00.000', '20130526 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6364, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20130602 06:30:00.000', '20130602 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6365, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20130609 06:30:00.000', '20130609 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6366, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20130616 06:30:00.000', '20130616 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6367, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20130623 06:30:00.000', '20130623 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6368, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20130630 06:30:00.000', '20130630 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6369, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20130707 06:30:00.000', '20130707 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6370, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20130714 06:30:00.000', '20130714 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6371, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20130721 06:30:00.000', '20130721 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6372, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20130728 06:30:00.000', '20130728 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6373, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20130804 06:30:00.000', '20130804 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6374, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20130811 06:30:00.000', '20130811 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6375, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20130818 06:30:00.000', '20130818 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6376, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20130825 06:30:00.000', '20130825 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6377, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20130901 06:30:00.000', '20130901 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6378, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20130908 06:30:00.000', '20130908 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6379, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20130915 06:30:00.000', '20130915 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6380, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20130922 06:30:00.000', '20130922 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6381, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20130929 06:30:00.000', '20130929 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6382, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20131006 06:30:00.000', '20131006 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6383, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20131013 06:30:00.000', '20131013 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6384, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20131020 06:30:00.000', '20131020 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6385, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20131027 06:30:00.000', '20131027 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6386, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20131103 06:30:00.000', '20131103 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6387, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20131110 06:30:00.000', '20131110 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6388, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20131117 06:30:00.000', '20131117 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6389, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20131124 06:30:00.000', '20131124 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6390, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20131201 06:30:00.000', '20131201 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6391, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20131208 06:30:00.000', '20131208 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6392, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20131215 06:30:00.000', '20131215 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6393, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20131222 06:30:00.000', '20131222 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6394, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20131229 06:30:00.000', '20131229 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6395, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20140105 06:30:00.000', '20140105 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6396, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20140112 06:30:00.000', '20140112 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6397, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20140119 06:30:00.000', '20140119 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6398, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20140126 06:30:00.000', '20140126 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6399, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20140202 06:30:00.000', '20140202 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6400, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20140209 06:30:00.000', '20140209 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6401, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20140216 06:30:00.000', '20140216 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6402, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20140223 06:30:00.000', '20140223 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6403, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20140302 06:30:00.000', '20140302 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6404, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20140309 06:30:00.000', '20140309 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6405, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20140316 06:30:00.000', '20140316 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6406, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20140323 06:30:00.000', '20140323 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6407, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20140330 06:30:00.000', '20140330 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6408, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20140406 06:30:00.000', '20140406 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6409, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20140413 06:30:00.000', '20140413 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6410, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20140420 06:30:00.000', '20140420 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6411, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20140427 06:30:00.000', '20140427 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6412, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20140504 06:30:00.000', '20140504 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6413, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20140511 06:30:00.000', '20140511 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6414, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20140518 06:30:00.000', '20140518 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6415, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20140525 06:30:00.000', '20140525 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6416, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20140601 06:30:00.000', '20140601 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6417, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20140608 06:30:00.000', '20140608 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6418, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20140615 06:30:00.000', '20140615 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6419, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20140622 06:30:00.000', '20140622 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6420, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20140629 06:30:00.000', '20140629 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6421, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20140706 06:30:00.000', '20140706 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6422, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20140713 06:30:00.000', '20140713 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6423, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20140720 06:30:00.000', '20140720 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6424, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20140727 06:30:00.000', '20140727 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6425, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20140803 06:30:00.000', '20140803 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6426, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20140810 06:30:00.000', '20140810 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6427, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20140817 06:30:00.000', '20140817 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6428, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20140824 06:30:00.000', '20140824 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6429, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20140831 06:30:00.000', '20140831 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6430, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20140907 06:30:00.000', '20140907 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6431, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20140914 06:30:00.000', '20140914 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6432, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20140921 06:30:00.000', '20140921 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6433, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20140928 06:30:00.000', '20140928 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6434, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20141005 06:30:00.000', '20141005 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6435, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20141012 06:30:00.000', '20141012 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6436, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20141019 06:30:00.000', '20141019 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6437, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20141026 06:30:00.000', '20141026 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6438, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20141102 06:30:00.000', '20141102 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6439, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20141109 06:30:00.000', '20141109 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6440, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20141116 06:30:00.000', '20141116 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6441, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20141123 06:30:00.000', '20141123 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6442, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20141130 06:30:00.000', '20141130 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6443, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20141207 06:30:00.000', '20141207 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6444, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20141214 06:30:00.000', '20141214 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6445, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20141221 06:30:00.000', '20141221 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6446, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20141228 06:30:00.000', '20141228 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6447, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20150104 06:30:00.000', '20150104 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6448, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20150111 06:30:00.000', '20150111 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6449, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20150118 06:30:00.000', '20150118 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6450, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20150125 06:30:00.000', '20150125 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6451, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20150201 06:30:00.000', '20150201 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6452, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20150208 06:30:00.000', '20150208 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6453, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20150215 06:30:00.000', '20150215 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6454, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20150222 06:30:00.000', '20150222 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6455, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20150301 06:30:00.000', '20150301 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6456, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20150308 06:30:00.000', '20150308 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6457, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20150315 06:30:00.000', '20150315 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6458, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20150322 06:30:00.000', '20150322 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6459, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20150329 06:30:00.000', '20150329 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6460, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20150405 06:30:00.000', '20150405 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6461, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20150412 06:30:00.000', '20150412 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6462, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20150419 06:30:00.000', '20150419 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6463, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20150426 06:30:00.000', '20150426 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6464, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20150503 06:30:00.000', '20150503 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6465, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20150510 06:30:00.000', '20150510 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6466, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20150517 06:30:00.000', '20150517 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6467, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20150524 06:30:00.000', '20150524 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6468, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20150531 06:30:00.000', '20150531 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6469, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20150607 06:30:00.000', '20150607 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6470, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20150614 06:30:00.000', '20150614 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6471, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20150621 06:30:00.000', '20150621 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6472, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20150628 06:30:00.000', '20150628 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6473, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20150705 06:30:00.000', '20150705 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6474, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20150712 06:30:00.000', '20150712 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6475, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20150719 06:30:00.000', '20150719 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6476, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20150726 06:30:00.000', '20150726 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6477, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20150802 06:30:00.000', '20150802 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6478, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20150809 06:30:00.000', '20150809 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6479, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20150816 06:30:00.000', '20150816 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6480, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20150823 06:30:00.000', '20150823 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6481, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20150830 06:30:00.000', '20150830 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6482, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20150906 06:30:00.000', '20150906 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6483, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20150913 06:30:00.000', '20150913 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6484, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20150920 06:30:00.000', '20150920 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6485, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20150927 06:30:00.000', '20150927 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6486, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20151004 06:30:00.000', '20151004 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6487, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20151011 06:30:00.000', '20151011 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6488, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20151018 06:30:00.000', '20151018 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6489, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20151025 06:30:00.000', '20151025 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6490, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20151101 06:30:00.000', '20151101 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6491, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20151108 06:30:00.000', '20151108 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6492, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20151115 06:30:00.000', '20151115 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6493, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20151122 06:30:00.000', '20151122 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6494, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20151129 06:30:00.000', '20151129 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6495, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20151206 06:30:00.000', '20151206 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6496, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20151213 06:30:00.000', '20151213 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6497, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20151220 06:30:00.000', '20151220 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6498, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20151227 06:30:00.000', '20151227 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6499, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20160103 06:30:00.000', '20160103 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6500, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20160110 06:30:00.000', '20160110 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6501, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20160117 06:30:00.000', '20160117 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6502, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20160124 06:30:00.000', '20160124 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6503, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20160131 06:30:00.000', '20160131 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6504, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20160207 06:30:00.000', '20160207 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6505, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20160214 06:30:00.000', '20160214 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6506, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20160221 06:30:00.000', '20160221 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6507, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20160228 06:30:00.000', '20160228 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6508, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20160306 06:30:00.000', '20160306 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6509, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20160313 06:30:00.000', '20160313 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6510, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20160320 06:30:00.000', '20160320 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6511, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20160327 06:30:00.000', '20160327 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6512, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20160403 06:30:00.000', '20160403 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6513, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20160410 06:30:00.000', '20160410 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6514, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20160417 06:30:00.000', '20160417 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6515, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20160424 06:30:00.000', '20160424 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6516, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20160501 06:30:00.000', '20160501 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6517, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20160508 06:30:00.000', '20160508 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6518, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20160515 06:30:00.000', '20160515 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6519, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20160522 06:30:00.000', '20160522 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6520, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20160529 06:30:00.000', '20160529 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6521, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20160605 06:30:00.000', '20160605 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6522, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20160612 06:30:00.000', '20160612 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6523, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20160619 06:30:00.000', '20160619 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6524, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20160626 06:30:00.000', '20160626 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6525, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20160703 06:30:00.000', '20160703 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6526, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20160710 06:30:00.000', '20160710 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6527, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20160717 06:30:00.000', '20160717 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6528, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20160724 06:30:00.000', '20160724 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6529, 13, N'Tafseer', N'Tafseer: Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Abdurrafaa</h3>', N'Main Center', '20160731 06:30:00.000', '20160731 19:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6530, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20110803 19:00:00.000', '20110803 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6531, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20110810 19:00:00.000', '20110810 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6532, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20110817 19:00:00.000', '20110817 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6533, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20110824 19:00:00.000', '20110824 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6534, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20110831 19:00:00.000', '20110831 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6535, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20110907 19:00:00.000', '20110907 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6536, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20110914 19:00:00.000', '20110914 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6537, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20110921 19:00:00.000', '20110921 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6538, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20110928 19:00:00.000', '20110928 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6539, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20111005 19:00:00.000', '20111005 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6540, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20111012 19:00:00.000', '20111012 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6541, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20111019 19:00:00.000', '20111019 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6542, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20111026 19:00:00.000', '20111026 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6543, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20111102 19:00:00.000', '20111102 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6544, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20111109 19:00:00.000', '20111109 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6545, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20111116 19:00:00.000', '20111116 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6546, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20111123 19:00:00.000', '20111123 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6547, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20111130 19:00:00.000', '20111130 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6548, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20111207 19:00:00.000', '20111207 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6549, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20111214 19:00:00.000', '20111214 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6550, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20111221 19:00:00.000', '20111221 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6551, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20111228 19:00:00.000', '20111228 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6552, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20120104 19:00:00.000', '20120104 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6553, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20120111 19:00:00.000', '20120111 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6554, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20120118 19:00:00.000', '20120118 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6555, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20120125 19:00:00.000', '20120125 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6556, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20120201 19:00:00.000', '20120201 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6557, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20120208 19:00:00.000', '20120208 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6558, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20120215 19:00:00.000', '20120215 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6559, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20120222 19:00:00.000', '20120222 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6560, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20120229 19:00:00.000', '20120229 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6561, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20120307 19:00:00.000', '20120307 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6562, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20120314 19:00:00.000', '20120314 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6563, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20120321 19:00:00.000', '20120321 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6564, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20120328 19:00:00.000', '20120328 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6565, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20120404 19:00:00.000', '20120404 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6566, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20120411 19:00:00.000', '20120411 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6567, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20120418 19:00:00.000', '20120418 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6568, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20120425 19:00:00.000', '20120425 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6569, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20120502 19:00:00.000', '20120502 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6570, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20120509 19:00:00.000', '20120509 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6571, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20120516 19:00:00.000', '20120516 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6572, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20120523 19:00:00.000', '20120523 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6573, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20120530 19:00:00.000', '20120530 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6574, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20120606 19:00:00.000', '20120606 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6575, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20120613 19:00:00.000', '20120613 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6576, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20120620 19:00:00.000', '20120620 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6577, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20120627 19:00:00.000', '20120627 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6578, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20120704 19:00:00.000', '20120704 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6579, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20120711 19:00:00.000', '20120711 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6580, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20120718 19:00:00.000', '20120718 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6581, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20120725 19:00:00.000', '20120725 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6582, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20120801 19:00:00.000', '20120801 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6583, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20120808 19:00:00.000', '20120808 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6584, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20120815 19:00:00.000', '20120815 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6585, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20120822 19:00:00.000', '20120822 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6586, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20120829 19:00:00.000', '20120829 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6587, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20120905 19:00:00.000', '20120905 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6588, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20120912 19:00:00.000', '20120912 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6589, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20120919 19:00:00.000', '20120919 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6590, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20120926 19:00:00.000', '20120926 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6591, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20121003 19:00:00.000', '20121003 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6592, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20121010 19:00:00.000', '20121010 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6593, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20121017 19:00:00.000', '20121017 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6594, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20121024 19:00:00.000', '20121024 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6595, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20121031 19:00:00.000', '20121031 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6596, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20121107 19:00:00.000', '20121107 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6597, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20121114 19:00:00.000', '20121114 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6598, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20121121 19:00:00.000', '20121121 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6599, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20121128 19:00:00.000', '20121128 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6600, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20121205 19:00:00.000', '20121205 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6601, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20121212 19:00:00.000', '20121212 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6602, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20121219 19:00:00.000', '20121219 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6603, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20121226 19:00:00.000', '20121226 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6604, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20130102 19:00:00.000', '20130102 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6605, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20130109 19:00:00.000', '20130109 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6606, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20130116 19:00:00.000', '20130116 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6607, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20130123 19:00:00.000', '20130123 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6608, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20130130 19:00:00.000', '20130130 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6609, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20130206 19:00:00.000', '20130206 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6610, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20130213 19:00:00.000', '20130213 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6611, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20130220 19:00:00.000', '20130220 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6612, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20130227 19:00:00.000', '20130227 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6613, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20130306 19:00:00.000', '20130306 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6614, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20130313 19:00:00.000', '20130313 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6615, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20130320 19:00:00.000', '20130320 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6616, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20130327 19:00:00.000', '20130327 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6617, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20130403 19:00:00.000', '20130403 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6618, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20130410 19:00:00.000', '20130410 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6619, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20130417 19:00:00.000', '20130417 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6620, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20130424 19:00:00.000', '20130424 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6621, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20130501 19:00:00.000', '20130501 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6622, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20130508 19:00:00.000', '20130508 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6623, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20130515 19:00:00.000', '20130515 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6624, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20130522 19:00:00.000', '20130522 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6625, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20130529 19:00:00.000', '20130529 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6626, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20130605 19:00:00.000', '20130605 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6627, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20130612 19:00:00.000', '20130612 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6628, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20130619 19:00:00.000', '20130619 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6629, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20130626 19:00:00.000', '20130626 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6630, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20130703 19:00:00.000', '20130703 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6631, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20130710 19:00:00.000', '20130710 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6632, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20130717 19:00:00.000', '20130717 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6633, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20130724 19:00:00.000', '20130724 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6634, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20130731 19:00:00.000', '20130731 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6635, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20130807 19:00:00.000', '20130807 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6636, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20130814 19:00:00.000', '20130814 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6637, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20130821 19:00:00.000', '20130821 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6638, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20130828 19:00:00.000', '20130828 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6639, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20130904 19:00:00.000', '20130904 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6640, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20130911 19:00:00.000', '20130911 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6641, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20130918 19:00:00.000', '20130918 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6642, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20130925 19:00:00.000', '20130925 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6643, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20131002 19:00:00.000', '20131002 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6644, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20131009 19:00:00.000', '20131009 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6645, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20131016 19:00:00.000', '20131016 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6646, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20131023 19:00:00.000', '20131023 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6647, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20131030 19:00:00.000', '20131030 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6648, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20131106 19:00:00.000', '20131106 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6649, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20131113 19:00:00.000', '20131113 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6650, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20131120 19:00:00.000', '20131120 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6651, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20131127 19:00:00.000', '20131127 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6652, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20131204 19:00:00.000', '20131204 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6653, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20131211 19:00:00.000', '20131211 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6654, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20131218 19:00:00.000', '20131218 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6655, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20131225 19:00:00.000', '20131225 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6656, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20140101 19:00:00.000', '20140101 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6657, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20140108 19:00:00.000', '20140108 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6658, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20140115 19:00:00.000', '20140115 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6659, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20140122 19:00:00.000', '20140122 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6660, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20140129 19:00:00.000', '20140129 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6661, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20140205 19:00:00.000', '20140205 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6662, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20140212 19:00:00.000', '20140212 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6663, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20140219 19:00:00.000', '20140219 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6664, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20140226 19:00:00.000', '20140226 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6665, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20140305 19:00:00.000', '20140305 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6666, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20140312 19:00:00.000', '20140312 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6667, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20140319 19:00:00.000', '20140319 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6668, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20140326 19:00:00.000', '20140326 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6669, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20140402 19:00:00.000', '20140402 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6670, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20140409 19:00:00.000', '20140409 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6671, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20140416 19:00:00.000', '20140416 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6672, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20140423 19:00:00.000', '20140423 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6673, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20140430 19:00:00.000', '20140430 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6674, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20140507 19:00:00.000', '20140507 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6675, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20140514 19:00:00.000', '20140514 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6676, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20140521 19:00:00.000', '20140521 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6677, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20140528 19:00:00.000', '20140528 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6678, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20140604 19:00:00.000', '20140604 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6679, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20140611 19:00:00.000', '20140611 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6680, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20140618 19:00:00.000', '20140618 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6681, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20140625 19:00:00.000', '20140625 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6682, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20140702 19:00:00.000', '20140702 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6683, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20140709 19:00:00.000', '20140709 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6684, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20140716 19:00:00.000', '20140716 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6685, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20140723 19:00:00.000', '20140723 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6686, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20140730 19:00:00.000', '20140730 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6687, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20140806 19:00:00.000', '20140806 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6688, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20140813 19:00:00.000', '20140813 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6689, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20140820 19:00:00.000', '20140820 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6690, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20140827 19:00:00.000', '20140827 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6691, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20140903 19:00:00.000', '20140903 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6692, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20140910 19:00:00.000', '20140910 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6693, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20140917 19:00:00.000', '20140917 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6694, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20140924 19:00:00.000', '20140924 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6695, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20141001 19:00:00.000', '20141001 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6696, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20141008 19:00:00.000', '20141008 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6697, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20141015 19:00:00.000', '20141015 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6698, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20141022 19:00:00.000', '20141022 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6699, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20141029 19:00:00.000', '20141029 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6700, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20141105 19:00:00.000', '20141105 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6701, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20141112 19:00:00.000', '20141112 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6702, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20141119 19:00:00.000', '20141119 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6703, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20141126 19:00:00.000', '20141126 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6704, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20141203 19:00:00.000', '20141203 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6705, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20141210 19:00:00.000', '20141210 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6706, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20141217 19:00:00.000', '20141217 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6707, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20141224 19:00:00.000', '20141224 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6708, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20141231 19:00:00.000', '20141231 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6709, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20150107 19:00:00.000', '20150107 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6710, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20150114 19:00:00.000', '20150114 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6711, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20150121 19:00:00.000', '20150121 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6712, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20150128 19:00:00.000', '20150128 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6713, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20150204 19:00:00.000', '20150204 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6714, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20150211 19:00:00.000', '20150211 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6715, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20150218 19:00:00.000', '20150218 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6716, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20150225 19:00:00.000', '20150225 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6717, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20150304 19:00:00.000', '20150304 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6718, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20150311 19:00:00.000', '20150311 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6719, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20150318 19:00:00.000', '20150318 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6720, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20150325 19:00:00.000', '20150325 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6721, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20150401 19:00:00.000', '20150401 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6722, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20150408 19:00:00.000', '20150408 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6723, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20150415 19:00:00.000', '20150415 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6724, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20150422 19:00:00.000', '20150422 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6725, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20150429 19:00:00.000', '20150429 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6726, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20150506 19:00:00.000', '20150506 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6727, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20150513 19:00:00.000', '20150513 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6728, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20150520 19:00:00.000', '20150520 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6729, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20150527 19:00:00.000', '20150527 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6730, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20150603 19:00:00.000', '20150603 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6731, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20150610 19:00:00.000', '20150610 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6732, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20150617 19:00:00.000', '20150617 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6733, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20150624 19:00:00.000', '20150624 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6734, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20150701 19:00:00.000', '20150701 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6735, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20150708 19:00:00.000', '20150708 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6736, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20150715 19:00:00.000', '20150715 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6737, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20150722 19:00:00.000', '20150722 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6738, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20150729 19:00:00.000', '20150729 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6739, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20150805 19:00:00.000', '20150805 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6740, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20150812 19:00:00.000', '20150812 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6741, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20150819 19:00:00.000', '20150819 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6742, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20150826 19:00:00.000', '20150826 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6743, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20150902 19:00:00.000', '20150902 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6744, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20150909 19:00:00.000', '20150909 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6745, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20150916 19:00:00.000', '20150916 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6746, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20150923 19:00:00.000', '20150923 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6747, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20150930 19:00:00.000', '20150930 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6748, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20151007 19:00:00.000', '20151007 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6749, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20151014 19:00:00.000', '20151014 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6750, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20151021 19:00:00.000', '20151021 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6751, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20151028 19:00:00.000', '20151028 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6752, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20151104 19:00:00.000', '20151104 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6753, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20151111 19:00:00.000', '20151111 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6754, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20151118 19:00:00.000', '20151118 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6755, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20151125 19:00:00.000', '20151125 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6756, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20151202 19:00:00.000', '20151202 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6757, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20151209 19:00:00.000', '20151209 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6758, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20151216 19:00:00.000', '20151216 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6759, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20151223 19:00:00.000', '20151223 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6760, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20151230 19:00:00.000', '20151230 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6761, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20160106 19:00:00.000', '20160106 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6762, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20160113 19:00:00.000', '20160113 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6763, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20160120 19:00:00.000', '20160120 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6764, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20160127 19:00:00.000', '20160127 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6765, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20160203 19:00:00.000', '20160203 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6766, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20160210 19:00:00.000', '20160210 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6767, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20160217 19:00:00.000', '20160217 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6768, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20160224 19:00:00.000', '20160224 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6769, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20160302 19:00:00.000', '20160302 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6770, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20160309 19:00:00.000', '20160309 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6771, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20160316 19:00:00.000', '20160316 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6772, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20160323 19:00:00.000', '20160323 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6773, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20160330 19:00:00.000', '20160330 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6774, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20160406 19:00:00.000', '20160406 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6775, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20160413 19:00:00.000', '20160413 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6776, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20160420 19:00:00.000', '20160420 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6777, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20160427 19:00:00.000', '20160427 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6778, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20160504 19:00:00.000', '20160504 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6779, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20160511 19:00:00.000', '20160511 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6780, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20160518 19:00:00.000', '20160518 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6781, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20160525 19:00:00.000', '20160525 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6782, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20160601 19:00:00.000', '20160601 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6783, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20160608 19:00:00.000', '20160608 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6784, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20160615 19:00:00.000', '20160615 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6785, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20160622 19:00:00.000', '20160622 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6786, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20160629 19:00:00.000', '20160629 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6787, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20160706 19:00:00.000', '20160706 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6788, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20160713 19:00:00.000', '20160713 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6789, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20160720 19:00:00.000', '20160720 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6790, 8, N'Prophetic Guidance - Seerah', N'Prophetic Guidance - Seerah: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Prophetic Guidance - Seerah: Sh. Abdurrafaa</h3>', N'Main Center', '20160727 19:00:00.000', '20160727 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6791, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20110802 21:00:00.000', '20110802 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6792, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20110803 21:00:00.000', '20110803 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6793, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20110809 21:00:00.000', '20110809 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6794, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20110810 21:00:00.000', '20110810 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6795, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20110816 21:00:00.000', '20110816 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6796, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20110817 21:00:00.000', '20110817 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6797, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20110823 21:00:00.000', '20110823 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6798, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20110824 21:00:00.000', '20110824 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6799, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20110830 21:00:00.000', '20110830 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6800, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20110831 21:00:00.000', '20110831 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6801, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20110906 21:00:00.000', '20110906 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6802, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20110907 21:00:00.000', '20110907 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6803, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20110913 21:00:00.000', '20110913 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6804, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20110914 21:00:00.000', '20110914 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6805, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20110920 21:00:00.000', '20110920 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6806, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20110921 21:00:00.000', '20110921 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6807, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20110927 21:00:00.000', '20110927 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6808, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20110928 21:00:00.000', '20110928 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6809, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20111004 21:00:00.000', '20111004 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6810, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20111005 21:00:00.000', '20111005 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6811, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20111011 21:00:00.000', '20111011 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6812, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20111012 21:00:00.000', '20111012 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6813, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20111018 21:00:00.000', '20111018 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6814, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20111019 21:00:00.000', '20111019 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6815, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20111025 21:00:00.000', '20111025 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6816, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20111026 21:00:00.000', '20111026 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6817, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20111101 21:00:00.000', '20111101 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6818, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20111102 21:00:00.000', '20111102 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6819, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20111108 21:00:00.000', '20111108 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6820, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20111109 21:00:00.000', '20111109 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6821, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20111115 21:00:00.000', '20111115 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6822, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20111116 21:00:00.000', '20111116 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6823, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20111122 21:00:00.000', '20111122 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6824, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20111123 21:00:00.000', '20111123 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6825, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20111129 21:00:00.000', '20111129 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6826, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20111130 21:00:00.000', '20111130 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6827, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20111206 21:00:00.000', '20111206 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6828, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20111207 21:00:00.000', '20111207 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6829, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20111213 21:00:00.000', '20111213 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6830, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20111214 21:00:00.000', '20111214 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6831, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20111220 21:00:00.000', '20111220 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6832, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20111221 21:00:00.000', '20111221 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6833, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20111227 21:00:00.000', '20111227 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6834, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20111228 21:00:00.000', '20111228 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6835, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20120103 21:00:00.000', '20120103 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6836, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20120104 21:00:00.000', '20120104 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6837, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20120110 21:00:00.000', '20120110 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6838, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20120111 21:00:00.000', '20120111 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6839, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20120117 21:00:00.000', '20120117 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6840, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20120118 21:00:00.000', '20120118 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6841, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20120124 21:00:00.000', '20120124 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6842, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20120125 21:00:00.000', '20120125 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6843, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20120131 21:00:00.000', '20120131 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6844, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20120201 21:00:00.000', '20120201 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6845, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20120207 21:00:00.000', '20120207 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6846, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20120208 21:00:00.000', '20120208 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6847, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20120214 21:00:00.000', '20120214 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6848, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20120215 21:00:00.000', '20120215 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6849, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20120221 21:00:00.000', '20120221 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6850, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20120222 21:00:00.000', '20120222 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6851, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20120228 21:00:00.000', '20120228 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6852, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20120229 21:00:00.000', '20120229 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6853, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20120306 21:00:00.000', '20120306 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6854, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20120307 21:00:00.000', '20120307 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6855, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20120313 21:00:00.000', '20120313 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6856, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20120314 21:00:00.000', '20120314 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6857, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20120320 21:00:00.000', '20120320 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6858, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20120321 21:00:00.000', '20120321 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6859, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20120327 21:00:00.000', '20120327 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6860, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20120328 21:00:00.000', '20120328 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6861, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20120403 21:00:00.000', '20120403 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6862, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20120404 21:00:00.000', '20120404 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6863, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20120410 21:00:00.000', '20120410 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6864, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20120411 21:00:00.000', '20120411 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6865, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20120417 21:00:00.000', '20120417 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6866, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20120418 21:00:00.000', '20120418 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6867, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20120424 21:00:00.000', '20120424 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6868, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20120425 21:00:00.000', '20120425 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6869, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20120501 21:00:00.000', '20120501 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6870, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20120502 21:00:00.000', '20120502 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6871, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20120508 21:00:00.000', '20120508 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6872, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20120509 21:00:00.000', '20120509 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6873, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20120515 21:00:00.000', '20120515 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6874, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20120516 21:00:00.000', '20120516 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6875, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20120522 21:00:00.000', '20120522 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6876, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20120523 21:00:00.000', '20120523 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6877, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20120529 21:00:00.000', '20120529 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6878, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20120530 21:00:00.000', '20120530 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6879, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20120605 21:00:00.000', '20120605 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6880, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20120606 21:00:00.000', '20120606 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6881, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20120612 21:00:00.000', '20120612 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6882, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20120613 21:00:00.000', '20120613 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6883, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20120619 21:00:00.000', '20120619 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6884, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20120620 21:00:00.000', '20120620 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6885, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20120626 21:00:00.000', '20120626 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6886, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20120627 21:00:00.000', '20120627 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6887, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20120703 21:00:00.000', '20120703 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6888, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20120704 21:00:00.000', '20120704 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6889, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20120710 21:00:00.000', '20120710 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6890, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20120711 21:00:00.000', '20120711 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6891, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20120717 21:00:00.000', '20120717 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6892, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20120718 21:00:00.000', '20120718 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6893, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20120724 21:00:00.000', '20120724 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6894, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20120725 21:00:00.000', '20120725 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6895, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20120731 21:00:00.000', '20120731 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6896, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20120801 21:00:00.000', '20120801 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6897, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20120807 21:00:00.000', '20120807 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6898, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20120808 21:00:00.000', '20120808 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6899, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20120814 21:00:00.000', '20120814 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6900, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20120815 21:00:00.000', '20120815 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6901, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20120821 21:00:00.000', '20120821 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6902, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20120822 21:00:00.000', '20120822 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6903, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20120828 21:00:00.000', '20120828 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6904, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20120829 21:00:00.000', '20120829 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6905, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20120904 21:00:00.000', '20120904 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6906, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20120905 21:00:00.000', '20120905 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6907, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20120911 21:00:00.000', '20120911 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6908, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20120912 21:00:00.000', '20120912 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6909, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20120918 21:00:00.000', '20120918 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6910, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20120919 21:00:00.000', '20120919 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6911, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20120925 21:00:00.000', '20120925 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6912, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20120926 21:00:00.000', '20120926 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6913, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20121002 21:00:00.000', '20121002 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6914, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20121003 21:00:00.000', '20121003 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6915, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20121009 21:00:00.000', '20121009 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6916, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20121010 21:00:00.000', '20121010 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6917, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20121016 21:00:00.000', '20121016 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6918, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20121017 21:00:00.000', '20121017 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6919, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20121023 21:00:00.000', '20121023 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6920, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20121024 21:00:00.000', '20121024 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6921, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20121030 21:00:00.000', '20121030 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6922, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20121031 21:00:00.000', '20121031 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6923, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20121106 21:00:00.000', '20121106 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6924, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20121107 21:00:00.000', '20121107 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6925, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20121113 21:00:00.000', '20121113 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6926, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20121114 21:00:00.000', '20121114 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6927, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20121120 21:00:00.000', '20121120 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6928, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20121121 21:00:00.000', '20121121 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6929, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20121127 21:00:00.000', '20121127 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6930, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20121128 21:00:00.000', '20121128 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6931, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20121204 21:00:00.000', '20121204 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6932, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20121205 21:00:00.000', '20121205 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6933, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20121211 21:00:00.000', '20121211 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6934, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20121212 21:00:00.000', '20121212 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6935, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20121218 21:00:00.000', '20121218 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6936, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20121219 21:00:00.000', '20121219 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6937, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20121225 21:00:00.000', '20121225 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6938, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20121226 21:00:00.000', '20121226 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6939, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20130101 21:00:00.000', '20130101 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6940, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20130102 21:00:00.000', '20130102 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6941, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20130108 21:00:00.000', '20130108 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6942, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20130109 21:00:00.000', '20130109 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6943, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20130115 21:00:00.000', '20130115 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6944, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20130116 21:00:00.000', '20130116 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6945, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20130122 21:00:00.000', '20130122 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6946, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20130123 21:00:00.000', '20130123 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6947, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20130129 21:00:00.000', '20130129 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6948, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20130130 21:00:00.000', '20130130 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6949, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20130205 21:00:00.000', '20130205 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6950, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20130206 21:00:00.000', '20130206 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6951, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20130212 21:00:00.000', '20130212 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6952, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20130213 21:00:00.000', '20130213 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6953, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20130219 21:00:00.000', '20130219 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6954, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20130220 21:00:00.000', '20130220 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6955, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20130226 21:00:00.000', '20130226 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6956, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20130227 21:00:00.000', '20130227 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6957, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20130305 21:00:00.000', '20130305 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6958, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20130306 21:00:00.000', '20130306 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6959, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20130312 21:00:00.000', '20130312 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6960, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20130313 21:00:00.000', '20130313 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6961, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20130319 21:00:00.000', '20130319 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6962, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20130320 21:00:00.000', '20130320 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6963, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20130326 21:00:00.000', '20130326 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6964, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20130327 21:00:00.000', '20130327 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6965, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20130402 21:00:00.000', '20130402 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6966, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20130403 21:00:00.000', '20130403 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6967, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20130409 21:00:00.000', '20130409 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6968, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20130410 21:00:00.000', '20130410 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6969, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20130416 21:00:00.000', '20130416 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6970, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20130417 21:00:00.000', '20130417 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6971, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20130423 21:00:00.000', '20130423 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6972, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20130424 21:00:00.000', '20130424 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6973, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20130430 21:00:00.000', '20130430 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6974, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20130501 21:00:00.000', '20130501 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6975, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20130507 21:00:00.000', '20130507 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6976, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20130508 21:00:00.000', '20130508 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6977, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20130514 21:00:00.000', '20130514 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6978, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20130515 21:00:00.000', '20130515 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6979, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20130521 21:00:00.000', '20130521 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6980, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20130522 21:00:00.000', '20130522 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6981, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20130528 21:00:00.000', '20130528 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6982, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20130529 21:00:00.000', '20130529 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6983, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20130604 21:00:00.000', '20130604 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6984, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20130605 21:00:00.000', '20130605 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6985, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20130611 21:00:00.000', '20130611 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6986, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20130612 21:00:00.000', '20130612 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6987, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20130618 21:00:00.000', '20130618 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6988, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20130619 21:00:00.000', '20130619 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6989, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20130625 21:00:00.000', '20130625 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6990, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20130626 21:00:00.000', '20130626 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6991, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20130702 21:00:00.000', '20130702 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6992, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20130703 21:00:00.000', '20130703 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6993, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20130709 21:00:00.000', '20130709 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6994, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20130710 21:00:00.000', '20130710 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6995, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20130716 21:00:00.000', '20130716 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6996, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20130717 21:00:00.000', '20130717 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6997, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20130723 21:00:00.000', '20130723 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6998, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20130724 21:00:00.000', '20130724 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (6999, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20130730 21:00:00.000', '20130730 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7000, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20130731 21:00:00.000', '20130731 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7001, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20130806 21:00:00.000', '20130806 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7002, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20130807 21:00:00.000', '20130807 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7003, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20130813 21:00:00.000', '20130813 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7004, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20130814 21:00:00.000', '20130814 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7005, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20130820 21:00:00.000', '20130820 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7006, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20130821 21:00:00.000', '20130821 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7007, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20130827 21:00:00.000', '20130827 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7008, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20130828 21:00:00.000', '20130828 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7009, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20130903 21:00:00.000', '20130903 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7010, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20130904 21:00:00.000', '20130904 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7011, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20130910 21:00:00.000', '20130910 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7012, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20130911 21:00:00.000', '20130911 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7013, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20130917 21:00:00.000', '20130917 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7014, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20130918 21:00:00.000', '20130918 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7015, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20130924 21:00:00.000', '20130924 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7016, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20130925 21:00:00.000', '20130925 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7017, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20131001 21:00:00.000', '20131001 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7018, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20131002 21:00:00.000', '20131002 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7019, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20131008 21:00:00.000', '20131008 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7020, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20131009 21:00:00.000', '20131009 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7021, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20131015 21:00:00.000', '20131015 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7022, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20131016 21:00:00.000', '20131016 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7023, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20131022 21:00:00.000', '20131022 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7024, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20131023 21:00:00.000', '20131023 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7025, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20131029 21:00:00.000', '20131029 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7026, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20131030 21:00:00.000', '20131030 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7027, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20131105 21:00:00.000', '20131105 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7028, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20131106 21:00:00.000', '20131106 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7029, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20131112 21:00:00.000', '20131112 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7030, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20131113 21:00:00.000', '20131113 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7031, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20131119 21:00:00.000', '20131119 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7032, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20131120 21:00:00.000', '20131120 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7033, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20131126 21:00:00.000', '20131126 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7034, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20131127 21:00:00.000', '20131127 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7035, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20131203 21:00:00.000', '20131203 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7036, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20131204 21:00:00.000', '20131204 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7037, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20131210 21:00:00.000', '20131210 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7038, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20131211 21:00:00.000', '20131211 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7039, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20131217 21:00:00.000', '20131217 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7040, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20131218 21:00:00.000', '20131218 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7041, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20131224 21:00:00.000', '20131224 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7042, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20131225 21:00:00.000', '20131225 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7043, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20131231 21:00:00.000', '20131231 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7044, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20140101 21:00:00.000', '20140101 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7045, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20140107 21:00:00.000', '20140107 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7046, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20140108 21:00:00.000', '20140108 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7047, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20140114 21:00:00.000', '20140114 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7048, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20140115 21:00:00.000', '20140115 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7049, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20140121 21:00:00.000', '20140121 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7050, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20140122 21:00:00.000', '20140122 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7051, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20140128 21:00:00.000', '20140128 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7052, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20140129 21:00:00.000', '20140129 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7053, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20140204 21:00:00.000', '20140204 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7054, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20140205 21:00:00.000', '20140205 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7055, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20140211 21:00:00.000', '20140211 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7056, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20140212 21:00:00.000', '20140212 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7057, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20140218 21:00:00.000', '20140218 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7058, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20140219 21:00:00.000', '20140219 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7059, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20140225 21:00:00.000', '20140225 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7060, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20140226 21:00:00.000', '20140226 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7061, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20140304 21:00:00.000', '20140304 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7062, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20140305 21:00:00.000', '20140305 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7063, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20140311 21:00:00.000', '20140311 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7064, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20140312 21:00:00.000', '20140312 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7065, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20140318 21:00:00.000', '20140318 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7066, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20140319 21:00:00.000', '20140319 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7067, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20140325 21:00:00.000', '20140325 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7068, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20140326 21:00:00.000', '20140326 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7069, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20140401 21:00:00.000', '20140401 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7070, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20140402 21:00:00.000', '20140402 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7071, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20140408 21:00:00.000', '20140408 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7072, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20140409 21:00:00.000', '20140409 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7073, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20140415 21:00:00.000', '20140415 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7074, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20140416 21:00:00.000', '20140416 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7075, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20140422 21:00:00.000', '20140422 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7076, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20140423 21:00:00.000', '20140423 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7077, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20140429 21:00:00.000', '20140429 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7078, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20140430 21:00:00.000', '20140430 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7079, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20140506 21:00:00.000', '20140506 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7080, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20140507 21:00:00.000', '20140507 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7081, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20140513 21:00:00.000', '20140513 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7082, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20140514 21:00:00.000', '20140514 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7083, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20140520 21:00:00.000', '20140520 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7084, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20140521 21:00:00.000', '20140521 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7085, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20140527 21:00:00.000', '20140527 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7086, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20140528 21:00:00.000', '20140528 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7087, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20140603 21:00:00.000', '20140603 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7088, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20140604 21:00:00.000', '20140604 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7089, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20140610 21:00:00.000', '20140610 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7090, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20140611 21:00:00.000', '20140611 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7091, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20140617 21:00:00.000', '20140617 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7092, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20140618 21:00:00.000', '20140618 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7093, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20140624 21:00:00.000', '20140624 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7094, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20140625 21:00:00.000', '20140625 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7095, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20140701 21:00:00.000', '20140701 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7096, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20140702 21:00:00.000', '20140702 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7097, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20140708 21:00:00.000', '20140708 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7098, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20140709 21:00:00.000', '20140709 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7099, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20140715 21:00:00.000', '20140715 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7100, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20140716 21:00:00.000', '20140716 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7101, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20140722 21:00:00.000', '20140722 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7102, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20140723 21:00:00.000', '20140723 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7103, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20140729 21:00:00.000', '20140729 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7104, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20140730 21:00:00.000', '20140730 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7105, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20140805 21:00:00.000', '20140805 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7106, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20140806 21:00:00.000', '20140806 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7107, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20140812 21:00:00.000', '20140812 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7108, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20140813 21:00:00.000', '20140813 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7109, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20140819 21:00:00.000', '20140819 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7110, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20140820 21:00:00.000', '20140820 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7111, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20140826 21:00:00.000', '20140826 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7112, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20140827 21:00:00.000', '20140827 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7113, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20140902 21:00:00.000', '20140902 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7114, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20140903 21:00:00.000', '20140903 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7115, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20140909 21:00:00.000', '20140909 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7116, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20140910 21:00:00.000', '20140910 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7117, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20140916 21:00:00.000', '20140916 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7118, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20140917 21:00:00.000', '20140917 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7119, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20140923 21:00:00.000', '20140923 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7120, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20140924 21:00:00.000', '20140924 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7121, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20140930 21:00:00.000', '20140930 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7122, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20141001 21:00:00.000', '20141001 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7123, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20141007 21:00:00.000', '20141007 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7124, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20141008 21:00:00.000', '20141008 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7125, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20141014 21:00:00.000', '20141014 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7126, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20141015 21:00:00.000', '20141015 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7127, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20141021 21:00:00.000', '20141021 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7128, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20141022 21:00:00.000', '20141022 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7129, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20141028 21:00:00.000', '20141028 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7130, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20141029 21:00:00.000', '20141029 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7131, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20141104 21:00:00.000', '20141104 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7132, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20141105 21:00:00.000', '20141105 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7133, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20141111 21:00:00.000', '20141111 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7134, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20141112 21:00:00.000', '20141112 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7135, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20141118 21:00:00.000', '20141118 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7136, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20141119 21:00:00.000', '20141119 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7137, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20141125 21:00:00.000', '20141125 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7138, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20141126 21:00:00.000', '20141126 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7139, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20141202 21:00:00.000', '20141202 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7140, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20141203 21:00:00.000', '20141203 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7141, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20141209 21:00:00.000', '20141209 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7142, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20141210 21:00:00.000', '20141210 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7143, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20141216 21:00:00.000', '20141216 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7144, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20141217 21:00:00.000', '20141217 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7145, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20141223 21:00:00.000', '20141223 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7146, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20141224 21:00:00.000', '20141224 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7147, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20141230 21:00:00.000', '20141230 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7148, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20141231 21:00:00.000', '20141231 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7149, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20150106 21:00:00.000', '20150106 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7150, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20150107 21:00:00.000', '20150107 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7151, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20150113 21:00:00.000', '20150113 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7152, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20150114 21:00:00.000', '20150114 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7153, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20150120 21:00:00.000', '20150120 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7154, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20150121 21:00:00.000', '20150121 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7155, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20150127 21:00:00.000', '20150127 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7156, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20150128 21:00:00.000', '20150128 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7157, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20150203 21:00:00.000', '20150203 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7158, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20150204 21:00:00.000', '20150204 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7159, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20150210 21:00:00.000', '20150210 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7160, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20150211 21:00:00.000', '20150211 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7161, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20150217 21:00:00.000', '20150217 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7162, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20150218 21:00:00.000', '20150218 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7163, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20150224 21:00:00.000', '20150224 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7164, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20150225 21:00:00.000', '20150225 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7165, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20150303 21:00:00.000', '20150303 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7166, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20150304 21:00:00.000', '20150304 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7167, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20150310 21:00:00.000', '20150310 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7168, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20150311 21:00:00.000', '20150311 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7169, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20150317 21:00:00.000', '20150317 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7170, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20150318 21:00:00.000', '20150318 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7171, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20150324 21:00:00.000', '20150324 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7172, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20150325 21:00:00.000', '20150325 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7173, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20150331 21:00:00.000', '20150331 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7174, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20150401 21:00:00.000', '20150401 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7175, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20150407 21:00:00.000', '20150407 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7176, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20150408 21:00:00.000', '20150408 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7177, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20150414 21:00:00.000', '20150414 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7178, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20150415 21:00:00.000', '20150415 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7179, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20150421 21:00:00.000', '20150421 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7180, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20150422 21:00:00.000', '20150422 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7181, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20150428 21:00:00.000', '20150428 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7182, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20150429 21:00:00.000', '20150429 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7183, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20150505 21:00:00.000', '20150505 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7184, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20150506 21:00:00.000', '20150506 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7185, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20150512 21:00:00.000', '20150512 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7186, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20150513 21:00:00.000', '20150513 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7187, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20150519 21:00:00.000', '20150519 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7188, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20150520 21:00:00.000', '20150520 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7189, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20150526 21:00:00.000', '20150526 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7190, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20150527 21:00:00.000', '20150527 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7191, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20150602 21:00:00.000', '20150602 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7192, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20150603 21:00:00.000', '20150603 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7193, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20150609 21:00:00.000', '20150609 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7194, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20150610 21:00:00.000', '20150610 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7195, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20150616 21:00:00.000', '20150616 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7196, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20150617 21:00:00.000', '20150617 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7197, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20150623 21:00:00.000', '20150623 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7198, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20150624 21:00:00.000', '20150624 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7199, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20150630 21:00:00.000', '20150630 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7200, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20150701 21:00:00.000', '20150701 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7201, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20150707 21:00:00.000', '20150707 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7202, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20150708 21:00:00.000', '20150708 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7203, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20150714 21:00:00.000', '20150714 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7204, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20150715 21:00:00.000', '20150715 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7205, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20150721 21:00:00.000', '20150721 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7206, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20150722 21:00:00.000', '20150722 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7207, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20150728 21:00:00.000', '20150728 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7208, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20150729 21:00:00.000', '20150729 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7209, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20150804 21:00:00.000', '20150804 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7210, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20150805 21:00:00.000', '20150805 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7211, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20150811 21:00:00.000', '20150811 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7212, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20150812 21:00:00.000', '20150812 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7213, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20150818 21:00:00.000', '20150818 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7214, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20150819 21:00:00.000', '20150819 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7215, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20150825 21:00:00.000', '20150825 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7216, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20150826 21:00:00.000', '20150826 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7217, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20150901 21:00:00.000', '20150901 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7218, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20150902 21:00:00.000', '20150902 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7219, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20150908 21:00:00.000', '20150908 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7220, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20150909 21:00:00.000', '20150909 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7221, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20150915 21:00:00.000', '20150915 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7222, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20150916 21:00:00.000', '20150916 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7223, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20150922 21:00:00.000', '20150922 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7224, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20150923 21:00:00.000', '20150923 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7225, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20150929 21:00:00.000', '20150929 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7226, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20150930 21:00:00.000', '20150930 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7227, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20151006 21:00:00.000', '20151006 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7228, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20151007 21:00:00.000', '20151007 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7229, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20151013 21:00:00.000', '20151013 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7230, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20151014 21:00:00.000', '20151014 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7231, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20151020 21:00:00.000', '20151020 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7232, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20151021 21:00:00.000', '20151021 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7233, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20151027 21:00:00.000', '20151027 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7234, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20151028 21:00:00.000', '20151028 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7235, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20151103 21:00:00.000', '20151103 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7236, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20151104 21:00:00.000', '20151104 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7237, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20151110 21:00:00.000', '20151110 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7238, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20151111 21:00:00.000', '20151111 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7239, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20151117 21:00:00.000', '20151117 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7240, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20151118 21:00:00.000', '20151118 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7241, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20151124 21:00:00.000', '20151124 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7242, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20151125 21:00:00.000', '20151125 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7243, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20151201 21:00:00.000', '20151201 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7244, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20151202 21:00:00.000', '20151202 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7245, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20151208 21:00:00.000', '20151208 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7246, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20151209 21:00:00.000', '20151209 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7247, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20151215 21:00:00.000', '20151215 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7248, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20151216 21:00:00.000', '20151216 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7249, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20151222 21:00:00.000', '20151222 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7250, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20151223 21:00:00.000', '20151223 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7251, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20151229 21:00:00.000', '20151229 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7252, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20151230 21:00:00.000', '20151230 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7253, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20160105 21:00:00.000', '20160105 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7254, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20160106 21:00:00.000', '20160106 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7255, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20160112 21:00:00.000', '20160112 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7256, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20160113 21:00:00.000', '20160113 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7257, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20160119 21:00:00.000', '20160119 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7258, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20160120 21:00:00.000', '20160120 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7259, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20160126 21:00:00.000', '20160126 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7260, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20160127 21:00:00.000', '20160127 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7261, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20160202 21:00:00.000', '20160202 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7262, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20160203 21:00:00.000', '20160203 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7263, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20160209 21:00:00.000', '20160209 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7264, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20160210 21:00:00.000', '20160210 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7265, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20160216 21:00:00.000', '20160216 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7266, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20160217 21:00:00.000', '20160217 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7267, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20160223 21:00:00.000', '20160223 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7268, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20160224 21:00:00.000', '20160224 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7269, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20160301 21:00:00.000', '20160301 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7270, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20160302 21:00:00.000', '20160302 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7271, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20160308 21:00:00.000', '20160308 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7272, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20160309 21:00:00.000', '20160309 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7273, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20160315 21:00:00.000', '20160315 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7274, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20160316 21:00:00.000', '20160316 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7275, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20160322 21:00:00.000', '20160322 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7276, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20160323 21:00:00.000', '20160323 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7277, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20160329 21:00:00.000', '20160329 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7278, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20160330 21:00:00.000', '20160330 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7279, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20160405 21:00:00.000', '20160405 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7280, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20160406 21:00:00.000', '20160406 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7281, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20160412 21:00:00.000', '20160412 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7282, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20160413 21:00:00.000', '20160413 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7283, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20160419 21:00:00.000', '20160419 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7284, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20160420 21:00:00.000', '20160420 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7285, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20160426 21:00:00.000', '20160426 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7286, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20160427 21:00:00.000', '20160427 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7287, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20160503 21:00:00.000', '20160503 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7288, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20160504 21:00:00.000', '20160504 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7289, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20160510 21:00:00.000', '20160510 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7290, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20160511 21:00:00.000', '20160511 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7291, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20160517 21:00:00.000', '20160517 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7292, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20160518 21:00:00.000', '20160518 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7293, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20160524 21:00:00.000', '20160524 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7294, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20160525 21:00:00.000', '20160525 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7295, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20160531 21:00:00.000', '20160531 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7296, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20160601 21:00:00.000', '20160601 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7297, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20160607 21:00:00.000', '20160607 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7298, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20160608 21:00:00.000', '20160608 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7299, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20160614 21:00:00.000', '20160614 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7300, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20160615 21:00:00.000', '20160615 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7301, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20160621 21:00:00.000', '20160621 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7302, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20160622 21:00:00.000', '20160622 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7303, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20160628 21:00:00.000', '20160628 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7304, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20160629 21:00:00.000', '20160629 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7305, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20160705 21:00:00.000', '20160705 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7306, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20160706 21:00:00.000', '20160706 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7307, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20160712 21:00:00.000', '20160712 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7308, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20160713 21:00:00.000', '20160713 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7309, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20160719 21:00:00.000', '20160719 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7310, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20160720 21:00:00.000', '20160720 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7311, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20160726 21:00:00.000', '20160726 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7312, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20160727 21:00:00.000', '20160727 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7313, 5, N'Taleem Al Quran', N'Taleem Al Quran: Qaari AbdulKarim (level 1)', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Qaari AbdulKarim (level 1)</h3>', N'Main Center', '20160802 21:00:00.000', '20160802 22:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7314, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20110805 06:30:00.000', '20110805 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7315, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20110812 06:30:00.000', '20110812 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7316, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20110819 06:30:00.000', '20110819 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7317, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20110826 06:30:00.000', '20110826 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7318, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20110902 06:30:00.000', '20110902 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7319, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20110909 06:30:00.000', '20110909 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7320, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20110916 06:30:00.000', '20110916 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7321, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20110923 06:30:00.000', '20110923 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7322, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20110930 06:30:00.000', '20110930 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7323, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20111007 06:30:00.000', '20111007 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7324, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20111014 06:30:00.000', '20111014 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7325, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20111021 06:30:00.000', '20111021 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7326, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20111028 06:30:00.000', '20111028 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7327, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20111104 06:30:00.000', '20111104 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7328, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20111111 06:30:00.000', '20111111 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7329, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20111118 06:30:00.000', '20111118 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7330, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20111125 06:30:00.000', '20111125 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7331, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20111202 06:30:00.000', '20111202 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7332, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20111209 06:30:00.000', '20111209 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7333, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20111216 06:30:00.000', '20111216 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7334, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20111223 06:30:00.000', '20111223 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7335, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20111230 06:30:00.000', '20111230 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7336, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20120106 06:30:00.000', '20120106 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7337, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20120113 06:30:00.000', '20120113 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7338, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20120120 06:30:00.000', '20120120 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7339, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20120127 06:30:00.000', '20120127 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7340, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20120203 06:30:00.000', '20120203 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7341, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20120210 06:30:00.000', '20120210 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7342, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20120217 06:30:00.000', '20120217 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7343, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20120224 06:30:00.000', '20120224 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7344, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20120302 06:30:00.000', '20120302 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7345, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20120309 06:30:00.000', '20120309 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7346, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20120316 06:30:00.000', '20120316 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7347, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20120323 06:30:00.000', '20120323 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7348, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20120330 06:30:00.000', '20120330 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7349, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20120406 06:30:00.000', '20120406 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7350, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20120413 06:30:00.000', '20120413 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7351, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20120420 06:30:00.000', '20120420 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7352, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20120427 06:30:00.000', '20120427 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7353, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20120504 06:30:00.000', '20120504 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7354, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20120511 06:30:00.000', '20120511 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7355, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20120518 06:30:00.000', '20120518 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7356, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20120525 06:30:00.000', '20120525 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7357, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20120601 06:30:00.000', '20120601 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7358, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20120608 06:30:00.000', '20120608 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7359, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20120615 06:30:00.000', '20120615 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7360, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20120622 06:30:00.000', '20120622 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7361, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20120629 06:30:00.000', '20120629 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7362, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20120706 06:30:00.000', '20120706 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7363, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20120713 06:30:00.000', '20120713 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7364, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20120720 06:30:00.000', '20120720 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7365, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20120727 06:30:00.000', '20120727 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7366, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20120803 06:30:00.000', '20120803 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7367, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20120810 06:30:00.000', '20120810 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7368, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20120817 06:30:00.000', '20120817 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7369, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20120824 06:30:00.000', '20120824 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7370, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20120831 06:30:00.000', '20120831 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7371, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20120907 06:30:00.000', '20120907 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7372, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20120914 06:30:00.000', '20120914 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7373, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20120921 06:30:00.000', '20120921 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7374, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20120928 06:30:00.000', '20120928 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7375, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20121005 06:30:00.000', '20121005 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7376, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20121012 06:30:00.000', '20121012 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7377, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20121019 06:30:00.000', '20121019 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7378, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20121026 06:30:00.000', '20121026 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7379, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20121102 06:30:00.000', '20121102 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7380, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20121109 06:30:00.000', '20121109 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7381, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20121116 06:30:00.000', '20121116 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7382, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20121123 06:30:00.000', '20121123 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7383, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20121130 06:30:00.000', '20121130 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7384, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20121207 06:30:00.000', '20121207 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7385, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20121214 06:30:00.000', '20121214 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7386, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20121221 06:30:00.000', '20121221 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7387, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20121228 06:30:00.000', '20121228 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7388, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20130104 06:30:00.000', '20130104 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7389, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20130111 06:30:00.000', '20130111 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7390, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20130118 06:30:00.000', '20130118 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7391, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20130125 06:30:00.000', '20130125 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7392, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20130201 06:30:00.000', '20130201 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7393, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20130208 06:30:00.000', '20130208 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7394, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20130215 06:30:00.000', '20130215 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7395, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20130222 06:30:00.000', '20130222 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7396, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20130301 06:30:00.000', '20130301 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7397, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20130308 06:30:00.000', '20130308 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7398, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20130315 06:30:00.000', '20130315 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7399, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20130322 06:30:00.000', '20130322 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7400, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20130329 06:30:00.000', '20130329 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7401, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20130405 06:30:00.000', '20130405 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7402, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20130412 06:30:00.000', '20130412 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7403, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20130419 06:30:00.000', '20130419 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7404, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20130426 06:30:00.000', '20130426 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7405, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20130503 06:30:00.000', '20130503 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7406, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20130510 06:30:00.000', '20130510 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7407, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20130517 06:30:00.000', '20130517 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7408, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20130524 06:30:00.000', '20130524 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7409, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20130531 06:30:00.000', '20130531 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7410, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20130607 06:30:00.000', '20130607 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7411, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20130614 06:30:00.000', '20130614 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7412, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20130621 06:30:00.000', '20130621 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7413, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20130628 06:30:00.000', '20130628 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7414, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20130705 06:30:00.000', '20130705 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7415, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20130712 06:30:00.000', '20130712 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7416, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20130719 06:30:00.000', '20130719 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7417, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20130726 06:30:00.000', '20130726 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7418, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20130802 06:30:00.000', '20130802 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7419, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20130809 06:30:00.000', '20130809 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7420, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20130816 06:30:00.000', '20130816 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7421, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20130823 06:30:00.000', '20130823 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7422, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20130830 06:30:00.000', '20130830 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7423, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20130906 06:30:00.000', '20130906 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7424, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20130913 06:30:00.000', '20130913 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7425, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20130920 06:30:00.000', '20130920 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7426, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20130927 06:30:00.000', '20130927 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7427, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20131004 06:30:00.000', '20131004 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7428, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20131011 06:30:00.000', '20131011 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7429, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20131018 06:30:00.000', '20131018 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7430, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20131025 06:30:00.000', '20131025 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7431, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20131101 06:30:00.000', '20131101 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7432, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20131108 06:30:00.000', '20131108 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7433, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20131115 06:30:00.000', '20131115 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7434, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20131122 06:30:00.000', '20131122 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7435, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20131129 06:30:00.000', '20131129 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7436, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20131206 06:30:00.000', '20131206 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7437, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20131213 06:30:00.000', '20131213 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7438, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20131220 06:30:00.000', '20131220 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7439, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20131227 06:30:00.000', '20131227 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7440, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20140103 06:30:00.000', '20140103 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7441, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20140110 06:30:00.000', '20140110 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7442, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20140117 06:30:00.000', '20140117 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7443, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20140124 06:30:00.000', '20140124 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7444, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20140131 06:30:00.000', '20140131 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7445, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20140207 06:30:00.000', '20140207 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7446, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20140214 06:30:00.000', '20140214 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7447, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20140221 06:30:00.000', '20140221 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7448, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20140228 06:30:00.000', '20140228 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7449, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20140307 06:30:00.000', '20140307 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7450, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20140314 06:30:00.000', '20140314 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7451, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20140321 06:30:00.000', '20140321 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7452, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20140328 06:30:00.000', '20140328 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7453, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20140404 06:30:00.000', '20140404 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7454, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20140411 06:30:00.000', '20140411 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7455, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20140418 06:30:00.000', '20140418 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7456, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20140425 06:30:00.000', '20140425 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7457, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20140502 06:30:00.000', '20140502 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7458, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20140509 06:30:00.000', '20140509 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7459, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20140516 06:30:00.000', '20140516 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7460, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20140523 06:30:00.000', '20140523 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7461, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20140530 06:30:00.000', '20140530 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7462, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20140606 06:30:00.000', '20140606 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7463, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20140613 06:30:00.000', '20140613 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7464, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20140620 06:30:00.000', '20140620 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7465, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20140627 06:30:00.000', '20140627 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7466, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20140704 06:30:00.000', '20140704 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7467, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20140711 06:30:00.000', '20140711 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7468, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20140718 06:30:00.000', '20140718 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7469, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20140725 06:30:00.000', '20140725 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7470, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20140801 06:30:00.000', '20140801 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7471, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20140808 06:30:00.000', '20140808 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7472, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20140815 06:30:00.000', '20140815 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7473, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20140822 06:30:00.000', '20140822 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7474, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20140829 06:30:00.000', '20140829 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7475, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20140905 06:30:00.000', '20140905 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7476, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20140912 06:30:00.000', '20140912 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7477, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20140919 06:30:00.000', '20140919 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7478, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20140926 06:30:00.000', '20140926 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7479, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20141003 06:30:00.000', '20141003 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7480, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20141010 06:30:00.000', '20141010 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7481, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20141017 06:30:00.000', '20141017 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7482, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20141024 06:30:00.000', '20141024 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7483, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20141031 06:30:00.000', '20141031 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7484, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20141107 06:30:00.000', '20141107 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7485, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20141114 06:30:00.000', '20141114 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7486, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20141121 06:30:00.000', '20141121 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7487, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20141128 06:30:00.000', '20141128 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7488, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20141205 06:30:00.000', '20141205 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7489, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20141212 06:30:00.000', '20141212 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7490, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20141219 06:30:00.000', '20141219 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7491, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20141226 06:30:00.000', '20141226 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7492, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20150102 06:30:00.000', '20150102 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7493, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20150109 06:30:00.000', '20150109 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7494, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20150116 06:30:00.000', '20150116 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7495, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20150123 06:30:00.000', '20150123 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7496, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20150130 06:30:00.000', '20150130 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7497, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20150206 06:30:00.000', '20150206 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7498, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20150213 06:30:00.000', '20150213 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7499, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20150220 06:30:00.000', '20150220 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7500, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20150227 06:30:00.000', '20150227 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7501, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20150306 06:30:00.000', '20150306 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7502, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20150313 06:30:00.000', '20150313 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7503, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20150320 06:30:00.000', '20150320 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7504, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20150327 06:30:00.000', '20150327 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7505, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20150403 06:30:00.000', '20150403 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7506, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20150410 06:30:00.000', '20150410 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7507, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20150417 06:30:00.000', '20150417 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7508, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20150424 06:30:00.000', '20150424 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7509, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20150501 06:30:00.000', '20150501 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7510, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20150508 06:30:00.000', '20150508 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7511, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20150515 06:30:00.000', '20150515 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7512, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20150522 06:30:00.000', '20150522 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7513, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20150529 06:30:00.000', '20150529 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7514, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20150605 06:30:00.000', '20150605 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7515, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20150612 06:30:00.000', '20150612 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7516, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20150619 06:30:00.000', '20150619 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7517, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20150626 06:30:00.000', '20150626 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7518, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20150703 06:30:00.000', '20150703 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7519, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20150710 06:30:00.000', '20150710 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7520, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20150717 06:30:00.000', '20150717 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7521, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20150724 06:30:00.000', '20150724 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7522, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20150731 06:30:00.000', '20150731 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7523, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20150807 06:30:00.000', '20150807 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7524, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20150814 06:30:00.000', '20150814 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7525, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20150821 06:30:00.000', '20150821 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7526, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20150828 06:30:00.000', '20150828 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7527, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20150904 06:30:00.000', '20150904 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7528, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20150911 06:30:00.000', '20150911 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7529, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20150918 06:30:00.000', '20150918 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7530, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20150925 06:30:00.000', '20150925 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7531, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20151002 06:30:00.000', '20151002 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7532, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20151009 06:30:00.000', '20151009 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7533, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20151016 06:30:00.000', '20151016 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7534, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20151023 06:30:00.000', '20151023 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7535, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20151030 06:30:00.000', '20151030 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7536, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20151106 06:30:00.000', '20151106 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7537, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20151113 06:30:00.000', '20151113 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7538, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20151120 06:30:00.000', '20151120 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7539, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20151127 06:30:00.000', '20151127 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7540, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20151204 06:30:00.000', '20151204 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7541, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20151211 06:30:00.000', '20151211 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7542, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20151218 06:30:00.000', '20151218 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7543, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20151225 06:30:00.000', '20151225 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7544, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20160101 06:30:00.000', '20160101 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7545, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20160108 06:30:00.000', '20160108 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7546, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20160115 06:30:00.000', '20160115 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7547, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20160122 06:30:00.000', '20160122 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7548, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20160129 06:30:00.000', '20160129 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7549, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20160205 06:30:00.000', '20160205 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7550, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20160212 06:30:00.000', '20160212 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7551, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20160219 06:30:00.000', '20160219 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7552, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20160226 06:30:00.000', '20160226 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7553, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20160304 06:30:00.000', '20160304 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7554, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20160311 06:30:00.000', '20160311 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7555, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20160318 06:30:00.000', '20160318 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7556, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20160325 06:30:00.000', '20160325 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7557, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20160401 06:30:00.000', '20160401 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7558, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20160408 06:30:00.000', '20160408 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7559, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20160415 06:30:00.000', '20160415 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7560, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20160422 06:30:00.000', '20160422 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7561, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20160429 06:30:00.000', '20160429 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7562, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20160506 06:30:00.000', '20160506 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7563, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20160513 06:30:00.000', '20160513 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7564, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20160520 06:30:00.000', '20160520 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7565, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20160527 06:30:00.000', '20160527 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7566, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20160603 06:30:00.000', '20160603 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7567, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20160610 06:30:00.000', '20160610 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7568, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20160617 06:30:00.000', '20160617 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7569, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20160624 06:30:00.000', '20160624 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7570, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20160701 06:30:00.000', '20160701 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7571, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20160708 06:30:00.000', '20160708 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7572, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20160715 06:30:00.000', '20160715 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7573, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20160722 06:30:00.000', '20160722 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7574, 11, N'Beautiful Names of Allah', N'Beautiful Names of Allah: Imam Magid', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Beautiful Names of Allah: Imam Magid</h3>', N'Main Center', '20160729 06:30:00.000', '20160729 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7575, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20110805 19:00:00.000', '20110805 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7576, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20110812 19:00:00.000', '20110812 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7577, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20110819 19:00:00.000', '20110819 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7578, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20110826 19:00:00.000', '20110826 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7579, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20110902 19:00:00.000', '20110902 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7580, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20110909 19:00:00.000', '20110909 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7581, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20110916 19:00:00.000', '20110916 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7582, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20110923 19:00:00.000', '20110923 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7583, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20110930 19:00:00.000', '20110930 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7584, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20111007 19:00:00.000', '20111007 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7585, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20111014 19:00:00.000', '20111014 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7586, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20111021 19:00:00.000', '20111021 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7587, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20111028 19:00:00.000', '20111028 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7588, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20111104 19:00:00.000', '20111104 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7589, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20111111 19:00:00.000', '20111111 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7590, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20111118 19:00:00.000', '20111118 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7591, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20111125 19:00:00.000', '20111125 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7592, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20111202 19:00:00.000', '20111202 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7593, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20111209 19:00:00.000', '20111209 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7594, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20111216 19:00:00.000', '20111216 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7595, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20111223 19:00:00.000', '20111223 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7596, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20111230 19:00:00.000', '20111230 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7597, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20120106 19:00:00.000', '20120106 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7598, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20120113 19:00:00.000', '20120113 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7599, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20120120 19:00:00.000', '20120120 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7600, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20120127 19:00:00.000', '20120127 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7601, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20120203 19:00:00.000', '20120203 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7602, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20120210 19:00:00.000', '20120210 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7603, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20120217 19:00:00.000', '20120217 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7604, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20120224 19:00:00.000', '20120224 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7605, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20120302 19:00:00.000', '20120302 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7606, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20120309 19:00:00.000', '20120309 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7607, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20120316 19:00:00.000', '20120316 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7608, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20120323 19:00:00.000', '20120323 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7609, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20120330 19:00:00.000', '20120330 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7610, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20120406 19:00:00.000', '20120406 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7611, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20120413 19:00:00.000', '20120413 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7612, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20120420 19:00:00.000', '20120420 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7613, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20120427 19:00:00.000', '20120427 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7614, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20120504 19:00:00.000', '20120504 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7615, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20120511 19:00:00.000', '20120511 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7616, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20120518 19:00:00.000', '20120518 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7617, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20120525 19:00:00.000', '20120525 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7618, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20120601 19:00:00.000', '20120601 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7619, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20120608 19:00:00.000', '20120608 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7620, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20120615 19:00:00.000', '20120615 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7621, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20120622 19:00:00.000', '20120622 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7622, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20120629 19:00:00.000', '20120629 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7623, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20120706 19:00:00.000', '20120706 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7624, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20120713 19:00:00.000', '20120713 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7625, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20120720 19:00:00.000', '20120720 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7626, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20120727 19:00:00.000', '20120727 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7627, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20120803 19:00:00.000', '20120803 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7628, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20120810 19:00:00.000', '20120810 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7629, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20120817 19:00:00.000', '20120817 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7630, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20120824 19:00:00.000', '20120824 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7631, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20120831 19:00:00.000', '20120831 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7632, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20120907 19:00:00.000', '20120907 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7633, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20120914 19:00:00.000', '20120914 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7634, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20120921 19:00:00.000', '20120921 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7635, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20120928 19:00:00.000', '20120928 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7636, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20121005 19:00:00.000', '20121005 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7637, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20121012 19:00:00.000', '20121012 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7638, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20121019 19:00:00.000', '20121019 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7639, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20121026 19:00:00.000', '20121026 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7640, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20121102 19:00:00.000', '20121102 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7641, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20121109 19:00:00.000', '20121109 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7642, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20121116 19:00:00.000', '20121116 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7643, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20121123 19:00:00.000', '20121123 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7644, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20121130 19:00:00.000', '20121130 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7645, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20121207 19:00:00.000', '20121207 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7646, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20121214 19:00:00.000', '20121214 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7647, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20121221 19:00:00.000', '20121221 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7648, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20121228 19:00:00.000', '20121228 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7649, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20130104 19:00:00.000', '20130104 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7650, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20130111 19:00:00.000', '20130111 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7651, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20130118 19:00:00.000', '20130118 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7652, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20130125 19:00:00.000', '20130125 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7653, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20130201 19:00:00.000', '20130201 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7654, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20130208 19:00:00.000', '20130208 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7655, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20130215 19:00:00.000', '20130215 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7656, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20130222 19:00:00.000', '20130222 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7657, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20130301 19:00:00.000', '20130301 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7658, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20130308 19:00:00.000', '20130308 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7659, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20130315 19:00:00.000', '20130315 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7660, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20130322 19:00:00.000', '20130322 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7661, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20130329 19:00:00.000', '20130329 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7662, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20130405 19:00:00.000', '20130405 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7663, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20130412 19:00:00.000', '20130412 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7664, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20130419 19:00:00.000', '20130419 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7665, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20130426 19:00:00.000', '20130426 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7666, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20130503 19:00:00.000', '20130503 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7667, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20130510 19:00:00.000', '20130510 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7668, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20130517 19:00:00.000', '20130517 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7669, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20130524 19:00:00.000', '20130524 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7670, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20130531 19:00:00.000', '20130531 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7671, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20130607 19:00:00.000', '20130607 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7672, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20130614 19:00:00.000', '20130614 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7673, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20130621 19:00:00.000', '20130621 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7674, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20130628 19:00:00.000', '20130628 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7675, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20130705 19:00:00.000', '20130705 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7676, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20130712 19:00:00.000', '20130712 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7677, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20130719 19:00:00.000', '20130719 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7678, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20130726 19:00:00.000', '20130726 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7679, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20130802 19:00:00.000', '20130802 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7680, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20130809 19:00:00.000', '20130809 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7681, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20130816 19:00:00.000', '20130816 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7682, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20130823 19:00:00.000', '20130823 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7683, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20130830 19:00:00.000', '20130830 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7684, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20130906 19:00:00.000', '20130906 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7685, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20130913 19:00:00.000', '20130913 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7686, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20130920 19:00:00.000', '20130920 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7687, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20130927 19:00:00.000', '20130927 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7688, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20131004 19:00:00.000', '20131004 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7689, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20131011 19:00:00.000', '20131011 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7690, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20131018 19:00:00.000', '20131018 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7691, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20131025 19:00:00.000', '20131025 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7692, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20131101 19:00:00.000', '20131101 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7693, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20131108 19:00:00.000', '20131108 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7694, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20131115 19:00:00.000', '20131115 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7695, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20131122 19:00:00.000', '20131122 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7696, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20131129 19:00:00.000', '20131129 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7697, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20131206 19:00:00.000', '20131206 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7698, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20131213 19:00:00.000', '20131213 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7699, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20131220 19:00:00.000', '20131220 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7700, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20131227 19:00:00.000', '20131227 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7701, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20140103 19:00:00.000', '20140103 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7702, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20140110 19:00:00.000', '20140110 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7703, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20140117 19:00:00.000', '20140117 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7704, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20140124 19:00:00.000', '20140124 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7705, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20140131 19:00:00.000', '20140131 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7706, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20140207 19:00:00.000', '20140207 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7707, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20140214 19:00:00.000', '20140214 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7708, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20140221 19:00:00.000', '20140221 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7709, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20140228 19:00:00.000', '20140228 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7710, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20140307 19:00:00.000', '20140307 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7711, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20140314 19:00:00.000', '20140314 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7712, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20140321 19:00:00.000', '20140321 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7713, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20140328 19:00:00.000', '20140328 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7714, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20140404 19:00:00.000', '20140404 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7715, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20140411 19:00:00.000', '20140411 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7716, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20140418 19:00:00.000', '20140418 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7717, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20140425 19:00:00.000', '20140425 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7718, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20140502 19:00:00.000', '20140502 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7719, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20140509 19:00:00.000', '20140509 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7720, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20140516 19:00:00.000', '20140516 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7721, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20140523 19:00:00.000', '20140523 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7722, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20140530 19:00:00.000', '20140530 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7723, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20140606 19:00:00.000', '20140606 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7724, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20140613 19:00:00.000', '20140613 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7725, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20140620 19:00:00.000', '20140620 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7726, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20140627 19:00:00.000', '20140627 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7727, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20140704 19:00:00.000', '20140704 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7728, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20140711 19:00:00.000', '20140711 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7729, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20140718 19:00:00.000', '20140718 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7730, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20140725 19:00:00.000', '20140725 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7731, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20140801 19:00:00.000', '20140801 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7732, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20140808 19:00:00.000', '20140808 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7733, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20140815 19:00:00.000', '20140815 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7734, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20140822 19:00:00.000', '20140822 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7735, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20140829 19:00:00.000', '20140829 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7736, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20140905 19:00:00.000', '20140905 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7737, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20140912 19:00:00.000', '20140912 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7738, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20140919 19:00:00.000', '20140919 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7739, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20140926 19:00:00.000', '20140926 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7740, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20141003 19:00:00.000', '20141003 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7741, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20141010 19:00:00.000', '20141010 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7742, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20141017 19:00:00.000', '20141017 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7743, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20141024 19:00:00.000', '20141024 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7744, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20141031 19:00:00.000', '20141031 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7745, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20141107 19:00:00.000', '20141107 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7746, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20141114 19:00:00.000', '20141114 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7747, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20141121 19:00:00.000', '20141121 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7748, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20141128 19:00:00.000', '20141128 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7749, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20141205 19:00:00.000', '20141205 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7750, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20141212 19:00:00.000', '20141212 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7751, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20141219 19:00:00.000', '20141219 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7752, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20141226 19:00:00.000', '20141226 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7753, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20150102 19:00:00.000', '20150102 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7754, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20150109 19:00:00.000', '20150109 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7755, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20150116 19:00:00.000', '20150116 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7756, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20150123 19:00:00.000', '20150123 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7757, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20150130 19:00:00.000', '20150130 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7758, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20150206 19:00:00.000', '20150206 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7759, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20150213 19:00:00.000', '20150213 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7760, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20150220 19:00:00.000', '20150220 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7761, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20150227 19:00:00.000', '20150227 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7762, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20150306 19:00:00.000', '20150306 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7763, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20150313 19:00:00.000', '20150313 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7764, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20150320 19:00:00.000', '20150320 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7765, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20150327 19:00:00.000', '20150327 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7766, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20150403 19:00:00.000', '20150403 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7767, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20150410 19:00:00.000', '20150410 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7768, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20150417 19:00:00.000', '20150417 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7769, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20150424 19:00:00.000', '20150424 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7770, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20150501 19:00:00.000', '20150501 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7771, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20150508 19:00:00.000', '20150508 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7772, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20150515 19:00:00.000', '20150515 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7773, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20150522 19:00:00.000', '20150522 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7774, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20150529 19:00:00.000', '20150529 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7775, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20150605 19:00:00.000', '20150605 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7776, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20150612 19:00:00.000', '20150612 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7777, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20150619 19:00:00.000', '20150619 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7778, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20150626 19:00:00.000', '20150626 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7779, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20150703 19:00:00.000', '20150703 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7780, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20150710 19:00:00.000', '20150710 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7781, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20150717 19:00:00.000', '20150717 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7782, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20150724 19:00:00.000', '20150724 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7783, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20150731 19:00:00.000', '20150731 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7784, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20150807 19:00:00.000', '20150807 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7785, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20150814 19:00:00.000', '20150814 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7786, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20150821 19:00:00.000', '20150821 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7787, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20150828 19:00:00.000', '20150828 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7788, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20150904 19:00:00.000', '20150904 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7789, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20150911 19:00:00.000', '20150911 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7790, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20150918 19:00:00.000', '20150918 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7791, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20150925 19:00:00.000', '20150925 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7792, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20151002 19:00:00.000', '20151002 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7793, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20151009 19:00:00.000', '20151009 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7794, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20151016 19:00:00.000', '20151016 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7795, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20151023 19:00:00.000', '20151023 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7796, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20151030 19:00:00.000', '20151030 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7797, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20151106 19:00:00.000', '20151106 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7798, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20151113 19:00:00.000', '20151113 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7799, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20151120 19:00:00.000', '20151120 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7800, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20151127 19:00:00.000', '20151127 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7801, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20151204 19:00:00.000', '20151204 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7802, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20151211 19:00:00.000', '20151211 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7803, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20151218 19:00:00.000', '20151218 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7804, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20151225 19:00:00.000', '20151225 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7805, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20160101 19:00:00.000', '20160101 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7806, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20160108 19:00:00.000', '20160108 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7807, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20160115 19:00:00.000', '20160115 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7808, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20160122 19:00:00.000', '20160122 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7809, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20160129 19:00:00.000', '20160129 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7810, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20160205 19:00:00.000', '20160205 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7811, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20160212 19:00:00.000', '20160212 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7812, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20160219 19:00:00.000', '20160219 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7813, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20160226 19:00:00.000', '20160226 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7814, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20160304 19:00:00.000', '20160304 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7815, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20160311 19:00:00.000', '20160311 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7816, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20160318 19:00:00.000', '20160318 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7817, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20160325 19:00:00.000', '20160325 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7818, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20160401 19:00:00.000', '20160401 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7819, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20160408 19:00:00.000', '20160408 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7820, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20160415 19:00:00.000', '20160415 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7821, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20160422 19:00:00.000', '20160422 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7822, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20160429 19:00:00.000', '20160429 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7823, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20160506 19:00:00.000', '20160506 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7824, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20160513 19:00:00.000', '20160513 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7825, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20160520 19:00:00.000', '20160520 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7826, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20160527 19:00:00.000', '20160527 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7827, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20160603 19:00:00.000', '20160603 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7828, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20160610 19:00:00.000', '20160610 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7829, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20160617 19:00:00.000', '20160617 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7830, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20160624 19:00:00.000', '20160624 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7831, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20160701 19:00:00.000', '20160701 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7832, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20160708 19:00:00.000', '20160708 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7833, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20160715 19:00:00.000', '20160715 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7834, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20160722 19:00:00.000', '20160722 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7835, 12, N'Oceans of Knowledge', N'Oceans of Knowledge - Islamic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Oceans of Knowledge - Islamic Studies</h3>', N'Main Center', '20160729 19:00:00.000', '20160729 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7836, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20110804 19:00:00.000', '20110804 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7837, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20110811 19:00:00.000', '20110811 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7838, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20110818 19:00:00.000', '20110818 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7839, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20110825 19:00:00.000', '20110825 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7840, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20110901 19:00:00.000', '20110901 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7841, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20110908 19:00:00.000', '20110908 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7842, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20110915 19:00:00.000', '20110915 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7843, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20110922 19:00:00.000', '20110922 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7844, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20110929 19:00:00.000', '20110929 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7845, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20111006 19:00:00.000', '20111006 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7846, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20111013 19:00:00.000', '20111013 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7847, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20111020 19:00:00.000', '20111020 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7848, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20111027 19:00:00.000', '20111027 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7849, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20111103 19:00:00.000', '20111103 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7850, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20111110 19:00:00.000', '20111110 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7851, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20111117 19:00:00.000', '20111117 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7852, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20111124 19:00:00.000', '20111124 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7853, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20111201 19:00:00.000', '20111201 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7854, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20111208 19:00:00.000', '20111208 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7855, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20111215 19:00:00.000', '20111215 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7856, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20111222 19:00:00.000', '20111222 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7857, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20111229 19:00:00.000', '20111229 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7858, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20120105 19:00:00.000', '20120105 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7859, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20120112 19:00:00.000', '20120112 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7860, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20120119 19:00:00.000', '20120119 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7861, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20120126 19:00:00.000', '20120126 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7862, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20120202 19:00:00.000', '20120202 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7863, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20120209 19:00:00.000', '20120209 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7864, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20120216 19:00:00.000', '20120216 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7865, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20120223 19:00:00.000', '20120223 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7866, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20120301 19:00:00.000', '20120301 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7867, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20120308 19:00:00.000', '20120308 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7868, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20120315 19:00:00.000', '20120315 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7869, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20120322 19:00:00.000', '20120322 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7870, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20120329 19:00:00.000', '20120329 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7871, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20120405 19:00:00.000', '20120405 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7872, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20120412 19:00:00.000', '20120412 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7873, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20120419 19:00:00.000', '20120419 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7874, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20120426 19:00:00.000', '20120426 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7875, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20120503 19:00:00.000', '20120503 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7876, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20120510 19:00:00.000', '20120510 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7877, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20120517 19:00:00.000', '20120517 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7878, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20120524 19:00:00.000', '20120524 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7879, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20120531 19:00:00.000', '20120531 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7880, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20120607 19:00:00.000', '20120607 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7881, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20120614 19:00:00.000', '20120614 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7882, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20120621 19:00:00.000', '20120621 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7883, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20120628 19:00:00.000', '20120628 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7884, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20120705 19:00:00.000', '20120705 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7885, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20120712 19:00:00.000', '20120712 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7886, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20120719 19:00:00.000', '20120719 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7887, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20120726 19:00:00.000', '20120726 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7888, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20120802 19:00:00.000', '20120802 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7889, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20120809 19:00:00.000', '20120809 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7890, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20120816 19:00:00.000', '20120816 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7891, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20120823 19:00:00.000', '20120823 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7892, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20120830 19:00:00.000', '20120830 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7893, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20120906 19:00:00.000', '20120906 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7894, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20120913 19:00:00.000', '20120913 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7895, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20120920 19:00:00.000', '20120920 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7896, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20120927 19:00:00.000', '20120927 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7897, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20121004 19:00:00.000', '20121004 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7898, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20121011 19:00:00.000', '20121011 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7899, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20121018 19:00:00.000', '20121018 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7900, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20121025 19:00:00.000', '20121025 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7901, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20121101 19:00:00.000', '20121101 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7902, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20121108 19:00:00.000', '20121108 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7903, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20121115 19:00:00.000', '20121115 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7904, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20121122 19:00:00.000', '20121122 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7905, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20121129 19:00:00.000', '20121129 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7906, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20121206 19:00:00.000', '20121206 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7907, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20121213 19:00:00.000', '20121213 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7908, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20121220 19:00:00.000', '20121220 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7909, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20121227 19:00:00.000', '20121227 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7910, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20130103 19:00:00.000', '20130103 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7911, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20130110 19:00:00.000', '20130110 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7912, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20130117 19:00:00.000', '20130117 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7913, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20130124 19:00:00.000', '20130124 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7914, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20130131 19:00:00.000', '20130131 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7915, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20130207 19:00:00.000', '20130207 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7916, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20130214 19:00:00.000', '20130214 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7917, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20130221 19:00:00.000', '20130221 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7918, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20130228 19:00:00.000', '20130228 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7919, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20130307 19:00:00.000', '20130307 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7920, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20130314 19:00:00.000', '20130314 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7921, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20130321 19:00:00.000', '20130321 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7922, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20130328 19:00:00.000', '20130328 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7923, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20130404 19:00:00.000', '20130404 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7924, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20130411 19:00:00.000', '20130411 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7925, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20130418 19:00:00.000', '20130418 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7926, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20130425 19:00:00.000', '20130425 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7927, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20130502 19:00:00.000', '20130502 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7928, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20130509 19:00:00.000', '20130509 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7929, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20130516 19:00:00.000', '20130516 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7930, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20130523 19:00:00.000', '20130523 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7931, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20130530 19:00:00.000', '20130530 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7932, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20130606 19:00:00.000', '20130606 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7933, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20130613 19:00:00.000', '20130613 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7934, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20130620 19:00:00.000', '20130620 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7935, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20130627 19:00:00.000', '20130627 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7936, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20130704 19:00:00.000', '20130704 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7937, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20130711 19:00:00.000', '20130711 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7938, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20130718 19:00:00.000', '20130718 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7939, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20130725 19:00:00.000', '20130725 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7940, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20130801 19:00:00.000', '20130801 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7941, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20130808 19:00:00.000', '20130808 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7942, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20130815 19:00:00.000', '20130815 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7943, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20130822 19:00:00.000', '20130822 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7944, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20130829 19:00:00.000', '20130829 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7945, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20130905 19:00:00.000', '20130905 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7946, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20130912 19:00:00.000', '20130912 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7947, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20130919 19:00:00.000', '20130919 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7948, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20130926 19:00:00.000', '20130926 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7949, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20131003 19:00:00.000', '20131003 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7950, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20131010 19:00:00.000', '20131010 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7951, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20131017 19:00:00.000', '20131017 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7952, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20131024 19:00:00.000', '20131024 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7953, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20131031 19:00:00.000', '20131031 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7954, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20131107 19:00:00.000', '20131107 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7955, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20131114 19:00:00.000', '20131114 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7956, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20131121 19:00:00.000', '20131121 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7957, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20131128 19:00:00.000', '20131128 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7958, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20131205 19:00:00.000', '20131205 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7959, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20131212 19:00:00.000', '20131212 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7960, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20131219 19:00:00.000', '20131219 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7961, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20131226 19:00:00.000', '20131226 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7962, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20140102 19:00:00.000', '20140102 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7963, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20140109 19:00:00.000', '20140109 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7964, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20140116 19:00:00.000', '20140116 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7965, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20140123 19:00:00.000', '20140123 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7966, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20140130 19:00:00.000', '20140130 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7967, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20140206 19:00:00.000', '20140206 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7968, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20140213 19:00:00.000', '20140213 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7969, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20140220 19:00:00.000', '20140220 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7970, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20140227 19:00:00.000', '20140227 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7971, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20140306 19:00:00.000', '20140306 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7972, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20140313 19:00:00.000', '20140313 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7973, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20140320 19:00:00.000', '20140320 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7974, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20140327 19:00:00.000', '20140327 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7975, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20140403 19:00:00.000', '20140403 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7976, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20140410 19:00:00.000', '20140410 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7977, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20140417 19:00:00.000', '20140417 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7978, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20140424 19:00:00.000', '20140424 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7979, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20140501 19:00:00.000', '20140501 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7980, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20140508 19:00:00.000', '20140508 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7981, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20140515 19:00:00.000', '20140515 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7982, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20140522 19:00:00.000', '20140522 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7983, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20140529 19:00:00.000', '20140529 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7984, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20140605 19:00:00.000', '20140605 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7985, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20140612 19:00:00.000', '20140612 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7986, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20140619 19:00:00.000', '20140619 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7987, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20140626 19:00:00.000', '20140626 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7988, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20140703 19:00:00.000', '20140703 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7989, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20140710 19:00:00.000', '20140710 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7990, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20140717 19:00:00.000', '20140717 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7991, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20140724 19:00:00.000', '20140724 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7992, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20140731 19:00:00.000', '20140731 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7993, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20140807 19:00:00.000', '20140807 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7994, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20140814 19:00:00.000', '20140814 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7995, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20140821 19:00:00.000', '20140821 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7996, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20140828 19:00:00.000', '20140828 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7997, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20140904 19:00:00.000', '20140904 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7998, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20140911 19:00:00.000', '20140911 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (7999, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20140918 19:00:00.000', '20140918 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8000, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20140925 19:00:00.000', '20140925 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8001, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20141002 19:00:00.000', '20141002 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8002, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20141009 19:00:00.000', '20141009 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8003, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20141016 19:00:00.000', '20141016 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8004, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20141023 19:00:00.000', '20141023 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8005, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20141030 19:00:00.000', '20141030 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8006, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20141106 19:00:00.000', '20141106 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8007, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20141113 19:00:00.000', '20141113 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8008, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20141120 19:00:00.000', '20141120 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8009, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20141127 19:00:00.000', '20141127 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8010, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20141204 19:00:00.000', '20141204 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8011, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20141211 19:00:00.000', '20141211 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8012, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20141218 19:00:00.000', '20141218 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8013, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20141225 19:00:00.000', '20141225 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8014, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20150101 19:00:00.000', '20150101 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8015, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20150108 19:00:00.000', '20150108 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8016, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20150115 19:00:00.000', '20150115 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8017, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20150122 19:00:00.000', '20150122 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8018, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20150129 19:00:00.000', '20150129 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8019, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20150205 19:00:00.000', '20150205 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8020, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20150212 19:00:00.000', '20150212 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8021, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20150219 19:00:00.000', '20150219 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8022, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20150226 19:00:00.000', '20150226 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8023, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20150305 19:00:00.000', '20150305 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8024, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20150312 19:00:00.000', '20150312 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8025, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20150319 19:00:00.000', '20150319 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8026, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20150326 19:00:00.000', '20150326 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8027, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20150402 19:00:00.000', '20150402 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8028, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20150409 19:00:00.000', '20150409 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8029, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20150416 19:00:00.000', '20150416 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8030, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20150423 19:00:00.000', '20150423 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8031, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20150430 19:00:00.000', '20150430 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8032, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20150507 19:00:00.000', '20150507 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8033, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20150514 19:00:00.000', '20150514 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8034, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20150521 19:00:00.000', '20150521 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8035, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20150528 19:00:00.000', '20150528 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8036, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20150604 19:00:00.000', '20150604 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8037, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20150611 19:00:00.000', '20150611 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8038, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20150618 19:00:00.000', '20150618 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8039, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20150625 19:00:00.000', '20150625 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8040, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20150702 19:00:00.000', '20150702 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8041, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20150709 19:00:00.000', '20150709 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8042, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20150716 19:00:00.000', '20150716 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8043, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20150723 19:00:00.000', '20150723 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8044, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20150730 19:00:00.000', '20150730 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8045, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20150806 19:00:00.000', '20150806 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8046, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20150813 19:00:00.000', '20150813 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8047, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20150820 19:00:00.000', '20150820 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8048, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20150827 19:00:00.000', '20150827 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8049, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20150903 19:00:00.000', '20150903 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8050, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20150910 19:00:00.000', '20150910 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8051, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20150917 19:00:00.000', '20150917 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8052, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20150924 19:00:00.000', '20150924 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8053, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20151001 19:00:00.000', '20151001 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8054, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20151008 19:00:00.000', '20151008 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8055, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20151015 19:00:00.000', '20151015 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8056, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20151022 19:00:00.000', '20151022 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8057, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20151029 19:00:00.000', '20151029 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8058, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20151105 19:00:00.000', '20151105 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8059, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20151112 19:00:00.000', '20151112 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8060, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20151119 19:00:00.000', '20151119 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8061, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20151126 19:00:00.000', '20151126 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8062, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20151203 19:00:00.000', '20151203 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8063, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20151210 19:00:00.000', '20151210 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8064, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20151217 19:00:00.000', '20151217 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8065, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20151224 19:00:00.000', '20151224 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8066, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20151231 19:00:00.000', '20151231 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8067, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20160107 19:00:00.000', '20160107 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8068, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20160114 19:00:00.000', '20160114 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8069, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20160121 19:00:00.000', '20160121 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8070, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20160128 19:00:00.000', '20160128 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8071, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20160204 19:00:00.000', '20160204 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8072, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20160211 19:00:00.000', '20160211 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8073, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20160218 19:00:00.000', '20160218 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8074, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20160225 19:00:00.000', '20160225 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8075, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20160303 19:00:00.000', '20160303 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8076, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20160310 19:00:00.000', '20160310 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8077, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20160317 19:00:00.000', '20160317 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8078, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20160324 19:00:00.000', '20160324 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8079, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20160331 19:00:00.000', '20160331 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8080, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20160407 19:00:00.000', '20160407 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8081, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20160414 19:00:00.000', '20160414 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8082, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20160421 19:00:00.000', '20160421 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8083, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20160428 19:00:00.000', '20160428 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8084, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20160505 19:00:00.000', '20160505 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8085, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20160512 19:00:00.000', '20160512 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8086, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20160519 19:00:00.000', '20160519 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8087, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20160526 19:00:00.000', '20160526 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8088, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20160602 19:00:00.000', '20160602 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8089, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20160609 19:00:00.000', '20160609 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8090, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20160616 19:00:00.000', '20160616 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8091, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20160623 19:00:00.000', '20160623 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8092, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20160630 19:00:00.000', '20160630 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8093, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20160707 19:00:00.000', '20160707 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8094, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20160714 19:00:00.000', '20160714 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8095, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20160721 19:00:00.000', '20160721 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8096, 10, N'Journey Through the Quran', N'Journey Through the Quran - Quranic Studies', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Journey Through the Quran - Quranic Studies</h3>', N'Main Center', '20160728 19:00:00.000', '20160728 20:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8097, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20110807 07:00:00.000', '20110807 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8098, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20110814 07:00:00.000', '20110814 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8099, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20110821 07:00:00.000', '20110821 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8100, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20110828 07:00:00.000', '20110828 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8101, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20110904 07:00:00.000', '20110904 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8102, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20110911 07:00:00.000', '20110911 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8103, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20110918 07:00:00.000', '20110918 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8104, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20110925 07:00:00.000', '20110925 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8105, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20111002 07:00:00.000', '20111002 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8106, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20111009 07:00:00.000', '20111009 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8107, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20111016 07:00:00.000', '20111016 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8108, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20111023 07:00:00.000', '20111023 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8109, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20111030 07:00:00.000', '20111030 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8110, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20111106 07:00:00.000', '20111106 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8111, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20111113 07:00:00.000', '20111113 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8112, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20111120 07:00:00.000', '20111120 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8113, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20111127 07:00:00.000', '20111127 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8114, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20111204 07:00:00.000', '20111204 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8115, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20111211 07:00:00.000', '20111211 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8116, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20111218 07:00:00.000', '20111218 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8117, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20111225 07:00:00.000', '20111225 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8118, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20120101 07:00:00.000', '20120101 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8119, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20120108 07:00:00.000', '20120108 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8120, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20120115 07:00:00.000', '20120115 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8121, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20120122 07:00:00.000', '20120122 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8122, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20120129 07:00:00.000', '20120129 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8123, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20120205 07:00:00.000', '20120205 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8124, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20120212 07:00:00.000', '20120212 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8125, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20120219 07:00:00.000', '20120219 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8126, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20120226 07:00:00.000', '20120226 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8127, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20120304 07:00:00.000', '20120304 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8128, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20120311 07:00:00.000', '20120311 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8129, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20120318 07:00:00.000', '20120318 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8130, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20120325 07:00:00.000', '20120325 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8131, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20120401 07:00:00.000', '20120401 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8132, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20120408 07:00:00.000', '20120408 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8133, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20120415 07:00:00.000', '20120415 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8134, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20120422 07:00:00.000', '20120422 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8135, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20120429 07:00:00.000', '20120429 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8136, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20120506 07:00:00.000', '20120506 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8137, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20120513 07:00:00.000', '20120513 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8138, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20120520 07:00:00.000', '20120520 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8139, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20120527 07:00:00.000', '20120527 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8140, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20120603 07:00:00.000', '20120603 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8141, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20120610 07:00:00.000', '20120610 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8142, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20120617 07:00:00.000', '20120617 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8143, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20120624 07:00:00.000', '20120624 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8144, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20120701 07:00:00.000', '20120701 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8145, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20120708 07:00:00.000', '20120708 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8146, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20120715 07:00:00.000', '20120715 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8147, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20120722 07:00:00.000', '20120722 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8148, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20120729 07:00:00.000', '20120729 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8149, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20120805 07:00:00.000', '20120805 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8150, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20120812 07:00:00.000', '20120812 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8151, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20120819 07:00:00.000', '20120819 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8152, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20120826 07:00:00.000', '20120826 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8153, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20120902 07:00:00.000', '20120902 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8154, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20120909 07:00:00.000', '20120909 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8155, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20120916 07:00:00.000', '20120916 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8156, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20120923 07:00:00.000', '20120923 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8157, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20120930 07:00:00.000', '20120930 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8158, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20121007 07:00:00.000', '20121007 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8159, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20121014 07:00:00.000', '20121014 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8160, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20121021 07:00:00.000', '20121021 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8161, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20121028 07:00:00.000', '20121028 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8162, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20121104 07:00:00.000', '20121104 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8163, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20121111 07:00:00.000', '20121111 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8164, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20121118 07:00:00.000', '20121118 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8165, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20121125 07:00:00.000', '20121125 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8166, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20121202 07:00:00.000', '20121202 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8167, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20121209 07:00:00.000', '20121209 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8168, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20121216 07:00:00.000', '20121216 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8169, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20121223 07:00:00.000', '20121223 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8170, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20121230 07:00:00.000', '20121230 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8171, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20130106 07:00:00.000', '20130106 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8172, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20130113 07:00:00.000', '20130113 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8173, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20130120 07:00:00.000', '20130120 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8174, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20130127 07:00:00.000', '20130127 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8175, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20130203 07:00:00.000', '20130203 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8176, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20130210 07:00:00.000', '20130210 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8177, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20130217 07:00:00.000', '20130217 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8178, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20130224 07:00:00.000', '20130224 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8179, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20130303 07:00:00.000', '20130303 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8180, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20130310 07:00:00.000', '20130310 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8181, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20130317 07:00:00.000', '20130317 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8182, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20130324 07:00:00.000', '20130324 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8183, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20130331 07:00:00.000', '20130331 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8184, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20130407 07:00:00.000', '20130407 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8185, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20130414 07:00:00.000', '20130414 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8186, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20130421 07:00:00.000', '20130421 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8187, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20130428 07:00:00.000', '20130428 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8188, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20130505 07:00:00.000', '20130505 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8189, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20130512 07:00:00.000', '20130512 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8190, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20130519 07:00:00.000', '20130519 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8191, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20130526 07:00:00.000', '20130526 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8192, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20130602 07:00:00.000', '20130602 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8193, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20130609 07:00:00.000', '20130609 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8194, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20130616 07:00:00.000', '20130616 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8195, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20130623 07:00:00.000', '20130623 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8196, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20130630 07:00:00.000', '20130630 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8197, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20130707 07:00:00.000', '20130707 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8198, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20130714 07:00:00.000', '20130714 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8199, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20130721 07:00:00.000', '20130721 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8200, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20130728 07:00:00.000', '20130728 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8201, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20130804 07:00:00.000', '20130804 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8202, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20130811 07:00:00.000', '20130811 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8203, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20130818 07:00:00.000', '20130818 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8204, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20130825 07:00:00.000', '20130825 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8205, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20130901 07:00:00.000', '20130901 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8206, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20130908 07:00:00.000', '20130908 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8207, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20130915 07:00:00.000', '20130915 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8208, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20130922 07:00:00.000', '20130922 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8209, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20130929 07:00:00.000', '20130929 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8210, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20131006 07:00:00.000', '20131006 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8211, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20131013 07:00:00.000', '20131013 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8212, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20131020 07:00:00.000', '20131020 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8213, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20131027 07:00:00.000', '20131027 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8214, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20131103 07:00:00.000', '20131103 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8215, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20131110 07:00:00.000', '20131110 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8216, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20131117 07:00:00.000', '20131117 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8217, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20131124 07:00:00.000', '20131124 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8218, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20131201 07:00:00.000', '20131201 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8219, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20131208 07:00:00.000', '20131208 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8220, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20131215 07:00:00.000', '20131215 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8221, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20131222 07:00:00.000', '20131222 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8222, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20131229 07:00:00.000', '20131229 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8223, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20140105 07:00:00.000', '20140105 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8224, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20140112 07:00:00.000', '20140112 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8225, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20140119 07:00:00.000', '20140119 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8226, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20140126 07:00:00.000', '20140126 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8227, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20140202 07:00:00.000', '20140202 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8228, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20140209 07:00:00.000', '20140209 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8229, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20140216 07:00:00.000', '20140216 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8230, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20140223 07:00:00.000', '20140223 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8231, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20140302 07:00:00.000', '20140302 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8232, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20140309 07:00:00.000', '20140309 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8233, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20140316 07:00:00.000', '20140316 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8234, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20140323 07:00:00.000', '20140323 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8235, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20140330 07:00:00.000', '20140330 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8236, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20140406 07:00:00.000', '20140406 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8237, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20140413 07:00:00.000', '20140413 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8238, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20140420 07:00:00.000', '20140420 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8239, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20140427 07:00:00.000', '20140427 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8240, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20140504 07:00:00.000', '20140504 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8241, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20140511 07:00:00.000', '20140511 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8242, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20140518 07:00:00.000', '20140518 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8243, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20140525 07:00:00.000', '20140525 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8244, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20140601 07:00:00.000', '20140601 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8245, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20140608 07:00:00.000', '20140608 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8246, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20140615 07:00:00.000', '20140615 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8247, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20140622 07:00:00.000', '20140622 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8248, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20140629 07:00:00.000', '20140629 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8249, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20140706 07:00:00.000', '20140706 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8250, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20140713 07:00:00.000', '20140713 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8251, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20140720 07:00:00.000', '20140720 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8252, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20140727 07:00:00.000', '20140727 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8253, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20140803 07:00:00.000', '20140803 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8254, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20140810 07:00:00.000', '20140810 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8255, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20140817 07:00:00.000', '20140817 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8256, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20140824 07:00:00.000', '20140824 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8257, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20140831 07:00:00.000', '20140831 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8258, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20140907 07:00:00.000', '20140907 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8259, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20140914 07:00:00.000', '20140914 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8260, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20140921 07:00:00.000', '20140921 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8261, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20140928 07:00:00.000', '20140928 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8262, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20141005 07:00:00.000', '20141005 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8263, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20141012 07:00:00.000', '20141012 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8264, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20141019 07:00:00.000', '20141019 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8265, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20141026 07:00:00.000', '20141026 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8266, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20141102 07:00:00.000', '20141102 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8267, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20141109 07:00:00.000', '20141109 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8268, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20141116 07:00:00.000', '20141116 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8269, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20141123 07:00:00.000', '20141123 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8270, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20141130 07:00:00.000', '20141130 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8271, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20141207 07:00:00.000', '20141207 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8272, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20141214 07:00:00.000', '20141214 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8273, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20141221 07:00:00.000', '20141221 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8274, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20141228 07:00:00.000', '20141228 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8275, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20150104 07:00:00.000', '20150104 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8276, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20150111 07:00:00.000', '20150111 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8277, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20150118 07:00:00.000', '20150118 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8278, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20150125 07:00:00.000', '20150125 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8279, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20150201 07:00:00.000', '20150201 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8280, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20150208 07:00:00.000', '20150208 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8281, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20150215 07:00:00.000', '20150215 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8282, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20150222 07:00:00.000', '20150222 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8283, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20150301 07:00:00.000', '20150301 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8284, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20150308 07:00:00.000', '20150308 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8285, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20150315 07:00:00.000', '20150315 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8286, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20150322 07:00:00.000', '20150322 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8287, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20150329 07:00:00.000', '20150329 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8288, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20150405 07:00:00.000', '20150405 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8289, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20150412 07:00:00.000', '20150412 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8290, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20150419 07:00:00.000', '20150419 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8291, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20150426 07:00:00.000', '20150426 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8292, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20150503 07:00:00.000', '20150503 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8293, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20150510 07:00:00.000', '20150510 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8294, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20150517 07:00:00.000', '20150517 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8295, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20150524 07:00:00.000', '20150524 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8296, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20150531 07:00:00.000', '20150531 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8297, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20150607 07:00:00.000', '20150607 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8298, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20150614 07:00:00.000', '20150614 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8299, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20150621 07:00:00.000', '20150621 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8300, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20150628 07:00:00.000', '20150628 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8301, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20150705 07:00:00.000', '20150705 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8302, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20150712 07:00:00.000', '20150712 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8303, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20150719 07:00:00.000', '20150719 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8304, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20150726 07:00:00.000', '20150726 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8305, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20150802 07:00:00.000', '20150802 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8306, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20150809 07:00:00.000', '20150809 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8307, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20150816 07:00:00.000', '20150816 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8308, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20150823 07:00:00.000', '20150823 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8309, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20150830 07:00:00.000', '20150830 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8310, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20150906 07:00:00.000', '20150906 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8311, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20150913 07:00:00.000', '20150913 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8312, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20150920 07:00:00.000', '20150920 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8313, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20150927 07:00:00.000', '20150927 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8314, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20151004 07:00:00.000', '20151004 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8315, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20151011 07:00:00.000', '20151011 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8316, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20151018 07:00:00.000', '20151018 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8317, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20151025 07:00:00.000', '20151025 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8318, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20151101 07:00:00.000', '20151101 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8319, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20151108 07:00:00.000', '20151108 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8320, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20151115 07:00:00.000', '20151115 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8321, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20151122 07:00:00.000', '20151122 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8322, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20151129 07:00:00.000', '20151129 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8323, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20151206 07:00:00.000', '20151206 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8324, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20151213 07:00:00.000', '20151213 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8325, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20151220 07:00:00.000', '20151220 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8326, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20151227 07:00:00.000', '20151227 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8327, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20160103 07:00:00.000', '20160103 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8328, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20160110 07:00:00.000', '20160110 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8329, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20160117 07:00:00.000', '20160117 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8330, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20160124 07:00:00.000', '20160124 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8331, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20160131 07:00:00.000', '20160131 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8332, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20160207 07:00:00.000', '20160207 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8333, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20160214 07:00:00.000', '20160214 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8334, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20160221 07:00:00.000', '20160221 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8335, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20160228 07:00:00.000', '20160228 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8336, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20160306 07:00:00.000', '20160306 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8337, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20160313 07:00:00.000', '20160313 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8338, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20160320 07:00:00.000', '20160320 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8339, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20160327 07:00:00.000', '20160327 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8340, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20160403 07:00:00.000', '20160403 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8341, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20160410 07:00:00.000', '20160410 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8342, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20160417 07:00:00.000', '20160417 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8343, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20160424 07:00:00.000', '20160424 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8344, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20160501 07:00:00.000', '20160501 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8345, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20160508 07:00:00.000', '20160508 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8346, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20160515 07:00:00.000', '20160515 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8347, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20160522 07:00:00.000', '20160522 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8348, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20160529 07:00:00.000', '20160529 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8349, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20160605 07:00:00.000', '20160605 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8350, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20160612 07:00:00.000', '20160612 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8351, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20160619 07:00:00.000', '20160619 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8352, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20160626 07:00:00.000', '20160626 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8353, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20160703 07:00:00.000', '20160703 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8354, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20160710 07:00:00.000', '20160710 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8355, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20160717 07:00:00.000', '20160717 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8356, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20160724 07:00:00.000', '20160724 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8357, 14, N'Taleem Al Quran', N'Taleem Al Quran: Sh. Abdurrafaa', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Taleem Al Quran: Sh. Abdurrafaa</h3>', N'Main Center', '20160731 07:00:00.000', '20160731 08:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8358, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20110808 06:30:00.000', '20110808 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8359, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20110815 06:30:00.000', '20110815 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8360, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20110822 06:30:00.000', '20110822 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8361, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20110829 06:30:00.000', '20110829 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8362, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20110905 06:30:00.000', '20110905 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8363, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20110912 06:30:00.000', '20110912 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8364, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20110919 06:30:00.000', '20110919 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8365, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20110926 06:30:00.000', '20110926 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8366, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20111003 06:30:00.000', '20111003 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8367, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20111010 06:30:00.000', '20111010 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8368, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20111017 06:30:00.000', '20111017 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8369, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20111024 06:30:00.000', '20111024 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8370, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20111031 06:30:00.000', '20111031 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8371, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20111107 06:30:00.000', '20111107 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8372, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20111114 06:30:00.000', '20111114 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8373, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20111121 06:30:00.000', '20111121 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8374, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20111128 06:30:00.000', '20111128 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8375, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20111205 06:30:00.000', '20111205 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8376, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20111212 06:30:00.000', '20111212 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8377, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20111219 06:30:00.000', '20111219 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8378, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20111226 06:30:00.000', '20111226 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8379, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20120102 06:30:00.000', '20120102 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8380, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20120109 06:30:00.000', '20120109 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8381, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20120116 06:30:00.000', '20120116 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8382, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20120123 06:30:00.000', '20120123 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8383, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20120130 06:30:00.000', '20120130 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8384, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20120206 06:30:00.000', '20120206 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8385, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20120213 06:30:00.000', '20120213 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8386, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20120220 06:30:00.000', '20120220 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8387, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20120227 06:30:00.000', '20120227 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8388, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20120305 06:30:00.000', '20120305 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8389, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20120312 06:30:00.000', '20120312 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8390, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20120319 06:30:00.000', '20120319 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8391, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20120326 06:30:00.000', '20120326 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8392, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20120402 06:30:00.000', '20120402 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8393, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20120409 06:30:00.000', '20120409 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8394, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20120416 06:30:00.000', '20120416 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8395, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20120423 06:30:00.000', '20120423 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8396, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20120430 06:30:00.000', '20120430 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8397, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20120507 06:30:00.000', '20120507 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8398, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20120514 06:30:00.000', '20120514 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8399, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20120521 06:30:00.000', '20120521 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8400, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20120528 06:30:00.000', '20120528 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8401, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20120604 06:30:00.000', '20120604 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8402, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20120611 06:30:00.000', '20120611 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8403, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20120618 06:30:00.000', '20120618 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8404, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20120625 06:30:00.000', '20120625 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8405, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20120702 06:30:00.000', '20120702 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8406, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20120709 06:30:00.000', '20120709 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8407, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20120716 06:30:00.000', '20120716 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8408, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20120723 06:30:00.000', '20120723 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8409, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20120730 06:30:00.000', '20120730 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8410, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20120806 06:30:00.000', '20120806 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8411, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20120813 06:30:00.000', '20120813 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8412, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20120820 06:30:00.000', '20120820 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8413, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20120827 06:30:00.000', '20120827 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8414, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20120903 06:30:00.000', '20120903 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8415, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20120910 06:30:00.000', '20120910 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8416, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20120917 06:30:00.000', '20120917 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8417, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20120924 06:30:00.000', '20120924 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8418, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20121001 06:30:00.000', '20121001 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8419, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20121008 06:30:00.000', '20121008 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8420, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20121015 06:30:00.000', '20121015 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8421, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20121022 06:30:00.000', '20121022 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8422, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20121029 06:30:00.000', '20121029 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8423, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20121105 06:30:00.000', '20121105 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8424, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20121112 06:30:00.000', '20121112 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8425, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20121119 06:30:00.000', '20121119 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8426, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20121126 06:30:00.000', '20121126 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8427, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20121203 06:30:00.000', '20121203 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8428, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20121210 06:30:00.000', '20121210 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8429, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20121217 06:30:00.000', '20121217 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8430, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20121224 06:30:00.000', '20121224 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8431, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20121231 06:30:00.000', '20121231 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8432, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20130107 06:30:00.000', '20130107 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8433, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20130114 06:30:00.000', '20130114 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8434, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20130121 06:30:00.000', '20130121 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8435, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20130128 06:30:00.000', '20130128 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8436, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20130204 06:30:00.000', '20130204 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8437, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20130211 06:30:00.000', '20130211 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8438, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20130218 06:30:00.000', '20130218 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8439, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20130225 06:30:00.000', '20130225 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8440, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20130304 06:30:00.000', '20130304 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8441, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20130311 06:30:00.000', '20130311 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8442, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20130318 06:30:00.000', '20130318 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8443, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20130325 06:30:00.000', '20130325 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8444, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20130401 06:30:00.000', '20130401 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8445, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20130408 06:30:00.000', '20130408 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8446, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20130415 06:30:00.000', '20130415 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8447, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20130422 06:30:00.000', '20130422 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8448, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20130429 06:30:00.000', '20130429 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8449, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20130506 06:30:00.000', '20130506 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8450, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20130513 06:30:00.000', '20130513 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8451, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20130520 06:30:00.000', '20130520 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8452, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20130527 06:30:00.000', '20130527 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8453, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20130603 06:30:00.000', '20130603 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8454, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20130610 06:30:00.000', '20130610 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8455, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20130617 06:30:00.000', '20130617 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8456, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20130624 06:30:00.000', '20130624 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8457, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20130701 06:30:00.000', '20130701 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8458, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20130708 06:30:00.000', '20130708 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8459, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20130715 06:30:00.000', '20130715 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8460, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20130722 06:30:00.000', '20130722 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8461, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20130729 06:30:00.000', '20130729 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8462, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20130805 06:30:00.000', '20130805 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8463, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20130812 06:30:00.000', '20130812 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8464, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20130819 06:30:00.000', '20130819 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8465, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20130826 06:30:00.000', '20130826 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8466, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20130902 06:30:00.000', '20130902 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8467, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20130909 06:30:00.000', '20130909 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8468, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20130916 06:30:00.000', '20130916 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8469, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20130923 06:30:00.000', '20130923 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8470, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20130930 06:30:00.000', '20130930 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8471, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20131007 06:30:00.000', '20131007 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8472, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20131014 06:30:00.000', '20131014 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8473, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20131021 06:30:00.000', '20131021 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8474, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20131028 06:30:00.000', '20131028 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8475, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20131104 06:30:00.000', '20131104 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8476, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20131111 06:30:00.000', '20131111 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8477, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20131118 06:30:00.000', '20131118 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8478, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20131125 06:30:00.000', '20131125 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8479, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20131202 06:30:00.000', '20131202 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8480, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20131209 06:30:00.000', '20131209 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8481, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20131216 06:30:00.000', '20131216 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8482, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20131223 06:30:00.000', '20131223 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8483, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20131230 06:30:00.000', '20131230 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8484, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20140106 06:30:00.000', '20140106 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8485, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20140113 06:30:00.000', '20140113 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8486, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20140120 06:30:00.000', '20140120 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8487, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20140127 06:30:00.000', '20140127 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8488, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20140203 06:30:00.000', '20140203 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8489, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20140210 06:30:00.000', '20140210 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8490, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20140217 06:30:00.000', '20140217 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8491, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20140224 06:30:00.000', '20140224 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8492, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20140303 06:30:00.000', '20140303 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8493, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20140310 06:30:00.000', '20140310 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8494, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20140317 06:30:00.000', '20140317 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8495, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20140324 06:30:00.000', '20140324 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8496, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20140331 06:30:00.000', '20140331 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8497, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20140407 06:30:00.000', '20140407 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8498, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20140414 06:30:00.000', '20140414 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8499, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20140421 06:30:00.000', '20140421 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8500, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20140428 06:30:00.000', '20140428 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8501, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20140505 06:30:00.000', '20140505 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8502, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20140512 06:30:00.000', '20140512 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8503, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20140519 06:30:00.000', '20140519 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8504, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20140526 06:30:00.000', '20140526 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8505, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20140602 06:30:00.000', '20140602 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8506, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20140609 06:30:00.000', '20140609 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8507, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20140616 06:30:00.000', '20140616 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8508, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20140623 06:30:00.000', '20140623 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8509, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20140630 06:30:00.000', '20140630 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8510, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20140707 06:30:00.000', '20140707 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8511, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20140714 06:30:00.000', '20140714 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8512, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20140721 06:30:00.000', '20140721 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8513, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20140728 06:30:00.000', '20140728 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8514, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20140804 06:30:00.000', '20140804 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8515, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20140811 06:30:00.000', '20140811 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8516, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20140818 06:30:00.000', '20140818 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8517, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20140825 06:30:00.000', '20140825 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8518, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20140901 06:30:00.000', '20140901 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8519, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20140908 06:30:00.000', '20140908 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8520, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20140915 06:30:00.000', '20140915 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8521, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20140922 06:30:00.000', '20140922 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8522, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20140929 06:30:00.000', '20140929 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8523, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20141006 06:30:00.000', '20141006 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8524, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20141013 06:30:00.000', '20141013 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8525, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20141020 06:30:00.000', '20141020 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8526, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20141027 06:30:00.000', '20141027 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8527, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20141103 06:30:00.000', '20141103 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8528, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20141110 06:30:00.000', '20141110 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8529, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20141117 06:30:00.000', '20141117 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8530, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20141124 06:30:00.000', '20141124 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8531, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20141201 06:30:00.000', '20141201 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8532, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20141208 06:30:00.000', '20141208 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8533, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20141215 06:30:00.000', '20141215 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8534, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20141222 06:30:00.000', '20141222 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8535, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20141229 06:30:00.000', '20141229 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8536, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20150105 06:30:00.000', '20150105 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8537, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20150112 06:30:00.000', '20150112 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8538, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20150119 06:30:00.000', '20150119 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8539, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20150126 06:30:00.000', '20150126 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8540, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20150202 06:30:00.000', '20150202 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8541, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20150209 06:30:00.000', '20150209 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8542, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20150216 06:30:00.000', '20150216 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8543, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20150223 06:30:00.000', '20150223 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8544, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20150302 06:30:00.000', '20150302 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8545, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20150309 06:30:00.000', '20150309 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8546, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20150316 06:30:00.000', '20150316 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8547, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20150323 06:30:00.000', '20150323 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8548, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20150330 06:30:00.000', '20150330 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8549, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20150406 06:30:00.000', '20150406 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8550, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20150413 06:30:00.000', '20150413 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8551, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20150420 06:30:00.000', '20150420 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8552, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20150427 06:30:00.000', '20150427 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8553, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20150504 06:30:00.000', '20150504 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8554, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20150511 06:30:00.000', '20150511 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8555, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20150518 06:30:00.000', '20150518 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8556, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20150525 06:30:00.000', '20150525 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8557, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20150601 06:30:00.000', '20150601 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8558, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20150608 06:30:00.000', '20150608 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8559, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20150615 06:30:00.000', '20150615 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8560, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20150622 06:30:00.000', '20150622 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8561, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20150629 06:30:00.000', '20150629 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8562, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20150706 06:30:00.000', '20150706 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8563, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20150713 06:30:00.000', '20150713 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8564, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20150720 06:30:00.000', '20150720 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8565, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20150727 06:30:00.000', '20150727 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8566, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20150803 06:30:00.000', '20150803 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8567, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20150810 06:30:00.000', '20150810 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8568, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20150817 06:30:00.000', '20150817 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8569, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20150824 06:30:00.000', '20150824 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8570, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20150831 06:30:00.000', '20150831 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8571, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20150907 06:30:00.000', '20150907 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8572, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20150914 06:30:00.000', '20150914 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8573, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20150921 06:30:00.000', '20150921 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8574, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20150928 06:30:00.000', '20150928 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8575, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20151005 06:30:00.000', '20151005 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8576, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20151012 06:30:00.000', '20151012 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8577, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20151019 06:30:00.000', '20151019 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8578, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20151026 06:30:00.000', '20151026 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8579, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20151102 06:30:00.000', '20151102 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8580, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20151109 06:30:00.000', '20151109 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8581, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20151116 06:30:00.000', '20151116 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8582, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20151123 06:30:00.000', '20151123 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8583, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20151130 06:30:00.000', '20151130 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8584, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20151207 06:30:00.000', '20151207 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8585, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20151214 06:30:00.000', '20151214 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8586, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20151221 06:30:00.000', '20151221 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8587, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20151228 06:30:00.000', '20151228 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8588, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20160104 06:30:00.000', '20160104 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8589, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20160111 06:30:00.000', '20160111 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8590, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20160118 06:30:00.000', '20160118 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8591, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20160125 06:30:00.000', '20160125 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8592, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20160201 06:30:00.000', '20160201 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8593, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20160208 06:30:00.000', '20160208 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8594, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20160215 06:30:00.000', '20160215 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8595, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20160222 06:30:00.000', '20160222 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8596, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20160229 06:30:00.000', '20160229 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8597, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20160307 06:30:00.000', '20160307 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8598, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20160314 06:30:00.000', '20160314 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8599, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20160321 06:30:00.000', '20160321 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8600, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20160328 06:30:00.000', '20160328 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8601, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20160404 06:30:00.000', '20160404 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8602, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20160411 06:30:00.000', '20160411 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8603, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20160418 06:30:00.000', '20160418 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8604, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20160425 06:30:00.000', '20160425 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8605, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20160502 06:30:00.000', '20160502 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8606, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20160509 06:30:00.000', '20160509 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8607, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20160516 06:30:00.000', '20160516 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8608, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20160523 06:30:00.000', '20160523 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8609, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20160530 06:30:00.000', '20160530 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8610, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20160606 06:30:00.000', '20160606 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8611, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20160613 06:30:00.000', '20160613 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8612, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20160620 06:30:00.000', '20160620 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8613, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20160627 06:30:00.000', '20160627 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8614, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20160704 06:30:00.000', '20160704 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8615, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20160711 06:30:00.000', '20160711 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8616, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20160718 06:30:00.000', '20160718 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8617, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20160725 06:30:00.000', '20160725 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8618, 16, N'Tafseer', N'Tafseer: Br. Solaiman Jalloh', N'<h3 style="padding-top: 0px; padding-right: 0px; padding-bottom: 6px; padding-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; font-family: Arial, sans-serif; font-size: 16px; font-weight: bold; color: rgb(34, 34, 34); ">Tafseer: Br. Solaiman Jalloh</h3>', N'Main Center', '20160801 06:30:00.000', '20160801 07:00:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8619, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20110804 19:00:00.000', '20110804 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8620, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20110811 19:00:00.000', '20110811 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8621, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20110818 19:00:00.000', '20110818 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8622, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20110825 19:00:00.000', '20110825 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8623, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20110901 19:00:00.000', '20110901 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8624, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20110908 19:00:00.000', '20110908 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8625, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20110915 19:00:00.000', '20110915 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8626, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20110922 19:00:00.000', '20110922 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8627, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20110929 19:00:00.000', '20110929 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8628, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20111006 19:00:00.000', '20111006 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8629, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20111013 19:00:00.000', '20111013 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8630, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20111020 19:00:00.000', '20111020 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8631, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20111027 19:00:00.000', '20111027 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8632, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20111103 19:00:00.000', '20111103 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8633, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20111110 19:00:00.000', '20111110 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8634, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20111117 19:00:00.000', '20111117 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8635, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20111124 19:00:00.000', '20111124 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8636, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20111201 19:00:00.000', '20111201 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8637, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20111208 19:00:00.000', '20111208 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8638, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20111215 19:00:00.000', '20111215 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8639, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20111222 19:00:00.000', '20111222 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8640, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20111229 19:00:00.000', '20111229 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8641, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20120105 19:00:00.000', '20120105 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8642, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20120112 19:00:00.000', '20120112 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8643, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20120119 19:00:00.000', '20120119 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8644, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20120126 19:00:00.000', '20120126 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8645, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20120202 19:00:00.000', '20120202 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8646, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20120209 19:00:00.000', '20120209 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8647, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20120216 19:00:00.000', '20120216 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8648, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20120223 19:00:00.000', '20120223 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8649, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20120301 19:00:00.000', '20120301 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8650, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20120308 19:00:00.000', '20120308 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8651, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20120315 19:00:00.000', '20120315 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8652, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20120322 19:00:00.000', '20120322 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8653, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20120329 19:00:00.000', '20120329 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8654, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20120405 19:00:00.000', '20120405 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8655, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20120412 19:00:00.000', '20120412 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8656, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20120419 19:00:00.000', '20120419 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8657, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20120426 19:00:00.000', '20120426 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8658, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20120503 19:00:00.000', '20120503 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8659, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20120510 19:00:00.000', '20120510 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8660, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20120517 19:00:00.000', '20120517 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8661, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20120524 19:00:00.000', '20120524 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8662, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20120531 19:00:00.000', '20120531 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8663, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20120607 19:00:00.000', '20120607 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8664, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20120614 19:00:00.000', '20120614 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8665, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20120621 19:00:00.000', '20120621 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8666, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20120628 19:00:00.000', '20120628 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8667, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20120705 19:00:00.000', '20120705 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8668, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20120712 19:00:00.000', '20120712 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8669, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20120719 19:00:00.000', '20120719 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8670, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20120726 19:00:00.000', '20120726 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8671, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20120802 19:00:00.000', '20120802 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8672, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20120809 19:00:00.000', '20120809 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8673, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20120816 19:00:00.000', '20120816 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8674, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20120823 19:00:00.000', '20120823 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8675, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20120830 19:00:00.000', '20120830 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8676, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20120906 19:00:00.000', '20120906 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8677, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20120913 19:00:00.000', '20120913 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8678, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20120920 19:00:00.000', '20120920 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8679, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20120927 19:00:00.000', '20120927 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8680, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20121004 19:00:00.000', '20121004 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8681, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20121011 19:00:00.000', '20121011 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8682, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20121018 19:00:00.000', '20121018 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8683, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20121025 19:00:00.000', '20121025 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8684, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20121101 19:00:00.000', '20121101 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8685, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20121108 19:00:00.000', '20121108 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8686, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20121115 19:00:00.000', '20121115 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8687, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20121122 19:00:00.000', '20121122 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8688, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20121129 19:00:00.000', '20121129 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8689, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20121206 19:00:00.000', '20121206 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8690, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20121213 19:00:00.000', '20121213 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8691, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20121220 19:00:00.000', '20121220 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8692, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20121227 19:00:00.000', '20121227 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8693, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20130103 19:00:00.000', '20130103 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8694, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20130110 19:00:00.000', '20130110 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8695, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20130117 19:00:00.000', '20130117 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8696, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20130124 19:00:00.000', '20130124 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8697, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20130131 19:00:00.000', '20130131 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8698, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20130207 19:00:00.000', '20130207 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8699, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20130214 19:00:00.000', '20130214 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8700, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20130221 19:00:00.000', '20130221 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8701, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20130228 19:00:00.000', '20130228 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8702, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20130307 19:00:00.000', '20130307 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8703, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20130314 19:00:00.000', '20130314 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8704, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20130321 19:00:00.000', '20130321 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8705, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20130328 19:00:00.000', '20130328 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8706, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20130404 19:00:00.000', '20130404 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8707, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20130411 19:00:00.000', '20130411 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8708, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20130418 19:00:00.000', '20130418 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8709, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20130425 19:00:00.000', '20130425 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8710, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20130502 19:00:00.000', '20130502 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8711, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20130509 19:00:00.000', '20130509 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8712, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20130516 19:00:00.000', '20130516 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8713, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20130523 19:00:00.000', '20130523 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8714, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20130530 19:00:00.000', '20130530 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8715, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20130606 19:00:00.000', '20130606 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8716, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20130613 19:00:00.000', '20130613 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8717, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20130620 19:00:00.000', '20130620 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8718, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20130627 19:00:00.000', '20130627 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8719, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20130704 19:00:00.000', '20130704 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8720, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20130711 19:00:00.000', '20130711 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8721, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20130718 19:00:00.000', '20130718 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8722, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20130725 19:00:00.000', '20130725 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8723, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20130801 19:00:00.000', '20130801 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8724, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20130808 19:00:00.000', '20130808 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8725, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20130815 19:00:00.000', '20130815 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8726, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20130822 19:00:00.000', '20130822 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8727, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20130829 19:00:00.000', '20130829 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8728, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20130905 19:00:00.000', '20130905 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8729, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20130912 19:00:00.000', '20130912 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8730, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20130919 19:00:00.000', '20130919 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8731, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20130926 19:00:00.000', '20130926 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8732, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20131003 19:00:00.000', '20131003 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8733, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20131010 19:00:00.000', '20131010 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8734, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20131017 19:00:00.000', '20131017 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8735, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20131024 19:00:00.000', '20131024 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8736, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20131031 19:00:00.000', '20131031 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8737, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20131107 19:00:00.000', '20131107 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8738, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20131114 19:00:00.000', '20131114 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8739, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20131121 19:00:00.000', '20131121 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8740, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20131128 19:00:00.000', '20131128 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8741, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20131205 19:00:00.000', '20131205 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8742, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20131212 19:00:00.000', '20131212 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8743, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20131219 19:00:00.000', '20131219 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8744, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20131226 19:00:00.000', '20131226 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8745, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20140102 19:00:00.000', '20140102 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8746, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20140109 19:00:00.000', '20140109 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8747, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20140116 19:00:00.000', '20140116 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8748, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20140123 19:00:00.000', '20140123 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8749, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20140130 19:00:00.000', '20140130 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8750, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20140206 19:00:00.000', '20140206 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8751, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20140213 19:00:00.000', '20140213 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8752, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20140220 19:00:00.000', '20140220 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8753, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20140227 19:00:00.000', '20140227 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8754, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20140306 19:00:00.000', '20140306 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8755, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20140313 19:00:00.000', '20140313 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8756, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20140320 19:00:00.000', '20140320 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8757, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20140327 19:00:00.000', '20140327 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8758, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20140403 19:00:00.000', '20140403 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8759, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20140410 19:00:00.000', '20140410 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8760, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20140417 19:00:00.000', '20140417 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8761, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20140424 19:00:00.000', '20140424 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8762, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20140501 19:00:00.000', '20140501 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8763, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20140508 19:00:00.000', '20140508 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8764, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20140515 19:00:00.000', '20140515 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8765, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20140522 19:00:00.000', '20140522 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8766, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20140529 19:00:00.000', '20140529 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8767, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20140605 19:00:00.000', '20140605 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8768, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20140612 19:00:00.000', '20140612 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8769, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20140619 19:00:00.000', '20140619 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8770, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20140626 19:00:00.000', '20140626 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8771, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20140703 19:00:00.000', '20140703 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8772, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20140710 19:00:00.000', '20140710 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8773, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20140717 19:00:00.000', '20140717 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8774, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20140724 19:00:00.000', '20140724 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8775, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20140731 19:00:00.000', '20140731 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8776, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20140807 19:00:00.000', '20140807 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8777, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20140814 19:00:00.000', '20140814 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8778, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20140821 19:00:00.000', '20140821 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8779, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20140828 19:00:00.000', '20140828 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8780, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20140904 19:00:00.000', '20140904 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8781, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20140911 19:00:00.000', '20140911 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8782, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20140918 19:00:00.000', '20140918 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8783, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20140925 19:00:00.000', '20140925 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8784, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20141002 19:00:00.000', '20141002 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8785, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20141009 19:00:00.000', '20141009 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8786, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20141016 19:00:00.000', '20141016 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8787, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20141023 19:00:00.000', '20141023 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8788, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20141030 19:00:00.000', '20141030 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8789, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20141106 19:00:00.000', '20141106 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8790, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20141113 19:00:00.000', '20141113 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8791, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20141120 19:00:00.000', '20141120 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8792, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20141127 19:00:00.000', '20141127 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8793, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20141204 19:00:00.000', '20141204 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8794, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20141211 19:00:00.000', '20141211 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8795, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20141218 19:00:00.000', '20141218 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8796, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20141225 19:00:00.000', '20141225 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8797, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20150101 19:00:00.000', '20150101 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8798, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20150108 19:00:00.000', '20150108 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8799, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20150115 19:00:00.000', '20150115 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8800, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20150122 19:00:00.000', '20150122 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8801, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20150129 19:00:00.000', '20150129 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8802, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20150205 19:00:00.000', '20150205 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8803, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20150212 19:00:00.000', '20150212 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8804, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20150219 19:00:00.000', '20150219 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8805, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20150226 19:00:00.000', '20150226 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8806, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20150305 19:00:00.000', '20150305 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8807, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20150312 19:00:00.000', '20150312 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8808, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20150319 19:00:00.000', '20150319 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8809, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20150326 19:00:00.000', '20150326 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8810, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20150402 19:00:00.000', '20150402 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8811, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20150409 19:00:00.000', '20150409 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8812, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20150416 19:00:00.000', '20150416 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8813, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20150423 19:00:00.000', '20150423 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8814, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20150430 19:00:00.000', '20150430 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8815, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20150507 19:00:00.000', '20150507 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8816, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20150514 19:00:00.000', '20150514 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8817, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20150521 19:00:00.000', '20150521 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8818, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20150528 19:00:00.000', '20150528 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8819, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20150604 19:00:00.000', '20150604 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8820, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20150611 19:00:00.000', '20150611 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8821, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20150618 19:00:00.000', '20150618 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8822, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20150625 19:00:00.000', '20150625 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8823, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20150702 19:00:00.000', '20150702 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8824, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20150709 19:00:00.000', '20150709 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8825, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20150716 19:00:00.000', '20150716 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8826, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20150723 19:00:00.000', '20150723 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8827, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20150730 19:00:00.000', '20150730 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8828, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20150806 19:00:00.000', '20150806 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8829, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20150813 19:00:00.000', '20150813 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8830, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20150820 19:00:00.000', '20150820 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8831, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20150827 19:00:00.000', '20150827 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8832, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20150903 19:00:00.000', '20150903 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8833, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20150910 19:00:00.000', '20150910 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8834, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20150917 19:00:00.000', '20150917 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8835, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20150924 19:00:00.000', '20150924 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8836, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20151001 19:00:00.000', '20151001 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8837, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20151008 19:00:00.000', '20151008 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8838, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20151015 19:00:00.000', '20151015 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8839, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20151022 19:00:00.000', '20151022 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8840, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20151029 19:00:00.000', '20151029 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8841, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20151105 19:00:00.000', '20151105 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8842, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20151112 19:00:00.000', '20151112 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8843, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20151119 19:00:00.000', '20151119 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8844, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20151126 19:00:00.000', '20151126 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8845, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20151203 19:00:00.000', '20151203 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8846, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20151210 19:00:00.000', '20151210 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8847, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20151217 19:00:00.000', '20151217 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8848, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20151224 19:00:00.000', '20151224 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8849, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20151231 19:00:00.000', '20151231 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8850, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20160107 19:00:00.000', '20160107 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8851, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20160114 19:00:00.000', '20160114 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8852, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20160121 19:00:00.000', '20160121 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8853, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20160128 19:00:00.000', '20160128 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8854, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20160204 19:00:00.000', '20160204 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8855, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20160211 19:00:00.000', '20160211 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8856, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20160218 19:00:00.000', '20160218 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8857, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20160225 19:00:00.000', '20160225 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8858, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20160303 19:00:00.000', '20160303 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8859, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20160310 19:00:00.000', '20160310 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8860, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20160317 19:00:00.000', '20160317 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8861, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20160324 19:00:00.000', '20160324 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8862, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20160331 19:00:00.000', '20160331 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8863, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20160407 19:00:00.000', '20160407 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8864, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20160414 19:00:00.000', '20160414 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8865, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20160421 19:00:00.000', '20160421 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8866, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20160428 19:00:00.000', '20160428 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8867, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20160505 19:00:00.000', '20160505 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8868, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20160512 19:00:00.000', '20160512 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8869, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20160519 19:00:00.000', '20160519 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8870, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20160526 19:00:00.000', '20160526 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8871, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20160602 19:00:00.000', '20160602 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8872, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20160609 19:00:00.000', '20160609 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8873, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20160616 19:00:00.000', '20160616 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8874, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20160623 19:00:00.000', '20160623 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8875, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20160630 19:00:00.000', '20160630 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8876, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20160707 19:00:00.000', '20160707 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8877, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20160714 19:00:00.000', '20160714 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8878, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20160721 19:00:00.000', '20160721 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8879, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20160728 19:00:00.000', '20160728 20:30:00.000', -5, 0)
INSERT INTO [Events].[Occurances] ([OccuranceID], [EventID], [Title], [ShortDescription], [Description], [Location], [StartDate], [EndDate], [TimeZone], [IsAllDay]) VALUES (8880, 18, N'Islam 101', N'Islam 101', N'Islam 101', N'Main Center Room 303', '20160804 19:00:00.000', '20160804 20:30:00.000', -5, 0)
SET IDENTITY_INSERT [Events].[Occurances] OFF
SET IDENTITY_INSERT [JummahPrayers].[Locations] ON
INSERT INTO [JummahPrayers].[Locations] ([LocationID], [Name], [Street], [Street2], [City], [State], [ZipCode], [FridayNote], [LongNote], [Latitude], [Longitude], [DisplayOrder]) VALUES (1, N'Main Center', N'46903 Sugarland Road', N'', N'Sterling', N'VA', N'20164', N'Friday Note', N'Longnote', 39.006436, -77.379334, 1)
EXEC(N'INSERT INTO [JummahPrayers].[Locations] ([LocationID], [Name], [Street], [Street2], [City], [State], [ZipCode], [FridayNote], [LongNote], [Latitude], [Longitude], [DisplayOrder]) VALUES (2, N''Ashburn'', N''21740 Beaumeade Circle'', N''Unit 100'', N''Ashburn'', N''VA'', N''20147'', N'''', N''<span class="Apple-style-span" style="font-family: Verdana, Arial, Helvetica, sans-serif; font-size: 11px; "><p style="margin-top: 0px; margin-right: 0px; margin-bottom: 15px; margin-left: 0px; padding-top: 0px; padding-right: 0px; padding-bottom: 0px; padding-left: 0px; border-top-width: 0px; border-right-width: 0px; border-bottom-width: 0px; border-left-width: 0px; border-style: initial; border-color: initial; outline-width: 0px; outline-style: initial; outline-color: initial; font-weight: inherit; font-style: inherit; font-size: 11px; font-family: Verdana, Arial, Helvetica, sans-serif; vertical-align: baseline; line-height: 1.6em; ">When you turn onto&nbsp;<font face="Verdana"><strong style="font-weight: bold; color: rgb(141, 136, 104); text-decoration: none; ">BEAUMEADE CIR</strong>&nbsp;you will see a White Buildings(with Ummah Bazaar)&nbsp;on your right.</font></p><p style="margin-top: 0px; margin-right: 0px; margin-bottom: 15px; margin-left: 0px; padding-top: 0px; padding-right: 0px; padding-bottom: 0px; padding-left: 0px; border-top-width: 0px; border-right-width: 0px; border-bottom-width: 0px; border-left-width: 0px; border-style: initial; border-color: initial; outline-width: 0px; outline-style: initial; outline-color: initial; font-weight: inherit; font-style: inherit; font-size: 11px; font-family: Verdana, Arial, Helvetica, sans-serif; vertical-align: baseline; line-height: 1.6em; "><font face="Verdana">Go passed it to the Brown Buildings on the Right.</font></p><p style="margin-top: 0px; margin-right: 0px; margin-bottom: 15px; margin-left: 0px; padding-top: 0px; padding-right: 0px; padding-bottom: 0px; padding-left: 0px; border-top-width: 0px; border-right-width: 0px; border-bottom-width: 0px; border-left-width: 0px; border-style: initial; border-color: initial; outline-width: 0px; outline-style: initial; outline-color: initial; font-weight: inherit; font-style: inherit; font-size: 11px; font-family: Verdana, Arial, Helvetica, sans-serif; vertical-align: baseline; line-height: 1.6em; "><strong style="font-weight: bold; color: rgb(141, 136, 104); text-decoration: none; "><font face="Verdana" color="#cc2f13">Please park and enter from the door at the back side of the building.</font></strong></p><p style="margin-top: 0px; margin-right: 0px; margin-bottom: 15px; margin-left: 0px; padding-top: 0px; padding-right: 0px; padding-bottom: 0px; padding-left: 0px; border-top-width: 0px; border-right-width: 0px; border-bottom-width: 0px; border-left-width: 0px; border-style: initial; border-color: initial; outline-width: 0px; outline-style: initial; outline-color: initial; font-weight: inherit; font-style: inherit; font-size: 11px; font-family: Verdana, Arial, Helvetica, sans-serif; vertical-align: baseline; line-height: 1.6em; ">We would like to thank Beth Chaverim Reform Congregation for their frienship and opening up for us to rent their 3000</p><p style="margin-top: 0px; margin-right: 0px; margin-bottom: 15px; margin-left: 0px; padding-top: 0px; padding-right: 0px; padding-bottom: 0px; padding-left: 0px; border-top-width: 0px; border-right-width: 0px; border-bottom-width: 0px; border-left-width: 0px; border-style: initial; border-color: initial; outline-width: 0px; outline-style: initial; outline-color: initial; font-weight: inherit; font-style: inherit; font-size: 11px; font-family: Verdana, Arial, Helvetica, sans-serif; vertical-align: baseline; line-height: 1.6em; ">Sq Ft Rental Facility for ADAMS-Ashburn Masjid.</p><p style="margin-top: 0px; margin-right: 0px; margin-bottom: 15px; margin-left: 0px; padding-top: 0px; padding-right: 0px; padding-bottom: 0px; padding-left: 0px; border-top-width: 0px; border-right-width: 0px; border-bottom-width: 0px; border-left-width: 0px; border-style: initial; border-color: initial; outline-width: 0px; outline-style: initial; outline-color: initial; font-weight: inherit; font-style: inherit; font-size: 11px; font-family: Verdana, Arial, Helvetica, sans-serif; vertical-align: baseline;'', 39.018400, -77.456038, 2)')
EXEC(N'DECLARE @pv binary(16)
'+N'SELECT @pv=TEXTPTR([LongNote]) FROM [JummahPrayers].[Locations] WHERE [LocationID]=2
UPDATETEXT [JummahPrayers].[Locations].[LongNote] @pv NULL NULL N'' line-height: 1.6em; ">This is Interfaith Cooperation and Friendship at its Best.</p><p style="margin-top: 0px; margin-right: 0px; margin-bottom: 15px; margin-left: 0px; padding-top: 0px; padding-right: 0px; padding-bottom: 0px; padding-left: 0px; border-top-width: 0px; border-right-width: 0px; border-bottom-width: 0px; border-left-width: 0px; border-style: initial; border-color: initial; outline-width: 0px; outline-style: initial; outline-color: initial; font-weight: inherit; font-style: inherit; font-size: 11px; font-family: Verdana, Arial, Helvetica, sans-serif; vertical-align: baseline; line-height: 1.6em; ">With PEACE, Love, Respect, and Harmony.......</p><p style="margin-top: 0px; margin-right: 0px; margin-bottom: 15px; margin-left: 0px; padding-top: 0px; padding-right: 0px; padding-bottom: 0px; padding-left: 0px; border-top-width: 0px; border-right-width: 0px; border-bottom-width: 0px; border-left-width: 0px; border-style: initial; border-color: initial; outline-width: 0px; outline-style: initial; outline-color: initial; font-weight: inherit; font-style: inherit; font-size: 11px; font-family: Verdana, Arial, Helvetica, sans-serif; vertical-align: baseline; line-height: 1.6em; "><b><font face="Verdana" color="#a37152" size="2">Directions from Route 7</font></b></p><ul style="margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; padding-top: 0px; padding-right: 0px; padding-bottom: 0px; padding-left: 0px; border-top-width: 0px; border-right-width: 0px; border-bottom-width: 0px; border-left-width: 0px; border-style: initial; border-color: initial; outline-width: 0px; outline-style: initial; outline-color: initial; font-weight: inherit; font-style: inherit; font-size: 11px; font-family: Verdana, Arial, Helvetica, sans-serif; vertical-align: baseline; "><li style="margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; padding-top: 0px; padding-right: 0px; padding-bottom: 0px; padding-left: 0px; border-top-width: 0px; border-right-width: 0px; border-bottom-width: 0px; border-left-width: 0px; border-style: initial; border-color: initial; outline-width: 0px; outline-style: initial; outline-color: initial; font-weight: inherit; font-style: inherit; font-size: 11px; font-family: Verdana, Arial, Helvetica, sans-serif; vertical-align: baseline; "><font face="Verdana" color="#000000" size="2">Turn Right on&nbsp;<b>LOUDOUN COUNTY PKY(VA-607 S)</b>&nbsp;- go&nbsp;<b>3.1</b>&nbsp;mi</font></li><li style="margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; padding-top: 0px; padding-right: 0px; padding-bottom: 0px; padding-left: 0px; border-top-width: 0px; border-right-width: 0px; border-bottom-width: 0px; border-left-width: 0px; border-style: initial; border-color: initial; outline-width: 0px; outline-style: initial; outline-color: initial; font-weight: inherit; font-style: inherit; font-size: 11px; font-family: Verdana, Arial, Helvetica, sans-serif; vertical-align: baseline; "><font face="Verdana" color="#000000" size="2">Turn Right on&nbsp;<b>BEAUMEADE CIR</b>&nbsp;- go&nbsp;<b>0.2</b>&nbsp;mi</font></li><li style="margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; padding-top: 0px; padding-right: 0px; padding-bottom: 0px; padding-left: 0px; border-top-width: 0px; border-right-width: 0px; border-bottom-width: 0px; border-left-width: 0px; border-style: initial; border-color: initial; outline-width: 0px; outline-style: initial; outline-color: initial; font-weight: inherit; font-style: inherit; font-size: 11px; font-family: Verdana, Arial, Helvetica, sans-serif; vertical-align: baseline; "><font face="Verdana" color="#000000" size="2">Arrive at 21740&nbsp;<b>BEAUMEADE CIR</b>, UNIT 100.</font></li><li style="margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; padding-top: 0px; padding-right: 0px; padding-bottom: 0px; padding-left: 0px; border-top-width: 0px; border-right-width: 0px; border-bottom-width: 0px; border-left-width: 0px; b''
UPDATETEXT [JummahPrayers].[Locations].[LongNote] @pv NULL NULL N''order-style: initial; border-color: initial; outline-width: 0px; outline-style: initial; outline-color: initial; font-weight: inherit; font-style: inherit; font-size: 11px; font-family: Verdana, Arial, Helvetica, sans-serif; vertical-align: baseline; "><p align="left" style="margin-top: 0px; margin-right: 0px; margin-bottom: 15px; margin-left: 0px; padding-top: 0px; padding-right: 0px; padding-bottom: 0px; padding-left: 0px; border-top-width: 0px; border-right-width: 0px; border-bottom-width: 0px; border-left-width: 0px; border-style: initial; border-color: initial; outline-width: 0px; outline-style: initial; outline-color: initial; font-weight: inherit; font-style: inherit; font-size: 11px; font-family: Verdana, Arial, Helvetica, sans-serif; vertical-align: baseline; line-height: 1.6em; "><b><font face="Verdana" color="#cc2f13" size="2">Please park and enter from the door at the back side of the building.</font></b></p></li></ul><p style="margin-top: 0px; margin-right: 0px; margin-bottom: 15px; margin-left: 0px; padding-top: 0px; padding-right: 0px; padding-bottom: 0px; padding-left: 0px; border-top-width: 0px; border-right-width: 0px; border-bottom-width: 0px; border-left-width: 0px; border-style: initial; border-color: initial; outline-width: 0px; outline-style: initial; outline-color: initial; font-weight: inherit; font-style: inherit; font-size: 11px; font-family: Verdana, Arial, Helvetica, sans-serif; vertical-align: baseline; line-height: 1.6em; "><b><font face="Verdana" color="#a37152" size="2">Directions from Waxpool Road coming from Ashburn</font></b></p><ul style="margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; padding-top: 0px; padding-right: 0px; padding-bottom: 0px; padding-left: 0px; border-top-width: 0px; border-right-width: 0px; border-bottom-width: 0px; border-left-width: 0px; border-style: initial; border-color: initial; outline-width: 0px; outline-style: initial; outline-color: initial; font-weight: inherit; font-style: inherit; font-size: 11px; font-family: Verdana, Arial, Helvetica, sans-serif; vertical-align: baseline; "><li style="margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; padding-top: 0px; padding-right: 0px; padding-bottom: 0px; padding-left: 0px; border-top-width: 0px; border-right-width: 0px; border-bottom-width: 0px; border-left-width: 0px; border-style: initial; border-color: initial; outline-width: 0px; outline-style: initial; outline-color: initial; font-weight: inherit; font-style: inherit; font-size: 11px; font-family: Verdana, Arial, Helvetica, sans-serif; vertical-align: baseline; "><font face="Verdana" color="#000000" size="2">Turn Left on<b>&nbsp;LOUDOUN COUNTY PKY(VA-607 N)&nbsp;</b>- go 0.3 mi</font></li><li style="margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; padding-top: 0px; padding-right: 0px; padding-bottom: 0px; padding-left: 0px; border-top-width: 0px; border-right-width: 0px; border-bottom-width: 0px; border-left-width: 0px; border-style: initial; border-color: initial; outline-width: 0px; outline-style: initial; outline-color: initial; font-weight: inherit; font-style: inherit; font-size: 11px; font-family: Verdana, Arial, Helvetica, sans-serif; vertical-align: baseline; "><font face="Verdana" color="#000000" size="2">Turn Left on<b>&nbsp;BEAUMEADE CIR</b>&nbsp;- go 0.2 mi</font></li><li style="margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; padding-top: 0px; padding-right: 0px; padding-bottom: 0px; padding-left: 0px; border-top-width: 0px; border-right-width: 0px; border-bottom-width: 0px; border-left-width: 0px; border-style: initial; border-color: initial; outline-width: 0px; outline-style: initial; outline-color: initial; font-weight: inherit; font-style: inherit; font-size: 11px; font-family: Verdana, Arial, Helvetica, sans-serif; vertical-align: baseline; "><font face="Verdana" color="#000000" size="2">Arrive at 21740&nbsp;<b>BEAUMEADE CIR</b>, UNIT 100.</font></l''
UPDATETEXT [JummahPrayers].[Locations].[LongNote] @pv NULL NULL N''i><li style="margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; padding-top: 0px; padding-right: 0px; padding-bottom: 0px; padding-left: 0px; border-top-width: 0px; border-right-width: 0px; border-bottom-width: 0px; border-left-width: 0px; border-style: initial; border-color: initial; outline-width: 0px; outline-style: initial; outline-color: initial; font-weight: inherit; font-style: inherit; font-size: 11px; font-family: Verdana, Arial, Helvetica, sans-serif; vertical-align: baseline; "><p align="left" style="margin-top: 0px; margin-right: 0px; margin-bottom: 15px; margin-left: 0px; padding-top: 0px; padding-right: 0px; padding-bottom: 0px; padding-left: 0px; border-top-width: 0px; border-right-width: 0px; border-bottom-width: 0px; border-left-width: 0px; border-style: initial; border-color: initial; outline-width: 0px; outline-style: initial; outline-color: initial; font-weight: inherit; font-style: inherit; font-size: 11px; font-family: Verdana, Arial, Helvetica, sans-serif; vertical-align: baseline; line-height: 1.6em; "><b><font face="Verdana" color="#cc2f13" size="2">Please park and enter from the door at the back side of the building.</font></b></p></li></ul><p style="margin-top: 0px; margin-right: 0px; margin-bottom: 15px; margin-left: 0px; padding-top: 0px; padding-right: 0px; padding-bottom: 0px; padding-left: 0px; border-top-width: 0px; border-right-width: 0px; border-bottom-width: 0px; border-left-width: 0px; border-style: initial; border-color: initial; outline-width: 0px; outline-style: initial; outline-color: initial; font-weight: inherit; font-style: inherit; font-size: 11px; font-family: Verdana, Arial, Helvetica, sans-serif; vertical-align: baseline; line-height: 1.6em; "><b><font face="Verdana" color="#a37152" size="2">Directions from Waxpool Road coming from Route 28</font></b></p><ul style="margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; padding-top: 0px; padding-right: 0px; padding-bottom: 0px; padding-left: 0px; border-top-width: 0px; border-right-width: 0px; border-bottom-width: 0px; border-left-width: 0px; border-style: initial; border-color: initial; outline-width: 0px; outline-style: initial; outline-color: initial; font-weight: inherit; font-style: inherit; font-size: 11px; font-family: Verdana, Arial, Helvetica, sans-serif; vertical-align: baseline; "><li style="margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; padding-top: 0px; padding-right: 0px; padding-bottom: 0px; padding-left: 0px; border-top-width: 0px; border-right-width: 0px; border-bottom-width: 0px; border-left-width: 0px; border-style: initial; border-color: initial; outline-width: 0px; outline-style: initial; outline-color: initial; font-weight: inherit; font-style: inherit; font-size: 11px; font-family: Verdana, Arial, Helvetica, sans-serif; vertical-align: baseline; "><font face="Verdana" color="#000000" size="2">Turn Right on<b>&nbsp;LOUDOUN COUNTY PKY(VA-607 N)&nbsp;</b>- go&nbsp;<b>0.3</b>&nbsp;mi</font></li><li style="margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; padding-top: 0px; padding-right: 0px; padding-bottom: 0px; padding-left: 0px; border-top-width: 0px; border-right-width: 0px; border-bottom-width: 0px; border-left-width: 0px; border-style: initial; border-color: initial; outline-width: 0px; outline-style: initial; outline-color: initial; font-weight: inherit; font-style: inherit; font-size: 11px; font-family: Verdana, Arial, Helvetica, sans-serif; vertical-align: baseline; "><font face="Verdana" color="#000000" size="2">Turn Left on&nbsp;<b>BEAUMEADE CIR</b>&nbsp;- go&nbsp;<b>0.2</b>&nbsp;mi</font></li><li style="margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; padding-top: 0px; padding-right: 0px; padding-bottom: 0px; padding-left: 0px; border-top-width: 0px; border-right-width: 0px; border-bottom-width: 0px; border-left-width: 0px; border-style: initial; border-color: initial; outline-width: 0''
UPDATETEXT [JummahPrayers].[Locations].[LongNote] @pv NULL NULL N''px; outline-style: initial; outline-color: initial; font-weight: inherit; font-style: inherit; font-size: 11px; font-family: Verdana, Arial, Helvetica, sans-serif; vertical-align: baseline; "><font face="Verdana" color="#000000" size="2">Arrive at 21740&nbsp;<b>BEAUMEADE CIR</b>, UNIT 100.</font></li><li style="margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; padding-top: 0px; padding-right: 0px; padding-bottom: 0px; padding-left: 0px; border-top-width: 0px; border-right-width: 0px; border-bottom-width: 0px; border-left-width: 0px; border-style: initial; border-color: initial; outline-width: 0px; outline-style: initial; outline-color: initial; font-weight: inherit; font-style: inherit; font-size: 11px; font-family: Verdana, Arial, Helvetica, sans-serif; vertical-align: baseline; "><p align="left" style="margin-top: 0px; margin-right: 0px; margin-bottom: 15px; margin-left: 0px; padding-top: 0px; padding-right: 0px; padding-bottom: 0px; padding-left: 0px; border-top-width: 0px; border-right-width: 0px; border-bottom-width: 0px; border-left-width: 0px; border-style: initial; border-color: initial; outline-width: 0px; outline-style: initial; outline-color: initial; font-weight: inherit; font-style: inherit; font-size: 11px; font-family: Verdana, Arial, Helvetica, sans-serif; vertical-align: baseline; line-height: 1.6em; "><b><font face="Verdana" color="#cc2f13" size="2">Please park and enter from the door at the back side of the building.</font></b></p></li></ul></span>''
')
EXEC(N'INSERT INTO [JummahPrayers].[Locations] ([LocationID], [Name], [Street], [Street2], [City], [State], [ZipCode], [FridayNote], [LongNote], [Latitude], [Longitude], [DisplayOrder]) VALUES (3, N''North Reston'', N''1441 Wiehle Avenue'', N'''', N''Reston'', N''VA'', N''20190'', N'''', N''<span class="Apple-style-span" style="font-family: Verdana, Arial, Helvetica, sans-serif; font-size: 11px; "><font size="2"><span style="margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; padding-top: 0px; padding-right: 0px; padding-bottom: 0px; padding-left: 0px; border-top-width: 0px; border-right-width: 0px; border-bottom-width: 0px; border-left-width: 0px; border-style: initial; border-color: initial; outline-width: 0px; outline-style: initial; outline-color: initial; font-weight: normal; font-style: inherit; font-size: 11px; font-family: Verdana, Arial, Helvetica, sans-serif; vertical-align: baseline; ">Northern Virginia Hebrew Congregation (Reform Jewish Synagogue)&nbsp;</span></font><p style="margin-top: 0px; margin-right: 0px; margin-bottom: 15px; margin-left: 0px; padding-top: 0px; padding-right: 0px; padding-bottom: 0px; padding-left: 0px; border-top-width: 0px; border-right-width: 0px; border-bottom-width: 0px; border-left-width: 0px; border-style: initial; border-color: initial; outline-width: 0px; outline-style: initial; outline-color: initial; font-weight: inherit; font-style: inherit; font-size: 11px; font-family: Verdana, Arial, Helvetica, sans-serif; vertical-align: baseline; line-height: 1.6em; ">1441 Wiehle Avenue Reston, VA 20190&nbsp;<br>Social Hall or Multipurpose room</p><p style="margin-top: 0px; margin-right: 0px; margin-bottom: 15px; margin-left: 0px; padding-top: 0px; padding-right: 0px; padding-bottom: 0px; padding-left: 0px; border-top-width: 0px; border-right-width: 0px; border-bottom-width: 0px; border-left-width: 0px; border-style: initial; border-color: initial; outline-width: 0px; outline-style: initial; outline-color: initial; font-weight: inherit; font-style: inherit; font-size: 11px; font-family: Verdana, Arial, Helvetica, sans-serif; vertical-align: baseline; line-height: 1.6em; ">Please note they are Neighbors and share a parking lot with&nbsp;<br>St Thomas A Beckett Catholic Church</p><p style="margin-top: 0px; margin-right: 0px; margin-bottom: 15px; margin-left: 0px; padding-top: 0px; padding-right: 0px; padding-bottom: 0px; padding-left: 0px; border-top-width: 0px; border-right-width: 0px; border-bottom-width: 0px; border-left-width: 0px; border-style: initial; border-color: initial; outline-width: 0px; outline-style: initial; outline-color: initial; font-weight: inherit; font-style: inherit; font-size: 11px; font-family: Verdana, Arial, Helvetica, sans-serif; vertical-align: baseline; line-height: 1.6em; ">We truly thank Northern Virginia Hebrew Congregation for their friendship and opening their multipurpose or social hall for rental for our Reston Jumaa. This is Interfaith Cooperation and Friendship at its Best. With PEACE, Love, Respect, and Harmony.......</p><p style="margin-top: 0px; margin-right: 0px; margin-bottom: 15px; margin-left: 0px; padding-top: 0px; padding-right: 0px; padding-bottom: 0px; padding-left: 0px; border-top-width: 0px; border-right-width: 0px; border-bottom-width: 0px; border-left-width: 0px; border-style: initial; border-color: initial; outline-width: 0px; outline-style: initial; outline-color: initial; font-weight: inherit; font-style: inherit; font-size: 11px; font-family: Verdana, Arial, Helvetica, sans-serif; vertical-align: baseline; line-height: 1.6em; ">Address and Directions:&nbsp;<br>1441 Wiehle Avenue Reston, VA 20190</p><p style="margin-top: 0px; margin-right: 0px; margin-bottom: 15px; margin-left: 0px; padding-top: 0px; padding-right: 0px; padding-bottom: 0px; padding-left: 0px; border-top-width: 0px; border-right-width: 0px; border-bottom-width: 0px; border-left-width: 0px; border-style: initial; border-color: initial; outline-width: 0px; outline-style: initial; outline-color: initial; font-weight: inherit; font-style: inherit; font-size: 11px; font-family: Verdana, Arial, Helvetica, sans-serif; vertical-align: baseline; line-height: 1.6em; ">Please follow all parking rules and regulations.</p><p style="margin-top: 0px; m'', 38.971227, -77.332301, 3)')
SELECT @pv=TEXTPTR([LongNote]) FROM [JummahPrayers].[Locations] WHERE [LocationID]=3
UPDATETEXT [JummahPrayers].[Locations].[LongNote] @pv NULL NULL N'argin-right: 0px; margin-bottom: 15px; margin-left: 0px; padding-top: 0px; padding-right: 0px; padding-bottom: 0px; padding-left: 0px; border-top-width: 0px; border-right-width: 0px; border-bottom-width: 0px; border-left-width: 0px; border-style: initial; border-color: initial; outline-width: 0px; outline-style: initial; outline-color: initial; font-weight: inherit; font-style: inherit; font-size: 11px; font-family: Verdana, Arial, Helvetica, sans-serif; vertical-align: baseline; line-height: 1.6em; ">Any questions please call - 703-981-2318(ADAMS Reston Manager - Mohammed Karim) or 703-433-1325(ADAMS)</p><p style="margin-top: 0px; margin-right: 0px; margin-bottom: 15px; margin-left: 0px; padding-top: 0px; padding-right: 0px; padding-bottom: 0px; padding-left: 0px; border-top-width: 0px; border-right-width: 0px; border-bottom-width: 0px; border-left-width: 0px; border-style: initial; border-color: initial; outline-width: 0px; outline-style: initial; outline-color: initial; font-weight: inherit; font-style: inherit; font-size: 11px; font-family: Verdana, Arial, Helvetica, sans-serif; vertical-align: baseline; line-height: 1.6em; ">From Dulles Airport&nbsp;<br>Dulles Toll Road East Go North/Left On WIEHLE AVE/ VA-828 exit, EXIT 13.&nbsp;<br>Turn right into 1441 Wiehle Ave Reston, VA 20190-3830</p><p style="margin-top: 0px; margin-right: 0px; margin-bottom: 15px; margin-left: 0px; padding-top: 0px; padding-right: 0px; padding-bottom: 0px; padding-left: 0px; border-top-width: 0px; border-right-width: 0px; border-bottom-width: 0px; border-left-width: 0px; border-style: initial; border-color: initial; outline-width: 0px; outline-style: initial; outline-color: initial; font-weight: inherit; font-style: inherit; font-size: 11px; font-family: Verdana, Arial, Helvetica, sans-serif; vertical-align: baseline; line-height: 1.6em; ">From 495:&nbsp;<br>Dulles Toll Road Wes Go North/Right On WIEHLE AVE/ VA-828 exit, EXIT 13.&nbsp;<br>Turn right into 1441 Wiehle Ave Reston, VA 20190-3830</p><p style="margin-top: 0px; margin-right: 0px; margin-bottom: 15px; margin-left: 0px; padding-top: 0px; padding-right: 0px; padding-bottom: 0px; padding-left: 0px; border-top-width: 0px; border-right-width: 0px; border-bottom-width: 0px; border-left-width: 0px; border-style: initial; border-color: initial; outline-width: 0px; outline-style: initial; outline-color: initial; font-weight: inherit; font-style: inherit; font-size: 11px; font-family: Verdana, Arial, Helvetica, sans-serif; vertical-align: baseline; line-height: 1.6em; ">From Baron Cameron going East&nbsp;<br>turn South/Right On WIEHLE AVE&nbsp;<br>turn Left Into 1441 Wiehle Ave Reston, VA 20190-3830</p><p style="margin-top: 0px; margin-right: 0px; margin-bottom: 15px; margin-left: 0px; padding-top: 0px; padding-right: 0px; padding-bottom: 0px; padding-left: 0px; border-top-width: 0px; border-right-width: 0px; border-bottom-width: 0px; border-left-width: 0px; border-style: initial; border-color: initial; outline-width: 0px; outline-style: initial; outline-color: initial; font-weight: inherit; font-style: inherit; font-size: 11px; font-family: Verdana, Arial, Helvetica, sans-serif; vertical-align: baseline; line-height: 1.6em; ">From Baron Cameron going West&nbsp;<br>turn South/Left On WIEHLE AVE&nbsp;<br>turn Left Into 1441 Wiehle Ave Reston, VA 20190-3830</p></span>'
EXEC(N'INSERT INTO [JummahPrayers].[Locations] ([LocationID], [Name], [Street], [Street2], [City], [State], [ZipCode], [FridayNote], [LongNote], [Latitude], [Longitude], [DisplayOrder]) VALUES (4, N''South Reston-Herndon'', N''12343 Sunrise Valley Dr'', N''Suite B'', N''Reston'', N''VA'', N''20191'', N'''', N''<span class="Apple-style-span" style="font-family: Verdana, Arial, Helvetica, sans-serif; font-size: 11px; "><div style="margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; padding-top: 0px; padding-right: 0px; padding-bottom: 0px; padding-left: 0px; border-top-width: 0px; border-right-width: 0px; border-bottom-width: 0px; border-left-width: 0px; border-style: initial; border-color: initial; outline-width: 0px; outline-style: initial; outline-color: initial; font-weight: inherit; font-style: inherit; font-size: 11px; font-family: Verdana, Arial, Helvetica, sans-serif; vertical-align: baseline; ">ADAMS South Reston-Herndon</div><div style="margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; padding-top: 0px; padding-right: 0px; padding-bottom: 0px; padding-left: 0px; border-top-width: 0px; border-right-width: 0px; border-bottom-width: 0px; border-left-width: 0px; border-style: initial; border-color: initial; outline-width: 0px; outline-style: initial; outline-color: initial; font-weight: inherit; font-style: inherit; font-size: 11px; font-family: Verdana, Arial, Helvetica, sans-serif; vertical-align: baseline; ">Serving Reston, Oak Hill, and Herndon</div><div style="margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; padding-top: 0px; padding-right: 0px; padding-bottom: 0px; padding-left: 0px; border-top-width: 0px; border-right-width: 0px; border-bottom-width: 0px; border-left-width: 0px; border-style: initial; border-color: initial; outline-width: 0px; outline-style: initial; outline-color: initial; font-weight: inherit; font-style: inherit; font-size: 11px; font-family: Verdana, Arial, Helvetica, sans-serif; vertical-align: baseline; "><br></div><div style="margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; padding-top: 0px; padding-right: 0px; padding-bottom: 0px; padding-left: 0px; border-top-width: 0px; border-right-width: 0px; border-bottom-width: 0px; border-left-width: 0px; border-style: initial; border-color: initial; outline-width: 0px; outline-style: initial; outline-color: initial; font-weight: inherit; font-style: inherit; font-size: 11px; font-family: Verdana, Arial, Helvetica, sans-serif; vertical-align: baseline; ">Friday at 12:15pm(75 people) and 1:30pm(75 people)&nbsp;</div><div style="margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; padding-top: 0px; padding-right: 0px; padding-bottom: 0px; padding-left: 0px; border-top-width: 0px; border-right-width: 0px; border-bottom-width: 0px; border-left-width: 0px; border-style: initial; border-color: initial; outline-width: 0px; outline-style: initial; outline-color: initial; font-weight: inherit; font-style: inherit; font-size: 11px; font-family: Verdana, Arial, Helvetica, sans-serif; vertical-align: baseline; ">Location: 12343 Sunrise Valley Dr Suite B, Reston, VA 20191 Map Attached&nbsp;</div><div style="margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; padding-top: 0px; padding-right: 0px; padding-bottom: 0px; padding-left: 0px; border-top-width: 0px; border-right-width: 0px; border-bottom-width: 0px; border-left-width: 0px; border-style: initial; border-color: initial; outline-width: 0px; outline-style: initial; outline-color: initial; font-weight: inherit; font-style: inherit; font-size: 11px; font-family: Verdana, Arial, Helvetica, sans-serif; vertical-align: baseline; ">Sunrise Technology Park/12343 - On Sunrise Valley Drive Between Reston Parkway and Fairfax County Parkway</div><div style="margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; padding-top: 0px; padding-right: 0px; padding-bottom: 0px; padding-left: 0px; border-top-width: 0px; border-right-width: 0px; border-bottom-width: 0px; border-left-width: 0px; border-style: initial; border-color: initial; outline-width: 0px; outline-style: initial; outline-color: initial; font-weight: inherit; font-style: inherit; font-size: 11px; font-family: Verd'', 38.950190, -77.370516, 4)')
SELECT @pv=TEXTPTR([LongNote]) FROM [JummahPrayers].[Locations] WHERE [LocationID]=4
UPDATETEXT [JummahPrayers].[Locations].[LongNote] @pv NULL NULL N'ana, Arial, Helvetica, sans-serif; vertical-align: baseline; "><br></div><div style="margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; padding-top: 0px; padding-right: 0px; padding-bottom: 0px; padding-left: 0px; border-top-width: 0px; border-right-width: 0px; border-bottom-width: 0px; border-left-width: 0px; border-style: initial; border-color: initial; outline-width: 0px; outline-style: initial; outline-color: initial; font-weight: inherit; font-style: inherit; font-size: 11px; font-family: Verdana, Arial, Helvetica, sans-serif; vertical-align: baseline; ">From Dulles Toll Road Exit 12 Reston Parkway</div><div style="margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; padding-top: 0px; padding-right: 0px; padding-bottom: 0px; padding-left: 0px; border-top-width: 0px; border-right-width: 0px; border-bottom-width: 0px; border-left-width: 0px; border-style: initial; border-color: initial; outline-width: 0px; outline-style: initial; outline-color: initial; font-weight: inherit; font-style: inherit; font-size: 11px; font-family: Verdana, Arial, Helvetica, sans-serif; vertical-align: baseline; ">Go South on Reston Parkway</div><div style="margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; padding-top: 0px; padding-right: 0px; padding-bottom: 0px; padding-left: 0px; border-top-width: 0px; border-right-width: 0px; border-bottom-width: 0px; border-left-width: 0px; border-style: initial; border-color: initial; outline-width: 0px; outline-style: initial; outline-color: initial; font-weight: inherit; font-style: inherit; font-size: 11px; font-family: Verdana, Arial, Helvetica, sans-serif; vertical-align: baseline; ">Take a Right on Sunrise Valley Drive (go 0.7 miles and thru 3 lights)</div><div style="margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; padding-top: 0px; padding-right: 0px; padding-bottom: 0px; padding-left: 0px; border-top-width: 0px; border-right-width: 0px; border-bottom-width: 0px; border-left-width: 0px; border-style: initial; border-color: initial; outline-width: 0px; outline-style: initial; outline-color: initial; font-weight: inherit; font-style: inherit; font-size: 11px; font-family: Verdana, Arial, Helvetica, sans-serif; vertical-align: baseline; ">Go Thru the 3rd light and take the next left into 12343 Sunrise Valley(Sunrise Technology Park/12343)</div><div style="margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; padding-top: 0px; padding-right: 0px; padding-bottom: 0px; padding-left: 0px; border-top-width: 0px; border-right-width: 0px; border-bottom-width: 0px; border-left-width: 0px; border-style: initial; border-color: initial; outline-width: 0px; outline-style: initial; outline-color: initial; font-weight: inherit; font-style: inherit; font-size: 11px; font-family: Verdana, Arial, Helvetica, sans-serif; vertical-align: baseline; ">Take a Left and go to the back and take a right and park along the back edge and walk between</div><div style="margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; padding-top: 0px; padding-right: 0px; padding-bottom: 0px; padding-left: 0px; border-top-width: 0px; border-right-width: 0px; border-bottom-width: 0px; border-left-width: 0px; border-style: initial; border-color: initial; outline-width: 0px; outline-style: initial; outline-color: initial; font-weight: inherit; font-style: inherit; font-size: 11px; font-family: Verdana, Arial, Helvetica, sans-serif; vertical-align: baseline; ">Building to 12343 B – there will be sign on the door</div></span>'
INSERT INTO [JummahPrayers].[Locations] ([LocationID], [Name], [Street], [Street2], [City], [State], [ZipCode], [FridayNote], [LongNote], [Latitude], [Longitude], [DisplayOrder]) VALUES (5, N'Tysons Corner', N'8401 Westpark Drive', N'', N'Mclean', N'VA', N'22012', N'', N'<span class="Apple-style-span" style="line-height: 17px; font-family: Verdana, Arial, Helvetica, sans-serif; font-size: 11px; "><b>Best Western Hotel</b></span>', 38.923818, -77.234917, 5)
INSERT INTO [JummahPrayers].[Locations] ([LocationID], [Name], [Street], [Street2], [City], [State], [ZipCode], [FridayNote], [LongNote], [Latitude], [Longitude], [DisplayOrder]) VALUES (6, N'Fairfax', N'12025 Lee Jackson Highway', N'', N'Fairfax', N'VA', N'22033', N'', N'<span class="Apple-style-span" style="border-collapse: collapse; font-family: Verdana, Arial, Helvetica, sans-serif; font-size: 11px; ">Waterford Fair Oaks</span>', 38.866298, -77.362209, 6)
INSERT INTO [JummahPrayers].[Locations] ([LocationID], [Name], [Street], [Street2], [City], [State], [ZipCode], [FridayNote], [LongNote], [Latitude], [Longitude], [DisplayOrder]) VALUES (7, N'Greater Gainesville', N'7300 Atlas Walkway ', N'', N'Gainesville', N'VA', N'20155', N'', N'<span class="Apple-style-span" style="border-collapse: collapse; font-family: arial, sans-serif; font-size: 11px; ">Hampton Inn</span>', 38.795570, -77.609739, 7)
INSERT INTO [JummahPrayers].[Locations] ([LocationID], [Name], [Street], [Street2], [City], [State], [ZipCode], [FridayNote], [LongNote], [Latitude], [Longitude], [DisplayOrder]) VALUES (8, N'South Riding', N'3940 Centerview Dr ', N'', N'Chantilly', N'VA', N'20151', N'', N'<span class="Apple-style-span" style="line-height: 17px; font-family: Verdana, Arial, Helvetica, sans-serif; font-size: 11px; ">Wingate By Wyndham&nbsp;<br>Phone:&nbsp;<span id="gc-number-0" class="gc-cs-link" title="Call with Google Voice" style="margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; padding-top: 0px; padding-right: 0px; padding-bottom: 0px; padding-left: 0px; border-top-width: 0px; border-right-width: 0px; border-bottom-width: 0px; border-left-width: 0px; border-style: initial; border-color: initial; outline-width: 0px; outline-style: initial; outline-color: initial; font-weight: inherit; font-style: inherit; font-size: 11px; font-family: Verdana, Arial, Helvetica, sans-serif; vertical-align: baseline; color: rgb(0, 51, 187); text-decoration: underline; cursor: pointer; ">571-203-0999</span>&nbsp;<br>www.wingateinns.com</span>', 38.896751, -77.433106, 8)
INSERT INTO [JummahPrayers].[Locations] ([LocationID], [Name], [Street], [Street2], [City], [State], [ZipCode], [FridayNote], [LongNote], [Latitude], [Longitude], [DisplayOrder]) VALUES (9, N'Crystal City', N'1700 Jefferson Davis Highway', N'', N'Arlington', N'VA', N'22202', N'', N'<span class="Apple-style-span" style="border-collapse: collapse; font-family: arial, sans-serif; font-size: 11px; ">Location:<br><br>The schedule for the remaining Friday Prayers at Crystal City are as follows:<br><br>11/26: No Jumuah will be held at this location<br>12/3: Jumuah will be held at the Marriott Crystal Gateway Hotel- 1700 Jefferson Davis Highway, Arlington, VA<br>12/10: Jumuah will be held at the regular location, the Marriott Crystal City-1999 Jefferson Davis Highway · Arlington, Virginia<br>12/17: Jumuah will be held at the regular location, the Marriott Crystal City-1999 Jefferson Davis Highway · Arlington, Virginia<br>12/24: No Jumuah will be held at this location<br>12/31: No Jumuah will be held at this location<br><br>Room:<br>Mount Vernon Room (Mezzanine Level)<br><br>For more information please contact;<br><br><a href="mailto:farooq_syed@yahoo.com" target="_blank" style="margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; padding-top: 0px; padding-right: 0px; padding-bottom: 0px; padding-left: 0px; border-top-width: 0px; border-right-width: 0px; border-bottom-width: 0px; border-left-width: 0px; border-style: initial; border-color: initial; outline-width: 0px; outline-style: initial; outline-color: initial; font-weight: inherit; font-style: inherit; font-size: 11px; font-family: Verdana, Arial, Helvetica, sans-serif; vertical-align: baseline; text-decoration: none; color: rgb(42, 93, 176); ">farooq_syed@yahoo.com</a><br>or<br><a href="mailto:mobeen.vaid@gmail.com" target="_blank" style="margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; padding-top: 0px; padding-right: 0px; padding-bottom: 0px; padding-left: 0px; border-top-width: 0px; border-right-width: 0px; border-bottom-width: 0px; border-left-width: 0px; border-style: initial; border-color: initial; outline-width: 0px; outline-style: initial; outline-color: initial; font-weight: inherit; font-style: inherit; font-size: 11px; font-family: Verdana, Arial, Helvetica, sans-serif; vertical-align: baseline; text-decoration: none; color: rgb(42, 93, 176); ">mobeen.vaid@gmail.com</a></span>', 38.859197, -77.052510, 9)
INSERT INTO [JummahPrayers].[Locations] ([LocationID], [Name], [Street], [Street2], [City], [State], [ZipCode], [FridayNote], [LongNote], [Latitude], [Longitude], [DisplayOrder]) VALUES (10, N'Washington DC', N'1317 G St., NW', N'', N'Washington', N'DC', N'20005', N'', N'<span class="Apple-style-span" style="border-collapse: collapse; font-family: arial, sans-serif; font-size: 11px; ">Church of the Epiphany</span>', 38.898319, -77.030448, 10)
SET IDENTITY_INSERT [JummahPrayers].[Locations] OFF
SET IDENTITY_INSERT [JummahPrayers].[Prayers] ON
INSERT INTO [JummahPrayers].[Prayers] ([PrayerID], [LocationID], [Name], [Time], [DisplayOrder]) VALUES (1, 1, N'1st Jummah', N'11:45 AM', 1)
INSERT INTO [JummahPrayers].[Prayers] ([PrayerID], [LocationID], [Name], [Time], [DisplayOrder]) VALUES (2, 1, N'2nd Jummah', N'1:15 PM', 2)
INSERT INTO [JummahPrayers].[Prayers] ([PrayerID], [LocationID], [Name], [Time], [DisplayOrder]) VALUES (3, 1, N'3rd Jumaah', N'2:30 PM', 3)
INSERT INTO [JummahPrayers].[Prayers] ([PrayerID], [LocationID], [Name], [Time], [DisplayOrder]) VALUES (4, 2, N'1st Jummah', N'12:15 PM', 1)
INSERT INTO [JummahPrayers].[Prayers] ([PrayerID], [LocationID], [Name], [Time], [DisplayOrder]) VALUES (5, 2, N'2nd Jummah', N'1:15 PM', 2)
INSERT INTO [JummahPrayers].[Prayers] ([PrayerID], [LocationID], [Name], [Time], [DisplayOrder]) VALUES (6, 2, N'3rd Jummah', N'2:15 PM', 3)
INSERT INTO [JummahPrayers].[Prayers] ([PrayerID], [LocationID], [Name], [Time], [DisplayOrder]) VALUES (7, 3, N'1st Jummah', N'12:45 PM', 1)
INSERT INTO [JummahPrayers].[Prayers] ([PrayerID], [LocationID], [Name], [Time], [DisplayOrder]) VALUES (8, 3, N'2nd Jummah', N'1:45 PM', 2)
INSERT INTO [JummahPrayers].[Prayers] ([PrayerID], [LocationID], [Name], [Time], [DisplayOrder]) VALUES (9, 4, N'1st Jummah', N'12:15 PM', 1)
INSERT INTO [JummahPrayers].[Prayers] ([PrayerID], [LocationID], [Name], [Time], [DisplayOrder]) VALUES (10, 4, N'2nd Jummah', N'1:30 PM', 2)
INSERT INTO [JummahPrayers].[Prayers] ([PrayerID], [LocationID], [Name], [Time], [DisplayOrder]) VALUES (11, 5, N'1st Jummah', N'12:10 PM', 1)
INSERT INTO [JummahPrayers].[Prayers] ([PrayerID], [LocationID], [Name], [Time], [DisplayOrder]) VALUES (12, 5, N'2nd Jummah', N'12:50 PM', 2)
INSERT INTO [JummahPrayers].[Prayers] ([PrayerID], [LocationID], [Name], [Time], [DisplayOrder]) VALUES (13, 5, N'3rd Jummah', N'1:30 PM', 3)
INSERT INTO [JummahPrayers].[Prayers] ([PrayerID], [LocationID], [Name], [Time], [DisplayOrder]) VALUES (14, 6, N'1st Jummah', N'12:00 PM', 1)
INSERT INTO [JummahPrayers].[Prayers] ([PrayerID], [LocationID], [Name], [Time], [DisplayOrder]) VALUES (15, 6, N'2nd Jummah', N'1:00 PM', 2)
INSERT INTO [JummahPrayers].[Prayers] ([PrayerID], [LocationID], [Name], [Time], [DisplayOrder]) VALUES (16, 7, N'1st Jummah', N'1:00 PM', 1)
INSERT INTO [JummahPrayers].[Prayers] ([PrayerID], [LocationID], [Name], [Time], [DisplayOrder]) VALUES (17, 7, N'2nd Jummah', N'1:40 PM', 2)
INSERT INTO [JummahPrayers].[Prayers] ([PrayerID], [LocationID], [Name], [Time], [DisplayOrder]) VALUES (18, 8, N'1st Jummah', N'12:30 PM', 1)
INSERT INTO [JummahPrayers].[Prayers] ([PrayerID], [LocationID], [Name], [Time], [DisplayOrder]) VALUES (19, 8, N'2nd Jummah', N'1:30 PM', 2)
INSERT INTO [JummahPrayers].[Prayers] ([PrayerID], [LocationID], [Name], [Time], [DisplayOrder]) VALUES (20, 9, N'1st Jummah', N'12:30 PM', 1)
INSERT INTO [JummahPrayers].[Prayers] ([PrayerID], [LocationID], [Name], [Time], [DisplayOrder]) VALUES (21, 10, N'1st Jummah', N'1:15 PM', 1)
INSERT INTO [JummahPrayers].[Prayers] ([PrayerID], [LocationID], [Name], [Time], [DisplayOrder]) VALUES (22, 10, N'2nd Jummah', N'1:55 PM', 2)
SET IDENTITY_INSERT [JummahPrayers].[Prayers] OFF
SET IDENTITY_INSERT [Console].[Applications] ON
INSERT INTO [Console].[Applications] ([ApplicationID], [Name], [Controller], [Url], [Icon], [DisplayOrder]) VALUES (18, N'Announcements', N'Announcements', N'/Announcements', N'/content/images/pencil_48.png', 1)
INSERT INTO [Console].[Applications] ([ApplicationID], [Name], [Controller], [Url], [Icon], [DisplayOrder]) VALUES (19, N'Pages', N'Pages', N'/Pages', N'/content/images/pages.gif', 2)
INSERT INTO [Console].[Applications] ([ApplicationID], [Name], [Controller], [Url], [Icon], [DisplayOrder]) VALUES (20, N'Press Releases', N'PressReleases', N'/PressReleases', N'/content/images/news_48x48.png', 3)
INSERT INTO [Console].[Applications] ([ApplicationID], [Name], [Controller], [Url], [Icon], [DisplayOrder]) VALUES (21, N'Jummah Prayers', N'JummahPrayers', N'/JummahPrayers', N'/content/images/muslims-pray-time-10.png', 4)
INSERT INTO [Console].[Applications] ([ApplicationID], [Name], [Controller], [Url], [Icon], [DisplayOrder]) VALUES (22, N'Eid Prayers', N'EidPrayers', N'/EidPrayers', N'/content/images/muslims-pray-time-10.png', 5)
INSERT INTO [Console].[Applications] ([ApplicationID], [Name], [Controller], [Url], [Icon], [DisplayOrder]) VALUES (23, N'Taraweh Prayers', N'TarawehPrayers', N'/TarawehPrayers', N'/content/images/muslims-pray-time-10.png', 6)
INSERT INTO [Console].[Applications] ([ApplicationID], [Name], [Controller], [Url], [Icon], [DisplayOrder]) VALUES (24, N'Daily Prayers', N'DailyPrayers', N'/DailyPrayers', N'/content/images/muslims-pray-time-10.png', 7)
INSERT INTO [Console].[Applications] ([ApplicationID], [Name], [Controller], [Url], [Icon], [DisplayOrder]) VALUES (25, N'Events', N'Events', N'/Events', N'/content/images/calendar.png', 8)
INSERT INTO [Console].[Applications] ([ApplicationID], [Name], [Controller], [Url], [Icon], [DisplayOrder]) VALUES (26, N'Files', N'Files', N'/Files', N'/content/images/pencil_48.png', 9)
INSERT INTO [Console].[Applications] ([ApplicationID], [Name], [Controller], [Url], [Icon], [DisplayOrder]) VALUES (27, N'Settings', N'Console', N'/Console', N'/content/images/user.png', 10)
INSERT INTO [Console].[Applications] ([ApplicationID], [Name], [Controller], [Url], [Icon], [DisplayOrder]) VALUES (28, N'Sitemap', N'Sitemap', N'/Sitemap', N'/content/images/pencil_48.png', 11)
INSERT INTO [Console].[Applications] ([ApplicationID], [Name], [Controller], [Url], [Icon], [DisplayOrder]) VALUES (29, N'Home Page', N'Home', N'/Home', N'/content/images/pencil_48.png', 12)
INSERT INTO [Console].[Applications] ([ApplicationID], [Name], [Controller], [Url], [Icon], [DisplayOrder]) VALUES (30, N'Membership', N'Membership', N'/Membership', N'/content/images/Member.gif', 13)
INSERT INTO [Console].[Applications] ([ApplicationID], [Name], [Controller], [Url], [Icon], [DisplayOrder]) VALUES (31, N'Classifieds', N'Classifieds', N'/Classifieds', N'/content/images/classifieds.png', 14)
INSERT INTO [Console].[Applications] ([ApplicationID], [Name], [Controller], [Url], [Icon], [DisplayOrder]) VALUES (32, N'Businesses', N'Businesses', N'/Businesses', N'/content/images/business.jpg', 15)
INSERT INTO [Console].[Applications] ([ApplicationID], [Name], [Controller], [Url], [Icon], [DisplayOrder]) VALUES (33, N'Donations', N'Donations', N'/Donations', N'/content/images/pencil_48.png', 16)
SET IDENTITY_INSERT [Console].[Applications] OFF
SET IDENTITY_INSERT [Sitemap].[Nodes] ON
INSERT INTO [Sitemap].[Nodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (1, NULL, N'/', N'Home', 1)
INSERT INTO [Sitemap].[Nodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (2, 1, N'/myadams', N'My ADAMS', 7)
INSERT INTO [Sitemap].[Nodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (4, 2, N'/myadams/profile', N'My Profile', 2)
INSERT INTO [Sitemap].[Nodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (5, 2, N'/myadams/classifieds', N'My Classifieds', 3)
INSERT INTO [Sitemap].[Nodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (6, 2, N'/myadams/businesses', N'My Businesses', 4)
INSERT INTO [Sitemap].[Nodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (7, 1, N'/about-us', N'About Us', 2)
INSERT INTO [Sitemap].[Nodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (8, 7, N'/about-us/history', N'History', 1)
INSERT INTO [Sitemap].[Nodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (9, 7, N'/about-us/mission', N'Mission', 2)
INSERT INTO [Sitemap].[Nodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (10, 7, N'/Files/ByLaws_05162011.pdf', N'By-Laws', 4)
INSERT INTO [Sitemap].[Nodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (11, 1, N'/services', N'Services', 3)
INSERT INTO [Sitemap].[Nodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (15, 1, N'/community', N'Community', 4)
INSERT INTO [Sitemap].[Nodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (16, 15, N'/community/interfaith', N'Interfaith', 1)
INSERT INTO [Sitemap].[Nodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (17, 15, N'/community/civic', N'Civic', 2)
INSERT INTO [Sitemap].[Nodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (18, 15, N'/community/community-service', N'Community Service', 3)
INSERT INTO [Sitemap].[Nodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (19, 1, N'/education', N'Education', 5)
INSERT INTO [Sitemap].[Nodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (20, 19, N'/education/sunday-school', N'Sunday School', 3)
INSERT INTO [Sitemap].[Nodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (21, 19, N'/education/taleem-ul-quran', N'Taleem Ul Quran', 5)
INSERT INTO [Sitemap].[Nodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (23, 1, N'/events', N'Events', 6)
INSERT INTO [Sitemap].[Nodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (24, 7, N'/about-us/vision', N'Vision', 3)
INSERT INTO [Sitemap].[Nodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (25, 7, N'/about-us/fundraising', N'Fundraising', 7)
INSERT INTO [Sitemap].[Nodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (26, 7, N'/about-us/class-policy', N'Class Policy', 8)
INSERT INTO [Sitemap].[Nodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (27, 7, N'/Files/2010_Annual_Report_Public_v2.doc.pdf', N'2010 Annual Report', 6)
INSERT INTO [Sitemap].[Nodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (28, 7, N'/Files/HeartbeatV3_I27.pdf', N'Newsletter', 5)
INSERT INTO [Sitemap].[Nodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (29, 4, N'/myadams/profile/email', N'My Email', 5)
INSERT INTO [Sitemap].[Nodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (30, 4, N'/myadams/profile/password', N'My Password', 5)
INSERT INTO [Sitemap].[Nodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (31, 4, N'/myadams/profile/general', N'My Information', 5)
INSERT INTO [Sitemap].[Nodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (33, 11, N'/services/funeral-services', N'Funeral Services', 7)
INSERT INTO [Sitemap].[Nodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (34, 11, N'/services/marriage', N'Marriage', 7)
INSERT INTO [Sitemap].[Nodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (36, 11, N'/services/social-services', N'Social Services', 7)
INSERT INTO [Sitemap].[Nodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (37, 11, N'/services/zakat', N'Zakat', 7)
INSERT INTO [Sitemap].[Nodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (38, 15, N'/community/new-muslim-support-group', N'New Muslim Support Group', 7)
INSERT INTO [Sitemap].[Nodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (39, 19, N'/education/computer-training', N'Computer Training', 1)
INSERT INTO [Sitemap].[Nodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (40, 19, N'/education/preschool', N'Preschool', 2)
INSERT INTO [Sitemap].[Nodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (41, 19, N'/education/tahfeez-ul-quran', N'Tahfeez Ul Quran', 4)
INSERT INTO [Sitemap].[Nodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (43, 1, N'/programs', N'Programs', 8)
INSERT INTO [Sitemap].[Nodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (44, 43, N'/programs/cub-scouts', N'Cub Scouts', 1)
INSERT INTO [Sitemap].[Nodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (45, 43, N'/programs/boy-scouts', N'Boy Scouts', 2)
INSERT INTO [Sitemap].[Nodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (46, 43, N'/programs/brothers', N'Brothers', 3)
INSERT INTO [Sitemap].[Nodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (47, 43, N'/programs/sisters', N'Sisters', 6)
INSERT INTO [Sitemap].[Nodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (48, 43, N'/programs/girl-scouts', N'Girl Scouts', 4)
INSERT INTO [Sitemap].[Nodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (49, 43, N'/programs/health-programs', N'Health Programs', 5)
INSERT INTO [Sitemap].[Nodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (50, 43, N'/programs/summer-camp', N'Summer Camp', 7)
INSERT INTO [Sitemap].[Nodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (51, 1, N'/join', N'Join', 9)
INSERT INTO [Sitemap].[Nodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (52, 51, N'/join/my-adams', N'My Adams', 9)
INSERT INTO [Sitemap].[Nodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (53, 51, N'/join/membership', N'Become A Member', 9)
INSERT INTO [Sitemap].[Nodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (54, 51, N'/join/email-list', N'ADAMS Email List', 9)
INSERT INTO [Sitemap].[Nodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (55, 34, N'/services/marriage/schedule-a-nikkah', N'Schedule A Nikkah', 6)
INSERT INTO [Sitemap].[Nodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (56, 1, N'/classifieds', N'Classifieds', 10)
INSERT INTO [Sitemap].[Nodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (57, 1, N'/businesses', N'Businesses', 11)
INSERT INTO [Sitemap].[Nodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (58, 1, N'/pressreleases', N'Press Releases', 12)
INSERT INTO [Sitemap].[Nodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (59, 1, N'/announcements', N'Announcements', 13)
INSERT INTO [Sitemap].[Nodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (60, 1, N'/prayers', N'Prayers', 13)
INSERT INTO [Sitemap].[Nodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (61, 60, N'/prayers/daily', N'Daily Prayers', 14)
INSERT INTO [Sitemap].[Nodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (62, 60, N'/prayers/jummah', N'Jummah Prayers', 14)
INSERT INTO [Sitemap].[Nodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (63, 60, N'/prayers/taraweh', N'Taraweh Prayers', 14)
INSERT INTO [Sitemap].[Nodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (64, 60, N'/prayers/eid', N'Eid Prayers', 14)
SET IDENTITY_INSERT [Sitemap].[Nodes] OFF
SET IDENTITY_INSERT [Sitemap].[WebTopNodes] ON
INSERT INTO [Sitemap].[WebTopNodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (1, NULL, N'/', N'Home', 1)
INSERT INTO [Sitemap].[WebTopNodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (2, 1, N'/about-us', N'About Us', 1)
INSERT INTO [Sitemap].[WebTopNodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (3, 1, N'/services', N'Services', 2)
INSERT INTO [Sitemap].[WebTopNodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (5, 1, N'/programs', N'Programs', 4)
INSERT INTO [Sitemap].[WebTopNodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (6, 1, N'/education', N'Education', 5)
INSERT INTO [Sitemap].[WebTopNodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (7, 1, N'/myadams', N'My ADAMS', 6)
INSERT INTO [Sitemap].[WebTopNodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (12, 1, N'/events', N'Events', 3)
SET IDENTITY_INSERT [Sitemap].[WebTopNodes] OFF
SET IDENTITY_INSERT [Sitemap].[WebLeftNodes] ON
INSERT INTO [Sitemap].[WebLeftNodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (1, NULL, N'/', N'Home', 1)
INSERT INTO [Sitemap].[WebLeftNodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (2, 1, N'/myadams', N'My ADAMS', 9)
INSERT INTO [Sitemap].[WebLeftNodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (4, 2, N'/myadams/profile', N'My Profile', 1)
INSERT INTO [Sitemap].[WebLeftNodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (5, 2, N'/myadams/classifieds', N'My Classifieds', 3)
INSERT INTO [Sitemap].[WebLeftNodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (6, 2, N'/myadams/businesses', N'My Businesses', 2)
INSERT INTO [Sitemap].[WebLeftNodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (7, 1, N'/about-us', N'About Us', 1)
INSERT INTO [Sitemap].[WebLeftNodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (8, 7, N'/about-us/history', N'History', 1)
INSERT INTO [Sitemap].[WebLeftNodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (9, 7, N'/about-us/mission', N'Mission', 2)
INSERT INTO [Sitemap].[WebLeftNodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (10, 7, N'/Files/ByLaws_05162011.pdf', N'By-Laws', 4)
INSERT INTO [Sitemap].[WebLeftNodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (11, 1, N'/services', N'Services', 8)
INSERT INTO [Sitemap].[WebLeftNodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (12, 11, N'/services/funeral-services', N'Funeral Services', 3)
INSERT INTO [Sitemap].[WebLeftNodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (13, 11, N'/services/social-services', N'Social Services', 6)
INSERT INTO [Sitemap].[WebLeftNodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (14, 37, N'/programs/health-programs', N'Health Programs', 5)
INSERT INTO [Sitemap].[WebLeftNodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (15, 1, N'/community', N'Community', 3)
INSERT INTO [Sitemap].[WebLeftNodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (16, 15, N'/community/interfaith', N'Interfaith', 1)
INSERT INTO [Sitemap].[WebLeftNodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (17, 15, N'/community/civic', N'Civic', 2)
INSERT INTO [Sitemap].[WebLeftNodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (18, 15, N'/community/community-service', N'Community Service', 3)
INSERT INTO [Sitemap].[WebLeftNodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (19, 1, N'/education', N'Education', 4)
INSERT INTO [Sitemap].[WebLeftNodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (20, 19, N'/education/sunday-school', N'Sunday School', 3)
INSERT INTO [Sitemap].[WebLeftNodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (21, 19, N'/education/taleem-ul-quran', N'Taleem Ul Quran', 5)
INSERT INTO [Sitemap].[WebLeftNodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (23, 7, N'/about-us/vision', N'Vision', 3)
INSERT INTO [Sitemap].[WebLeftNodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (25, 7, N'/Files/2010_Annual_Report_Public_v2.doc.pdf', N'2010 Annual Report', 6)
INSERT INTO [Sitemap].[WebLeftNodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (26, 7, N'/about-us/fundraising', N'Fundraising', 6)
INSERT INTO [Sitemap].[WebLeftNodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (27, 7, N'/about-us/class-policy', N'Class Policy', 6)
INSERT INTO [Sitemap].[WebLeftNodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (28, 11, N'/Prayers', N'Prayers', 5)
INSERT INTO [Sitemap].[WebLeftNodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (29, 28, N'/prayers/daily', N'Daily Prayers', 5)
INSERT INTO [Sitemap].[WebLeftNodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (30, 28, N'/prayers/jummah', N'Jummah Prayers', 5)
INSERT INTO [Sitemap].[WebLeftNodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (31, 28, N'/prayers/taraweh', N'Taraweh Prayers', 5)
INSERT INTO [Sitemap].[WebLeftNodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (32, 28, N'/prayers/eid', N'Eid Prayers', 5)
INSERT INTO [Sitemap].[WebLeftNodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (33, 4, N'/myadams/profile/email', N'My Email', 5)
INSERT INTO [Sitemap].[WebLeftNodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (34, 4, N'/myadams/profile/password', N'My Password', 5)
INSERT INTO [Sitemap].[WebLeftNodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (35, 4, N'/myadams/profile/general', N'My Information', 5)
INSERT INTO [Sitemap].[WebLeftNodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (37, 1, N'/programs', N'Programs', 12)
INSERT INTO [Sitemap].[WebLeftNodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (38, 13, N'/services/social-services/faith', N'Faith', 1)
INSERT INTO [Sitemap].[WebLeftNodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (39, 13, N'/services/social-services/shelters', N'Shelters', 3)
INSERT INTO [Sitemap].[WebLeftNodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (40, 13, N'/services/social-services/other-organizations', N'Other Organizations', 2)
INSERT INTO [Sitemap].[WebLeftNodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (41, 11, N'/services/marriage', N'Marriage', 4)
INSERT INTO [Sitemap].[WebLeftNodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (42, 11, N'/services/zakat', N'Zakat', 7)
INSERT INTO [Sitemap].[WebLeftNodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (43, 42, N'/files/ZakatulFitr_08012010.pdf', N'Zakat Form', 5)
INSERT INTO [Sitemap].[WebLeftNodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (44, 42, N'/services/zakat/distribution', N'Zakah Distribution', 4)
INSERT INTO [Sitemap].[WebLeftNodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (45, 42, N'/services/zakat/nisab', N'Nisab', 3)
INSERT INTO [Sitemap].[WebLeftNodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (46, 42, N'/services/zakat/who-should-pay-zakah', N'Who Should Pay Zakah', 2)
INSERT INTO [Sitemap].[WebLeftNodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (47, 42, N'/services/zakat/important-message', N'Important Message', 1)
INSERT INTO [Sitemap].[WebLeftNodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (48, 15, N'/community/new-muslim-support-group', N'New Muslim Support Group', 8)
INSERT INTO [Sitemap].[WebLeftNodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (49, 19, N'/education/computer-training', N'Computer Training', 1)
INSERT INTO [Sitemap].[WebLeftNodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (50, 19, N'/education/preschool', N'Preschool', 2)
INSERT INTO [Sitemap].[WebLeftNodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (51, 19, N'/education/tahfeez-ul-quran', N'Tahfeez Ul Quran', 4)
INSERT INTO [Sitemap].[WebLeftNodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (52, 1, N'/events', N'Events', 5)
INSERT INTO [Sitemap].[WebLeftNodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (53, 1, N'/join', N'Join', 6)
INSERT INTO [Sitemap].[WebLeftNodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (54, 53, N'/join/my-adams', N'My Adams', 10)
INSERT INTO [Sitemap].[WebLeftNodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (55, 53, N'/join/membership', N'Become A Member', 10)
INSERT INTO [Sitemap].[WebLeftNodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (56, 53, N'/join/email-list', N'ADAMS Email List', 10)
INSERT INTO [Sitemap].[WebLeftNodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (57, 11, N'/classifieds', N'Classifieds', 2)
INSERT INTO [Sitemap].[WebLeftNodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (58, 11, N'/businesses', N'Businesses', 1)
INSERT INTO [Sitemap].[WebLeftNodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (59, 1, N'/pressreleases', N'Press Releases', 11)
INSERT INTO [Sitemap].[WebLeftNodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (60, 1, N'/announcements', N'Announcements', 2)
INSERT INTO [Sitemap].[WebLeftNodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (61, 37, N'/programs/cub-scouts', N'Cub Scouts', 1)
INSERT INTO [Sitemap].[WebLeftNodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (62, 37, N'/programs/boy-scouts', N'Boy Scouts', 2)
INSERT INTO [Sitemap].[WebLeftNodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (63, 37, N'/programs/brothers', N'Brothers', 3)
INSERT INTO [Sitemap].[WebLeftNodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (64, 37, N'/programs/girl-scouts', N'Girl Scouts', 4)
INSERT INTO [Sitemap].[WebLeftNodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (65, 37, N'/programs/sisters', N'Sisters', 6)
INSERT INTO [Sitemap].[WebLeftNodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (66, 37, N'/programs/summer-camp', N'Summer Camp', 7)
INSERT INTO [Sitemap].[WebLeftNodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (67, 19, N'http://www.qurtubainstitute.org', N'Qurtuba Institute', 11)
SET IDENTITY_INSERT [Sitemap].[WebLeftNodes] OFF
SET IDENTITY_INSERT [Sitemap].[MobileNodes] ON
INSERT INTO [Sitemap].[MobileNodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (1, NULL, N'/', N'Home', 1)
INSERT INTO [Sitemap].[MobileNodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (2, 1, N'/myadams', N'My ADAMS', 9)
INSERT INTO [Sitemap].[MobileNodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (4, 2, N'/myadams/profile', N'My Profile', 1)
INSERT INTO [Sitemap].[MobileNodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (5, 2, N'/myadams/classifieds', N'My Classifieds', 3)
INSERT INTO [Sitemap].[MobileNodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (6, 2, N'/myadams/businesses', N'My Businesses', 2)
INSERT INTO [Sitemap].[MobileNodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (7, 1, N'/about-us', N'About Us', 1)
INSERT INTO [Sitemap].[MobileNodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (8, 7, N'/about-us/history', N'History', 1)
INSERT INTO [Sitemap].[MobileNodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (9, 7, N'/about-us/mission', N'Mission', 2)
INSERT INTO [Sitemap].[MobileNodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (10, 7, N'/Files/ByLaws_05162011.pdf', N'By-Laws', 4)
INSERT INTO [Sitemap].[MobileNodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (11, 1, N'/services', N'Services', 8)
INSERT INTO [Sitemap].[MobileNodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (12, 11, N'/services/funeral-services', N'Funeral Services', 3)
INSERT INTO [Sitemap].[MobileNodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (13, 11, N'/services/social-services', N'Social Services', 6)
INSERT INTO [Sitemap].[MobileNodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (14, 37, N'/programs/health-programs', N'Health Programs', 5)
INSERT INTO [Sitemap].[MobileNodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (15, 1, N'/community', N'Community', 3)
INSERT INTO [Sitemap].[MobileNodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (16, 15, N'/community/interfaith', N'Interfaith', 1)
INSERT INTO [Sitemap].[MobileNodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (17, 15, N'/community/civic', N'Civic', 2)
INSERT INTO [Sitemap].[MobileNodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (18, 15, N'/community/community-service', N'Community Service', 3)
INSERT INTO [Sitemap].[MobileNodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (19, 1, N'/education', N'Education', 4)
INSERT INTO [Sitemap].[MobileNodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (20, 19, N'/education/sunday-school', N'Sunday School', 3)
INSERT INTO [Sitemap].[MobileNodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (21, 19, N'/education/taleem-ul-quran', N'Taleem Ul Quran', 5)
INSERT INTO [Sitemap].[MobileNodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (23, 7, N'/about-us/vision', N'Vision', 3)
INSERT INTO [Sitemap].[MobileNodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (25, 7, N'/Files/2010_Annual_Report_Public_v2.doc.pdf', N'2010 Annual Report', 6)
INSERT INTO [Sitemap].[MobileNodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (26, 7, N'/about-us/fundraising', N'Fundraising', 6)
INSERT INTO [Sitemap].[MobileNodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (27, 7, N'/about-us/class-policy', N'Class Policy', 6)
INSERT INTO [Sitemap].[MobileNodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (28, 11, N'/Prayers', N'Prayers', 5)
INSERT INTO [Sitemap].[MobileNodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (29, 28, N'/prayers/daily', N'Daily Prayers', 5)
INSERT INTO [Sitemap].[MobileNodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (30, 28, N'/prayers/jummah', N'Jummah Prayers', 5)
INSERT INTO [Sitemap].[MobileNodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (31, 28, N'/prayers/taraweh', N'Taraweh Prayers', 5)
INSERT INTO [Sitemap].[MobileNodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (32, 28, N'/prayers/eid', N'Eid Prayers', 5)
INSERT INTO [Sitemap].[MobileNodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (33, 4, N'/myadams/profile/email', N'My Email', 5)
INSERT INTO [Sitemap].[MobileNodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (34, 4, N'/myadams/profile/password', N'My Password', 5)
INSERT INTO [Sitemap].[MobileNodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (35, 4, N'/myadams/profile/general', N'My Information', 5)
INSERT INTO [Sitemap].[MobileNodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (37, 1, N'/programs', N'Programs', 12)
INSERT INTO [Sitemap].[MobileNodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (38, 13, N'/services/social-services/faith', N'Faith', 1)
INSERT INTO [Sitemap].[MobileNodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (39, 13, N'/services/social-services/shelters', N'Shelters', 3)
INSERT INTO [Sitemap].[MobileNodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (40, 13, N'/services/social-services/other-organizations', N'Other Organizations', 2)
INSERT INTO [Sitemap].[MobileNodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (41, 11, N'/services/marriage', N'Marriage', 4)
INSERT INTO [Sitemap].[MobileNodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (42, 11, N'/services/zakat', N'Zakat', 7)
INSERT INTO [Sitemap].[MobileNodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (43, 42, N'/files/ZakatulFitr_08012010.pdf', N'Zakat Form', 5)
INSERT INTO [Sitemap].[MobileNodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (44, 42, N'/services/zakat/distribution', N'Zakah Distribution', 4)
INSERT INTO [Sitemap].[MobileNodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (45, 42, N'/services/zakat/nisab', N'Nisab', 3)
INSERT INTO [Sitemap].[MobileNodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (46, 42, N'/services/zakat/who-should-pay-zakah', N'Who Should Pay Zakah', 2)
INSERT INTO [Sitemap].[MobileNodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (47, 42, N'/services/zakat/important-message', N'Important Message', 1)
INSERT INTO [Sitemap].[MobileNodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (48, 15, N'/community/new-muslim-support-group', N'New Muslim Support Group', 8)
INSERT INTO [Sitemap].[MobileNodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (49, 19, N'/education/computer-training', N'Computer Training', 1)
INSERT INTO [Sitemap].[MobileNodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (50, 19, N'/education/preschool', N'Preschool', 2)
INSERT INTO [Sitemap].[MobileNodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (51, 19, N'/education/tahfeez-ul-quran', N'Tahfeez Ul Quran', 4)
INSERT INTO [Sitemap].[MobileNodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (52, 1, N'/events', N'Events', 5)
INSERT INTO [Sitemap].[MobileNodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (53, 1, N'/join', N'Join', 6)
INSERT INTO [Sitemap].[MobileNodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (54, 53, N'/join/my-adams', N'My Adams', 10)
INSERT INTO [Sitemap].[MobileNodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (55, 53, N'/join/membership', N'Become A Member', 10)
INSERT INTO [Sitemap].[MobileNodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (56, 53, N'/join/email-list', N'ADAMS Email List', 10)
INSERT INTO [Sitemap].[MobileNodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (57, 11, N'/classifieds', N'Classifieds', 2)
INSERT INTO [Sitemap].[MobileNodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (58, 11, N'/businesses', N'Businesses', 1)
INSERT INTO [Sitemap].[MobileNodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (59, 1, N'/pressreleases', N'Press Releases', 11)
INSERT INTO [Sitemap].[MobileNodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (60, 1, N'/announcements', N'Announcements', 2)
INSERT INTO [Sitemap].[MobileNodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (61, 37, N'/programs/cub-scouts', N'Cub Scouts', 1)
INSERT INTO [Sitemap].[MobileNodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (62, 37, N'/programs/boy-scouts', N'Boy Scouts', 2)
INSERT INTO [Sitemap].[MobileNodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (63, 37, N'/programs/brothers', N'Brothers', 3)
INSERT INTO [Sitemap].[MobileNodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (64, 37, N'/programs/girl-scouts', N'Girl Scouts', 4)
INSERT INTO [Sitemap].[MobileNodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (65, 37, N'/programs/sisters', N'Sisters', 6)
INSERT INTO [Sitemap].[MobileNodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (66, 37, N'/programs/summer-camp', N'Summer Camp', 7)
INSERT INTO [Sitemap].[MobileNodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (67, 19, N'http://www.qurtubainstitute.org', N'Qurtuba Institute', 11)
SET IDENTITY_INSERT [Sitemap].[MobileNodes] OFF
SET IDENTITY_INSERT [Pages].[Pages] ON
INSERT INTO [Pages].[Pages] ([PageID], [Title], [Url], [Content]) VALUES (1, N'About Us', N'/about-us', N'<h1>About ADAMS</h1><div>All Dulles Area Muslim Society (ADAMS) is one of the largest Muslim communities/mosques in the DC Metro Area and in the United States. ADAMS is a non profit 501c(3) Organization. ADAMS serves over 5000 families and has 7 branches(Sterling/Herndon, Tysons Corner, Fairfax, Reston, Leesburg, Ashburn, and South Riding) in Northern Virginia. ADAMS Center is governed by a 13-member democratically elected board of trustees comprising of men and women. ADAMS engages in regular interfaith, government relations, social services, and community service. ADAMS has one of the largest Cub Scout, Boy Scout, and Girl Scout programs in the DC Metro area.</div><div><br></div><div>* ADAMS is governed by a thirteen-member Board of Trustees and the Executive Committee - both elected by the members, with strong participation by women. Specifically, 3 out of the 13 Board Of Trustees are Women.</div><div><br></div><div>* ADAMS maintains strong ties with other religious groups, and regularly hosts dialogs with Jewish, Christian, Sikh, Hindu, Baha''i, and other faith traditions.</div><div><br></div><div>* ADAMS participates heavily in interfaith and community service programs and social events.</div><div><br></div><div>* ADAMS has one common prayer area for men and women, and does not practice gender discriminations.</div><div><br></div><div>* ADAMS doesn''t practice denominational discrimination between Sunnis and Shi''ites and both groups have participation and involvement in the community</div><div><br></div><div>* ADAMS has active Boy Scouts and Girl Scouts programs.</div><div><br></div><div>* ADAMS maintains an excellent relationship with the FBI, the Department of the Treasury, the Department of State, and various state and local law enforcement agencies.</div><div><br></div><div>* ADAMS has its financial statements independently audited and certified by an independent CPA firm and our auditied financials are presented to the General Body every year in May.&nbsp;</div><div><br></div><div>* ADAMS regularly hosts elected public officials and candidates from all parties for public offices during Friday prayers, social activities and the annual Northern Virginia Civic Picnic.</div><div><br></div><div>* The All Dulles Area Muslim Society (ADAMS), along with other Muslim organizations throughout North America, strongly condemn and reject the actions of terrorists and terrorism.</div><p></p>')
INSERT INTO [Pages].[Pages] ([PageID], [Title], [Url], [Content]) VALUES (2, N'History', N'/about-us/history', N'<h1>History of ADAMS</h1><div>All Dulles Area Muslim Society (ADAMS) was established in 1983 by a small number of families in the Herndon/Reston area in Northern Virginia. Over the past two decades it has grown to be one of the largest Muslim Community organizations in the Washington metropolitan area. Today ADAMS serves the town of Chantilly, Centerville, Sterling, Great Falls, Ashburn, Leesburg, and McLean in addition to Herndon and Reston. ADAMS'' main interest is the upbringing of Muslim children. Monthly potluck gatherings provide the children with opportunity to know one another and bond together. The Sunday school has been established for the purpose of building Muslim character with strong faith and knowledge of the proper way to perform rites of worship.</div><div><br></div><div>It is a membership organization registered in the State of Virginia as a non-profit, tax exempt corporation and is affiliated with the Islamic Society of North America (ISNA).</div><div><br></div><div>ADAMS membership is continuously increasing and has reached about 2,200 individuals. However, it serves close to 5000 families in the area. The Sunday school enrollment is almost 500 students.</div><div><br></div><div>The organization is managed by an elected Executive Committee. The Committee reports to the Board of Trustees which is formed thirteen elected members.</div><div><br></div><div>ADAMS Center is currently located in Sterling at Sugarland Road. The center is 25,000 Sq ft and has a masjid for 750 people, 375 parking spaces, weekend school for 500 children, a community multi-purpose hall, library, and a gymnasium.</div><div><br></div><div>ADAMS also owns a cemetery which is available to the larger Washington metropolitan Muslim community.</div>')
INSERT INTO [Pages].[Pages] ([PageID], [Title], [Url], [Content]) VALUES (3, N'Mission', N'/about-us/mission', N'<h1>ADAMS Mission</h1><div>ADAMS believes that, service to humankind is an important part of devotion to Allah (swt) and that all Muslims are enjoined to be good neighbors. Thus, ADAMS'' mission is to serve Allah (swt) through service to the Muslim community by providing religious education and social services in the best professional manner as embodied in the Quran and Sunnah. Further, ADAMS is dedicated to representing the eternal truths of Islam to the broader community through positive contributions to the society at large.</div>')
INSERT INTO [Pages].[Pages] ([PageID], [Title], [Url], [Content]) VALUES (4, N'Vision', N'/about-us/vision', N'<h1>ADAMS VISION</h1><div>ADAMS aspires to be the anchor of a model community of practicing Muslims of diverse backgrounds, democratically governed, efficiently served, relating to one another with inclusiveness and tolerance, and interacting with neighbors in an Islamic exemplary fashion.</div>')
INSERT INTO [Pages].[Pages] ([PageID], [Title], [Url], [Content]) VALUES (6, N'Fundraising', N'/about-us/fundraising', N'<h1>Fundraising</h1><div><br></div><div>Please donate securely online at http://adamscenter.org/Join/Donate.aspx</div><div><br></div><div>ADAMS is now planning Phase II and III of Construction and Expansion</div><div><br></div><div>Phase II includes DayCare Facility Renovation for 75 Kids in the 1st Floor of current center</div><div><br></div><div>Phase III includes Permanent Masjid Hall, More Classrooms,2nd Event Hall.</div><div><br></div><div>Both phases depend on Parking Lot Expansion, adding a second entrance and widening of sugarland road in front of the center.</div><div><br></div><div>To launch Phase II and III, We need a total of $830,000 for the Parking Lot Expansion and a group of ADAMS devotees put together a $300,000 Matching Qard Hasan/Donation Fund that will match your donations and or Qard Hasan DOLLAR for DOLLAR, Between now and September 30, 2005.</div><div><br></div><div>Donation Target: $830,000&nbsp;</div><div>Donations Received: $174,805&nbsp;</div><div>Oct 1 Dinner donations: 135,729&nbsp;</div><div>Individual Qard Hasan: $71,000&nbsp;</div><div>Pledges $50,000&nbsp;</div><div>Matching Qard Hasan Received: $300,000&nbsp;</div><div>Sub-Total Received: $731,610&nbsp;</div><div>------------------------------------------&nbsp;</div><div>TOTAL NEEDED: $98,390</div><p></p>')
INSERT INTO [Pages].[Pages] ([PageID], [Title], [Url], [Content]) VALUES (7, N'Class Policy', N'/about-us/class-policy', N'<p></p><h1>Classes at ADAMS Center - POLICY STATEMENT</h1><div>2004</div><div><br></div><div>Definition</div><div><br></div><div>For the purpose of this policy a class is a session or a series of periodic sessions, attended by a group of people as learners, and led by one or more persons as instructor or instructors, at which presentations and discussions relate to one or more topics of interest.</div><div><br></div><div>Process</div><div><br></div><div>A person or persons who wish to organize, conduct, teach, mentor, advise, or deal with a class or classes, as defined in this policy statement, shall be required to submit an application or applications, one for each class or each set of classes that constitutes a course, to the Education Content Approval Committee for review and approval or denial of such an application or applications. No activity of any type regarding a pending application may be conducted until final approval has been formally received by an applicant. Content Review</div><div><br></div><div>All content of any and all class sessions are subject to related policies of ADAMS as, specifically listed in the application form for seminars/classes. These policies, which shall be considered part of this policy statement, are based on the vision, mission and strategic priorities of ADAMS and may not be violated in the conduct of any activity under ADAMS â€™ sponsorship or on ADAMS â€™ property. The Director of ADAMSâ€™ and any other designated official shall have the right to review the content of any session at any time to ensure compliance with ADAMS â€™ policies.</div><div><br></div><div>Procedures</div><div><br></div><div>Operations Director of ADAMS Center, with approval of the President , shall determine procedures to comply with this policy statement, including the type and use of forms, deadlines, facility allocation and use, and other operational, logistics and security concerns.</div><p></p>')
EXEC(N'INSERT INTO [Pages].[Pages] ([PageID], [Title], [Url], [Content]) VALUES (8, N''Privacy Policy'', N''/information/privacy_policy'', N''<h1>

        Privacy Policy</h1>

    <p>

        The following statement outlines the privacy policy of ADAMS Center. This policy

        is based on our fundamental goal to provide our visitors with quality information

        and resources while maintaining individual anonymity and personal privacy. Please

        forward any comments you may have regarding this policy to webmaster@adamscenter.org.

    </p>

    <h2>

        Visitor data collected by ADAMS Center

    </h2>

    <p>

        When you access our web pages, the client information and the essential and nonessential

        technical information listed below is automatically collected - we refer to those

        categories collectively as "access" information. No other information is collected

        through the ADAMS Center web site except when you deliberately decide to send it

        to us (for example, by clicking on a link to send us an e-mail). The information

        you might choose to send us is listed below as "optional information."

    </p>

    <h2>

        Automatically collected access information

    </h2>

    <p>

        Client information: the Internet domain and Internet address of the computer you

        are using. Essential technical information: identification of the page or service

        you are requesting, type of browser and operating system you are using; and the

        date and time of access. Nonessential technical information: the Internet address

        of the website from which you linked directly to our web site, and the "cookie information"

        described below.

    </p>

    <h2>

        Optional information</h2>

    <p>

        When you send us an e-mail: your name, e-mail address, and the content of your e-mail.

        When you complete online forms: all the data you choose to fill in or confirm.

    </p>

    <h2>

        The way we use information</h2>

    <p>

        Client information is used to route the requested web page to your computer for

        viewing. In theory, the requested web page and the routing information could be

        discerned by other entities involved in transmitting the requested page to you.

        We do not control the privacy practices of those entities. Essential and nonessential

        technical information helps us respond to your request in an appropriate format

        (or in a personalized manner) and helps us plan website improvements. Optional information

        enables us to provide services or information tailored more specifically to your

        needs or to forward your message or inquiry to another entity that is better able

        to do so, and also allows us to plan website improvements.

    </p>

    <p>

        We may keep user information from our systems indefinitely after the web page is

        transmitted, but we do not try to obtain any information to link it to the individuals

        who browse our web site. However, on rare occasions when a "hacker" attempts to

        breach computer security, logs of access information are retained to permit a security

        investigation and in such cases may be forwarded together with any other relevant

        information in our possession to law enforcement agencies.

    </p>

    <p>

        We use information you provide about yourself only to complete your specific request.

        We do not share this information with outside parties except to the extent necessary

        to complete that request. Similarly, we use the information you provide about someone

        else when making a request only to complete that request. Again, we do not share

        this information with outside parties except to the extent necessary to complete

        that request.

    </p>

    <p>

        We generally use return e-mail addresses only to answer the e-mail we receive. Such

        addresses are generally not used for any other purpose.

    </p>

    <p>

        Fin'')')
SELECT @pv=TEXTPTR([Content]) FROM [Pages].[Pages] WHERE [PageID]=8
UPDATETEXT [Pages].[Pages].[Content] @pv NULL NULL N'ally, we never use or share the personally identifiable information provided

        to us online in ways unrelated to the ones described above without a clear notice

        on the particular site and without also providing you an opportunity to opt-out

        or otherwise prohibit such unrelated uses.

    </p>

    <h2>

        Use of cookies

    </h2>

    <p>

        The ADAMS Center website uses "cookies," a small data file transferred by a website

        to your computer''s hard drive. We send cookies when you surf http://www.adamscenter.org,

        respond to online surveys or polls, or request information. Accepting the cookies

        used on our site does not give us access to your Personally Identifiable Information,

        but we can use the cookies to identify your computer. The aggregate information

        collected permits us to analyze traffic patterns on our site. This can enable us

        over time to provide you with a better experience by improving the content and making

        it easier to use.

    </p>

    <h2>

        Providing information is your choice

    </h2>

    <p>

        There is no legal requirement for you to provide any information at our website

        However, our website will not work without routing information and the essential

        technical information. Failure of your browser to provide nonessential technical

        information will not prevent your use of our website but may prevent certain features

        from working. For any optional information that is requested at the website, failure

        to provide the requested information will mean that the particular feature or service

        associated with that part of the web page may not be available to you.

    </p>

    <h2>

        Our commitment to data security

    </h2>

    <p>

        To prevent unauthorized access, maintain data accuracy, and ensure the correct use

        of information, we have put in place appropriate physical, electronic, and managerial

        procedures to safeguard and secure the information we collect online, consistent

        with the policies of ADAMS Center and with the laws and regulations of United States.

    </p>

    <h2>

        How to contact us

    </h2>

    <p>

        Should you have other questions or concerns about our privacy policies and practices,

        please refer to the contact us page for more information..

    </p>

'
EXEC(N'INSERT INTO [Pages].[Pages] ([PageID], [Title], [Url], [Content]) VALUES (9, N''Legal Notice'', N''/information/legal_notice'', N''<h1>

        Legal Notice</h1>

    <p>

        Legal Notice Copyright ©

        2011

        ADAMS Center. All rights reserved.

        <br />

        Please review the following terms and conditions prior to using ADAMS Center''''s website

        (the website). Any use of the web site and its content is subject to the following

        terms and conditions. Your use of the web site indicates your acceptance of said

        terms and conditions. If you do not accept such terms and conditions you may not

        use the web site and it''''s content.

    </p>

    <h2>

        ACCEPTANCE OF TERMS</h2>

    <p>

        ADAMS Center and the ADAMS Center logo are trademarks of ADAMS Center Organization

        (ADAMS Center), a limited liability company registered in and subject to the laws

        of United States. ADAMS Center may, at its sole discretion, choose to change the

        terms, conditions and operation of this Website at any time without prior notice.

        By using this service the user waives any rights or claims it may have against ADAMS

        Center. Consequently, by accessing, browsing and/or using the Website you acknowledge

        to have read, understood and agreed to be bound by these terms. By using the Website

        you have agreed to these terms. You may not alter, change, modify or adapt the Website

        in any way.

    </p>

    <h2>

        TRADEMARKS</h2>

    <p>

        The trademarks, service marks, and logos (the Trademarks) used and displayed on

        the Website are either the Trademarks or the registered Trademarks of ADAMS Center.

        Other product and company names mentioned on this Website may be the trademarks

        or registered trademarks of their respective owners.

    </p>

    <h2>

        LIMITATION OF LIABILITY</h2>

    <p>

        Except as specifically stated on the Website, neither ADAMS Center nor any of its

        directors, employees or other representatives shall be liable for damages arising

        out of or in connection with the use of the Website. This is a comprehensive limitation

        of liability that applies to all damages of any kind, including, but not limited

        to, compensatory, direct, indirect or consequential damages, loss of data, income

        or profit, loss of or damage to property and claims of or related to third parties.

    </p>

    <p>

        Information on this Website may contain inaccuracies or typographical errors for

        which ADAMS Center takes no responsibility.

    </p>

    <p>

        ADAMS Center does not make any representations for other websites that you may access

        through this Website. While ADAMS Center has no control over web sites produced

        and authored by third parties, ADAMS Center declines all liability for the accessibility,

        content and use as well as the products, services, that are made available through

        such third party''''s web site.

    </p>

    <p>

        Under no circumstance shall ADAMS Center be liable to any party for any direct,

        indirect, special or other consequential damages for any use of the web site, or

        any other hyperlinked web site, including, but not limited to, any lost profits,

        business interruption, loss of programmes or other data or similar, even if we have

        been expressly advised as to the possibility of such damages.

    </p>

    <p>

        Information on the web site is provided "as is" without warranty of any kind, either

        express or implied, including, but not limited to, the implied warranties of merchantability,

        fitness for a particular purpose, or non-infringement. Some jurisdictions do not

        allow the exclusion of implied warranties, so the above exclusion may not apply

        to you.

    </p>

    <p>

        All prices are in US Dollars (UDS) unless otherwise indicated.

        Prices and specifications are subject to change'')')
SELECT @pv=TEXTPTR([Content]) FROM [Pages].[Pages] WHERE [PageID]=9
UPDATETEXT [Pages].[Pages].[Content] @pv NULL NULL N' without notice.

    </p>

    <p>

        If you have any questions about this legal notice, please refer to the contact us page.

    </p>
'
INSERT INTO [Pages].[Pages] ([PageID], [Title], [Url], [Content]) VALUES (10, N'Services', N'/Services', N'<h1>Services</h1>
<ul id="mainlinks">
    <li>
	<h3>Businesses</h3>
	<a href="/businesses"><img src="/Content/Images/links/businesses.jpg" class="ui-corner-all"></a></li>
    <li>
	<h3>Classifieds</h3>
	<a href="/classifieds"><img src="/Content/Images/links/classifieds.jpg" class="ui-corner-all"></a></li>
    <li>
	<h3>Funeral Services</h3>
	<a href="/services/funeral-services"><img src="/Content/Images/links/funeral.png" class="ui-corner-all"></a></li>
    <li>
	<h3>Marriage Services</h3>
	<a href="/services/marriage"><img src="/Content/Images/links/marriage.jpg" class="ui-corner-all"></a></li>
    <li>
	<h3>Prayers</h3>
	<a href="/prayers"><img src="/Content/Images/links/prayer.jpg" class="ui-corner-all"></a></li>
    <li>
	<h3>Social Services</h3>
	<a href="/services/social-services"><img src="/Content/Images/links/social.jpg" class="ui-corner-all"></a></li>
    <li>
	<h3>Zakat</h3>
	<a href="/services/zakat"><img src="/Content/Images/links/zakat.jpg" class="ui-corner-all"></a></li>
</ul>
<div style="clear: both;"></div>')
EXEC(N'INSERT INTO [Pages].[Pages] ([PageID], [Title], [Url], [Content]) VALUES (11, N''Funeral Services'', N''/services/funeral-services'', N''<h1>Funeral Information</h1>

<p>

Allah describes death in a number of places in the Quran.

</p>

<p>

[Qaaf 50:43] Verily it is We Who give Life and Death; and to Us is the Final Goal-

</p>

<p>

[Al Jathiyai 45:26] Say: "It is Allah Who gives you life, then gives you death; then He will gather you together for the Day of Judgment about which there is no doubt": But most men do not understand.

One day we all will return to meet our creator Allah Subhan wa Tallah. As you are reading this please think and ponder how you have prepared for the moment when the angel of death will come. It is human nature not to think about this moment or prepare for it but as Allah says in surah Ankaboot Surah 20: V 57

</p>

<p>

[Al-Ankaboot 29:57] Every soul shall have a taste of death in the end to Us shall ye be brought back.

</p>

<p>

This document contains information on what to do when someone dies. It gives step by step procedure and important contact and cost information. Following topics are discussed

</p>

<p>

<ol>

<li><a href="#1">Will and Estate Planning</a></li>

<li><a href="#2">When a Person is Near Death</a></li>

<li><a href="#3">Role of close Family and Friends</a></li>

<li><a href="#4">Advance Preparation</a></li>

<li><a href="#5">Funeral Homes</a></li>

<li><a href="#6">Cemetery List</a></li>

<li><a href="#7">Cost of Funeral and Burial</a></li>

<li><a href="#8">Essentials of Funeral</a></li>

<li><a href="#9">Things Recommended to Avoid</a></li>

<li><a href="#10">Idah Period for the (Wife of deceased)</a></li>

<li><a href="#11">After Death</a></li>

</ol>

</p>

<p>

For ADAMS Funeral services, please contact:

<br />- Br. Khalid Iqbal at 202 439 5432 (cell) or 703 433 1325 Ext 103 (office) 
<br />- ADAMS Main number 703 433 1325 Ext 101    
<br />- Br. Tanweer Ahmed Khan 703 855 7438 or 703 433 1325 Ext 113 (office)
<br />- Br. Basir Kapadia at 703 728 5529 (cell)  
</p>

<p>

<a name="1"></a>

<h2>1. Will (Wasiah) and Estate planning:</h2>

</p>

<p>

Islam has strongly emphasized that each individual make a Will in his/her lifetime and have witnesses to it.  

</p>

<p>

[Surah Al-Baqara 2:180]"It is prescribed for you, when death approaches one of you, if he leaves behind wealth, that he bequeaths unto parents and near relatives in goodness; (that is) a duty on those who safeguard themselves with full awareness of divine laws." 2:180 The Holy Quran.

</p>

<p>The Prophet (SAW) has also strongly urged Muslims to do so. It is so much important, that when going to bed to sleep, it is recommended that the Will be kept under the pillow.

</p>

<p>In these times, the Will has become extremely important.  It avoids costs and complications for the heirs. It provides for the proper distribution of assets, properties and possessions, instruction for payment of debts, selection of an executor and appointment of a guardian for minor. Without a will, the state would step-in, distributing the wealth according to the state laws and the court would select an administrator for the estate and a guardian for children.

</p>

<p>Parents with children of minor age especially must have a well written will assigning a trustee for their estate and guardian for the children. If there is no will the court will assign guardian of its choice. Not writing The Last Will and Testament, then, amounts to giving up your rights regarding your inheritance.

</p>

<p>There are many Islamic wills prepared by scholars and Will experts that are available on the internet e.g. ISNA has a good sample of Islamic will 

<br/>http://www.scribd.com/doc/20362864/Islamic-Will-From-ISna

 </p>

<p>

<a name="2"></a>

<h2>2. When a person is near death:</h2>

</p>

<p>

<ul>

<li>Seek to pay out any outstanding debts

<li>Ask for forgiveness from family friends and acquaintances

<li>Assign someone as trustee to execute funeral arrangements 

<li>Assign someone as trustee to execute condition of the will

<li>Remember Allah asking His forgiveness

</ul>



'')')
EXEC(N'DECLARE @pv binary(16)
'+N'SELECT @pv=TEXTPTR([Content]) FROM [Pages].[Pages] WHERE [PageID]=11
UPDATETEXT [Pages].[Pages].[Content] @pv NULL NULL N'' </p>

<p>

<a name="3"></a>

<h2>3. Role of Close Family and Friends</h2>

</p>

<p>

Close family and friends should try to support and comfort the dying person through supplication and remembrance of Allah.

</p>

<p>Encourage and help him or her to recite the Shahda  

</p>

<p>It was narrated that Muâ€™aadh ibn Jabal (may Allaah be pleased with him) said: I heard the Messenger of Allaah (peace and blessings of Allaah be upon him) say: "If a personâ€™s last words are Laa ilaaha ill-Allaah, Paradise will be guaranteed for him." Narrated by Ahmad, 21529; Abu Dawood, 3116; classed as saheeh by al-Albaani in Irwaâ€™ al-Ghaleel, 687 

</p>

<p>It was narrated from Anas that the Messenger of Allaah (peace and blessings of Allaah be upon him) visited a man from among the Ansaar when he was sick and he said: "O maternal uncle, say Laa ilaaha ill-Allaah." He said: "Maternal uncle or paternal uncle?" He said: "Maternal uncle." He said: "Is it better for me to say it?â€™ He said: "Yes." Narrated by Ahmad, 13414. Al-Albaani said in Ahkaam al-Janaaâ€™iz: its isnaad is saheeh according to the conditions of Muslim. 

</p>

<p>The dying person should not be bothered with repeated requests to say shahada, if he has said it and does not say anything after that. 

</p>

<p>Upon death, the eye lids are to be closed, the body should be covered, and preparation for burial takes place as soon as possible. The whole body is washed and wrapped in a shroud. Muslims gather and a prayer is performed for the dead. The body is to buried soon after the prayer. The wrapped body is to be laid directly at the bottom of the dug grave. The body is to be laid on its right side facing the direction of Makkah. A ceiling is attached to the grave and then covered with dirt. The grave is to be marked by raising its top level of dirt above surrounding grounds. A stone may be used to mark its location, but no writings are allowed. Buildings or other forms of structures are not allowed on top of the grave. 

</p>

<p>The family of the dead has a responsibility to fulfill any debts he had as soon as possible. They have the commitment to maintain contacts and courteous relationships with close relatives and close friends. They frequently pray and supplicate for him. Charity, fasting, prayers, and pilgrimage are often performed on behalf of the dead. Visiting the graves is recommended for the living to remember death and the Day of Judgment. 



 </p>

<p>

<a name="4"></a>

<h2>4. Advance preparation</h2>

</p>

<p> 

<ul>

<li>Choose a family member or friend to coordinate and resolve funeral and burial issues. 

<li>Ensure that death certificate is issued by a doctor/hospital. Funeral home can also arrange for it. Death certificate is required before body can be removed for washing and preparation for burial (There might be a cost of obtaining a death certificate). In Virginia police might be involved if the death happens at home. In that case please consult with your family physicians 

<li>Unless required by law Muslims avoid autopsy on the deceased body

<li>Get cost estimates from funeral homes for washing and transporting the body. (Please check the list of funeral homes)

<li>Select funeral home, cemetery (burial site) and the Masjid where the prayers will be performed. 

<li>Ensure that cemetery lot ownership paperwork is readily available if the family has already purchased a cemetery site. 

<li>Funeral Directors coordinate transportation of the body from the hospital to the funeral home and from the funeral home to the Masjid for the funeral prayer and then to the cemetery. Ensure that timings are correctly adhered. 

<li>Call the Masjid director or Imam ahead of time informing about the Janaza prayer

<li>Normally, cemeteries charge premium rates to arrange services after 3:00 PM. Additional charges are applied for services over weekends. 

<li>Print directions the precession will follow. Hand out copies of directions at the funeral home/Masjid. 

</ul>


''
UPDATETEXT [Pages].[Pages].[Content] @pv NULL NULL N''
 </p>

<p>

<a name="5"></a>

<h2>5. FUNERAL HOMES </h2>

</p>

<p>

1. Aden Muslim Funeral Services

<br />www.adenmuslimfuneral.com

<br />1242 Easy St. Woodbridge VA 22191

<br />Tele: 703 490 1212, 703 586 2460, 703 973 7070
<br />Contact: Br. Abbasi or Br. Sana

</p>

<p>

2. Janazah Services

<br />14640 Flint Lee Road, Suite C

<br />Chantilly VA 20151

<br />Tele: 571 490 2249
<br />Contact: Sr. Mariam Rose AbdRahmaan

</p>

<p>

3. Loudoun Funeral Chapel

<br />158 Catoctin Circle, S.E. 

<br />Leesburg, VA 20177

<br />Tele: 703 777 6000
<br />Contact: Bill or Cathy

</p>

<p>

4. Universal Mortury Inc

<br />411 Kennedy St NW

<br />Washington DC 20011

<br />202 723 1075
<br />Contact: Br. Mateen

</p>

<p>

5. Latney Funeral Home

<br />2831 Georgia Ave NW

<br />Washington DC 20011

<br />Tele 202 882 2455, or 202 882 1424
<br />Contact: Br. Jeelani



 </p>

<p>

<a name="6"></a>

<h2>6.	CEMETRIES</h2>

</p>

<p>

1. All Muslim American Association (AMAA) 

<br />1112 Brook Road 

<br />Stafford VA 22405

<br />Contact Persons: Muhammad Younus 240-602-6587 (Cell), Mohammad Khan 703 717 1851, or Sikiandar 703-360-6282
</p>

<p>

2. AL-Frdaus Memorial Gardens 

<br />3845 New Design Road

<br />Fredrick MD 21703-7930

<br />Contact Person:  

<br />Brother Muhammad Aslam

<br />Administrator ICM, Gaithersburg MD 

<br />PH- 301-840-9440 
</p>

<p>

3. National Memorial Park 

<br />7482 Lee Highway 

<br />Falls Church VA

<br />PH- 703-560-4400, 703-289-4700
</p>

<p>

4. Stonewall Memorial Park 

<br />12004 Lee Highway 

<br />Manassas VA 20109

<br />PH- Amy Shaw 703-754-4210
</p>

<p>

5. George Washington Cemetery 

<br />9500 Riggs Road

<br />Adelphi MD 20783

<br />PH- 301-434-4640
</p>

<p>

6. Mount Comfort Cemetery 

<br />6600 South Kings Highway

<br />Alexandria VA 22306

<br />PH-703-765-3800

 </p>

<p>

<a name="7"></a>

<h2>7.	BASIC COST OF FUNERAL AND BURIAL</h2>

</p>

<p>

Services provided by funeral home are:

<ul>

<li>Transportation of body from the place of death to the funeral home, to the Masjid and then cemetery. The charges could vary if they are transporting the body to longer than average distances. The charges start from $3.50 per mile. Some funeral home also have fixed additional cost to certain cemeteries out of their normal area of service

<li>Storing, washing, kafan and preparing the body

<li>Casket /Box may be additional cost if the body is buried in the casket

<li>Family gathering, special viewing, or other services are usually extra charge

</ul>

</p>

<p>

Cemetery Cost includes:

<ul>

<li>

<li>Cost of plot

<li>Opening and closing of grave

<li>Vault and liner

<li>Processing fees

</ul>

</p>

<p>

The cost of funeral and burial varies based on services requested by the family and the Funeral home or Cemetery. The total cost of funeral and burial start with $3500 and more. The cemeteries usually require one day or more notice for preparing the grave. They may charge extra for overtime for burial after 3 pm or on weekend or holiday.

 

 

</p>

<p>

 <a name="8"></a>

<h2>8.	Janaza Preprations Guidelines</h2>

</p>

<p>

When a Muslim passes away, it is a collective obligation (Fard-e-kifaya) of that particular Muslim community to arrange and participate in the funeral services for the deceased. Though only some members of the community may fulfill this obligation on behalf of the rest, the entire community would be held to account if none did it. This is a right of a Muslim even after death. 

 </p>

<p>

Basically the funeral procedure consists of four major steps: 

</p>

<p>

1. Ghusl (washing the body ) 



<br />2. Kafan (wrapping the body in white shrouds) 



<br />3. Salat-ul Janazah (Funeral Prayer) 



<br />4. Dafan (Burial) 





</p>

<p>							

<h2>Practices that should be avoided</h2>		

</p>

<p>

<ul>

<li>No reading of the Quran or Zikr (Remembrance of Allah) during the ghusl. 

<li>Unless necessary, funeral services are prohibited during sunri''
UPDATETEXT [Pages].[Pages].[Content] @pv NULL NULL N''se/sunset/noon. 

<li>Itâ€™s prohibited to build any kind of structure on top of the grave. 

<li>Itâ€™s prohibited to cremate the body. 

<li>It is prohibited for non-mehrum to view the face of deceased Muslim women

<li>Unless required by law, autopsy is prohibited and should be avoided. 

<li>Every effort should be made to bury the body as quickly as possible in a local cemetery. 

<li>There are no Islamic teaching to: 

<ul>

<li>Transfer the body to another country.	

<li>Reveal the face of the body in the grave.

<li>Shout with any special zikr during and after the burial. 

<li>Read the Qurâ€™an in the cemetery. 

<li>Place any flowers or water around the grave. 

<li>Wear black clothes. 

<li>Deliver eulogies. 

</ul>

</ul>





</p>

<p>



<a name="9"></a>

<h2>9.	Iddah (Waiting Period) for a Muslim Widow: </h2>

</p>

<p>

For a Muslim woman, who has lost her husband, the iddah period is four (lunar) months 

and ten days. If she is pregnant, the iddah ends at the delivery. 

During this period it is recommended for her to stay in her home and may leave only 

when itâ€™s absolutely necessary (e.g., medical or other  emergency or necessary 

Chores that would need her to attend).  Family and friends are to take care of the

 widow during this period of Iddah

 </p>

<p>

<a name="10"></a>

<h2>10.	Checklist: What To Do When a Family Member or Community Member Dies</h2>

</p>

<p>

It is a trial time to handle the death of a family member. Often the next of kin or friends find themselves lost asking themselves "What do I need to do now"? We have prepared a check list that will be of assistance

</p>

<p>

ACTION REQUIRED IMMIDIATELY AFTER DEATH

<ul>

<li>We recommend selecting one person (Family member or Friend) to coordinate all funeral and burial arrangements

<li>He or she should have financial resources to pay for the costs that may require immediate payments

<li>Obtaining a death certificate is the first step. Ask your family physician for assistance or coroner in order to obtain a death certificate. Please keep in mind the cost of issuance of death certificate.

<li>If the death occurs at home, you may need to contact a local police officer or coroner office.

<li>If possible decline autopsy being done on the deceased. It should only be allowed if required by law. 

<li>If the Decedent wished, a donation of body parts and tissues should be considered.

<li>Notify family and friends. You may want to consider having family members contact others to save yourself some time on the phone during a stressful period.

<li>Look for instructions or will which the Decedent may have left regarding preferences for funeral and burial arrangements. Obtain a list of Funeral homes and cemeteries from www.adamscenter.org or www.MCCMD.org. The cost may vary depending upon the funeral homes and cemetery and each line item requested by the family

<li>Contact a funeral home concerning burial. A Muslim burial home like ADEN is recommended as they have good experience in Muslim burials and can take care of washing and preparing the Janzah

<li>Contact Cemetery where you want your loved one to be buried (List available at www.adamscenter.org) find out about the costs and timings. Cemeteries might have time restrictions on weekends and holidays. We recommend Muslim cemeteries like Al-Firdous in Marland or AMAA in Virginia. For other cemeteries ask the grave location to make sure that is in Muslim location and they will dig it so that the deceased face is towards Qibla when laid in grave.

<li>Please note that cemeteries charge premium rates to arrange for services after their normal office hours (Usually after 3 pm burial)

<li>Contact local Mosque where Janaza prayer will be held. Arrange for Janazah prayer time according to the time given by cemetery and or regular prayer times at the masjid 

<li>Print directions to the cemetery. Hand out copies of directions at the Masjid / funeral home (if the body is taken from funeral home d''
UPDATETEXT [Pages].[Pages].[Content] @pv NULL NULL N''irectly to the cemetery) 

</ul>

</p>

<p>

HANDELING OF FINANCES AND ASSETS

<ul>

<li>Contact the Social Security Administration and any other government agencies or benefit program that may be making payments to the Decedent. (Note that the payment for the month of death will not be made by the Social Security Administration and others.)

<li>Review the Decedents financial affairs and look for any estate planning documents, such as Wills and Trusts, along with any other relevant documents, including: 

<ul>

<li>Funeral and Burial Plans

<li>Bank statements, checkbooks, similar documents

<li>Safty Deposit Box Agreements and keys

<li>Stocks, bonds or mutual fund documents

<li>Life Insurance Policies;

<li>Trust documents

<li>Pension-retirement benefits

<li>Old tax returns

<li>Marriage, birth and death certificates

<li>Divorce documentation (If divorced)

<li>Computer records regarding books of a business or personal assets

<li>Titles to motor vehicles

<li>Rental documents (leases)

<li>Any documentation regarding business ownership, partnership or other business interests

<li>Health Insurance, make claims for the final illness and

<li>Unpaid bills.

<ul>

<li>Open a bank account for the estate of the Decedent. This should be done early on and all receipts and disbursements should be recorded in that bank account, in order to account properly for the assets of the Decedent and the expenses of administration.

<li>Probate is a process similar to that of accounting. The Personal Representative is responsible for collecting the assets and reporting to the Court as to the amount of assets in the Estate of the Decedent. The Personal Representative then assembles the assets and, after paying debts, expenses and taxes, distributes the assets according to the wishes of the Decedent. If the Decedent left no Will, the process of administration is essentially the same, except that state law determines to whom the assets are distributed. If everything is done correctly, eventually, after the Personal Representative has accounted for and distributed the assets, the Personal Representative is discharged.

<li>Make an inventory of household goods, personal belongings and the like, in order that they can be accounted for and properly distributed.

<li>Look for insurance policies or annuities which may continue for other family members and other assets.  Contact the Insurer with respect to any current policies or annuities..

<li>Determine if the Decedent owned any securities, stocks, bonds, mutual funds, etc.

<li>Retirement Plans, IRA accounts and similar retirement benefits involve important choices which need to be made by certain beneficiaries, particularly in regard to IRA accounts under recent IRS regulations. If there are annuities, pension and profit sharing plans and interest of that type, they may provide for joint payment to a surviving spouse or others.

<li>If, after the appointment of a Personal Representative, a bank account or safe deposit box is found, then the assets in the bank account or safe deposit box need to be distributed according to the wishes of the Decedent, written will or the Islamic way. This is done after paying any outstanding debt, Taxes and funeral and burial cost.

<li>The income taxes of the Decedent for the year of death need to be filed, and any tax due must be paid. If there is a surviving spouse, the surviving spouse and Decedent can file a joint return for the year of death.

<li>In handling the affairs of a Decedent, consider that as amanah (trust). Please be extremely careful in deciding upon the asset or financial estate distribution, Be deliberate and do not be hasty with decisions or distributions. The death of someone, particularly a family member or friend, is stressful and often if there are children of the Decedent around during the course of the final illness, 

</ul>

</p>

<p>

WILL

<ul>

<li>If there is a Will, take the Will to the appropriate County or City office to have ''
UPDATETEXT [Pages].[Pages].[Content] @pv NULL NULL N''it accepted for probate.

<li>Adminis'
+N'tering the Will - If the Will is properly drawn, it will name a Personal Representative (also known as Executor or Executrix). The Personal Representative, who can be an individual, a group of individuals or one or more institutions, or a combination of the aforementioned, will be responsible for the administration of the Estate of the Decedent.

<li>If there is no Will then the family should try to distribute the asset according to the Islamic way. (The family is encouraged to contact a scholar and Muslim Estate planner to assist. If no effort is made and there are sufficient assets to probate (typically, at least $15,000 or more), then the Court will appoint an administrator and the assets of the Decedent will be distributed according to state law. This situation is referred to by some as having the state write a Will for you. All states have a set of laws relating to intestate succession (transfer of property after dying without a Will), and the states decide who gets which assets if someone dies without a Will.

<li>Parents with children under the age of 18 must mention, who they can trust to take care of their children if they die before them reaching adulthood.  

</ul>

</p>

<p>

MINOR CHILDREN LEFT BEHIND

</p>

<p>

If there are minor children under the age of 18 years and the Will provides for a guardian, then the guardian needs to be informed and the children need to be placed in the care of the guardian. If there are minor children and no guardian is appointed, or if there is no Will, then based on the state laws the Court will appoint a guardian.

</p>

<p>

GOOD ADVICE FROM LAWYERS

</p>

<p>

<ul>

<li>Make sure to have a living Will for you and adult family members. 

<li>Advice from Lawyers is that there may be disputes regarding the treatment or other problems related to declining physical or mental abilities of the parent. Stated differently, it is a time of frazzled nerves and irritable people, so be very careful not to create schisms which can last for a very long time.

<li>Watch out for people who prey upon families of Decedents. There are people who look for death notices and make unfounded claims against the Decedent. Do not accept the claims of unknown individuals that lack documentation. In case of doubt consult a lawyer.

</ul>

</p>
''
')
EXEC(N'INSERT INTO [Pages].[Pages] ([PageID], [Title], [Url], [Content]) VALUES (12, N''Health Programs'', N''/programs/health-programs'', N''<h1>

        Health Education and Programs Committee</h1>

    <h2>

        Mission Statement:

    </h2>

    <p>

        In the name of Allah, the Beneficent, the Merciful. Our bodies do not belong to

        us, but rather they are on loan to us from our Creator, the Almighty, the All Knowing,

        Allah subhana wa ta aala. This amana (trust) is something we as Muslims, indeed

        we as human beings, will be held accountable for on the Day of Judgement. It is

        imperative that as Muslims we take care of our bodies not just for the physical

        benefit, but for our spiritual benefit as well. It is my sincere hope that the health

        programs outlined here will contribute to the health of the ADAMS community.

    </p>

    <h2>

        Health Programs Under Development:

    </h2>

    <h3>

        Medical Seminars -

    </h3>

    <p>

        Medical/health seminars are held quarterly at the ADAMS Center. Each quarterly series

        is assigned a general topic which is covered in four sessions. Each session is approximately

        2 hours long including a question and answer period. Each session focuses on a specific

        aspect of the general topic. Each session is taught by a specialized health professional

        in the particular field of expertise. Admission to the seminars is free.

<br>

<div style="padding-left:50px;">



<b>What is Therapy? Realities and Misconceptions</b>

<p>

March 8th  

<br />Q & A with qualified Muslim Mental Health Professionals 

<br />Discuss the role of therapists vs. the role of imams in counseling

<br />Learn about different types of counseling and psychotherapy

<br />

<br /> 

An interactive discussion with Navid Rashid M.D. and Salma Abugideiri, L.P.C. 

</p>



<b>The Importance of Oral Hygiene</b>

<p>

April 5th 

<br />Q & A with qualified Muslim Dentist 

<br /> Raffle prizes, including teeth whitening

<br /> Free Oral screenings for attendees

<br /> Fun for the whole family

<br /> 

<br /> 

<a href="/Services/adams.ppt">An interactive presentation with Anwar Ahmad, DMD</a> 

</p>



<b>Heart Health</b>

<p>

May 3rd 

<br />50% of people who have had heart attacks had normal cholesterol

<br />An interactive presentation with Mahsin Habib, M.D.

<br />1-3 month

<br />1-6 month

<br />10-1 month 

</p>



<b>Nutrition - Healthy eating made fun</b>

<p> 

June 7th 

<br />The Importance of good nutrition

<br />Join us in our kitchen as we get tips from a qualified Health Professional

<br />Come cook with Mahsin Habib, M.D.

<br />2-1 week of Ideal Protein 

</p> 



</div>





    </p>

    <h3>

        Health Information -

    </h3>

    <p>

        ADAMS provides health information in the form of pamphlets and booklets made for

        distribution. These materials inform and educate the community on a myriad of health

        and medical topics. Please check with the main office for the latest available materials.

    </p>

    <h3>

        Blood Drive -

    </h3>

    <p>

        ADAMS works in close conjuction with INOVA blood donor services to hold quarterly

        blood drives at the ADAMS Center. Rooms are set up on the lower level to accomodate

        blood donation. One room is reserved for men and another room is reserved for women.

        Male staff will be on hand to assist the brothers and female staff will be on hand

        to assist the sisters. Currently there is a blood shortage in the local area and

        nationwide. To learn more about what you can do to donate blood or to volunteer

        please contact the health director.

    </p><br>

<p>

<IMG SRC="ADAMS-INOVA-2009.JPG" ALT="ADAMS-INOVA-2009"><br>

</p>    



<h3>

        Free Blood Pressure and Glucose Check-ups -

    </h3>

    <p>

        Hypertention (high blood pressure) and diabetes (high blood glucose) are two very

        prevalent diseases worldwide. Patients with these conditions can be treated through

        me'')')
SELECT @pv=TEXTPTR([Content]) FROM [Pages].[Pages] WHERE [PageID]=12
UPDATETEXT [Pages].[Pages].[Content] @pv NULL NULL N'dication and lifestyle modification. However screening tests are essential in

        diagnosis and even prevention of hypertension and diabetes. ADAMS will provide free

        blood pressure and blood glucose check-ups at the ADAMS Center once a month on Fridays.

        A physician will be on hand to oversee this program. If you would like to volunteer

        toward this effort please contact the health director.

    </p>

    <h3>

        Health Fair -

    </h3>

    <p>

        ADAMS will host an annual health fair. Seminars and lectures will be held in the

        lower level classrooms. These seminars will cover a variety of health and medical

        topics including mental health issues. In addition to the seminars there will also

        be rooms available for blood donation and bone marrow donation. There will also

        be a health bazaar in the main hall. In the bazaar, vendors will sell health related

        products and will also include local Muslim physicians advertising their services.

        Admission is free and open to the public. The next health fair is scheduled for

        fall 2008.

    </p>

    <h3>

        Partnership With The Fairfax County Health Department -

    </h3>

    <p>

        ADAMS works closely with the Fairfax County Health Department. This partnership

        provides the community better access to Fairfax County Health Services. The ADAMS

        director of health education and programs is a sitting member of the Fairfax County

        Multicultural Health Care Advisory Council.

    </p>

    <h3>

        Free Clinic -

    </h3>

    <p>

        ADAMS is currently working on the development of a free clinic in the Sterling,

        VA area. If you are a local physician interested in being part of this effort please

        contact the health director.

    </p>

    <h3>

        ADAMS Health Insurance Plan -

    </h3>

    <p>

        ADAMS is currently working on a plan to provide health insurance at a discounted

        premium for official ADAMS members. If you would like to become an ADAMS member

        please contact the main office.

    </p>

    <h3>

        Muslim Physician Directory -

    </h3>

    <p>

        This directory consists of Muslim physicians and other health professionals who

        practice in the local ADAMS area. Included in this directory is a subset of those

        physicians who are willing to see patients without health insurance. There are Muslim

        physicians of every medical specialty in the directory. If you are looking for a

        Muslim physician or you happen to be a Muslim physician and want to be included

        in the directory please contact the health director. This is a free service.

    </p>
'
INSERT INTO [Pages].[Pages] ([PageID], [Title], [Url], [Content]) VALUES (13, N'Social Services', N'/services/social-services', N'content tbd...')
INSERT INTO [Pages].[Pages] ([PageID], [Title], [Url], [Content]) VALUES (14, N'Faith', N'/services/social-services/faith', N'<h1>

        Foundation For Appropriate and Immediate Temporary Help (FAITH)

</h1>

    <p>

        ADAMS works with a Muslim Social Services Organization called:

    </p>

                    <br />

        Office Phone # (571)323-2198 and fax (571)-323-2199
    </p>

    The website address is <a href="www.faithus.org">www.faithus.org </a></p>

    <p>



Drop off items to the FAITH Thrift Store during open hours:<br /><br />

FAITH Thrift Store<br>

795 Center Street #2A<br>

Herndon, VA 20170<br>

571-323-2198 - ext. 9<br>
Store Hours<br>

Tuesday, Wednesday, Thursday, Saturday and Sunday: 10am - 4:30pm <br>

(Thrift Store closed Mondays & Fridays)<br>





    </p>

    <p>

        FAITH Thrift Store has:

        <br />

        1) New clothing and shoes.

        <br />

        2) Used things in very good condition.

        <br />

        3) Decoration pieces from all over the world.

        <br />

        4) Jewelry

    </p>

    <p>

        All funds from the thrift store go towards helping the needy families in the community.

        Come buy and volunteer at the store.

    </p>
')
INSERT INTO [Pages].[Pages] ([PageID], [Title], [Url], [Content]) VALUES (15, N'Shelters', N'/services/social-services/shelters', N'<h1>

        Shelters</h1>

    <p>

        Bailey''s Crossroads Shelter Falls Chruch - 703-820-7623
    </p>

    <p>

        Carpenters Shelter Alexandria - 703-548-7500
    </p>

    <p>

        Elanor Kennedy Shelter - Springfield - 703-799-0200
    </p>

    <p>

        Reston Interfaith Shelter(Families) -Reston - 703-437-1975
    </p>
')
INSERT INTO [Pages].[Pages] ([PageID], [Title], [Url], [Content]) VALUES (16, N'Other Organizations', N'/services/social-services/other-organizations', N'<h1>

        Other Organizations</h1>

    <p>

        Fairfax County Emergency Assistance

    </p>

    <p>

        Major Community-Based Organizations

    </p>

    <p>

        Food, Rent, and Utilities

    </p>

    <p>

        Capital Food Bank: 202-526-5344 x 222
    </p>

    <p>

        Committee for Helping Others: 703-281-3243
    </p>

    <p>

        Facets: 703-352-5090
    </p>

    <p>

        Fairfax Fish(For Immediate Sympathetic Help): 703-222-0880
    </p>

    <p>

        Falls Church Community Services: 703-222-0880
    </p>

    <p>

        Food for Others: 703-207-9173
    </p>

    <p>

        Good Shepard Housing & Family Services: 703-768-9404
    </p>

    <p>

        Herndon-Reston Fish: 703-391-0150
    </p>

    <p>

        Housing & Community of Northern VA: 703-913-0880
    </p>

    <p>

        Kinonia Foundation: 703-971-1991
    </p>

    <p>

        LLVCAI: 703-968-3007
    </p>

    <p>

        LINK: 703-437-1776
    </p>

    <p>

        Lorton Community Action Center: 703-339-5161
    </p>

    <p>

        Northern VA Family Services: 703-533-9727
    </p>

    <p>

        Our Daily Bread: 703-273-8829
    </p>

    <p>

        Reston Interfaith: 703-787-3100
    </p>

    <p>

        Salvation Army(Alexandria): 703-548-0579
    </p>

    <p>

        Salvation Army(Fairfax): 703-385-8700
    </p>

    <p>

        Share, Inc: 703-284-2179
    </p>

    <p>

        United Way: 703-847-0402
    </p>

    <p>

        WIC (Permanent Residents Women & Children): 1888-943-2645

    </p>
')
INSERT INTO [Pages].[Pages] ([PageID], [Title], [Url], [Content]) VALUES (17, N'Marriage', N'/services/marriage', N'<h1>

        ADAMS Matrimonial Committee CompanionshipsEvent</h1>

    

    <p>

        ADAMS Center Volunteers have created a nationwide matrimonial service for Muslims

        of all ages. This service is free for all participants! To get a description of

        our service, and to complete the online application form, please visit our website.

        Don''t forget to sign up for notification of our very popular annual retreats, to

        bring singles together from across the nation! <a href="http://www.companionships.org">www.companionships.org</a>

    </p>

    <p>

        </p><h3>Some useful documents: </h3><p></p>

    <ul style="margin: 10px 0px 10px 20px;">

        <li><a href="/files/MarriageApplication.doc">Marriage Application</a></li>

        <li><a href="/files/Pre_MaritalContract.doc">Pre Marital Contract</a></li>

        <li><a href="/files/PremaritalCounselingQuestionnaire.doc">Premarital Counseling Questionnaire</a></li>

        <li><a href="/files/PremaritalCounselingForm.doc">Premarital Counseling Completion Form</a></li>

        <li><a href="/files/Proceduresforgettingmarried.doc">Procedures for getting married</a></li>

<br>

<li><a href="/services/marriage/schedule-a-nikkah">Schedule a Nikkah</a></li>

    </ul>



    <p>

        Please download and fax the completed forms to ADAMS at 571-434-8611 or turn it
        in person at Main ADAMS Center.

    </p>

    <p>

    You can obtain a marriage license from the local county courthouse in the county in which

        you reside, and fax it to ADAMS. The following locations are for the VA, and DC

        residents:

    </p>

    <p>

        A) Fairfax County Court House (703-691-7320)

    </p>

    <p>

        B) Arlington County Court House (703-228-4510)

    </p>

    <p>

        C) Loudoun County Court House (703-777-0270)

    </p>

    <p>

        D) Alexandria County Court House (703-838-5046)

    </p>
')
INSERT INTO [Pages].[Pages] ([PageID], [Title], [Url], [Content]) VALUES (18, N'Zakat', N'/services/zakat', N'content tbd...')
INSERT INTO [Pages].[Pages] ([PageID], [Title], [Url], [Content]) VALUES (19, N'Zakah Distribution', N'/services/zakat/distribution', N'<h1>

        Zakah Distribution

    </h1>

    <p>

        "Alms are for the poor and the needy, and those employed to administer the (funds);

        for those whose hearts have been (recently) reconciled (to the truth); for those

        in bondage and in debt; in the cause of Allah; and for the wayfarer: (Thus is it)

        ordained by Allah, and Allah is full of knowledge and wisdom." (Qur''an 9: 60) ADAMS

        Zakah Committee, having the options furnished by this verse, selects the priorities

        acording to the circumstances and needs in the community, nation and in the Muslim

        Ummah at latge. ADAMS adopted the following explanation for the eight avenues of

        Zakah:

    </p>

    <p>

        1. The Poor

        <br />

        The poor who does not have sufficient sustenance and lives under Nisab in his/her

        area.

    </p>

    <p>

        2. The Needy

        <br />

        The person who was rendered quiet by the demeaning poverty so that he/she does not

        beg others for help.

    </p>

    <p>

        3. Zakah Collection

        <br />

        Direct expenses of the Zakah process, such as collectorsâ€™ remuneration, postage,

        telephone, stationery, transportationâ€¦.etc.

    </p>

    <p>

        4. The Reconciled

        <br />

        Persons whom Muslims would like to gain on their side, as well as those who have

        recently adopted Islam and are in need for support.

    </p>

    <p>

        5. The Oppressed

        <br />

        Captives of wars and victims of oppression, persecution and of restriction of basic

        freedoms and human rights, previously used to emancipate slaves.

    </p>

    <p>

        6. The Insolvent

        <br />

        The person who is not able to meet his liabilities. The debtor who borrowed money

        to meet his or her basic requirements or to cover humanitarian case, but could not

        reimburse his creditors.

    </p>

    <p>

        7. The Cause of Allah vThe cause of Allah includes spending on causes such as Human

        rights and freedoms, on all deeds that serve the application of Islamic teachings

        and help in the understanding of Islam, the propagation of its Message, and establishing

        Masajids and Islamic schools and centers..etc.

    </p>

    <p>

        8. The Wayfarer

        <br />

        The person who was forced to desert his own land, the refugee who was thrown out

        of his country, or who immigrated under conditions of civil war in oneâ€™s own country

        and has no access to his/her wealth.

    </p>
')
INSERT INTO [Pages].[Pages] ([PageID], [Title], [Url], [Content]) VALUES (20, N'Nisab', N'/services/zakat/nisab', N'<h1>

        Nisab</h1>

    <h2>

        Nisab (Exemption Limit) Table

    </h2>

    <p>

        The U.S. Census Bureau has published figures specifying the 1996 Threshold of Income,

        below which a family living in the USA is considered poor. The figures below are

        based on the 1996 Threshold of Income plus 2.5% for inflation adjustment.

    </p>

    <p>

        <table>

            <tr>

                <th>

                    Family Size

                </th>

                <th>

                    Annual Min Income

                </th>

            </tr>

            <tr>

                <td>

                    1

                </td>

                <td>

                    $8,980

                </td>

            </tr>

            <tr>

                <td>

                    2

                </td>

                <td>

                    $12,120

                </td>

            </tr>

            <tr>

                <td>

                    3

                </td>

                <td>

                    $15,260

                </td>

            </tr>

            <tr>

                <td>

                    4

                </td>

                <td>

                    $18,400

                </td>

            </tr>

            <tr>

                <td>

                    5

                </td>

                <td>

                    $21,54

                </td>

            </tr>

            <tr>

                <td>

                    6

                </td>

                <td>

                    $24,680

                </td>

            </tr>

            <tr>

                <td>

                    7

                </td>

                <td>

                    $27,820

                </td>

            </tr>

            <tr>

                <td>

                    8

                </td>

                <td>

                    $30,960

                </td>

            </tr>

        </table>

        For each additional person, add $3,140

        <br />

        SOURCE: Federal Register, Vol. 68, No. 26, February 7, 2003, pp. 6456-6458

    </p>

    <p>

        These figures are based on the average standard of living in medium size cities.

        If you are living in a very large city (New York, Chicago, Los Angeles, etc.) you

        must add 10% to the above mentioned figures. If you are living in a small country

        town or village, you may subtract 10% from the above figures.

    </p>

    <p>

        Enter your adjusted exemption limit on Zakah Calculation Form line 11.

    </p>

    <p>

        No adjustment is needed if residing in the Washington Metropolitan area.

    </p>
')
INSERT INTO [Pages].[Pages] ([PageID], [Title], [Url], [Content]) VALUES (21, N'Who Should Pay Zakah', N'/services/zakat/who-should-pay-zakah', N'<h1>

        Who Should Pay Zakah

    </h1>

    <p>

        Wealth is subject to Zakah irrespective of its ownerâ€™s sex, age, maturity, or

        sanity.

    </p>

    <p>

        A debtor acquiring a loan and benefiting from it, is responsible for Zakah due on

        it.

    </p>

    <p>

        Zakah is due on all economic goods, except for those goods acquired for personal

        use.

    </p>

    <p>

        Zakatable wealth is the wealth that exceeds the exemption limit (Nisab) of the payer,

        calculated according to the number of his/her dependents and the cost of living

        during the previous year.

    </p>

    <p>

        Zakah of a certain category of wealth is to be paid once in any one lunar year.

    </p>
')
INSERT INTO [Pages].[Pages] ([PageID], [Title], [Url], [Content]) VALUES (22, N'Important Message', N'/services/zakat/important-message', N'<h1>

        Important Message Before You Calculate Zakah

    </h1>

    <p>

        Dear Muslim brothers and sisters,

    </p>

    <p>

        Assalamu Alaykum!

    </p>

    <p>

        ADAMS is pleased to be able to present to the Muslim community, and in particular

        to those among them who should pay Zakah, a specially prepared form which is designed

        to facilitate the calculation of Zakah payments in accordance with the prescribed

        Shariah guidelines and in a form which American taxpayers will undoubtedly find

        familiar.

    </p>

    <p>

        In preparing this form, careful attention was paid to choosing fiqh opinions relevant

        to the circumstances of Muslims living in North America. These opinions have been

        solicited from scholars who combine, with their knowledge of Shariah and its sciences,

        experience in dealing with issues affecting the Muslim community in the North American

        context. It should be noted, however, that there are several points in regard to

        Zakah on which there are differences of opinion. Those who wish may seek details

        of these issues in the books of fiqh and Shariah transactions. ADAMS wishes to make

        it clear to all of its members that the opinions on which it has based this form

        are not the only opinions on these matters . They do, however, represent what ADAMS

        considers to be the fiqh that is most appropriate to the circumstances of the community.

    </p>

    <p>

        ADAMS will be pleased to accept your Zakah contributions and, in turn, to spend

        the funds it collects in the best possible ways approved by the Shariah. A specially

        constituted Zakah committee will study the circumstances of potential recipients

        and make distributions accordingly.

    </p>

    <p>

        We hope that this effort will benefit not only the members of immediate ADAMS community,

        but the members of the entire North American Muslim Community as well. Finally,

        it is Allah who grants success!

    </p>

    <p>

        Note: Zakah should be calculated based on lunar year.

    </p>

    <p>

        You can download the zakah form in Adobe format (pdf) and then print it.You will

        need the Adobe Reader for this. Or, you can complete the zakah form online if you

        have Internet Explorer version 4.0 or greater.

    </p>
')
INSERT INTO [Pages].[Pages] ([PageID], [Title], [Url], [Content]) VALUES (23, N'Community', N'/community', N'content tbd..')
INSERT INTO [Pages].[Pages] ([PageID], [Title], [Url], [Content]) VALUES (24, N'Interfaith', N'/community/interfaith', N'<h1>ADAMS Interfaith</h1>

<p>

ADAMS Interfaith Activites:





<br /><a href="Activities.aspx">Activities</a>



</p>



<p>

ADAMS Interfaith Committee Affiliations

<br /><a href="Relationships.aspx">Relationships</a>

</p>

<p>

For more information please contact

Sr. Farhanahz Ellis at farhanahzellis@yahoo.com 

</p>

')
EXEC(N'INSERT INTO [Pages].[Pages] ([PageID], [Title], [Url], [Content]) VALUES (25, N''Interfaith Activities'', N''/community/interfaith/interfaith-activities'', N''<h1>

        ADAMS Interfaith Activities</h1>

   

<p>

On Sunday September 13, 2009 at 5:30pm ADAMS will hold the 8th Annual Interfaith PEACE Gathering at the ADAMS Center in Sterling, VA, in remembrance of the victims of the World Trade Center and Pentagon attacks. Interfaith groups will be represented and speaking at this event. In addition, we will honor the efforts made this past year by the members of our local Police Departments, Fire Departments, and Interfaith/Civic Organizations. Local Government Officials will also be speaking at this event. Also, this year we begin the effort to take a collection for humanitarian relief charity and we will pass around a collection box to collect donations for the Humanitarian Relief for the Christian Community in Gojra, Pakistan which was affected by extremist mob violence recently. 

<br>

Please RSVP to attend this event at <a href="mailto:rojpm@yahoo.com" target="_blank">rojpm@yahoo.com</a>

<br>

<a href="http://www.adamscenter.org/Media/Articles/ADAMSCondemnsTerrorism.aspx">http://www.adamscenter.org/Media/Articles/ADAMSCondemnsTerrorism.aspx</a>

 

</p>

<p>

        On Fri. June 17, 2005, Br. Mukit Hosain, Sr. Farhanahz Ellis, and Br. Rizwan Jaka

        attended the retirement ceremony dinner of Reverend Roberta Finkelstein at the Universal

        Unitarian Church of Sterling. ADAMS Board of Trustees presented Reverend Roberta

        Finkelstein a plaque in honor of her efforts for PEACE and Justice.

    </p>

    <p>

        On Tue June 14, 2005 Br. Rizwan Jaka, Imam Magid, Br. Sheikh Rashid, Br. Hud Williams,

        Sr. Farhanahz Ellis, Sr. Rahima Ullah, Sr. Uzma Rasheed, Sr Aliyah Khan, Br. Noman

        Khan attended The Interfaith Conference of Washington Bridge Builder Awards at the

        Egyptian Embassy. Awards were presented to Dr. Akbar, Rabbi Lustig, Bishop John

        Chane, and the Egyptian Ambassador to the U.S. Over 250 Interfaith representatives

        attended this wonderful event coordinated by Reverend Clark Lobenstein and Ms. Mona

        Ismail.

    </p>

    <p>

        On Wed Apr 27, 2005 Imam Magid, Br. Sheikh Rashid, Br. Hud Williams, Sr. Nasreen,

        Sr.Shama , and Br. Rizwan Jaka attended a Freedom Seder at The Washington Hebrew

        Congregation. It is a Passover tradition that Washington Hebrew Congregation invites

        Interfaith guests to participate in. It was very nice and educational event.

    </p>

    <p>

        On Tue Apr 5, 2005 ADAMS hosted a tour and program for the Northern Virginia Hebrew

        Congregation Students and Parents. They visited ADAMS, asked many questions and

        observed Maghrib Prayer. Br. Hud Williams(ADAMS Youth Director) hosted them. Sr.

        Farhanahz(ADAMS Interfaith Chair) Coordinated the event. The ADAMS Center and Imam

        Magid has an longstanding working relationship and friendship with The Northern

        Virginia Hebrew Congregation.

    </p>

    <p>

        On Sunday Mar 13, 2005 ADAMS Hosted a Church group from Mclean, VA

    </p>

    <p>

        On March 06, 2005 the Reston Trialogue, (All Dulles Area Muslim Society(ADAMS),

        Northern Virginia Hebrew Congregation and St. Thomas ?? Beckett) held an Interfaith

        Panel about "The Role of Women in Judaism, Catholicism and Islam" The event took

        place at the ADAMS center from 7:00 p.m. to 9:00 p.m. This event marked Women''''s

        History Month which is March. This is a part of a two year-long ongoing Interfaith

        Trialogue that started in 2003. Over 140 Christians, Jewish, and Muslims attended

        the event. Speakers Included: Ms Uzma Unus, ADAMS Vice President, Ms. Farhanahz

        Ellis, Chair of ADAMS Interfaith Committee, Rabbi Gold of Northern Virginia Hebrew

        Congregation, Father Thomas of St. Thomas ?? Beckett Church

    </p>

    <p>

        On Sun Jan 16, 2005 ADAMS members attended and spoke at an Interfaith Opera Fundraiser

        f'')')
EXEC(N'DECLARE @pv binary(16)
'+N'SELECT @pv=TEXTPTR([Content]) FROM [Pages].[Pages] WHERE [PageID]=25
UPDATETEXT [Pages].[Pages].[Content] @pv NULL NULL N''or Tsunami Relief Hosted at the Washington Hebrew Congregation. Speakers included

        Rabbi Lustig and Rizwan Jaka It was sponsored by Washington Hebrew Congregation,

        Episcopal Diocese of Washington & Washington National Cathedral, and All Dulles

        Area Muslim Society (ADAMS Center). Over $10,000 was raised for Tsunami Relief

    </p>

    <p>

        Sunday, December 5th, 2004 ADAMS hosted the Northern Virginia Women''''s Interfaith

        Fellowship Quartely Meeting

    </p>

    <p>

        Wednesday Nov 24, 2004 ADAMS Participated in 2 Thanksgiving Eve Interfaith Gatherings

    </p>

    <p>

        - United Christian Parish, All Dulles Area Muslim Society(ADAMS), Northern Virginia

        Hebrew Congregation, Washington Plaza Baptist Church, and more got together at the

        United Christian Parish in Reston for an Interfaith Gathering marking Thanksgiving.

    </p>

    <p>

        - Adat Reyim Synagogue, Burke Presbyterian Church, and All Dulles Area Muslim Society(ADAMS)

        got together at the Adat Reyim Synagogue in Springfield, VA for the 2nd Annual Interfaith

        Gathering marking Thanksgiving.

    </p>

    <p>

        Sunday November 7th, 2004 ADAMS Hosted and Interfaith Ramadan Iftar Gathering. Representatives

        of the Christian, Jewish, and Muslim Community spoke and attended the event. Reverend

        Clark Lobenstein of the Interfaith Conference was the Keynote Speaker. Here is an

        article in the Times Community Newspaper that summarizes the event: Please Click

        Here . The event was also covered byt he Loudoun Connection in a full color spread

        , WTOP News, and Fox 5.

    </p>

    <p>

        Sunday Oct 17, 2004 Interfaith Trialogue A Discussion Sponsored by Jews, Catholics,

        and Muslims The Topic was The Impact of Faith on Public Policy. Sponsors and Speakers

        from: Northern Virginia Hebrew Congregation, St. Thomas ?? Becket Catholic Church,

        and the All Dulles Area Muslim Society

    </p>

    <p>

        Saturday, September 11, 2004, members of the ADAMS Center conducted and took part

        in many interfaith activities. ADAMS held an Interfaith PEACE dinner at the ADAMS

        Center in Sterling, VA, in remembrance of the victims of the horrible tragedies

        at the World Trade Center and Pentagon attacks. Representatives of Christian, Jewish,

        and Sikh Faiths were be represented and spoke at this event. ADAMS also honored

        Local Police and Fire Departments for their continuous community service. Local

        Government Officials spoke at this event. The ADAMS community also participated

        in an Interfaith Housing Project for the Homeless in Washington DC on Sat Sept 11,

        2004 from 8am to 4:30pm. In addition, ADAMS participated in the Interfaith Vigil

        at Fairfax County Government Center and with the Northern Virginia Interfaith Vigil

        overnight.

    </p>

    <p>

        August 25th, 2004 ADAMS participated in an Interfaith Prayer Vigil at the Unitarian

        Universalists of Sterling Church for the victims of the humanitarian crisis in Darfur

    </p>

    <p>

        Aug 2, 2004, the ADAMS Center hosted Children''''s Friendship Project for Northern

        Ireland. The main goal of this program is to provide the kids with leadership tools

        they can use to promote Peace, Respect and Tolerance, wherever they are. The teens

        get to know each other as individuals and establish relationships.

    </p>

    <p>

        July 17, 2004 ?? ADAMS Interfaith Committee coordinated an Around the World Festival

        and invited Interfaith Community and ADAMS Neighbors for a day of fun and food.

    </p>

    <p>

        June 1, 2004 ?? ADAMS, United Christian Parish, and a Jewish Congreation held and

        Interfaith event for PEACE, Tolerance, and Respect with speeches and Interfaith

        songs at the United Christian''
UPDATETEXT [Pages].[Pages].[Content] @pv NULL NULL N'' Parish in Reston, VA

    </p>

    <p>

        May 16, 2004 - ADAMS Interfaith Committee setup a women''''s dialogue with Etz Hayim

        Jewish Synagogue.

    </p>

    <p>

        Apr 25, 2004 - ADAMS, Burke Presbyterian Church , and Adat Reyim Synagogue hold

        an Interfaith concert at burke Presbyterian to raise funds for the needy in Afghanistan

    </p>

    <p>

        Mar 28, 2004 - Women??s History and Hertiage Interfaith Discussion

    </p>

    <p>

        Feb 14, 2004 - ADAMS Black History Month Festival

    </p>

    <p>

        Jan 11, 2004 - Trialogue, ?Life After Death In The Three Abrahamic Traditions?

    </p>

    <p>

        Nov 22, 2003 Interfaith Iftar in the Combo Room witrh over 15 Interfaith Leaders

        from 9 Congregations of Christians and Jewish Communities in the DC Metro area.

        The program was coordinated by the ADAMS Interfaith Committee

    </p>

    <p>

        Nov 15, 2003 ?? Northern Virginia Women??s Interfaith Group Montly Meeting at

        the ADAMS Center

    </p>

    <p>

        Oct 3, 2003 - Inter-religious and Interantional Federation for World Peace Conference

    </p>

    <p>

        Sept 11, 2003 Interfaith PEACE Event at ADAMS with members of Muslims, Christian

        and Jewish communties

    </p>
''
')
EXEC(N'INSERT INTO [Pages].[Pages] ([PageID], [Title], [Url], [Content]) VALUES (26, N''Interfaith Relationships'', N''/community/interfaith/interfaith-relationships'', N''<h1>

        Interfaith Relationships

    </h1>

    <p>

        ADAMS works with United Christian Parish Reston , St, Annes Church, Trinity Presbyterian

        Church, Universal Unitarians of Sterling, Northern Viginia Hebrew Congrengation,

        Adat Reyim Synagogue in Burke, St. Andrew''''s Episcopal Church at Burke, Congregation

        Etz Hayim, Shoreshim Jewish Congregation, Universal Unitarians of Leesburg, Washington

        Plaza Baptist Church, Reston Interfaith, Interfaith Conference of Metropolitan Washington

        and more

    </p>

    <h3>

        ADAMS Interfaith Affiliations

    </h3>

    <p>

        Fairfax Faith Communities in Actionâ€”Interfaith organization that coordinates activities

        with people of faith regarding social service and community volunteerism. Established

        by Sharon Boulevard Supervisor, people from different churches, community of faith

        and other non-profit organizations. Share resources through training, facilities

        and programs of social services. ADAMS is Member of steering committee who established

        the structure and interviewed and hired the county employees working in the Interfaith

        Liaison Office. ADAMS Center participated in 3 annual conferences by donating money

        and food and assisted with the logistics and planning. A good network of faith communities,

        non-profit organizations and local officials. Serving currently as the chairperson

        of the Tolerance and Respect task force. The purpose of the committee is to promote

        dialog between faith communities in Fairfax County. Currently, there are 2 dialog

        groups, Mclean and Annandale. 2 successful intercommunity dialogs in Mclean and

        Annandale from which 2 committees have been established. The Tolerance committee

        will be meeting on April 15, 2004 at the ADAMS Center. This Fairfax Faith committee

        meets once monthly every second Wednesday of the month at 2pm. The task force meets

        monthly, plus the local dialog meetings.

    </p>

    <p>

        Fairfax Youth Partnership Nonprofit organization in charge of youth programs and

        after-school activities. Their office is located in the Government Building in Fairfax

        County. Role: approve budgets, programs, member of committee (After-School Committee)

        which meets once a month.

    </p>

    <p>

        Interfaith Conference of Metropolitan Washington - <a href="http://www.ifcmw.org">http://www.ifcmw.org

        </a>

    </p>

    <p>

        Trialogue of Reston - Involves ADAMS Center, Northern VA Hebrew Congregation, and

        the Catholic Church in Reston. Once a year, a trialogue is held and requires three

        annual meetings for planning. The purpose is to improve the understanding of the

        three major religionâ€™s values and beliefs as well as to promote tolerance between

        the three congregations. ADAMS Center hosted the last trialog about life after death.

        Planning of the trialog will be passed to the chairperson of the Interfaith committee.

    </p>

    <p>

        George Mason University Campus Ministry - Provides guidance and helps students of

        different faiths on campus. This is a professional organization, run by Clergies.

        The representatives of the particular faith are liaisons between the students and

        the clergy. ADAMS Center is the sponsoring organization for the Muslim Campus Ministry.

        The Campus Ministry meets monthly on the 2nd Tuesday at 1pm at GMU. The rest of

        that day is spent at the University to establish a better relationship with the

        University.

    </p>

    <p>

        Interfaith of Burke Community - Burke Presbyterian Church, Adat Reyim Synagogue,

        and ADAMS Center are involved in many interfaith projects (Thanksgiving gathering,

        lecture the author Lauren Blumenfeld of the book â€œRevenge, '')')
SELECT @pv=TEXTPTR([Content]) FROM [Pages].[Pages] WHERE [PageID]=26
UPDATETEXT [Pages].[Pages].[Content] @pv NULL NULL N'A Story of Hopeâ€

        and currently working on fundraising activity with the Jewish, Christian and Muslim

        Communities). On the 25th of April, there is an Interfaith concert scheduled, where

        Native Deen is to perform.

    </p>

    <p>

        NVA Interfaith Womenâ€™s Group â€“ Ongoing dialogue and meetings between Interfaith

        women from ADAMS, Virginia Presbyterian Chirch, St Annes Church, Sikh Community,

        and other

    </p>

    <p>

        Interfaith Community and Learning Center Project- ADAMS and United Christian Parish

    </p>

    <p>

        Representative on the Board of Reston Interfaith which runs the Reston Homeless

        Shelter.

        <br />

        <a href="http://www.restoninterfaith.org">http://www.restoninterfaith.org</a>

    </p>

    <p>

        Womens Dialgoue with Congregation Etz Hayim

    </p>
'
EXEC(N'INSERT INTO [Pages].[Pages] ([PageID], [Title], [Url], [Content]) VALUES (27, N''Civic'', N''/community/civic'', N''<h1>

        Civic</h1>

    <p>

        <a href="../Media/PressReleases/GovernmentElectionStatement.aspx">Government Election Statement</a>

    </p>

    <p>

        ADAMS Center is committed to civic involvement and participation. ADAMS works closely

        with our elected government officials and law enforcement. Below is a summary of

        some our activities.

    </p>

    <p>

        On Wed Mar 30, 2005 ADAMS participate in a FBI town Hall Meeting in Falls Church

    </p>

    <p>

        On Fri Mar 18, 2005 at 7pm, The Fairfax County Board of Supervisors honored the

        Legacy of Ms. Sharifa AlKhateeb, Community Activist and Leader at the ADAMS Center,

        because Ms. AlKhateeb dedicated so much of her community life to benefiting Fairfax

        County.

    </p>

    <p>

        Br. Rizwan Jaka, President of ADAMS, introduced the Board of Supervisors and talked

        about th legacy of Sr. Sharifa Al-Khateeb.

        <br />

        Fairfax County Supervisor Chairman Gerry Connolly and Mason District Supervisor

        <br />

        Penny Gross came to ADAMS Center and delivered the Proclamation

        <br />

        Plaque to the family of Sr. Sharifa Al-Khateeb.

        <br />

        Sr. Farhanahz, ADAMS Interfaith Chairperson, read a letter from Dr. Reverend Clark

        Lobenstein of the Interfaith conference.

        <br />

        Sr. Maha AlKhateeb Thanked everyone and also said a few words, as well.

        <br />

        Imam Magid closed of the event with some final thoughts and dua.

    </p>

    <p>

        On Sat Jan 15, 2005 ADAMS Hosted Br. Abdullah Al-Zuabi from the Arab American Institute

        (James Zogby''''s organization) to speak to the youth and ADAMS local Eid Team about

        the civic process. CNN covered the event.

    </p>

    <p>

        October 2004 and November 2004 - ADAMS was instrumental in a Get Out the Vote Campaign.

        ADAMS had sermons, speeches, and emails to encourage people to get out to vote.

        ADAMS Participated and had several voter registration drives, as well. ADAMS invited

        and had candidates from all parties to speak to the congregation at Friday Prayers

        and our Fall Festival ADAMS activities were covered by ABC News and Nightline.

    </p>

    <p>

        Tuesday Oct 26, 2004 - ADAMS coordinated and hosted a Ramadan Iftar with Local DC

        Metro Area FBI Leadership

    </p>

    <p>

        Sunday Oct 17, 2004 Interfaith Trialogue A Discussion Sponsored by Jews, Catholics,

        and Muslims The Topic was The Impact of Faith on Public Policy. Sponsors and Speakers

        from: Northern Virginia Hebrew Congregation, St. Thomas Ã Becket Catholic Church,

        and the All Dulles Area Muslim Society

    </p>

    <p>

        Sat Aug 14, 2004- 4th Annual Northern Virginia Family and Civic Picnic at Lake Fairfax.

        All candidates running for elected and current government official are invited to

        a BBQ and Carnival with the community.We had a wonderful 4th Annual Family and Civic

        Picnic.

    </p>

    <p>

        We had almost 300 people come out throughout the day. We had speeches, food, and

        fun. We had a moon bounce and games for the kids. We thank the community for attending

        this even with the weather. We thank all the volunteers.

    </p>

    <p>

        We had speeches from 3 MC''''s, 3 Congressional Candidates, 2 Presidential Campaigns,

        2 Board of Supervisors, 1 VA State Delegate, 2 School Board Members, 1 town Council

        Member, 2 Imams, 2 Christian Pastors, 1 Interfaith activist, a Boys Scout, and 7

        Sponsor Representatives.

    </p>

    <p>

        Sat July 10, 2004 - National Lawyers Guild and CAIR MD & VA help a Civil Rights

        forum at the ADAMS Center

    </p>

    <p>

        Monday May 17, 2004 - ADAMS Girl Scouts Brownies and Daisies take part in Flag Ceremony

        at the Daughte'')')
SELECT @pv=TEXTPTR([Content]) FROM [Pages].[Pages] WHERE [PageID]=27
UPDATETEXT [Pages].[Pages].[Content] @pv NULL NULL N'r''s of the American Revolution Consitutional Hall for the 50th Anniversary

        of Brown Vs. Board of Education Supreme Court Case that led to de-segregation of

        schools in America

    </p>

    <p>

        Tue May 11, 2004 -ADAMS hosted local Muslim Leader''s dinner meeting with the FBI.

    </p>

    <p>

        Sun May 9, 2004 - Million Mom March- ADAMS and Masjid Muhammad partnered to sponsor

        and support the Million Mom March.

    </p>

    <p>

        Sat May 8, 2004 - ADAMS Hosted a seminar with Department of Homeland Security and

        other government agencies

    </p>

    <p>

        Dec 12, 2003 - ADAMS and MPAC Hosted a Town Hall meeting with FBI

    </p>
'
EXEC(N'INSERT INTO [Pages].[Pages] ([PageID], [Title], [Url], [Content]) VALUES (28, N''Community Service'', N''/community/community-service'', N''<h1>

        Community Service</h1>

    <p>

        ADAMS is involved in many community service activities to help the less fortunate

        and the environment.

    </p>

    <p>

        ADAMS Community Service is led by ADAMS Community Service Committee, Muslim Sports

        League(MSL), ADAMS youth, and ADAMS Members

    </p>

    <p>

        1) Every Month ADAMS Members join FoodSource Foundation in food preparation for

        the less fortunate

    </p>

    <p>

        2) ADAMS is on the Board of Reston Interfaith Shelter

    </p>

    <p>

        Jun 6. 2005 - The All Dulles Area Muslim Society(ADAMS) and Al-Fatih Academy supports

        National Hunger Awareness Day. The ADAMS Community and Al-Faith Academy coordinated

        a Canned Food Drive and will donate canned food to a local shelter. ADAMS Community

        members and Al-Faith Academy students will also be participating in the â€œ Hunger

        No More: An Interfaith Convocationâ€ at Washington National Cathedral, on Monday,

        June 6, 2005, 7:00 pm.

    </p>

    <p>

        Sat May 21, 2005 The A-Team, a group of 15 Sisters from ADAMS Center, participated

        in the Reston Relay for Life. The relay is sponsored by the American Cancer Society

        to raise funds for research towards finding a cure for cancer. The day began at

        10 am at South Lakes High School, setting up our campsite and pitching our tents.

        The opening ceremonies began at 1pm. The relay began at 2 pm, with each team member

        walking 45 minute shifts around the track. In the evening, the A-Team hosted a henna

        table, and we raised $100 doing henna designs for Relay participants. The great

        news is that the A-Team, through your support and generosity, raised over $4,170

        for the American Cancer Society.

    </p>

    <p>

        Nov 20-30, 2004 - ADAMS helped with a FAITH( www.faithus.org ) led effort to raise

        money and buy over 240 coats for the Day Laborers and their families in Herndon.

        The project was called "Warmth for the Winter" FAITH also organized a Thanksgiving

        Dinner for the Day Laborers and their families.

    </p>

    <p>

        Day laborers receive Winter Coats Muslim community offer â€œWarmth for the Winterâ€

        <br />

        <a href="http://www.connectionnewspapers.com/article.asp?article=43204&paper=66&cat=104">

            http://www.connectionnewspapers.com/article.asp?article=43204&paper=66&cat=104</a>

    </p>

    <p>

        Faith groups unite for those in need:

        <br />

        <a href="http://www.connectionnewspapers.com/article.asp?article=43199&paper=66&cat=104">

            http://www.connectionnewspapers.com/article.asp?article=43199&paper=66&cat=104</a>

    </p>

    <p>

        Nov 14, 2004 - ADAMS and the DC Eid Committee collected Food for the Homeless at

        the Eid Celebration and donated it to a Homeless Shelter

    </p>

    <p>

        Oct/Nov 2004 - ADAMS MSL volunteers helped in feeding the homeless in Washington

        DC.

    </p>

    <p>

        Oct/Nov 2004 - ADAMS Daisy and Brownie Troops conducted a Baby Bundles project to

        collect new items for babies to help 12 families in need

    </p>

    <p>

        Oct/Nov 2004 - ADAMS MSL group coordinated an Eid Toy Drive to collect Toys for

        children of families in need.

    </p>

    <p>

        Oct 28, 2004 - ADAMS Members along with Food Source Foundation help prepare and

        distribute meals among the homeless. The food preparation took place at the Fairfax

        Presbyterian Church.

    </p>

    <p>

        Oct 8, 2004 ADAMS and National Kidney Foundation offered Kidnet Risk Screening at

        ADAMS

    </p>

    <p>

        September 11, 2004 - The ADAMS community also participated in an Interfaith Housing

        Project for the Homeless in Washington DC from 8am to 4:30pm.

    </p>

    <p>

        Septe'')')
SELECT @pv=TEXTPTR([Content]) FROM [Pages].[Pages] WHERE [PageID]=28
UPDATETEXT [Pages].[Pages].[Content] @pv NULL NULL N'mber 5, 2004 - ADAMS encourages the community to donate to victims of Hurricane

        Charley and Frances thru the American Red Cross

    </p>

    <p>

        August 25, 2004 - Two Girl Scouts from ADAMS Center were chosen to represent the

        Girl Scout Annual School Supplies Drive television promotions, in connection with

        Channel 9 CBS (WUSA), Safeway, and SunTrust Bank! The girls arrived at SunTrust

        HQ Branch in Washington, DC and taped two short 30 segments with Topper Shutt, the

        CBS Meterologist.

    </p>

    <p>

        August 21/22, 2004 - ADAMS Sponsors the HDCC Tennis Tournament benefiting the Charity

        Organization Vecinos Unidos/United Neighbors, Inc . Vecinos Unidos/United Neighbors,

        Inc . organization is dedicated to making the future brighter for Herndon children.

        Their mission is to assist and support children who are targeted for failure in

        our society. The approach chosen to accomplish this was to provide a safe and non-intimidating

        community outreach office that offered walk-in homework assistance, computer resources

        and educational assistance. For more information: http://www.cascadestech.com/tennis/

    </p>

    <p>

        August 2004 - ADAMS MSL will be going down to the DC Central Kitchen. Our task is

        to assist the kitchen with cooking food for about 20-30 local shelters that serve

        around 500 - 1000 people. We''ll be going on August 8 2004 from 9:00 AM to 12:00

        PM. We have reserved space for 15 volounteers.

    </p>

    <p>

        August 2004 - ADAMS MSL will be going down to the DC Central Kitchen. Our task is

        to assist the kitchen with cooking food for about 20-30 local shelters that serve

        around 500 - 1000 people. We''ll be going on August 8 2004 from 9:00 AM to 12:00

        PM. We have reserved space for 15 volounteers.

    </p>

    <p>

        July 2004 - ADAMS MSL cooked and served dinner to 30 people at St. Timothy''s Episcopal

        Church in Reston, VA. They hold a program there called "Nurturing Parenting Program"

        it''s a FAITH based program and we have signed up to serve dinner and assist w/ baby

        sitting for this weeks session.

    </p>

    <p>

        June 2004 - ADAMS MSL helped renovate a shelter in Arlington. Our group was responsible

        for renovating a kitchen and a bedroom in the shelter.

        <br />

        <a href="http://www.geocities.com/muslimsportsleague/shelterpics.htm">http://www.geocities.com/muslimsportsleague/shelterpics.htm</a>

    </p>

    <p>

        May 2004 - ADAMS Members along with Food Source Foundation help prepare and distribute

        meals among the homeless on Thursday, 27 May. The food preparation took place at

        the Fairfax Presbyterian Church.

    </p>

    <p>

        - ADAMS MSL and Brothers Youth collected T-Shirts for the Homeless

    </p>

    <p>

        April 2004 - Two sisters from the ADAMS Center walked in a 40 mile to raise awareness

        and funds to find a cure for breast cancer through the Avon Foundation.

    </p>

    <p>

        - ADAMS MSL and Brothers Youth collected Sweat Pants for the Homeless

    </p>

    <p>

        - ADAMS Community Service Committee takes part in the 16th Annual Potomac River

        Watershed Cleanup

    </p>

    <p>

        March 2004 - ADAMS Community Servce Committee takes part in Stream & Runnymeade

        Park Cleanup

    </p>
'
INSERT INTO [Pages].[Pages] ([PageID], [Title], [Url], [Content]) VALUES (29, N'New Muslim Support Group', N'/community/new-muslim-support-group', N'<h1>

        ADAMS New Muslim Support Group</h1>

    <p>

        Co-Chairs Sr. Misbah Javaid and Sr. Farhanahz Ellis

    </p>

    <p>

        This is a welcoming group for new muslims. Our goal is to help new muslims learn

        the basics of the Faith and find support and friends in the Faith. We are a family

        friendly group and kids are welcome!!

    </p>

    <h3>

        Islam 101 - Every Thursday</h3>

    <p>

        Islam 101

        <br />

        Category: Organizational Events

        <br />

        Contact: learn_islam@adamscenter.us

        <br />

        Location: Youth Room at the Third Level

        <br />

        Date/Time

        <br />

        Every Thursday, at 7:00 PM

        <br />

        Details

        <br />

        Announcing: Islam 101

        <br />

        Thursdays (Starting MAY 10th) - 7:00 PM - 8:30 PM - ADAMS Center

    </p>

    <p>

        This class will introduce, discuss, and answer questions on a wide range of topics

        related to the beliefs and practices of Islam. Topics will include: Articles of

        faith, Pillars of Islam, Quran, Life of Prophet Muhammad (SAW), Sunnah and ahadith,

        Relationship with other religions, Family/social life, Culture and Islam, etc. This

        course is appropriate for new Muslims, Muslims who wish to expand their existing

        knowledge, and non-Muslims interested in learning more about Islam. All are welcome.

    </p>

    <h3>

        Salat Class</h3>

    <p>

        Prayer Class

        <br />

        Contact: khalid_iqbal1@hotmail.com

        <br />

        Location: Prayer Room

        <br />

        Date/Time: By request

        <br />

        Details

        <br />

        Announcing: Salat Class

        <br />

        This class is provided to anyone who would like to learn how to pray. It will be

        held on an as needed basis. To request a session, email Khalid Iqbal at khalid_iqbal1@hotmail.com.

    </p>

    <h3>

        Quran Class</h3>

    <p>

        Basic Quran

        <br />

        Contact: learn_islam@adamscenter.us

        <br />

        Date/Time

        <br />

        Every Wednesday, at 7:00 PM

        <br />

        Details

        <br />

        Announcing: Quran Class for Beginners

    </p>

    <p>

        A ''Basics of Reading Quran'' class will be every Wednesday at 7pm. This class will

        teach Arabic letters, formation of words, and initial verses of the Quran in Arabic.

        Tutors are also available if you miss a class.

    </p>
')
INSERT INTO [Pages].[Pages] ([PageID], [Title], [Url], [Content]) VALUES (30, N'Media', N'/media', N'content tbd...')
EXEC(N'INSERT INTO [Pages].[Pages] ([PageID], [Title], [Url], [Content]) VALUES (31, N''ADAMS in the News'', N''/media/adams-in-the-news'', N''<h1>

        Articles on the All Dulles Area Muslim Society(ADAMS)</h1>

    <p>

        July 23, 2005 Around the World Festival

        <br />

        <a href="http://www.timescommunity.com/site/tab1.cfm?newsid=14926655&BRD=2553&PAG=461&dept_id=506035&rfi=6">

            http://www.timescommunity.com/site/tab1.cfm?newsid=14926655&BRD=2553&PAG=461&dept_id=506035&rfi=6</a>

    </p>

    <p>

        Jul 22 ADAMS Friday Prayer forcuses on PEACE and Condemning Terrorism:

        <br />

        <a href="http://www.wusatv9.com/news/news_article.aspx?storyid=41511">http://www.wusatv9.com/news/news_article.aspx?storyid=41511</a>

        <br />

        <a href="http://www.washingtontimes.com/metro/20050722-112719-3561r.htm">http://www.washingtontimes.com/metro/20050722-112719-3561r.htm</a>

    </p>

    <p>

        July 12, 2005 ADAMS helps in Interfaith effort to help Day Laborers:

        <br />

        <a href="http://www.washingtonpost.com/wp-dyn/content/article/2005/07/12/AR2005071200048.html">

            http://www.washingtonpost.com/wp-dyn/content/article/2005/07/12/AR2005071200048.html</a>

    </p>

    <p>

        June 6, 2005 The All Dulles Area Muslim Society and Al-Fatih Academy supported and

        participated in National Hunger Awareness Day

        <br />

        <a href="http://www.zwire.com/site/news.cfm?newsid=14695851&BRD=2553&PAG=461&dept_id=507243&rfi=8">

            http://www.zwire.com/site/news.cfm?newsid=14695851&BRD=2553&PAG=461&dept_id=507243&rfi=8

        </a>

    </p>

    <p>

        Thu Apr 14, 2005 - Imam Magid organizes singles retreat for marriage-minded

        <br />

        <a href="http://www.dcexaminer.com/articles/2005/04/14/features/faith/95faith14companionships.txt">

            http://www.dcexaminer.com/articles/2005/04/14/features/faith/95faith14companionships.txt</a>

    </p>

    <p>

        On Fri Apr 8, 2005 - ADAMS Hosted CNN as they are doing a piece on Islamic Financing.

        They interviewed Br. Shirin Elkoshairi(ADAMS Media Relations Co-chair), Br. Hud

        Williams(ADAMS Youth Director), and Br. Sheikh Rashid Lamptey(ADAMS Deputy Imam)

    </p>

    <p>

        Apr 2, 2005: The All Dulles Area Muslim Society(ADAMS) would like to express our

        deepest sympathies to the Catholic Community for the loss of Pope John Paul II

        <br />

        <a href="http://www.connectionnewspapers.com/article.asp?article=48715&paper=61&cat=110">

            http://www.connectionnewspapers.com/article.asp?article=48715&paper=61&cat=110</a>

    </p>

    <p>

        <a href="http://www.timescommunity.com/site/tab1.cfm?newsid=14290101&BRD=2553&PAG=461&dept_id=506035&rfi=6">

            http://www.timescommunity.com/site/tab1.cfm?newsid=14290101&BRD=2553&PAG=461&dept_id=506035&rfi=6</a>

    </p>

    <p>

        <a href="http://www.easterner.com/news.htm#muslims">http://www.easterner.com/news.htm#muslims

        </a>

    </p>

    <p>

        March 29, 2005 Note on Fairfax County Board of Supervisors Honoring Sr. Sharifa

        AlKhateeb at the ADAMS Center <a href="http://www.timescommunity.com/site/news.cfm?newsid=14245698&BRD=2553&PAG=461&dept_id=507243&rfi=8">http://www.timescommunity.com/site/news.cfm?newsid=14245698&BRD=2553&PAG=461&dept_id=507243&rfi=8</a>

    </p>

    <p>

        March 24, 2005 - Article about Fairfax County Board of Supervisors Honoring Sr.

        Sharifa AlKhateeb at the ADAMS Center

        <br />

        <a href="http://www.connectionnewspapers.com/article.asp?article=48027&paper=67&cat=104">

            http://www.connectionnewspapers.com/article.asp?article=48027&paper=67&cat=104

        </a>

    </p>

    <p>

        March 17, 2005 On March 6, the Reston Trialogue Ã‘ All Dulles Area Muslim Society

        (ADAMS), Northern Virginia Hebrew Congregation and St. Thomas Ë† Beckett Ã‘ held

        an Interfaith Panel about "The Role of Women in Judaism, Catholicism and Islam."

        <br />

      '')')
SELECT @pv=TEXTPTR([Content]) FROM [Pages].[Pages] WHERE [PageID]=31
UPDATETEXT [Pages].[Pages].[Content] @pv NULL NULL N'  <a href="http://www.connectionnewspapers.com/article.asp?article=47825&cat=111">http://www.connectionnewspapers.com/article.asp?article=47825&cat=111

        </a>

    </p>

    <p>

        Mar 11, 2005 Muslim Imams Condemn Terrorism

        <br />

        <a href="http://www.washtimes.com/metro/20050310-105612-1198r.htm">http://www.washtimes.com/metro/20050310-105612-1198r.htm

        </a>

    </p>
'
INSERT INTO [Pages].[Pages] ([PageID], [Title], [Url], [Content]) VALUES (32, N'Media Center', N'/media/media-center', N'<h1>

        ADAMS Media Center

    </h1>

    <p>

        <a href="../../AboutUs/Default.aspx">Informaton About ADAMS</a>

    </p>

    <p>

        <a href="../Articles/Default.aspx" id="ctl00_ctl00_ctl00_cphContent_cphContent_cphContent_A1">Articles about The All Dulles

            Area Muslim Society(ADAMS)</a>

    </p>

    <p>

        <a href="../PressReleases/Default.aspx" id="ctl00_ctl00_ctl00_cphContent_cphContent_cphContent_A2">Press Releases from The

            All Dulles Area Muslim Society(ADAMS)</a>

    </p>

    <p>

        <a href="../../Community/Interfaith/Default.aspx" id="ctl00_ctl00_ctl00_cphContent_cphContent_cphContent_A3">ADAMS Interfaith

            Activities</a>

    </p>

    <p>

        <a href="../../Community/Civic.aspx" id="ctl00_ctl00_ctl00_cphContent_cphContent_cphContent_A4">

            ADAMS Government Relations</a>

    </p>

    <p>

        <a href="../../Community/CommunityService.aspx" id="ctl00_ctl00_ctl00_cphContent_cphContent_cphContent_A5">ADAMS Community Service</a>

    </p>

    <p>

        <a href="../Articles/ADAMSCondemnsTerrorism.aspx" id="ctl00_ctl00_ctl00_cphContent_cphContent_cphContent_A6">The All Dulles

            Area Muslim Society (ADAMS), along with other Muslim organizations throughout North

            America, strongly condemn and reject the actions of terrorists and terrorism.</a>

    </p>

    <p>

        For Media Inquiries please call 703-433-1325 x-103 or mobile: 571-217-9286
        <br />

        <a href="MediaRequestForm.pdf">Please click here and fill out this form for media inquiries</a>

    </p>
')
INSERT INTO [Pages].[Pages] ([PageID], [Title], [Url], [Content]) VALUES (33, N'Inclement Weather Policy', N'/information/inclement-weather-policy', N'<h1>

        Inclement Weather Policy</h1>

<p>

ADAMS will strive to remain open for all prayers and activities insha''Allah.  Should reasonably harsh weather force premature closure of the Center and its activities (including prayer) please do the following to confirm:

</p>

<p>                       

1)     CALL your program head to see if your activity is rescheduled for another day or canceled.

<br/>

2)    CALL the ADAMS Main Line at 703.433.1325 and listen to the recording to hear program cancellation information.
<br/>

3)    Please check ADAMS website www.adamscenter.org for updates.

 <br/>

4) Please check for email updates through ADAMS yahoogroup emails.

 

 </p>

<p>

Insha''Allah following these four steps will help us ensure safety and security of the community and the center.

    

</p>
')
EXEC(N'INSERT INTO [Pages].[Pages] ([PageID], [Title], [Url], [Content]) VALUES (34, N''Legal Notice'', N''/information/legal-notice'', N''<h1>

        Legal Notice</h1>

    <p>

        Legal Notice Copyright ©

        2011

        ADAMS Center. All rights reserved.

        <br />

        Please review the following terms and conditions prior to using ADAMS Center''''s website

        (the website). Any use of the web site and its content is subject to the following

        terms and conditions. Your use of the web site indicates your acceptance of said

        terms and conditions. If you do not accept such terms and conditions you may not

        use the web site and it''''s content.

    </p>

    <h2>

        ACCEPTANCE OF TERMS</h2>

    <p>

        ADAMS Center and the ADAMS Center logo are trademarks of ADAMS Center Organization

        (ADAMS Center), a limited liability company registered in and subject to the laws

        of United States. ADAMS Center may, at its sole discretion, choose to change the

        terms, conditions and operation of this Website at any time without prior notice.

        By using this service the user waives any rights or claims it may have against ADAMS

        Center. Consequently, by accessing, browsing and/or using the Website you acknowledge

        to have read, understood and agreed to be bound by these terms. By using the Website

        you have agreed to these terms. You may not alter, change, modify or adapt the Website

        in any way.

    </p>

    <h2>

        TRADEMARKS</h2>

    <p>

        The trademarks, service marks, and logos (the Trademarks) used and displayed on

        the Website are either the Trademarks or the registered Trademarks of ADAMS Center.

        Other product and company names mentioned on this Website may be the trademarks

        or registered trademarks of their respective owners.

    </p>

    <h2>

        LIMITATION OF LIABILITY</h2>

    <p>

        Except as specifically stated on the Website, neither ADAMS Center nor any of its

        directors, employees or other representatives shall be liable for damages arising

        out of or in connection with the use of the Website. This is a comprehensive limitation

        of liability that applies to all damages of any kind, including, but not limited

        to, compensatory, direct, indirect or consequential damages, loss of data, income

        or profit, loss of or damage to property and claims of or related to third parties.

    </p>

    <p>

        Information on this Website may contain inaccuracies or typographical errors for

        which ADAMS Center takes no responsibility.

    </p>

    <p>

        ADAMS Center does not make any representations for other websites that you may access

        through this Website. While ADAMS Center has no control over web sites produced

        and authored by third parties, ADAMS Center declines all liability for the accessibility,

        content and use as well as the products, services, that are made available through

        such third party''''s web site.

    </p>

    <p>

        Under no circumstance shall ADAMS Center be liable to any party for any direct,

        indirect, special or other consequential damages for any use of the web site, or

        any other hyperlinked web site, including, but not limited to, any lost profits,

        business interruption, loss of programmes or other data or similar, even if we have

        been expressly advised as to the possibility of such damages.

    </p>

    <p>

        Information on the web site is provided "as is" without warranty of any kind, either

        express or implied, including, but not limited to, the implied warranties of merchantability,

        fitness for a particular purpose, or non-infringement. Some jurisdictions do not

        allow the exclusion of implied warranties, so the above exclusion may not apply

        to you.

    </p>

    <p>

        All prices are in US Dollars (UDS) unless otherwise indicated.

        Prices and specifications are subject to change'')')
SELECT @pv=TEXTPTR([Content]) FROM [Pages].[Pages] WHERE [PageID]=34
UPDATETEXT [Pages].[Pages].[Content] @pv NULL NULL N' without notice.

    </p>

    <p>

        If you have any questions about this legal notice, please refer to the contact us page.

    </p>
'
INSERT INTO [Pages].[Pages] ([PageID], [Title], [Url], [Content]) VALUES (35, N'Contact Us', N'/contact-us', N'<h1>

        ADAMS Center Contacts</h1>

    <h2>

        Administration</h2>

    <p>

        Phone and Fax:

        <br />

        Main Line: 703-433-1325 ext 101 - Administration
        <br />

        Line 2: 703-404-0745 ext 101 - Administration
        <br />

        Fax: 571-434-8611
        <br /> 

        <a href="http://helpdesk.adamscenter.us" target="_blank">Give Suggestion</a>

<br />        <a href="http://helpdesk.adamscenter.us" target="_blank">Request a Service</a>



    </p>

    <p>

        <h3>

            Deputy Director/Chief Operating Officer</h3>

        Br. Khalid Iqbal

        <br />

        703-433-1325 ext. 103
        <br />

        Mobile: 202-439-5432
        <br />

        deputydirector@adamscenter.us

    </p>

    <p>

        <h3>

            Operations Department:

        </h3>

        Br. Tanweer Ahmed, Operations Supervisor

        <br />

        703-433-1325 ext. 103
        <br />

        703-855-7438(URGENT)

        <br />

        tanweerahmed@adamscenter.us

    </p>

    <h3>

        Accounting Department:</h3>

    <p>

        703-433-1325 x-106 and accounting@adamscenter.us
    </p>

    <p>

        Zakat (Assistance) Committee

        <br />

        571.437.9779
    </p>

    <p>

        <h3>

            Office of the Executive Director/Imam:

        </h3>

        Imam Mohamed Magid, Executive Director/Imam

        <br />

        Sr. Hanaa Unus, Executive Assistant

        <br />

        imam@adamscenter.us

        <br />

        703-433-1325 ext. 105 and 571-437-9566
<br />

<br />

<i>To request Imam Magid to do a lecture, seminar, or workshop in your community or at your organization, please send an e-mail to qurtuba@adamscenter.us</i>

    </p>

<p>

        Ustad Abdul Rafaa Ouertani - Deputy Imam

        <br />

        iqrafirst@gmail.com

    </p>    

<p>

        Hafiz Samiullah Safi - Daily Prayer Imam

    </p>

    <p>

        Hafiz Hatim Youssef - Daily Prayer Imam

    </p>

    <p>

        <h3>

            Youth Department:

        </h3>

    </p>

    <p>

        Br. Joshua Salaam - Youth Director

        <br />

        Email: youthdirector@adamscenter.us

        <br />

        Office Phone: (703) 433-1325 x112
        <br />

        Office Location: Youth Room 3rd Floor

    </p>

    <p>

        <h3>Interfaith and Outreach Department: </h3>

        Sr. Farhanahz Ellis, Interfaith and Outreach Director

        <br />

        farhanahzellis@gmail.com

        <br />

        703-433-1325 ext. 107 and 571-283-1441
        <br />

        Office Location: Room 203 Main Floor

    </p>

    <h2>

        Executive Committee/ Officers</h2>

    <p>

        Br. Farooq Syed

        <br />

        President and Board Member

        <br />

        farooq_syed@yahoo.com

        <br />

        703-408-4921
    </p>

    <p>

Br. Syed Moktadir

<br />

Vice-President and Board Member 

<br />

syed.moktadir@gmail.com

    </p>

    <p>

Sr. Sanober Yacoob  

<br />

Treasurer and Board Member 

<br />

Sanober.Yacoob@adamscenter.us

    </p>

    <p>

Br. Awais Sheikh

<br />

Secretary and Board Member 

<br />

secretary@adamscenter.us</p>

    <h3>

        Mailing Address:</h3>

    <p>

        ADAMS Center

        <br />

        P.O. BOX 1085

        <br />

        Herndon, VA 20172

    </p>

    <h3>

        Main ADAMS Center Address:</h3>

    <p>

        46903 Sugarland Road

        <br />

        Sterling,VA 20164

        <br />

        <a href="http://maps.google.com/maps?f=q&hl=en&geocode=&q=46903+Sugarland+Road,+Sterling,VA+20164&sll=37.0625,-95.677068&sspn=50.51141,76.640625&ie=UTF8&z=16&iwloc=addr">

            (map & directions)</a>

    </p>
')
INSERT INTO [Pages].[Pages] ([PageID], [Title], [Url], [Content]) VALUES (36, N'Branches', N'/branches', N'<h1>

        Branches</h1>

    <p>

        ADAMS Center has established 5 Jumaa(Friday Prayer) Locations, 3 Taraweh Locations

        on Ramadaan, 6 Branch Committees. ADAMS Activities will continue to grow and expand.

        ADAMS Suburb based committees are establishing and over time local ADAMS branches/community

        centers will be established in the Dulles Area Suburbs in every zip code, inshaAllah

    </p>

    <h2>

        <a href="MainCenter.aspx">Main Center</a></h2>

    <p>

        HeadQuarters, Daily Prayers, Jumaas, Ramadan Taraweh Activities, Sports, Education

        Programs and much much more

    </p>

    <h2>

        <a href="Reston.aspx">Reston Jumaa</a></h2>

    <p>

        - (Friday Prayers)

    </p>

    <h2>

        <a href="Fairfax.aspx">Fairfax Jumaa</a></h2>

    <p>

        - (Friday Prayers) and Ramadan Taraweh

        <br />

        - working on ADAMS South Center Project to establish a permanent community center

        serving Fairfax, South Riding, Centreville, Chantilly, and more

    </p>

    <h2>

        <a href="Leesburg.aspx">Leesburg Jumaa</a></h2>

    <p>

        - (Friday Prayers)

        <br />

        - working on an ADAMS Leesburg Community Center Feasiblity study,

        <br />

        - working on planning a potluck in february, inshaAllah

    </p>

    <h2>

        <a href="TysonsCorner.aspx">Tysons Corner Jumaa</a></h2>

    <p>

        - (Friday Prayers)

    </p></a>

    <h2>

        <a href="Ashburn.aspx">Ashburn</a></h2>

    <p>

        - Daily Prayers, Jumaas, Ramadan Taraweh, and Committee

        <br />

    </p>

    <h2>

        <a href="SouthRiding.aspx">South Riding</a></h2>

    <p>

        - Committee

        <br />

        - working on ADAMS South Center Project to establish a permanent community center

        serving Fairfax, South Riding, Centreville, Chantilly, and more
 
        <br />

        - they have had several potlucks

    </p>

')
EXEC(N'INSERT INTO [Pages].[Pages] ([PageID], [Title], [Url], [Content]) VALUES (37, N''Privacy Policy'', N''/information/privacy-policy'', N''<h1>

        Privacy Policy</h1>

    <p>

        The following statement outlines the privacy policy of ADAMS Center. This policy

        is based on our fundamental goal to provide our visitors with quality information

        and resources while maintaining individual anonymity and personal privacy. Please

        forward any comments you may have regarding this policy to webmaster@adamscenter.org.

    </p>

    <h2>

        Visitor data collected by ADAMS Center

    </h2>

    <p>

        When you access our web pages, the client information and the essential and nonessential

        technical information listed below is automatically collected - we refer to those

        categories collectively as "access" information. No other information is collected

        through the ADAMS Center web site except when you deliberately decide to send it

        to us (for example, by clicking on a link to send us an e-mail). The information

        you might choose to send us is listed below as "optional information."

    </p>

    <h2>

        Automatically collected access information

    </h2>

    <p>

        Client information: the Internet domain and Internet address of the computer you

        are using. Essential technical information: identification of the page or service

        you are requesting, type of browser and operating system you are using; and the

        date and time of access. Nonessential technical information: the Internet address

        of the website from which you linked directly to our web site, and the "cookie information"

        described below.

    </p>

    <h2>

        Optional information</h2>

    <p>

        When you send us an e-mail: your name, e-mail address, and the content of your e-mail.

        When you complete online forms: all the data you choose to fill in or confirm.

    </p>

    <h2>

        The way we use information</h2>

    <p>

        Client information is used to route the requested web page to your computer for

        viewing. In theory, the requested web page and the routing information could be

        discerned by other entities involved in transmitting the requested page to you.

        We do not control the privacy practices of those entities. Essential and nonessential

        technical information helps us respond to your request in an appropriate format

        (or in a personalized manner) and helps us plan website improvements. Optional information

        enables us to provide services or information tailored more specifically to your

        needs or to forward your message or inquiry to another entity that is better able

        to do so, and also allows us to plan website improvements.

    </p>

    <p>

        We may keep user information from our systems indefinitely after the web page is

        transmitted, but we do not try to obtain any information to link it to the individuals

        who browse our web site. However, on rare occasions when a "hacker" attempts to

        breach computer security, logs of access information are retained to permit a security

        investigation and in such cases may be forwarded together with any other relevant

        information in our possession to law enforcement agencies.

    </p>

    <p>

        We use information you provide about yourself only to complete your specific request.

        We do not share this information with outside parties except to the extent necessary

        to complete that request. Similarly, we use the information you provide about someone

        else when making a request only to complete that request. Again, we do not share

        this information with outside parties except to the extent necessary to complete

        that request.

    </p>

    <p>

        We generally use return e-mail addresses only to answer the e-mail we receive. Such

        addresses are generally not used for any other purpose.

    </p>

    <p>

        Fin'')')
SELECT @pv=TEXTPTR([Content]) FROM [Pages].[Pages] WHERE [PageID]=37
UPDATETEXT [Pages].[Pages].[Content] @pv NULL NULL N'ally, we never use or share the personally identifiable information provided

        to us online in ways unrelated to the ones described above without a clear notice

        on the particular site and without also providing you an opportunity to opt-out

        or otherwise prohibit such unrelated uses.

    </p>

    <h2>

        Use of cookies

    </h2>

    <p>

        The ADAMS Center website uses "cookies," a small data file transferred by a website

        to your computer''s hard drive. We send cookies when you surf http://www.adamscenter.org,

        respond to online surveys or polls, or request information. Accepting the cookies

        used on our site does not give us access to your Personally Identifiable Information,

        but we can use the cookies to identify your computer. The aggregate information

        collected permits us to analyze traffic patterns on our site. This can enable us

        over time to provide you with a better experience by improving the content and making

        it easier to use.

    </p>

    <h2>

        Providing information is your choice

    </h2>

    <p>

        There is no legal requirement for you to provide any information at our website

        However, our website will not work without routing information and the essential

        technical information. Failure of your browser to provide nonessential technical

        information will not prevent your use of our website but may prevent certain features

        from working. For any optional information that is requested at the website, failure

        to provide the requested information will mean that the particular feature or service

        associated with that part of the web page may not be available to you.

    </p>

    <h2>

        Our commitment to data security

    </h2>

    <p>

        To prevent unauthorized access, maintain data accuracy, and ensure the correct use

        of information, we have put in place appropriate physical, electronic, and managerial

        procedures to safeguard and secure the information we collect online, consistent

        with the policies of ADAMS Center and with the laws and regulations of United States.

    </p>

    <h2>

        How to contact us

    </h2>

    <p>

        Should you have other questions or concerns about our privacy policies and practices,

        please refer to the contact us page for more information..

    </p>
'
INSERT INTO [Pages].[Pages] ([PageID], [Title], [Url], [Content]) VALUES (38, N'Parking & Towing Policy', N'/information/parking-towing-policy', N'<h1>

        ADAMS CENTER NO PARKING AND TOWING POLICY

    </h1>

    <p>

        In keeping with the guiding principles of the All Dulles Area Muslim Society and

        our commitment to our neighbors of the ADAMS Center to deter and prevent unauthorized

        parking of vehicles, the ADAMS Administration Department shall enforce this policy

        for vehicles parked in the following areas of the ADAMS Center Parking Lot and surrounding

        areas:

    </p>

    <p>

        Please do NOT park Vehicles in fire lanes marked with yellow paint and/or signs

    </p>

    <p>

        Please do NOT park Vehicles in handicapped parking without proper permit

    </p>

    <p>

        Please do NOT park Vehicles in Norwood and Colvin Hunt residential developments,

        viz., Norwood Drive and Landerset Drive

    </p>

    <p>

        Please do NOT park Vehicles in the MuirField Apartments

    </p>

    <p>

        Please do NOT park Vehicles parked over forty-eight hours in any section of the

        Parking Lot

    </p>

    <p>

        Please do NOT park Vehicles on Sugarland Rd in front of the Masjid or in front of

        the Neighbors houses. Sugarland Rd in from the of the Masjid is a turning lane,

        accelaration lane and part of it is a fire lane

    </p>

    <p>

        Any vehicle seen in violation of this Parking and Towing Policy is subject to towing

        and impoundment by an authorized ADAMS contractor. Any expenses and damage occurred

        as a result is the sole responsibility of the legal owner of the vehicle; ADAMS

        assumes no liability in such cases.

    </p>

    <h2>

        Suggestions:

    </h2>

    <p>

        We ask that people carpool to ADAMS Main Center.

    </p>

    <p>

        We ask that people who live close by should walk to the center

    </p>

    <p>

        Please donate to pay for the 2nd entrance/exit and parking lot so we can then build

        our next phase of the center(A Permanent Prayer Hall and more classrooms)

    </p>

    <p>

        O ye who believe! Fulfill (all) obligations. Quran [5:1]

    </p>
')
INSERT INTO [Pages].[Pages] ([PageID], [Title], [Url], [Content]) VALUES (39, N'Education', N'/education', N'<h1>Education</h1>
<ul id="mainlinks">
    <li>
	<h3>Computer Training</h3>
	<a href="/education/computer-training"><img src="/Content/Images/links/computer.jpg" class="ui-corner-all"></a></li>
    <li>
	<h3>Preschool</h3>
	<a href="/education/preschool"><img src="/Content/Images/links/preschool.jpg" class="ui-corner-all"></a></li>
    <li>
	<h3>Sunday School</h3>
	<a href="/education/sunday-school"><img src="/Content/Images/links/sundayschool.jpg" class="ui-corner-all"></a></li>
    <li>
	<h3>Tahfeez ul Quran</h3>
	<a href="/education/tahfeez-ul-quran"><img src="/Content/Images/links/tahfeez.jpg" class="ui-corner-all"></a></li>
    <li>
	<h3>Taleem ul Quran</h3>
	<a href="/education/taleem-ul-quran"><img src="/Content/Images/links/taleem.jpg" class="ui-corner-all"></a></li>
    <li>
	<h3>Qurtuba Institute</h3>
	<a href="http://www.qurtubainstitute.org/"><img src="/Content/Images/links/qurtuba.jpg" class="ui-corner-all"></a></li>
</ul>
<div style="clear: both;"></div>')
INSERT INTO [Pages].[Pages] ([PageID], [Title], [Url], [Content]) VALUES (40, N'Computer Training', N'/education/computer-training', N'content tbd...')
INSERT INTO [Pages].[Pages] ([PageID], [Title], [Url], [Content]) VALUES (41, N'Preschool', N'/education/preschool', N'<h1>ADAMS Radiant Hearts Academy (Preschool - 2nd Grade)</h1>

<p>

Registration for ADAMS Radiant Hearts Academy 2011-2012 academic year is now in session.  Please pick up a form from room # 103 and return it as soon as possible to reserve your child''s seat!

</p>
')
INSERT INTO [Pages].[Pages] ([PageID], [Title], [Url], [Content]) VALUES (42, N'Summer Camp', N'/programs/summer-camp', N'<h1>

        ADAMS Children Summer Camp 2011</h1>

    <h2>

        JOIN US FOR A SUMMER FULL OF FUN &amp; LEARNING!!!</h2>

    <p>

        <a href="/files/adams-summer-camp2011Flyer.pdf">Click here to download flier.</a>

    </p>

<p>

        <a href="/files/2011RegistrationPage1.pdf">Click here to download registration form 1.</a>

    </p>

<p>

        <a href="/files/2011RegistrationPage2.pdf">Click here to download registration form 2.</a>

    </p>

    <p>

        We are now open for registration for children ages 3 1/2 to 12, or pre-school through

        6thgrade.

    </p>

    <p>

        <b>Duration:</b> 4 weeks from July 5th to July 28th

    </p>

    <p>

        <b>Time:</b> 9 am to 1 pm Monday through Thursday

        <br>

        Prepaid after care available from 1 pm to 6 pm

    </p>

    <p>

        <b>Place:</b> ADAMS Center

    </p>

    <p>

        <b>Fee:</b> Preschool through 6th grade:

<br> $285 per child (includes field trip)

        <br>

        Plus $40 field trip fees

        <br>

        $3 per hour for everyday aftercare,

<br> $5 for "once in a while" aftercare

    </p>

    <p>

        Please register your child before June 28th. A $10 late fee will be charged for

        registrations after June 28th and a $25 late fee will be charged for walk in registration,

        if available.

    </p>

    <p>

        To register leave the form and check at the ADAMS office.

    </p>

    <p>

        For information please download the <a href="adams-summer-camp2011Flyer.pdf">flier</a> or e-mail Srvallah@aol.com or call(571) 346 3259

    </p>
')
INSERT INTO [Pages].[Pages] ([PageID], [Title], [Url], [Content]) VALUES (43, N'Sunday School', N'/education/sunday-school', N'<h1>Sunday School</h1> 

<h3>We are closed for the Summer!</h3>

<p>New year begins September 11, 2011. The office and classes are closed until then. Have a safe, relaxing and productive summer!</p>



<h2>Welcome</h2> 

<p>

	<b>Children''s Education Program</b> <br />

	[formerly known as Sunday School] <br /> 

	(for 4-12 years old) <br />

	<b>Regular Hours:</b> <br /> 

	Morning Shift: 10 am - 1 pm <br />

	Afternoon Shift: 1:30 pm - 4:30 pm 

</p>



<h2>2011-2012 Registration</h2> 

<p>Limited seating available. During the school year, space permitting, student registration is held on-site only during regular school hours on Sundays from 10am - 12:30pm and again from 1:45pm to 4:15pm. 

<br \><br \>

Visit the <a href="http://adamscenter.org/Education/SundaySchool/Calendar.aspx">calendar</a> for special events/closings.

<br \><br \>

First child''s full year tuition is $420 and each additional is $205. Payment is due upon registration. Check only please.

<br \><br \>

See you on Sundays, insha''Allah!

</p>



<h3> Something to Remember</h3>



<p>Please bring children to ADAMS Center a few minutes before the scheduled time (between 9:50 and 10:00 AM for the morning shift, and between 1:20-1:30 PM for the afternoon shift).</p> 



<p> All children are required to assemble in the ''Combo Room'' on the first level at the exact start

time. </p> 



<p> 

	Please pick up children on time. Fines may be assessed for late pick-up. <br /> 

	Thank you for your cooperation and consideration. 

</p> 



<p> Contact ADAMS Center: <br />

	(703) 433-1325 Ext-104 
</p> 



<p>

	Student Services and Registration: <br />

	<a href="mailto:CEPOffice@gmail.com">CEPOffice@gmail.com</a> 

</p>



<p> 

	Contact the Director: <br /> 

	<a href="mailto:omaiayo@gmail.com">omaiayo@gmail.com</a> 

</p>
')
INSERT INTO [Pages].[Pages] ([PageID], [Title], [Url], [Content]) VALUES (44, N'Tahfeez Ul Quran', N'/education/tahfeez-ul-quran', N'<h1>

        ADAMS Hifz Program

    </h1>

    <p>

        "Alif Laam Meem. This Book, there is no doubt in it, is a guide to those who guard

        (against evil)."

    </p>



<p>

<h3>Sponser a Hafiz for only $84/month for next 12 months </h3>



<a href="https://www.paypal.com/cgi-bin/webscr?cmd=_s-xclick&hosted_button_id=8582844" target="_blank"> Click here to Sponsor a Hafiz</a>



</p>



<p>

<h3>Make one time donation to Hafiz Program</h3>

<object width="250" height="250"><param name="movie" value="http://widget.chipin.com/widget/id/c2d8240b38c3a9a8"></param><param name="allowScriptAccess" value="always"></param><param name="wmode" value="transparent"></param><param name="event_title" value="ADAMS%20HIFZ%20Program"></param><param name="event_desc" value="Sponser%20a%20Hafiz.%20%20Help%20a%20Hafiz%20learn%20the%20words%20of%20Allah.%20%20We%20are%20looking%20for%2060%20dollars%20to%20pay%20%241000%20per%20year."></param><embed src="http://widget.chipin.com/widget/id/c2d8240b38c3a9a8" flashVars="event_title=ADAMS%20HIFZ%20Program&event_desc=Sponser%20a%20Hafiz.%20%20Help%20a%20Hafiz%20learn%20the%20words%20of%20Allah.%20%20We%20are%20looking%20for%2060%20dollars%20to%20pay%20%241000%20per%20year." type="application/x-shockwave-flash" allowScriptAccess="always" wmode="transparent" width="250" height="250"></embed></object>

</p>
')
INSERT INTO [Pages].[Pages] ([PageID], [Title], [Url], [Content]) VALUES (45, N'Taleem Ul Quran', N'/education/taleem-ul-quran', N'<h1>Taleem Ul Quran </h1>

<br>

<h2>Quran Classes for Ages 5-18</h2>

<br>

<img alt="QuranClasses" src="/files/QuranClasses.jpg">

<br>



<br><b>How to Choose the Right Class for Your Child</b><br>

<br><b>Step 1:</b> Choose the kind of class you want from Column One.

<br><b>Step 2:</b> Pick the days and times that are convenient for you. Please email srvAllah@gmail.com or call 703-433-1325 ext. 102 to see if space is available.
<br><b>Step 3:</b> Fill out a Registration form that you can find outside the main office on the second floor.

<br>
')
INSERT INTO [Pages].[Pages] ([PageID], [Title], [Url], [Content]) VALUES (46, N'Brothers', N'/programs/brothers', N'<h1>

        ADAMS Brothers</h1>

    

THE BROTHERS RING



<br><br>







DATE: Every Friday

<br />TIME:	6:30pm - 7:30pm

<br />WHO:	All brothers, young and old

<br />WHAT:	Discuss and debate politics, religious topics, and every day issues facing youth. There are also field trips some Friday''s. 

<br>

<br />CONTACT:	Br. Joshua Salaam - <a href="mailto:youthdirector@adamscenter.us">youthdirector@adamscenter.us</a>
')
INSERT INTO [Pages].[Pages] ([PageID], [Title], [Url], [Content]) VALUES (47, N'Sisters', N'/programs/sisters', N'<h1>

        The ADAMS Sister''s Youth Group

    </h1>

    <p>

        2009-2010 Officers

        <br />

        President: Sana Rauf

        <br />

        Vice-President: Hiba Farah

        <br />

        Secretary: Aziz Bhatti

        <br />

        Treasurer: Fahduma Majid

    </p>

    <p>

        Sponser: Sr. Salwa Zenhom*

    </p>

    <p>

        Objectives

        <br />

        To serve as a foundation of knowledge for our members.

        <br />

        To increase our members'' ''iman (faith) by providing avenues of spiritual guidance.

        <br />

        To strengthen the bonds of sisterhood by creating a fun, comfortable environment.

        <br />

        To promote a healthy community by increasing understanding of Islam to society at large.

        

    </p>

    <p>

        Sister''s Youth Group meetings are held Fridays at 7:00 on the third floor in the Youth

        room at ADAMS. They are open to all sisters ages 12 to 18.

    </p>

    <p>

        Come join the sisters of ADAMS for various activities, such as picnics, games, parties, movie nights, discussion circles, and so much more!<P>



For more information, please email:<a href="mailto: sana.rauf.7@gmail.com"> sana.rauf.7@gmail.com</a>

    

<br />

*We are currently seeking a new sponser.  If you are interested, please email us at the above address!

</p>
')
INSERT INTO [Pages].[Pages] ([PageID], [Title], [Url], [Content]) VALUES (48, N'Boy Scouts', N'/programs/boy-scouts', N'<center>

        <img src="/files/ScoutEmblem.jpg" align="middle" alt="" />

        <h1>

            ADAMS Boy Scouts Information Page

        </h1>

    </center>

    <p>

        As salamu alaykum Scouts, Parents and Future Scouts!

    </p>

    <p>

        If you would like to register your son or volunteer some of your time, please email

        <a href="mailto:Scoutmaster1576@yahoo.com">Scoutmaster1576@yahoo.com</a> or <a href="mailto:youthdirector@adamscenter.us">

            youthdirector@adamscenter.us</a>

    </p>

    <p>

        <a href="http://www.scouting.org/factsheets/02-503.html">Boy Scouting</a>, one of

        the traditional membership divisions of the BSA, is available to boys who have earned

        the Arrow of Light Award and are at least 10 years old or have completed the fifth

        grade and are at least 10, or who are 11, but not yet 18 years old. The program

        achieves the BSA''s objectives of developing character, citizenship, and personal

        fitness.

    </p>

    <p>

        You may know that the ADAMS Scouting program is entirely run by volunteers, including

        parents like you. Our program is getting stronger and we are planning activities

        for our scouts for entire year. Some of the dates are still tentative. We also have

        planned other activities and it will be listed once we have a suitable dates for

        the scouts and adults.

    </p>

    <p>

        <a href="CommitteeMembers.aspx">Troop 1576 Committee Members</a>

        <br />

        <a href="AdultLeaders.aspx">Troop 1576 Adult Leaders</a>

        <br />

        <a href="ContactRelatedToBSA.aspx">Additional Contact related to

            BSA</a>

        <br />

        <a href="Achieve2006.aspx">Please check what our scouts have

            achieved this year</a>

        <br />

        <a href="PhotoGallery.aspx">Please check the Photo Gallery</a>

    </p>

    <p>

        <a href="Activity2006.aspx">Troop 1576 Activity Calendar for

            2006</a>

        <br />

        <a href="Activity2007.aspx">Troop 1576 Activity Calendar for

            2007</a>

    </p>

    <p>

        <a href="FormsAndDocuments.aspx">Forms and Documents</a>

        <br />

        <a href="Links.aspx">Additional URL Link</a>

    </p>
')
INSERT INTO [Pages].[Pages] ([PageID], [Title], [Url], [Content]) VALUES (49, N'Cub Scouts', N'/programs/cub-scouts', N'<h1>ADAMS Cub Scout Pack 1576 </h1>

<p>

Please note that our site has moved....

</p>

<p>

Please click below to visit our new location:

</p>

<p>

<a href="http://www.adamsscouting.org ">http://www.adamsscouting.org</a>

</p>
')
INSERT INTO [Pages].[Pages] ([PageID], [Title], [Url], [Content]) VALUES (50, N'Girl Scouts', N'/programs/girl-scouts', N'content tbd..')
INSERT INTO [Pages].[Pages] ([PageID], [Title], [Url], [Content]) VALUES (51, N'Schedule A Nikkah', N'/services/marriage/schedule-a-nikkah', N'<iframe src="http://spreadsheets.google.com/embeddedform?key=ru6-QZkBzvV4Y6fcNIDNdAg" width="760" height="2500" frameborder="0" marginheight="0" marginwidth="0">Loading...</iframe>

')
INSERT INTO [Pages].[Pages] ([PageID], [Title], [Url], [Content]) VALUES (52, N'My Adams', N'/join/my-adams', N'content tbd...')
INSERT INTO [Pages].[Pages] ([PageID], [Title], [Url], [Content]) VALUES (53, N'ADAMS Email List', N'/join/email-list', N'<h1>Subscribe to ADAMS Email Network</h1>

   <p>

If you live in or around the ADAMS community and would like to be in constant touch with ADAMS'' activities, news, and events, then please join this email group today! Currently, the group has over 1800 email addresses in it.

</p><p>

To join the ADAMS list email,Please email the following information to:  adams1-owner@yahoogroups.com

</p><p>

Your Name, Phone #, and Address 

<br/>Are you an ADAMS member? 

<br/>Two references of people you know within the community 

<br/>Which jumaa do you attend at ADAMS or other Masjid 

</p><p>

To unsubscribe, please send a blank email to: adams1-unsubscribe@yahoogroups.com

</p><p>

To post a message, please send your message to: adams1@yahoogroups.com

</p><p>

Posting to the group is moderated.

</p><p>

For Classifieds emails to be sent to the adams1 and printed at ADAMS 

<br/>Please click here: <a href="http://www.adamscenter.org/Classifieds/Default.aspx">Classifieds</a>

<br/>- personal place for rent 

<br/>- personal place for sale 

<br/>- personal car sale 

<br/>- one time garage sale 

<br/>- items to give away 

<br/>- need help with a task 

<br/>- babysitting

</p><p>

For Business advertisement please fill out a contract for email, fliers: 

<a href="boothflierdisplaymailemailform.pdf">boothflierdisplaymailemailform.pdf</a>

</p>
')
INSERT INTO [Pages].[Pages] ([PageID], [Title], [Url], [Content]) VALUES (54, N'Become A Member', N'/join/membership', N'<h1>Become A Member</h1>

<br>

Thank you for your interest in becoming a member of ADAMS center! It is through the support of our members that ADAMS is able to offer a multitude of programs and services for the community.<p>



Please use the form below to apply for membership. Once you complete the form, you can submit it one of two ways:<p>



1 - Via mail (please include payment) to:<br>



Attn: Secretary, ADAMS Center<br>

49603 Sugarland Road<br>

Sterling, VA, 20164<br><p>



2 - In person by dropping off the form and payment to the office, or dropping it into the memberships box outside of the office.<br>

<p>

<a href="https://docs.google.com/a/adamscenter.org/viewer?a=v&pid=explorer&chrome=true&srcid=0B1_zhWTgty9AY2I5NDAzNGMtNmFlOC00NzAwLWI5MjctMjlmZThmNzU0YzFh&hl=en&authkey=CNWnqosD">To Download Membership form click here</a><p>



PLEASE NOTE: Please review the following membership stipulations, as found in the Bylaws:

<p>

"Membership dues must be paid by personal check, personal debit or credit card or cash by the individual for himself/herself or for a family member (defined as spouse, children, parents and parents-in-law). However, new members must submit the membership application and pay the dues in person. Cash payments must be submitted in person. Applications submitted in the bundled form shall be invalid. Bundling is defined as one individual submitting application/renewals and payments for people other than himself/herself or for a family member. ADAMS Board has the discretion to approve or reject any membership applications.

<p>

The annual dues shall become payable on the first day of each anniversary year. Additional charges and fees may be assessed by the Board, subject to approval of the General Assembly, for specific purposes, such as a building or maintenance fund. The Board may prescribe charges or fees for special events and activities as it sees fit. Associate Members and Honorary members shall not be required to pay any dues"

<p>

If you have any questions regarding membership, please contact <a href="mailto:Secretary@adamscenter.us">Secretary@adamscenter.us</a><br>
')
INSERT INTO [Pages].[Pages] ([PageID], [Title], [Url], [Content]) VALUES (55, N'Join', N'/join', N'content tbd...')
INSERT INTO [Pages].[Pages] ([PageID], [Title], [Url], [Content]) VALUES (56, N'Programs', N'/programs', N'<p></p><h1>Programs</h1>
<ul id="mainlinks">
    <li>
	<h3>Cub Scouts</h3>
	<a href="/programs/cub-scouts"><img src="/Content/Images/links/cubscouts.jpg" class="ui-corner-all"></a></li>
    <li>
	<h3>Boy Scouts</h3>
	<a href="/programs/boy-scouts"><img src="/Content/Images/links/boyscouts.jpg" class="ui-corner-all"></a></li>
    <li>
	<h3>Brothers</h3>
	<a href="/programs/brothers"><img src="/Content/Images/links/brothers.jpg" class="ui-corner-all"></a></li>
    <li>
	<h3>Girl Scouts</h3>
	<a href="http://www.adamsscouting.org/staticpages/index.php/GirlScouts"><img src="/Content/Images/links/girlscouts.jpg" class="ui-corner-all"></a></li>
    <li>
	<h3>Health</h3>
	<a href="/programs/health-programs"><img src="/Content/Images/links/health.jpg" class="ui-corner-all"></a></li>
    <li>
	<h3>Sisters</h3>
	<a href="/programs/sisters"><img src="/Content/Images/links/sisters.jpg" class="ui-corner-all"></a></li>
    <li>
	<h3>Summer Camp</h3>
	<a href="/programs/summer-camp"><img src="/Content/Images/links/summer.jpg" class="ui-corner-all"></a></li>
</ul>
<div style="clear: both;"></div><p></p>')
INSERT INTO [Pages].[Pages] ([PageID], [Title], [Url], [Content]) VALUES (57, N'Prayers', N'/prayers', N'<h1>Prayers</h1>
<ul id="mainlinks">
    <li>
	<h3>Daily</h3>
	<a href="/prayers/daily"><img src="/Content/Images/links/daily.jpg" class="ui-corner-all"></a></li>
    <li>
	<h3>Jummah</h3>
	<a href="/prayers/jummah"><img src="/Content/Images/links/jummah.jpg" class="ui-corner-all"></a></li>
    <li>
	<h3>Taraweh</h3>
	<a href="/prayers/taraweh"><img src="/Content/Images/links/taraweh.jpg" class="ui-corner-all"></a></li>
    <li>
	<h3>Eid</h3>
	<a href="/prayers/eid"><img src="/Content/Images/links/eid.jpg" class="ui-corner-all"></a></li>
</ul>
<div style="clear: both;"></div>')
INSERT INTO [Pages].[Pages] ([PageID], [Title], [Url], [Content]) VALUES (59, N'Test', N'/Test/hello', N'asdfasdf')
SET IDENTITY_INSERT [Pages].[Pages] OFF
SET IDENTITY_INSERT [Sitemap].[WebBottomNodes] ON
INSERT INTO [Sitemap].[WebBottomNodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (1, NULL, N'/', N'Home', 1)
INSERT INTO [Sitemap].[WebBottomNodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (15, 1, N'/community', N'Community', 4)
INSERT INTO [Sitemap].[WebBottomNodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (16, 15, N'/community/interfaith', N'Interfaith', 5)
INSERT INTO [Sitemap].[WebBottomNodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (17, 15, N'/community/civic', N'Civic', 2)
INSERT INTO [Sitemap].[WebBottomNodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (18, 15, N'/community/community-service', N'Community Service', 3)
INSERT INTO [Sitemap].[WebBottomNodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (19, 1, N'/education', N'Education', 3)
INSERT INTO [Sitemap].[WebBottomNodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (20, 19, N'/education/sunday-school', N'Sunday School', 3)
INSERT INTO [Sitemap].[WebBottomNodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (21, 19, N'/education/taleem-ul-quran', N'Taleem Ul Quran', 5)
INSERT INTO [Sitemap].[WebBottomNodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (23, 1, N'/services', N'Services', 2)
INSERT INTO [Sitemap].[WebBottomNodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (27, 32, N'/programs/health-programs', N'Health Programs', 5)
INSERT INTO [Sitemap].[WebBottomNodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (28, 23, N'/services/funeral-services', N'Funeral Services', 3)
INSERT INTO [Sitemap].[WebBottomNodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (29, 23, N'/services/social-services', N'Social Services', 6)
INSERT INTO [Sitemap].[WebBottomNodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (30, 23, N'/services/zakat', N'Zakat', 7)
INSERT INTO [Sitemap].[WebBottomNodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (31, 15, N'/community/new-muslim-support-group', N'New Muslim Support Group', 6)
INSERT INTO [Sitemap].[WebBottomNodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (32, 1, N'/programs', N'Programs', 1)
INSERT INTO [Sitemap].[WebBottomNodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (33, 23, N'/services/marriage', N'Marriage', 4)
INSERT INTO [Sitemap].[WebBottomNodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (34, 19, N'http://www.qurtubainstitute.org/', N'Qurtuba Institute', 6)
INSERT INTO [Sitemap].[WebBottomNodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (35, 19, N'/education/computer-training', N'Computer Training', 1)
INSERT INTO [Sitemap].[WebBottomNodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (36, 19, N'/education/preschool', N'Preschool', 2)
INSERT INTO [Sitemap].[WebBottomNodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (37, 19, N'/education/tahfeez-ul-quran', N'Tahfeez Ul Quran', 4)
INSERT INTO [Sitemap].[WebBottomNodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (38, 32, N'http://www.adamsyep.org/', N'Youth Education Program', 8)
INSERT INTO [Sitemap].[WebBottomNodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (39, 32, N'/programs/summer-camp', N'Summer Camp', 7)
INSERT INTO [Sitemap].[WebBottomNodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (49, 23, N'/prayers', N'Prayers', 5)
INSERT INTO [Sitemap].[WebBottomNodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (57, 1, N'/join', N'Join', 5)
INSERT INTO [Sitemap].[WebBottomNodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (58, 57, N'/myadams', N'My ADAMS', 6)
INSERT INTO [Sitemap].[WebBottomNodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (59, 57, N'/join/membership', N'Become A Member', 6)
INSERT INTO [Sitemap].[WebBottomNodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (60, 57, N'/join/email-list', N'ADAMS Email List', 6)
INSERT INTO [Sitemap].[WebBottomNodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (61, 32, N'/programs/brothers', N'Brothers', 3)
INSERT INTO [Sitemap].[WebBottomNodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (62, 32, N'/programs/sisters', N'Sisters', 6)
INSERT INTO [Sitemap].[WebBottomNodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (63, 32, N'/programs/boy-scouts', N'Boy Scouts', 2)
INSERT INTO [Sitemap].[WebBottomNodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (64, 32, N'/programs/cub-scouts', N'Cub Scouts', 1)
INSERT INTO [Sitemap].[WebBottomNodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (65, 32, N'/programs/girl-scouts', N'Girl Scouts', 4)
INSERT INTO [Sitemap].[WebBottomNodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (66, 15, N'/announcements', N'Announcements', 1)
INSERT INTO [Sitemap].[WebBottomNodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (67, 15, N'/pressreleases', N'Press Releases', 7)
INSERT INTO [Sitemap].[WebBottomNodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (68, 15, N'/events', N'Events', 4)
INSERT INTO [Sitemap].[WebBottomNodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (69, 23, N'/classifieds', N'Classifieds', 2)
INSERT INTO [Sitemap].[WebBottomNodes] ([NodeID], [ParentNodeID], [Url], [Title], [DisplayOrder]) VALUES (70, 23, N'/businesses', N'Businesses', 1)
SET IDENTITY_INSERT [Sitemap].[WebBottomNodes] OFF
SET IDENTITY_INSERT [Announcements].[Announcements] ON
EXEC(N'INSERT INTO [Announcements].[Announcements] ([AnnouncementID], [Title], [ShortDescription], [LongDescription], [StartDate], [EndDate], [Link]) VALUES (3, N''Ramadan and Eid ul-Fitr'', N''1st of Ramadan will be on Monday, August 1'', N''<span class="Apple-style-span" style="font-family: Verdana, Arial, Helvetica, sans-serif; font-size: 11px; background-color: rgb(255, 255, 255); "><span style="margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; padding-top: 0px; padding-right: 0px; padding-bottom: 0px; padding-left: 0px; border-top-width: 0px; border-right-width: 0px; border-bottom-width: 0px; border-left-width: 0px; border-style: initial; border-color: initial; outline-width: 0px; outline-style: initial; outline-color: initial; font-style: inherit; font-size: 11px; font-family: verdana, helvetica, sans-serif; vertical-align: baseline; border-collapse: collapse; color: rgb(0, 0, 0); "><div style="margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; padding-top: 0px; padding-right: 0px; padding-bottom: 0px; padding-left: 0px; border-top-width: 0px; border-right-width: 0px; border-bottom-width: 0px; border-left-width: 0px; border-style: initial; border-color: initial; outline-width: 0px; outline-style: initial; outline-color: initial; font-style: inherit; font-size: 11px; font-family: Verdana, Arial, Helvetica, sans-serif; vertical-align: baseline; "><div style="margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; padding-top: 0px; padding-right: 0px; padding-bottom: 0px; padding-left: 0px; border-top-width: 0px; border-right-width: 0px; border-bottom-width: 0px; border-left-width: 0px; border-style: initial; border-color: initial; outline-width: 0px; outline-style: initial; outline-color: initial; font-style: inherit; font-size: 11px; font-family: Verdana, Arial, Helvetica, sans-serif; vertical-align: baseline; ">AsSalaamualaikum WaRahmatullahi WaBarakatahu,<br></div></div><div align="left" style="margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; padding-top: 0px; padding-right: 0px; padding-bottom: 0px; padding-left: 0px; border-top-width: 0px; border-right-width: 0px; border-bottom-width: 0px; border-left-width: 0px; border-style: initial; border-color: initial; outline-width: 0px; outline-style: initial; outline-color: initial; font-style: inherit; font-size: 11px; font-family: Verdana, Arial, Helvetica, sans-serif; vertical-align: baseline; "><font color="#003300" size="2" face="Verdana"><b>2011&nbsp;<font color="#003300">Ramadan and Eid ul-Fitr Announcement</font></b></font></div><font color="#003300" size="2" face="Verdana"><font color="#000000"><div align="center" style="margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; padding-top: 0px; padding-right: 0px; padding-bottom: 0px; padding-left: 0px; border-top-width: 0px; border-right-width: 0px; border-bottom-width: 0px; border-left-width: 0px; border-style: initial; border-color: initial; outline-width: 0px; outline-style: initial; outline-color: initial; font-style: inherit; font-size: 11px; font-family: Verdana, Arial, Helvetica, sans-serif; vertical-align: baseline; "><font color="#ff0000"></font></div></font></font><div align="left" style="margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; padding-top: 0px; padding-right: 0px; padding-bottom: 0px; padding-left: 0px; border-top-width: 0px; border-right-width: 0px; border-bottom-width: 0px; border-left-width: 0px; border-style: initial; border-color: initial; outline-width: 0px; outline-style: initial; outline-color: initial; font-style: inherit; font-size: 11px; font-family: Verdana, Arial, Helvetica, sans-serif; vertical-align: baseline; "><font color="#003300" size="2" face="Verdana"><font color="#000000">"O you who believe, fasting is prescribed to you as it was prescribed to those before you, that you may (learn) self-restraint. " Quran 2: 183</font></font></div><div align="left" style="margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; padding-top: 0px; padding-right: 0px; padding-bottom: 0px; padding-left: 0px; border-top-width: 0px; border-right-width: 0px; border-bottom-width: 0px; border'', ''20110731 00:00:00.000'', ''20110807 00:00:00.000'', N'''')')
EXEC(N'DECLARE @pv binary(16)
'+N'SELECT @pv=TEXTPTR([LongDescription]) FROM [Announcements].[Announcements] WHERE [AnnouncementID]=3
UPDATETEXT [Announcements].[Announcements].[LongDescription] @pv NULL NULL N''-left-width: 0px; border-style: initial; border-color: initial; outline-width: 0px; outline-style: initial; outline-color: initial; font-style: inherit; font-size: 11px; font-family: Verdana, Arial, Helvetica, sans-serif; vertical-align: baseline; "></div><div align="left" style="margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; padding-top: 0px; padding-right: 0px; padding-bottom: 0px; padding-left: 0px; border-top-width: 0px; border-right-width: 0px; border-bottom-width: 0px; border-left-width: 0px; border-style: initial; border-color: initial; outline-width: 0px; outline-style: initial; outline-color: initial; font-style: inherit; font-size: 11px; font-family: Verdana, Arial, Helvetica, sans-serif; vertical-align: baseline; "></div><div align="left" style="margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; padding-top: 0px; padding-right: 0px; padding-bottom: 0px; padding-left: 0px; border-top-width: 0px; border-right-width: 0px; border-bottom-width: 0px; border-left-width: 0px; border-style: initial; border-color: initial; outline-width: 0px; outline-style: initial; outline-color: initial; font-style: inherit; font-size: 11px; font-family: Verdana, Arial, Helvetica, sans-serif; vertical-align: baseline; ">InshaAllah, Ramadan 2011 will begin on Monday, August 1, 2011 and the first day of Taraweeh will be on Sunday,&nbsp;July 31, 2011.&nbsp;Eid-ul-Fitr&nbsp;will be on Tuesday,&nbsp;August 30, 2011. This is based on the policy adopted by ADAMS Board to follow the rulings of&nbsp;Fiqh Council of North America&nbsp;for the beginning of Raamdan and Eid-ul- Fitr. Please refer to the details from the Fiqh Council website:&nbsp;<a href="http://www.fiqhcouncil.org/" rel="nofollow" target="_blank" style="margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; padding-top: 0px; padding-right: 0px; padding-bottom: 0px; padding-left: 0px; border-top-width: 0px; border-right-width: 0px; border-bottom-width: 0px; border-left-width: 0px; border-style: initial; border-color: initial; outline-width: 0px; outline-style: initial; outline-color: initial; font-style: inherit; font-size: 11px; font-family: Verdana, Arial, Helvetica, sans-serif; vertical-align: baseline; text-decoration: none; color: rgb(17, 85, 204); ">www.fiqhcouncil.org</a>&nbsp;ADAMS will have Taraweeh in the Main Center, Ashburn Center, Fairfax, North Reston, South Reston-Herndon, Greater Gainesville andSouth Riding. Please see ADAMS Website for any updates at&nbsp;<a href="http://www.adamscenter.org/" rel="nofollow" target="_blank" style="margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; padding-top: 0px; padding-right: 0px; padding-bottom: 0px; padding-left: 0px; border-top-width: 0px; border-right-width: 0px; border-bottom-width: 0px; border-left-width: 0px; border-style: initial; border-color: initial; outline-width: 0px; outline-style: initial; outline-color: initial; font-style: inherit; font-size: 11px; font-family: Verdana, Arial, Helvetica, sans-serif; vertical-align: baseline; text-decoration: none; color: rgb(17, 85, 204); "><font color="#9136ad">http://www.adamscenter.org/</font></a><br><br></div><div style="margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; padding-top: 0px; padding-right: 0px; padding-bottom: 0px; padding-left: 0px; border-top-width: 0px; border-right-width: 0px; border-bottom-width: 0px; border-left-width: 0px; border-style: initial; border-color: initial; outline-width: 0px; outline-style: initial; outline-color: initial; font-style: inherit; font-size: 11px; font-family: Verdana, Arial, Helvetica, sans-serif; vertical-align: baseline; ">The Fiqh Council of North America recognizes astronomical calculation as an acceptable Shar’i method for determining the beginning of Lunar months including the months of Ramadan and Shawwal. FCNA uses Makkah al-Mukarram as a conventional point and takes the position that the conjunction must take pl''
UPDATETEXT [Announcements].[Announcements].[LongDescription] @pv NULL NULL N''ace before sunset in Makkah and moon must set after sunset in Makkah.</div><div style="margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; padding-top: 0px; padding-right: 0px; padding-bottom: 0px; padding-left: 0px; border-top-width: 0px; border-right-width: 0px; border-bottom-width: 0px; border-left-width: 0px; border-style: initial; border-color: initial; outline-width: 0px; outline-style: initial; outline-color: initial; font-style: inherit; font-size: 11px; font-family: Verdana, Arial, Helvetica, sans-serif; vertical-align: baseline; ">&nbsp;</div><div style="margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; padding-top: 0px; padding-right: 0px; padding-bottom: 0px; padding-left: 0px; border-top-width: 0px; border-right-width: 0px; border-bottom-width: 0px; border-left-width: 0px; border-style: initial; border-color: initial; outline-width: 0px; outline-style: initial; outline-color: initial; font-style: inherit; font-size: 11px; font-family: Verdana, Arial, Helvetica, sans-serif; vertical-align: baseline; ">On the basis of this method the dates of Ramadan and Eidul Fitr for the year 1432 AH are established as follows:</div><div style="margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; padding-top: 0px; padding-right: 0px; padding-bottom: 0px; padding-left: 0px; border-top-width: 0px; border-right-width: 0px; border-bottom-width: 0px; border-left-width: 0px; border-style: initial; border-color: initial; outline-width: 0px; outline-style: initial; outline-color: initial; font-style: inherit; font-size: 11px; font-family: Verdana, Arial, Helvetica, sans-serif; vertical-align: baseline; "><br><strong style="font-weight: bold; color: rgb(141, 136, 104); text-decoration: none; "><font color="#ff4040">1st of Ramadan will be on Monday, August 1, 2011<br>1st of Shawwal will be on Tuesday, August 30, 2011</font></strong></div><div style="margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; padding-top: 0px; padding-right: 0px; padding-bottom: 0px; padding-left: 0px; border-top-width: 0px; border-right-width: 0px; border-bottom-width: 0px; border-left-width: 0px; border-style: initial; border-color: initial; outline-width: 0px; outline-style: initial; outline-color: initial; font-style: inherit; font-size: 11px; font-family: Verdana, Arial, Helvetica, sans-serif; vertical-align: baseline; "><br>Ramadan 1432 AH:<br>The Astronomical New Moon is on July 30, 2011 (Saturday) at 18:40 Universal Time (9:40 p.m. Makkah time). Sunset at Makkah on July 30 is at 7:01 p.m. The birth of the new moon will be 3:39 minutes after sunset. Therefore Sunday cannot be the first day of Ramadan. However, on Sunday July 31, the sunset in Makkah will be at 7:1 p.m. and moonset is at 7:26 p.m. Therefore 1st day of Ramadan is Monday, August 1, insha''''Allah. First Tarawih prayer will be on Sunday night.</div><div style="margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; padding-top: 0px; padding-right: 0px; padding-bottom: 0px; padding-left: 0px; border-top-width: 0px; border-right-width: 0px; border-bottom-width: 0px; border-left-width: 0px; border-style: initial; border-color: initial; outline-width: 0px; outline-style: initial; outline-color: initial; font-style: inherit; font-size: 11px; font-family: Verdana, Arial, Helvetica, sans-serif; vertical-align: baseline; "><br>Eid ul-Fitr 1432 AH:<br>The Astronomical New Moon is on August 29, 2011 (Monday) at 3:04 Universal Time (6:04 a.m. Makkah time). On Monday, August 29, sunset at Makkah is 6:40 p.m. local time, while moonset is at 6:44 pm local time. Therefore, first day of Shawwal, i.e., Eid ul-Fitr is Tuesday, August 30, insha''''Allah.<br>May Allah (swt) keep us on the right path, and accept our fasting and prayers. Ameen. For more detailed information, please visit:&nbsp;<a title="www.fiqhcouncil.org" href="http://www.fiqhcouncil.org/" target="_blank" style="margin-top: 0px; margin-right: 0px; ma''
UPDATETEXT [Announcements].[Announcements].[LongDescription] @pv NULL NULL N''rgin-bottom: 0px; margin-left: 0px; padding-top: 0px; padding-right: 0px; padding-bottom: 0px; padding-left: 0px; border-top-width: 0px; border-right-width: 0px; border-bottom-width: 0px; border-left-width: 0px; border-style: initial; border-color: initial; outline-width: 0px; outline-style: initial; outline-color: initial; font-style: inherit; font-size: 11px; font-family: Verdana, Arial, Helvetica, sans-serif; vertical-align: baseline; text-decoration: none; color: rgb(17, 85, 204); "><font color="#0066cc">www.fiqhcouncil.org</font></a>&nbsp;or&nbsp;<a title="www.moonsighting.com" href="http://www.moonsighting.com/" target="_blank" style="margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; padding-top: 0px; padding-right: 0px; padding-bottom: 0px; padding-left: 0px; border-top-width: 0px; border-right-width: 0px; border-bottom-width: 0px; border-left-width: 0px; border-style: initial; border-color: initial; outline-width: 0px; outline-style: initial; outline-color: initial; font-style: inherit; font-size: 11px; font-family: Verdana, Arial, Helvetica, sans-serif; vertical-align: baseline; text-decoration: none; color: rgb(17, 85, 204); "><font color="#0066cc">www.moonsighting.com</font></a></div></span></span>''
')
EXEC(N'INSERT INTO [Announcements].[Announcements] ([AnnouncementID], [Title], [ShortDescription], [LongDescription], [StartDate], [EndDate], [Link]) VALUES (4, N''PMP Certification Class'', N''PMP Certification Prep Class at ADAMS'', N''<span class="Apple-style-span" style="font-family: Verdana, Arial, Helvetica, sans-serif; font-size: 11px; background-color: rgb(255, 255, 255); "><p class="MsoNormal" align="center" style="margin-top: 0in; margin-right: 0in; margin-bottom: 0pt; margin-left: 0in; padding-top: 0px; padding-right: 0px; padding-bottom: 0px; padding-left: 0px; border-top-width: 0px; border-right-width: 0px; border-bottom-width: 0px; border-left-width: 0px; border-style: initial; border-color: initial; outline-width: 0px; outline-style: initial; outline-color: initial; font-style: inherit; font-size: 11px; font-family: Verdana, Arial, Helvetica, sans-serif; vertical-align: baseline; line-height: 1.6em; text-align: center; "><b><span style="margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; padding-top: 0px; padding-right: 0px; padding-bottom: 0px; padding-left: 0px; border-top-width: 0px; border-right-width: 0px; border-bottom-width: 0px; border-left-width: 0px; border-style: initial; border-color: initial; outline-width: 0px; outline-style: initial; outline-color: initial; font-style: inherit; font-size: 16pt; font-family: Verdana, Arial, Helvetica, sans-serif; vertical-align: baseline; line-height: 24px; "><font color="#000000"><font face="Calibri">PMP® Certification Prep Class at ADAMS<o:p></o:p></font></font></span></b></p><p class="MsoNormal" align="center" style="margin-top: 0in; margin-right: 0in; margin-bottom: 0pt; margin-left: 0in; padding-top: 0px; padding-right: 0px; padding-bottom: 0px; padding-left: 0px; border-top-width: 0px; border-right-width: 0px; border-bottom-width: 0px; border-left-width: 0px; border-style: initial; border-color: initial; outline-width: 0px; outline-style: initial; outline-color: initial; font-style: inherit; font-size: 11px; font-family: Verdana, Arial, Helvetica, sans-serif; vertical-align: baseline; line-height: 1.6em; text-align: center; "><font color="#000000" size="3" face="Calibri">When: September 17, 18, 24 &amp; 25th, 2011.(Registration closes September 2nd, 2011)</font></p><p class="MsoNormal" align="center" style="margin-top: 0in; margin-right: 0in; margin-bottom: 0pt; margin-left: 0in; padding-top: 0px; padding-right: 0px; padding-bottom: 0px; padding-left: 0px; border-top-width: 0px; border-right-width: 0px; border-bottom-width: 0px; border-left-width: 0px; border-style: initial; border-color: initial; outline-width: 0px; outline-style: initial; outline-color: initial; font-style: inherit; font-size: 11px; font-family: Verdana, Arial, Helvetica, sans-serif; vertical-align: baseline; line-height: 1.6em; text-align: center; "><font color="#000000" size="3" face="Calibri">Time: 8AM to 6:30PM</font></p><p class="MsoNormal" align="center" style="margin-top: 0in; margin-right: 0in; margin-bottom: 0pt; margin-left: 0in; padding-top: 0px; padding-right: 0px; padding-bottom: 0px; padding-left: 0px; border-top-width: 0px; border-right-width: 0px; border-bottom-width: 0px; border-left-width: 0px; border-style: initial; border-color: initial; outline-width: 0px; outline-style: initial; outline-color: initial; font-style: inherit; font-size: 11px; font-family: Verdana, Arial, Helvetica, sans-serif; vertical-align: baseline; line-height: 1.6em; text-align: center; "><font color="#000000" size="3" face="Calibri">Cost: $999 (We accept all major credit cards via PayPal)</font></p><p class="MsoNormal" align="center" style="margin-top: 0in; margin-right: 0in; margin-bottom: 0pt; margin-left: 0in; padding-top: 0px; padding-right: 0px; padding-bottom: 0px; padding-left: 0px; border-top-width: 0px; border-right-width: 0px; border-bottom-width: 0px; border-left-width: 0px; border-style: initial; border-color: initial; outline-width: 0px; outline-style: initial; outline-color: initial; font-style: inherit; font-size: 11px; font-family: Verdana, Arial, Helvetica, sans-serif; vertical-align: baseline; line-height: 1.6em; text-align: center; "><font color="#000000" size="3" face="Calibri">Location: Fai'', ''20110731 00:00:00.000'', ''20110902 00:00:00.000'', N'''')')
EXEC(N'DECLARE @pv binary(16)
'+N'SELECT @pv=TEXTPTR([LongDescription]) FROM [Announcements].[Announcements] WHERE [AnnouncementID]=4
UPDATETEXT [Announcements].[Announcements].[LongDescription] @pv NULL NULL N''rfax Institute, 500 Grove Street, Herndon VA 20170</font></p><p class="MsoNormal" align="center" style="margin-top: 0in; margin-right: 0in; margin-bottom: 0pt; margin-left: 0in; padding-top: 0px; padding-right: 0px; padding-bottom: 0px; padding-left: 0px; border-top-width: 0px; border-right-width: 0px; border-bottom-width: 0px; border-left-width: 0px; border-style: initial; border-color: initial; outline-width: 0px; outline-style: initial; outline-color: initial; font-style: inherit; font-size: 11px; font-family: Verdana, Arial, Helvetica, sans-serif; vertical-align: baseline; line-height: 1.6em; text-align: center; "><font color="#000000" size="3" face="Calibri">Registration:&nbsp;</font><a href="http://inov8solutions.com/" style="margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; padding-top: 0px; padding-right: 0px; padding-bottom: 0px; padding-left: 0px; border-top-width: 0px; border-right-width: 0px; border-bottom-width: 0px; border-left-width: 0px; border-style: initial; border-color: initial; outline-width: 0px; outline-style: initial; outline-color: initial; font-style: inherit; font-size: 11px; font-family: Verdana, Arial, Helvetica, sans-serif; vertical-align: baseline; text-decoration: none; color: rgb(0, 0, 255); "><font color="#0000ff" size="3" face="Calibri">http://inov8solutions.com/</font></a></p><p class="MsoNormal" align="center" style="margin-top: 0in; margin-right: 0in; margin-bottom: 0pt; margin-left: 0in; padding-top: 0px; padding-right: 0px; padding-bottom: 0px; padding-left: 0px; border-top-width: 0px; border-right-width: 0px; border-bottom-width: 0px; border-left-width: 0px; border-style: initial; border-color: initial; outline-width: 0px; outline-style: initial; outline-color: initial; font-style: inherit; font-size: 11px; font-family: Verdana, Arial, Helvetica, sans-serif; vertical-align: baseline; line-height: 1.6em; text-align: center; "><font color="#000000" size="3" face="Calibri">T:&nbsp;<span id="gc-number-0" class="gc-cs-link" title="Call with Google Voice" style="margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; padding-top: 0px; padding-right: 0px; padding-bottom: 0px; padding-left: 0px; border-top-width: 0px; border-right-width: 0px; border-bottom-width: 0px; border-left-width: 0px; border-style: initial; border-color: initial; outline-width: 0px; outline-style: initial; outline-color: initial; font-style: inherit; font-size: 11px; font-family: Verdana, Arial, Helvetica, sans-serif; vertical-align: baseline; color: rgb(0, 51, 187); text-decoration: underline; cursor: pointer; ">(917) 589-7358</span>&nbsp;/ (732) 476-7472</font></p><p class="MsoNormal" align="center" style="margin-top: 0in; margin-right: 0in; margin-bottom: 0pt; margin-left: 0in; padding-top: 0px; padding-right: 0px; padding-bottom: 0px; padding-left: 0px; border-top-width: 0px; border-right-width: 0px; border-bottom-width: 0px; border-left-width: 0px; border-style: initial; border-color: initial; outline-width: 0px; outline-style: initial; outline-color: initial; font-style: inherit; font-size: 11px; font-family: Verdana, Arial, Helvetica, sans-serif; vertical-align: baseline; line-height: 1.6em; text-align: center; "><o:p><font color="#000000" size="3" face="Calibri">&nbsp;</font></o:p></p><p class="MsoNormal" align="center" style="margin-top: 0in; margin-right: 0in; margin-bottom: 0pt; margin-left: 0in; padding-top: 0px; padding-right: 0px; padding-bottom: 0px; padding-left: 0px; border-top-width: 0px; border-right-width: 0px; border-bottom-width: 0px; border-left-width: 0px; border-style: initial; border-color: initial; outline-width: 0px; outline-style: initial; outline-color: initial; font-style: inherit; font-size: 11px; font-family: Verdana, Arial, Helvetica, sans-serif; vertical-align: baseline; line-height: 1.6em; text-align: center; "><b><span style="margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; padding-top: 0px; padding-right: 0px; padding''
UPDATETEXT [Announcements].[Announcements].[LongDescription] @pv NULL NULL N''-bottom: 0px; padding-left: 0px; border-top-width: 0px; border-right-width: 0px; border-bottom-width: 0px; border-left-width: 0px; border-style: initial; border-color: initial; outline-width: 0px; outline-style: initial; outline-color: initial; font-style: inherit; font-size: 16pt; font-family: Verdana, Arial, Helvetica, sans-serif; vertical-align: baseline; line-height: 24px; "><font color="#000000"><font face="Calibri">PMP® Certification Prep Class at ADAMS<o:p></o:p></font></font></span></b></p><p class="MsoNormal" align="center" style="margin-top: 0in; margin-right: 0in; margin-bottom: 0pt; margin-left: 0in; padding-top: 0px; padding-right: 0px; padding-bottom: 0px; padding-left: 0px; border-top-width: 0px; border-right-width: 0px; border-bottom-width: 0px; border-left-width: 0px; border-style: initial; border-color: initial; outline-width: 0px; outline-style: initial; outline-color: initial; font-style: inherit; font-size: 11px; font-family: Verdana, Arial, Helvetica, sans-serif; vertical-align: baseline; line-height: 1.6em; text-align: center; "><font color="#000000" size="3" face="Calibri">When: December 3, 4, 10 &amp; 11th, 2011(Registration closes November 19th, 2011)</font></p><p class="MsoNormal" align="center" style="margin-top: 0in; margin-right: 0in; margin-bottom: 0pt; margin-left: 0in; padding-top: 0px; padding-right: 0px; padding-bottom: 0px; padding-left: 0px; border-top-width: 0px; border-right-width: 0px; border-bottom-width: 0px; border-left-width: 0px; border-style: initial; border-color: initial; outline-width: 0px; outline-style: initial; outline-color: initial; font-style: inherit; font-size: 11px; font-family: Verdana, Arial, Helvetica, sans-serif; vertical-align: baseline; line-height: 1.6em; text-align: center; "><font color="#000000" size="3" face="Calibri">Time: 8AM to 6:30PM</font></p><p class="MsoNormal" align="center" style="margin-top: 0in; margin-right: 0in; margin-bottom: 0pt; margin-left: 0in; padding-top: 0px; padding-right: 0px; padding-bottom: 0px; padding-left: 0px; border-top-width: 0px; border-right-width: 0px; border-bottom-width: 0px; border-left-width: 0px; border-style: initial; border-color: initial; outline-width: 0px; outline-style: initial; outline-color: initial; font-style: inherit; font-size: 11px; font-family: Verdana, Arial, Helvetica, sans-serif; vertical-align: baseline; line-height: 1.6em; text-align: center; "><font color="#000000" size="3" face="Calibri">Cost: $999 (We accept all major credit cards via PayPal)</font></p><p class="MsoNormal" align="center" style="margin-top: 0in; margin-right: 0in; margin-bottom: 0pt; margin-left: 0in; padding-top: 0px; padding-right: 0px; padding-bottom: 0px; padding-left: 0px; border-top-width: 0px; border-right-width: 0px; border-bottom-width: 0px; border-left-width: 0px; border-style: initial; border-color: initial; outline-width: 0px; outline-style: initial; outline-color: initial; font-style: inherit; font-size: 11px; font-family: Verdana, Arial, Helvetica, sans-serif; vertical-align: baseline; line-height: 1.6em; text-align: center; "><font color="#000000" size="3" face="Calibri">Location: Fairfax Institute, 500 Grove Street, Herndon VA 20170</font></p><p class="MsoNormal" align="center" style="margin-top: 0in; margin-right: 0in; margin-bottom: 0pt; margin-left: 0in; padding-top: 0px; padding-right: 0px; padding-bottom: 0px; padding-left: 0px; border-top-width: 0px; border-right-width: 0px; border-bottom-width: 0px; border-left-width: 0px; border-style: initial; border-color: initial; outline-width: 0px; outline-style: initial; outline-color: initial; font-style: inherit; font-size: 11px; font-family: Verdana, Arial, Helvetica, sans-serif; vertical-align: baseline; line-height: 1.6em; text-align: center; "><font color="#000000" size="3" face="Calibri">Registration:&nbsp;</font><a href="http://inov8solutions.com/" style="margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; padding-top: 0px; padding-right: 0p''
UPDATETEXT [Announcements].[Announcements].[LongDescription] @pv NULL NULL N''x; padding-bottom: 0px; padding-left: 0px; border-top-width: 0px; border-right-width: 0px; border-bottom-width: 0px; border-left-width: 0px; border-style: initial; border-color: initial; outline-width: 0px; outline-style: initial; outline-color: initial; font-style: inherit; font-size: 11px; font-family: Verdana, Arial, Helvetica, sans-serif; vertical-align: baseline; text-decoration: none; color: rgb(0, 0, 255); "><font color="#0000ff" size="3" face="Calibri">http://inov8solutions.com/</font></a></p><p class="MsoNormal" align="center" style="margin-top: 0in; margin-right: 0in; margin-bottom: 0pt; margin-left: 0in; padding-top: 0px; padding-right: 0px; padding-bottom: 0px; padding-left: 0px; border-top-width: 0px; border-right-width: 0px; border-bottom-width: 0px; border-left-width: 0px; border-style: initial; border-color: initial; outline-width: 0px; outline-style: initial; outline-color: initial; font-style: inherit; font-size: 11px; font-family: Verdana, Arial, Helvetica, sans-serif; vertical-align: baseline; line-height: 1.6em; text-align: center; "><font color="#000000" size="3" face="Calibri">T:&nbsp;<span id="gc-number-1" class="gc-cs-link" title="Call with Google Voice" style="margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; padding-top: 0px; padding-right: 0px; padding-bottom: 0px; padding-left: 0px; border-top-width: 0px; border-right-width: 0px; border-bottom-width: 0px; border-left-width: 0px; border-style: initial; border-color: initial; outline-width: 0px; outline-style: initial; outline-color: initial; font-style: inherit; font-size: 11px; font-family: Verdana, Arial, Helvetica, sans-serif; vertical-align: baseline; color: rgb(0, 51, 187); text-decoration: underline; cursor: pointer; ">(917) 589-7358</span>&nbsp;/ (732) 476-7472</font></p></span>''
')
INSERT INTO [Announcements].[Announcements] ([AnnouncementID], [Title], [ShortDescription], [LongDescription], [StartDate], [EndDate], [Link]) VALUES (5, N'A Documentary Video', N'A Documentary Video about an Interfaith Seder hosted by ADAMS', N'<span class="Apple-style-span" style="font-family: arial, helvetica, sans-serif; font-size: 11px; background-color: rgb(255, 255, 255); ">A Documentary short about an Interfaith Seder hosted by<br>The All Dulles Area Muslim Society(ADAMS) Mosque and<br>the Washington Area Jews for Jewish-Muslim Understanding<br>Produced By Matt Spangler&nbsp;<br><br>Please see Video Documentary:&nbsp;<a href="http://vimeo.com/24281822" target="_blank" style="margin-top: 0px; margin-right: 0px; margin-bottom: 0px; margin-left: 0px; padding-top: 0px; padding-right: 0px; padding-bottom: 0px; padding-left: 0px; border-top-width: 0px; border-right-width: 0px; border-bottom-width: 0px; border-left-width: 0px; border-style: initial; border-color: initial; outline-width: 0px; outline-style: initial; outline-color: initial; font-style: inherit; font-size: 11px; font-family: Verdana, Arial, Helvetica, sans-serif; vertical-align: baseline; text-decoration: none; color: rgb(17, 85, 204); ">http://vimeo.com/24281822</a></span>', '20110731 00:00:00.000', '20110807 00:00:00.000', N'')
INSERT INTO [Announcements].[Announcements] ([AnnouncementID], [Title], [ShortDescription], [LongDescription], [StartDate], [EndDate], [Link]) VALUES (6, N'Watch Taraweh Live', N'View a live video of taraweh prayer (10PM - 12AM)', N'&nbsp;', '20110802 00:00:00.000', '20110830 00:00:00.000', N'mms://media.adamscenter.org/adams')
SET IDENTITY_INSERT [Announcements].[Announcements] OFF
SET IDENTITY_INSERT [PressReleases].[PressReleases] ON
INSERT INTO [PressReleases].[PressReleases] ([PressReleaseID], [Title], [ShortDescription], [LongDescription], [ReleaseDate]) VALUES (2, N'ADAMS Condemns 911 Attacks', N'The All Dulles Area Muslim Society(ADAMS) Deplores and Condemns The Attacks on the World Trade Center and the Pentagon', N'<p>

        With the Name of God, Most Compassionate, Most Merciful

    </p>

    <p>

        All Dulles Area Muslim Society(ADAMS)

    </p>

    <p>

        FOR IMMEDIATE RELEASE â€“ 9/11/2001

    </p>

    <p>

        The All Dulles Area Muslim Society(ADAMS) Deplores and Condemns The Attacks on the

        World Trade Center and the Pentagon

    </p>

    <p>

        (Herndon, VA â€“ 9/11/2001) â€“ The All Dulles Area Muslim Society(ADAMS), along

        with other Muslim organizations throughout North America, strongly condemns this

        morningâ€™s plane attacks on the World Trade Center and the Pentagon and expresses

        deep sorrow for Americans that were injured and killed. ADAMS sends out its condolence

        to all victims of this cowardly terrorist attack. There is no cause that justifies

        this type of an immoral and inhumane act that has affected so many innocent American

        lives. ADAMS supports all efforts of the investigation in order to track down the

        people responsible for this tragic act of terrorism. We join with all Americans

        in calling for the swift apprehension and punishment of the perpetrators. No political

        cause could ever be assisted by such immoral acts.

    </p>

    <p>

        ADAMS is setting up a Fund to help the victims and the family of victims. ADAMS

        is also arranging a blood donation drive to help the victims and the family of victims.
    </p>
', '20010911 00:00:00.000')
INSERT INTO [PressReleases].[PressReleases] ([PressReleaseID], [Title], [ShortDescription], [LongDescription], [ReleaseDate]) VALUES (3, N'ADAMS Victim of Hate Crimes', N'The All Dulles Area Muslim Society (ADAMS) center and sign at future site has been vandalized as a part of hate crime retaliation. ', N'<p>

        With the Name of God, Most Compassionate, Most Merciful

    </p>

    <p>

        All Dulles Area Muslim Society(ADAMS)

    </p>

    <p>

        FOR IMMEDIATE RELEASE 9/12/2001

    </p>

    <p>

        The All Dulles Area Muslim Society (ADAMS) center and sign at future site has been

        vandalized as a part of hate crime retaliation.

    </p>

    <p>

        (Herndon, VA 9/12/2001) This morning the ADAMS Sterling Mosque hallway was vandalized

        with profanity and graffiti and the sign at its future construction site at Herndon

        on Sugarland Road and Drainesville Road was also vandalized with profanity and graffiti.

        The Police have been contacted and ADAMS is working with them.

    </p>

    <p>

        Threats have been received by many Muslim organizations across the U. S. and Muslims

        have been and continue to be harassed. Muslim women that wear the headcovering have

        been harassed and fear for their safety.

    </p>

    <p>

        The seven million American Muslims should NOT be persecuted for the acts of a few

        insane individuals. These inhumane terrorists DO NOT represent Islam or Muslims.

        In fact, American Muslims worked in the World Trade Center and the Pentagon and

        are among the victims along with all of humanity in this horrible and despicable

        terrorist attack.

    </p>

    <p>

        The ADAMS Center took part in and spoke at an interfaith service on September 11

        at 7:30pm which was organized by the United Chrisitian Parish. Chrisitian, Jewish,

        and Muslim people took part in the service and over 300 people attended. The message

        of the evening was condemnation of the horrible terrorist attacks and the seeking

        of peace, brotherhood, and tolerance.

    </p>

    <p>

        The All Dulles Area Muslim Society Society(ADAMS), along with other Muslim organizations

        throughout North America, strongly condemns the terrorist attacks and expresses

        deep sorrow for Americans that were injured and killed. ADAMS sends its condolences

        to all victims of this cowardly terrorist attack. ADAMS supports all efforts of

        the investigation in order to track down the people responsible for this tragic

        act of terrorism. We join with all Americans in calling for the swift apprehension

        and punishment of the perpetrators.

    </p>

    <p>

        ADAMS is setting up a fund and a blood donation drive to help the victims and their

        families

    </p>
', '20010912 00:00:00.000')
INSERT INTO [PressReleases].[PressReleases] ([PressReleaseID], [Title], [ShortDescription], [LongDescription], [ReleaseDate]) VALUES (4, N'ADAMS Hosts Interfaith for Northern Ireland', N'ADAMS Center Hosted Interfaith gathering for 36 youth from Children''s Friendship Project for Northern Ireland. ', N'<p>

        ADAMS Center Hosted Interfaith gathering for 36 youth from Children''s Friendship

        Project for Northern Ireland on Monday Aug 2, 2004

    </p>

    <p>

        WHAT:

        <br />

        On Monday Aug 2, 2004 at 10:00am to 5:00pm, the ADAMS Center will host Children''s

        Friendship Project for Northern Ireland. The main goal of this program is to provide

        the kids with leadership tools they can use to promote Peace, Respect and Tolerance,

        wherever they are. The teens get to know each other as individuals and establish

        relationships.

    </p>

    <p>

        This session at ADAMS Center is just a 1 day part of an overall 3-week program.

        This year they have brought 36 teenagers so they can spend some time in a neutral

        place knowing each other and engage in a constructive dialogue.

    </p>

    <p>

        Sharon Harroun is the Chairperson for the Children''s Friendship Project for Northern

        Ireland. This purpose of this organization is to work with Northern Irish kids so

        they can end the political/religious conflict in that country

    </p>

    <p>

        Agenda:

        <br />

        1- Interfaith presentation by leaders of various Faith communities.

        <br />

        2- Interfaith Dialog with teens from ADAMS.

        <br />

        3- Working session with facilitators

    </p>
', '20040802 00:00:00.000')
INSERT INTO [PressReleases].[PressReleases] ([PressReleaseID], [Title], [ShortDescription], [LongDescription], [ReleaseDate]) VALUES (5, N'PEACE Gathering Held at ADAMS On 9/11', N'Muslim, Christian, Jewish, and Sikh Faith members to hold PEACE Gathering at the ADAMS Center ON 9/11 ANNIVERSARY at 5:00-8:00pm,Prayers for peace and national unity to be offered at all events ', N'<p>

        In the Name of God, The Compassionate, The Merciful

    </p>

    <p>

        All Dulles Area Muslim Society (ADAMS)

    </p>

    <p>

        FOR IMMEDIATE RELEASE 9/8/2004

    </p>

    <p>

        Muslim, Christian, Jewish, and Sikh Faith members to hold PEACE Gathering at the

        ADAMS Center ON 9/11 ANNIVERSARY at 5:00-8:00pm,Prayers for peace and national unity

        to be offered at all events.

    </p>

    <p>

        WHAT: On Saturday, September 11, 2004, members of the ADAMS Center will conduct

        and take part in many interfaith activities. ADAMS will hold an Interfaith PEACE

        Banquet at the ADAMS Center in Sterling, VA, from 5:00pm-8:00pm, in remembrance

        of the victims of the World Trade Center and Pentagon attacks. Representatives of

        Christian, Jewish, and Sikh Faiths will be represented and speaking at this event.

        ADAMS will also be honoring Local Police and Fire Departments for their continuous

        community service. Local Government Officials will also be speaking at this event.

        The ADAMS community will also participate in an Interfaith Housing Project for the

        Homeless in Washington DC on Sat Sept 11, 2004 from 8am to 4:30pm. In addition,

        ADAMS will participate in Northern Virginia Interfaith Vigil overnight at ADAMS

        Center on Satruday Sept 11, 2004 at 9pm

    </p>

    <p>

        In this time of reflection, our hearts are with the victims and the families of

        the victims of the September 11th tragedy and our prayers are for peace and compassion.

        Only through getting to know one another on a personal level can people of different

        faiths build bridges of understanding respect, and tolerance. There are an estimated

        120,000 Muslims in the DC Metro area and some seven million nationwide.

    </p>
', '20040911 00:00:00.000')
INSERT INTO [PressReleases].[PressReleases] ([PressReleaseID], [Title], [ShortDescription], [LongDescription], [ReleaseDate]) VALUES (6, N'Hispanic Heritage Festival', N'Hispanic Heritage Festival at the ADAMS Center ', N'<p>

        All Dulles Area Muslim Society (ADAMS)

    </p>

    <p>

        ADAMS Center Presents

        <br />

        Hispanic Heritage Festival at the ADAMS Center

        <br />

        Sunday, September 19, 2004 at 12-6pm

    </p>

    <p>

        WHAT:

        <br />

        On Sunday September 19, 2004 at 12:00pm to 6:00pm, the ADAMS Center will host the

        ADAMS Hispanic Heritage Festival . It is an Event for Familes to attend and experience

        the diversity of Hispanic Cultures. ADAMS has invited the public, neighbors, and

        the Interfaith community to this festival.

    </p>

    <p>

        Discover the Diverse Hispanic Cultures Discover the Array of languages Hispanic

        Speak Information on Strong Ties between Islamic and Hispanic Cultures Sample a

        Variety of Hispanic Cuisine Fun and activities for children and bigger children,

        too!

    </p>
', '20040919 00:00:00.000')
EXEC(N'INSERT INTO [PressReleases].[PressReleases] ([PressReleaseID], [Title], [ShortDescription], [LongDescription], [ReleaseDate]) VALUES (7, N''Islamic Influences in Contemporary Ceramics'', N''The ADAMS Center Sponsors the Target Gallery, the national exhibition space at the Torpedo Factory Art Center, will host an important cross-cultural exhibition entitled Fertile Earth: Islamic Influences in Contemporary Ceramics.'', N''<p>

        NEWS RELEASE: NCECA Exhibition Explores Islamic Influences in Contemporary Ceramics

    </p>

    <p>

        at the

        <br />

        Torpedo Factory Art Center

        <br />

        105 North Union Street, Alexandria, VA 22314

        <br />

        targetgallery@torpedofactory.org

    </p>

    <p>

        March 3, 2005

        <br />

        FOR IMMEDIATE RELEASE

        <br />

        CONTACT & IMAGES: Claire Huschle, (703) 838-4565 x 4
    </p>

    <p>

        NCECA Exhibition Explores Islamic Influences in Contemporary Ceramics

    </p>

    <p>

        Torpedo Factory Celebrates Ceramics and Cultural Exchange in March and April

    </p>

    <p>

        Alexandria, VAâ€” From March 16 through April 24, 2005, Target Gallery, the national

        exhibition space at the Torpedo Factory Art Center, will host an important cross-cultural

        exhibition entitled Fertile Earth: Islamic Influences in Contemporary Ceramics.

        The show is part of the National Council on Education in the Ceramic Arts (NCECA)

        annual conference (March 16-20) in Baltimore/Washington, DC. Karen Koblitz, a Los

        Angeles-based sculptor, curated the exhibition.

    </p>

    <p>

        A reception and panel discussion on Islamic influences on the arts will be held

        on Sunday, March 20, between 5-8 pm. Lebanese Taverna Restaurant will provide a

        culinary program, Cultural Exchange in Cuisine, at the reception. The exhibition

        has inspired a series of programs throughout the months of March and April at the

        Torpedo Factory Art Center, from Middle Eastern music and dance to a children''''s

        event recreating the archaeological excavation of ceramics.

    </p>

    <p>

        Fertile Earth and its related programs are made possible by the generous support

        and partnership of the Adams Center, a Muslim community center in Northern Virginia;

        the national and regional offices of the Council on American-Islamic Relations (CAIR),

        America''''s largest Muslim civil liberties group; the American-Turkish Association

        of Washington, D.C.; Lebanese Taverna Restaurant; and members of the Friends of

        the Torpedo Factory Art Center, a non- profit organization supporting the outreach

        programs of the art center.

    </p>

    <p>

        The nine ceramists in Fertile Earth use the decoration and techniques from the rich

        artistic heritage of Islam to demonstrate how contemporary artists are keeping ancient

        styles and methods alive. These sculptors are among the most lauded in the world

        of ceramic art. They are Alan Caiger-Smith (United Kingdom), Sanam Emami (United

        States), Neil Forrest (Canada), Andrea Gill (United States), Amanda Jaffe (United

        States), Karen Koblitz (United States), Nermin Kura (United States), Liz Quackenbush

        (United States), and Carolinda Tolstoy (United Kingdom). A digital catalogue of

        the exhibition is available through the gallery.

    </p>

    <p>

        In addition to the culinary presentation by Lebanese Taverna, the March 20 reception

        will include a panel discussion on cultural exchange in the creative arts at 6 PM,

        and all 14 ceramic studios and galleries in the Torpedo Factory will be open for

        visitors. On Saturday, April 2, at 2 PM, the Alexandria Archaeology Museum on the

        third floor will present a children''''s program entitled The Potter''''s Art (reservations

        required). On April 14, from 6-9 PM, Second Thursday Art Night, ceramic studios

        will present demonstrations for the public. For a complete description of programs

        related to the Fertile Earth exhibition, contact the Target Gallery at 703- 838-4565,

        extension 4, or visit the Torpedo Factory website at www.torpedofactory.org. Unless

        otherwise noted, all events and receptions are free of ch'', ''20050303 00:00:00.000'')')
SELECT @pv=TEXTPTR([LongDescription]) FROM [PressReleases].[PressReleases] WHERE [PressReleaseID]=7
UPDATETEXT [PressReleases].[PressReleases].[LongDescription] @pv NULL NULL N'arge and open to the public.

    </p>

    <p>

        Target Gallery is the national exhibition space of the Torpedo Factory Art Center,

        displaying artwork in all media from artists across the United States and abroad.

        Target is open to the public Wednesday through Sunday, 12 noon to 5 pm and other

        times by appointment. Contact the gallery at (703) 838-4565, ext. 4 or by e- mail

        at targetgallery@torpedofactory.org. The Torpedo Factory is located at 105 N. Union

        Street, Alexandria, VA.

    </p>
'
INSERT INTO [PressReleases].[PressReleases] ([PressReleaseID], [Title], [ShortDescription], [LongDescription], [ReleaseDate]) VALUES (8, N'ADAMS Hosts Peace Gathering for Madrid', N'The ADAMS Center in Sterling Virginia hosted a visit by Borja Montesino, Political Counselor at the Embassy of Spain in Washington, D.C. to attend a special prayer service in memory of those who lost their lives in the recent attacks in Madrid.', N'<p>

        On Friday, March 26, 2004, the ADAMS Center in Sterling Virginia hosted a visit

        by Borja Montesino, Political Counselor at the Embassy of Spain in Washington, D.C.

        to attend a special prayer service in memory of those who lost their lives in the

        recent attacks in Madrid, and to pray for peace and understanding among people of

        all faiths and in all countries.

    </p>

    <p>

        Mr. Montesino, a senior career diplomat at the Spanish Embassy, represented Spanish

        Ambassador Javier Ruperez, who is in Spain of consultations. The prayer service

        was led by ADAMS Imam Mohamed Magid, and was attended by the many hundreds of Muslim

        men, women and children who had come to the Mosque for the regular Friday prayers,

        and remained afterwards to show their support for the gesture of support to those

        who had been killed or injured in the attacks.

    </p>

    <p>

        Imam Magid spoke in his sermon about the need for peace between all faith and goodwill,

        and noted the tragedy had a major impact on the lives of everyone it has touched,

        no matter what their religion may be, and that we must all ask Godâ€™s help to stop

        this from happening again. â€œNothing justifies targeting of civilians, in Spain,

        the United States, Iraq, Palestine, or anywhere else. This violates the word and

        the spirit of the Quran,â€ noted the Imam.

    </p>

    <p>

        ADAMS Government Relations Chairman Robert Marro, in introducing Counsellor Montesino,

        also noted that Islam has never condoned violence against civilians, and in fact

        the Quran is quite specific in forbidding any attacks on non-combatants, even in

        wartime.

    </p>

    <p>

        â€œThroughout historyâ€, explained Marro, â€œIslam has been spread far more often

        by peaceful persuasion than by force of arms, and even in war, any wanton attacks

        on innocent civilians have been strictly forbidden. It is bitterly ironic this attack

        occurred in Spain, which for centuries had been a model of harmony between Muslims,

        Christians and Jews, the center of civilization and learning in Europe, and a conduit

        for dissemination of classical scientific knowledge to the West.â€.

    </p>

    <p>

        ADAMS has been involved in many interfaith activities and outreach, and has often

        expressed its own strong appreciation for the support of the local community when

        its own community members, or its facilities, have been targets of discrimination

        and other attacks in the past months and years. â€This event with the Spanish Embassy

        will show the Muslim Community is steadfast in its opposition to any activities

        that put innocent lives at risk, explained Imam Magid. â€œI was very pleased

        with the many members of our community who came to speak to Mr. Montesino after

        the service, to personally express their sorrow and condolence for these innocent

        victims. I hope it will show Mr. Montesino and his colleagues and all the people

        in Spain that our community has the strongest sympathy with our Spanish brothers

        and sisters

    </p>
', '20040326 00:00:00.000')
INSERT INTO [PressReleases].[PressReleases] ([PressReleaseID], [Title], [ShortDescription], [LongDescription], [ReleaseDate]) VALUES (9, N'ADAMS Expresses Sympathies for Pope John Paul II', N'The All Dulles Area Muslim Society(ADAMS) would like to express our deepest sympathies to the Catholic Community for the loss of Pope John Paul II', N'<p>

        The All Dulles Area Muslim Society(ADAMS) would like to express our deepest sympathies

        to the Catholic Community for the loss of Pope John Paul II

    </p>

    <p>

        The All Dulles Area Muslim Society(ADAMS) would like to express our deepest sympathies

        to the Catholic Community for the loss of one of the worldâ€™s most prominent spiritual

        leaders who stood for religious freedom, human rights, and building bridges. Pope

        John Paul, II was a great champion of interfaith work and he will be sadly missed

        by all. Muslims worldwide respected Pope John Paul II as an advocate for justice

        and human rights

    </p>

    <p>

        We hope that his legacy will be celebrated, because death for great men of history

        does not signify the end of the good works in which they leave behind. We pray that

        the Church will continue to carry this great legacy.

    </p>

    <p>

        Many community members of ADAMS, including the Imam, President, & Committee Leaders,

        have extended family and in-Laws that are Catholic.

    </p>

    <p>

        On March 06, 2005 the Reston Trialogue, (All Dulles Area Muslim Society(ADAMS),

        Northern Virginia Hebrew Congregation and St. Thomas Ã Beckett) held an Interfaith

        Panel about "The Role of Women in Judaism, Catholicism and Islam" The event took

        place at the ADAMS center from 7:00 p.m. to 9:00 p.m. This event marked Women''s

        History Month which is March. This is a part of a two year-long ongoing Interfaith

        Trialogue that started in 2003. Over 140 Catholic, Jewish, and Muslims attended

        the event.

    </p>

    <p>

        We hope to continue to build bridges and friendships between our Faith Communities

        and Remember the Legacy of Pope John Paul II.

    </p>
', '20050402 00:00:00.000')
INSERT INTO [PressReleases].[PressReleases] ([PressReleaseID], [Title], [ShortDescription], [LongDescription], [ReleaseDate]) VALUES (10, N'National Hunger Awareness Day', N'The All Dulles Area Muslim Society(ADAMS) and Al-Fatih Academy Supports and Participate in National Hunger Awareness Day.', N'<p>

        The All Dulles Area Muslim Society(ADAMS) and Al-Fatih Academy Supports and Participate

        in National Hunger Awareness Day.

    </p>

    <p>

        WHAT: The All Dulles Area Muslim Society(ADAMS) and Al-Fatih Academy supports National

        Hunger Awareness Day. The ADAMS Community and Al-Faith Academy coordinated a Canned

        Food Drive and will donate canned food to a local shelter. ADAMS Community members

        and Al-Faith Academy students will also be participating in the Hunger No More:

        An Interfaith Convocation at Washington National Cathedral, on Monday, June 6, 2005,

        7:00 pm.

    </p>

    <p>

        The All Dulles Area Muslim Society(ADAMS) has a long history of community service

        through various programs. ADAMS is a member of Reston Interfaith. ADAMS coordinates

        Food Drives for the Homeless during the 2 major Eid Festivals a year. ADAMS has

        participated in the "Warmth for the Winter Project providing coats to the Day Laborers

        and their families in Herndon. For more information on ADAMS Community Service Projects

        please visit <a href="../../Community/CommunityService.aspx">CommunityService

            Page</a>.

    </p>
', '20050606 00:00:00.000')
INSERT INTO [PressReleases].[PressReleases] ([PressReleaseID], [Title], [ShortDescription], [LongDescription], [ReleaseDate]) VALUES (11, N'Girl Scouts Annual Recognitions Ceremony', N'All Dulles Area Muslim Society(ADAMS) Girl Scouts Annual Recognitions Ceremony on Saturday June 11, 2005 from 11:30am to 2:00pm.', N'<p>

        ADAMS Center Presents

        <br />

        All Dulles Area Muslim Society(ADAMS) Girl Scouts Annual Recognitions

        <br />

        Ceremony on Saturday June 11, 2005 from 11:30am to 2:00pm

    </p>

    <p>

        WHAT: All Dulles Area Muslim Society(ADAMS) Girl Scouts Annual Recognitions Ceremony

        on Saturday June 11, 2005 from 11:30am to 2:00pm Every year ADAMS Center commemorates

        and recognizes its Girl Scout troopsâ€™ accomplishments by conducting an Annual

        Recognitions Ceremony. This ceremony enables girls to share in a special part of

        Girl Scout history and create their own special memories. The ADAMS Girl Scouts

        program provides many exciting opportunities! Girls learn and participate in activities,

        help their community, make new friends, and learn more about themselves all while

        having the time of their lives!

    </p>

    <p>

        At this yearâ€™s ceremony, Girl Scouts of all levels will receive numerous patches

        and awards and Troop Leaders will receive awards of appreciation. A moment will

        also be taken to recognize Ms. Margaret Farchtchi, an ADAMS Girl Scout Troop Leader

        and recipient of the â€œOutstanding Volunteerâ€ Award from the Girl Scouts Council

        of the Nationâ€™s Capital.

    </p>
', '20050611 00:00:00.000')
INSERT INTO [PressReleases].[PressReleases] ([PressReleaseID], [Title], [ShortDescription], [LongDescription], [ReleaseDate]) VALUES (12, N'Interfaith Golf Tournament', N'Interfaith Guests have been invited to participate in an Interfaith Golf tournament. ', N'<p>

        ADAMS Center Presents

        <br />

        ADAMS 2nd Muslim Sports League Golf Classic on

        <br />

        Sat June 25, 2005 at 1-5pm. Interfaith Guests have been invited to participate.

    </p>

    <p>

        WHAT: This is the 2nd Golf tournament sponsored by the ADAMS Center Muslim Sports

        League. We have invited Interfaith Guests to join the tournament, as well. There

        will be a Round of 18 holes including cart, lunch buffet, Long Ball Competition,

        Closest to Pin Competition, and Prizes The event will be held on June 25th, 2005

        @ Penderbrook Golf Course in Fairlakes, VA.

    </p>

    <p>

        The ADAMS Center and Muslim Sports League encourage the community to get involved

        in sports and exercise to keep the mind and body healthy. We feel sports are a good

        way to build bonds of friendship and community. The ADAMS Center and Muslim Sports

        League coordinate many other sports activities like Basketball, Soccer, Football,

        Badminton, Cricket, Ping Pong, Skiing, and more.

        <br />

        The ADAMS Muslim Sports League has also sponsored several Community Service Activities

        to help the Homeless.

    </p>

    <p>

        For More information on the ADAMS Muslim Sports League

        <br />

        <a href="http://www.muslimsportsleague.org">http://www.muslimsportsleague.org</a>

    </p>
', '20050625 00:00:00.000')
INSERT INTO [PressReleases].[PressReleases] ([PressReleaseID], [Title], [ShortDescription], [LongDescription], [ReleaseDate]) VALUES (13, N'ADAMS Condemns London Attacks', N'The All Dulles Area Muslim Society(ADAMS) Deplores and Condemns The Attacks in London as "barbaric crimes." ', N'<p>

        With the Name of God, Most Compassionate, Most Merciful

    </p>

    <p>

        All Dulles Area Muslim Society (ADAMS)

    </p>

    <p>

        -- MEDIA ADVISORY--

    </p>

    <p>

        FOR IMMEDIATE RELEASE â€“ 7/7/2005

    </p>

    <p>

        The All Dulles Area Muslim Society(ADAMS) Deplores and Condemns The Attacks in London

        as "barbaric crimes."

    </p>

    <p>

        (Sterling, VA â€“ 7/7/2005) â€“ The All Dulles Area Muslim Society(ADAMS), along

        with other Muslim organizations throughout North America condemn these barbaric

        crimes that can never be justified or excused. American Muslims offer their sincere

        condolences to the loved ones of those who were killed or injured in today''s attacks

        and call for the swift apprehension and punishment of the perpetrators.

    </p>

    <p>

        "Islam, the religion of tolerance, holds the human soul in high esteem, and considers

        the attack against innocent human beings a grave sin, this is backed by the Qur''anic

        verse which reads:

    </p>

    <p>

        "Who so ever kills a human being for other than manslaughter or corruption in the

        earth, it shall be as if he has killed all mankind, and who so ever saves the life

        of one, it shall be as if he had saved the life of all mankind," (Quran).

    </p>

    <p>

        Friday is a Muslim Holy Day and during our Sermons we will be condemning these terrorist

        attacks. In addition, during the Sermons we will be saying a special prayer and

        condolences to families of those who were killed or injured.

    </p>

    <p>

        The All Dulles Area Muslim Society(ADAMS) is one of the largest Mosques in the DC

        Metro Area and in the United States. ADAMS is a Non Profit 501c3 Organization. ADAMS

        serves over 5000 Families and has 7 Branches(Sterling/Herndon, Tysons Corner, Fairfax,

        Reston, Leesburg, Ashburn, and South Riding) in Northern Virginia. ADAMS center

        is governed by a 13 Member Democratically Elected Board of Trustees comprising of

        Men and Women. ADAMS engages in regular Interfaith, Government Relations, Social

        Services, and Community Service. ADAMS has one of the largest Cub Scout, Boy Scout,

        and Girl Scout programs in the DC Metro area. The ADAMS Center serves on an advisory

        council to the FBI Washington Field Office. In addition, we have hosted FBI Town

        Hall meetings at the ADAMS Center. VA</p>
', '20050707 00:00:00.000')
INSERT INTO [PressReleases].[PressReleases] ([PressReleaseID], [Title], [ShortDescription], [LongDescription], [ReleaseDate]) VALUES (14, N'ADAMS Condemns Egypt Attacks', N'All Dulles Area Muslim Society(ADAMS) CONDEMNS Terrorist Attacks in EGYPT ', N'<p>

        All Dulles Area Muslim Society(ADAMS) CONDEMNS Terrorist Attacks in EGYPT

    </p>

    <p>

        (Sterling, VA., 7/23/05) - The All Dulles Area Muslim Society(ADAMS) c condemns

        the bomb attacks in the Egyptian resort of Sharm el-Sheik early Saturday (local

        time) that left at least 80 people dead and many more wounded.

    </p>

    <p>

        It is with great sadness and revulsion that we once again witness senseless attacks

        on innocent civilian. American Muslims condemn these brutal attacks, offer their

        sincere condolences to the loved ones of those who were killed or injured and call

        for the swift apprehension and punishment of the perpetrator

    </p>

    <p>

        ADAMS again addressed the issue of Condemning Terrorism and promoting PEACE in all

        the 10 Friday Prayers held in 5 ADAMS Friday Prayer Locations.

    </p>

    <p>

        ADAMS feels we all need to re-double our efforts to promote Tolerance, PEACE, and

        Respect.

    </p>
', '20050723 00:00:00.000')
INSERT INTO [PressReleases].[PressReleases] ([PressReleaseID], [Title], [ShortDescription], [LongDescription], [ReleaseDate]) VALUES (15, N'ADAMS Backs Fatwa Against Terror', N'The All Dulles Area Muslim Society(ADAMS) BACKS FATWA( Islamic religious ruling) AGAINST TERROR ', N'<h1>

        Fatwa Against Terror</h1>

    <p>

        With the Name of God, Most Compassionate, Most Merciful

    </p>

    <p>

        All Dulles Area Muslim Society (ADAMS)

    </p>

    <p>

        -- MEDIA ADVISORY--

    </p>

    <p>

        FOR IMMEDIATE RELEASE ? 7/28/2005

    </p>

    <p>

        The All Dulles Area Muslim Society(ADAMS) BACKS FATWA(Islamic religious ruling)

        AGAINST TERROR

    </p>

    <p>

        (Sterling, VA 7/28/2005) The All Dulles Area Muslim Society(ADAMS) today offered

        its support for a fatwa, or Islamic religious ruling, against terrorism and extremism

        issued by the Fiqh Council of North America (FCNA) and endorsed by more than 120

        U.S. Muslim groups, leaders and institutions. (The term "fiqh" refers to Islamic

        jurisprudence.) In addtion, Almost 700,000 US Muslims and their Family?s have signed

        a petition condemning Terrorism

    </p>

    <p>

        The fatwa, released during a news conference on 7/28/2005 at the National Press

        Club in Washington, D.C., states in part:

    </p>

    <p>

        "Islam strictly condemns religious extremism and the use of violence against innocent

        lives. There is no justification in Islam for extremism or terrorism. Targeting

        civilians'' life and property through suicide bombings or any other method of attack

        is haram - or forbidden - and those who commit these barbaric acts are criminals,

        not ''martyrs''. . .In the light of the teachings of the Qur''an and Sunnah we clearly

        and strongly state:

    </p>

    <p>

        1. All acts of terrorism targeting civilians are haram (forbidden) in Islam.

    </p>

    <p>

        2. It is haram for a Muslim to cooperate with any individual or group that is involved

        in any act of terrorism or violence. 3. It is the civic and religious duty of Muslims

        to cooperate with law enforcement authorities to protect the lives of all civilians.

        We issue this fatwa following the guidance of our scripture, the Qur''an, and the

        teachings of our Prophet Muhammad - peace be upon him."

    </p>

    <p>

        It should be noted that American Muslims have repeatedly condemned Terrorism and

        Violence. American Muslims are working for PEACE, Dialogue, and Respect.

    </p>

    <p>

        SEE THE FULL TEXT OF FATWA AT: <a href="http://www.isna.net/316.0.html?&no_cache=1&sword_list[]=Fatwa">http://www.isna.net/316.0.html?&no_cache=1&sword_list[]=Fatwa</a>

    </p>
', '20050728 00:00:00.000')
INSERT INTO [PressReleases].[PressReleases] ([PressReleaseID], [Title], [ShortDescription], [LongDescription], [ReleaseDate]) VALUES (16, N'5th Annual Northern Virginia Civic Picnic', N'Northern Virginia Mosques and Organizations organize the 5th Annual Northern Virginia Civic Picnic on August 20, 2005 ', N'<p>

        In The name of God, the Compassionate, the Merciful

    </p>

    <p>

        All Dulles Area Muslim Society (ADAMS)

    </p>

    <p>

        FOR IMMEDIATE RELEASE

    </p>

    <p>

        Northern Virginia Mosques and Organizations organize the 5th Annual Northern Virginia

        Civic Picnic on August 20, 2005 at Lake Fairfax Park 16 Candidates for Virginia

        State Offices, 4 Local Government Officials, and Interfaith Representatives will

        be speaking.

    </p>

    <p>

        What: Northern Virginia Mosques and Organization are holding the 5th Annual Northern

        Virginia Family and Civic Picnic on Saturday Aug 20, 2005 from 2:00 pm â€“ 5:00

        pm at Lake Fairfax Park in Reston, VA. ADAMS, Dar Al-Hijrah, Manassas Mosque, Muslim

        Assocation of Virgina, MAS Freedom Foundation, MPAC, CAIR are 501(c) Non Profit

        organizations and consequently will be inviting all candidates from all parties

        to address the community. In addition, Local Government Officials and Interfaith

        Representatives will be addressing the community. Civic involvement, Voter Registration

        and Family fun will be the theme of the picnic.

    </p>

    <p>

        Details: The Muslim community of Northern Virginia has made it a priority to encourage

        our community to be involved with local and state government elections and other

        civic issues. ADAMS, Dar Al-Hijrah Islamic Center, Manassas Mosque, and Muslim Association

        of Virginia serve a community of over 50,000 people. Our regional religious celebrations

        attract over 20,000 people from Northern Virginia. We continue to conduct voter

        registration drives, as we are planning one for this event, and encourage civic

        involvement at our centers and our activities.

    </p>
', '20050820 00:00:00.000')
INSERT INTO [PressReleases].[PressReleases] ([PressReleaseID], [Title], [ShortDescription], [LongDescription], [ReleaseDate]) VALUES (17, N'ADAMS Interfaith Peace', N'ADAMS Interfaith Peace Activities for 9/11 ', N'<p>

        In the Name of God, The Compassionate, The Merciful

    </p>

    <p>

        All Dulles Area Muslim Society (ADAMS)

    </p>

    <p>

        FOR IMMEDIATE RELEASE 9/6/2005

    </p>

    <p>

        On Sept 10, 2005 at 6pm-9pm, Muslim, Christian, Jewish, and Sikh Faith members to

        hold 4th Annual PEACE Gathering at the ADAMS Center.

    </p>

    <p>

        On Sept 10, 2005 at 11am, ADAMS Imam will preside over funeral in New York for ADAMS

        Center MemberÂ¡Â¦s Family that were Muslim Victims of 9/11 Terrorist Attacks

    </p>

    <p>

        On Sept 11, 2005 at 1:30pm-4:00pm, ADAMS to take part in Interfaith Unity Walk in

        DC on 9/11 from Washington Hebrew Congregation, to the Islamic Center.

    </p>

    <p>

        WHAT: On Saturday, September 10, 2005 and Sunday September 11, 2005, members of

        the All Dulles Area Muslim society(ADAMS) will conduct and take part in many interfaith

        activities. In this time of reflection, our hearts are with the victims and the

        families of the victims of the September 11th tragedy and our prayers are for peace

        and compassion. Through getting to know one another on a personal level, people

        of different faiths can build bridges of understanding respect, and tolerance. American

        Muslims Condemn Terrorism and Extremism.

    </p>

    <p>

        On Saturday September 10, 2005 at 6pm-9pm, ADAMS will hold the 4th Annual Interfaith

        PEACE Gathering at the ADAMS Center in Sterling, VA, in remembrance of the victims

        of the World Trade Center and Pentagon attacks. Representatives of Christian, Jewish,

        and Sikh Faiths will be represented and speaking at this event. ADAMS will also

        be honoring Local Police and Fire Departments for their continuous community service.

        Local Government Officials will also be speaking at this event.

    </p>

    <p>

        On Saturday September 10, 2005 at 11am, ADAMS Center Executive Director, Imam Mohamed

        Magid will preside over the funeral services in New York(7602 Rockaway Blvd, Woodhaven,

        NY 11421) for recently confirmed Muslim Victims of 9/11 Terrorist Attacks at the

        World Trade Center. The Daugther(Ms. Shakila Yasmin) and Son-In Law(Nurul Haque

        Mian) of Mr. Sharif A.Chowdhury(Member of ADAMS) were among the victims that were

        killed on 9/11 and their remains were confirmed by DNA testing just recently.

    </p>

    <p>

        On Sunday September 11, 2005 at 1:30pm-4:00pm, The ADAMS community will also participate

        in the Interfaith Unity Walk(www.dcunitywalk.com) in Washington DC from Washington

        Hebrew Congregation to the Islamic Center. The Walk starts at 3935 Macomb Street,

        NW Washington, DC 20016. This unprecedented 9/11 Unity Walk will be launched at

        Washington Hebrew Congregation by the renowned Abrahamic Partners, Ambassador Akbar

        Ahmed of American University, Episcopal Bishop John Chane, and their host Senior

        Rabbi Bruce Lustig. The Purpose Statement for the 9/11 Unity Walk reads: Â¡Â§We

        walk together as neighbors from many faiths and cultures. We gather in peace to

        demonstrate our unity, recalling the spirit of togetherness that grew out of 9/11.

        We commemorate this day because concern for each otherÂ¡Â¦s welfare is the shared

        hope of us all.

    </p>
', '20050909 00:00:00.000')
INSERT INTO [PressReleases].[PressReleases] ([PressReleaseID], [Title], [ShortDescription], [LongDescription], [ReleaseDate]) VALUES (18, N'Hurricane Katrina Relief Efforts', N'The All Dulles Area Muslim Society(ADAMS) and Al-Fatih Academy Support and Participate in Hurricane Katrina Relief Efforts by collecting donations since Sept 2, 2005 and supporting the  Dulles Area Community Network Katrina Food/Supply Effort. ', N'<p>

        Sept 16, 2005

    </p>

    <p>

        The All Dulles Area Muslim Society(ADAMS) and Al-Fatih Academy Support and Participate

        in Hurricane Katrina Relief Efforts by collecting donations since Sept 2, 2005 and

        supporting the

    </p>

    <p>

        Dulles Area Community Network Katrina Food/Supply Effort.

    </p>

    <p>

        ADAMS Imam/Executive Director is taking part in National Day of Prayer for Hurricane

        Victims at the National Cathedral on Friday Sept 16, 2005 at 11am.

    </p>

    <p>

        American Muslim Relief Groups Pledge $10 Million to help Hurricane Victims and 3000

        Houston Muslims Help the Victims at the Astrodome.

    </p>

    <p>

        WHAT: The All Dulles Area Muslim Society(ADAMS) and Al-Fatih Academy support the

        Dulles Area Community Networking Effort(http://www.dullesareacommunity.net/ ) to

        collect food and supplies and take it down to affected areas in Louisiana to help

        evacuees. The ADAMS Center(46903 Sugarland Road, Sterling, VA 20164) is a drop off

        location for canned food, dry food, and supplies. Also, Tax Deductible donations

        for the Dulles Area Networking Relief Effort canbe written payable to ADAMS. The

        coordination is occurring at the Herndon Police Station. In addition, Al-Faith Academy

        Students collected and helped sort supplies at the Herndon Police Station at 11am

        on Friday Sept 16, 2005.

    </p>

    <p>

        Since Fri Sept 2, The ADAMS Community and Youth Groups have been collecting donations

        at our Friday Prayers in Sterling, Reston, Fairfax, Leesburg, and Tysons Corner

        for Hurricane Victims/Evacuees and donating to the Hurricane Katrina efforts of

        Islamic Relief(http://www.irw.org/katrina/ ), American Red Cross(www.redcross.org/

        ), Islamic Center of Baton Rouge, National Council On Islamic Scouting, and Dulles

        Area Networking. The ADAMS Community is supporting a Hurricane Relief Picnic at

        Lake Fairfax Park on Sept 17 and the ADAMS Sisters Youth Group is planning a fundraiser

        in October. The ADAMS Community and Al-Fatih Academy understand that it will take

        A long term and consistent efforts to help our fellow Citizens in the Gulf Coast

        recover and rebuild. In addition, the American Muslim Relief Groups have pledged

        $10 Million in donations to help all victims of the hurricane. Also, 3000 volunteers

        from the Muslim Community of Houston Provided relief efforts to the victims at the

        Astrodome. ADAMS Imam/Executive Director is taking part in National Day of Prayer

        for Hurricane Victims at the National Cathedral on Friday Sept 16, 2005 at 11am

    </p>
', '20051108 00:00:00.000')
EXEC(N'INSERT INTO [PressReleases].[PressReleases] ([PressReleaseID], [Title], [ShortDescription], [LongDescription], [ReleaseDate]) VALUES (19, N''ADAMS Meets to Reduce Global Poverty'', N''ADAMS EXECUTIVE DIRECTOR, IMAM MOHAMED MAGID AND FELLOW PROMINENT CHRISTIAN, JEWISH, & MUSLIM LEADERS MEET WITH SECRETARY OF STATE CONDOLEEZZA RICE TO ENCOURAGE BOLD EFFORTS TO REDUCE GLOBAL POVERTY THROUGH AID AND TRADE '', N''<p>

        FOR IMMEDIATE RELEASE

        <br />

        December 1, 2005 ADAMS EXECUTIVE DIRECTOR, IMAM MOHAMED MAGID AND FELLOW PROMINENT

        CHRISTIAN, JEWISH, & MUSLIM LEADERS MEET WITH SECRETARY OF STATE CONDOLEEZZA RICE

        TO ENCOURAGE BOLD EFFORTS TO REDUCE GLOBAL POVERTY THROUGH AID AND TRADE

    </p>

    <p>

        WASHINGTON-Prominent Christian, Jewish and Muslim leaders, including Imam Mohamed

        Magid, met with Secretary of State Condoleezza Rice today to urge progress on the

        Doha Development Round of trade negotiations at the upcoming World Trade Organization

        (WTO) meeting. Leaders also encouraged the administration to propose a $5 billion

        increase for poverty-focused development assistance in the president''''s FY 2007 budget

        request. The All Dulles Area Muslim Society(ADAMS) believes it is important to work

        together as Faith Communities for helping make this world a better place. Charity

        is one of the Five Pillars of Islam. Imam Mohamed Magid said â€œHelping the poor

        and the needy in underdeveloped countries means we will be sharing our beautiful

        American and Faith values of helping people in need.â€ ADAMS is honored to work

        with Bread for the World and other Faith groups in this honorable cause. ADAMS is

        on the Board of the Interfaith Conference of Metropolitan Washington, Fairfax Faith

        Communities in Action, and Reston Interfaith Pantry and Shelter. "Progress on the

        Doha Development Round of trade negotiations is important to poor people around

        the world," said Presiding Bishop Mark Hanson of the Evangelical Lutheran Church

        in America. Cardinal Theodore McCarrick met separately with President Bush about

        the Doha negotiations just before he joined other religious leaders for the meeting

        with Secretary Rice. "The administration has put a strong proposal on the table

        in the Doha negotiations," said the Rev. David Beckmann. "We hope President Bush

        and other world leaders will go the extra mile to achieve a breakthrough this month."

        Agricultural issues are at the center of current negotiations. A recent Bread for

        the World Institute report argues that the current system of agricultural subsidies

        and protection contributes to the persistence of hunger and poverty in the developing

        world. It is also not the best way to help struggling families and struggling communities

        in rural areas of the United States.

        <p>

            Religious leaders urged:

            <br />

            * Elimination of trade-distorting agricultural subsidies;

            <br />

            * expanded market access for poor-country products;

            <br />

            * freedom for poor countries to determine how they liberalize their economies; and,

            <br />

            * increased assistance to help poor countries develop their capacity to participate

            in trade.

        </p>

        Faith leaders also encouraged the administration to live up their pledges of aid

        to developing nations. "We fight against poverty because faith requires it and conscience

        demands it," President Bush declared when he announced the Millennium Challenge

        Account (MCA) initiative in 2002. The president promised major new funding for the

        MCA and his HIV/AIDS initiative. At this summer''''s G8 Summit, he promised to double

        U.S. development assistance to Africa by 2010. But funding has fallen short of the

        president''''s promises. Congress is approving less than half the increase in poverty-focused

        development assistance that the president requested for FY 2006. Currently, the

        United States spends less than one half of 1 percent of our federal budget on reducing

        global poverty and addressing the crisis of AIDS. The administratio'', ''20051201 00:00:00.000'')')
SELECT @pv=TEXTPTR([LongDescription]) FROM [PressReleases].[PressReleases] WHERE [PressReleaseID]=19
UPDATETEXT [PressReleases].[PressReleases].[LongDescription] @pv NULL NULL N'n is right now

        putting together their budget request for FY 2007, and the religious leaders urged

        Secretary Rice to be bold. Bread for the World and many religious bodies will join

        together in a major grassroots campaign to win a $5 billion increase in poverty-focused

        development assistance for FY 2007. "Trade and aid are both important," said Rev.

        Beckmann. "Aid can help poor countries participate in trade, and changes in trade

        policy can open opportunities for struggling people around the world to earn a decent

        living."

        <p>

            Faith leaders who attended the meeting:

            <br />

            Rev. David Beckmann, President, Bread for the World

            <br />

            Rabbi Frederick Mark Dobb, Adat Shalom Reconstructionist Congregation

            <br />

            Imam Mohamed HagMagid, Executive Director and Imam, All Dulles Area Muslim Society

            <br />

            Bishop Mark Hanson, Presiding Bishop, Evangelical Lutheran Church in America

            <br />

            Imam Yahya Hendi, Muslim Chaplin, Georgetown University

            <br />

            Rev. Dr. Clifton Kirkpatrick, Stated Clerk of the General Assembly, Presbyterian

            Church (USA)

            <br />

            Cardinal Theodore E. McCarrick, Catholic Archbishop of Washington

            <br />

            Bishop Roy I. Sano, Executive Secretary, United Methodist Council of Bishops

            <br />

            Bishop Monroe R. Saunders Jr., Presiding Bishop, The United Church of Jesus Christ,

            Apostolic

            <br />

            Dr. Sayyid M. Syeed, Secretary General, Islamic Society of North America

            <br />

            Dr. H. Eric Schockman, President, MAZON: A Jewish Response to Hunger

            <br />

            Dr. Daniel Vestal, Coordinator, Cooperative Baptist Fellowship

            <br />

            Rabbi Jeffrey A. Wohlberg, Adas Israel Congregation.

            <br />

            All Dulles Area Muslim Society(ADAMS) is one of the largest Muslim communities/mosques

            in the DC Metro Area and in the United States. ADAMS is a non profit 501c(3) Organization.

            ADAMS serves over 5000 families and has 7 branches(Sterling/Herndon, Tysons Corner,

            Fairfax, Reston, Leesburg, Ashburn, and South Riding) in Northern Virginia. ADAMS

            Center is governed by a 13-member democratically elected board of trustees comprising

            of men and women. ADAMS engages in regular interfaith, government relations, social

            services, and community service. ADAMS has one of the largest Cub Scout, Boy Scout,

            and Girl Scout programs in the DC Metro area.

        </p>
'
EXEC(N'INSERT INTO [PressReleases].[PressReleases] ([PressReleaseID], [Title], [ShortDescription], [LongDescription], [ReleaseDate]) VALUES (20, N''Release of Iraq Hostage'', N''DC-AREA MUSLIMS TO CALL FOR RELEASE OF VA MAN HELD HOSTAGE IN IRAQ  Interfaith groups to urge immediate release of local Christian peace activist '', N''<p>

        DC-AREA MUSLIMS TO CALL FOR RELEASE OF VA MAN HELD HOSTAGE IN IRAQ

    </p>

    <p>

        Interfaith groups to urge immediate release of local Christian peace activist

    </p>

    <p>

        (WASHINGTON, D.C., 12/3/2005) - On Sunday, December 4 , local and national Muslim

        and Christian leaders will hold a news conference in Washington, D.C., to call for

        the immediate release of a local peace activist taken hostage recently in Iraq.

    </p>

    <p>

        WHAT : Interfaith News Conference Calling for Release of Virginian Held Hostage

        in Iraq

    </p>

    <p>

        The Muslim and Christian leaders will urge the kidnappers to release Tom Fox , 54,

        of Clear Brook, Va., and all other hostages in Iraq. We pray and ask for the safe

        return of Tom and all the Hostages taken in Iraq.

    </p>

    <p>

        Tom has been active in Virginia''''s Quaker community(Langley Hill Friends Meeting)

        and is one of four members of Christian Peacemaker Teams (CPT) kidnapped last Saturday

        by a group calling itself the Swords of Righteousness Brigade. The kidnappers have

        threatened to kill the hostages unless all prisoners in U.S. and Iraqi detention

        centers are released.

    </p>

    <p>

        Christian Peacemaker Teams (CPT) is a violence-reduction initiative with roots in

        the Historic Peace Churches (Mennonites, Brethren, Quakers) with participation from

        a broad range of Christian denominations and groups. CPT offers an organized, nonviolent

        alternative to war and other forms of lethal inter-group conflict. CPT provides

        organizational support to persons committed to faith-based nonviolent alternatives

        in situations where lethal conflict is an immediate reality or is supported by public

        policy.

    </p>

    <p>

        All Dulles Area Muslim Society (ADAMS) and Langley Hill Friends Meeting have a very

        close friendship. They meet regularly for Interfaith meetings and community service

        projects. The Langley Hill Friends Meeting Womenâ€™s group offered to help Muslim

        Women wearing scarves since they were targets of Hate Crimes. Langley Hill Friends

        Meeting sent cards and flowers after ADAMS was vandalized. Langley Hill Friends

        Meeting coordinated an overnight vigil on 9/11/2004 to keep ADAMS safe from the

        yearly vandalism against ADAMS Mosque that happened on 9/12/2001, 9/11/2002, ad

        9/11/2003. ADAMS truly appreciates the friendship and efforts of Langley Hill Friends

        Meeting.

    </p>

    <p>

        The Sunday news conference is being co-sponsored by the Washington-based Council

        on American-Islamic Relations (CAIR), All Dulles Area Muslim Society (ADAMS) and

        Langley Hill Friends Meeting in McLean, Va., of which Fox is a member.

    </p>

    <p>

        WHEN : Sunday, December 4, 12:30 p.m.

    </p>

    <p>

        WHERE : National Headquarters of the Council on American-Islamic Relations (CAIR),

        453 New Jersey Avenue S.E., Washington, D.C.

    </p>

    <p>

        All Dulles Area Muslim Society(ADAMS) is one of the largest Muslim communities/mosques

        in the DC Metro Area and in the United States. ADAMS is a non profit 501c(3) Organization.

        ADAMS serves over 5000 families and has 7 branches(Sterling/Herndon, Tysons Corner,

        Fairfax, Reston, Leesburg, Ashburn, and South Riding) in Northern Virginia. ADAMS

        Center is governed by a 13-member democratically elected board of trustees comprising

        of men and women. ADAMS engages in regular interfaith, government relations, social

        services, and community service. ADAMS has one of the largest Cub Scout, Boy Scout,

        and Girl Scout programs in the DC Metro area.

    </p>
'', ''20051204 00:00:00.000'')')
INSERT INTO [PressReleases].[PressReleases] ([PressReleaseID], [Title], [ShortDescription], [LongDescription], [ReleaseDate]) VALUES (21, N'ADAMS Participates in Civil Rights Interfaith', N'The All Dulles Area Muslim Society(ADAMS) Participated in The Interfaith Service honoring the Sacrifice in the Struggle for Civil Rights made by Reverend Dr. Martin Luther King, Jr.. The event was held at the Israel Baptist Church in Washington DC.', N'<p>

        - MEDIA ADVISORY--

    </p>

    <p>

        On Sunday Jan 15, 2006, The All Dulles Area Muslim Society(ADAMS) Participated in

        The Interfaith Service honoring the Sacrifice in the Struggle for Civil Rights made

        by Reverend Dr. Martin Luther King, Jr.. The event was held at the Israel Baptist

        Church in Washington DC. This event was co-sponsored by the Interfaith Conference

        of Metropolitan Washington

    </p>

    <p>

        ADAMS Children participated in the Interfaith Choir singing songs ?American The

        Beautiful and We Shall Overcome. ADAMS Interfaith Committee Chairperson,

        Ms. Farhanahz Ellis, read verses from the Holy Quran. ADAMS Executive Director,

        Imam Mohamed Magid, walked in the Faith Leader Procession.

    </p>

    <p>

        The Interfaith Service had representatives of Christian, Jewish, Muslim, Sikh, Hindu-Jain,

        Bahai, Buddhist, and Zoroastrian Faiths

    </p>

    <p>

        The Reverend Dr. Martin Luther King Jr. quoted the national creed: "We hold these

        truths to be self-evident: that all men are created equal." Prophet Muhammad expressed

        a similar sentiment more than 1400 years ago when he said, "There is no superiority

        of a white person over a black, nor an Arab over a non-Arab, except in God consciousness."

        In other words, all people are equal and should only be judged on the basis of merit

        rather than physical attributes.

    </p>

    <p>

        ADAMS also honors the efforts and principles of Ms. Rosa Parks and Her sacrifice

        for the Civil Rights Movement. ADAMS thanks all those that have worked and are working

        diligently to safeguard Civil Rights and Civil Liberties. ADAMS prays for PEACE,

        Respect, and Harmony.

    </p>

    <p>

        All Dulles Area Muslim Society(ADAMS) is one of the largest Muslim communities/mosques

        in the DC Metro Area and in the United States. ADAMS is a non profit 501c(3) Organization.

        ADAMS serves over 5000 families and has 7 branches(Sterling/Herndon, Tysons Corner,

        Fairfax, Reston, Leesburg, Ashburn, and South Riding) in Northern Virginia. ADAMS

        Center is governed by a 13-member democratically elected board of trustees comprising

        of men and women. ADAMS engages in regular interfaith, government relations, social

        services, and community service. ADAMS has one of the largest Cub Scout, Boy Scout,

        and Girl Scout programs in the DC Metro area.

    </p>
', '20050615 00:00:00.000')
EXEC(N'INSERT INTO [PressReleases].[PressReleases] ([PressReleaseID], [Title], [ShortDescription], [LongDescription], [ReleaseDate]) VALUES (22, N''ADAMS Condemns Fort Hood Attacks'', N''The All Dulles Area Muslim Society (ADAMS) condemns the cowardly and unforgivable attack at Fort Hood and expresses heartfelt condolences to the victims and their families.'', N''<p>

<center>

<b>All Dulles Area Muslim Society</b>

<br />46903 Sugarland Rd, Sterling, VA 20164

<br />

<a href="http://www.adamscenter.org">www.adamscenter.org</a>

</center>

</p>

<p>

In the Name of God, The Compassionate, The Merciful

</p>

<p> 

FOR IMMEDIATE RELEASE 11/5/2009

 </p>

<p>

The All Dulles Area Muslim Society (ADAMS) condemns the cowardly and unforgivable attack at Fort Hood and expresses heartfelt condolences to the victims and their families.

 </p>

<p>

No religious or political ideology could ever justify or excuse such inexcusable and indiscriminate violence. The attack was horrible in that it targeted the all-volunteer army that protects our nation and our precious freedom. American Muslims stand with our fellow citizens in offering prayers for the victims.

 </p>

<p>

Several thousand Muslim men and women faithfully serve in the United States military, including ADAMS community members who have served honorably and loyally. Two of our community members who served in the US Military were killed in action in Iraq. ADAMS held Funeral Services for them and they were buried in Arlington Cemetary. We appreciate their service, as well as the service of all dedicated volunteers committed to our country.

 </p>

<p>

National Statements:

<br /><a href="http://www.amafandvac.org/cms/" target="_blank">http://www.amafandvac.org/cms/</a>

<br/><a href="http://www.isna.net/articles/News/Muslim-American-Organizations-Denounce-Shooting-Incident-at-Fort-Hood.aspx" target="_blank">http://www.isna.net/articles/News/Muslim-American-Organizations-Denounce-Shooting-Incident-at-Fort-Hood.aspx</a>

<br/><a href="http://www.isna.net/articles/News/ISNA-Condemns-Attacks-on-Fort-Hood-Soldiers-and-Expresses-Condolences-to-the-Victims-and-T.aspx" target="_blank">http://www.isna.net/articles/News/ISNA-Condemns-Attacks-on-Fort-Hood-Soldiers-and-Expresses-Condolences-to-the-Victims-and-T.aspx</a>

<br/><a href="http://www.adamscenter.org/Announcements/Condem.aspx" target="_blank">http://www.adamscenter.org/Announcements/Condem.aspx</a>

<br/><a href="http://www.mpac.org/article.php?id=957" target="_blank">http://www.mpac.org/article.php?id=957</a>

<br/><a href="http://www.mpac.org/article.php?id=958" target="_blank">http://www.mpac.org/article.php?id=958</a>

<br/><a href="http://www.cair.com/ArticleDetails.aspx?ArticleID=26126&&name=n&&currPage=1" target="_blank">http://www.cair.com/ArticleDetails.aspx?ArticleID=26126&&name=n&&currPage=1</a>

</p>

<p>

Islam holds the human soul in high esteem, and considers the attack against innocent human beings a grave sin. ADAMS states clearly that those who commit acts murder and cruelty in the name of Islam are not only destroying innocent lives, but are also betraying the values of the faith they claim to represent.

 </p>

<p>

We repudiate and dissociate ourselves from any Muslim group or individual who commits such brutal and un-Islamic acts. We refuse to allow our faith to be held hostage by the criminal actions of a tiny minority acting outside the teachings of both the Quran and the Prophet Muhammad, peace be upon him.

 </p>

<p>

Please see more about ADAMS

<a href="http://www.adamscenter.org/Media/MediaCenter/Default.aspx">http://www.adamscenter.org/Media/MediaCenter/Default.aspx</a>

 </p>

<p>

All Dulles Area Muslim Society(ADAMS) is one of the largest Muslim communities/mosques in the DC Metro Area and in the United States. ADAMS is a non profit 501c(3) Organization. ADAMS serves over 5000 families and has 7 branches(Sterling/Herndon, Tysons Corner, Fairfax, Reston, Ashburn, South Riding, and Washington DC) ADAMS Center is governed by a 13-member democratically elected board of trustees comprising of men and women. ADAMS engages in regular interfaith, government relations, social services, and community service. ADAMS has one of the largest Cub Scout, Boy Scout, and Girl Scout programs in the DC Metro area.

</p>'', ''20091105 00:00:00.000'')')
INSERT INTO [PressReleases].[PressReleases] ([PressReleaseID], [Title], [ShortDescription], [LongDescription], [ReleaseDate]) VALUES (23, N'ADAMS Condemns Attempted Attach on Delta Flight', N'The All Dulles Area Muslim Society Condemns the attempted terror attack on a Delta-Northwest Airlines flight. Actions such as this that compromise human safety and security have no foundation in Islam''s call for for peace and moral behavior ', N'<p>

In the Name of God, The Compassionate, The Merciful

</p>

<p>

FOR IMMEDIATE RELEASE

</p>

<p>

12/26/2009

</p>

<p>

The All Dulles Area Muslim Society Condemns the attempted terror attack on a Delta-Northwest Airlines flight.  

Actions such as this that compromise human safety and security have no foundation in Islam''s call for for peace and moral behavior.

</p>

<p>

We congratulate the airline''s passengers, crew, and law enforcement for subduing the perpetrator. It is this type of vigilence and courage that will help keep our nation and world safer. We are thankful that all passengers are safe. We call for extra airport security and safety measures to be put into place to help keep air travelers safe.

</p>

<p>

The All Dulles Area Muslim Society (ADAMS), along with other Muslim organizations throughout North America, strongly condemn and reject the actions of terrorists and terrorism.

</p>

<p>

Islam holds the human soul in high esteem, and considers the attack against innocent human beings a grave sin. ADAMS has stated clearly and consistently that those who commit acts terror, murder and cruelty in the name of Islam are not only destroying innocent lives, but are also betraying the values of the faith they claim to represent.

</p>

<p>

We repudiate and dissociate ourselves from any Muslim group or individual who commits such brutal and un-Islamic acts. We object and refuse to allow our faith to be held hostage by the criminal actions of a tiny minority acting outside the teachings of both the Quran and the Prophet Muhammad (peace be upon him).

 </p>

<p>

All Dulles Area Muslim Society(ADAMS) is one of the largest Muslim communities/mosques in the DC Metro Area and in the United States. ADAMS is a non profit 501c(3) Organization. ADAMS serves over 5000 families and has 7 branches(Sterling/Herndon, Tysons Corner, Fairfax, Reston, Leesburg, Ashburn, and South Riding) in Northern Virginia. ADAMS Center is governed by a 13-member democratically elected board of trustees comprising of men and women. ADAMS engages in regular interfaith, government relations, social services, and community service. ADAMS has one of the largest Cub Scout, Boy Scout, and Girl Scout programs in the DC Metro area.

</p>
', '20091226 00:00:00.000')
INSERT INTO [PressReleases].[PressReleases] ([PressReleaseID], [Title], [ShortDescription], [LongDescription], [ReleaseDate]) VALUES (24, N'ADAMS Participates in Interfaith Activities', N'On Saturday Sept 11, 2010 and Sept. 12, 2010 members of the All Dulles Area Muslim Society(ADAMS) will conduct and take part in interfaith and peace activities.', N'<p>

In the Name of God, The Compassionate, The Merciful 

</p>

<p>

All Dulles Area Muslim Society (ADAMS)

 </p>

<p>

FOR IMMEDIATE RELEASE - 9/1/2010

</p>

<p>

On Saturday Sept 11, 2010 and Sept. 12, 2010 members of the All Dulles Area Muslim Society(ADAMS) will conduct and take part in interfaith and peace activities.  In this time of reflection and 9th Anniversary, our hearts are with the victims and the families of the victims of the September 11th tragedy and our prayers are for peace and compassion. Muslims Condemn Terrorism and Extremism. We condemn the horrific terrorist attacks of 9/11. We pray for the defeat of extremism and terrorism. We pray for the safety and security of our country and its people. We pray for the safety and security of all inhabitants of our planet. We pray that interfaith harmony, cooperation, and respect prevail both here at home and all around the globe. Through getting to know one another on a personal level, people of different faiths can build bridges of understanding, respect, and harmony.

</p>

<p>

WHAT:

<br/>On Saturday September 11, 2010 at 5:30pm-9:00pm, ADAMS will hold the 9th Annual Interfaith PEACE Gathering and Law Enforcement Appreciation event at the ADAMS Main Center Mosque in Sterling, VA. This in remembrance of the victims of the World Trade Center and Pentagon 9/11 attacks.  Interfaith groups will be represented and speaking at this event.  ADAMS will also be honoring Local Police and Fire Departments for their continuous community service.  Local Government Officials will also be speaking at this event. 

 </p>

<p>

On Sunday, September 12, 2010 at 1:30pm-4:30pm, ADAMS is co-sponsoring and participating in the Interfaith Unity Walk (http://www.911unitywalk.org/) in Washington, DC. We will gather at 1:00 p.m at the National Sikh Gurdwara (3801 Massachusetts Avenue, NW). Participants will visit churches and temples along the route. Then we will pause for a program at the Islamic Center (2551 Mass Ave) and finally conclude at the Gandhi Memorial Statue (Mass Ave at 21st) at 4:30 p.m.

 </p>

<p>

About ADAMS: All Dulles Area Muslim Society(ADAMS) is one of the largest Muslim communities/mosques in the DC Metro Area and in the United States.ADAMS is a non profit 501c(3) Organization. ADAMS serves over 5000 families and has 9 branches in Virginia/DC - (Sterling/Herndon, Tysons Corner, Fairfax, Reston, Ashburn/Leesburg, South Riding, Gainesville, Crystal City, and Washington DC). ADAMS Center is governed by a 13-member democratically elected board of trustees comprising of men and women. ADAMS engages in regularinterfaith, government relations, social services, and community service. ADAMS has one of the largest Cub Scout, Boy Scout, and GirlScout programs in the DC Metro area.

</p>
', '20100901 00:00:00.000')
EXEC(N'INSERT INTO [PressReleases].[PressReleases] ([PressReleaseID], [Title], [ShortDescription], [LongDescription], [ReleaseDate]) VALUES (25, N''ADAMS Condemns Plot to Attack Metro System'', N''The All Dulles Area Muslim Society (ADAMS) and the entire Muslim Community of the Washington DC Metropolitan Area are outraged by the news of an individual being involved in a plot to attack the Metro system in Washington.'', N''<p>

In the Name of God, The Compassionate, The Merciful 

</p>

<p>

All Dulles Area Muslim Society (ADAMS)

 </p>

<p>

FOR IMMEDIATE RELEASE - 10/27/2010

</p>

<p>

The All Dulles Area Muslim Society (ADAMS) and the entire Muslim Community of the Washington DC Metropolitan Area are outraged by the news of an individual being involved in a plot to attack the Metro system in Washington.  ADAMS and all its members vehemently condemn Terrorism and Extremism in all forms.  We commend and congratulate the FBI for arresting the alleged perpetrator, Farooque Ahmed, and for preventing the plot to attack Metro.  We call for a swift investigation, trial, and maximum prosecution of this or any other individuals convicted of such heinous crimes.

</p>

<p> 

Washington Post: Feds arrest N.Va. man in D.C. Metro bomb plot

http://www.washingtonpost.com/wp-dyn/content/article/2010/10/27/AR2010102704857.html?hpid=topnews

 </p>

<p>

"In announcing this arrest, officials emphasized that at no time was the public in danger during this investigation and that the FBI was aware of Ahmed''''s activities from before the alleged attempt began and closely monitored his activities until his arrest," the statement said. "The public should be assured that there was no threat against Metrorail or the general public in the Washington, D.C., area."

 </p>

<p>

 ADAMS encourages the Muslim community everywhere in America (and worldwide) to continue to cooperate with law enforcement officials and we urge anyone aware of this personâ€™s activities or any suspicious activities in general to come forward and contact law enforcement immediately at the FBI Washington Field Office at (202) 324-3000
 </p>

<p>

We also take this sad occasion to remind all Americans that Islam holds the human soul in high esteem, and considers the attack against innocent human beings a sin of the gravest magnitude. ADAMS has always been clear and very forthright in our position that those who commit acts of terror, murder and cruelty in the name of Islam are not only destroying innocent lives, but are also betraying the values of the faith they falsely claim to represent.  The Holy Quran makes plain that no attacks on, or even injustice done to, Muslims can ever justify the massacre of innocent people, and no act of terror will ever serve the cause of Islam.  

</p>

<p>

We therefore repudiate and dissociate ourselves, and the entire Muslim Community in Virginia and throughout the United States, from any misguided or fanatical groups or individuals who commit or even simply plan such brutal and un-Islamic acts. We refuse to allow our faith to be held hostage by the criminal actions of a tiny minority of miscreants acting outside the teachings of both the Quran and the Prophet Muhammad (peace be upon him).

 </p>

<p>

For several years, the All Dulles Area Muslim Society (ADAMS) has served on the American Muslim Sikh Advisory Committee to the FBI Washington Field Office, and has always encouraged open dialogue and cooperation from the Muslim Community with Law Enforcement, to protect our Nation and to protect individual Civil Rights.  ADAMS has hosted several Town Hall meetings with the FBI Washington Field Office (WFO) at the Mosque, and has had many advisory sessions with the WFO Director and Field Agents where we have shared our mutual concerns and explored ways of strengthening our cooperation. 

 </p>

<p>

ADAMS has a variety of ongoing projects, activities, sermons, and educational programs to work with our youth and our entire community to prevent extremism.  Our community hosts and participates in a wide range of community service activities, PEACE  Events, Interfaith events, and Scouting activities designed to engage our youth in productive citizenship activities.

 </p>
'', ''20101027 00:00:00.000'')')
EXEC(N'INSERT INTO [PressReleases].[PressReleases] ([PressReleaseID], [Title], [ShortDescription], [LongDescription], [ReleaseDate]) VALUES (26, N''Muslim Community Helps FBI'', N''Associated Press Article: Officials: Muslim source turned in terror suspect The tip that led to the FBI''''s subway bombing sting came from a source in the Muslim community '', N''    

<p>

All Dulles Area Muslim Society

46903 Sugarland Rd, Sterling, VA 20164

</p>

<p>

www.adamscenter.org



</p>

<p> 

American Muslim Community Helps Prevent Terrorism, American Muslim Community Works closely with Law Enforcement, and International Cooperation Prevents Terrorism

 </p>

<p>

1) Oct 28: Associated Press Article: Officials: Muslim source turned in terror suspect

WASHINGTON â€“ The tip that led to the FBI''''s subway bombing sting came from a source in the Muslim community

http://news.yahoo.com/s/ap/20101028/ap_on_go_ca_st_pe/us_terror_arrest

 </p>

<p>

For several years, the All Dulles Area Muslim Society (ADAMS) has served on the American Muslim Sikh Advisory Committee to the FBI Washington Field Office, and has always encouraged open dialogue and cooperation from the Muslim Community with Law Enforcement, to protect our Nation and to protect individual Civil Rights.  ADAMS has hosted several Town Hall meetings with the FBI Washington Field Office (WFO) at the Mosque, and has had many advisory sessions with the WFO Director and Field Agents where we have shared our mutual concerns and explored ways of strengthening our cooperation.  All Dulles Area Muslim Society (ADAMS) encourages the community to report any suspicious activities to Law enforcement. ADAMS has reported suspicious activities in the past.

 </p>

<p>

http://www.time.com/time/magazine/article/0,9171,1129587-3,00.html

 </p>

<p>

2)  Oct 26: Muslim Association of Hawaii Chairman Hakim Ouansafi told the Honolulu Star-Advertiser that Shehadeh was a ''''''''loner'''''''' who recently arrived from New York and was not a member of the group. Ouansafi said the Muslim Association of Hawaii made ''''''''great contributions'''''''' in assisting law enforcement agencies in their investigation of Shehadeh.''''''''These kinds of things are not tolerated,'''''''' Ouansafi said.Muslim Association of Hawaii Ouansafi told television station KHON that the worst place for someone with extremists views to come is Hawaii, ''''''''because there''''s absolutely no tolerance, and there''''s only one mosque, and our community is a community that speaks to each other, so if someone hears something, they will come and tell me. We felt uncomfortable, so we asked him not to come back.''''''''

 </p>

<p>

The FBI developed two confidential informants who were boyhood classmates of Shehadeh.

http://www.mauinews.com/page/content.detail/id/542211/Terror-case-suspect-waives-extradition-to-N-Y-.html?nav=5031

http://www.latimes.com/sc-dc-1026-hawaii-terrorism-20101026,0,101011.story

 </p>

<p>

3)  Oct 29 - A U.S. official said the search for the devices was triggered by a "tip from a very close ally of the United States." The tip was relayed to U.S. authorities Thursday and contained "very specific information" about devices in packages being shipped to the United States from Yemen, the official said.  Brennan, in a statement, said the United States was "grateful to the Kingdom of Saudi Arabia for their assistance in developing information that helped underscore the imminence of the threat emanating from Yemen."

</p>

<p>

http://www.washingtonpost.com/wp-dyn/content/article/2010/10/29/AR2010102904395.html?hpid=topnews

 </p>

<p>

"What happened is you have great information sharing from the Saudis," Napolitano said Saturday. "We were immediately able to work across the globe to get these packages segregated

 </p>

<p>

http://www.cnn.com/2010/US/10/30/security.concern/index.html?hpt=T1

</p>

<p>

---------------------------------------------------

</p>

<p>

FOR IMMEDIATE RELEASE 10/27/2010

 </p>

<p>

The All Dulles Area Muslim Society (ADAMS) and the entire Muslim Community of the Washington DC Metropolitan Area are outraged by the news of an individual being involved in a plot to attack the Metro system in Washington.  ADAMS and all its members vehemently condemn Terrorism and Extremism in all forms.  We commend and congratulate the FBI for arresting the alleged perpetrator, Farooque Ahmed, and for preventi'', ''20101028 00:00:00.000'')')
EXEC(N'DECLARE @pv binary(16)
'+N'SELECT @pv=TEXTPTR([LongDescription]) FROM [PressReleases].[PressReleases] WHERE [PressReleaseID]=26
UPDATETEXT [PressReleases].[PressReleases].[LongDescription] @pv NULL NULL N''ng the plot to attack Metro.  We call for a swift investigation, trial, and maximum prosecution of this or any other individuals convicted of such heinous crimes.

 </p>

<p>

Washington Post: Feds arrest N.Va. man in D.C. Metro bomb plot

http://www.washingtonpost.com/wp-dyn/content/article/2010/10/27/AR2010102704857.html?hpid=topnews

 </p>

<p>

"In announcing this arrest, officials emphasized that at no time was the public in danger during this investigation and that the FBI was aware of Ahmed''''s activities from before the alleged attempt began and closely monitored his activities until his arrest," the statement said. "The public should be assured that there was no threat against Metrorail or the general public in the Washington, D.C., area."

 </p>

<p>

 ADAMS encourages the Muslim community everywhere in America (and worldwide) to continue to cooperate with law enforcement officials and we urge anyone aware of this personâ€™s activities or any suspicious activities in general to come forward and contact law enforcement immediately at the FBI Washington Field Office at (202) 324-3000
 </p>

<p>

We also take this sad occasion to remind all Americans that Islam holds the human soul in high esteem, and considers the attack against innocent human beings a sin of the gravest magnitude. ADAMS has always been clear and very forthright in our position that those who commit acts of terror, murder and cruelty in the name of Islam are not only destroying innocent lives, but are also betraying the values of the faith they falsely claim to represent.  The Holy Quran makes plain that no attacks on, or even injustice done to, Muslims can ever justify the massacre of innocent people, and no act of terror will ever serve the cause of Islam.  

</p>

<p>

 

We therefore repudiate and dissociate ourselves, and the entire Muslim Community in Virginia and throughout the United States, from any misguided or fanatical groups or individuals who commit or even simply plan such brutal and un-Islamic acts. We refuse to allow our faith to be held hostage by the criminal actions of a tiny minority of miscreants acting outside the teachings of both the Quran and the Prophet Muhammad (peace be upon him).

 </p>

<p>

For several years, the All Dulles Area Muslim Society (ADAMS) has served on the American Muslim Sikh Advisory Committee to the FBI Washington Field Office, and has always encouraged open dialogue and cooperation from the Muslim Community with Law Enforcement, to protect our Nation and to protect individual Civil Rights.  ADAMS has hosted several Town Hall meetings with the FBI Washington Field Office (WFO) at the Mosque, and has had many advisory sessions with the WFO Director and Field Agents where we have shared our mutual concerns and explored ways of strengthening our cooperation. 

 </p>

<p>

ADAMS has a variety of ongoing projects, activities, sermons, and educational programs to work with our youth and our entire community to prevent extremism.  Our community hosts and participates in a wide range of community service activities, PEACE  Events, Interfaith events, and Scouting activities designed to engage our youth in productive citizenship activities.

  </p>

<p>

All Dulles Area Muslim Society(ADAMS) is one of the largest Muslim communities/mosques in the DC Metro Area and in the United States. ADAMS is a non profit 501c(3) Organization. ADAMS serves over 5000 families and has 9 branches in Virginia/DC - (Sterling/Herndon, Tysons Corner, Fairfax, Reston, Ashburn/Leesburg, South Riding, Gainesville, Crystal City, and Washington DC).ADAMS Center is governed by a 13-member democratically elected board of trustees comprising of men and women. ADAMS engages in regular interfaith, government relations, social services, and community service. ADAMS has one of the largest Cub Scout, Boy Scout, and Girl Scout programs in the DC Metro area.

</p>
''
')
EXEC(N'INSERT INTO [PressReleases].[PressReleases] ([PressReleaseID], [Title], [ShortDescription], [LongDescription], [ReleaseDate]) VALUES (27, N''ADAMS Condemns Attempted Attack'', N''The All Dulles Area Muslim Society (ADAMS) and the entire Muslim community are outraged by the news of an individual being involved in a attempted plot to attack the Armed Forces Recruitment Station in Catonsville, MD.'', N''<p>

All Dulles Area Muslim Society

46903 Sugarland Rd, Sterling, VA 20164

</p>

<p>

www.adamscenter.org



</p>

<p>

FOR IMMEDIATE RELEASE 12/9/2010

 </p>

<p>

The All Dulles Area Muslim Society (ADAMS) and the entire Muslim community of the Washington DC Metropolitan Area are outraged by the news of an individual being involved in a attempted plot to attack the Armed Forces Recruitment Station in Catonsville, MD.  ADAMS and all its members vehemently condemn terrorism and extremism in all forms.  We commend and congratulate the FBI for arresting the alleged perpetrator, Antonio Martinez, and for preventing the plot to attack this government facility.

 </p>

<p>

We are pleased to see reports that someone in the community alerted the FBI about Antonio Martinez. Please note that in recent cases of potential terrorist activity, it was members of the Muslim community who alerted authorities to the presence of such a threat. We call for a swift investigation and trial. We call for a maximum penalty against this or any other individuals if they are found guilty and convicted of such heinous crimes. ADAMS urges anyone aware of this personâ€™s activities or any suspicious activities in general to come forward and contact law enforcement immediately at the FBI Washington Field Office (WFO) at (202) 324-3000.

 </p>

<p>

Baltimore Sun: <a href="http://www.baltimoresun.com/news/maryland/bs-md-bomb-plot-arrest-20101208,0,739343.story?page=2">http://www.baltimoresun.com/news/maryland/bs-md-bomb-plot-arrest-20101208,0,739343.story?page=2</a>  â€œOfficials said Martinez tried to recruit others into the plot and was turned down. Of the four people Martinez allegedly tried to â€˜recruit in the scheme,â€™ Rosenstein said, â€˜two turned him down, one tried to talk him out of it, and the fourth turned him into the FBI.â€™ â€

 </p>

<p>

Baltimore Sun:  <a href="http://www.baltimoresun.com/news/maryland/bs-md-bombing-martinez-20101208,0,7134308.story">http://www.baltimoresun.com/news/maryland/bs-md-bombing-martinez-20101208,0,7134308.story</a>

â€œIn 2006 [Antonio Martinez] was charged with armed robbery and handgun offenses in Montgomery County.â€

 </p>

<p>

Associated Press: <a href="http://news.yahoo.com/s/ap/20101208/ap_on_re_us/us_recruiting_center_bomb_plot">http://news.yahoo.com/s/ap/20101208/ap_on_re_us/us_recruiting_center_bomb_plot</a>

â€œ â€˜There was never any actual danger to the public during this operation this morning,â€™ U.S. Attorney Rod J. Rosenstein said Wednesday after a hearing in U.S. District Court in Baltimore. â€˜That''''s because the FBI was controlling the situation.â€™ â€

 </p>

<p>

Several thousand Muslim men and women faithfully serve in the United States military, including ADAMS community members who have served honorably and loyally. Two of our community members who served in the US Military were killed in action in Iraq. ADAMS held funeral services for them and they were buried in Arlington Cemetery. We appreciate their service, as well as the service of all dedicated volunteers committed to our country.

 </p>

<p>

We remind Americans of every faith that Islam holds the human soul in highest esteem, and considers an attack on innocent human beings as a sin of the gravest magnitude. ADAMS has always been clear and very forthright in our position that those who commit acts of terror, murder, and cruelty in the name of Islam not only destroy innocent lives, but also betray the core values of the faith they so falsely claim to represent.  The Holy Qurâ€™an makes it clear that attacks on, or even injustice done to, Muslims can never justify the massacre of innocent people, and acts of terror can never serve the cause of Islam.

 </p>

<p>

We therefore repudiate and dissociate ourselves, and the entire Muslim Community in Virginia and throughout the United States, from any misguided, fanatical, or mentally unbalanced individuals who commit or even simply plan such brutal and un-Islamic acts. We refus'', ''20101209 00:00:00.000'')')
SELECT @pv=TEXTPTR([LongDescription]) FROM [PressReleases].[PressReleases] WHERE [PressReleaseID]=27
UPDATETEXT [PressReleases].[PressReleases].[LongDescription] @pv NULL NULL N'e to allow our faith to be held hostage by the criminal actions of a tiny minority of brutal miscreants acting outside the teachings of both the Qurâ€™an and the Prophet Muhammad (peace be upon him).

 </p>

<p>

For several years, ADAMS has served on the American Muslim Sikh Advisory Committee to the FBI Washington Field Office (WFO).  We have always encouraged open dialogue and cooperation from the Muslim community with law enforcement in order to protect our nation and to protect individual civil rights.  ADAMS has hosted several Town Hall meetings with the FBI WFO at our mosque, and we have had many advisory sessions with the WFO Director and Field Agents where we have shared our mutual concerns and explored ways of strengthening our cooperation. 

 </p>

<p>

ADAMS has a variety of ongoing projects, activities, sermons, and educational programs to work with our youth and our entire community to prevent extremism.  Our community hosts and participates in a wide range of community service activities, peace-building events, interfaith events, and Scouting activities designed to engage our youth in productive citizenship activities.  We make every possible effort to keep our community focused on positive ways to contribute to this great nation.

</p>

<p>

All Dulles Area Muslim Society (ADAMS), a nonprofit 501c(3) organization, is one of the largest Muslim communities/mosques in the DC Metro Area and in the United States. ADAMS serves over 5000 families with nine branches in Virginia/DC - (Sterling/Herndon, Tysons Corner, Fairfax, Reston, Ashburn/Leesburg, South Riding, Gainesville, Crystal City, and Washington DC).  ADAMS is governed by a thirteen-member democratically elected board of trustees comprising men and women, and engages in regular interfaith, government relations, social services, and community service.   ADAMS has one of the largest Cub Scout, Boy Scout, and Girl Scout programs in the DC Metro area.

</p>
'
EXEC(N'INSERT INTO [PressReleases].[PressReleases] ([PressReleaseID], [Title], [ShortDescription], [LongDescription], [ReleaseDate]) VALUES (28, N''ADAMS Condemns Threat to Attack Metro System'', N''The All Dulles Area Muslim Society (ADAMS) is outraged by the news of an individual allegedly threatening on Facebook to put pipe bombs on the Washington DC Metro System. '', N''<p>

All Dulles Area Muslim Society

46903 Sugarland Rd, Sterling, VA 20164

</p>

<p>

www.adamscenter.org



</p>

<p>

FOR IMMEDIATE RELEASE 12/15/2010

 </p>

<p>

The All Dulles Area Muslim Society (ADAMS) is outraged by the news of an individual allegedly threatening on Facebook to put pipe bombs on the Washington DC Metro System. ADAMS and all its members vehemently condemn terrorism and extremism in all forms.  We commend and congratulate the FBI for arresting the alleged perpetrator, Awais Younis. We are pleased to see reports that someone in the community of New Orleans alerted the FBI about Awais Younis.

Please note that in recent cases of potential terrorist activity, it was members of the Muslim community who alerted authorities to the presence of such a threat.

 </p>

<p>

http://voices.washingtonpost.com/crime-scene/from-the-courthouse/arlington-man-accused-of-threa.html?hpid=topnews

â€œIn late November, someone told FBI agents in New Orleans that a person they had met via Facebook had chatted about using explosives in the D.C. area, court papers sayâ€â€¦â€¦â€¦"The public should be reassured that his activities prior to his arrest were carefully monitored and that there is no threat against Metrorail or the general public in the Washington, D.C. area," Dean Boyd said.

 </p>

<p>

We call for a swift investigation and trial.We call for a maximum penalty against this or any other individuals if they are found guilty and convicted of such heinous threat. ADAMS urges anyone aware of this personâ€™s activities or any suspicious activities in general to come forward and contact law enforcement immediately at the FBI Washington Field Office (WFO) at (202) 324-3000.

 </p>

<p>

We remind Americans of every faith that Islam holds the human soul in highest esteem, and considers an attack on innocent human beings as a sin of the gravest magnitude. ADAMS has always been clear and very forthright in our position that those who commit acts of terror, murder, and cruelty in the name of Islam not only destroy innocent lives, but also betray the core values of the faith they so falsely claim to represent.  The Holy Qurâ€™an makes it clear that attacks on, or even injustice done to, Muslims can never justify the massacre of innocent people, and acts of terror can never serve the cause of Islam.

 </p>

<p>

Please see Fatwa Against Terrorism:

http://www.isna.net/Interfaith/pages/UP-Fatwa.aspx

 </p>

<p>

We therefore repudiate and dissociate ourselves, and the entire Muslim Community in Virginia and throughout the United States, from any misguided, fanatical, or mentally unbalanced individuals who commit or even simply plan such brutal and un-Islamic acts. We refuse to allow our faith to be held hostage by the criminal actions of a tiny minority of brutal miscreants acting outside the teachings of both the Qurâ€™an and the Prophet Muhammad (peace be upon him).

 </p>

<p>

For several years, ADAMS has served on the American Muslim Sikh Advisory Committee to the FBI Washington Field Office (WFO).  We have always encouraged open dialogue and cooperation from the Muslim community with law enforcement in order to protect our nation and to protect individual civil rights.  ADAMS has hosted several Town Hall meetings with the FBI WFO at our mosque, and we have had many advisory sessions with the WFO Director and Field Agents where we have shared our mutual concerns and explored ways of strengthening our cooperation. 

 </p>

<p>

ADAMS has a variety of ongoing projects, activities, sermons, and educational programs to work with our youth and our entire community to prevent extremism.  Our community hosts and participates in a wide range of community service activities, peace-building events, interfaith events, and Scouting activities designed to engage our youth in productive citizenship activities.  We make every possible effort to keep our community focused on positive ways to contribute to this great nation.

</p>

<p>

All '', ''20101215 00:00:00.000'')')
SELECT @pv=TEXTPTR([LongDescription]) FROM [PressReleases].[PressReleases] WHERE [PressReleaseID]=28
UPDATETEXT [PressReleases].[PressReleases].[LongDescription] @pv NULL NULL N'Dulles Area Muslim Society (ADAMS), a nonprofit 501c(3) organization, is one of the largest Muslim communities/mosques in the DC Metro Area and in the United States. ADAMS serves over 5000 families with nine branches in Virginia/DC - (Sterling/Herndon, Tysons Corner, Fairfax, Reston, Ashburn/Leesburg, South Riding, Gainesville, Crystal City, and Washington DC).  ADAMS is governed by a thirteen-member democratically elected board of trustees comprising men and women, and engages in regular interfaith, government relations, social services, and community service.   ADAMS has one of the largest Cub Scout, Boy Scout, and Girl Scout programs in the DC Metro area.

</p>
'
EXEC(N'INSERT INTO [PressReleases].[PressReleases] ([PressReleaseID], [Title], [ShortDescription], [LongDescription], [ReleaseDate]) VALUES (29, N''ADAMS Condemns Attacks on Churches in Baghdad'', N''The All Dulles Area Muslim Society(ADAMS) condemns the terrorist attacks on Christian Churches and Christian celebrations in Baghdad and in Alexandria, Egypt, and attacks on Christians in Nigeria.'', N''<p>

All Dulles Area Muslim Society

46903 Sugarland Rd, Sterling, VA 20164

</p>

<p>

www.adamscenter.org



</p>

<p>

FOR IMMEDIATE RELEASE 1/8/2011

 </p>

<p>

The All Dulles Area Muslim Society(ADAMS) condemns the terrorist attacks on Christian Churches and Christian celebrations in Baghdad and in Alexandria, Egypt, and attacks on Christians in Nigeria.  These are absolute crimes against humanity, and there can never be any justification for such odious actions.  Our hearts, thoughts, and sympathies are with all the victims and the families of the victims.  This is truly the work of evil and misguided people who want to destroy the harmony which has existed in these countries between Muslims, Christians and Jews for over 1000 years. 

</p>

<p>

We urge the Iraqi, Egyptian and Nigerian governments to take all measures to arrest and prosecute the individuals responsible for these heinous crimes swiftly and to the fullest measure. We also urge that the Christian Community in Iraq and Egypt receives full security, protection and justice, and we pray for PEACE between the Muslim and Christian Communities in Nigeria. Members of all faiths must work together to help bring about PEACE, and bring an end to terrorism, extremism and conflict.

</p>

<p>

"It is truly a sad day for all people when a simple act of worship or community celebration is marked by violence and innocent deaths.  ADAMS and the Islamic Society of North America (ISNA) asks Muslim community members and organizations in Egypt, Iraq, and Nigeria to lend support to the families who lost loved ones during these attacks, and urges American Muslims to join them in prayer for God to ease the suffering of all those affected by this terrible tragedy," said ADAMS Executive Director and ISNA President, Imam Mohamed Magid.

</p>

<p>

â€œMuslims are not only obligated NOT to harm Christians, but to protect and defend them and their places of worship,â€ said Imam Ahmed Al Tayeb, the Grand Imam of Al-Azhar, in response to the attack this week.

</p>

<p>

Islam holds the human soul in high esteem, and considers the attack against innocent human beings a very grave sin.

<br/>ADAMS has stated clearly and consistently that those who commit acts of terror, murder and cruelty in the name of Islam are not only destroying innocent lives, but are also betraying the values of the faith they claim to represent.  No injustice done to Muslims can ever justify the massacre of innocent people, and no act of terror will ever serve the cause of Islam.  We repudiate and dissociate ourselves from any Muslim group or individual who commits such brutal and un-Islamic acts. We refuse to allow our faith to be held hostage by the criminal actions of a tiny minority acting outside the teachings of both the Quran and the Prophet Muhammad, Peace Be Upon Him.

</p>

<p>

After a previous case of misguided violence in Pakistan, in January 2006, ADAMS partnered with the Sangla Hill Rebuilding Coalition to raise money to rebuild the Christian Churches burned by mobs in Sangla Hill, Pakistan.  Our ADAMS community will always oppose and deplore such un-Islamic attacks on our brothers and sisters in faith.

</p>

<p>

Observer News: Rebuilding Faith: Area Muslims Raise Money for Destroyed Churches in Pakistan

<br/>http://www.observernews.com/stories/current/news/011306/ADAMS.shtml

</p>

<p>

Daily Times: ADAMS Member efforts to Rebuild Churches in Sangla Hill

<br/>http://www.dailytimes.com.pk/default.asp?page=2006%5C01%5C04%5Cstory_4-1-2006_pg7_58

</p>

<p>

Please see ADAMS Statement on Condemning Terrorism and Fatwa Against Terrorism

<br/>http://www.adamscenter.org/Media/Articles/ADAMSCondemnsTerrorism.aspx

</p>

<p>

Please see more about ADAMS

<br/>http://www.adamscenter.org/Media/MediaCenter/Default.aspx

</p>

<p>

All Dulles Area Muslim Society(ADAMS) is one of the largest Muslim communities/mosques in the DC Metro Area and in the United States.ADAMS is a non profit 501c(3) Organization. '', ''20110108 00:00:00.000'')')
SELECT @pv=TEXTPTR([LongDescription]) FROM [PressReleases].[PressReleases] WHERE [PressReleaseID]=29
UPDATETEXT [PressReleases].[PressReleases].[LongDescription] @pv NULL NULL N'ADAMS serves over 5000 families and has 10 branches in Virginia/DC - (Sterling/Herndon, Tysons Corner, Fairfax, North Reston, South Reston-Herndon, Ashburn/Leesburg, South Riding, Gainesville, Crystal City, and Washington DC).ADAMS Center is governed by a 13-member democratically elected board of trustees comprising of men and women. ADAMS engages in regular interfaith, government relations, social services, and community service. ADAMS has one of the largest Cub Scout, Boy Scout, and GirlScout programs in the DC Metro area.

</p>
'
EXEC(N'INSERT INTO [PressReleases].[PressReleases] ([PressReleaseID], [Title], [ShortDescription], [LongDescription], [ReleaseDate]) VALUES (30, N''ADAMS Condemns Attacks on Christians in Pakisan'', N''ADAMS Condemns the Terrorist Crimes Against Humanity Against the Christian Community in Gojra, Pakistan'', N''<p>

       In the Name of God, The Compassionate, The Merciful

</p>

<p> 

All Dulles Area Muslim Society(ADAMS)

</p>

<p> 

FOR IMMEDIATE RELEASE 8/03/2009

</p>

<p>  

The All Dulles Area Muslim Society(ADAMS) Condemns the terrorist crimes against humanity against the Christian community in Gojra, Pakistan. Our hearts, thoughts, and sympathies are with all the victims and the families of the victims.  We are very saddened by these horrible deaths, the burning of the houses, and the burning of a Church. We hope that the perpetrators of these heinous crimes will be brought to justice. We hope that Christian Minority in Pakistan receives security, protection, and justice. We must work to help bring about PEACE and bring an end to terrorism, extremism, and conflict.

</p>

<p>  

Excerpts From A Pakistani Newspaper, Dawn: Violence had broken out in a Gojra village after an alleged incident of desecration of the Holy Quran during a wedding ceremony. The incident triggered two days of violence in which a mob torched a large number of houses, burning seven people alive. Gojra city police have arrested more than 65 people for their alleged involvement in the violence. Provincial Law Minister Rana Sanaullah, who visited the violence-hit town on Sunday, promised to pay compensation to the affected families. ''''We have identified those who attacked. They are terrorists, these people want to destabilize our country,'''' he told reporters.

</p>

<p> 

 

Islam holds the human soul in high esteem, and considers the attack against innocent human beings a grave sin. ADAMS states clearly that those who commit acts of murder and cruelty in the name of Islam are not only destroying innocent lives, but are also betraying the values of the faith they claim to represent. No injustice done to Muslims can ever justify the massacre of innocent people, and no act of terror will ever serve the cause of Islam.  We repudiate and dissociate ourselves from any Muslim group or individual who commits such brutal and un-Islamic acts. We refuse to allow our faith to be held hostage by the criminal actions of a tiny minority acting outside the teachings of both the Quran and the Prophet Muhammad, Peace Be Upon Him.

 </p>

<p> 

On January 21, 2006, ADAMS partnered with the Sangla Hill Rebuilding Coalition to raise money to rebuild the Churches burned by mobs in Sangla Hill, Pakistan.

 </p>

<p> 

Observer News: Rebuilding Faith: Area Muslims Raise Money for Destroyed Churches in Pakistan<br>

<a href>http://www.observernews.com/stories/current/news/011306/ADAMS.html</a>

 </p>

<p> 

Daily Times: ADAMS Member efforts to Rebuild Churches in Sangla Hill<br>

<a href>http://www.dailytimes.com.pk/default.asp?page=2006\01\04\story_4-1-2006_pg7_58</a>

 </p>

<p> 

Please see ADAMS Statement on Condemning Terrorism and Fatwa Against Terrorism<br>

<a href>http://www.adamscenter.org/Media/Articles/ADAMSCondemnsTerrorism.aspx</a>

 </p>

<p> 

Please see more about ADAMS<br>

<a href>http://www.adamscenter.org/Media/MediaCenter/Default.aspx</a>

 </p>

<p> 

All Dulles Area Muslim Society(ADAMS) is one of the largest Muslim communities/mosques in the DC Metro Area and in the United States. ADAMS is a non profit 501c(3) Organization. ADAMS serves over 5000 families and has 7 branches(Sterling/Herndon, Tysons Corner, Fairfax, Reston, Leesburg, Ashburn, and South Riding) in Northern Virginia. ADAMS Center is governed by a 13-member democratically elected board of trustees comprising of men and women. ADAMS engages in regular interfaith, government relations, social services, and community service. ADAMS has one of the largest Cub Scout, Boy Scout, and Girl Scout programs in the DC Metro area.

</p>
'', ''20090803 00:00:00.000'')')
INSERT INTO [PressReleases].[PressReleases] ([PressReleaseID], [Title], [ShortDescription], [LongDescription], [ReleaseDate]) VALUES (31, N'ADAMS Condemns Terrorism', N'The All Dulles Area Muslim Society(ADAMS) BACKS FATWA( Islamic religious ruling) AGAINST TERROR', N'<p>

        With the Name of God, Most Compassionate, Most Merciful

    </p>

    <p>

        All Dulles Area Muslim Society(ADAMS)

    p>

    <p>

        The All Dulles Area Muslim Society (ADAMS), along with other Muslim organizations

        throughout North America, strongly condemn and reject the actions of terrorists

        and terrorism.

    </p>

    <p>

        The All Dulles Area Muslim Society(ADAMS) BACKS <a href="../../Information/PressReleases/P7.aspx">FATWA( Islamic religious ruling) AGAINST TERROR</a>

    </p>

    <p>

        The ADAMS Board voted on May 22, 2005 to unanimously adopt the MPAC National Anti-Terrorism

        Campaign Handbook and follow and implement the guidelines. <a href="http://www.mpac.org/atc/home.asp">

            http://www.mpac.org/atc/home.asp</a>

    </p>

    <p>

        "Islam, the religion of tolerance, holds the human soul in high esteem, and considers

        the attack against innocent human beings a grave sin, this is backed by the Qur''anic

        verse which reads:

    </p>

    <p>

        "Who so ever kills a human being for other than manslaughter or corruption in the

        earth, it shall be as if he has killed all mankind, and who so ever saves the life

        of one, it shall be as if he had saved the life of all mankind," (Quran: Al-Ma''dah:32).

    </p>

    <p>

        The All Dulles Area Muslim Society states clearly that those who commit acts of

        terror, murder and cruelty in the name of Islam are not only destroying innocent

        lives, but are also betraying the values of the faith they claim to represent. No

        injustice done to Muslims can ever justify the massacre of innocent people, and

        no act of terror will ever serve the cause of Islam. We repudiate and dissociate

        ourselves from any Muslim group or individual who commits such brutal and un-Islamic

        acts. We refuse to allow our faith to be held hostage by the criminal actions of

        a tiny minority acting outside the teachings of both the Quran and the Prophet Muhammad,

        peace be upon him.

    </p>

    <p>

        "As it states in the Quran: ''Oh you who believe, stand up firmly for justice, as

        witnesses to God, even if it be against yourselves, or your parents, or your kin,

        and whether it be against rich or poor; for God can best protect both. Do not follow

        any passion, lest you not be just. And if you distort or decline to do justice,

        verily God is well-acquainted with all that you do.''" (Quran 4:135)

    </p>

    <p>

        On Sep 11, 2001 The All Dulles Area Muslim Society(ADAMS) issued this statement:

        The All Dulles Area Muslim Society(ADAMS) <a href="../../Home/ADAMSCondemns911Attacks.aspx">Deplores and Condemns The Attacks on the World Trade Center and the

            Pentagon</a>

    </p>

    <p>

        The ADAMS Center serves on an advisory council to the FBI Washington Field Office.

        We have hosted FBI Town Hall meetings at the ADAMS Center.

    </p>

', '20050522 00:00:00.000')
EXEC(N'INSERT INTO [PressReleases].[PressReleases] ([PressReleaseID], [Title], [ShortDescription], [LongDescription], [ReleaseDate]) VALUES (32, N''ADAMS Condemns Plots to Attack Synagogues'', N''All Dulles Area Muslim Society(ADAMS) is relieved to learn that law enforcement agencies were able to foil a plot to blow up two synagogues in New York.'', N''<p>

        In the Name of God, The Compassionate, The Merciful

    </p>

    <p>

        All Dulles Area Muslim Society(ADAMS)

    </p>

    <p>

        FOR IMMEDIATE RELEASE 5/21/2009

    </p>

    <p>

        The All Dulles Area Muslim Society(ADAMS) Condemns Plots to Attack Synagogues and National Targets

 </p>

<p>

All Dulles Area Muslim Society(ADAMS) is relieved to learn that law enforcement agencies were able to foil a plot to blow up two synagogues in New York, and is appalled that suspects planned to attack places of worship and to commit crimes against national institutions.

</p>

<p> 

We commend the FBI and other law enforcement agencies for preventing the planned acts of violence by these fanatic criminals. We reject unequivocally such violence or any attempt to undermine public safety and national security. We are repulsed by the hatred directed towards the Jewish community and stand in solidarity with our Jewish neighbors.

</p>

<p> 

The FBI and New York police accused four men on Wednesday night of planting explosives in two cars that were parked outside two synagogues, and of planning to use surface-to-air missile to shoot down military planes. The suspects were, reportedly, unaware that the explosives were inert and the stinger was deactivated as the four suspects were led to believe that they were part of real operation by an FBI informant who infiltrated the group and provided the fake weapons. Several media reports referred to the suspects as Muslim. ADAMS rejects the association of Islam with such criminality, hatred and bigotry.

</p>

<p> 

ADAMS has been working actively in Interfaith efforts and building bridges of respect and understanding between Faith Communities and All People. ADAMS values our ground-breaking partnerships with the Washington DC Metropolitan Area Jewish Community to foster mutual respect and understanding. ADAMS rents space from Two Synagogues - One ADAMS location is a Mosque that is the Neighbor of a Synagogue and the other location is a Friday Prayer service in a community hall within a Synagogue. ADAMS members have attended Interfaith Seders and Interfaith Shabbat services at a Synagogue  ADAMS has hosted Two Interfaith Passover Seders at our Mosque. ADAMS has hosted a Holocaust Remembrance event with a Holocaust Survivor in our Mosque.  An Attack on a Synagogue/Jewish Community is like an attack on a Mosque/Muslim Community.

</p>

<p>  

The Islamic Society of North America(ISNA) held a Press Conference to address this incident in collaboration with the Foundation for Ethnic Understanding (CEU). CEU was represented by Rabbi Mark Schneier. The Press Conference was held at the Islamic Culture Center in New York City and Imam Shamsi Ali representing the Center as well as the Muslim community.

</p>

<p> 

Islam holds the human soul in high esteem, and considers the attack against innocent human beings a grave sin.  ADAMS states clearly that those who commit acts of terror, murder and cruelty in the name of Islam are not only 

destroying innocent lives, but are also betraying the values of the faith they claim  to represent. No injustice done to Muslims can ever justify the massacre of innocent people, and no act of terror will ever serve the cause of Islam.

</p>

<p> 

We repudiate and dissociate ourselves from any Muslim group or individual who commits such brutal and un-Islamic acts. We refuse to allow our faith to be held hostage by the criminal actions of a tiny minority acting outside the teachings of both the Quran and the Prophet Muhammad, peace be upon him.

</p>

<p> 

We must work to help bring about PEACE and bring an end to terrorism, extremism, and conflict.

</p>

<p> 

Please see ADAMS Statement on Condemning Terrorism and Fatwa Against Terrorism

<a href>http://www.adamscenter.org/Media/Articles/ADAMSCondemnsTerrorism.aspx</a>

</p>

<p> 

Please see more about ADAMS

<br>

<a href> http://www.adamscenter.org/Media/MediaCenter/Default.aspx </a>

</'', ''20090521 00:00:00.000'')')
SELECT @pv=TEXTPTR([LongDescription]) FROM [PressReleases].[PressReleases] WHERE [PressReleaseID]=32
UPDATETEXT [PressReleases].[PressReleases].[LongDescription] @pv NULL NULL N'p>

<p>  

All Dulles Area Muslim Society(ADAMS) is one of the largest Muslim communities/mosques in the DC Metro Area and in the United States. ADAMS is a non profit 501c(3) Organization. ADAMS serves over 5000 families and has 7 branches(Sterling/Herndon, Tysons Corner, Fairfax, Reston, Leesburg, Ashburn, and South Riding) in Northern Virginia. ADAMS Center is governed by a 13-member democratically elected board of trustees comprising of men and women. ADAMS engages in regular interfaith, government relations, social services, and community service. ADAMS has one of the largest Cub Scout, Boy Scout, and Girl Scout programs in the DC Metro area. 

</p>
'
INSERT INTO [PressReleases].[PressReleases] ([PressReleaseID], [Title], [ShortDescription], [LongDescription], [ReleaseDate]) VALUES (33, N'Standing in Solidarity', N'Imam Mohammed Magid, All Dulles Area Muslim Society, Sterling, VA and Rabbi Robert Nosanchuk Northern Virginia Hebrew Congregation, Reston, VA', N' 

<p>

By:

</p>

<p>

Imam Mohammed Magid, All Dulles Area Muslim Society, Sterling, VA and Rabbi Robert Nosanchuk Northern Virginia Hebrew Congregation, Reston, VA



</p>

<p> 



None of us will soon forget the recent events in Riverdale, NY, leading to the arrest of men planning violence and spouting hatred against the members of a synagogue. But it does not and cannot stand alone in our memory as we meet one another as\Muslims and Jews.

</p>

<p> 

For nearly ten years, our synagogue and mosque have engaged in dialogue programs and joint projects to raise awareness on issues pertinent to our faith and to build cooperation in our community. We have gained insight from each faith as both Islam and Judaism promote the dignity and integrity of every human being. Learning from our dialogue as rabbi and imam, we are planning a visit to the Middle East to provide humanitarian aid to Jewish and Muslim communities and to build peace and compassion. And recently we began welcoming one another into our homes to acknowledge the heartfelt prayer and values of the other. During this past year, we held a pulpit exchange as rabbi and imam and members of the mosque at All Dulles Area Muslim Society of Sterling, Virginia now visit the Northern Virginia Hebrew Congregation in Reston, Virginia as a location for Friday Muslim congregational prayer.

</p>

<p> 

We hope that these pictures of our communities sharing space with hospitality and sharing ideas and joint projects with respect and cooperation will be remembered this week, alongside the memories of the recent events plotted on a synagogue in New York.

</p>

<p> 

For these events in New York trouble us both. When people plot violent attacks on synagogues or mosques, this reminds all of us to stand together as one community against all the hatred and religious bigotry that people claim to justify by religion. For hatred has no place in Islam or Judaism. Both of our traditions teach us to love our neighbors and to care about one another as human beings. They teach us to do as several members of the New York Muslim and Jewish communities have done and respond to the recent threats of violence with solidarity.

</p>

<p> 

Still we believe even more efforts of solidarity are needed. We must engage people in both of our faiths to build understanding and collaboration until we see anti Semitism and Islamaphobia wiped out. All of the leaders of our community must bear the responsibility of teaching that an attack on one place of worship should be considered an attack on every place of worship. For in America all of us should enjoy freedom of religious expression and assembly.

</p>

<p> 

In fact, attacks based on errant ideas about our religions are a breach of the very freedom of religion we enjoy in this country. Those who plot violence should not be seen as representing Islam or Judaism or any faith. Nor is it reasonable to justify threatening another community’s rights on the basis of one’s religion. Rather the motive of those plotting violence is nothing short of racism and hatred.  As imam and rabbi, we see attacking any synagogue or mosque as an attack on all places of worship and as an attack on freedom itself.

</p>

<p> 

-------------------------------

</p>

<p>

PEACE, SHALOM, SALAAM,

</p>
', '20090522 00:00:00.000')
INSERT INTO [PressReleases].[PressReleases] ([PressReleaseID], [Title], [ShortDescription], [LongDescription], [ReleaseDate]) VALUES (34, N'Time Magzine / Wash. Post', N'ADAMS Mentions in News Media', N'<p>

        1) Please read about ADAMS Scouting in the Washington Post:

        <br />

        <a href="ScoutingPost.aspx">Click here to read.</a>

    </p>

    <p>

        2) ADAMS in Time Magazine of Nov 21, 2005

        <br />

        Please read the Time Magazine article about Imam Magid and ADAMS Center.

    </p>

    <p>

        Please see Time Magazine''s Online Picture Essay about Imam Magid and ADAMS Community:

        <br />

        <a href="http://www.time.com/time/photoessays/imam_america/1.html">http://www.time.com/time/photoessays/imam_america/1.html</a>

    </p>

    <p>

        MODERATE MUSLIM CLERICS IN THE U.S. TEND TO THEIR FAITHFUL--AND HELP THE FBI FIGHT

        TERRORISTS

        <br />

        DOUGLAS WALLER STERLING, Time, 11/21/05

        <br />

        <a href="http://www.time.com/time/magazine/article/0,9171,1129587,00.html">http://www.time.com/time/magazine/article/0,9171,1129587,00.html</a>

    </p>

    <p>

        IT WAS ON SEPT. 10, A DAY SHY OF THE fourth anniversary of the attack on the World

        Trade Center, that Imam Mohamed Magid met terrorism''s victims face to face. He was

        presiding at the funeral on Long Island for the daughter and son-in-law of Bangladeshi

        Americans from his Sterling, Va., mosque. The children, who were at work in the

        North Tower, perished in the Sept. 11 attack, but not until this past August had

        medical examiners identified enough of their charred tissue and bone fragments for

        the parents to hold a funeral. Staring at the two wooden boxes covered with green

        embroidered cloth and surrounded by grieving family members, the Muslim cleric was

        gripped by both sadness and rage. "The terrorists who kill in the name of Islam

        claim they are the martyrs," Magid told TIME later, the anger still roiling him.

        "But the victims are the martyrs. The terrorists are the murderers, and God will

        deal with them on Judgment Day."

    </p>

    <p>

        From his mosque in Virginia, Magid, like many of the some 600 full-time imams across

        the country, is fighting his own war against radicals trying to hijack his religion.

        For Magid that has meant not only condemning terrorism but also working closely

        with the FBI in battling it. He regularly opens doors for agents trying to cultivate

        contacts in his Muslim community, and he alerts the bureau when suspicious persons

        approach his congregation. That puts him in a precarious position: How does he maintain

        credibility as a spiritual adviser while, in effect, he is informing on fellow Muslims?

        To understand that balancing act, TIME spent two weeks following Magid as he raced

        from prayer to prayer, meeting to meeting, in the strange new world of American

        Muslim ministry.

    </p>

    <p>

        Please read the rest of the article on:

        <br />

        <a href="http://www.time.com/time/magazine/article/0,9171,1129587,00.html">http://www.time.com/time/magazine/article/0,9171,1129587,00.html</a>

    </p>

    <p>

        Wa''Salam ''Alaikum

    </p>

    <p>

        Rizwan Jaka

    </p>

    <p>

        President, All Dulles Area Muslim Society(ADAMS)

        <br />

        www.adamscenter.org

        <br />

        Board Member,

        <br />

        Interfaith Conference of Metropolitan Washington

        <br />

        www.ifcmw.org

    </p>
', '20051101 00:00:00.000')
SET IDENTITY_INSERT [PressReleases].[PressReleases] OFF
ALTER TABLE [Sitemap].[WebBottomNodes] ADD CONSTRAINT [Fk_WebBottomNodes_WebBottomNodes] FOREIGN KEY ([ParentNodeID]) REFERENCES [Sitemap].[WebBottomNodes] ([NodeID])
ALTER TABLE [Sitemap].[WebLeftNodes] ADD CONSTRAINT [Fk_WebLeftNodes_WebLeftNodes] FOREIGN KEY ([ParentNodeID]) REFERENCES [Sitemap].[WebLeftNodes] ([NodeID])
ALTER TABLE [Sitemap].[WebTopNodes] ADD CONSTRAINT [Fk_WebTopNodes_WebTopNodes] FOREIGN KEY ([ParentNodeID]) REFERENCES [Sitemap].[WebTopNodes] ([NodeID])
ALTER TABLE [Sitemap].[Nodes] ADD CONSTRAINT [Fk_Nodes_Nodes] FOREIGN KEY ([ParentNodeID]) REFERENCES [Sitemap].[Nodes] ([NodeID])
ALTER TABLE [Sitemap].[MobileNodes] ADD CONSTRAINT [Fk_MobileNodes_MobileNodes] FOREIGN KEY ([ParentNodeID]) REFERENCES [Sitemap].[MobileNodes] ([NodeID])
ALTER TABLE [JummahPrayers].[Prayers] ADD CONSTRAINT [Fk_Prayers_Locations] FOREIGN KEY ([LocationID]) REFERENCES [JummahPrayers].[Locations] ([LocationID])
ALTER TABLE [Events].[Occurances] ADD CONSTRAINT [Fk_Occurances_Events] FOREIGN KEY ([EventID]) REFERENCES [Events].[Events] ([EventID])
ALTER TABLE [Donations].[Quick] ADD CONSTRAINT [Fk_Quick_Buckets] FOREIGN KEY ([BucketID]) REFERENCES [Donations].[Buckets] ([BucketID])
ALTER TABLE [Donations].[OneTime] ADD CONSTRAINT [Fk_OneTime_Buckets] FOREIGN KEY ([BucketID]) REFERENCES [Donations].[Buckets] ([BucketID])
ALTER TABLE [Donations].[OneTime] ADD CONSTRAINT [Fk_OneTime_Members] FOREIGN KEY ([MemberID]) REFERENCES [Membership].[Members] ([MemberID])
ALTER TABLE [DailyPrayers].[PrayerTimes] ADD CONSTRAINT [Fk_PrayerTimes_Locations] FOREIGN KEY ([LocationID]) REFERENCES [DailyPrayers].[Locations] ([LocationID])
ALTER TABLE [TarawehPrayers].[Prayers] ADD CONSTRAINT [Fk_Prayers_Locations] FOREIGN KEY ([LocationID]) REFERENCES [TarawehPrayers].[Locations] ([LocationID])
ALTER TABLE [Events].[WidgetEvents] ADD CONSTRAINT [Fk_WidgetEvents_Events] FOREIGN KEY ([EventID]) REFERENCES [Events].[Events] ([EventID])
ALTER TABLE [Events].[WidgetEvents] ADD CONSTRAINT [Fk_WidgetEvents_Widgets] FOREIGN KEY ([WidgetID]) REFERENCES [Events].[Widgets] ([WidgetID])
ALTER TABLE [Events].[Events] ADD CONSTRAINT [Fk_Events_Calendars] FOREIGN KEY ([CalendarID]) REFERENCES [Events].[Calendars] ([CalendarID])
ALTER TABLE [Classifieds].[Categories] ADD CONSTRAINT [Fk_Categories_Types] FOREIGN KEY ([TypeID]) REFERENCES [Classifieds].[Types] ([TypeID])
ALTER TABLE [Businesses].[Businesses] ADD CONSTRAINT [Fk_Businesses_Categories] FOREIGN KEY ([CategoryID]) REFERENCES [Businesses].[Categories] ([CategoryID])
ALTER TABLE [Businesses].[Businesses] ADD CONSTRAINT [Fk_Businesses_Members] FOREIGN KEY ([MemberID]) REFERENCES [Membership].[Members] ([MemberID])
ALTER TABLE [Businesses].[Categories] ADD CONSTRAINT [Fk_Categories_Types] FOREIGN KEY ([TypeID]) REFERENCES [Businesses].[Types] ([TypeID])
ALTER TABLE [Console].[UsersApplications] ADD CONSTRAINT [Fk_UsersApplications_ApplicationID] FOREIGN KEY ([ApplicationID]) REFERENCES [Console].[Applications] ([ApplicationID])
ALTER TABLE [Console].[UsersApplications] ADD CONSTRAINT [Fk_UsersApplications_UserID] FOREIGN KEY ([UserID]) REFERENCES [Console].[Users] ([UserID])
ALTER TABLE [Donations].[Recurring] ADD CONSTRAINT [Fk_Recurring_Buckets] FOREIGN KEY ([BucketID]) REFERENCES [Donations].[Buckets] ([BucketID])
ALTER TABLE [Donations].[Recurring] ADD CONSTRAINT [Fk_Recurring_Members] FOREIGN KEY ([MemberID]) REFERENCES [Membership].[Members] ([MemberID])
ALTER TABLE [EidPrayers].[Prayers] ADD CONSTRAINT [Fk_Prayers_Location] FOREIGN KEY ([LocationID]) REFERENCES [EidPrayers].[Locations] ([LocationID])
ALTER TABLE [Finance].[CreditCards] ADD CONSTRAINT [Fk_CreditCards_Members] FOREIGN KEY ([MemberID]) REFERENCES [Membership].[Members] ([MemberID])
ALTER TABLE [Classifieds].[Postings] ADD CONSTRAINT [Fk_Postings_Categories] FOREIGN KEY ([CategoryID]) REFERENCES [Classifieds].[Categories] ([CategoryID])
ALTER TABLE [Classifieds].[Postings] ADD CONSTRAINT [Fk_Postings_Members] FOREIGN KEY ([MemberID]) REFERENCES [Membership].[Members] ([MemberID])
COMMIT TRANSACTION
